/*
 *  Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
* @author Rustem V. Rafikov
* @version $Revision$
 */
package org.apache.harmony.awt.nativebridge.windows;
public interface WindowsDefs {
    static final int __SIGNED_CHARS__ = 1;
    static final int __STDC_VERSION__ = 199409;
    static final int __LONG_DOUBLE_SIZE__ = 64;
    static final int __EDG__ = 1;
    static final int __EDG_VERSION__ = 302;
    static final int __ICL = 800;
    static final int __INTEL_COMPILER = 800;
    static final int _M_IX86 = 700;
    static final int _MSC_VER = 1200;
    static final int _WIN32 = 1;
    static final int _MSC_FULL_VER = 12000000;
    static final int _INTEGRAL_MAX_BITS = 64;
    static final int __QMSPP_ = 1;
    static final int _MSC_EXTENSIONS = 1;
    static final int _WIN32_WINNT = 0x0500;
    static final int WINVER = 0x0501;
    static final int EXCEPTION_EXECUTE_HANDLER = 1;
    static final int EXCEPTION_CONTINUE_SEARCH = 0;
    static final int EXCEPTION_CONTINUE_EXECUTION = -1;
    static final int STRICT = 1;
    static final int MAX_PATH = 260;
    static final int FALSE = 0;
    static final int TRUE = 1;
    static final int _UPPER = 0x1;
    static final int _LOWER = 0x2;
    static final int _DIGIT = 0x4;
    static final int _SPACE = 0x8;
    static final int _PUNCT = 0x10;
    static final int _CONTROL = 0x20;
    static final int _BLANK = 0x40;
    static final int _HEX = 0x80;
    static final int _LEADBYTE = 0x8000;
    static final int _ALPHA = (0x0100|_UPPER|_LOWER);
    static final int ANYSIZE_ARRAY = 1;
    static final int MEMORY_ALLOCATION_ALIGNMENT = 8;
    static final int PRAGMA_DEPRECATED_DDK = 0;
    static final int APPLICATION_ERROR_MASK = 0x20000000;
    static final int ERROR_SEVERITY_SUCCESS = 0x00000000;
    static final int ERROR_SEVERITY_INFORMATIONAL = 0x40000000;
    static final int ERROR_SEVERITY_WARNING = 0x80000000;
    static final int ERROR_SEVERITY_ERROR = 0xC0000000;
    static final long MAXLONGLONG = (0x7fffffffffffffffL);
    static final int UNICODE_STRING_MAX_CHARS = (32767);
    static final int _NLSCMPERROR = 2147483647;
    static final int MINCHAR = 0x80;
    static final int MAXCHAR = 0x7f;
    static final int MINSHORT = 0x8000;
    static final int MAXSHORT = 0x7fff;
    static final int MINLONG = 0x80000000;
    static final int MAXLONG = 0x7fffffff;
    static final int MAXBYTE = 0xff;
    static final int MAXWORD = 0xffff;
    static final int MAXDWORD = 0xffffffff;
    static final int VER_SERVER_NT = 0x80000000;
    static final int VER_WORKSTATION_NT = 0x40000000;
    static final int VER_SUITE_SMALLBUSINESS = 0x00000001;
    static final int VER_SUITE_ENTERPRISE = 0x00000002;
    static final int VER_SUITE_BACKOFFICE = 0x00000004;
    static final int VER_SUITE_COMMUNICATIONS = 0x00000008;
    static final int VER_SUITE_TERMINAL = 0x00000010;
    static final int VER_SUITE_SMALLBUSINESS_RESTRICTED = 0x00000020;
    static final int VER_SUITE_EMBEDDEDNT = 0x00000040;
    static final int VER_SUITE_DATACENTER = 0x00000080;
    static final int VER_SUITE_SINGLEUSERTS = 0x00000100;
    static final int VER_SUITE_PERSONAL = 0x00000200;
    static final int VER_SUITE_BLADE = 0x00000400;
    static final int VER_SUITE_EMBEDDED_RESTRICTED = 0x00000800;
    static final int LANG_NEUTRAL = 0x00;
    static final int LANG_INVARIANT = 0x7f;
    static final int LANG_AFRIKAANS = 0x36;
    static final int LANG_ALBANIAN = 0x1c;
    static final int LANG_ARABIC = 0x01;
    static final int LANG_ARMENIAN = 0x2b;
    static final int LANG_ASSAMESE = 0x4d;
    static final int LANG_AZERI = 0x2c;
    static final int LANG_BASQUE = 0x2d;
    static final int LANG_BELARUSIAN = 0x23;
    static final int LANG_BENGALI = 0x45;
    static final int LANG_BULGARIAN = 0x02;
    static final int LANG_CATALAN = 0x03;
    static final int LANG_CHINESE = 0x04;
    static final int LANG_CROATIAN = 0x1a;
    static final int LANG_CZECH = 0x05;
    static final int LANG_DANISH = 0x06;
    static final int LANG_DIVEHI = 0x65;
    static final int LANG_DUTCH = 0x13;
    static final int LANG_ENGLISH = 0x09;
    static final int LANG_ESTONIAN = 0x25;
    static final int LANG_FAEROESE = 0x38;
    static final int LANG_FARSI = 0x29;
    static final int LANG_FINNISH = 0x0b;
    static final int LANG_FRENCH = 0x0c;
    static final int LANG_GALICIAN = 0x56;
    static final int LANG_GEORGIAN = 0x37;
    static final int LANG_GERMAN = 0x07;
    static final int LANG_GREEK = 0x08;
    static final int LANG_GUJARATI = 0x47;
    static final int LANG_HEBREW = 0x0d;
    static final int LANG_HINDI = 0x39;
    static final int LANG_HUNGARIAN = 0x0e;
    static final int LANG_ICELANDIC = 0x0f;
    static final int LANG_INDONESIAN = 0x21;
    static final int LANG_ITALIAN = 0x10;
    static final int LANG_JAPANESE = 0x11;
    static final int LANG_KANNADA = 0x4b;
    static final int LANG_KASHMIRI = 0x60;
    static final int LANG_KAZAK = 0x3f;
    static final int LANG_KONKANI = 0x57;
    static final int LANG_KOREAN = 0x12;
    static final int LANG_KYRGYZ = 0x40;
    static final int LANG_LATVIAN = 0x26;
    static final int LANG_LITHUANIAN = 0x27;
    static final int LANG_MACEDONIAN = 0x2f;
    static final int LANG_MALAY = 0x3e;
    static final int LANG_MALAYALAM = 0x4c;
    static final int LANG_MANIPURI = 0x58;
    static final int LANG_MARATHI = 0x4e;
    static final int LANG_MONGOLIAN = 0x50;
    static final int LANG_NEPALI = 0x61;
    static final int LANG_NORWEGIAN = 0x14;
    static final int LANG_ORIYA = 0x48;
    static final int LANG_POLISH = 0x15;
    static final int LANG_PORTUGUESE = 0x16;
    static final int LANG_PUNJABI = 0x46;
    static final int LANG_ROMANIAN = 0x18;
    static final int LANG_RUSSIAN = 0x19;
    static final int LANG_SANSKRIT = 0x4f;
    static final int LANG_SERBIAN = 0x1a;
    static final int LANG_SINDHI = 0x59;
    static final int LANG_SLOVAK = 0x1b;
    static final int LANG_SLOVENIAN = 0x24;
    static final int LANG_SPANISH = 0x0a;
    static final int LANG_SWAHILI = 0x41;
    static final int LANG_SWEDISH = 0x1d;
    static final int LANG_SYRIAC = 0x5a;
    static final int LANG_TAMIL = 0x49;
    static final int LANG_TATAR = 0x44;
    static final int LANG_TELUGU = 0x4a;
    static final int LANG_THAI = 0x1e;
    static final int LANG_TURKISH = 0x1f;
    static final int LANG_UKRAINIAN = 0x22;
    static final int LANG_URDU = 0x20;
    static final int LANG_UZBEK = 0x43;
    static final int LANG_VIETNAMESE = 0x2a;
    static final int SUBLANG_NEUTRAL = 0x00;
    static final int SUBLANG_DEFAULT = 0x01;
    static final int SUBLANG_SYS_DEFAULT = 0x02;
    static final int SUBLANG_ARABIC_SAUDI_ARABIA = 0x01;
    static final int SUBLANG_ARABIC_IRAQ = 0x02;
    static final int SUBLANG_ARABIC_EGYPT = 0x03;
    static final int SUBLANG_ARABIC_LIBYA = 0x04;
    static final int SUBLANG_ARABIC_ALGERIA = 0x05;
    static final int SUBLANG_ARABIC_MOROCCO = 0x06;
    static final int SUBLANG_ARABIC_TUNISIA = 0x07;
    static final int SUBLANG_ARABIC_OMAN = 0x08;
    static final int SUBLANG_ARABIC_YEMEN = 0x09;
    static final int SUBLANG_ARABIC_SYRIA = 0x0a;
    static final int SUBLANG_ARABIC_JORDAN = 0x0b;
    static final int SUBLANG_ARABIC_LEBANON = 0x0c;
    static final int SUBLANG_ARABIC_KUWAIT = 0x0d;
    static final int SUBLANG_ARABIC_UAE = 0x0e;
    static final int SUBLANG_ARABIC_BAHRAIN = 0x0f;
    static final int SUBLANG_ARABIC_QATAR = 0x10;
    static final int SUBLANG_AZERI_LATIN = 0x01;
    static final int SUBLANG_AZERI_CYRILLIC = 0x02;
    static final int SUBLANG_CHINESE_TRADITIONAL = 0x01;
    static final int SUBLANG_CHINESE_SIMPLIFIED = 0x02;
    static final int SUBLANG_CHINESE_HONGKONG = 0x03;
    static final int SUBLANG_CHINESE_SINGAPORE = 0x04;
    static final int SUBLANG_CHINESE_MACAU = 0x05;
    static final int SUBLANG_DUTCH = 0x01;
    static final int SUBLANG_DUTCH_BELGIAN = 0x02;
    static final int SUBLANG_ENGLISH_US = 0x01;
    static final int SUBLANG_ENGLISH_UK = 0x02;
    static final int SUBLANG_ENGLISH_AUS = 0x03;
    static final int SUBLANG_ENGLISH_CAN = 0x04;
    static final int SUBLANG_ENGLISH_NZ = 0x05;
    static final int SUBLANG_ENGLISH_EIRE = 0x06;
    static final int SUBLANG_ENGLISH_SOUTH_AFRICA = 0x07;
    static final int SUBLANG_ENGLISH_JAMAICA = 0x08;
    static final int SUBLANG_ENGLISH_CARIBBEAN = 0x09;
    static final int SUBLANG_ENGLISH_BELIZE = 0x0a;
    static final int SUBLANG_ENGLISH_TRINIDAD = 0x0b;
    static final int SUBLANG_ENGLISH_ZIMBABWE = 0x0c;
    static final int SUBLANG_ENGLISH_PHILIPPINES = 0x0d;
    static final int SUBLANG_FRENCH = 0x01;
    static final int SUBLANG_FRENCH_BELGIAN = 0x02;
    static final int SUBLANG_FRENCH_CANADIAN = 0x03;
    static final int SUBLANG_FRENCH_SWISS = 0x04;
    static final int SUBLANG_FRENCH_LUXEMBOURG = 0x05;
    static final int SUBLANG_FRENCH_MONACO = 0x06;
    static final int SUBLANG_GERMAN = 0x01;
    static final int SUBLANG_GERMAN_SWISS = 0x02;
    static final int SUBLANG_GERMAN_AUSTRIAN = 0x03;
    static final int SUBLANG_GERMAN_LUXEMBOURG = 0x04;
    static final int SUBLANG_GERMAN_LIECHTENSTEIN = 0x05;
    static final int SUBLANG_ITALIAN = 0x01;
    static final int SUBLANG_ITALIAN_SWISS = 0x02;
    static final int SUBLANG_KASHMIRI_INDIA = 0x02;
    static final int SUBLANG_KOREAN = 0x01;
    static final int SUBLANG_LITHUANIAN = 0x01;
    static final int SUBLANG_MALAY_MALAYSIA = 0x01;
    static final int SUBLANG_MALAY_BRUNEI_DARUSSALAM = 0x02;
    static final int SUBLANG_NEPALI_INDIA = 0x02;
    static final int SUBLANG_NORWEGIAN_BOKMAL = 0x01;
    static final int SUBLANG_NORWEGIAN_NYNORSK = 0x02;
    static final int SUBLANG_PORTUGUESE = 0x02;
    static final int SUBLANG_PORTUGUESE_BRAZILIAN = 0x01;
    static final int SUBLANG_SERBIAN_LATIN = 0x02;
    static final int SUBLANG_SERBIAN_CYRILLIC = 0x03;
    static final int SUBLANG_SPANISH = 0x01;
    static final int SUBLANG_SPANISH_MEXICAN = 0x02;
    static final int SUBLANG_SPANISH_MODERN = 0x03;
    static final int SUBLANG_SPANISH_GUATEMALA = 0x04;
    static final int SUBLANG_SPANISH_COSTA_RICA = 0x05;
    static final int SUBLANG_SPANISH_PANAMA = 0x06;
    static final int SUBLANG_SPANISH_DOMINICAN_REPUBLIC = 0x07;
    static final int SUBLANG_SPANISH_VENEZUELA = 0x08;
    static final int SUBLANG_SPANISH_COLOMBIA = 0x09;
    static final int SUBLANG_SPANISH_PERU = 0x0a;
    static final int SUBLANG_SPANISH_ARGENTINA = 0x0b;
    static final int SUBLANG_SPANISH_ECUADOR = 0x0c;
    static final int SUBLANG_SPANISH_CHILE = 0x0d;
    static final int SUBLANG_SPANISH_URUGUAY = 0x0e;
    static final int SUBLANG_SPANISH_PARAGUAY = 0x0f;
    static final int SUBLANG_SPANISH_BOLIVIA = 0x10;
    static final int SUBLANG_SPANISH_EL_SALVADOR = 0x11;
    static final int SUBLANG_SPANISH_HONDURAS = 0x12;
    static final int SUBLANG_SPANISH_NICARAGUA = 0x13;
    static final int SUBLANG_SPANISH_PUERTO_RICO = 0x14;
    static final int SUBLANG_SWEDISH = 0x01;
    static final int SUBLANG_SWEDISH_FINLAND = 0x02;
    static final int SUBLANG_URDU_PAKISTAN = 0x01;
    static final int SUBLANG_URDU_INDIA = 0x02;
    static final int SUBLANG_UZBEK_LATIN = 0x01;
    static final int SUBLANG_UZBEK_CYRILLIC = 0x02;
    static final int SORT_DEFAULT = 0x0;
    static final int SORT_JAPANESE_XJIS = 0x0;
    static final int SORT_JAPANESE_UNICODE = 0x1;
    static final int SORT_CHINESE_BIG5 = 0x0;
    static final int SORT_CHINESE_PRCP = 0x0;
    static final int SORT_CHINESE_UNICODE = 0x1;
    static final int SORT_CHINESE_PRC = 0x2;
    static final int SORT_CHINESE_BOPOMOFO = 0x3;
    static final int SORT_KOREAN_KSC = 0x0;
    static final int SORT_KOREAN_UNICODE = 0x1;
    static final int SORT_GERMAN_PHONE_BOOK = 0x1;
    static final int SORT_HUNGARIAN_DEFAULT = 0x0;
    static final int SORT_HUNGARIAN_TECHNICAL = 0x1;
    static final int SORT_GEORGIAN_TRADITIONAL = 0x0;
    static final int SORT_GEORGIAN_MODERN = 0x1;
    static final int NLS_VALID_LOCALE_MASK = 0x000fffff;
    static final int MAXIMUM_WAIT_OBJECTS = 64;
    static final int MAXIMUM_SUSPEND_COUNT = MAXCHAR;
    static final int SIZE_OF_80387_REGISTERS = 80;
    static final int CONTEXT_i386 = 0x00010000;
    static final int CONTEXT_i486 = 0x00010000;
    static final int CONTEXT_CONTROL = (CONTEXT_i386 | 0x00000001);
    static final int CONTEXT_INTEGER = (CONTEXT_i386 | 0x00000002);
    static final int CONTEXT_SEGMENTS = (CONTEXT_i386 | 0x00000004);
    static final int CONTEXT_FLOATING_POINT = (CONTEXT_i386 | 0x00000008);
    static final int CONTEXT_DEBUG_REGISTERS = (CONTEXT_i386 | 0x00000010);
    static final int CONTEXT_EXTENDED_REGISTERS = (CONTEXT_i386 | 0x00000020);
    static final int CONTEXT_FULL = (CONTEXT_CONTROL | CONTEXT_INTEGER | CONTEXT_SEGMENTS);
    static final int CONTEXT_ALL = (CONTEXT_CONTROL | CONTEXT_INTEGER | CONTEXT_SEGMENTS | CONTEXT_FLOATING_POINT | CONTEXT_DEBUG_REGISTERS | CONTEXT_EXTENDED_REGISTERS);
    static final int MAXIMUM_SUPPORTED_EXTENSION = 512;
    static final int EXCEPTION_NONCONTINUABLE = 0x1;
    static final int EXCEPTION_MAXIMUM_PARAMETERS = 15;
    static final int DELETE = (0x00010000);
    static final int READ_CONTROL = (0x00020000);
    static final int WRITE_DAC = (0x00040000);
    static final int WRITE_OWNER = (0x00080000);
    static final int SYNCHRONIZE = (0x00100000);
    static final int STANDARD_RIGHTS_REQUIRED = (0x000F0000);
    static final int STANDARD_RIGHTS_READ = (READ_CONTROL);
    static final int STANDARD_RIGHTS_WRITE = (READ_CONTROL);
    static final int STANDARD_RIGHTS_EXECUTE = (READ_CONTROL);
    static final int STANDARD_RIGHTS_ALL = (0x001F0000);
    static final int SPECIFIC_RIGHTS_ALL = (0x0000FFFF);
    static final int ACCESS_SYSTEM_SECURITY = (0x01000000);
    static final int MAXIMUM_ALLOWED = (0x02000000);
    static final int GENERIC_READ = (0x80000000);
    static final int GENERIC_WRITE = (0x40000000);
    static final int GENERIC_EXECUTE = (0x20000000);
    static final int GENERIC_ALL = (0x10000000);
    static final int SID_REVISION = (1);
    static final int SID_MAX_SUB_AUTHORITIES = (15);
    static final int SID_RECOMMENDED_SUB_AUTHORITIES = (1);
    static final int SECURITY_NULL_RID = (0x00000000);
    static final int SECURITY_WORLD_RID = (0x00000000);
    static final int SECURITY_LOCAL_RID = (0x00000000);
    static final int SECURITY_CREATOR_OWNER_RID = (0x00000000);
    static final int SECURITY_CREATOR_GROUP_RID = (0x00000001);
    static final int SECURITY_CREATOR_OWNER_SERVER_RID = (0x00000002);
    static final int SECURITY_CREATOR_GROUP_SERVER_RID = (0x00000003);
    static final int SECURITY_DIALUP_RID = (0x00000001);
    static final int SECURITY_NETWORK_RID = (0x00000002);
    static final int SECURITY_BATCH_RID = (0x00000003);
    static final int SECURITY_INTERACTIVE_RID = (0x00000004);
    static final int SECURITY_LOGON_IDS_RID = (0x00000005);
    static final int SECURITY_LOGON_IDS_RID_COUNT = (3);
    static final int SECURITY_SERVICE_RID = (0x00000006);
    static final int SECURITY_ANONYMOUS_LOGON_RID = (0x00000007);
    static final int SECURITY_PROXY_RID = (0x00000008);
    static final int SECURITY_ENTERPRISE_CONTROLLERS_RID = (0x00000009);
    static final int SECURITY_SERVER_LOGON_RID = SECURITY_ENTERPRISE_CONTROLLERS_RID;
    static final int SECURITY_PRINCIPAL_SELF_RID = (0x0000000A);
    static final int SECURITY_AUTHENTICATED_USER_RID = (0x0000000B);
    static final int SECURITY_RESTRICTED_CODE_RID = (0x0000000C);
    static final int SECURITY_TERMINAL_SERVER_RID = (0x0000000D);
    static final int SECURITY_REMOTE_LOGON_RID = (0x0000000E);
    static final int SECURITY_THIS_ORGANIZATION_RID = (0x0000000F);
    static final int SECURITY_LOCAL_SYSTEM_RID = (0x00000012);
    static final int SECURITY_LOCAL_SERVICE_RID = (0x00000013);
    static final int SECURITY_NETWORK_SERVICE_RID = (0x00000014);
    static final int SECURITY_NT_NON_UNIQUE = (0x00000015);
    static final int SECURITY_NT_NON_UNIQUE_SUB_AUTH_COUNT = (3);
    static final int SECURITY_BUILTIN_DOMAIN_RID = (0x00000020);
    static final int SECURITY_PACKAGE_BASE_RID = (0x00000040);
    static final int SECURITY_PACKAGE_RID_COUNT = (2);
    static final int SECURITY_PACKAGE_NTLM_RID = (0x0000000A);
    static final int SECURITY_PACKAGE_SCHANNEL_RID = (0x0000000E);
    static final int SECURITY_PACKAGE_DIGEST_RID = (0x00000015);
    static final int SECURITY_MAX_ALWAYS_FILTERED = (0x000003E7);
    static final int SECURITY_MIN_NEVER_FILTERED = (0x000003E8);
    static final int SECURITY_OTHER_ORGANIZATION_RID = (0x000003E8);
    static final int FOREST_USER_RID_MAX = (0x000001F3);
    static final int DOMAIN_USER_RID_ADMIN = (0x000001F4);
    static final int DOMAIN_USER_RID_GUEST = (0x000001F5);
    static final int DOMAIN_USER_RID_KRBTGT = (0x000001F6);
    static final int DOMAIN_USER_RID_MAX = (0x000003E7);
    static final int DOMAIN_GROUP_RID_ADMINS = (0x00000200);
    static final int DOMAIN_GROUP_RID_USERS = (0x00000201);
    static final int DOMAIN_GROUP_RID_GUESTS = (0x00000202);
    static final int DOMAIN_GROUP_RID_COMPUTERS = (0x00000203);
    static final int DOMAIN_GROUP_RID_CONTROLLERS = (0x00000204);
    static final int DOMAIN_GROUP_RID_CERT_ADMINS = (0x00000205);
    static final int DOMAIN_GROUP_RID_SCHEMA_ADMINS = (0x00000206);
    static final int DOMAIN_GROUP_RID_ENTERPRISE_ADMINS = (0x00000207);
    static final int DOMAIN_GROUP_RID_POLICY_ADMINS = (0x00000208);
    static final int DOMAIN_ALIAS_RID_ADMINS = (0x00000220);
    static final int DOMAIN_ALIAS_RID_USERS = (0x00000221);
    static final int DOMAIN_ALIAS_RID_GUESTS = (0x00000222);
    static final int DOMAIN_ALIAS_RID_POWER_USERS = (0x00000223);
    static final int DOMAIN_ALIAS_RID_ACCOUNT_OPS = (0x00000224);
    static final int DOMAIN_ALIAS_RID_SYSTEM_OPS = (0x00000225);
    static final int DOMAIN_ALIAS_RID_PRINT_OPS = (0x00000226);
    static final int DOMAIN_ALIAS_RID_BACKUP_OPS = (0x00000227);
    static final int DOMAIN_ALIAS_RID_REPLICATOR = (0x00000228);
    static final int DOMAIN_ALIAS_RID_RAS_SERVERS = (0x00000229);
    static final int DOMAIN_ALIAS_RID_PREW2KCOMPACCESS = (0x0000022A);
    static final int DOMAIN_ALIAS_RID_REMOTE_DESKTOP_USERS = (0x0000022B);
    static final int DOMAIN_ALIAS_RID_NETWORK_CONFIGURATION_OPS = (0x0000022C);
    static final int DOMAIN_ALIAS_RID_INCOMING_FOREST_TRUST_BUILDERS = (0x0000022D);
    static final int DOMAIN_ALIAS_RID_MONITORING_USERS = (0x0000022E);
    static final int DOMAIN_ALIAS_RID_LOGGING_USERS = (0x0000022F);
    static final int SE_GROUP_MANDATORY = (0x00000001);
    static final int SE_GROUP_ENABLED_BY_DEFAULT = (0x00000002);
    static final int SE_GROUP_ENABLED = (0x00000004);
    static final int SE_GROUP_OWNER = (0x00000008);
    static final int SE_GROUP_USE_FOR_DENY_ONLY = (0x00000010);
    static final int SE_GROUP_LOGON_ID = (0xC0000000);
    static final int SE_GROUP_RESOURCE = (0x20000000);
    static final int ACL_REVISION = (2);
    static final int ACL_REVISION_DS = (4);
    static final int ACL_REVISION1 = (1);
    static final int ACL_REVISION2 = (2);
    static final int ACL_REVISION3 = (3);
    static final int ACL_REVISION4 = (4);
    static final int MAX_ACL_REVISION = ACL_REVISION4;
    static final int ACCESS_MIN_MS_ACE_TYPE = (0x0);
    static final int ACCESS_ALLOWED_ACE_TYPE = (0x0);
    static final int ACCESS_DENIED_ACE_TYPE = (0x1);
    static final int SYSTEM_AUDIT_ACE_TYPE = (0x2);
    static final int SYSTEM_ALARM_ACE_TYPE = (0x3);
    static final int ACCESS_MAX_MS_V2_ACE_TYPE = (0x3);
    static final int ACCESS_ALLOWED_COMPOUND_ACE_TYPE = (0x4);
    static final int ACCESS_MAX_MS_V3_ACE_TYPE = (0x4);
    static final int ACCESS_MIN_MS_OBJECT_ACE_TYPE = (0x5);
    static final int ACCESS_ALLOWED_OBJECT_ACE_TYPE = (0x5);
    static final int ACCESS_DENIED_OBJECT_ACE_TYPE = (0x6);
    static final int SYSTEM_AUDIT_OBJECT_ACE_TYPE = (0x7);
    static final int SYSTEM_ALARM_OBJECT_ACE_TYPE = (0x8);
    static final int ACCESS_MAX_MS_OBJECT_ACE_TYPE = (0x8);
    static final int ACCESS_MAX_MS_V4_ACE_TYPE = (0x8);
    static final int ACCESS_MAX_MS_ACE_TYPE = (0x8);
    static final int ACCESS_ALLOWED_CALLBACK_ACE_TYPE = (0x9);
    static final int ACCESS_DENIED_CALLBACK_ACE_TYPE = (0xA);
    static final int ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE = (0xB);
    static final int ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE = (0xC);
    static final int SYSTEM_AUDIT_CALLBACK_ACE_TYPE = (0xD);
    static final int SYSTEM_ALARM_CALLBACK_ACE_TYPE = (0xE);
    static final int SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE = (0xF);
    static final int SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE = (0x10);
    static final int ACCESS_MAX_MS_V5_ACE_TYPE = (0x10);
    static final int OBJECT_INHERIT_ACE = (0x1);
    static final int CONTAINER_INHERIT_ACE = (0x2);
    static final int NO_PROPAGATE_INHERIT_ACE = (0x4);
    static final int INHERIT_ONLY_ACE = (0x8);
    static final int INHERITED_ACE = (0x10);
    static final int VALID_INHERIT_FLAGS = (0x1F);
    static final int SUCCESSFUL_ACCESS_ACE_FLAG = (0x40);
    static final int FAILED_ACCESS_ACE_FLAG = (0x80);
    static final int ACE_OBJECT_TYPE_PRESENT = 0x1;
    static final int ACE_INHERITED_OBJECT_TYPE_PRESENT = 0x2;
    static final int SECURITY_DESCRIPTOR_REVISION = (1);
    static final int SECURITY_DESCRIPTOR_REVISION1 = (1);
    static final int SE_OWNER_DEFAULTED = (0x0001);
    static final int SE_GROUP_DEFAULTED = (0x0002);
    static final int SE_DACL_PRESENT = (0x0004);
    static final int SE_DACL_DEFAULTED = (0x0008);
    static final int SE_SACL_PRESENT = (0x0010);
    static final int SE_SACL_DEFAULTED = (0x0020);
    static final int SE_DACL_AUTO_INHERIT_REQ = (0x0100);
    static final int SE_SACL_AUTO_INHERIT_REQ = (0x0200);
    static final int SE_DACL_AUTO_INHERITED = (0x0400);
    static final int SE_SACL_AUTO_INHERITED = (0x0800);
    static final int SE_DACL_PROTECTED = (0x1000);
    static final int SE_SACL_PROTECTED = (0x2000);
    static final int SE_RM_CONTROL_VALID = (0x4000);
    static final int SE_SELF_RELATIVE = (0x8000);
    static final int ACCESS_OBJECT_GUID = 0;
    static final int ACCESS_PROPERTY_SET_GUID = 1;
    static final int ACCESS_PROPERTY_GUID = 2;
    static final int ACCESS_MAX_LEVEL = 4;
    static final int AUDIT_ALLOW_NO_PRIVILEGE = 0x1;
    static final int SE_PRIVILEGE_ENABLED_BY_DEFAULT = (0x00000001);
    static final int SE_PRIVILEGE_ENABLED = (0x00000002);
    static final int SE_PRIVILEGE_REMOVED = (0X00000004);
    static final int SE_PRIVILEGE_USED_FOR_ACCESS = (0x80000000);
    static final int PRIVILEGE_SET_ALL_NECESSARY = (1);
    static final int TOKEN_ASSIGN_PRIMARY = (0x0001);
    static final int TOKEN_DUPLICATE = (0x0002);
    static final int TOKEN_IMPERSONATE = (0x0004);
    static final int TOKEN_QUERY = (0x0008);
    static final int TOKEN_QUERY_SOURCE = (0x0010);
    static final int TOKEN_ADJUST_PRIVILEGES = (0x0020);
    static final int TOKEN_ADJUST_GROUPS = (0x0040);
    static final int TOKEN_ADJUST_DEFAULT = (0x0080);
    static final int TOKEN_ADJUST_SESSIONID = (0x0100);
    static final int TOKEN_ALL_ACCESS_P = (STANDARD_RIGHTS_REQUIRED | TOKEN_ASSIGN_PRIMARY | TOKEN_DUPLICATE | TOKEN_IMPERSONATE | TOKEN_QUERY | TOKEN_QUERY_SOURCE | TOKEN_ADJUST_PRIVILEGES | TOKEN_ADJUST_GROUPS | TOKEN_ADJUST_DEFAULT );
    static final int TOKEN_ALL_ACCESS = (TOKEN_ALL_ACCESS_P | TOKEN_ADJUST_SESSIONID );
    static final int TOKEN_READ = (STANDARD_RIGHTS_READ | TOKEN_QUERY);
    static final int TOKEN_WRITE = (STANDARD_RIGHTS_WRITE | TOKEN_ADJUST_PRIVILEGES | TOKEN_ADJUST_GROUPS | TOKEN_ADJUST_DEFAULT);
    static final int TOKEN_EXECUTE = (STANDARD_RIGHTS_EXECUTE);
    static final int TOKEN_AUDIT_SUCCESS_INCLUDE = 0x1;
    static final int TOKEN_AUDIT_SUCCESS_EXCLUDE = 0x2;
    static final int TOKEN_AUDIT_FAILURE_INCLUDE = 0x4;
    static final int TOKEN_AUDIT_FAILURE_EXCLUDE = 0x8;
    static final int VALID_AUDIT_POLICY_BITS = (TOKEN_AUDIT_SUCCESS_INCLUDE | TOKEN_AUDIT_SUCCESS_EXCLUDE | TOKEN_AUDIT_FAILURE_INCLUDE | TOKEN_AUDIT_FAILURE_EXCLUDE);
    static final int TOKEN_SOURCE_LENGTH = 8;
    static final int SECURITY_DYNAMIC_TRACKING = (TRUE);
    static final int SECURITY_STATIC_TRACKING = (FALSE);
    static final int DISABLE_MAX_PRIVILEGE = 0x1;
    static final int SANDBOX_INERT = 0x2;
    static final int OWNER_SECURITY_INFORMATION = (0x00000001);
    static final int GROUP_SECURITY_INFORMATION = (0x00000002);
    static final int DACL_SECURITY_INFORMATION = (0x00000004);
    static final int SACL_SECURITY_INFORMATION = (0x00000008);
    static final int PROTECTED_DACL_SECURITY_INFORMATION = (0x80000000);
    static final int PROTECTED_SACL_SECURITY_INFORMATION = (0x40000000);
    static final int UNPROTECTED_DACL_SECURITY_INFORMATION = (0x20000000);
    static final int UNPROTECTED_SACL_SECURITY_INFORMATION = (0x10000000);
    static final int PROCESS_TERMINATE = (0x0001);
    static final int PROCESS_CREATE_THREAD = (0x0002);
    static final int PROCESS_SET_SESSIONID = (0x0004);
    static final int PROCESS_VM_OPERATION = (0x0008);
    static final int PROCESS_VM_READ = (0x0010);
    static final int PROCESS_VM_WRITE = (0x0020);
    static final int PROCESS_DUP_HANDLE = (0x0040);
    static final int PROCESS_CREATE_PROCESS = (0x0080);
    static final int PROCESS_SET_QUOTA = (0x0100);
    static final int PROCESS_SET_INFORMATION = (0x0200);
    static final int PROCESS_QUERY_INFORMATION = (0x0400);
    static final int PROCESS_SUSPEND_RESUME = (0x0800);
    static final int PROCESS_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0xFFF);
    static final int MAXIMUM_PROCESSORS = 32;
    static final int THREAD_TERMINATE = (0x0001);
    static final int THREAD_SUSPEND_RESUME = (0x0002);
    static final int THREAD_GET_CONTEXT = (0x0008);
    static final int THREAD_SET_CONTEXT = (0x0010);
    static final int THREAD_SET_INFORMATION = (0x0020);
    static final int THREAD_QUERY_INFORMATION = (0x0040);
    static final int THREAD_SET_THREAD_TOKEN = (0x0080);
    static final int THREAD_IMPERSONATE = (0x0100);
    static final int THREAD_DIRECT_IMPERSONATION = (0x0200);
    static final int THREAD_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0x3FF);
    static final int JOB_OBJECT_ASSIGN_PROCESS = (0x0001);
    static final int JOB_OBJECT_SET_ATTRIBUTES = (0x0002);
    static final int JOB_OBJECT_QUERY = (0x0004);
    static final int JOB_OBJECT_TERMINATE = (0x0008);
    static final int JOB_OBJECT_SET_SECURITY_ATTRIBUTES = (0x0010);
    static final int JOB_OBJECT_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0x1F );
    static final int FLS_MAXIMUM_AVAILABLE = 128;
    static final int TLS_MINIMUM_AVAILABLE = 64;
    static final int THREAD_BASE_PRIORITY_LOWRT = 15;
    static final int THREAD_BASE_PRIORITY_MAX = 2;
    static final int THREAD_BASE_PRIORITY_MIN = (-2);
    static final int THREAD_BASE_PRIORITY_IDLE = (-15);
    static final int QUOTA_LIMITS_HARDWS_MIN_ENABLE = 0x00000001;
    static final int QUOTA_LIMITS_HARDWS_MIN_DISABLE = 0x00000002;
    static final int QUOTA_LIMITS_HARDWS_MAX_ENABLE = 0x00000004;
    static final int QUOTA_LIMITS_HARDWS_MAX_DISABLE = 0x00000008;
    static final int JOB_OBJECT_TERMINATE_AT_END_OF_JOB = 0;
    static final int JOB_OBJECT_POST_AT_END_OF_JOB = 1;
    static final int JOB_OBJECT_MSG_END_OF_JOB_TIME = 1;
    static final int JOB_OBJECT_MSG_END_OF_PROCESS_TIME = 2;
    static final int JOB_OBJECT_MSG_ACTIVE_PROCESS_LIMIT = 3;
    static final int JOB_OBJECT_MSG_ACTIVE_PROCESS_ZERO = 4;
    static final int JOB_OBJECT_MSG_NEW_PROCESS = 6;
    static final int JOB_OBJECT_MSG_EXIT_PROCESS = 7;
    static final int JOB_OBJECT_MSG_ABNORMAL_EXIT_PROCESS = 8;
    static final int JOB_OBJECT_MSG_PROCESS_MEMORY_LIMIT = 9;
    static final int JOB_OBJECT_MSG_JOB_MEMORY_LIMIT = 10;
    static final int JOB_OBJECT_LIMIT_WORKINGSET = 0x00000001;
    static final int JOB_OBJECT_LIMIT_PROCESS_TIME = 0x00000002;
    static final int JOB_OBJECT_LIMIT_JOB_TIME = 0x00000004;
    static final int JOB_OBJECT_LIMIT_ACTIVE_PROCESS = 0x00000008;
    static final int JOB_OBJECT_LIMIT_AFFINITY = 0x00000010;
    static final int JOB_OBJECT_LIMIT_PRIORITY_CLASS = 0x00000020;
    static final int JOB_OBJECT_LIMIT_PRESERVE_JOB_TIME = 0x00000040;
    static final int JOB_OBJECT_LIMIT_SCHEDULING_CLASS = 0x00000080;
    static final int JOB_OBJECT_LIMIT_PROCESS_MEMORY = 0x00000100;
    static final int JOB_OBJECT_LIMIT_JOB_MEMORY = 0x00000200;
    static final int JOB_OBJECT_LIMIT_DIE_ON_UNHANDLED_EXCEPTION = 0x00000400;
    static final int JOB_OBJECT_LIMIT_BREAKAWAY_OK = 0x00000800;
    static final int JOB_OBJECT_LIMIT_SILENT_BREAKAWAY_OK = 0x00001000;
    static final int JOB_OBJECT_LIMIT_KILL_ON_JOB_CLOSE = 0x00002000;
    static final int JOB_OBJECT_LIMIT_RESERVED2 = 0x00004000;
    static final int JOB_OBJECT_LIMIT_RESERVED3 = 0x00008000;
    static final int JOB_OBJECT_LIMIT_RESERVED4 = 0x00010000;
    static final int JOB_OBJECT_LIMIT_RESERVED5 = 0x00020000;
    static final int JOB_OBJECT_LIMIT_RESERVED6 = 0x00040000;
    static final int JOB_OBJECT_LIMIT_VALID_FLAGS = 0x0007ffff;
    static final int JOB_OBJECT_BASIC_LIMIT_VALID_FLAGS = 0x000000ff;
    static final int JOB_OBJECT_EXTENDED_LIMIT_VALID_FLAGS = 0x00003fff;
    static final int JOB_OBJECT_RESERVED_LIMIT_VALID_FLAGS = 0x0007ffff;
    static final int JOB_OBJECT_UILIMIT_NONE = 0x00000000;
    static final int JOB_OBJECT_UILIMIT_HANDLES = 0x00000001;
    static final int JOB_OBJECT_UILIMIT_READCLIPBOARD = 0x00000002;
    static final int JOB_OBJECT_UILIMIT_WRITECLIPBOARD = 0x00000004;
    static final int JOB_OBJECT_UILIMIT_SYSTEMPARAMETERS = 0x00000008;
    static final int JOB_OBJECT_UILIMIT_DISPLAYSETTINGS = 0x00000010;
    static final int JOB_OBJECT_UILIMIT_GLOBALATOMS = 0x00000020;
    static final int JOB_OBJECT_UILIMIT_DESKTOP = 0x00000040;
    static final int JOB_OBJECT_UILIMIT_EXITWINDOWS = 0x00000080;
    static final int JOB_OBJECT_UILIMIT_ALL = 0x000000FF;
    static final int JOB_OBJECT_UI_VALID_FLAGS = 0x000000FF;
    static final int JOB_OBJECT_SECURITY_NO_ADMIN = 0x00000001;
    static final int JOB_OBJECT_SECURITY_RESTRICTED_TOKEN = 0x00000002;
    static final int JOB_OBJECT_SECURITY_ONLY_TOKEN = 0x00000004;
    static final int JOB_OBJECT_SECURITY_FILTER_TOKENS = 0x00000008;
    static final int JOB_OBJECT_SECURITY_VALID_FLAGS = 0x0000000f;
    static final int EVENT_MODIFY_STATE = 0x0002;
    static final int EVENT_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x3);
    static final int MUTANT_QUERY_STATE = 0x0001;
    static final int MUTANT_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE| MUTANT_QUERY_STATE);
    static final int SEMAPHORE_MODIFY_STATE = 0x0002;
    static final int SEMAPHORE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x3);
    static final int TIMER_QUERY_STATE = 0x0001;
    static final int TIMER_MODIFY_STATE = 0x0002;
    static final int TIMER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE| TIMER_QUERY_STATE|TIMER_MODIFY_STATE);
    static final int TIME_ZONE_ID_UNKNOWN = 0;
    static final int TIME_ZONE_ID_STANDARD = 1;
    static final int TIME_ZONE_ID_DAYLIGHT = 2;
    static final int LTP_PC_SMT = 0x1;
    static final int PROCESSOR_INTEL_386 = 386;
    static final int PROCESSOR_INTEL_486 = 486;
    static final int PROCESSOR_INTEL_PENTIUM = 586;
    static final int PROCESSOR_INTEL_IA64 = 2200;
    static final int PROCESSOR_AMD_X8664 = 8664;
    static final int PROCESSOR_MIPS_R4000 = 4000;
    static final int PROCESSOR_ALPHA_21064 = 21064;
    static final int PROCESSOR_PPC_601 = 601;
    static final int PROCESSOR_PPC_603 = 603;
    static final int PROCESSOR_PPC_604 = 604;
    static final int PROCESSOR_PPC_620 = 620;
    static final int PROCESSOR_HITACHI_SH3 = 10003;
    static final int PROCESSOR_HITACHI_SH3E = 10004;
    static final int PROCESSOR_HITACHI_SH4 = 10005;
    static final int PROCESSOR_MOTOROLA_821 = 821;
    static final int PROCESSOR_SHx_SH3 = 103;
    static final int PROCESSOR_SHx_SH4 = 104;
    static final int PROCESSOR_STRONGARM = 2577;
    static final int PROCESSOR_ARM720 = 1824;
    static final int PROCESSOR_ARM820 = 2080;
    static final int PROCESSOR_ARM920 = 2336;
    static final int PROCESSOR_ARM_7TDMI = 70001;
    static final int PROCESSOR_OPTIL = 0x494f;
    static final int PROCESSOR_ARCHITECTURE_INTEL = 0;
    static final int PROCESSOR_ARCHITECTURE_MIPS = 1;
    static final int PROCESSOR_ARCHITECTURE_ALPHA = 2;
    static final int PROCESSOR_ARCHITECTURE_PPC = 3;
    static final int PROCESSOR_ARCHITECTURE_SHX = 4;
    static final int PROCESSOR_ARCHITECTURE_ARM = 5;
    static final int PROCESSOR_ARCHITECTURE_IA64 = 6;
    static final int PROCESSOR_ARCHITECTURE_ALPHA64 = 7;
    static final int PROCESSOR_ARCHITECTURE_MSIL = 8;
    static final int PROCESSOR_ARCHITECTURE_AMD64 = 9;
    static final int PROCESSOR_ARCHITECTURE_IA32_ON_WIN64 = 10;
    static final int PROCESSOR_ARCHITECTURE_UNKNOWN = 0xFFFF;
    static final int PF_FLOATING_POINT_PRECISION_ERRATA = 0;
    static final int PF_FLOATING_POINT_EMULATED = 1;
    static final int PF_COMPARE_EXCHANGE_DOUBLE = 2;
    static final int PF_MMX_INSTRUCTIONS_AVAILABLE = 3;
    static final int PF_PPC_MOVEMEM_64BIT_OK = 4;
    static final int PF_ALPHA_BYTE_INSTRUCTIONS = 5;
    static final int PF_XMMI_INSTRUCTIONS_AVAILABLE = 6;
    static final int PF_3DNOW_INSTRUCTIONS_AVAILABLE = 7;
    static final int PF_RDTSC_INSTRUCTION_AVAILABLE = 8;
    static final int PF_PAE_ENABLED = 9;
    static final int PF_XMMI64_INSTRUCTIONS_AVAILABLE = 10;
    static final int SECTION_QUERY = 0x0001;
    static final int SECTION_MAP_WRITE = 0x0002;
    static final int SECTION_MAP_READ = 0x0004;
    static final int SECTION_MAP_EXECUTE = 0x0008;
    static final int SECTION_EXTEND_SIZE = 0x0010;
    static final int SECTION_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SECTION_QUERY| SECTION_MAP_WRITE | SECTION_MAP_READ | SECTION_MAP_EXECUTE | SECTION_EXTEND_SIZE);
    static final int PAGE_NOACCESS = 0x01;
    static final int PAGE_READONLY = 0x02;
    static final int PAGE_READWRITE = 0x04;
    static final int PAGE_WRITECOPY = 0x08;
    static final int PAGE_EXECUTE = 0x10;
    static final int PAGE_EXECUTE_READ = 0x20;
    static final int PAGE_EXECUTE_READWRITE = 0x40;
    static final int PAGE_EXECUTE_WRITECOPY = 0x80;
    static final int PAGE_GUARD = 0x100;
    static final int PAGE_NOCACHE = 0x200;
    static final int PAGE_WRITECOMBINE = 0x400;
    static final int MEM_COMMIT = 0x1000;
    static final int MEM_RESERVE = 0x2000;
    static final int MEM_DECOMMIT = 0x4000;
    static final int MEM_RELEASE = 0x8000;
    static final int MEM_FREE = 0x10000;
    static final int MEM_PRIVATE = 0x20000;
    static final int MEM_MAPPED = 0x40000;
    static final int MEM_RESET = 0x80000;
    static final int MEM_TOP_DOWN = 0x100000;
    static final int MEM_WRITE_WATCH = 0x200000;
    static final int MEM_PHYSICAL = 0x400000;
    static final int MEM_LARGE_PAGES = 0x20000000;
    static final int MEM_4MB_PAGES = 0x80000000;
    static final int SEC_FILE = 0x800000;
    static final int SEC_IMAGE = 0x1000000;
    static final int SEC_RESERVE = 0x4000000;
    static final int SEC_COMMIT = 0x8000000;
    static final int SEC_NOCACHE = 0x10000000;
    static final int MEM_IMAGE = SEC_IMAGE;
    static final int WRITE_WATCH_FLAG_RESET = 0x01;
    static final int FILE_READ_DATA = ( 0x0001 );
    static final int FILE_LIST_DIRECTORY = ( 0x0001 );
    static final int FILE_WRITE_DATA = ( 0x0002 );
    static final int FILE_ADD_FILE = ( 0x0002 );
    static final int FILE_APPEND_DATA = ( 0x0004 );
    static final int FILE_ADD_SUBDIRECTORY = ( 0x0004 );
    static final int FILE_CREATE_PIPE_INSTANCE = ( 0x0004 );
    static final int FILE_READ_EA = ( 0x0008 );
    static final int FILE_WRITE_EA = ( 0x0010 );
    static final int FILE_EXECUTE = ( 0x0020 );
    static final int FILE_TRAVERSE = ( 0x0020 );
    static final int FILE_DELETE_CHILD = ( 0x0040 );
    static final int FILE_READ_ATTRIBUTES = ( 0x0080 );
    static final int FILE_WRITE_ATTRIBUTES = ( 0x0100 );
    static final int FILE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0x1FF);
    static final int FILE_GENERIC_READ = (STANDARD_RIGHTS_READ | FILE_READ_DATA | FILE_READ_ATTRIBUTES | FILE_READ_EA | SYNCHRONIZE);
    static final int FILE_GENERIC_WRITE = (STANDARD_RIGHTS_WRITE | FILE_WRITE_DATA | FILE_WRITE_ATTRIBUTES | FILE_WRITE_EA | FILE_APPEND_DATA | SYNCHRONIZE);
    static final int FILE_GENERIC_EXECUTE = (STANDARD_RIGHTS_EXECUTE | FILE_READ_ATTRIBUTES | FILE_EXECUTE | SYNCHRONIZE);
    static final int FILE_SHARE_READ = 0x00000001;
    static final int FILE_SHARE_WRITE = 0x00000002;
    static final int FILE_SHARE_DELETE = 0x00000004;
    static final int FILE_ATTRIBUTE_READONLY = 0x00000001;
    static final int FILE_ATTRIBUTE_HIDDEN = 0x00000002;
    static final int FILE_ATTRIBUTE_SYSTEM = 0x00000004;
    static final int FILE_ATTRIBUTE_DIRECTORY = 0x00000010;
    static final int FILE_ATTRIBUTE_ARCHIVE = 0x00000020;
    static final int FILE_ATTRIBUTE_DEVICE = 0x00000040;
    static final int FILE_ATTRIBUTE_NORMAL = 0x00000080;
    static final int FILE_ATTRIBUTE_TEMPORARY = 0x00000100;
    static final int FILE_ATTRIBUTE_SPARSE_FILE = 0x00000200;
    static final int FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400;
    static final int FILE_ATTRIBUTE_COMPRESSED = 0x00000800;
    static final int FILE_ATTRIBUTE_OFFLINE = 0x00001000;
    static final int FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000;
    static final int FILE_ATTRIBUTE_ENCRYPTED = 0x00004000;
    static final int FILE_NOTIFY_CHANGE_FILE_NAME = 0x00000001;
    static final int FILE_NOTIFY_CHANGE_DIR_NAME = 0x00000002;
    static final int FILE_NOTIFY_CHANGE_ATTRIBUTES = 0x00000004;
    static final int FILE_NOTIFY_CHANGE_SIZE = 0x00000008;
    static final int FILE_NOTIFY_CHANGE_LAST_WRITE = 0x00000010;
    static final int FILE_NOTIFY_CHANGE_LAST_ACCESS = 0x00000020;
    static final int FILE_NOTIFY_CHANGE_CREATION = 0x00000040;
    static final int FILE_NOTIFY_CHANGE_SECURITY = 0x00000100;
    static final int FILE_ACTION_ADDED = 0x00000001;
    static final int FILE_ACTION_REMOVED = 0x00000002;
    static final int FILE_ACTION_MODIFIED = 0x00000003;
    static final int FILE_ACTION_RENAMED_OLD_NAME = 0x00000004;
    static final int FILE_ACTION_RENAMED_NEW_NAME = 0x00000005;
    static final int FILE_CASE_SENSITIVE_SEARCH = 0x00000001;
    static final int FILE_CASE_PRESERVED_NAMES = 0x00000002;
    static final int FILE_UNICODE_ON_DISK = 0x00000004;
    static final int FILE_PERSISTENT_ACLS = 0x00000008;
    static final int FILE_FILE_COMPRESSION = 0x00000010;
    static final int FILE_VOLUME_QUOTAS = 0x00000020;
    static final int FILE_SUPPORTS_SPARSE_FILES = 0x00000040;
    static final int FILE_SUPPORTS_REPARSE_POINTS = 0x00000080;
    static final int FILE_SUPPORTS_REMOTE_STORAGE = 0x00000100;
    static final int FILE_VOLUME_IS_COMPRESSED = 0x00008000;
    static final int FILE_SUPPORTS_OBJECT_IDS = 0x00010000;
    static final int FILE_SUPPORTS_ENCRYPTION = 0x00020000;
    static final int FILE_NAMED_STREAMS = 0x00040000;
    static final int FILE_READ_ONLY_VOLUME = 0x00080000;
    static final int IO_REPARSE_TAG_RESERVED_ZERO = (0);
    static final int IO_REPARSE_TAG_RESERVED_ONE = (1);
    static final int IO_REPARSE_TAG_RESERVED_RANGE = IO_REPARSE_TAG_RESERVED_ONE;
    static final int IO_REPARSE_TAG_MOUNT_POINT = (0xA0000003);
    static final int IO_REPARSE_TAG_HSM = (0xC0000004);
    static final int IO_REPARSE_TAG_SIS = (0x80000007);
    static final int IO_REPARSE_TAG_DFS = (0x8000000A);
    static final int IO_REPARSE_TAG_FILTER_MANAGER = (0x8000000B);
    static final int IO_COMPLETION_MODIFY_STATE = 0x0002;
    static final int IO_COMPLETION_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x3);
    static final int DUPLICATE_CLOSE_SOURCE = 0x00000001;
    static final int DUPLICATE_SAME_ACCESS = 0x00000002;
    static final int POWER_SYSTEM_MAXIMUM = 7;
    static final int PDCAP_D0_SUPPORTED = 0x00000001;
    static final int PDCAP_D1_SUPPORTED = 0x00000002;
    static final int PDCAP_D2_SUPPORTED = 0x00000004;
    static final int PDCAP_D3_SUPPORTED = 0x00000008;
    static final int PDCAP_WAKE_FROM_D0_SUPPORTED = 0x00000010;
    static final int PDCAP_WAKE_FROM_D1_SUPPORTED = 0x00000020;
    static final int PDCAP_WAKE_FROM_D2_SUPPORTED = 0x00000040;
    static final int PDCAP_WAKE_FROM_D3_SUPPORTED = 0x00000080;
    static final int PDCAP_WARM_EJECT_SUPPORTED = 0x00000100;
    static final int POWER_ACTION_QUERY_ALLOWED = 0x00000001;
    static final int POWER_ACTION_UI_ALLOWED = 0x00000002;
    static final int POWER_ACTION_OVERRIDE_APPS = 0x00000004;
    static final int POWER_ACTION_LIGHTEST_FIRST = 0x10000000;
    static final int POWER_ACTION_LOCK_CONSOLE = 0x20000000;
    static final int POWER_ACTION_DISABLE_WAKES = 0x40000000;
    static final int POWER_ACTION_CRITICAL = 0x80000000;
    static final int POWER_LEVEL_USER_NOTIFY_TEXT = 0x00000001;
    static final int POWER_LEVEL_USER_NOTIFY_SOUND = 0x00000002;
    static final int POWER_LEVEL_USER_NOTIFY_EXEC = 0x00000004;
    static final int POWER_USER_NOTIFY_BUTTON = 0x00000008;
    static final int POWER_USER_NOTIFY_SHUTDOWN = 0x00000010;
    static final int POWER_FORCE_TRIGGER_RESET = 0x80000000;
    static final int NUM_DISCHARGE_POLICIES = 4;
    static final int DISCHARGE_POLICY_CRITICAL = 0;
    static final int DISCHARGE_POLICY_LOW = 1;
    static final int PO_THROTTLE_NONE = 0;
    static final int PO_THROTTLE_CONSTANT = 1;
    static final int PO_THROTTLE_DEGRADE = 2;
    static final int PO_THROTTLE_ADAPTIVE = 3;
    static final int PO_THROTTLE_MAXIMUM = 4;
    static final int IMAGE_DOS_SIGNATURE = 0x5A4D;
    static final int IMAGE_OS2_SIGNATURE = 0x454E;
    static final int IMAGE_OS2_SIGNATURE_LE = 0x454C;
    static final int IMAGE_VXD_SIGNATURE = 0x454C;
    static final int IMAGE_NT_SIGNATURE = 0x00004550;
    static final int IMAGE_SIZEOF_FILE_HEADER = 20;
    static final int IMAGE_FILE_RELOCS_STRIPPED = 0x0001;
    static final int IMAGE_FILE_EXECUTABLE_IMAGE = 0x0002;
    static final int IMAGE_FILE_LINE_NUMS_STRIPPED = 0x0004;
    static final int IMAGE_FILE_LOCAL_SYMS_STRIPPED = 0x0008;
    static final int IMAGE_FILE_AGGRESIVE_WS_TRIM = 0x0010;
    static final int IMAGE_FILE_LARGE_ADDRESS_AWARE = 0x0020;
    static final int IMAGE_FILE_BYTES_REVERSED_LO = 0x0080;
    static final int IMAGE_FILE_32BIT_MACHINE = 0x0100;
    static final int IMAGE_FILE_DEBUG_STRIPPED = 0x0200;
    static final int IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = 0x0400;
    static final int IMAGE_FILE_NET_RUN_FROM_SWAP = 0x0800;
    static final int IMAGE_FILE_SYSTEM = 0x1000;
    static final int IMAGE_FILE_DLL = 0x2000;
    static final int IMAGE_FILE_UP_SYSTEM_ONLY = 0x4000;
    static final int IMAGE_FILE_BYTES_REVERSED_HI = 0x8000;
    static final int IMAGE_FILE_MACHINE_UNKNOWN = 0;
    static final int IMAGE_FILE_MACHINE_I386 = 0x014c;
    static final int IMAGE_FILE_MACHINE_R3000 = 0x0162;
    static final int IMAGE_FILE_MACHINE_R4000 = 0x0166;
    static final int IMAGE_FILE_MACHINE_R10000 = 0x0168;
    static final int IMAGE_FILE_MACHINE_WCEMIPSV2 = 0x0169;
    static final int IMAGE_FILE_MACHINE_ALPHA = 0x0184;
    static final int IMAGE_FILE_MACHINE_SH3 = 0x01a2;
    static final int IMAGE_FILE_MACHINE_SH3DSP = 0x01a3;
    static final int IMAGE_FILE_MACHINE_SH3E = 0x01a4;
    static final int IMAGE_FILE_MACHINE_SH4 = 0x01a6;
    static final int IMAGE_FILE_MACHINE_SH5 = 0x01a8;
    static final int IMAGE_FILE_MACHINE_ARM = 0x01c0;
    static final int IMAGE_FILE_MACHINE_THUMB = 0x01c2;
    static final int IMAGE_FILE_MACHINE_AM33 = 0x01d3;
    static final int IMAGE_FILE_MACHINE_POWERPC = 0x01F0;
    static final int IMAGE_FILE_MACHINE_POWERPCFP = 0x01f1;
    static final int IMAGE_FILE_MACHINE_IA64 = 0x0200;
    static final int IMAGE_FILE_MACHINE_MIPS16 = 0x0266;
    static final int IMAGE_FILE_MACHINE_ALPHA64 = 0x0284;
    static final int IMAGE_FILE_MACHINE_MIPSFPU = 0x0366;
    static final int IMAGE_FILE_MACHINE_MIPSFPU16 = 0x0466;
    static final int IMAGE_FILE_MACHINE_AXP64 = IMAGE_FILE_MACHINE_ALPHA64;
    static final int IMAGE_FILE_MACHINE_TRICORE = 0x0520;
    static final int IMAGE_FILE_MACHINE_CEF = 0x0CEF;
    static final int IMAGE_FILE_MACHINE_EBC = 0x0EBC;
    static final int IMAGE_FILE_MACHINE_AMD64 = 0x8664;
    static final int IMAGE_FILE_MACHINE_M32R = 0x9041;
    static final int IMAGE_FILE_MACHINE_CEE = 0xC0EE;
    static final int IMAGE_NUMBEROF_DIRECTORY_ENTRIES = 16;
    static final int IMAGE_SIZEOF_ROM_OPTIONAL_HEADER = 56;
    static final int IMAGE_SIZEOF_STD_OPTIONAL_HEADER = 28;
    static final int IMAGE_SIZEOF_NT_OPTIONAL32_HEADER = 224;
    static final int IMAGE_SIZEOF_NT_OPTIONAL64_HEADER = 240;
    static final int IMAGE_NT_OPTIONAL_HDR32_MAGIC = 0x10b;
    static final int IMAGE_NT_OPTIONAL_HDR64_MAGIC = 0x20b;
    static final int IMAGE_ROM_OPTIONAL_HDR_MAGIC = 0x107;
    static final int IMAGE_SIZEOF_NT_OPTIONAL_HEADER = IMAGE_SIZEOF_NT_OPTIONAL32_HEADER;
    static final int IMAGE_NT_OPTIONAL_HDR_MAGIC = IMAGE_NT_OPTIONAL_HDR32_MAGIC;
    static final int IMAGE_SUBSYSTEM_UNKNOWN = 0;
    static final int IMAGE_SUBSYSTEM_NATIVE = 1;
    static final int IMAGE_SUBSYSTEM_WINDOWS_GUI = 2;
    static final int IMAGE_SUBSYSTEM_WINDOWS_CUI = 3;
    static final int IMAGE_SUBSYSTEM_OS2_CUI = 5;
    static final int IMAGE_SUBSYSTEM_POSIX_CUI = 7;
    static final int IMAGE_SUBSYSTEM_NATIVE_WINDOWS = 8;
    static final int IMAGE_SUBSYSTEM_WINDOWS_CE_GUI = 9;
    static final int IMAGE_SUBSYSTEM_EFI_APPLICATION = 10;
    static final int IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER = 11;
    static final int IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER = 12;
    static final int IMAGE_SUBSYSTEM_EFI_ROM = 13;
    static final int IMAGE_SUBSYSTEM_XBOX = 14;
    static final int IMAGE_DLLCHARACTERISTICS_NO_SEH = 0x0400;
    static final int IMAGE_DLLCHARACTERISTICS_NO_BIND = 0x0800;
    static final int IMAGE_DLLCHARACTERISTICS_WDM_DRIVER = 0x2000;
    static final int IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE = 0x8000;
    static final int IMAGE_DIRECTORY_ENTRY_EXPORT = 0;
    static final int IMAGE_DIRECTORY_ENTRY_IMPORT = 1;
    static final int IMAGE_DIRECTORY_ENTRY_RESOURCE = 2;
    static final int IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3;
    static final int IMAGE_DIRECTORY_ENTRY_SECURITY = 4;
    static final int IMAGE_DIRECTORY_ENTRY_BASERELOC = 5;
    static final int IMAGE_DIRECTORY_ENTRY_DEBUG = 6;
    static final int IMAGE_DIRECTORY_ENTRY_ARCHITECTURE = 7;
    static final int IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8;
    static final int IMAGE_DIRECTORY_ENTRY_TLS = 9;
    static final int IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10;
    static final int IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11;
    static final int IMAGE_DIRECTORY_ENTRY_IAT = 12;
    static final int IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT = 13;
    static final int IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14;
    static final int IMAGE_SIZEOF_SHORT_NAME = 8;
    static final int IMAGE_SIZEOF_SECTION_HEADER = 40;
    static final int IMAGE_SCN_TYPE_NO_PAD = 0x00000008;
    static final int IMAGE_SCN_CNT_CODE = 0x00000020;
    static final int IMAGE_SCN_CNT_INITIALIZED_DATA = 0x00000040;
    static final int IMAGE_SCN_CNT_UNINITIALIZED_DATA = 0x00000080;
    static final int IMAGE_SCN_LNK_OTHER = 0x00000100;
    static final int IMAGE_SCN_LNK_INFO = 0x00000200;
    static final int IMAGE_SCN_LNK_REMOVE = 0x00000800;
    static final int IMAGE_SCN_LNK_COMDAT = 0x00001000;
    static final int IMAGE_SCN_NO_DEFER_SPEC_EXC = 0x00004000;
    static final int IMAGE_SCN_GPREL = 0x00008000;
    static final int IMAGE_SCN_MEM_FARDATA = 0x00008000;
    static final int IMAGE_SCN_MEM_PURGEABLE = 0x00020000;
    static final int IMAGE_SCN_MEM_16BIT = 0x00020000;
    static final int IMAGE_SCN_MEM_LOCKED = 0x00040000;
    static final int IMAGE_SCN_MEM_PRELOAD = 0x00080000;
    static final int IMAGE_SCN_ALIGN_1BYTES = 0x00100000;
    static final int IMAGE_SCN_ALIGN_2BYTES = 0x00200000;
    static final int IMAGE_SCN_ALIGN_4BYTES = 0x00300000;
    static final int IMAGE_SCN_ALIGN_8BYTES = 0x00400000;
    static final int IMAGE_SCN_ALIGN_16BYTES = 0x00500000;
    static final int IMAGE_SCN_ALIGN_32BYTES = 0x00600000;
    static final int IMAGE_SCN_ALIGN_64BYTES = 0x00700000;
    static final int IMAGE_SCN_ALIGN_128BYTES = 0x00800000;
    static final int IMAGE_SCN_ALIGN_256BYTES = 0x00900000;
    static final int IMAGE_SCN_ALIGN_512BYTES = 0x00A00000;
    static final int IMAGE_SCN_ALIGN_1024BYTES = 0x00B00000;
    static final int IMAGE_SCN_ALIGN_2048BYTES = 0x00C00000;
    static final int IMAGE_SCN_ALIGN_4096BYTES = 0x00D00000;
    static final int IMAGE_SCN_ALIGN_8192BYTES = 0x00E00000;
    static final int IMAGE_SCN_ALIGN_MASK = 0x00F00000;
    static final int IMAGE_SCN_LNK_NRELOC_OVFL = 0x01000000;
    static final int IMAGE_SCN_MEM_DISCARDABLE = 0x02000000;
    static final int IMAGE_SCN_MEM_NOT_CACHED = 0x04000000;
    static final int IMAGE_SCN_MEM_NOT_PAGED = 0x08000000;
    static final int IMAGE_SCN_MEM_SHARED = 0x10000000;
    static final int IMAGE_SCN_MEM_EXECUTE = 0x20000000;
    static final int IMAGE_SCN_MEM_READ = 0x40000000;
    static final int IMAGE_SCN_MEM_WRITE = 0x80000000;
    static final int IMAGE_SCN_SCALE_INDEX = 0x00000001;
    static final int IMAGE_SIZEOF_SYMBOL = 18;
    static final int IMAGE_SYM_SECTION_MAX = 0xFEFF;
    static final int IMAGE_SYM_TYPE_NULL = 0x0000;
    static final int IMAGE_SYM_TYPE_VOID = 0x0001;
    static final int IMAGE_SYM_TYPE_CHAR = 0x0002;
    static final int IMAGE_SYM_TYPE_SHORT = 0x0003;
    static final int IMAGE_SYM_TYPE_INT = 0x0004;
    static final int IMAGE_SYM_TYPE_LONG = 0x0005;
    static final int IMAGE_SYM_TYPE_FLOAT = 0x0006;
    static final int IMAGE_SYM_TYPE_DOUBLE = 0x0007;
    static final int IMAGE_SYM_TYPE_STRUCT = 0x0008;
    static final int IMAGE_SYM_TYPE_UNION = 0x0009;
    static final int IMAGE_SYM_TYPE_ENUM = 0x000A;
    static final int IMAGE_SYM_TYPE_MOE = 0x000B;
    static final int IMAGE_SYM_TYPE_BYTE = 0x000C;
    static final int IMAGE_SYM_TYPE_WORD = 0x000D;
    static final int IMAGE_SYM_TYPE_UINT = 0x000E;
    static final int IMAGE_SYM_TYPE_DWORD = 0x000F;
    static final int IMAGE_SYM_TYPE_PCODE = 0x8000;
    static final int IMAGE_SYM_DTYPE_NULL = 0;
    static final int IMAGE_SYM_DTYPE_POINTER = 1;
    static final int IMAGE_SYM_DTYPE_FUNCTION = 2;
    static final int IMAGE_SYM_DTYPE_ARRAY = 3;
    static final byte IMAGE_SYM_CLASS_END_OF_FUNCTION = (byte)-1;
    static final int IMAGE_SYM_CLASS_NULL = 0x0000;
    static final int IMAGE_SYM_CLASS_AUTOMATIC = 0x0001;
    static final int IMAGE_SYM_CLASS_EXTERNAL = 0x0002;
    static final int IMAGE_SYM_CLASS_STATIC = 0x0003;
    static final int IMAGE_SYM_CLASS_REGISTER = 0x0004;
    static final int IMAGE_SYM_CLASS_EXTERNAL_DEF = 0x0005;
    static final int IMAGE_SYM_CLASS_LABEL = 0x0006;
    static final int IMAGE_SYM_CLASS_UNDEFINED_LABEL = 0x0007;
    static final int IMAGE_SYM_CLASS_MEMBER_OF_STRUCT = 0x0008;
    static final int IMAGE_SYM_CLASS_ARGUMENT = 0x0009;
    static final int IMAGE_SYM_CLASS_STRUCT_TAG = 0x000A;
    static final int IMAGE_SYM_CLASS_MEMBER_OF_UNION = 0x000B;
    static final int IMAGE_SYM_CLASS_UNION_TAG = 0x000C;
    static final int IMAGE_SYM_CLASS_TYPE_DEFINITION = 0x000D;
    static final int IMAGE_SYM_CLASS_UNDEFINED_STATIC = 0x000E;
    static final int IMAGE_SYM_CLASS_ENUM_TAG = 0x000F;
    static final int IMAGE_SYM_CLASS_MEMBER_OF_ENUM = 0x0010;
    static final int IMAGE_SYM_CLASS_REGISTER_PARAM = 0x0011;
    static final int IMAGE_SYM_CLASS_BIT_FIELD = 0x0012;
    static final int IMAGE_SYM_CLASS_FAR_EXTERNAL = 0x0044;
    static final int IMAGE_SYM_CLASS_BLOCK = 0x0064;
    static final int IMAGE_SYM_CLASS_FUNCTION = 0x0065;
    static final int IMAGE_SYM_CLASS_END_OF_STRUCT = 0x0066;
    static final int IMAGE_SYM_CLASS_FILE = 0x0067;
    static final int IMAGE_SYM_CLASS_SECTION = 0x0068;
    static final int IMAGE_SYM_CLASS_WEAK_EXTERNAL = 0x0069;
    static final int IMAGE_SYM_CLASS_CLR_TOKEN = 0x006B;
    static final int N_BTMASK = 0x000F;
    static final int N_TMASK = 0x0030;
    static final int N_TMASK1 = 0x00C0;
    static final int N_TMASK2 = 0x00F0;
    static final int N_BTSHFT = 4;
    static final int N_TSHIFT = 2;
    static final int IMAGE_SIZEOF_AUX_SYMBOL = 18;
    static final int IMAGE_COMDAT_SELECT_NODUPLICATES = 1;
    static final int IMAGE_COMDAT_SELECT_ANY = 2;
    static final int IMAGE_COMDAT_SELECT_SAME_SIZE = 3;
    static final int IMAGE_COMDAT_SELECT_EXACT_MATCH = 4;
    static final int IMAGE_COMDAT_SELECT_ASSOCIATIVE = 5;
    static final int IMAGE_COMDAT_SELECT_LARGEST = 6;
    static final int IMAGE_COMDAT_SELECT_NEWEST = 7;
    static final int IMAGE_WEAK_EXTERN_SEARCH_NOLIBRARY = 1;
    static final int IMAGE_WEAK_EXTERN_SEARCH_LIBRARY = 2;
    static final int IMAGE_WEAK_EXTERN_SEARCH_ALIAS = 3;
    static final int IMAGE_SIZEOF_RELOCATION = 10;
    static final int IMAGE_REL_I386_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_I386_DIR16 = 0x0001;
    static final int IMAGE_REL_I386_REL16 = 0x0002;
    static final int IMAGE_REL_I386_DIR32 = 0x0006;
    static final int IMAGE_REL_I386_DIR32NB = 0x0007;
    static final int IMAGE_REL_I386_SEG12 = 0x0009;
    static final int IMAGE_REL_I386_SECTION = 0x000A;
    static final int IMAGE_REL_I386_SECREL = 0x000B;
    static final int IMAGE_REL_I386_TOKEN = 0x000C;
    static final int IMAGE_REL_I386_SECREL7 = 0x000D;
    static final int IMAGE_REL_I386_REL32 = 0x0014;
    static final int IMAGE_REL_MIPS_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_MIPS_REFHALF = 0x0001;
    static final int IMAGE_REL_MIPS_REFWORD = 0x0002;
    static final int IMAGE_REL_MIPS_JMPADDR = 0x0003;
    static final int IMAGE_REL_MIPS_REFHI = 0x0004;
    static final int IMAGE_REL_MIPS_REFLO = 0x0005;
    static final int IMAGE_REL_MIPS_GPREL = 0x0006;
    static final int IMAGE_REL_MIPS_LITERAL = 0x0007;
    static final int IMAGE_REL_MIPS_SECTION = 0x000A;
    static final int IMAGE_REL_MIPS_SECREL = 0x000B;
    static final int IMAGE_REL_MIPS_SECRELLO = 0x000C;
    static final int IMAGE_REL_MIPS_SECRELHI = 0x000D;
    static final int IMAGE_REL_MIPS_TOKEN = 0x000E;
    static final int IMAGE_REL_MIPS_JMPADDR16 = 0x0010;
    static final int IMAGE_REL_MIPS_REFWORDNB = 0x0022;
    static final int IMAGE_REL_MIPS_PAIR = 0x0025;
    static final int IMAGE_REL_ALPHA_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_ALPHA_REFLONG = 0x0001;
    static final int IMAGE_REL_ALPHA_REFQUAD = 0x0002;
    static final int IMAGE_REL_ALPHA_GPREL32 = 0x0003;
    static final int IMAGE_REL_ALPHA_LITERAL = 0x0004;
    static final int IMAGE_REL_ALPHA_LITUSE = 0x0005;
    static final int IMAGE_REL_ALPHA_GPDISP = 0x0006;
    static final int IMAGE_REL_ALPHA_BRADDR = 0x0007;
    static final int IMAGE_REL_ALPHA_HINT = 0x0008;
    static final int IMAGE_REL_ALPHA_INLINE_REFLONG = 0x0009;
    static final int IMAGE_REL_ALPHA_REFHI = 0x000A;
    static final int IMAGE_REL_ALPHA_REFLO = 0x000B;
    static final int IMAGE_REL_ALPHA_PAIR = 0x000C;
    static final int IMAGE_REL_ALPHA_MATCH = 0x000D;
    static final int IMAGE_REL_ALPHA_SECTION = 0x000E;
    static final int IMAGE_REL_ALPHA_SECREL = 0x000F;
    static final int IMAGE_REL_ALPHA_REFLONGNB = 0x0010;
    static final int IMAGE_REL_ALPHA_SECRELLO = 0x0011;
    static final int IMAGE_REL_ALPHA_SECRELHI = 0x0012;
    static final int IMAGE_REL_ALPHA_REFQ3 = 0x0013;
    static final int IMAGE_REL_ALPHA_REFQ2 = 0x0014;
    static final int IMAGE_REL_ALPHA_REFQ1 = 0x0015;
    static final int IMAGE_REL_ALPHA_GPRELLO = 0x0016;
    static final int IMAGE_REL_ALPHA_GPRELHI = 0x0017;
    static final int IMAGE_REL_PPC_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_PPC_ADDR64 = 0x0001;
    static final int IMAGE_REL_PPC_ADDR32 = 0x0002;
    static final int IMAGE_REL_PPC_ADDR24 = 0x0003;
    static final int IMAGE_REL_PPC_ADDR16 = 0x0004;
    static final int IMAGE_REL_PPC_ADDR14 = 0x0005;
    static final int IMAGE_REL_PPC_REL24 = 0x0006;
    static final int IMAGE_REL_PPC_REL14 = 0x0007;
    static final int IMAGE_REL_PPC_TOCREL16 = 0x0008;
    static final int IMAGE_REL_PPC_TOCREL14 = 0x0009;
    static final int IMAGE_REL_PPC_ADDR32NB = 0x000A;
    static final int IMAGE_REL_PPC_SECREL = 0x000B;
    static final int IMAGE_REL_PPC_SECTION = 0x000C;
    static final int IMAGE_REL_PPC_IFGLUE = 0x000D;
    static final int IMAGE_REL_PPC_IMGLUE = 0x000E;
    static final int IMAGE_REL_PPC_SECREL16 = 0x000F;
    static final int IMAGE_REL_PPC_REFHI = 0x0010;
    static final int IMAGE_REL_PPC_REFLO = 0x0011;
    static final int IMAGE_REL_PPC_PAIR = 0x0012;
    static final int IMAGE_REL_PPC_SECRELLO = 0x0013;
    static final int IMAGE_REL_PPC_SECRELHI = 0x0014;
    static final int IMAGE_REL_PPC_GPREL = 0x0015;
    static final int IMAGE_REL_PPC_TOKEN = 0x0016;
    static final int IMAGE_REL_PPC_TYPEMASK = 0x00FF;
    static final int IMAGE_REL_PPC_NEG = 0x0100;
    static final int IMAGE_REL_PPC_BRTAKEN = 0x0200;
    static final int IMAGE_REL_PPC_BRNTAKEN = 0x0400;
    static final int IMAGE_REL_PPC_TOCDEFN = 0x0800;
    static final int IMAGE_REL_SH3_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_SH3_DIRECT16 = 0x0001;
    static final int IMAGE_REL_SH3_DIRECT32 = 0x0002;
    static final int IMAGE_REL_SH3_DIRECT8 = 0x0003;
    static final int IMAGE_REL_SH3_DIRECT8_WORD = 0x0004;
    static final int IMAGE_REL_SH3_DIRECT8_LONG = 0x0005;
    static final int IMAGE_REL_SH3_DIRECT4 = 0x0006;
    static final int IMAGE_REL_SH3_DIRECT4_WORD = 0x0007;
    static final int IMAGE_REL_SH3_DIRECT4_LONG = 0x0008;
    static final int IMAGE_REL_SH3_PCREL8_WORD = 0x0009;
    static final int IMAGE_REL_SH3_PCREL8_LONG = 0x000A;
    static final int IMAGE_REL_SH3_PCREL12_WORD = 0x000B;
    static final int IMAGE_REL_SH3_STARTOF_SECTION = 0x000C;
    static final int IMAGE_REL_SH3_SIZEOF_SECTION = 0x000D;
    static final int IMAGE_REL_SH3_SECTION = 0x000E;
    static final int IMAGE_REL_SH3_SECREL = 0x000F;
    static final int IMAGE_REL_SH3_DIRECT32_NB = 0x0010;
    static final int IMAGE_REL_SH3_GPREL4_LONG = 0x0011;
    static final int IMAGE_REL_SH3_TOKEN = 0x0012;
    static final int IMAGE_REL_ARM_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_ARM_ADDR32 = 0x0001;
    static final int IMAGE_REL_ARM_ADDR32NB = 0x0002;
    static final int IMAGE_REL_ARM_BRANCH24 = 0x0003;
    static final int IMAGE_REL_ARM_BRANCH11 = 0x0004;
    static final int IMAGE_REL_ARM_TOKEN = 0x0005;
    static final int IMAGE_REL_ARM_GPREL12 = 0x0006;
    static final int IMAGE_REL_ARM_GPREL7 = 0x0007;
    static final int IMAGE_REL_ARM_BLX24 = 0x0008;
    static final int IMAGE_REL_ARM_BLX11 = 0x0009;
    static final int IMAGE_REL_ARM_SECTION = 0x000E;
    static final int IMAGE_REL_ARM_SECREL = 0x000F;
    static final int IMAGE_REL_AM_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_AM_ADDR32 = 0x0001;
    static final int IMAGE_REL_AM_ADDR32NB = 0x0002;
    static final int IMAGE_REL_AM_CALL32 = 0x0003;
    static final int IMAGE_REL_AM_FUNCINFO = 0x0004;
    static final int IMAGE_REL_AM_REL32_1 = 0x0005;
    static final int IMAGE_REL_AM_REL32_2 = 0x0006;
    static final int IMAGE_REL_AM_SECREL = 0x0007;
    static final int IMAGE_REL_AM_SECTION = 0x0008;
    static final int IMAGE_REL_AM_TOKEN = 0x0009;
    static final int IMAGE_REL_AMD64_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_AMD64_ADDR64 = 0x0001;
    static final int IMAGE_REL_AMD64_ADDR32 = 0x0002;
    static final int IMAGE_REL_AMD64_ADDR32NB = 0x0003;
    static final int IMAGE_REL_AMD64_REL32 = 0x0004;
    static final int IMAGE_REL_AMD64_REL32_1 = 0x0005;
    static final int IMAGE_REL_AMD64_REL32_2 = 0x0006;
    static final int IMAGE_REL_AMD64_REL32_3 = 0x0007;
    static final int IMAGE_REL_AMD64_REL32_4 = 0x0008;
    static final int IMAGE_REL_AMD64_REL32_5 = 0x0009;
    static final int IMAGE_REL_AMD64_SECTION = 0x000A;
    static final int IMAGE_REL_AMD64_SECREL = 0x000B;
    static final int IMAGE_REL_AMD64_SECREL7 = 0x000C;
    static final int IMAGE_REL_AMD64_TOKEN = 0x000D;
    static final int IMAGE_REL_IA64_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_IA64_IMM14 = 0x0001;
    static final int IMAGE_REL_IA64_IMM22 = 0x0002;
    static final int IMAGE_REL_IA64_IMM64 = 0x0003;
    static final int IMAGE_REL_IA64_DIR32 = 0x0004;
    static final int IMAGE_REL_IA64_DIR64 = 0x0005;
    static final int IMAGE_REL_IA64_PCREL21B = 0x0006;
    static final int IMAGE_REL_IA64_PCREL21M = 0x0007;
    static final int IMAGE_REL_IA64_PCREL21F = 0x0008;
    static final int IMAGE_REL_IA64_GPREL22 = 0x0009;
    static final int IMAGE_REL_IA64_LTOFF22 = 0x000A;
    static final int IMAGE_REL_IA64_SECTION = 0x000B;
    static final int IMAGE_REL_IA64_SECREL22 = 0x000C;
    static final int IMAGE_REL_IA64_SECREL64I = 0x000D;
    static final int IMAGE_REL_IA64_SECREL32 = 0x000E;
    static final int IMAGE_REL_IA64_DIR32NB = 0x0010;
    static final int IMAGE_REL_IA64_SREL14 = 0x0011;
    static final int IMAGE_REL_IA64_SREL22 = 0x0012;
    static final int IMAGE_REL_IA64_SREL32 = 0x0013;
    static final int IMAGE_REL_IA64_UREL32 = 0x0014;
    static final int IMAGE_REL_IA64_PCREL60X = 0x0015;
    static final int IMAGE_REL_IA64_PCREL60B = 0x0016;
    static final int IMAGE_REL_IA64_PCREL60F = 0x0017;
    static final int IMAGE_REL_IA64_PCREL60I = 0x0018;
    static final int IMAGE_REL_IA64_PCREL60M = 0x0019;
    static final int IMAGE_REL_IA64_IMMGPREL64 = 0x001A;
    static final int IMAGE_REL_IA64_TOKEN = 0x001B;
    static final int IMAGE_REL_IA64_GPREL32 = 0x001C;
    static final int IMAGE_REL_IA64_ADDEND = 0x001F;
    static final int IMAGE_REL_CEF_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_CEF_ADDR32 = 0x0001;
    static final int IMAGE_REL_CEF_ADDR64 = 0x0002;
    static final int IMAGE_REL_CEF_ADDR32NB = 0x0003;
    static final int IMAGE_REL_CEF_SECTION = 0x0004;
    static final int IMAGE_REL_CEF_SECREL = 0x0005;
    static final int IMAGE_REL_CEF_TOKEN = 0x0006;
    static final int IMAGE_REL_CEE_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_CEE_ADDR32 = 0x0001;
    static final int IMAGE_REL_CEE_ADDR64 = 0x0002;
    static final int IMAGE_REL_CEE_ADDR32NB = 0x0003;
    static final int IMAGE_REL_CEE_SECTION = 0x0004;
    static final int IMAGE_REL_CEE_SECREL = 0x0005;
    static final int IMAGE_REL_CEE_TOKEN = 0x0006;
    static final int IMAGE_REL_M32R_ABSOLUTE = 0x0000;
    static final int IMAGE_REL_M32R_ADDR32 = 0x0001;
    static final int IMAGE_REL_M32R_ADDR32NB = 0x0002;
    static final int IMAGE_REL_M32R_ADDR24 = 0x0003;
    static final int IMAGE_REL_M32R_GPREL16 = 0x0004;
    static final int IMAGE_REL_M32R_PCREL24 = 0x0005;
    static final int IMAGE_REL_M32R_PCREL16 = 0x0006;
    static final int IMAGE_REL_M32R_PCREL8 = 0x0007;
    static final int IMAGE_REL_M32R_REFHALF = 0x0008;
    static final int IMAGE_REL_M32R_REFHI = 0x0009;
    static final int IMAGE_REL_M32R_REFLO = 0x000A;
    static final int IMAGE_REL_M32R_PAIR = 0x000B;
    static final int IMAGE_REL_M32R_SECTION = 0x000C;
    static final int IMAGE_REL_M32R_SECREL32 = 0x000D;
    static final int IMAGE_REL_M32R_TOKEN = 0x000E;
    static final int EMARCH_ENC_I17_IMM7B_INST_WORD_X = 3;
    static final int EMARCH_ENC_I17_IMM7B_SIZE_X = 7;
    static final int EMARCH_ENC_I17_IMM7B_INST_WORD_POS_X = 4;
    static final int EMARCH_ENC_I17_IMM7B_VAL_POS_X = 0;
    static final int EMARCH_ENC_I17_IMM9D_INST_WORD_X = 3;
    static final int EMARCH_ENC_I17_IMM9D_SIZE_X = 9;
    static final int EMARCH_ENC_I17_IMM9D_INST_WORD_POS_X = 18;
    static final int EMARCH_ENC_I17_IMM9D_VAL_POS_X = 7;
    static final int EMARCH_ENC_I17_IMM5C_INST_WORD_X = 3;
    static final int EMARCH_ENC_I17_IMM5C_SIZE_X = 5;
    static final int EMARCH_ENC_I17_IMM5C_INST_WORD_POS_X = 13;
    static final int EMARCH_ENC_I17_IMM5C_VAL_POS_X = 16;
    static final int EMARCH_ENC_I17_IC_INST_WORD_X = 3;
    static final int EMARCH_ENC_I17_IC_SIZE_X = 1;
    static final int EMARCH_ENC_I17_IC_INST_WORD_POS_X = 12;
    static final int EMARCH_ENC_I17_IC_VAL_POS_X = 21;
    static final int EMARCH_ENC_I17_IMM41a_INST_WORD_X = 1;
    static final int EMARCH_ENC_I17_IMM41a_SIZE_X = 10;
    static final int EMARCH_ENC_I17_IMM41a_INST_WORD_POS_X = 14;
    static final int EMARCH_ENC_I17_IMM41a_VAL_POS_X = 22;
    static final int EMARCH_ENC_I17_IMM41b_INST_WORD_X = 1;
    static final int EMARCH_ENC_I17_IMM41b_SIZE_X = 8;
    static final int EMARCH_ENC_I17_IMM41b_INST_WORD_POS_X = 24;
    static final int EMARCH_ENC_I17_IMM41b_VAL_POS_X = 32;
    static final int EMARCH_ENC_I17_IMM41c_INST_WORD_X = 2;
    static final int EMARCH_ENC_I17_IMM41c_SIZE_X = 23;
    static final int EMARCH_ENC_I17_IMM41c_INST_WORD_POS_X = 0;
    static final int EMARCH_ENC_I17_IMM41c_VAL_POS_X = 40;
    static final int EMARCH_ENC_I17_SIGN_INST_WORD_X = 3;
    static final int EMARCH_ENC_I17_SIGN_SIZE_X = 1;
    static final int EMARCH_ENC_I17_SIGN_INST_WORD_POS_X = 27;
    static final int EMARCH_ENC_I17_SIGN_VAL_POS_X = 63;
    static final int IMAGE_SIZEOF_LINENUMBER = 6;
    static final int IMAGE_SIZEOF_BASE_RELOCATION = 8;
    static final int IMAGE_REL_BASED_ABSOLUTE = 0;
    static final int IMAGE_REL_BASED_HIGH = 1;
    static final int IMAGE_REL_BASED_LOW = 2;
    static final int IMAGE_REL_BASED_HIGHLOW = 3;
    static final int IMAGE_REL_BASED_HIGHADJ = 4;
    static final int IMAGE_REL_BASED_MIPS_JMPADDR = 5;
    static final int IMAGE_REL_BASED_MIPS_JMPADDR16 = 9;
    static final int IMAGE_REL_BASED_IA64_IMM64 = 9;
    static final int IMAGE_REL_BASED_DIR64 = 10;
    static final int IMAGE_ARCHIVE_START_SIZE = 8;
    static final int IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR = 60;
    static final int IMAGE_ORDINAL_FLAG32 = 0x80000000;
    static final int IMAGE_ORDINAL_FLAG = IMAGE_ORDINAL_FLAG32;
    static final int IMAGE_RESOURCE_NAME_IS_STRING = 0x80000000;
    static final int IMAGE_RESOURCE_DATA_IS_DIRECTORY = 0x80000000;
    static final int IMAGE_DEBUG_TYPE_UNKNOWN = 0;
    static final int IMAGE_DEBUG_TYPE_COFF = 1;
    static final int IMAGE_DEBUG_TYPE_CODEVIEW = 2;
    static final int IMAGE_DEBUG_TYPE_FPO = 3;
    static final int IMAGE_DEBUG_TYPE_MISC = 4;
    static final int IMAGE_DEBUG_TYPE_EXCEPTION = 5;
    static final int IMAGE_DEBUG_TYPE_FIXUP = 6;
    static final int IMAGE_DEBUG_TYPE_OMAP_TO_SRC = 7;
    static final int IMAGE_DEBUG_TYPE_OMAP_FROM_SRC = 8;
    static final int IMAGE_DEBUG_TYPE_BORLAND = 9;
    static final int IMAGE_DEBUG_TYPE_RESERVED10 = 10;
    static final int IMAGE_DEBUG_TYPE_CLSID = 11;
    static final int FRAME_FPO = 0;
    static final int FRAME_TRAP = 1;
    static final int FRAME_TSS = 2;
    static final int FRAME_NONFPO = 3;
    static final int SIZEOF_RFPO_DATA = 16;
    static final int IMAGE_DEBUG_MISC_EXENAME = 1;
    static final int IMAGE_SEPARATE_DEBUG_SIGNATURE = 0x4944;
    static final int NON_PAGED_DEBUG_SIGNATURE = 0x494E;
    static final int IMAGE_SEPARATE_DEBUG_FLAGS_MASK = 0x8000;
    static final int IMAGE_SEPARATE_DEBUG_MISMATCH = 0x8000;
    static final int IMPORT_OBJECT_HDR_SIG2 = 0xffff;
    static final int HEAP_NO_SERIALIZE = 0x00000001;
    static final int HEAP_GROWABLE = 0x00000002;
    static final int HEAP_GENERATE_EXCEPTIONS = 0x00000004;
    static final int HEAP_ZERO_MEMORY = 0x00000008;
    static final int HEAP_REALLOC_IN_PLACE_ONLY = 0x00000010;
    static final int HEAP_TAIL_CHECKING_ENABLED = 0x00000020;
    static final int HEAP_FREE_CHECKING_ENABLED = 0x00000040;
    static final int HEAP_DISABLE_COALESCE_ON_FREE = 0x00000080;
    static final int HEAP_CREATE_ALIGN_16 = 0x00010000;
    static final int HEAP_CREATE_ENABLE_TRACING = 0x00020000;
    static final int HEAP_MAXIMUM_TAG = 0x0FFF;
    static final int HEAP_PSEUDO_TAG_FLAG = 0x8000;
    static final int HEAP_TAG_SHIFT = 18;
    static final int IS_TEXT_UNICODE_ASCII16 = 0x0001;
    static final int IS_TEXT_UNICODE_REVERSE_ASCII16 = 0x0010;
    static final int IS_TEXT_UNICODE_STATISTICS = 0x0002;
    static final int IS_TEXT_UNICODE_REVERSE_STATISTICS = 0x0020;
    static final int IS_TEXT_UNICODE_CONTROLS = 0x0004;
    static final int IS_TEXT_UNICODE_REVERSE_CONTROLS = 0x0040;
    static final int IS_TEXT_UNICODE_SIGNATURE = 0x0008;
    static final int IS_TEXT_UNICODE_REVERSE_SIGNATURE = 0x0080;
    static final int IS_TEXT_UNICODE_ILLEGAL_CHARS = 0x0100;
    static final int IS_TEXT_UNICODE_ODD_LENGTH = 0x0200;
    static final int IS_TEXT_UNICODE_DBCS_LEADBYTE = 0x0400;
    static final int IS_TEXT_UNICODE_NULL_BYTES = 0x1000;
    static final int IS_TEXT_UNICODE_UNICODE_MASK = 0x000F;
    static final int IS_TEXT_UNICODE_REVERSE_MASK = 0x00F0;
    static final int IS_TEXT_UNICODE_NOT_UNICODE_MASK = 0x0F00;
    static final int IS_TEXT_UNICODE_NOT_ASCII_MASK = 0xF000;
    static final int COMPRESSION_FORMAT_NONE = (0x0000);
    static final int COMPRESSION_FORMAT_DEFAULT = (0x0001);
    static final int COMPRESSION_FORMAT_LZNT1 = (0x0002);
    static final int COMPRESSION_ENGINE_STANDARD = (0x0000);
    static final int COMPRESSION_ENGINE_MAXIMUM = (0x0100);
    static final int COMPRESSION_ENGINE_HIBER = (0x0200);
    static final int MESSAGE_RESOURCE_UNICODE = 0x0001;
    static final int VER_EQUAL = 1;
    static final int VER_GREATER = 2;
    static final int VER_GREATER_EQUAL = 3;
    static final int VER_LESS = 4;
    static final int VER_LESS_EQUAL = 5;
    static final int VER_AND = 6;
    static final int VER_OR = 7;
    static final int VER_CONDITION_MASK = 7;
    static final int VER_NUM_BITS_PER_CONDITION_MASK = 3;
    static final int VER_MINORVERSION = 0x0000001;
    static final int VER_MAJORVERSION = 0x0000002;
    static final int VER_BUILDNUMBER = 0x0000004;
    static final int VER_PLATFORMID = 0x0000008;
    static final int VER_SERVICEPACKMINOR = 0x0000010;
    static final int VER_SERVICEPACKMAJOR = 0x0000020;
    static final int VER_SUITENAME = 0x0000040;
    static final int VER_PRODUCT_TYPE = 0x0000080;
    static final int VER_NT_WORKSTATION = 0x0000001;
    static final int VER_NT_DOMAIN_CONTROLLER = 0x0000002;
    static final int VER_NT_SERVER = 0x0000003;
    static final int VER_PLATFORM_WIN32s = 0;
    static final int VER_PLATFORM_WIN32_WINDOWS = 1;
    static final int VER_PLATFORM_WIN32_NT = 2;
    static final int RTL_CRITSECT_TYPE = 0;
    static final int RTL_RESOURCE_TYPE = 1;
    static final int RTL_VRF_FLG_FULL_PAGE_HEAP = 0x00000001;
    static final int RTL_VRF_FLG_RESERVED_DONOTUSE = 0x00000002;
    static final int RTL_VRF_FLG_HANDLE_CHECKS = 0x00000004;
    static final int RTL_VRF_FLG_STACK_CHECKS = 0x00000008;
    static final int RTL_VRF_FLG_APPCOMPAT_CHECKS = 0x00000010;
    static final int RTL_VRF_FLG_TLS_CHECKS = 0x00000020;
    static final int RTL_VRF_FLG_DIRTY_STACKS = 0x00000040;
    static final int RTL_VRF_FLG_RPC_CHECKS = 0x00000080;
    static final int RTL_VRF_FLG_COM_CHECKS = 0x00000100;
    static final int RTL_VRF_FLG_DANGEROUS_APIS = 0x00000200;
    static final int RTL_VRF_FLG_RACE_CHECKS = 0x00000400;
    static final int RTL_VRF_FLG_DEADLOCK_CHECKS = 0x00000800;
    static final int RTL_VRF_FLG_FIRST_CHANCE_EXCEPTION_CHECKS = 0x00001000;
    static final int RTL_VRF_FLG_VIRTUAL_MEM_CHECKS = 0x00002000;
    static final int RTL_VRF_FLG_ENABLE_LOGGING = 0x00004000;
    static final int RTL_VRF_FLG_FAST_FILL_HEAP = 0x00008000;
    static final int RTL_VRF_FLG_VIRTUAL_SPACE_TRACKING = 0x00010000;
    static final int RTL_VRF_FLG_ENABLED_SYSTEM_WIDE = 0x00020000;
    static final int RTL_VRF_FLG_MISCELLANEOUS_CHECKS = 0x00020000;
    static final int RTL_VRF_FLG_LOCK_CHECKS = 0x00040000;
    static final int APPLICATION_VERIFIER_INTERNAL_ERROR = 0x80000000;
    static final int APPLICATION_VERIFIER_INTERNAL_WARNING = 0x40000000;
    static final int APPLICATION_VERIFIER_NO_BREAK = 0x20000000;
    static final int APPLICATION_VERIFIER_CONTINUABLE_BREAK = 0x10000000;
    static final int APPLICATION_VERIFIER_UNKNOWN_ERROR = 0x0001;
    static final int APPLICATION_VERIFIER_ACCESS_VIOLATION = 0x0002;
    static final int APPLICATION_VERIFIER_UNSYNCHRONIZED_ACCESS = 0x0003;
    static final int APPLICATION_VERIFIER_EXTREME_SIZE_REQUEST = 0x0004;
    static final int APPLICATION_VERIFIER_BAD_HEAP_HANDLE = 0x0005;
    static final int APPLICATION_VERIFIER_SWITCHED_HEAP_HANDLE = 0x0006;
    static final int APPLICATION_VERIFIER_DOUBLE_FREE = 0x0007;
    static final int APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK = 0x0008;
    static final int APPLICATION_VERIFIER_DESTROY_PROCESS_HEAP = 0x0009;
    static final int APPLICATION_VERIFIER_UNEXPECTED_EXCEPTION = 0x000A;
    static final int APPLICATION_VERIFIER_STACK_OVERFLOW = 0x000B;
    static final int APPLICATION_VERIFIER_TERMINATE_THREAD_CALL = 0x0100;
    static final int APPLICATION_VERIFIER_INVALID_EXIT_PROCESS_CALL = 0x0101;
    static final int APPLICATION_VERIFIER_EXIT_THREAD_OWNS_LOCK = 0x0200;
    static final int APPLICATION_VERIFIER_LOCK_IN_UNLOADED_DLL = 0x0201;
    static final int APPLICATION_VERIFIER_LOCK_IN_FREED_HEAP = 0x0202;
    static final int APPLICATION_VERIFIER_LOCK_DOUBLE_INITIALIZE = 0x0203;
    static final int APPLICATION_VERIFIER_LOCK_IN_FREED_MEMORY = 0x0204;
    static final int APPLICATION_VERIFIER_LOCK_CORRUPTED = 0x0205;
    static final int APPLICATION_VERIFIER_LOCK_INVALID_OWNER = 0x0206;
    static final int APPLICATION_VERIFIER_LOCK_INVALID_RECURSION_COUNT = 0x0207;
    static final int APPLICATION_VERIFIER_LOCK_INVALID_LOCK_COUNT = 0x0208;
    static final int APPLICATION_VERIFIER_LOCK_OVER_RELEASED = 0x0209;
    static final int APPLICATION_VERIFIER_LOCK_NOT_INITIALIZED = 0x0210;
    static final int APPLICATION_VERIFIER_LOCK_ALREADY_INITIALIZED = 0x0211;
    static final int APPLICATION_VERIFIER_INVALID_HANDLE = 0x0300;
    static final int APPLICATION_VERIFIER_INVALID_TLS_VALUE = 0x0301;
    static final int APPLICATION_VERIFIER_INCORRECT_WAIT_CALL = 0x0302;
    static final int APPLICATION_VERIFIER_NULL_HANDLE = 0x0303;
    static final int APPLICATION_VERIFIER_WAIT_IN_DLLMAIN = 0x0304;
    static final int APPLICATION_VERIFIER_COM_ERROR = 0x0400;
    static final int APPLICATION_VERIFIER_COM_API_IN_DLLMAIN = 0x0401;
    static final int APPLICATION_VERIFIER_COM_UNHANDLED_EXCEPTION = 0x0402;
    static final int APPLICATION_VERIFIER_COM_UNBALANCED_COINIT = 0x0403;
    static final int APPLICATION_VERIFIER_COM_UNBALANCED_OLEINIT = 0x0404;
    static final int APPLICATION_VERIFIER_COM_UNBALANCED_SWC = 0x0405;
    static final int APPLICATION_VERIFIER_COM_NULL_DACL = 0x0406;
    static final int APPLICATION_VERIFIER_COM_UNSAFE_IMPERSONATION = 0x0407;
    static final int APPLICATION_VERIFIER_COM_SMUGGLED_WRAPPER = 0x0408;
    static final int APPLICATION_VERIFIER_COM_SMUGGLED_PROXY = 0x0409;
    static final int APPLICATION_VERIFIER_COM_CF_SUCCESS_WITH_NULL = 0x040A;
    static final int APPLICATION_VERIFIER_COM_GCO_SUCCESS_WITH_NULL = 0x040B;
    static final int APPLICATION_VERIFIER_COM_OBJECT_IN_FREED_MEMORY = 0x040C;
    static final int APPLICATION_VERIFIER_COM_OBJECT_IN_UNLOADED_DLL = 0x040D;
    static final int APPLICATION_VERIFIER_COM_VTBL_IN_FREED_MEMORY = 0x040E;
    static final int APPLICATION_VERIFIER_COM_VTBL_IN_UNLOADED_DLL = 0x040F;
    static final int APPLICATION_VERIFIER_COM_HOLDING_LOCKS_ON_CALL = 0x0410;
    static final int APPLICATION_VERIFIER_RPC_ERROR = 0x0500;
    static final int APPLICATION_VERIFIER_INVALID_FREEMEM = 0x0600;
    static final int APPLICATION_VERIFIER_INVALID_ALLOCMEM = 0x0601;
    static final int APPLICATION_VERIFIER_INVALID_MAPVIEW = 0x0602;
    static final int APPLICATION_VERIFIER_PROBE_INVALID_ADDRESS = 0x0603;
    static final int APPLICATION_VERIFIER_PROBE_FREE_MEM = 0x0604;
    static final int APPLICATION_VERIFIER_PROBE_GUARD_PAGE = 0x0605;
    static final int APPLICATION_VERIFIER_PROBE_NULL = 0x0606;
    static final int APPLICATION_VERIFIER_PROBE_INVALID_START_OR_SIZE = 0x0607;
    static final int SEF_DACL_AUTO_INHERIT = 0x01;
    static final int SEF_SACL_AUTO_INHERIT = 0x02;
    static final int SEF_DEFAULT_DESCRIPTOR_FOR_OBJECT = 0x04;
    static final int SEF_AVOID_PRIVILEGE_CHECK = 0x08;
    static final int SEF_AVOID_OWNER_CHECK = 0x10;
    static final int SEF_DEFAULT_OWNER_FROM_PARENT = 0x20;
    static final int SEF_DEFAULT_GROUP_FROM_PARENT = 0x40;
    static final int WT_EXECUTEDEFAULT = 0x00000000;
    static final int WT_EXECUTEINIOTHREAD = 0x00000001;
    static final int WT_EXECUTEINUITHREAD = 0x00000002;
    static final int WT_EXECUTEINWAITTHREAD = 0x00000004;
    static final int WT_EXECUTEONLYONCE = 0x00000008;
    static final int WT_EXECUTEINTIMERTHREAD = 0x00000020;
    static final int WT_EXECUTELONGFUNCTION = 0x00000010;
    static final int WT_EXECUTEINPERSISTENTIOTHREAD = 0x00000040;
    static final int WT_EXECUTEINPERSISTENTTHREAD = 0x00000080;
    static final int WT_TRANSFER_IMPERSONATION = 0x00000100;
    static final int WT_EXECUTEINLONGTHREAD = 0x00000010;
    static final int WT_EXECUTEDELETEWAIT = 0x00000008;
    static final int ACTIVATION_CONTEXT_PATH_TYPE_NONE = (1);
    static final int ACTIVATION_CONTEXT_PATH_TYPE_WIN32_FILE = (2);
    static final int ACTIVATION_CONTEXT_PATH_TYPE_URL = (3);
    static final int ACTIVATION_CONTEXT_PATH_TYPE_ASSEMBLYREF = (4);
    static final int DLL_PROCESS_ATTACH = 1;
    static final int DLL_THREAD_ATTACH = 2;
    static final int DLL_THREAD_DETACH = 3;
    static final int DLL_PROCESS_DETACH = 0;
    static final int DLL_PROCESS_VERIFIER = 4;
    static final int EVENTLOG_SEQUENTIAL_READ = 0x0001;
    static final int EVENTLOG_SEEK_READ = 0x0002;
    static final int EVENTLOG_FORWARDS_READ = 0x0004;
    static final int EVENTLOG_BACKWARDS_READ = 0x0008;
    static final int EVENTLOG_SUCCESS = 0x0000;
    static final int EVENTLOG_ERROR_TYPE = 0x0001;
    static final int EVENTLOG_WARNING_TYPE = 0x0002;
    static final int EVENTLOG_INFORMATION_TYPE = 0x0004;
    static final int EVENTLOG_AUDIT_SUCCESS = 0x0008;
    static final int EVENTLOG_AUDIT_FAILURE = 0x0010;
    static final int EVENTLOG_START_PAIRED_EVENT = 0x0001;
    static final int EVENTLOG_END_PAIRED_EVENT = 0x0002;
    static final int EVENTLOG_END_ALL_PAIRED_EVENTS = 0x0004;
    static final int EVENTLOG_PAIRED_EVENT_ACTIVE = 0x0008;
    static final int EVENTLOG_PAIRED_EVENT_INACTIVE = 0x0010;
    static final int MAXLOGICALLOGNAMESIZE = 256;
    static final int KEY_QUERY_VALUE = (0x0001);
    static final int KEY_SET_VALUE = (0x0002);
    static final int KEY_CREATE_SUB_KEY = (0x0004);
    static final int KEY_ENUMERATE_SUB_KEYS = (0x0008);
    static final int KEY_NOTIFY = (0x0010);
    static final int KEY_CREATE_LINK = (0x0020);
    static final int KEY_WOW64_32KEY = (0x0200);
    static final int KEY_WOW64_64KEY = (0x0100);
    static final int KEY_WOW64_RES = (0x0300);
    static final int REG_OPTION_RESERVED = (0x00000000);
    static final int REG_OPTION_NON_VOLATILE = (0x00000000);
    static final int REG_OPTION_VOLATILE = (0x00000001);
    static final int REG_OPTION_CREATE_LINK = (0x00000002);
    static final int REG_OPTION_BACKUP_RESTORE = (0x00000004);
    static final int REG_OPTION_OPEN_LINK = (0x00000008);
    static final int REG_LEGAL_OPTION = (REG_OPTION_RESERVED | REG_OPTION_NON_VOLATILE | REG_OPTION_VOLATILE | REG_OPTION_CREATE_LINK | REG_OPTION_BACKUP_RESTORE | REG_OPTION_OPEN_LINK);
    static final int REG_CREATED_NEW_KEY = (0x00000001);
    static final int REG_OPENED_EXISTING_KEY = (0x00000002);
    static final int REG_STANDARD_FORMAT = 1;
    static final int REG_LATEST_FORMAT = 2;
    static final int REG_NO_COMPRESSION = 4;
    static final int REG_WHOLE_HIVE_VOLATILE = (0x00000001);
    static final int REG_REFRESH_HIVE = (0x00000002);
    static final int REG_NO_LAZY_FLUSH = (0x00000004);
    static final int REG_FORCE_RESTORE = (0x00000008);
    static final int REG_NOTIFY_CHANGE_NAME = (0x00000001);
    static final int REG_NOTIFY_CHANGE_ATTRIBUTES = (0x00000002);
    static final int REG_NOTIFY_CHANGE_LAST_SET = (0x00000004);
    static final int REG_NOTIFY_CHANGE_SECURITY = (0x00000008);
    static final int REG_LEGAL_CHANGE_FILTER = (REG_NOTIFY_CHANGE_NAME | REG_NOTIFY_CHANGE_ATTRIBUTES | REG_NOTIFY_CHANGE_LAST_SET | REG_NOTIFY_CHANGE_SECURITY);
    static final int REG_NONE = ( 0 );
    static final int REG_SZ = ( 1 );
    static final int REG_EXPAND_SZ = ( 2 );
    static final int REG_BINARY = ( 3 );
    static final int REG_DWORD = ( 4 );
    static final int REG_DWORD_LITTLE_ENDIAN = ( 4 );
    static final int REG_DWORD_BIG_ENDIAN = ( 5 );
    static final int REG_LINK = ( 6 );
    static final int REG_MULTI_SZ = ( 7 );
    static final int REG_RESOURCE_LIST = ( 8 );
    static final int REG_FULL_RESOURCE_DESCRIPTOR = ( 9 );
    static final int REG_RESOURCE_REQUIREMENTS_LIST = ( 10 );
    static final int REG_QWORD = ( 11 );
    static final int REG_QWORD_LITTLE_ENDIAN = ( 11 );
    static final int SERVICE_KERNEL_DRIVER = 0x00000001;
    static final int SERVICE_FILE_SYSTEM_DRIVER = 0x00000002;
    static final int SERVICE_ADAPTER = 0x00000004;
    static final int SERVICE_RECOGNIZER_DRIVER = 0x00000008;
    static final int SERVICE_DRIVER = (SERVICE_KERNEL_DRIVER | SERVICE_FILE_SYSTEM_DRIVER | SERVICE_RECOGNIZER_DRIVER);
    static final int SERVICE_WIN32_OWN_PROCESS = 0x00000010;
    static final int SERVICE_WIN32_SHARE_PROCESS = 0x00000020;
    static final int SERVICE_WIN32 = (SERVICE_WIN32_OWN_PROCESS | SERVICE_WIN32_SHARE_PROCESS);
    static final int SERVICE_INTERACTIVE_PROCESS = 0x00000100;
    static final int SERVICE_TYPE_ALL = (SERVICE_WIN32 | SERVICE_ADAPTER | SERVICE_DRIVER | SERVICE_INTERACTIVE_PROCESS);
    static final int SERVICE_BOOT_START = 0x00000000;
    static final int SERVICE_SYSTEM_START = 0x00000001;
    static final int SERVICE_AUTO_START = 0x00000002;
    static final int SERVICE_DEMAND_START = 0x00000003;
    static final int SERVICE_DISABLED = 0x00000004;
    static final int SERVICE_ERROR_IGNORE = 0x00000000;
    static final int SERVICE_ERROR_NORMAL = 0x00000001;
    static final int SERVICE_ERROR_SEVERE = 0x00000002;
    static final int SERVICE_ERROR_CRITICAL = 0x00000003;
    static final int TAPE_ERASE_SHORT = 0;
    static final int TAPE_ERASE_LONG = 1;
    static final int TAPE_LOAD = 0;
    static final int TAPE_UNLOAD = 1;
    static final int TAPE_TENSION = 2;
    static final int TAPE_LOCK = 3;
    static final int TAPE_UNLOCK = 4;
    static final int TAPE_FORMAT = 5;
    static final int TAPE_SETMARKS = 0;
    static final int TAPE_FILEMARKS = 1;
    static final int TAPE_SHORT_FILEMARKS = 2;
    static final int TAPE_LONG_FILEMARKS = 3;
    static final int TAPE_ABSOLUTE_POSITION = 0;
    static final int TAPE_LOGICAL_POSITION = 1;
    static final int TAPE_PSEUDO_LOGICAL_POSITION = 2;
    static final int TAPE_REWIND = 0;
    static final int TAPE_ABSOLUTE_BLOCK = 1;
    static final int TAPE_LOGICAL_BLOCK = 2;
    static final int TAPE_PSEUDO_LOGICAL_BLOCK = 3;
    static final int TAPE_SPACE_END_OF_DATA = 4;
    static final int TAPE_SPACE_RELATIVE_BLOCKS = 5;
    static final int TAPE_SPACE_FILEMARKS = 6;
    static final int TAPE_SPACE_SEQUENTIAL_FMKS = 7;
    static final int TAPE_SPACE_SETMARKS = 8;
    static final int TAPE_SPACE_SEQUENTIAL_SMKS = 9;
    static final int TAPE_DRIVE_FIXED = 0x00000001;
    static final int TAPE_DRIVE_SELECT = 0x00000002;
    static final int TAPE_DRIVE_INITIATOR = 0x00000004;
    static final int TAPE_DRIVE_ERASE_SHORT = 0x00000010;
    static final int TAPE_DRIVE_ERASE_LONG = 0x00000020;
    static final int TAPE_DRIVE_ERASE_BOP_ONLY = 0x00000040;
    static final int TAPE_DRIVE_ERASE_IMMEDIATE = 0x00000080;
    static final int TAPE_DRIVE_TAPE_CAPACITY = 0x00000100;
    static final int TAPE_DRIVE_TAPE_REMAINING = 0x00000200;
    static final int TAPE_DRIVE_FIXED_BLOCK = 0x00000400;
    static final int TAPE_DRIVE_VARIABLE_BLOCK = 0x00000800;
    static final int TAPE_DRIVE_WRITE_PROTECT = 0x00001000;
    static final int TAPE_DRIVE_EOT_WZ_SIZE = 0x00002000;
    static final int TAPE_DRIVE_ECC = 0x00010000;
    static final int TAPE_DRIVE_COMPRESSION = 0x00020000;
    static final int TAPE_DRIVE_PADDING = 0x00040000;
    static final int TAPE_DRIVE_REPORT_SMKS = 0x00080000;
    static final int TAPE_DRIVE_GET_ABSOLUTE_BLK = 0x00100000;
    static final int TAPE_DRIVE_GET_LOGICAL_BLK = 0x00200000;
    static final int TAPE_DRIVE_SET_EOT_WZ_SIZE = 0x00400000;
    static final int TAPE_DRIVE_EJECT_MEDIA = 0x01000000;
    static final int TAPE_DRIVE_CLEAN_REQUESTS = 0x02000000;
    static final int TAPE_DRIVE_SET_CMP_BOP_ONLY = 0x04000000;
    static final int TAPE_DRIVE_RESERVED_BIT = 0x80000000;
    static final int TAPE_DRIVE_LOAD_UNLOAD = 0x80000001;
    static final int TAPE_DRIVE_TENSION = 0x80000002;
    static final int TAPE_DRIVE_LOCK_UNLOCK = 0x80000004;
    static final int TAPE_DRIVE_REWIND_IMMEDIATE = 0x80000008;
    static final int TAPE_DRIVE_SET_BLOCK_SIZE = 0x80000010;
    static final int TAPE_DRIVE_LOAD_UNLD_IMMED = 0x80000020;
    static final int TAPE_DRIVE_TENSION_IMMED = 0x80000040;
    static final int TAPE_DRIVE_LOCK_UNLK_IMMED = 0x80000080;
    static final int TAPE_DRIVE_SET_ECC = 0x80000100;
    static final int TAPE_DRIVE_SET_COMPRESSION = 0x80000200;
    static final int TAPE_DRIVE_SET_PADDING = 0x80000400;
    static final int TAPE_DRIVE_SET_REPORT_SMKS = 0x80000800;
    static final int TAPE_DRIVE_ABSOLUTE_BLK = 0x80001000;
    static final int TAPE_DRIVE_ABS_BLK_IMMED = 0x80002000;
    static final int TAPE_DRIVE_LOGICAL_BLK = 0x80004000;
    static final int TAPE_DRIVE_LOG_BLK_IMMED = 0x80008000;
    static final int TAPE_DRIVE_END_OF_DATA = 0x80010000;
    static final int TAPE_DRIVE_RELATIVE_BLKS = 0x80020000;
    static final int TAPE_DRIVE_FILEMARKS = 0x80040000;
    static final int TAPE_DRIVE_SEQUENTIAL_FMKS = 0x80080000;
    static final int TAPE_DRIVE_SETMARKS = 0x80100000;
    static final int TAPE_DRIVE_SEQUENTIAL_SMKS = 0x80200000;
    static final int TAPE_DRIVE_REVERSE_POSITION = 0x80400000;
    static final int TAPE_DRIVE_SPACE_IMMEDIATE = 0x80800000;
    static final int TAPE_DRIVE_WRITE_SETMARKS = 0x81000000;
    static final int TAPE_DRIVE_WRITE_FILEMARKS = 0x82000000;
    static final int TAPE_DRIVE_WRITE_SHORT_FMKS = 0x84000000;
    static final int TAPE_DRIVE_WRITE_LONG_FMKS = 0x88000000;
    static final int TAPE_DRIVE_WRITE_MARK_IMMED = 0x90000000;
    static final int TAPE_DRIVE_FORMAT = 0xA0000000;
    static final int TAPE_DRIVE_FORMAT_IMMEDIATE = 0xC0000000;
    static final int TAPE_DRIVE_HIGH_FEATURES = 0x80000000;
    static final int TAPE_FIXED_PARTITIONS = 0;
    static final int TAPE_SELECT_PARTITIONS = 1;
    static final int TAPE_INITIATOR_PARTITIONS = 2;
    static final int TAPE_QUERY_DRIVE_PARAMETERS = 0;
    static final int TAPE_QUERY_MEDIA_CAPACITY = 1;
    static final int TAPE_CHECK_FOR_DRIVE_PROBLEM = 2;
    static final int TAPE_QUERY_IO_ERROR_DATA = 3;
    static final int TAPE_QUERY_DEVICE_ERROR_DATA = 4;
    static final int FILE_BEGIN = 0;
    static final int FILE_CURRENT = 1;
    static final int FILE_END = 2;
    static final int FILE_FLAG_WRITE_THROUGH = 0x80000000;
    static final int FILE_FLAG_OVERLAPPED = 0x40000000;
    static final int FILE_FLAG_NO_BUFFERING = 0x20000000;
    static final int FILE_FLAG_RANDOM_ACCESS = 0x10000000;
    static final int FILE_FLAG_SEQUENTIAL_SCAN = 0x08000000;
    static final int FILE_FLAG_DELETE_ON_CLOSE = 0x04000000;
    static final int FILE_FLAG_BACKUP_SEMANTICS = 0x02000000;
    static final int FILE_FLAG_POSIX_SEMANTICS = 0x01000000;
    static final int FILE_FLAG_OPEN_REPARSE_POINT = 0x00200000;
    static final int FILE_FLAG_OPEN_NO_RECALL = 0x00100000;
    static final int FILE_FLAG_FIRST_PIPE_INSTANCE = 0x00080000;
    static final int CREATE_NEW = 1;
    static final int CREATE_ALWAYS = 2;
    static final int OPEN_EXISTING = 3;
    static final int OPEN_ALWAYS = 4;
    static final int TRUNCATE_EXISTING = 5;
    static final int PROGRESS_CONTINUE = 0;
    static final int PROGRESS_CANCEL = 1;
    static final int PROGRESS_STOP = 2;
    static final int PROGRESS_QUIET = 3;
    static final int CALLBACK_CHUNK_FINISHED = 0x00000000;
    static final int CALLBACK_STREAM_SWITCH = 0x00000001;
    static final int COPY_FILE_FAIL_IF_EXISTS = 0x00000001;
    static final int COPY_FILE_RESTARTABLE = 0x00000002;
    static final int COPY_FILE_OPEN_SOURCE_FOR_WRITE = 0x00000004;
    static final int COPY_FILE_ALLOW_DECRYPTED_DESTINATION = 0x00000008;
    static final int REPLACEFILE_WRITE_THROUGH = 0x00000001;
    static final int REPLACEFILE_IGNORE_MERGE_ERRORS = 0x00000002;
    static final int PIPE_ACCESS_INBOUND = 0x00000001;
    static final int PIPE_ACCESS_OUTBOUND = 0x00000002;
    static final int PIPE_ACCESS_DUPLEX = 0x00000003;
    static final int PIPE_CLIENT_END = 0x00000000;
    static final int PIPE_SERVER_END = 0x00000001;
    static final int PIPE_WAIT = 0x00000000;
    static final int PIPE_NOWAIT = 0x00000001;
    static final int PIPE_READMODE_BYTE = 0x00000000;
    static final int PIPE_READMODE_MESSAGE = 0x00000002;
    static final int PIPE_TYPE_BYTE = 0x00000000;
    static final int PIPE_TYPE_MESSAGE = 0x00000004;
    static final int PIPE_UNLIMITED_INSTANCES = 255;
    static final int SECURITY_CONTEXT_TRACKING = 0x00040000;
    static final int SECURITY_EFFECTIVE_ONLY = 0x00080000;
    static final int SECURITY_SQOS_PRESENT = 0x00100000;
    static final int SECURITY_VALID_SQOS_FLAGS = 0x001F0000;
    static final int MUTEX_MODIFY_STATE = MUTANT_QUERY_STATE;
    static final int MUTEX_ALL_ACCESS = MUTANT_ALL_ACCESS;
    static final int DTR_CONTROL_DISABLE = 0x00;
    static final int DTR_CONTROL_ENABLE = 0x01;
    static final int DTR_CONTROL_HANDSHAKE = 0x02;
    static final int RTS_CONTROL_DISABLE = 0x00;
    static final int RTS_CONTROL_ENABLE = 0x01;
    static final int RTS_CONTROL_HANDSHAKE = 0x02;
    static final int RTS_CONTROL_TOGGLE = 0x03;
    static final int GMEM_FIXED = 0x0000;
    static final int GMEM_MOVEABLE = 0x0002;
    static final int GMEM_NOCOMPACT = 0x0010;
    static final int GMEM_NODISCARD = 0x0020;
    static final int GMEM_ZEROINIT = 0x0040;
    static final int GMEM_MODIFY = 0x0080;
    static final int GMEM_DISCARDABLE = 0x0100;
    static final int GMEM_NOT_BANKED = 0x1000;
    static final int GMEM_SHARE = 0x2000;
    static final int GMEM_DDESHARE = 0x2000;
    static final int GMEM_NOTIFY = 0x4000;
    static final int GMEM_LOWER = GMEM_NOT_BANKED;
    static final int GMEM_VALID_FLAGS = 0x7F72;
    static final int GMEM_INVALID_HANDLE = 0x8000;
    static final int GHND = (GMEM_MOVEABLE | GMEM_ZEROINIT);
    static final int GPTR = (GMEM_FIXED | GMEM_ZEROINIT);
    static final int GMEM_DISCARDED = 0x4000;
    static final int GMEM_LOCKCOUNT = 0x00FF;
    static final int LMEM_FIXED = 0x0000;
    static final int LMEM_MOVEABLE = 0x0002;
    static final int LMEM_NOCOMPACT = 0x0010;
    static final int LMEM_NODISCARD = 0x0020;
    static final int LMEM_ZEROINIT = 0x0040;
    static final int LMEM_MODIFY = 0x0080;
    static final int LMEM_DISCARDABLE = 0x0F00;
    static final int LMEM_VALID_FLAGS = 0x0F72;
    static final int LMEM_INVALID_HANDLE = 0x8000;
    static final int LHND = (LMEM_MOVEABLE | LMEM_ZEROINIT);
    static final int LPTR = (LMEM_FIXED | LMEM_ZEROINIT);
    static final int NONZEROLHND = (LMEM_MOVEABLE);
    static final int NONZEROLPTR = (LMEM_FIXED);
    static final int LMEM_DISCARDED = 0x4000;
    static final int LMEM_LOCKCOUNT = 0x00FF;
    static final int DEBUG_PROCESS = 0x00000001;
    static final int DEBUG_ONLY_THIS_PROCESS = 0x00000002;
    static final int CREATE_SUSPENDED = 0x00000004;
    static final int DETACHED_PROCESS = 0x00000008;
    static final int CREATE_NEW_CONSOLE = 0x00000010;
    static final int NORMAL_PRIORITY_CLASS = 0x00000020;
    static final int IDLE_PRIORITY_CLASS = 0x00000040;
    static final int HIGH_PRIORITY_CLASS = 0x00000080;
    static final int REALTIME_PRIORITY_CLASS = 0x00000100;
    static final int CREATE_NEW_PROCESS_GROUP = 0x00000200;
    static final int CREATE_UNICODE_ENVIRONMENT = 0x00000400;
    static final int CREATE_SEPARATE_WOW_VDM = 0x00000800;
    static final int CREATE_SHARED_WOW_VDM = 0x00001000;
    static final int CREATE_FORCEDOS = 0x00002000;
    static final int BELOW_NORMAL_PRIORITY_CLASS = 0x00004000;
    static final int ABOVE_NORMAL_PRIORITY_CLASS = 0x00008000;
    static final int STACK_SIZE_PARAM_IS_A_RESERVATION = 0x00010000;
    static final int CREATE_BREAKAWAY_FROM_JOB = 0x01000000;
    static final int CREATE_PRESERVE_CODE_AUTHZ_LEVEL = 0x02000000;
    static final int CREATE_DEFAULT_ERROR_MODE = 0x04000000;
    static final int CREATE_NO_WINDOW = 0x08000000;
    static final int PROFILE_USER = 0x10000000;
    static final int PROFILE_KERNEL = 0x20000000;
    static final int PROFILE_SERVER = 0x40000000;
    static final int CREATE_IGNORE_SYSTEM_DEFAULT = 0x80000000;
    static final int THREAD_PRIORITY_LOWEST = THREAD_BASE_PRIORITY_MIN;
    static final int THREAD_PRIORITY_BELOW_NORMAL = (THREAD_PRIORITY_LOWEST+1);
    static final int THREAD_PRIORITY_NORMAL = 0;
    static final int THREAD_PRIORITY_HIGHEST = THREAD_BASE_PRIORITY_MAX;
    static final int THREAD_PRIORITY_ABOVE_NORMAL = (THREAD_PRIORITY_HIGHEST-1);
    static final int THREAD_PRIORITY_ERROR_RETURN = (MAXLONG);
    static final int THREAD_PRIORITY_TIME_CRITICAL = THREAD_BASE_PRIORITY_LOWRT;
    static final int THREAD_PRIORITY_IDLE = THREAD_BASE_PRIORITY_IDLE;
    static final int EXCEPTION_DEBUG_EVENT = 1;
    static final int CREATE_THREAD_DEBUG_EVENT = 2;
    static final int CREATE_PROCESS_DEBUG_EVENT = 3;
    static final int EXIT_THREAD_DEBUG_EVENT = 4;
    static final int EXIT_PROCESS_DEBUG_EVENT = 5;
    static final int LOAD_DLL_DEBUG_EVENT = 6;
    static final int UNLOAD_DLL_DEBUG_EVENT = 7;
    static final int OUTPUT_DEBUG_STRING_EVENT = 8;
    static final int RIP_EVENT = 9;
    static final int DRIVE_UNKNOWN = 0;
    static final int DRIVE_NO_ROOT_DIR = 1;
    static final int DRIVE_REMOVABLE = 2;
    static final int DRIVE_FIXED = 3;
    static final int DRIVE_REMOTE = 4;
    static final int DRIVE_CDROM = 5;
    static final int DRIVE_RAMDISK = 6;
    static final int FILE_TYPE_UNKNOWN = 0x0000;
    static final int FILE_TYPE_DISK = 0x0001;
    static final int FILE_TYPE_CHAR = 0x0002;
    static final int FILE_TYPE_PIPE = 0x0003;
    static final int FILE_TYPE_REMOTE = 0x8000;
    static final int NOPARITY = 0;
    static final int ODDPARITY = 1;
    static final int EVENPARITY = 2;
    static final int MARKPARITY = 3;
    static final int SPACEPARITY = 4;
    static final int ONESTOPBIT = 0;
    static final int ONE5STOPBITS = 1;
    static final int TWOSTOPBITS = 2;
    static final int IGNORE = 0;
    static final int INFINITE = 0xFFFFFFFF;
    static final int CBR_110 = 110;
    static final int CBR_300 = 300;
    static final int CBR_600 = 600;
    static final int CBR_1200 = 1200;
    static final int CBR_2400 = 2400;
    static final int CBR_4800 = 4800;
    static final int CBR_9600 = 9600;
    static final int CBR_14400 = 14400;
    static final int CBR_19200 = 19200;
    static final int CBR_38400 = 38400;
    static final int CBR_56000 = 56000;
    static final int CBR_57600 = 57600;
    static final int CBR_115200 = 115200;
    static final int CBR_128000 = 128000;
    static final int CBR_256000 = 256000;
    static final int CE_RXOVER = 0x0001;
    static final int CE_OVERRUN = 0x0002;
    static final int CE_RXPARITY = 0x0004;
    static final int CE_FRAME = 0x0008;
    static final int CE_BREAK = 0x0010;
    static final int CE_TXFULL = 0x0100;
    static final int CE_PTO = 0x0200;
    static final int CE_IOE = 0x0400;
    static final int CE_DNS = 0x0800;
    static final int CE_OOP = 0x1000;
    static final int CE_MODE = 0x8000;
    static final int IE_BADID = (-1);
    static final int IE_OPEN = (-2);
    static final int IE_NOPEN = (-3);
    static final int IE_MEMORY = (-4);
    static final int IE_DEFAULT = (-5);
    static final int IE_HARDWARE = (-10);
    static final int IE_BYTESIZE = (-11);
    static final int IE_BAUDRATE = (-12);
    static final int EV_RXCHAR = 0x0001;
    static final int EV_RXFLAG = 0x0002;
    static final int EV_TXEMPTY = 0x0004;
    static final int EV_CTS = 0x0008;
    static final int EV_DSR = 0x0010;
    static final int EV_RLSD = 0x0020;
    static final int EV_BREAK = 0x0040;
    static final int EV_ERR = 0x0080;
    static final int EV_RING = 0x0100;
    static final int EV_PERR = 0x0200;
    static final int EV_RX80FULL = 0x0400;
    static final int EV_EVENT1 = 0x0800;
    static final int EV_EVENT2 = 0x1000;
    static final int SETXOFF = 1;
    static final int SETXON = 2;
    static final int SETRTS = 3;
    static final int CLRRTS = 4;
    static final int SETDTR = 5;
    static final int CLRDTR = 6;
    static final int RESETDEV = 7;
    static final int SETBREAK = 8;
    static final int CLRBREAK = 9;
    static final int PURGE_TXABORT = 0x0001;
    static final int PURGE_RXABORT = 0x0002;
    static final int PURGE_TXCLEAR = 0x0004;
    static final int PURGE_RXCLEAR = 0x0008;
    static final int LPTx = 0x80;
    static final int S_QUEUEEMPTY = 0;
    static final int S_THRESHOLD = 1;
    static final int S_ALLTHRESHOLD = 2;
    static final int S_NORMAL = 0;
    static final int S_LEGATO = 1;
    static final int S_STACCATO = 2;
    static final int S_PERIOD512 = 0;
    static final int S_PERIOD1024 = 1;
    static final int S_PERIOD2048 = 2;
    static final int S_PERIODVOICE = 3;
    static final int S_WHITE512 = 4;
    static final int S_WHITE1024 = 5;
    static final int S_WHITE2048 = 6;
    static final int S_WHITEVOICE = 7;
    static final int S_SERDVNA = (-1);
    static final int S_SEROFM = (-2);
    static final int S_SERMACT = (-3);
    static final int S_SERQFUL = (-4);
    static final int S_SERBDNT = (-5);
    static final int S_SERDLN = (-6);
    static final int S_SERDCC = (-7);
    static final int S_SERDTP = (-8);
    static final int S_SERDVL = (-9);
    static final int S_SERDMD = (-10);
    static final int S_SERDSH = (-11);
    static final int S_SERDPT = (-12);
    static final int S_SERDFQ = (-13);
    static final int S_SERDDR = (-14);
    static final int S_SERDSR = (-15);
    static final int S_SERDST = (-16);
    static final int NMPWAIT_WAIT_FOREVER = 0xffffffff;
    static final int NMPWAIT_NOWAIT = 0x00000001;
    static final int NMPWAIT_USE_DEFAULT_WAIT = 0x00000000;
    static final int FS_CASE_IS_PRESERVED = FILE_CASE_PRESERVED_NAMES;
    static final int FS_CASE_SENSITIVE = FILE_CASE_SENSITIVE_SEARCH;
    static final int FS_UNICODE_STORED_ON_DISK = FILE_UNICODE_ON_DISK;
    static final int FS_PERSISTENT_ACLS = FILE_PERSISTENT_ACLS;
    static final int FS_VOL_IS_COMPRESSED = FILE_VOLUME_IS_COMPRESSED;
    static final int FS_FILE_COMPRESSION = FILE_FILE_COMPRESSION;
    static final int FS_FILE_ENCRYPTION = FILE_SUPPORTS_ENCRYPTION;
    static final int FILE_MAP_COPY = SECTION_QUERY;
    static final int FILE_MAP_WRITE = SECTION_MAP_WRITE;
    static final int FILE_MAP_READ = SECTION_MAP_READ;
    static final int FILE_MAP_ALL_ACCESS = SECTION_ALL_ACCESS;
    static final int OF_READ = 0x00000000;
    static final int OF_WRITE = 0x00000001;
    static final int OF_READWRITE = 0x00000002;
    static final int OF_SHARE_COMPAT = 0x00000000;
    static final int OF_SHARE_EXCLUSIVE = 0x00000010;
    static final int OF_SHARE_DENY_WRITE = 0x00000020;
    static final int OF_SHARE_DENY_READ = 0x00000030;
    static final int OF_SHARE_DENY_NONE = 0x00000040;
    static final int OF_PARSE = 0x00000100;
    static final int OF_DELETE = 0x00000200;
    static final int OF_VERIFY = 0x00000400;
    static final int OF_CANCEL = 0x00000800;
    static final int OF_CREATE = 0x00001000;
    static final int OF_PROMPT = 0x00002000;
    static final int OF_EXIST = 0x00004000;
    static final int OF_REOPEN = 0x00008000;
    static final int OFS_MAXPATHNAME = 128;
    static final int MAXINTATOM = 0xC000;
    static final int PROCESS_HEAP_REGION = 0x0001;
    static final int PROCESS_HEAP_UNCOMMITTED_RANGE = 0x0002;
    static final int PROCESS_HEAP_ENTRY_BUSY = 0x0004;
    static final int PROCESS_HEAP_ENTRY_MOVEABLE = 0x0010;
    static final int PROCESS_HEAP_ENTRY_DDESHARE = 0x0020;
    static final int SCS_32BIT_BINARY = 0;
    static final int SCS_DOS_BINARY = 1;
    static final int SCS_WOW_BINARY = 2;
    static final int SCS_PIF_BINARY = 3;
    static final int SCS_POSIX_BINARY = 4;
    static final int SCS_OS216_BINARY = 5;
    static final int SCS_64BIT_BINARY = 6;
    static final int SCS_THIS_PLATFORM_BINARY = SCS_32BIT_BINARY;
    static final int FIBER_FLAG_FLOAT_SWITCH = 0x1;
    static final int SEM_FAILCRITICALERRORS = 0x0001;
    static final int SEM_NOGPFAULTERRORBOX = 0x0002;
    static final int SEM_NOALIGNMENTFAULTEXCEPT = 0x0004;
    static final int SEM_NOOPENFILEERRORBOX = 0x8000;
    static final int LOCKFILE_FAIL_IMMEDIATELY = 0x00000001;
    static final int LOCKFILE_EXCLUSIVE_LOCK = 0x00000002;
    static final int HANDLE_FLAG_INHERIT = 0x00000001;
    static final int HANDLE_FLAG_PROTECT_FROM_CLOSE = 0x00000002;
    static final int HINSTANCE_ERROR = 32;
    static final int GET_TAPE_MEDIA_INFORMATION = 0;
    static final int GET_TAPE_DRIVE_INFORMATION = 1;
    static final int SET_TAPE_MEDIA_INFORMATION = 0;
    static final int SET_TAPE_DRIVE_INFORMATION = 1;
    static final int FORMAT_MESSAGE_ALLOCATE_BUFFER = 0x00000100;
    static final int FORMAT_MESSAGE_IGNORE_INSERTS = 0x00000200;
    static final int FORMAT_MESSAGE_FROM_STRING = 0x00000400;
    static final int FORMAT_MESSAGE_FROM_HMODULE = 0x00000800;
    static final int FORMAT_MESSAGE_FROM_SYSTEM = 0x00001000;
    static final int FORMAT_MESSAGE_ARGUMENT_ARRAY = 0x00002000;
    static final int FORMAT_MESSAGE_MAX_WIDTH_MASK = 0x000000FF;
    static final int FILE_ENCRYPTABLE = 0;
    static final int FILE_IS_ENCRYPTED = 1;
    static final int FILE_SYSTEM_ATTR = 2;
    static final int FILE_ROOT_DIR = 3;
    static final int FILE_SYSTEM_DIR = 4;
    static final int FILE_UNKNOWN = 5;
    static final int FILE_SYSTEM_NOT_SUPPORT = 6;
    static final int FILE_USER_DISALLOWED = 7;
    static final int FILE_READ_ONLY = 8;
    static final int FILE_DIR_DISALLOWED = 9;
    static final int EFS_USE_RECOVERY_KEYS = (0x1);
    static final int CREATE_FOR_IMPORT = (1);
    static final int CREATE_FOR_DIR = (2);
    static final int OVERWRITE_HIDDEN = (4);
    static final int BACKUP_INVALID = 0x00000000;
    static final int BACKUP_DATA = 0x00000001;
    static final int BACKUP_EA_DATA = 0x00000002;
    static final int BACKUP_SECURITY_DATA = 0x00000003;
    static final int BACKUP_ALTERNATE_DATA = 0x00000004;
    static final int BACKUP_LINK = 0x00000005;
    static final int BACKUP_PROPERTY_DATA = 0x00000006;
    static final int BACKUP_OBJECT_ID = 0x00000007;
    static final int BACKUP_REPARSE_DATA = 0x00000008;
    static final int BACKUP_SPARSE_BLOCK = 0x00000009;
    static final int STREAM_NORMAL_ATTRIBUTE = 0x00000000;
    static final int STREAM_MODIFIED_WHEN_READ = 0x00000001;
    static final int STREAM_CONTAINS_SECURITY = 0x00000002;
    static final int STREAM_CONTAINS_PROPERTIES = 0x00000004;
    static final int STREAM_SPARSE_ATTRIBUTE = 0x00000008;
    static final int STARTF_USESHOWWINDOW = 0x00000001;
    static final int STARTF_USESIZE = 0x00000002;
    static final int STARTF_USEPOSITION = 0x00000004;
    static final int STARTF_USECOUNTCHARS = 0x00000008;
    static final int STARTF_USEFILLATTRIBUTE = 0x00000010;
    static final int STARTF_RUNFULLSCREEN = 0x00000020;
    static final int STARTF_FORCEONFEEDBACK = 0x00000040;
    static final int STARTF_FORCEOFFFEEDBACK = 0x00000080;
    static final int STARTF_USESTDHANDLES = 0x00000100;
    static final int STARTF_USEHOTKEY = 0x00000200;
    static final int SHUTDOWN_NORETRY = 0x00000001;
    static final int DONT_RESOLVE_DLL_REFERENCES = 0x00000001;
    static final int LOAD_LIBRARY_AS_DATAFILE = 0x00000002;
    static final int LOAD_WITH_ALTERED_SEARCH_PATH = 0x00000008;
    static final int LOAD_IGNORE_CODE_AUTHZ_LEVEL = 0x00000010;
    static final int DDD_RAW_TARGET_PATH = 0x00000001;
    static final int DDD_REMOVE_DEFINITION = 0x00000002;
    static final int DDD_EXACT_MATCH_ON_REMOVE = 0x00000004;
    static final int DDD_NO_BROADCAST_SYSTEM = 0x00000008;
    static final int DDD_LUID_BROADCAST_DRIVE = 0x00000010;
    static final int FIND_FIRST_EX_CASE_SENSITIVE = 0x00000001;
    static final int MOVEFILE_REPLACE_EXISTING = 0x00000001;
    static final int MOVEFILE_COPY_ALLOWED = 0x00000002;
    static final int MOVEFILE_DELAY_UNTIL_REBOOT = 0x00000004;
    static final int MOVEFILE_WRITE_THROUGH = 0x00000008;
    static final int MOVEFILE_CREATE_HARDLINK = 0x00000010;
    static final int MOVEFILE_FAIL_IF_NOT_TRACKABLE = 0x00000020;
    static final int EVENTLOG_FULL_INFO = 0;
    static final int MAX_COMPUTERNAME_LENGTH = 15;
    static final int LOGON32_LOGON_INTERACTIVE = 2;
    static final int LOGON32_LOGON_NETWORK = 3;
    static final int LOGON32_LOGON_BATCH = 4;
    static final int LOGON32_LOGON_SERVICE = 5;
    static final int LOGON32_LOGON_UNLOCK = 7;
    static final int LOGON32_LOGON_NETWORK_CLEARTEXT = 8;
    static final int LOGON32_LOGON_NEW_CREDENTIALS = 9;
    static final int LOGON32_PROVIDER_DEFAULT = 0;
    static final int LOGON32_PROVIDER_WINNT35 = 1;
    static final int LOGON32_PROVIDER_WINNT40 = 2;
    static final int LOGON32_PROVIDER_WINNT50 = 3;
    static final int LOGON_WITH_PROFILE = 0x00000001;
    static final int LOGON_NETCREDENTIALS_ONLY = 0x00000002;
    static final int LOGON_ZERO_PASSWORD_BUFFER = 0x80000000;
    static final int HW_PROFILE_GUIDLEN = 39;
    static final int MAX_PROFILE_LEN = 80;
    static final int DOCKINFO_UNDOCKED = (0x1);
    static final int DOCKINFO_DOCKED = (0x2);
    static final int DOCKINFO_USER_SUPPLIED = (0x4);
    static final int DOCKINFO_USER_UNDOCKED = (DOCKINFO_USER_SUPPLIED | DOCKINFO_UNDOCKED);
    static final int DOCKINFO_USER_DOCKED = (DOCKINFO_USER_SUPPLIED | DOCKINFO_DOCKED);
    static final int FACILITY_WINDOWS_CE = 24;
    static final int FACILITY_WINDOWS = 8;
    static final int FACILITY_URT = 19;
    static final int FACILITY_UMI = 22;
    static final int FACILITY_SXS = 23;
    static final int FACILITY_STORAGE = 3;
    static final int FACILITY_STATE_MANAGEMENT = 34;
    static final int FACILITY_SSPI = 9;
    static final int FACILITY_SCARD = 16;
    static final int FACILITY_SETUPAPI = 15;
    static final int FACILITY_SECURITY = 9;
    static final int FACILITY_RPC = 1;
    static final int FACILITY_WIN32 = 7;
    static final int FACILITY_CONTROL = 10;
    static final int FACILITY_NULL = 0;
    static final int FACILITY_METADIRECTORY = 35;
    static final int FACILITY_MSMQ = 14;
    static final int FACILITY_MEDIASERVER = 13;
    static final int FACILITY_INTERNET = 12;
    static final int FACILITY_ITF = 4;
    static final int FACILITY_HTTP = 25;
    static final int FACILITY_DPLAY = 21;
    static final int FACILITY_DISPATCH = 2;
    static final int FACILITY_CONFIGURATION = 33;
    static final int FACILITY_COMPLUS = 17;
    static final int FACILITY_CERT = 11;
    static final int FACILITY_BACKGROUNDCOPY = 32;
    static final int FACILITY_ACS = 20;
    static final int FACILITY_AAF = 18;
    static final int ERROR_SUCCESS = 0;
    static final int NO_ERROR = 0;
    static final int SEC_E_OK = (0x00000000);
    static final int ERROR_INVALID_FUNCTION = 1;
    static final int ERROR_FILE_NOT_FOUND = 2;
    static final int ERROR_PATH_NOT_FOUND = 3;
    static final int ERROR_TOO_MANY_OPEN_FILES = 4;
    static final int ERROR_ACCESS_DENIED = 5;
    static final int ERROR_INVALID_HANDLE = 6;
    static final int ERROR_ARENA_TRASHED = 7;
    static final int ERROR_NOT_ENOUGH_MEMORY = 8;
    static final int ERROR_INVALID_BLOCK = 9;
    static final int ERROR_BAD_ENVIRONMENT = 10;
    static final int ERROR_BAD_FORMAT = 11;
    static final int ERROR_INVALID_ACCESS = 12;
    static final int ERROR_INVALID_DATA = 13;
    static final int ERROR_OUTOFMEMORY = 14;
    static final int ERROR_INVALID_DRIVE = 15;
    static final int ERROR_CURRENT_DIRECTORY = 16;
    static final int ERROR_NOT_SAME_DEVICE = 17;
    static final int ERROR_NO_MORE_FILES = 18;
    static final int ERROR_WRITE_PROTECT = 19;
    static final int ERROR_BAD_UNIT = 20;
    static final int ERROR_NOT_READY = 21;
    static final int ERROR_BAD_COMMAND = 22;
    static final int ERROR_CRC = 23;
    static final int ERROR_BAD_LENGTH = 24;
    static final int ERROR_SEEK = 25;
    static final int ERROR_NOT_DOS_DISK = 26;
    static final int ERROR_SECTOR_NOT_FOUND = 27;
    static final int ERROR_OUT_OF_PAPER = 28;
    static final int ERROR_WRITE_FAULT = 29;
    static final int ERROR_READ_FAULT = 30;
    static final int ERROR_GEN_FAILURE = 31;
    static final int ERROR_SHARING_VIOLATION = 32;
    static final int ERROR_LOCK_VIOLATION = 33;
    static final int ERROR_WRONG_DISK = 34;
    static final int ERROR_SHARING_BUFFER_EXCEEDED = 36;
    static final int ERROR_HANDLE_EOF = 38;
    static final int ERROR_HANDLE_DISK_FULL = 39;
    static final int ERROR_NOT_SUPPORTED = 50;
    static final int ERROR_REM_NOT_LIST = 51;
    static final int ERROR_DUP_NAME = 52;
    static final int ERROR_BAD_NETPATH = 53;
    static final int ERROR_NETWORK_BUSY = 54;
    static final int ERROR_DEV_NOT_EXIST = 55;
    static final int ERROR_TOO_MANY_CMDS = 56;
    static final int ERROR_ADAP_HDW_ERR = 57;
    static final int ERROR_BAD_NET_RESP = 58;
    static final int ERROR_UNEXP_NET_ERR = 59;
    static final int ERROR_BAD_REM_ADAP = 60;
    static final int ERROR_PRINTQ_FULL = 61;
    static final int ERROR_NO_SPOOL_SPACE = 62;
    static final int ERROR_PRINT_CANCELLED = 63;
    static final int ERROR_NETNAME_DELETED = 64;
    static final int ERROR_NETWORK_ACCESS_DENIED = 65;
    static final int ERROR_BAD_DEV_TYPE = 66;
    static final int ERROR_BAD_NET_NAME = 67;
    static final int ERROR_TOO_MANY_NAMES = 68;
    static final int ERROR_TOO_MANY_SESS = 69;
    static final int ERROR_SHARING_PAUSED = 70;
    static final int ERROR_REQ_NOT_ACCEP = 71;
    static final int ERROR_REDIR_PAUSED = 72;
    static final int ERROR_FILE_EXISTS = 80;
    static final int ERROR_CANNOT_MAKE = 82;
    static final int ERROR_FAIL_I24 = 83;
    static final int ERROR_OUT_OF_STRUCTURES = 84;
    static final int ERROR_ALREADY_ASSIGNED = 85;
    static final int ERROR_INVALID_PASSWORD = 86;
    static final int ERROR_INVALID_PARAMETER = 87;
    static final int ERROR_NET_WRITE_FAULT = 88;
    static final int ERROR_NO_PROC_SLOTS = 89;
    static final int ERROR_TOO_MANY_SEMAPHORES = 100;
    static final int ERROR_EXCL_SEM_ALREADY_OWNED = 101;
    static final int ERROR_SEM_IS_SET = 102;
    static final int ERROR_TOO_MANY_SEM_REQUESTS = 103;
    static final int ERROR_INVALID_AT_INTERRUPT_TIME = 104;
    static final int ERROR_SEM_OWNER_DIED = 105;
    static final int ERROR_SEM_USER_LIMIT = 106;
    static final int ERROR_DISK_CHANGE = 107;
    static final int ERROR_DRIVE_LOCKED = 108;
    static final int ERROR_BROKEN_PIPE = 109;
    static final int ERROR_OPEN_FAILED = 110;
    static final int ERROR_BUFFER_OVERFLOW = 111;
    static final int ERROR_DISK_FULL = 112;
    static final int ERROR_NO_MORE_SEARCH_HANDLES = 113;
    static final int ERROR_INVALID_TARGET_HANDLE = 114;
    static final int ERROR_INVALID_CATEGORY = 117;
    static final int ERROR_INVALID_VERIFY_SWITCH = 118;
    static final int ERROR_BAD_DRIVER_LEVEL = 119;
    static final int ERROR_CALL_NOT_IMPLEMENTED = 120;
    static final int ERROR_SEM_TIMEOUT = 121;
    static final int ERROR_INSUFFICIENT_BUFFER = 122;
    static final int ERROR_INVALID_NAME = 123;
    static final int ERROR_INVALID_LEVEL = 124;
    static final int ERROR_NO_VOLUME_LABEL = 125;
    static final int ERROR_MOD_NOT_FOUND = 126;
    static final int ERROR_PROC_NOT_FOUND = 127;
    static final int ERROR_WAIT_NO_CHILDREN = 128;
    static final int ERROR_CHILD_NOT_COMPLETE = 129;
    static final int ERROR_DIRECT_ACCESS_HANDLE = 130;
    static final int ERROR_NEGATIVE_SEEK = 131;
    static final int ERROR_SEEK_ON_DEVICE = 132;
    static final int ERROR_IS_JOIN_TARGET = 133;
    static final int ERROR_IS_JOINED = 134;
    static final int ERROR_IS_SUBSTED = 135;
    static final int ERROR_NOT_JOINED = 136;
    static final int ERROR_NOT_SUBSTED = 137;
    static final int ERROR_JOIN_TO_JOIN = 138;
    static final int ERROR_SUBST_TO_SUBST = 139;
    static final int ERROR_JOIN_TO_SUBST = 140;
    static final int ERROR_SUBST_TO_JOIN = 141;
    static final int ERROR_BUSY_DRIVE = 142;
    static final int ERROR_SAME_DRIVE = 143;
    static final int ERROR_DIR_NOT_ROOT = 144;
    static final int ERROR_DIR_NOT_EMPTY = 145;
    static final int ERROR_IS_SUBST_PATH = 146;
    static final int ERROR_IS_JOIN_PATH = 147;
    static final int ERROR_PATH_BUSY = 148;
    static final int ERROR_IS_SUBST_TARGET = 149;
    static final int ERROR_SYSTEM_TRACE = 150;
    static final int ERROR_INVALID_EVENT_COUNT = 151;
    static final int ERROR_TOO_MANY_MUXWAITERS = 152;
    static final int ERROR_INVALID_LIST_FORMAT = 153;
    static final int ERROR_LABEL_TOO_LONG = 154;
    static final int ERROR_TOO_MANY_TCBS = 155;
    static final int ERROR_SIGNAL_REFUSED = 156;
    static final int ERROR_DISCARDED = 157;
    static final int ERROR_NOT_LOCKED = 158;
    static final int ERROR_BAD_THREADID_ADDR = 159;
    static final int ERROR_BAD_ARGUMENTS = 160;
    static final int ERROR_BAD_PATHNAME = 161;
    static final int ERROR_SIGNAL_PENDING = 162;
    static final int ERROR_MAX_THRDS_REACHED = 164;
    static final int ERROR_LOCK_FAILED = 167;
    static final int ERROR_BUSY = 170;
    static final int ERROR_CANCEL_VIOLATION = 173;
    static final int ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = 174;
    static final int ERROR_INVALID_SEGMENT_NUMBER = 180;
    static final int ERROR_INVALID_ORDINAL = 182;
    static final int ERROR_ALREADY_EXISTS = 183;
    static final int ERROR_INVALID_FLAG_NUMBER = 186;
    static final int ERROR_SEM_NOT_FOUND = 187;
    static final int ERROR_INVALID_STARTING_CODESEG = 188;
    static final int ERROR_INVALID_STACKSEG = 189;
    static final int ERROR_INVALID_MODULETYPE = 190;
    static final int ERROR_INVALID_EXE_SIGNATURE = 191;
    static final int ERROR_EXE_MARKED_INVALID = 192;
    static final int ERROR_BAD_EXE_FORMAT = 193;
    static final int ERROR_ITERATED_DATA_EXCEEDS_64k = 194;
    static final int ERROR_INVALID_MINALLOCSIZE = 195;
    static final int ERROR_DYNLINK_FROM_INVALID_RING = 196;
    static final int ERROR_IOPL_NOT_ENABLED = 197;
    static final int ERROR_INVALID_SEGDPL = 198;
    static final int ERROR_AUTODATASEG_EXCEEDS_64k = 199;
    static final int ERROR_RING2SEG_MUST_BE_MOVABLE = 200;
    static final int ERROR_RELOC_CHAIN_XEEDS_SEGLIM = 201;
    static final int ERROR_INFLOOP_IN_RELOC_CHAIN = 202;
    static final int ERROR_ENVVAR_NOT_FOUND = 203;
    static final int ERROR_NO_SIGNAL_SENT = 205;
    static final int ERROR_FILENAME_EXCED_RANGE = 206;
    static final int ERROR_RING2_STACK_IN_USE = 207;
    static final int ERROR_META_EXPANSION_TOO_LONG = 208;
    static final int ERROR_INVALID_SIGNAL_NUMBER = 209;
    static final int ERROR_THREAD_1_INACTIVE = 210;
    static final int ERROR_LOCKED = 212;
    static final int ERROR_TOO_MANY_MODULES = 214;
    static final int ERROR_NESTING_NOT_ALLOWED = 215;
    static final int ERROR_EXE_MACHINE_TYPE_MISMATCH = 216;
    static final int ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY = 217;
    static final int ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY = 218;
    static final int ERROR_BAD_PIPE = 230;
    static final int ERROR_PIPE_BUSY = 231;
    static final int ERROR_NO_DATA = 232;
    static final int ERROR_PIPE_NOT_CONNECTED = 233;
    static final int ERROR_MORE_DATA = 234;
    static final int ERROR_VC_DISCONNECTED = 240;
    static final int ERROR_INVALID_EA_NAME = 254;
    static final int ERROR_EA_LIST_INCONSISTENT = 255;
    static final int WAIT_TIMEOUT = 258;
    static final int ERROR_NO_MORE_ITEMS = 259;
    static final int ERROR_CANNOT_COPY = 266;
    static final int ERROR_DIRECTORY = 267;
    static final int ERROR_EAS_DIDNT_FIT = 275;
    static final int ERROR_EA_FILE_CORRUPT = 276;
    static final int ERROR_EA_TABLE_FULL = 277;
    static final int ERROR_INVALID_EA_HANDLE = 278;
    static final int ERROR_EAS_NOT_SUPPORTED = 282;
    static final int ERROR_NOT_OWNER = 288;
    static final int ERROR_TOO_MANY_POSTS = 298;
    static final int ERROR_PARTIAL_COPY = 299;
    static final int ERROR_OPLOCK_NOT_GRANTED = 300;
    static final int ERROR_INVALID_OPLOCK_PROTOCOL = 301;
    static final int ERROR_DISK_TOO_FRAGMENTED = 302;
    static final int ERROR_DELETE_PENDING = 303;
    static final int ERROR_MR_MID_NOT_FOUND = 317;
    static final int ERROR_SCOPE_NOT_FOUND = 318;
    static final int ERROR_INVALID_ADDRESS = 487;
    static final int ERROR_ARITHMETIC_OVERFLOW = 534;
    static final int ERROR_PIPE_CONNECTED = 535;
    static final int ERROR_PIPE_LISTENING = 536;
    static final int ERROR_EA_ACCESS_DENIED = 994;
    static final int ERROR_OPERATION_ABORTED = 995;
    static final int ERROR_IO_INCOMPLETE = 996;
    static final int ERROR_IO_PENDING = 997;
    static final int ERROR_NOACCESS = 998;
    static final int ERROR_SWAPERROR = 999;
    static final int ERROR_STACK_OVERFLOW = 1001;
    static final int ERROR_INVALID_MESSAGE = 1002;
    static final int ERROR_CAN_NOT_COMPLETE = 1003;
    static final int ERROR_INVALID_FLAGS = 1004;
    static final int ERROR_UNRECOGNIZED_VOLUME = 1005;
    static final int ERROR_FILE_INVALID = 1006;
    static final int ERROR_FULLSCREEN_MODE = 1007;
    static final int ERROR_NO_TOKEN = 1008;
    static final int ERROR_BADDB = 1009;
    static final int ERROR_BADKEY = 1010;
    static final int ERROR_CANTOPEN = 1011;
    static final int ERROR_CANTREAD = 1012;
    static final int ERROR_CANTWRITE = 1013;
    static final int ERROR_REGISTRY_RECOVERED = 1014;
    static final int ERROR_REGISTRY_CORRUPT = 1015;
    static final int ERROR_REGISTRY_IO_FAILED = 1016;
    static final int ERROR_NOT_REGISTRY_FILE = 1017;
    static final int ERROR_KEY_DELETED = 1018;
    static final int ERROR_NO_LOG_SPACE = 1019;
    static final int ERROR_KEY_HAS_CHILDREN = 1020;
    static final int ERROR_CHILD_MUST_BE_VOLATILE = 1021;
    static final int ERROR_NOTIFY_ENUM_DIR = 1022;
    static final int ERROR_DEPENDENT_SERVICES_RUNNING = 1051;
    static final int ERROR_INVALID_SERVICE_CONTROL = 1052;
    static final int ERROR_SERVICE_REQUEST_TIMEOUT = 1053;
    static final int ERROR_SERVICE_NO_THREAD = 1054;
    static final int ERROR_SERVICE_DATABASE_LOCKED = 1055;
    static final int ERROR_SERVICE_ALREADY_RUNNING = 1056;
    static final int ERROR_INVALID_SERVICE_ACCOUNT = 1057;
    static final int ERROR_SERVICE_DISABLED = 1058;
    static final int ERROR_CIRCULAR_DEPENDENCY = 1059;
    static final int ERROR_SERVICE_DOES_NOT_EXIST = 1060;
    static final int ERROR_SERVICE_CANNOT_ACCEPT_CTRL = 1061;
    static final int ERROR_SERVICE_NOT_ACTIVE = 1062;
    static final int ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = 1063;
    static final int ERROR_EXCEPTION_IN_SERVICE = 1064;
    static final int ERROR_DATABASE_DOES_NOT_EXIST = 1065;
    static final int ERROR_SERVICE_SPECIFIC_ERROR = 1066;
    static final int ERROR_PROCESS_ABORTED = 1067;
    static final int ERROR_SERVICE_DEPENDENCY_FAIL = 1068;
    static final int ERROR_SERVICE_LOGON_FAILED = 1069;
    static final int ERROR_SERVICE_START_HANG = 1070;
    static final int ERROR_INVALID_SERVICE_LOCK = 1071;
    static final int ERROR_SERVICE_MARKED_FOR_DELETE = 1072;
    static final int ERROR_SERVICE_EXISTS = 1073;
    static final int ERROR_ALREADY_RUNNING_LKG = 1074;
    static final int ERROR_SERVICE_DEPENDENCY_DELETED = 1075;
    static final int ERROR_BOOT_ALREADY_ACCEPTED = 1076;
    static final int ERROR_SERVICE_NEVER_STARTED = 1077;
    static final int ERROR_DUPLICATE_SERVICE_NAME = 1078;
    static final int ERROR_DIFFERENT_SERVICE_ACCOUNT = 1079;
    static final int ERROR_CANNOT_DETECT_DRIVER_FAILURE = 1080;
    static final int ERROR_CANNOT_DETECT_PROCESS_ABORT = 1081;
    static final int ERROR_NO_RECOVERY_PROGRAM = 1082;
    static final int ERROR_SERVICE_NOT_IN_EXE = 1083;
    static final int ERROR_NOT_SAFEBOOT_SERVICE = 1084;
    static final int ERROR_END_OF_MEDIA = 1100;
    static final int ERROR_FILEMARK_DETECTED = 1101;
    static final int ERROR_BEGINNING_OF_MEDIA = 1102;
    static final int ERROR_SETMARK_DETECTED = 1103;
    static final int ERROR_NO_DATA_DETECTED = 1104;
    static final int ERROR_PARTITION_FAILURE = 1105;
    static final int ERROR_INVALID_BLOCK_LENGTH = 1106;
    static final int ERROR_DEVICE_NOT_PARTITIONED = 1107;
    static final int ERROR_UNABLE_TO_LOCK_MEDIA = 1108;
    static final int ERROR_UNABLE_TO_UNLOAD_MEDIA = 1109;
    static final int ERROR_MEDIA_CHANGED = 1110;
    static final int ERROR_BUS_RESET = 1111;
    static final int ERROR_NO_MEDIA_IN_DRIVE = 1112;
    static final int ERROR_NO_UNICODE_TRANSLATION = 1113;
    static final int ERROR_DLL_INIT_FAILED = 1114;
    static final int ERROR_SHUTDOWN_IN_PROGRESS = 1115;
    static final int ERROR_NO_SHUTDOWN_IN_PROGRESS = 1116;
    static final int ERROR_IO_DEVICE = 1117;
    static final int ERROR_SERIAL_NO_DEVICE = 1118;
    static final int ERROR_IRQ_BUSY = 1119;
    static final int ERROR_MORE_WRITES = 1120;
    static final int ERROR_COUNTER_TIMEOUT = 1121;
    static final int ERROR_FLOPPY_ID_MARK_NOT_FOUND = 1122;
    static final int ERROR_FLOPPY_WRONG_CYLINDER = 1123;
    static final int ERROR_FLOPPY_UNKNOWN_ERROR = 1124;
    static final int ERROR_FLOPPY_BAD_REGISTERS = 1125;
    static final int ERROR_DISK_RECALIBRATE_FAILED = 1126;
    static final int ERROR_DISK_OPERATION_FAILED = 1127;
    static final int ERROR_DISK_RESET_FAILED = 1128;
    static final int ERROR_EOM_OVERFLOW = 1129;
    static final int ERROR_NOT_ENOUGH_SERVER_MEMORY = 1130;
    static final int ERROR_POSSIBLE_DEADLOCK = 1131;
    static final int ERROR_MAPPED_ALIGNMENT = 1132;
    static final int ERROR_SET_POWER_STATE_VETOED = 1140;
    static final int ERROR_SET_POWER_STATE_FAILED = 1141;
    static final int ERROR_TOO_MANY_LINKS = 1142;
    static final int ERROR_OLD_WIN_VERSION = 1150;
    static final int ERROR_APP_WRONG_OS = 1151;
    static final int ERROR_SINGLE_INSTANCE_APP = 1152;
    static final int ERROR_RMODE_APP = 1153;
    static final int ERROR_INVALID_DLL = 1154;
    static final int ERROR_NO_ASSOCIATION = 1155;
    static final int ERROR_DDE_FAIL = 1156;
    static final int ERROR_DLL_NOT_FOUND = 1157;
    static final int ERROR_NO_MORE_USER_HANDLES = 1158;
    static final int ERROR_MESSAGE_SYNC_ONLY = 1159;
    static final int ERROR_SOURCE_ELEMENT_EMPTY = 1160;
    static final int ERROR_DESTINATION_ELEMENT_FULL = 1161;
    static final int ERROR_ILLEGAL_ELEMENT_ADDRESS = 1162;
    static final int ERROR_MAGAZINE_NOT_PRESENT = 1163;
    static final int ERROR_DEVICE_REINITIALIZATION_NEEDED = 1164;
    static final int ERROR_DEVICE_REQUIRES_CLEANING = 1165;
    static final int ERROR_DEVICE_DOOR_OPEN = 1166;
    static final int ERROR_DEVICE_NOT_CONNECTED = 1167;
    static final int ERROR_NOT_FOUND = 1168;
    static final int ERROR_NO_MATCH = 1169;
    static final int ERROR_SET_NOT_FOUND = 1170;
    static final int ERROR_POINT_NOT_FOUND = 1171;
    static final int ERROR_NO_TRACKING_SERVICE = 1172;
    static final int ERROR_NO_VOLUME_ID = 1173;
    static final int ERROR_UNABLE_TO_REMOVE_REPLACED = 1175;
    static final int ERROR_UNABLE_TO_MOVE_REPLACEMENT = 1176;
    static final int ERROR_UNABLE_TO_MOVE_REPLACEMENT_2 = 1177;
    static final int ERROR_JOURNAL_DELETE_IN_PROGRESS = 1178;
    static final int ERROR_JOURNAL_NOT_ACTIVE = 1179;
    static final int ERROR_POTENTIAL_FILE_FOUND = 1180;
    static final int ERROR_JOURNAL_ENTRY_DELETED = 1181;
    static final int ERROR_BAD_DEVICE = 1200;
    static final int ERROR_CONNECTION_UNAVAIL = 1201;
    static final int ERROR_DEVICE_ALREADY_REMEMBERED = 1202;
    static final int ERROR_NO_NET_OR_BAD_PATH = 1203;
    static final int ERROR_BAD_PROVIDER = 1204;
    static final int ERROR_CANNOT_OPEN_PROFILE = 1205;
    static final int ERROR_BAD_PROFILE = 1206;
    static final int ERROR_NOT_CONTAINER = 1207;
    static final int ERROR_EXTENDED_ERROR = 1208;
    static final int ERROR_INVALID_GROUPNAME = 1209;
    static final int ERROR_INVALID_COMPUTERNAME = 1210;
    static final int ERROR_INVALID_EVENTNAME = 1211;
    static final int ERROR_INVALID_DOMAINNAME = 1212;
    static final int ERROR_INVALID_SERVICENAME = 1213;
    static final int ERROR_INVALID_NETNAME = 1214;
    static final int ERROR_INVALID_SHARENAME = 1215;
    static final int ERROR_INVALID_PASSWORDNAME = 1216;
    static final int ERROR_INVALID_MESSAGENAME = 1217;
    static final int ERROR_INVALID_MESSAGEDEST = 1218;
    static final int ERROR_SESSION_CREDENTIAL_CONFLICT = 1219;
    static final int ERROR_REMOTE_SESSION_LIMIT_EXCEEDED = 1220;
    static final int ERROR_DUP_DOMAINNAME = 1221;
    static final int ERROR_NO_NETWORK = 1222;
    static final int ERROR_CANCELLED = 1223;
    static final int ERROR_USER_MAPPED_FILE = 1224;
    static final int ERROR_CONNECTION_REFUSED = 1225;
    static final int ERROR_GRACEFUL_DISCONNECT = 1226;
    static final int ERROR_ADDRESS_ALREADY_ASSOCIATED = 1227;
    static final int ERROR_ADDRESS_NOT_ASSOCIATED = 1228;
    static final int ERROR_CONNECTION_INVALID = 1229;
    static final int ERROR_CONNECTION_ACTIVE = 1230;
    static final int ERROR_NETWORK_UNREACHABLE = 1231;
    static final int ERROR_HOST_UNREACHABLE = 1232;
    static final int ERROR_PROTOCOL_UNREACHABLE = 1233;
    static final int ERROR_PORT_UNREACHABLE = 1234;
    static final int ERROR_REQUEST_ABORTED = 1235;
    static final int ERROR_CONNECTION_ABORTED = 1236;
    static final int ERROR_RETRY = 1237;
    static final int ERROR_CONNECTION_COUNT_LIMIT = 1238;
    static final int ERROR_LOGIN_TIME_RESTRICTION = 1239;
    static final int ERROR_LOGIN_WKSTA_RESTRICTION = 1240;
    static final int ERROR_INCORRECT_ADDRESS = 1241;
    static final int ERROR_ALREADY_REGISTERED = 1242;
    static final int ERROR_SERVICE_NOT_FOUND = 1243;
    static final int ERROR_NOT_AUTHENTICATED = 1244;
    static final int ERROR_NOT_LOGGED_ON = 1245;
    static final int ERROR_CONTINUE = 1246;
    static final int ERROR_ALREADY_INITIALIZED = 1247;
    static final int ERROR_NO_MORE_DEVICES = 1248;
    static final int ERROR_NO_SUCH_SITE = 1249;
    static final int ERROR_DOMAIN_CONTROLLER_EXISTS = 1250;
    static final int ERROR_ONLY_IF_CONNECTED = 1251;
    static final int ERROR_OVERRIDE_NOCHANGES = 1252;
    static final int ERROR_BAD_USER_PROFILE = 1253;
    static final int ERROR_NOT_SUPPORTED_ON_SBS = 1254;
    static final int ERROR_SERVER_SHUTDOWN_IN_PROGRESS = 1255;
    static final int ERROR_HOST_DOWN = 1256;
    static final int ERROR_NON_ACCOUNT_SID = 1257;
    static final int ERROR_NON_DOMAIN_SID = 1258;
    static final int ERROR_APPHELP_BLOCK = 1259;
    static final int ERROR_ACCESS_DISABLED_BY_POLICY = 1260;
    static final int ERROR_REG_NAT_CONSUMPTION = 1261;
    static final int ERROR_CSCSHARE_OFFLINE = 1262;
    static final int ERROR_PKINIT_FAILURE = 1263;
    static final int ERROR_SMARTCARD_SUBSYSTEM_FAILURE = 1264;
    static final int ERROR_DOWNGRADE_DETECTED = 1265;
    static final int ERROR_MACHINE_LOCKED = 1271;
    static final int ERROR_CALLBACK_SUPPLIED_INVALID_DATA = 1273;
    static final int ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED = 1274;
    static final int ERROR_DRIVER_BLOCKED = 1275;
    static final int ERROR_INVALID_IMPORT_OF_NON_DLL = 1276;
    static final int ERROR_ACCESS_DISABLED_WEBBLADE = 1277;
    static final int ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER = 1278;
    static final int ERROR_RECOVERY_FAILURE = 1279;
    static final int ERROR_ALREADY_FIBER = 1280;
    static final int ERROR_ALREADY_THREAD = 1281;
    static final int ERROR_STACK_BUFFER_OVERRUN = 1282;
    static final int ERROR_PARAMETER_QUOTA_EXCEEDED = 1283;
    static final int ERROR_DEBUGGER_INACTIVE = 1284;
    static final int ERROR_DELAY_LOAD_FAILED = 1285;
    static final int ERROR_VDM_DISALLOWED = 1286;
    static final int ERROR_NOT_ALL_ASSIGNED = 1300;
    static final int ERROR_SOME_NOT_MAPPED = 1301;
    static final int ERROR_NO_QUOTAS_FOR_ACCOUNT = 1302;
    static final int ERROR_LOCAL_USER_SESSION_KEY = 1303;
    static final int ERROR_NULL_LM_PASSWORD = 1304;
    static final int ERROR_UNKNOWN_REVISION = 1305;
    static final int ERROR_REVISION_MISMATCH = 1306;
    static final int ERROR_INVALID_OWNER = 1307;
    static final int ERROR_INVALID_PRIMARY_GROUP = 1308;
    static final int ERROR_NO_IMPERSONATION_TOKEN = 1309;
    static final int ERROR_CANT_DISABLE_MANDATORY = 1310;
    static final int ERROR_NO_LOGON_SERVERS = 1311;
    static final int ERROR_NO_SUCH_LOGON_SESSION = 1312;
    static final int ERROR_NO_SUCH_PRIVILEGE = 1313;
    static final int ERROR_PRIVILEGE_NOT_HELD = 1314;
    static final int ERROR_INVALID_ACCOUNT_NAME = 1315;
    static final int ERROR_USER_EXISTS = 1316;
    static final int ERROR_NO_SUCH_USER = 1317;
    static final int ERROR_GROUP_EXISTS = 1318;
    static final int ERROR_NO_SUCH_GROUP = 1319;
    static final int ERROR_MEMBER_IN_GROUP = 1320;
    static final int ERROR_MEMBER_NOT_IN_GROUP = 1321;
    static final int ERROR_LAST_ADMIN = 1322;
    static final int ERROR_WRONG_PASSWORD = 1323;
    static final int ERROR_ILL_FORMED_PASSWORD = 1324;
    static final int ERROR_PASSWORD_RESTRICTION = 1325;
    static final int ERROR_LOGON_FAILURE = 1326;
    static final int ERROR_ACCOUNT_RESTRICTION = 1327;
    static final int ERROR_INVALID_LOGON_HOURS = 1328;
    static final int ERROR_INVALID_WORKSTATION = 1329;
    static final int ERROR_PASSWORD_EXPIRED = 1330;
    static final int ERROR_ACCOUNT_DISABLED = 1331;
    static final int ERROR_NONE_MAPPED = 1332;
    static final int ERROR_TOO_MANY_LUIDS_REQUESTED = 1333;
    static final int ERROR_LUIDS_EXHAUSTED = 1334;
    static final int ERROR_INVALID_SUB_AUTHORITY = 1335;
    static final int ERROR_INVALID_ACL = 1336;
    static final int ERROR_INVALID_SID = 1337;
    static final int ERROR_INVALID_SECURITY_DESCR = 1338;
    static final int ERROR_BAD_INHERITANCE_ACL = 1340;
    static final int ERROR_SERVER_DISABLED = 1341;
    static final int ERROR_SERVER_NOT_DISABLED = 1342;
    static final int ERROR_INVALID_ID_AUTHORITY = 1343;
    static final int ERROR_ALLOTTED_SPACE_EXCEEDED = 1344;
    static final int ERROR_INVALID_GROUP_ATTRIBUTES = 1345;
    static final int ERROR_BAD_IMPERSONATION_LEVEL = 1346;
    static final int ERROR_CANT_OPEN_ANONYMOUS = 1347;
    static final int ERROR_BAD_VALIDATION_CLASS = 1348;
    static final int ERROR_BAD_TOKEN_TYPE = 1349;
    static final int ERROR_NO_SECURITY_ON_OBJECT = 1350;
    static final int ERROR_CANT_ACCESS_DOMAIN_INFO = 1351;
    static final int ERROR_INVALID_SERVER_STATE = 1352;
    static final int ERROR_INVALID_DOMAIN_STATE = 1353;
    static final int ERROR_INVALID_DOMAIN_ROLE = 1354;
    static final int ERROR_NO_SUCH_DOMAIN = 1355;
    static final int ERROR_DOMAIN_EXISTS = 1356;
    static final int ERROR_DOMAIN_LIMIT_EXCEEDED = 1357;
    static final int ERROR_INTERNAL_DB_CORRUPTION = 1358;
    static final int ERROR_INTERNAL_ERROR = 1359;
    static final int ERROR_GENERIC_NOT_MAPPED = 1360;
    static final int ERROR_BAD_DESCRIPTOR_FORMAT = 1361;
    static final int ERROR_NOT_LOGON_PROCESS = 1362;
    static final int ERROR_LOGON_SESSION_EXISTS = 1363;
    static final int ERROR_NO_SUCH_PACKAGE = 1364;
    static final int ERROR_BAD_LOGON_SESSION_STATE = 1365;
    static final int ERROR_LOGON_SESSION_COLLISION = 1366;
    static final int ERROR_INVALID_LOGON_TYPE = 1367;
    static final int ERROR_CANNOT_IMPERSONATE = 1368;
    static final int ERROR_RXACT_INVALID_STATE = 1369;
    static final int ERROR_RXACT_COMMIT_FAILURE = 1370;
    static final int ERROR_SPECIAL_ACCOUNT = 1371;
    static final int ERROR_SPECIAL_GROUP = 1372;
    static final int ERROR_SPECIAL_USER = 1373;
    static final int ERROR_MEMBERS_PRIMARY_GROUP = 1374;
    static final int ERROR_TOKEN_ALREADY_IN_USE = 1375;
    static final int ERROR_NO_SUCH_ALIAS = 1376;
    static final int ERROR_MEMBER_NOT_IN_ALIAS = 1377;
    static final int ERROR_MEMBER_IN_ALIAS = 1378;
    static final int ERROR_ALIAS_EXISTS = 1379;
    static final int ERROR_LOGON_NOT_GRANTED = 1380;
    static final int ERROR_TOO_MANY_SECRETS = 1381;
    static final int ERROR_SECRET_TOO_LONG = 1382;
    static final int ERROR_INTERNAL_DB_ERROR = 1383;
    static final int ERROR_TOO_MANY_CONTEXT_IDS = 1384;
    static final int ERROR_LOGON_TYPE_NOT_GRANTED = 1385;
    static final int ERROR_NT_CROSS_ENCRYPTION_REQUIRED = 1386;
    static final int ERROR_NO_SUCH_MEMBER = 1387;
    static final int ERROR_INVALID_MEMBER = 1388;
    static final int ERROR_TOO_MANY_SIDS = 1389;
    static final int ERROR_LM_CROSS_ENCRYPTION_REQUIRED = 1390;
    static final int ERROR_NO_INHERITANCE = 1391;
    static final int ERROR_FILE_CORRUPT = 1392;
    static final int ERROR_DISK_CORRUPT = 1393;
    static final int ERROR_NO_USER_SESSION_KEY = 1394;
    static final int ERROR_LICENSE_QUOTA_EXCEEDED = 1395;
    static final int ERROR_WRONG_TARGET_NAME = 1396;
    static final int ERROR_MUTUAL_AUTH_FAILED = 1397;
    static final int ERROR_TIME_SKEW = 1398;
    static final int ERROR_CURRENT_DOMAIN_NOT_ALLOWED = 1399;
    static final int ERROR_INVALID_WINDOW_HANDLE = 1400;
    static final int ERROR_INVALID_MENU_HANDLE = 1401;
    static final int ERROR_INVALID_CURSOR_HANDLE = 1402;
    static final int ERROR_INVALID_ACCEL_HANDLE = 1403;
    static final int ERROR_INVALID_HOOK_HANDLE = 1404;
    static final int ERROR_INVALID_DWP_HANDLE = 1405;
    static final int ERROR_TLW_WITH_WSCHILD = 1406;
    static final int ERROR_CANNOT_FIND_WND_CLASS = 1407;
    static final int ERROR_WINDOW_OF_OTHER_THREAD = 1408;
    static final int ERROR_HOTKEY_ALREADY_REGISTERED = 1409;
    static final int ERROR_CLASS_ALREADY_EXISTS = 1410;
    static final int ERROR_CLASS_DOES_NOT_EXIST = 1411;
    static final int ERROR_CLASS_HAS_WINDOWS = 1412;
    static final int ERROR_INVALID_INDEX = 1413;
    static final int ERROR_INVALID_ICON_HANDLE = 1414;
    static final int ERROR_PRIVATE_DIALOG_INDEX = 1415;
    static final int ERROR_LISTBOX_ID_NOT_FOUND = 1416;
    static final int ERROR_NO_WILDCARD_CHARACTERS = 1417;
    static final int ERROR_CLIPBOARD_NOT_OPEN = 1418;
    static final int ERROR_HOTKEY_NOT_REGISTERED = 1419;
    static final int ERROR_WINDOW_NOT_DIALOG = 1420;
    static final int ERROR_CONTROL_ID_NOT_FOUND = 1421;
    static final int ERROR_INVALID_COMBOBOX_MESSAGE = 1422;
    static final int ERROR_WINDOW_NOT_COMBOBOX = 1423;
    static final int ERROR_INVALID_EDIT_HEIGHT = 1424;
    static final int ERROR_DC_NOT_FOUND = 1425;
    static final int ERROR_INVALID_HOOK_FILTER = 1426;
    static final int ERROR_INVALID_FILTER_PROC = 1427;
    static final int ERROR_HOOK_NEEDS_HMOD = 1428;
    static final int ERROR_GLOBAL_ONLY_HOOK = 1429;
    static final int ERROR_JOURNAL_HOOK_SET = 1430;
    static final int ERROR_HOOK_NOT_INSTALLED = 1431;
    static final int ERROR_INVALID_LB_MESSAGE = 1432;
    static final int ERROR_SETCOUNT_ON_BAD_LB = 1433;
    static final int ERROR_LB_WITHOUT_TABSTOPS = 1434;
    static final int ERROR_DESTROY_OBJECT_OF_OTHER_THREAD = 1435;
    static final int ERROR_CHILD_WINDOW_MENU = 1436;
    static final int ERROR_NO_SYSTEM_MENU = 1437;
    static final int ERROR_INVALID_MSGBOX_STYLE = 1438;
    static final int ERROR_INVALID_SPI_VALUE = 1439;
    static final int ERROR_SCREEN_ALREADY_LOCKED = 1440;
    static final int ERROR_HWNDS_HAVE_DIFF_PARENT = 1441;
    static final int ERROR_NOT_CHILD_WINDOW = 1442;
    static final int ERROR_INVALID_GW_COMMAND = 1443;
    static final int ERROR_INVALID_THREAD_ID = 1444;
    static final int ERROR_NON_MDICHILD_WINDOW = 1445;
    static final int ERROR_POPUP_ALREADY_ACTIVE = 1446;
    static final int ERROR_NO_SCROLLBARS = 1447;
    static final int ERROR_INVALID_SCROLLBAR_RANGE = 1448;
    static final int ERROR_INVALID_SHOWWIN_COMMAND = 1449;
    static final int ERROR_NO_SYSTEM_RESOURCES = 1450;
    static final int ERROR_NONPAGED_SYSTEM_RESOURCES = 1451;
    static final int ERROR_PAGED_SYSTEM_RESOURCES = 1452;
    static final int ERROR_WORKING_SET_QUOTA = 1453;
    static final int ERROR_PAGEFILE_QUOTA = 1454;
    static final int ERROR_COMMITMENT_LIMIT = 1455;
    static final int ERROR_MENU_ITEM_NOT_FOUND = 1456;
    static final int ERROR_INVALID_KEYBOARD_HANDLE = 1457;
    static final int ERROR_HOOK_TYPE_NOT_ALLOWED = 1458;
    static final int ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION = 1459;
    static final int ERROR_TIMEOUT = 1460;
    static final int ERROR_INVALID_MONITOR_HANDLE = 1461;
    static final int ERROR_EVENTLOG_FILE_CORRUPT = 1500;
    static final int ERROR_EVENTLOG_CANT_START = 1501;
    static final int ERROR_LOG_FILE_FULL = 1502;
    static final int ERROR_EVENTLOG_FILE_CHANGED = 1503;
    static final int ERROR_INSTALL_SERVICE_FAILURE = 1601;
    static final int ERROR_INSTALL_USEREXIT = 1602;
    static final int ERROR_INSTALL_FAILURE = 1603;
    static final int ERROR_INSTALL_SUSPEND = 1604;
    static final int ERROR_UNKNOWN_PRODUCT = 1605;
    static final int ERROR_UNKNOWN_FEATURE = 1606;
    static final int ERROR_UNKNOWN_COMPONENT = 1607;
    static final int ERROR_UNKNOWN_PROPERTY = 1608;
    static final int ERROR_INVALID_HANDLE_STATE = 1609;
    static final int ERROR_BAD_CONFIGURATION = 1610;
    static final int ERROR_INDEX_ABSENT = 1611;
    static final int ERROR_INSTALL_SOURCE_ABSENT = 1612;
    static final int ERROR_INSTALL_PACKAGE_VERSION = 1613;
    static final int ERROR_PRODUCT_UNINSTALLED = 1614;
    static final int ERROR_BAD_QUERY_SYNTAX = 1615;
    static final int ERROR_INVALID_FIELD = 1616;
    static final int ERROR_DEVICE_REMOVED = 1617;
    static final int ERROR_INSTALL_ALREADY_RUNNING = 1618;
    static final int ERROR_INSTALL_PACKAGE_OPEN_FAILED = 1619;
    static final int ERROR_INSTALL_PACKAGE_INVALID = 1620;
    static final int ERROR_INSTALL_UI_FAILURE = 1621;
    static final int ERROR_INSTALL_LOG_FAILURE = 1622;
    static final int ERROR_INSTALL_LANGUAGE_UNSUPPORTED = 1623;
    static final int ERROR_INSTALL_TRANSFORM_FAILURE = 1624;
    static final int ERROR_INSTALL_PACKAGE_REJECTED = 1625;
    static final int ERROR_FUNCTION_NOT_CALLED = 1626;
    static final int ERROR_FUNCTION_FAILED = 1627;
    static final int ERROR_INVALID_TABLE = 1628;
    static final int ERROR_DATATYPE_MISMATCH = 1629;
    static final int ERROR_UNSUPPORTED_TYPE = 1630;
    static final int ERROR_CREATE_FAILED = 1631;
    static final int ERROR_INSTALL_TEMP_UNWRITABLE = 1632;
    static final int ERROR_INSTALL_PLATFORM_UNSUPPORTED = 1633;
    static final int ERROR_INSTALL_NOTUSED = 1634;
    static final int ERROR_PATCH_PACKAGE_OPEN_FAILED = 1635;
    static final int ERROR_PATCH_PACKAGE_INVALID = 1636;
    static final int ERROR_PATCH_PACKAGE_UNSUPPORTED = 1637;
    static final int ERROR_PRODUCT_VERSION = 1638;
    static final int ERROR_INVALID_COMMAND_LINE = 1639;
    static final int ERROR_INSTALL_REMOTE_DISALLOWED = 1640;
    static final int ERROR_SUCCESS_REBOOT_INITIATED = 1641;
    static final int ERROR_PATCH_TARGET_NOT_FOUND = 1642;
    static final int ERROR_PATCH_PACKAGE_REJECTED = 1643;
    static final int ERROR_INSTALL_TRANSFORM_REJECTED = 1644;
    static final int ERROR_INSTALL_REMOTE_PROHIBITED = 1645;
    static final int RPC_S_INVALID_STRING_BINDING = 1700;
    static final int RPC_S_WRONG_KIND_OF_BINDING = 1701;
    static final int RPC_S_INVALID_BINDING = 1702;
    static final int RPC_S_PROTSEQ_NOT_SUPPORTED = 1703;
    static final int RPC_S_INVALID_RPC_PROTSEQ = 1704;
    static final int RPC_S_INVALID_STRING_UUID = 1705;
    static final int RPC_S_INVALID_ENDPOINT_FORMAT = 1706;
    static final int RPC_S_INVALID_NET_ADDR = 1707;
    static final int RPC_S_NO_ENDPOINT_FOUND = 1708;
    static final int RPC_S_INVALID_TIMEOUT = 1709;
    static final int RPC_S_OBJECT_NOT_FOUND = 1710;
    static final int RPC_S_ALREADY_REGISTERED = 1711;
    static final int RPC_S_TYPE_ALREADY_REGISTERED = 1712;
    static final int RPC_S_ALREADY_LISTENING = 1713;
    static final int RPC_S_NO_PROTSEQS_REGISTERED = 1714;
    static final int RPC_S_NOT_LISTENING = 1715;
    static final int RPC_S_UNKNOWN_MGR_TYPE = 1716;
    static final int RPC_S_UNKNOWN_IF = 1717;
    static final int RPC_S_NO_BINDINGS = 1718;
    static final int RPC_S_NO_PROTSEQS = 1719;
    static final int RPC_S_CANT_CREATE_ENDPOINT = 1720;
    static final int RPC_S_OUT_OF_RESOURCES = 1721;
    static final int RPC_S_SERVER_UNAVAILABLE = 1722;
    static final int RPC_S_SERVER_TOO_BUSY = 1723;
    static final int RPC_S_INVALID_NETWORK_OPTIONS = 1724;
    static final int RPC_S_NO_CALL_ACTIVE = 1725;
    static final int RPC_S_CALL_FAILED = 1726;
    static final int RPC_S_CALL_FAILED_DNE = 1727;
    static final int RPC_S_PROTOCOL_ERROR = 1728;
    static final int RPC_S_UNSUPPORTED_TRANS_SYN = 1730;
    static final int RPC_S_UNSUPPORTED_TYPE = 1732;
    static final int RPC_S_INVALID_TAG = 1733;
    static final int RPC_S_INVALID_BOUND = 1734;
    static final int RPC_S_NO_ENTRY_NAME = 1735;
    static final int RPC_S_INVALID_NAME_SYNTAX = 1736;
    static final int RPC_S_UNSUPPORTED_NAME_SYNTAX = 1737;
    static final int RPC_S_UUID_NO_ADDRESS = 1739;
    static final int RPC_S_DUPLICATE_ENDPOINT = 1740;
    static final int RPC_S_UNKNOWN_AUTHN_TYPE = 1741;
    static final int RPC_S_MAX_CALLS_TOO_SMALL = 1742;
    static final int RPC_S_STRING_TOO_LONG = 1743;
    static final int RPC_S_PROTSEQ_NOT_FOUND = 1744;
    static final int RPC_S_PROCNUM_OUT_OF_RANGE = 1745;
    static final int RPC_S_BINDING_HAS_NO_AUTH = 1746;
    static final int RPC_S_UNKNOWN_AUTHN_SERVICE = 1747;
    static final int RPC_S_UNKNOWN_AUTHN_LEVEL = 1748;
    static final int RPC_S_INVALID_AUTH_IDENTITY = 1749;
    static final int RPC_S_UNKNOWN_AUTHZ_SERVICE = 1750;
    static final int EPT_S_INVALID_ENTRY = 1751;
    static final int EPT_S_CANT_PERFORM_OP = 1752;
    static final int EPT_S_NOT_REGISTERED = 1753;
    static final int RPC_S_NOTHING_TO_EXPORT = 1754;
    static final int RPC_S_INCOMPLETE_NAME = 1755;
    static final int RPC_S_INVALID_VERS_OPTION = 1756;
    static final int RPC_S_NO_MORE_MEMBERS = 1757;
    static final int RPC_S_NOT_ALL_OBJS_UNEXPORTED = 1758;
    static final int RPC_S_INTERFACE_NOT_FOUND = 1759;
    static final int RPC_S_ENTRY_ALREADY_EXISTS = 1760;
    static final int RPC_S_ENTRY_NOT_FOUND = 1761;
    static final int RPC_S_NAME_SERVICE_UNAVAILABLE = 1762;
    static final int RPC_S_INVALID_NAF_ID = 1763;
    static final int RPC_S_CANNOT_SUPPORT = 1764;
    static final int RPC_S_NO_CONTEXT_AVAILABLE = 1765;
    static final int RPC_S_INTERNAL_ERROR = 1766;
    static final int RPC_S_ZERO_DIVIDE = 1767;
    static final int RPC_S_ADDRESS_ERROR = 1768;
    static final int RPC_S_FP_DIV_ZERO = 1769;
    static final int RPC_S_FP_UNDERFLOW = 1770;
    static final int RPC_S_FP_OVERFLOW = 1771;
    static final int RPC_X_NO_MORE_ENTRIES = 1772;
    static final int RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 1773;
    static final int RPC_X_SS_CHAR_TRANS_SHORT_FILE = 1774;
    static final int RPC_X_SS_IN_NULL_CONTEXT = 1775;
    static final int RPC_X_SS_CONTEXT_DAMAGED = 1777;
    static final int RPC_X_SS_HANDLES_MISMATCH = 1778;
    static final int RPC_X_SS_CANNOT_GET_CALL_HANDLE = 1779;
    static final int RPC_X_NULL_REF_POINTER = 1780;
    static final int RPC_X_ENUM_VALUE_OUT_OF_RANGE = 1781;
    static final int RPC_X_BYTE_COUNT_TOO_SMALL = 1782;
    static final int RPC_X_BAD_STUB_DATA = 1783;
    static final int ERROR_INVALID_USER_BUFFER = 1784;
    static final int ERROR_UNRECOGNIZED_MEDIA = 1785;
    static final int ERROR_NO_TRUST_LSA_SECRET = 1786;
    static final int ERROR_NO_TRUST_SAM_ACCOUNT = 1787;
    static final int ERROR_TRUSTED_DOMAIN_FAILURE = 1788;
    static final int ERROR_TRUSTED_RELATIONSHIP_FAILURE = 1789;
    static final int ERROR_TRUST_FAILURE = 1790;
    static final int RPC_S_CALL_IN_PROGRESS = 1791;
    static final int ERROR_NETLOGON_NOT_STARTED = 1792;
    static final int ERROR_ACCOUNT_EXPIRED = 1793;
    static final int ERROR_REDIRECTOR_HAS_OPEN_HANDLES = 1794;
    static final int ERROR_PRINTER_DRIVER_ALREADY_INSTALLED = 1795;
    static final int ERROR_UNKNOWN_PORT = 1796;
    static final int ERROR_UNKNOWN_PRINTER_DRIVER = 1797;
    static final int ERROR_UNKNOWN_PRINTPROCESSOR = 1798;
    static final int ERROR_INVALID_SEPARATOR_FILE = 1799;
    static final int ERROR_INVALID_PRIORITY = 1800;
    static final int ERROR_INVALID_PRINTER_NAME = 1801;
    static final int ERROR_PRINTER_ALREADY_EXISTS = 1802;
    static final int ERROR_INVALID_PRINTER_COMMAND = 1803;
    static final int ERROR_INVALID_DATATYPE = 1804;
    static final int ERROR_INVALID_ENVIRONMENT = 1805;
    static final int RPC_S_NO_MORE_BINDINGS = 1806;
    static final int ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = 1807;
    static final int ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT = 1808;
    static final int ERROR_NOLOGON_SERVER_TRUST_ACCOUNT = 1809;
    static final int ERROR_DOMAIN_TRUST_INCONSISTENT = 1810;
    static final int ERROR_SERVER_HAS_OPEN_HANDLES = 1811;
    static final int ERROR_RESOURCE_DATA_NOT_FOUND = 1812;
    static final int ERROR_RESOURCE_TYPE_NOT_FOUND = 1813;
    static final int ERROR_RESOURCE_NAME_NOT_FOUND = 1814;
    static final int ERROR_RESOURCE_LANG_NOT_FOUND = 1815;
    static final int ERROR_NOT_ENOUGH_QUOTA = 1816;
    static final int RPC_S_NO_INTERFACES = 1817;
    static final int RPC_S_CALL_CANCELLED = 1818;
    static final int RPC_S_BINDING_INCOMPLETE = 1819;
    static final int RPC_S_COMM_FAILURE = 1820;
    static final int RPC_S_UNSUPPORTED_AUTHN_LEVEL = 1821;
    static final int RPC_S_NO_PRINC_NAME = 1822;
    static final int RPC_S_NOT_RPC_ERROR = 1823;
    static final int RPC_S_UUID_LOCAL_ONLY = 1824;
    static final int RPC_S_SEC_PKG_ERROR = 1825;
    static final int RPC_S_NOT_CANCELLED = 1826;
    static final int RPC_X_INVALID_ES_ACTION = 1827;
    static final int RPC_X_WRONG_ES_VERSION = 1828;
    static final int RPC_X_WRONG_STUB_VERSION = 1829;
    static final int RPC_X_INVALID_PIPE_OBJECT = 1830;
    static final int RPC_X_WRONG_PIPE_ORDER = 1831;
    static final int RPC_X_WRONG_PIPE_VERSION = 1832;
    static final int RPC_S_GROUP_MEMBER_NOT_FOUND = 1898;
    static final int EPT_S_CANT_CREATE = 1899;
    static final int RPC_S_INVALID_OBJECT = 1900;
    static final int ERROR_INVALID_TIME = 1901;
    static final int ERROR_INVALID_FORM_NAME = 1902;
    static final int ERROR_INVALID_FORM_SIZE = 1903;
    static final int ERROR_ALREADY_WAITING = 1904;
    static final int ERROR_PRINTER_DELETED = 1905;
    static final int ERROR_INVALID_PRINTER_STATE = 1906;
    static final int ERROR_PASSWORD_MUST_CHANGE = 1907;
    static final int ERROR_DOMAIN_CONTROLLER_NOT_FOUND = 1908;
    static final int ERROR_ACCOUNT_LOCKED_OUT = 1909;
    static final int OR_INVALID_OXID = 1910;
    static final int OR_INVALID_OID = 1911;
    static final int OR_INVALID_SET = 1912;
    static final int RPC_S_SEND_INCOMPLETE = 1913;
    static final int RPC_S_INVALID_ASYNC_HANDLE = 1914;
    static final int RPC_S_INVALID_ASYNC_CALL = 1915;
    static final int RPC_X_PIPE_CLOSED = 1916;
    static final int RPC_X_PIPE_DISCIPLINE_ERROR = 1917;
    static final int RPC_X_PIPE_EMPTY = 1918;
    static final int ERROR_NO_SITENAME = 1919;
    static final int ERROR_CANT_ACCESS_FILE = 1920;
    static final int ERROR_CANT_RESOLVE_FILENAME = 1921;
    static final int RPC_S_ENTRY_TYPE_MISMATCH = 1922;
    static final int RPC_S_NOT_ALL_OBJS_EXPORTED = 1923;
    static final int RPC_S_INTERFACE_NOT_EXPORTED = 1924;
    static final int RPC_S_PROFILE_NOT_ADDED = 1925;
    static final int RPC_S_PRF_ELT_NOT_ADDED = 1926;
    static final int RPC_S_PRF_ELT_NOT_REMOVED = 1927;
    static final int RPC_S_GRP_ELT_NOT_ADDED = 1928;
    static final int RPC_S_GRP_ELT_NOT_REMOVED = 1929;
    static final int ERROR_KM_DRIVER_BLOCKED = 1930;
    static final int ERROR_CONTEXT_EXPIRED = 1931;
    static final int ERROR_PER_USER_TRUST_QUOTA_EXCEEDED = 1932;
    static final int ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED = 1933;
    static final int ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED = 1934;
    static final int ERROR_AUTHENTICATION_FIREWALL_FAILED = 1935;
    static final int ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED = 1936;
    static final int ERROR_INVALID_PIXEL_FORMAT = 2000;
    static final int ERROR_BAD_DRIVER = 2001;
    static final int ERROR_INVALID_WINDOW_STYLE = 2002;
    static final int ERROR_METAFILE_NOT_SUPPORTED = 2003;
    static final int ERROR_TRANSFORM_NOT_SUPPORTED = 2004;
    static final int ERROR_CLIPPING_NOT_SUPPORTED = 2005;
    static final int ERROR_INVALID_CMM = 2010;
    static final int ERROR_INVALID_PROFILE = 2011;
    static final int ERROR_TAG_NOT_FOUND = 2012;
    static final int ERROR_TAG_NOT_PRESENT = 2013;
    static final int ERROR_DUPLICATE_TAG = 2014;
    static final int ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE = 2015;
    static final int ERROR_PROFILE_NOT_FOUND = 2016;
    static final int ERROR_INVALID_COLORSPACE = 2017;
    static final int ERROR_ICM_NOT_ENABLED = 2018;
    static final int ERROR_DELETING_ICM_XFORM = 2019;
    static final int ERROR_INVALID_TRANSFORM = 2020;
    static final int ERROR_COLORSPACE_MISMATCH = 2021;
    static final int ERROR_INVALID_COLORINDEX = 2022;
    static final int ERROR_CONNECTED_OTHER_PASSWORD = 2108;
    static final int ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT = 2109;
    static final int ERROR_BAD_USERNAME = 2202;
    static final int ERROR_NOT_CONNECTED = 2250;
    static final int ERROR_OPEN_FILES = 2401;
    static final int ERROR_ACTIVE_CONNECTIONS = 2402;
    static final int ERROR_DEVICE_IN_USE = 2404;
    static final int ERROR_UNKNOWN_PRINT_MONITOR = 3000;
    static final int ERROR_PRINTER_DRIVER_IN_USE = 3001;
    static final int ERROR_SPOOL_FILE_NOT_FOUND = 3002;
    static final int ERROR_SPL_NO_STARTDOC = 3003;
    static final int ERROR_SPL_NO_ADDJOB = 3004;
    static final int ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED = 3005;
    static final int ERROR_PRINT_MONITOR_ALREADY_INSTALLED = 3006;
    static final int ERROR_INVALID_PRINT_MONITOR = 3007;
    static final int ERROR_PRINT_MONITOR_IN_USE = 3008;
    static final int ERROR_PRINTER_HAS_JOBS_QUEUED = 3009;
    static final int ERROR_SUCCESS_REBOOT_REQUIRED = 3010;
    static final int ERROR_SUCCESS_RESTART_REQUIRED = 3011;
    static final int ERROR_PRINTER_NOT_FOUND = 3012;
    static final int ERROR_PRINTER_DRIVER_WARNED = 3013;
    static final int ERROR_PRINTER_DRIVER_BLOCKED = 3014;
    static final int ERROR_WINS_INTERNAL = 4000;
    static final int ERROR_CAN_NOT_DEL_LOCAL_WINS = 4001;
    static final int ERROR_STATIC_INIT = 4002;
    static final int ERROR_INC_BACKUP = 4003;
    static final int ERROR_FULL_BACKUP = 4004;
    static final int ERROR_REC_NON_EXISTENT = 4005;
    static final int ERROR_RPL_NOT_ALLOWED = 4006;
    static final int ERROR_DHCP_ADDRESS_CONFLICT = 4100;
    static final int ERROR_WMI_GUID_NOT_FOUND = 4200;
    static final int ERROR_WMI_INSTANCE_NOT_FOUND = 4201;
    static final int ERROR_WMI_ITEMID_NOT_FOUND = 4202;
    static final int ERROR_WMI_TRY_AGAIN = 4203;
    static final int ERROR_WMI_DP_NOT_FOUND = 4204;
    static final int ERROR_WMI_UNRESOLVED_INSTANCE_REF = 4205;
    static final int ERROR_WMI_ALREADY_ENABLED = 4206;
    static final int ERROR_WMI_GUID_DISCONNECTED = 4207;
    static final int ERROR_WMI_SERVER_UNAVAILABLE = 4208;
    static final int ERROR_WMI_DP_FAILED = 4209;
    static final int ERROR_WMI_INVALID_MOF = 4210;
    static final int ERROR_WMI_INVALID_REGINFO = 4211;
    static final int ERROR_WMI_ALREADY_DISABLED = 4212;
    static final int ERROR_WMI_READ_ONLY = 4213;
    static final int ERROR_WMI_SET_FAILURE = 4214;
    static final int ERROR_INVALID_MEDIA = 4300;
    static final int ERROR_INVALID_LIBRARY = 4301;
    static final int ERROR_INVALID_MEDIA_POOL = 4302;
    static final int ERROR_DRIVE_MEDIA_MISMATCH = 4303;
    static final int ERROR_MEDIA_OFFLINE = 4304;
    static final int ERROR_LIBRARY_OFFLINE = 4305;
    static final int ERROR_EMPTY = 4306;
    static final int ERROR_NOT_EMPTY = 4307;
    static final int ERROR_MEDIA_UNAVAILABLE = 4308;
    static final int ERROR_RESOURCE_DISABLED = 4309;
    static final int ERROR_INVALID_CLEANER = 4310;
    static final int ERROR_UNABLE_TO_CLEAN = 4311;
    static final int ERROR_OBJECT_NOT_FOUND = 4312;
    static final int ERROR_DATABASE_FAILURE = 4313;
    static final int ERROR_DATABASE_FULL = 4314;
    static final int ERROR_MEDIA_INCOMPATIBLE = 4315;
    static final int ERROR_RESOURCE_NOT_PRESENT = 4316;
    static final int ERROR_INVALID_OPERATION = 4317;
    static final int ERROR_MEDIA_NOT_AVAILABLE = 4318;
    static final int ERROR_DEVICE_NOT_AVAILABLE = 4319;
    static final int ERROR_REQUEST_REFUSED = 4320;
    static final int ERROR_INVALID_DRIVE_OBJECT = 4321;
    static final int ERROR_LIBRARY_FULL = 4322;
    static final int ERROR_MEDIUM_NOT_ACCESSIBLE = 4323;
    static final int ERROR_UNABLE_TO_LOAD_MEDIUM = 4324;
    static final int ERROR_UNABLE_TO_INVENTORY_DRIVE = 4325;
    static final int ERROR_UNABLE_TO_INVENTORY_SLOT = 4326;
    static final int ERROR_UNABLE_TO_INVENTORY_TRANSPORT = 4327;
    static final int ERROR_TRANSPORT_FULL = 4328;
    static final int ERROR_CONTROLLING_IEPORT = 4329;
    static final int ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA = 4330;
    static final int ERROR_CLEANER_SLOT_SET = 4331;
    static final int ERROR_CLEANER_SLOT_NOT_SET = 4332;
    static final int ERROR_CLEANER_CARTRIDGE_SPENT = 4333;
    static final int ERROR_UNEXPECTED_OMID = 4334;
    static final int ERROR_CANT_DELETE_LAST_ITEM = 4335;
    static final int ERROR_MESSAGE_EXCEEDS_MAX_SIZE = 4336;
    static final int ERROR_VOLUME_CONTAINS_SYS_FILES = 4337;
    static final int ERROR_INDIGENOUS_TYPE = 4338;
    static final int ERROR_NO_SUPPORTING_DRIVES = 4339;
    static final int ERROR_CLEANER_CARTRIDGE_INSTALLED = 4340;
    static final int ERROR_FILE_OFFLINE = 4350;
    static final int ERROR_REMOTE_STORAGE_NOT_ACTIVE = 4351;
    static final int ERROR_REMOTE_STORAGE_MEDIA_ERROR = 4352;
    static final int ERROR_NOT_A_REPARSE_POINT = 4390;
    static final int ERROR_REPARSE_ATTRIBUTE_CONFLICT = 4391;
    static final int ERROR_INVALID_REPARSE_DATA = 4392;
    static final int ERROR_REPARSE_TAG_INVALID = 4393;
    static final int ERROR_REPARSE_TAG_MISMATCH = 4394;
    static final int ERROR_VOLUME_NOT_SIS_ENABLED = 4500;
    static final int ERROR_DEPENDENT_RESOURCE_EXISTS = 5001;
    static final int ERROR_DEPENDENCY_NOT_FOUND = 5002;
    static final int ERROR_DEPENDENCY_ALREADY_EXISTS = 5003;
    static final int ERROR_RESOURCE_NOT_ONLINE = 5004;
    static final int ERROR_HOST_NODE_NOT_AVAILABLE = 5005;
    static final int ERROR_RESOURCE_NOT_AVAILABLE = 5006;
    static final int ERROR_RESOURCE_NOT_FOUND = 5007;
    static final int ERROR_SHUTDOWN_CLUSTER = 5008;
    static final int ERROR_CANT_EVICT_ACTIVE_NODE = 5009;
    static final int ERROR_OBJECT_ALREADY_EXISTS = 5010;
    static final int ERROR_OBJECT_IN_LIST = 5011;
    static final int ERROR_GROUP_NOT_AVAILABLE = 5012;
    static final int ERROR_GROUP_NOT_FOUND = 5013;
    static final int ERROR_GROUP_NOT_ONLINE = 5014;
    static final int ERROR_HOST_NODE_NOT_RESOURCE_OWNER = 5015;
    static final int ERROR_HOST_NODE_NOT_GROUP_OWNER = 5016;
    static final int ERROR_RESMON_CREATE_FAILED = 5017;
    static final int ERROR_RESMON_ONLINE_FAILED = 5018;
    static final int ERROR_RESOURCE_ONLINE = 5019;
    static final int ERROR_QUORUM_RESOURCE = 5020;
    static final int ERROR_NOT_QUORUM_CAPABLE = 5021;
    static final int ERROR_CLUSTER_SHUTTING_DOWN = 5022;
    static final int ERROR_INVALID_STATE = 5023;
    static final int ERROR_RESOURCE_PROPERTIES_STORED = 5024;
    static final int ERROR_NOT_QUORUM_CLASS = 5025;
    static final int ERROR_CORE_RESOURCE = 5026;
    static final int ERROR_QUORUM_RESOURCE_ONLINE_FAILED = 5027;
    static final int ERROR_QUORUMLOG_OPEN_FAILED = 5028;
    static final int ERROR_CLUSTERLOG_CORRUPT = 5029;
    static final int ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE = 5030;
    static final int ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE = 5031;
    static final int ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND = 5032;
    static final int ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE = 5033;
    static final int ERROR_QUORUM_OWNER_ALIVE = 5034;
    static final int ERROR_NETWORK_NOT_AVAILABLE = 5035;
    static final int ERROR_NODE_NOT_AVAILABLE = 5036;
    static final int ERROR_ALL_NODES_NOT_AVAILABLE = 5037;
    static final int ERROR_RESOURCE_FAILED = 5038;
    static final int ERROR_CLUSTER_INVALID_NODE = 5039;
    static final int ERROR_CLUSTER_NODE_EXISTS = 5040;
    static final int ERROR_CLUSTER_JOIN_IN_PROGRESS = 5041;
    static final int ERROR_CLUSTER_NODE_NOT_FOUND = 5042;
    static final int ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND = 5043;
    static final int ERROR_CLUSTER_NETWORK_EXISTS = 5044;
    static final int ERROR_CLUSTER_NETWORK_NOT_FOUND = 5045;
    static final int ERROR_CLUSTER_NETINTERFACE_EXISTS = 5046;
    static final int ERROR_CLUSTER_NETINTERFACE_NOT_FOUND = 5047;
    static final int ERROR_CLUSTER_INVALID_REQUEST = 5048;
    static final int ERROR_CLUSTER_INVALID_NETWORK_PROVIDER = 5049;
    static final int ERROR_CLUSTER_NODE_DOWN = 5050;
    static final int ERROR_CLUSTER_NODE_UNREACHABLE = 5051;
    static final int ERROR_CLUSTER_NODE_NOT_MEMBER = 5052;
    static final int ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS = 5053;
    static final int ERROR_CLUSTER_INVALID_NETWORK = 5054;
    static final int ERROR_CLUSTER_NODE_UP = 5056;
    static final int ERROR_CLUSTER_IPADDR_IN_USE = 5057;
    static final int ERROR_CLUSTER_NODE_NOT_PAUSED = 5058;
    static final int ERROR_CLUSTER_NO_SECURITY_CONTEXT = 5059;
    static final int ERROR_CLUSTER_NETWORK_NOT_INTERNAL = 5060;
    static final int ERROR_CLUSTER_NODE_ALREADY_UP = 5061;
    static final int ERROR_CLUSTER_NODE_ALREADY_DOWN = 5062;
    static final int ERROR_CLUSTER_NETWORK_ALREADY_ONLINE = 5063;
    static final int ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE = 5064;
    static final int ERROR_CLUSTER_NODE_ALREADY_MEMBER = 5065;
    static final int ERROR_CLUSTER_LAST_INTERNAL_NETWORK = 5066;
    static final int ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS = 5067;
    static final int ERROR_INVALID_OPERATION_ON_QUORUM = 5068;
    static final int ERROR_DEPENDENCY_NOT_ALLOWED = 5069;
    static final int ERROR_CLUSTER_NODE_PAUSED = 5070;
    static final int ERROR_NODE_CANT_HOST_RESOURCE = 5071;
    static final int ERROR_CLUSTER_NODE_NOT_READY = 5072;
    static final int ERROR_CLUSTER_NODE_SHUTTING_DOWN = 5073;
    static final int ERROR_CLUSTER_JOIN_ABORTED = 5074;
    static final int ERROR_CLUSTER_INCOMPATIBLE_VERSIONS = 5075;
    static final int ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED = 5076;
    static final int ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED = 5077;
    static final int ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND = 5078;
    static final int ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED = 5079;
    static final int ERROR_CLUSTER_RESNAME_NOT_FOUND = 5080;
    static final int ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED = 5081;
    static final int ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST = 5082;
    static final int ERROR_CLUSTER_DATABASE_SEQMISMATCH = 5083;
    static final int ERROR_RESMON_INVALID_STATE = 5084;
    static final int ERROR_CLUSTER_GUM_NOT_LOCKER = 5085;
    static final int ERROR_QUORUM_DISK_NOT_FOUND = 5086;
    static final int ERROR_DATABASE_BACKUP_CORRUPT = 5087;
    static final int ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT = 5088;
    static final int ERROR_RESOURCE_PROPERTY_UNCHANGEABLE = 5089;
    static final int ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE = 5890;
    static final int ERROR_CLUSTER_QUORUMLOG_NOT_FOUND = 5891;
    static final int ERROR_CLUSTER_MEMBERSHIP_HALT = 5892;
    static final int ERROR_CLUSTER_INSTANCE_ID_MISMATCH = 5893;
    static final int ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP = 5894;
    static final int ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH = 5895;
    static final int ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP = 5896;
    static final int ERROR_CLUSTER_PARAMETER_MISMATCH = 5897;
    static final int ERROR_NODE_CANNOT_BE_CLUSTERED = 5898;
    static final int ERROR_CLUSTER_WRONG_OS_VERSION = 5899;
    static final int ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME = 5900;
    static final int ERROR_CLUSCFG_ALREADY_COMMITTED = 5901;
    static final int ERROR_CLUSCFG_ROLLBACK_FAILED = 5902;
    static final int ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT = 5903;
    static final int ERROR_CLUSTER_OLD_VERSION = 5904;
    static final int ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME = 5905;
    static final int ERROR_ENCRYPTION_FAILED = 6000;
    static final int ERROR_DECRYPTION_FAILED = 6001;
    static final int ERROR_FILE_ENCRYPTED = 6002;
    static final int ERROR_NO_RECOVERY_POLICY = 6003;
    static final int ERROR_NO_EFS = 6004;
    static final int ERROR_WRONG_EFS = 6005;
    static final int ERROR_NO_USER_KEYS = 6006;
    static final int ERROR_FILE_NOT_ENCRYPTED = 6007;
    static final int ERROR_NOT_EXPORT_FORMAT = 6008;
    static final int ERROR_FILE_READ_ONLY = 6009;
    static final int ERROR_DIR_EFS_DISALLOWED = 6010;
    static final int ERROR_EFS_SERVER_NOT_TRUSTED = 6011;
    static final int ERROR_BAD_RECOVERY_POLICY = 6012;
    static final int ERROR_EFS_ALG_BLOB_TOO_BIG = 6013;
    static final int ERROR_VOLUME_NOT_SUPPORT_EFS = 6014;
    static final int ERROR_EFS_DISABLED = 6015;
    static final int ERROR_EFS_VERSION_NOT_SUPPORT = 6016;
    static final int ERROR_NO_BROWSER_SERVERS_FOUND = 6118;
    static final int SCHED_E_SERVICE_NOT_LOCALSYSTEM = 6200;
    static final int ERROR_CTX_WINSTATION_NAME_INVALID = 7001;
    static final int ERROR_CTX_INVALID_PD = 7002;
    static final int ERROR_CTX_PD_NOT_FOUND = 7003;
    static final int ERROR_CTX_WD_NOT_FOUND = 7004;
    static final int ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY = 7005;
    static final int ERROR_CTX_SERVICE_NAME_COLLISION = 7006;
    static final int ERROR_CTX_CLOSE_PENDING = 7007;
    static final int ERROR_CTX_NO_OUTBUF = 7008;
    static final int ERROR_CTX_MODEM_INF_NOT_FOUND = 7009;
    static final int ERROR_CTX_INVALID_MODEMNAME = 7010;
    static final int ERROR_CTX_MODEM_RESPONSE_ERROR = 7011;
    static final int ERROR_CTX_MODEM_RESPONSE_TIMEOUT = 7012;
    static final int ERROR_CTX_MODEM_RESPONSE_NO_CARRIER = 7013;
    static final int ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE = 7014;
    static final int ERROR_CTX_MODEM_RESPONSE_BUSY = 7015;
    static final int ERROR_CTX_MODEM_RESPONSE_VOICE = 7016;
    static final int ERROR_CTX_TD_ERROR = 7017;
    static final int ERROR_CTX_WINSTATION_NOT_FOUND = 7022;
    static final int ERROR_CTX_WINSTATION_ALREADY_EXISTS = 7023;
    static final int ERROR_CTX_WINSTATION_BUSY = 7024;
    static final int ERROR_CTX_BAD_VIDEO_MODE = 7025;
    static final int ERROR_CTX_GRAPHICS_INVALID = 7035;
    static final int ERROR_CTX_LOGON_DISABLED = 7037;
    static final int ERROR_CTX_NOT_CONSOLE = 7038;
    static final int ERROR_CTX_CLIENT_QUERY_TIMEOUT = 7040;
    static final int ERROR_CTX_CONSOLE_DISCONNECT = 7041;
    static final int ERROR_CTX_CONSOLE_CONNECT = 7042;
    static final int ERROR_CTX_SHADOW_DENIED = 7044;
    static final int ERROR_CTX_WINSTATION_ACCESS_DENIED = 7045;
    static final int ERROR_CTX_INVALID_WD = 7049;
    static final int ERROR_CTX_SHADOW_INVALID = 7050;
    static final int ERROR_CTX_SHADOW_DISABLED = 7051;
    static final int ERROR_CTX_CLIENT_LICENSE_IN_USE = 7052;
    static final int ERROR_CTX_CLIENT_LICENSE_NOT_SET = 7053;
    static final int ERROR_CTX_LICENSE_NOT_AVAILABLE = 7054;
    static final int ERROR_CTX_LICENSE_CLIENT_INVALID = 7055;
    static final int ERROR_CTX_LICENSE_EXPIRED = 7056;
    static final int ERROR_CTX_SHADOW_NOT_RUNNING = 7057;
    static final int ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE = 7058;
    static final int ERROR_ACTIVATION_COUNT_EXCEEDED = 7059;
    static final int FRS_ERR_INVALID_API_SEQUENCE = 8001;
    static final int FRS_ERR_STARTING_SERVICE = 8002;
    static final int FRS_ERR_STOPPING_SERVICE = 8003;
    static final int FRS_ERR_INTERNAL_API = 8004;
    static final int FRS_ERR_INTERNAL = 8005;
    static final int FRS_ERR_SERVICE_COMM = 8006;
    static final int FRS_ERR_INSUFFICIENT_PRIV = 8007;
    static final int FRS_ERR_AUTHENTICATION = 8008;
    static final int FRS_ERR_PARENT_INSUFFICIENT_PRIV = 8009;
    static final int FRS_ERR_PARENT_AUTHENTICATION = 8010;
    static final int FRS_ERR_CHILD_TO_PARENT_COMM = 8011;
    static final int FRS_ERR_PARENT_TO_CHILD_COMM = 8012;
    static final int FRS_ERR_SYSVOL_POPULATE = 8013;
    static final int FRS_ERR_SYSVOL_POPULATE_TIMEOUT = 8014;
    static final int FRS_ERR_SYSVOL_IS_BUSY = 8015;
    static final int FRS_ERR_SYSVOL_DEMOTE = 8016;
    static final int FRS_ERR_INVALID_SERVICE_PARAMETER = 8017;
    static final int DS_S_SUCCESS = NO_ERROR;
    static final int ERROR_DS_NOT_INSTALLED = 8200;
    static final int ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY = 8201;
    static final int ERROR_DS_NO_ATTRIBUTE_OR_VALUE = 8202;
    static final int ERROR_DS_INVALID_ATTRIBUTE_SYNTAX = 8203;
    static final int ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED = 8204;
    static final int ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS = 8205;
    static final int ERROR_DS_BUSY = 8206;
    static final int ERROR_DS_UNAVAILABLE = 8207;
    static final int ERROR_DS_NO_RIDS_ALLOCATED = 8208;
    static final int ERROR_DS_NO_MORE_RIDS = 8209;
    static final int ERROR_DS_INCORRECT_ROLE_OWNER = 8210;
    static final int ERROR_DS_RIDMGR_INIT_ERROR = 8211;
    static final int ERROR_DS_OBJ_CLASS_VIOLATION = 8212;
    static final int ERROR_DS_CANT_ON_NON_LEAF = 8213;
    static final int ERROR_DS_CANT_ON_RDN = 8214;
    static final int ERROR_DS_CANT_MOD_OBJ_CLASS = 8215;
    static final int ERROR_DS_CROSS_DOM_MOVE_ERROR = 8216;
    static final int ERROR_DS_GC_NOT_AVAILABLE = 8217;
    static final int ERROR_SHARED_POLICY = 8218;
    static final int ERROR_POLICY_OBJECT_NOT_FOUND = 8219;
    static final int ERROR_POLICY_ONLY_IN_DS = 8220;
    static final int ERROR_PROMOTION_ACTIVE = 8221;
    static final int ERROR_NO_PROMOTION_ACTIVE = 8222;
    static final int ERROR_DS_OPERATIONS_ERROR = 8224;
    static final int ERROR_DS_PROTOCOL_ERROR = 8225;
    static final int ERROR_DS_TIMELIMIT_EXCEEDED = 8226;
    static final int ERROR_DS_SIZELIMIT_EXCEEDED = 8227;
    static final int ERROR_DS_ADMIN_LIMIT_EXCEEDED = 8228;
    static final int ERROR_DS_COMPARE_FALSE = 8229;
    static final int ERROR_DS_COMPARE_TRUE = 8230;
    static final int ERROR_DS_AUTH_METHOD_NOT_SUPPORTED = 8231;
    static final int ERROR_DS_STRONG_AUTH_REQUIRED = 8232;
    static final int ERROR_DS_INAPPROPRIATE_AUTH = 8233;
    static final int ERROR_DS_AUTH_UNKNOWN = 8234;
    static final int ERROR_DS_REFERRAL = 8235;
    static final int ERROR_DS_UNAVAILABLE_CRIT_EXTENSION = 8236;
    static final int ERROR_DS_CONFIDENTIALITY_REQUIRED = 8237;
    static final int ERROR_DS_INAPPROPRIATE_MATCHING = 8238;
    static final int ERROR_DS_CONSTRAINT_VIOLATION = 8239;
    static final int ERROR_DS_NO_SUCH_OBJECT = 8240;
    static final int ERROR_DS_ALIAS_PROBLEM = 8241;
    static final int ERROR_DS_INVALID_DN_SYNTAX = 8242;
    static final int ERROR_DS_IS_LEAF = 8243;
    static final int ERROR_DS_ALIAS_DEREF_PROBLEM = 8244;
    static final int ERROR_DS_UNWILLING_TO_PERFORM = 8245;
    static final int ERROR_DS_LOOP_DETECT = 8246;
    static final int ERROR_DS_NAMING_VIOLATION = 8247;
    static final int ERROR_DS_OBJECT_RESULTS_TOO_LARGE = 8248;
    static final int ERROR_DS_AFFECTS_MULTIPLE_DSAS = 8249;
    static final int ERROR_DS_SERVER_DOWN = 8250;
    static final int ERROR_DS_LOCAL_ERROR = 8251;
    static final int ERROR_DS_ENCODING_ERROR = 8252;
    static final int ERROR_DS_DECODING_ERROR = 8253;
    static final int ERROR_DS_FILTER_UNKNOWN = 8254;
    static final int ERROR_DS_PARAM_ERROR = 8255;
    static final int ERROR_DS_NOT_SUPPORTED = 8256;
    static final int ERROR_DS_NO_RESULTS_RETURNED = 8257;
    static final int ERROR_DS_CONTROL_NOT_FOUND = 8258;
    static final int ERROR_DS_CLIENT_LOOP = 8259;
    static final int ERROR_DS_REFERRAL_LIMIT_EXCEEDED = 8260;
    static final int ERROR_DS_SORT_CONTROL_MISSING = 8261;
    static final int ERROR_DS_OFFSET_RANGE_ERROR = 8262;
    static final int ERROR_DS_ROOT_MUST_BE_NC = 8301;
    static final int ERROR_DS_ADD_REPLICA_INHIBITED = 8302;
    static final int ERROR_DS_ATT_NOT_DEF_IN_SCHEMA = 8303;
    static final int ERROR_DS_MAX_OBJ_SIZE_EXCEEDED = 8304;
    static final int ERROR_DS_OBJ_STRING_NAME_EXISTS = 8305;
    static final int ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA = 8306;
    static final int ERROR_DS_RDN_DOESNT_MATCH_SCHEMA = 8307;
    static final int ERROR_DS_NO_REQUESTED_ATTS_FOUND = 8308;
    static final int ERROR_DS_USER_BUFFER_TO_SMALL = 8309;
    static final int ERROR_DS_ATT_IS_NOT_ON_OBJ = 8310;
    static final int ERROR_DS_ILLEGAL_MOD_OPERATION = 8311;
    static final int ERROR_DS_OBJ_TOO_LARGE = 8312;
    static final int ERROR_DS_BAD_INSTANCE_TYPE = 8313;
    static final int ERROR_DS_MASTERDSA_REQUIRED = 8314;
    static final int ERROR_DS_OBJECT_CLASS_REQUIRED = 8315;
    static final int ERROR_DS_MISSING_REQUIRED_ATT = 8316;
    static final int ERROR_DS_ATT_NOT_DEF_FOR_CLASS = 8317;
    static final int ERROR_DS_ATT_ALREADY_EXISTS = 8318;
    static final int ERROR_DS_CANT_ADD_ATT_VALUES = 8320;
    static final int ERROR_DS_SINGLE_VALUE_CONSTRAINT = 8321;
    static final int ERROR_DS_RANGE_CONSTRAINT = 8322;
    static final int ERROR_DS_ATT_VAL_ALREADY_EXISTS = 8323;
    static final int ERROR_DS_CANT_REM_MISSING_ATT = 8324;
    static final int ERROR_DS_CANT_REM_MISSING_ATT_VAL = 8325;
    static final int ERROR_DS_ROOT_CANT_BE_SUBREF = 8326;
    static final int ERROR_DS_NO_CHAINING = 8327;
    static final int ERROR_DS_NO_CHAINED_EVAL = 8328;
    static final int ERROR_DS_NO_PARENT_OBJECT = 8329;
    static final int ERROR_DS_PARENT_IS_AN_ALIAS = 8330;
    static final int ERROR_DS_CANT_MIX_MASTER_AND_REPS = 8331;
    static final int ERROR_DS_CHILDREN_EXIST = 8332;
    static final int ERROR_DS_OBJ_NOT_FOUND = 8333;
    static final int ERROR_DS_ALIASED_OBJ_MISSING = 8334;
    static final int ERROR_DS_BAD_NAME_SYNTAX = 8335;
    static final int ERROR_DS_ALIAS_POINTS_TO_ALIAS = 8336;
    static final int ERROR_DS_CANT_DEREF_ALIAS = 8337;
    static final int ERROR_DS_OUT_OF_SCOPE = 8338;
    static final int ERROR_DS_OBJECT_BEING_REMOVED = 8339;
    static final int ERROR_DS_CANT_DELETE_DSA_OBJ = 8340;
    static final int ERROR_DS_GENERIC_ERROR = 8341;
    static final int ERROR_DS_DSA_MUST_BE_INT_MASTER = 8342;
    static final int ERROR_DS_CLASS_NOT_DSA = 8343;
    static final int ERROR_DS_INSUFF_ACCESS_RIGHTS = 8344;
    static final int ERROR_DS_ILLEGAL_SUPERIOR = 8345;
    static final int ERROR_DS_ATTRIBUTE_OWNED_BY_SAM = 8346;
    static final int ERROR_DS_NAME_TOO_MANY_PARTS = 8347;
    static final int ERROR_DS_NAME_TOO_LONG = 8348;
    static final int ERROR_DS_NAME_VALUE_TOO_LONG = 8349;
    static final int ERROR_DS_NAME_UNPARSEABLE = 8350;
    static final int ERROR_DS_NAME_TYPE_UNKNOWN = 8351;
    static final int ERROR_DS_NOT_AN_OBJECT = 8352;
    static final int ERROR_DS_SEC_DESC_TOO_SHORT = 8353;
    static final int ERROR_DS_SEC_DESC_INVALID = 8354;
    static final int ERROR_DS_NO_DELETED_NAME = 8355;
    static final int ERROR_DS_SUBREF_MUST_HAVE_PARENT = 8356;
    static final int ERROR_DS_NCNAME_MUST_BE_NC = 8357;
    static final int ERROR_DS_CANT_ADD_SYSTEM_ONLY = 8358;
    static final int ERROR_DS_CLASS_MUST_BE_CONCRETE = 8359;
    static final int ERROR_DS_INVALID_DMD = 8360;
    static final int ERROR_DS_OBJ_GUID_EXISTS = 8361;
    static final int ERROR_DS_NOT_ON_BACKLINK = 8362;
    static final int ERROR_DS_NO_CROSSREF_FOR_NC = 8363;
    static final int ERROR_DS_SHUTTING_DOWN = 8364;
    static final int ERROR_DS_UNKNOWN_OPERATION = 8365;
    static final int ERROR_DS_INVALID_ROLE_OWNER = 8366;
    static final int ERROR_DS_COULDNT_CONTACT_FSMO = 8367;
    static final int ERROR_DS_CROSS_NC_DN_RENAME = 8368;
    static final int ERROR_DS_CANT_MOD_SYSTEM_ONLY = 8369;
    static final int ERROR_DS_REPLICATOR_ONLY = 8370;
    static final int ERROR_DS_OBJ_CLASS_NOT_DEFINED = 8371;
    static final int ERROR_DS_OBJ_CLASS_NOT_SUBCLASS = 8372;
    static final int ERROR_DS_NAME_REFERENCE_INVALID = 8373;
    static final int ERROR_DS_CROSS_REF_EXISTS = 8374;
    static final int ERROR_DS_CANT_DEL_MASTER_CROSSREF = 8375;
    static final int ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD = 8376;
    static final int ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX = 8377;
    static final int ERROR_DS_DUP_RDN = 8378;
    static final int ERROR_DS_DUP_OID = 8379;
    static final int ERROR_DS_DUP_MAPI_ID = 8380;
    static final int ERROR_DS_DUP_SCHEMA_ID_GUID = 8381;
    static final int ERROR_DS_DUP_LDAP_DISPLAY_NAME = 8382;
    static final int ERROR_DS_SEMANTIC_ATT_TEST = 8383;
    static final int ERROR_DS_SYNTAX_MISMATCH = 8384;
    static final int ERROR_DS_EXISTS_IN_MUST_HAVE = 8385;
    static final int ERROR_DS_EXISTS_IN_MAY_HAVE = 8386;
    static final int ERROR_DS_NONEXISTENT_MAY_HAVE = 8387;
    static final int ERROR_DS_NONEXISTENT_MUST_HAVE = 8388;
    static final int ERROR_DS_AUX_CLS_TEST_FAIL = 8389;
    static final int ERROR_DS_NONEXISTENT_POSS_SUP = 8390;
    static final int ERROR_DS_SUB_CLS_TEST_FAIL = 8391;
    static final int ERROR_DS_BAD_RDN_ATT_ID_SYNTAX = 8392;
    static final int ERROR_DS_EXISTS_IN_AUX_CLS = 8393;
    static final int ERROR_DS_EXISTS_IN_SUB_CLS = 8394;
    static final int ERROR_DS_EXISTS_IN_POSS_SUP = 8395;
    static final int ERROR_DS_RECALCSCHEMA_FAILED = 8396;
    static final int ERROR_DS_TREE_DELETE_NOT_FINISHED = 8397;
    static final int ERROR_DS_CANT_DELETE = 8398;
    static final int ERROR_DS_ATT_SCHEMA_REQ_ID = 8399;
    static final int ERROR_DS_BAD_ATT_SCHEMA_SYNTAX = 8400;
    static final int ERROR_DS_CANT_CACHE_ATT = 8401;
    static final int ERROR_DS_CANT_CACHE_CLASS = 8402;
    static final int ERROR_DS_CANT_REMOVE_ATT_CACHE = 8403;
    static final int ERROR_DS_CANT_REMOVE_CLASS_CACHE = 8404;
    static final int ERROR_DS_CANT_RETRIEVE_DN = 8405;
    static final int ERROR_DS_MISSING_SUPREF = 8406;
    static final int ERROR_DS_CANT_RETRIEVE_INSTANCE = 8407;
    static final int ERROR_DS_CODE_INCONSISTENCY = 8408;
    static final int ERROR_DS_DATABASE_ERROR = 8409;
    static final int ERROR_DS_GOVERNSID_MISSING = 8410;
    static final int ERROR_DS_MISSING_EXPECTED_ATT = 8411;
    static final int ERROR_DS_NCNAME_MISSING_CR_REF = 8412;
    static final int ERROR_DS_SECURITY_CHECKING_ERROR = 8413;
    static final int ERROR_DS_SCHEMA_NOT_LOADED = 8414;
    static final int ERROR_DS_SCHEMA_ALLOC_FAILED = 8415;
    static final int ERROR_DS_ATT_SCHEMA_REQ_SYNTAX = 8416;
    static final int ERROR_DS_GCVERIFY_ERROR = 8417;
    static final int ERROR_DS_DRA_SCHEMA_MISMATCH = 8418;
    static final int ERROR_DS_CANT_FIND_DSA_OBJ = 8419;
    static final int ERROR_DS_CANT_FIND_EXPECTED_NC = 8420;
    static final int ERROR_DS_CANT_FIND_NC_IN_CACHE = 8421;
    static final int ERROR_DS_CANT_RETRIEVE_CHILD = 8422;
    static final int ERROR_DS_SECURITY_ILLEGAL_MODIFY = 8423;
    static final int ERROR_DS_CANT_REPLACE_HIDDEN_REC = 8424;
    static final int ERROR_DS_BAD_HIERARCHY_FILE = 8425;
    static final int ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED = 8426;
    static final int ERROR_DS_CONFIG_PARAM_MISSING = 8427;
    static final int ERROR_DS_COUNTING_AB_INDICES_FAILED = 8428;
    static final int ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED = 8429;
    static final int ERROR_DS_INTERNAL_FAILURE = 8430;
    static final int ERROR_DS_UNKNOWN_ERROR = 8431;
    static final int ERROR_DS_ROOT_REQUIRES_CLASS_TOP = 8432;
    static final int ERROR_DS_REFUSING_FSMO_ROLES = 8433;
    static final int ERROR_DS_MISSING_FSMO_SETTINGS = 8434;
    static final int ERROR_DS_UNABLE_TO_SURRENDER_ROLES = 8435;
    static final int ERROR_DS_DRA_GENERIC = 8436;
    static final int ERROR_DS_DRA_INVALID_PARAMETER = 8437;
    static final int ERROR_DS_DRA_BUSY = 8438;
    static final int ERROR_DS_DRA_BAD_DN = 8439;
    static final int ERROR_DS_DRA_BAD_NC = 8440;
    static final int ERROR_DS_DRA_DN_EXISTS = 8441;
    static final int ERROR_DS_DRA_INTERNAL_ERROR = 8442;
    static final int ERROR_DS_DRA_INCONSISTENT_DIT = 8443;
    static final int ERROR_DS_DRA_CONNECTION_FAILED = 8444;
    static final int ERROR_DS_DRA_BAD_INSTANCE_TYPE = 8445;
    static final int ERROR_DS_DRA_OUT_OF_MEM = 8446;
    static final int ERROR_DS_DRA_MAIL_PROBLEM = 8447;
    static final int ERROR_DS_DRA_REF_ALREADY_EXISTS = 8448;
    static final int ERROR_DS_DRA_REF_NOT_FOUND = 8449;
    static final int ERROR_DS_DRA_OBJ_IS_REP_SOURCE = 8450;
    static final int ERROR_DS_DRA_DB_ERROR = 8451;
    static final int ERROR_DS_DRA_NO_REPLICA = 8452;
    static final int ERROR_DS_DRA_ACCESS_DENIED = 8453;
    static final int ERROR_DS_DRA_NOT_SUPPORTED = 8454;
    static final int ERROR_DS_DRA_RPC_CANCELLED = 8455;
    static final int ERROR_DS_DRA_SOURCE_DISABLED = 8456;
    static final int ERROR_DS_DRA_SINK_DISABLED = 8457;
    static final int ERROR_DS_DRA_NAME_COLLISION = 8458;
    static final int ERROR_DS_DRA_SOURCE_REINSTALLED = 8459;
    static final int ERROR_DS_DRA_MISSING_PARENT = 8460;
    static final int ERROR_DS_DRA_PREEMPTED = 8461;
    static final int ERROR_DS_DRA_ABANDON_SYNC = 8462;
    static final int ERROR_DS_DRA_SHUTDOWN = 8463;
    static final int ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET = 8464;
    static final int ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA = 8465;
    static final int ERROR_DS_DRA_EXTN_CONNECTION_FAILED = 8466;
    static final int ERROR_DS_INSTALL_SCHEMA_MISMATCH = 8467;
    static final int ERROR_DS_DUP_LINK_ID = 8468;
    static final int ERROR_DS_NAME_ERROR_RESOLVING = 8469;
    static final int ERROR_DS_NAME_ERROR_NOT_FOUND = 8470;
    static final int ERROR_DS_NAME_ERROR_NOT_UNIQUE = 8471;
    static final int ERROR_DS_NAME_ERROR_NO_MAPPING = 8472;
    static final int ERROR_DS_NAME_ERROR_DOMAIN_ONLY = 8473;
    static final int ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING = 8474;
    static final int ERROR_DS_CONSTRUCTED_ATT_MOD = 8475;
    static final int ERROR_DS_WRONG_OM_OBJ_CLASS = 8476;
    static final int ERROR_DS_DRA_REPL_PENDING = 8477;
    static final int ERROR_DS_DS_REQUIRED = 8478;
    static final int ERROR_DS_INVALID_LDAP_DISPLAY_NAME = 8479;
    static final int ERROR_DS_NON_BASE_SEARCH = 8480;
    static final int ERROR_DS_CANT_RETRIEVE_ATTS = 8481;
    static final int ERROR_DS_BACKLINK_WITHOUT_LINK = 8482;
    static final int ERROR_DS_EPOCH_MISMATCH = 8483;
    static final int ERROR_DS_SRC_NAME_MISMATCH = 8484;
    static final int ERROR_DS_SRC_AND_DST_NC_IDENTICAL = 8485;
    static final int ERROR_DS_DST_NC_MISMATCH = 8486;
    static final int ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC = 8487;
    static final int ERROR_DS_SRC_GUID_MISMATCH = 8488;
    static final int ERROR_DS_CANT_MOVE_DELETED_OBJECT = 8489;
    static final int ERROR_DS_PDC_OPERATION_IN_PROGRESS = 8490;
    static final int ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD = 8491;
    static final int ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION = 8492;
    static final int ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS = 8493;
    static final int ERROR_DS_NC_MUST_HAVE_NC_PARENT = 8494;
    static final int ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE = 8495;
    static final int ERROR_DS_DST_DOMAIN_NOT_NATIVE = 8496;
    static final int ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER = 8497;
    static final int ERROR_DS_CANT_MOVE_ACCOUNT_GROUP = 8498;
    static final int ERROR_DS_CANT_MOVE_RESOURCE_GROUP = 8499;
    static final int ERROR_DS_INVALID_SEARCH_FLAG = 8500;
    static final int ERROR_DS_NO_TREE_DELETE_ABOVE_NC = 8501;
    static final int ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE = 8502;
    static final int ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE = 8503;
    static final int ERROR_DS_SAM_INIT_FAILURE = 8504;
    static final int ERROR_DS_SENSITIVE_GROUP_VIOLATION = 8505;
    static final int ERROR_DS_CANT_MOD_PRIMARYGROUPID = 8506;
    static final int ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD = 8507;
    static final int ERROR_DS_NONSAFE_SCHEMA_CHANGE = 8508;
    static final int ERROR_DS_SCHEMA_UPDATE_DISALLOWED = 8509;
    static final int ERROR_DS_CANT_CREATE_UNDER_SCHEMA = 8510;
    static final int ERROR_DS_INSTALL_NO_SRC_SCH_VERSION = 8511;
    static final int ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE = 8512;
    static final int ERROR_DS_INVALID_GROUP_TYPE = 8513;
    static final int ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN = 8514;
    static final int ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN = 8515;
    static final int ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER = 8516;
    static final int ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER = 8517;
    static final int ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER = 8518;
    static final int ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER = 8519;
    static final int ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER = 8520;
    static final int ERROR_DS_HAVE_PRIMARY_MEMBERS = 8521;
    static final int ERROR_DS_STRING_SD_CONVERSION_FAILED = 8522;
    static final int ERROR_DS_NAMING_MASTER_GC = 8523;
    static final int ERROR_DS_DNS_LOOKUP_FAILURE = 8524;
    static final int ERROR_DS_COULDNT_UPDATE_SPNS = 8525;
    static final int ERROR_DS_CANT_RETRIEVE_SD = 8526;
    static final int ERROR_DS_KEY_NOT_UNIQUE = 8527;
    static final int ERROR_DS_WRONG_LINKED_ATT_SYNTAX = 8528;
    static final int ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD = 8529;
    static final int ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY = 8530;
    static final int ERROR_DS_CANT_START = 8531;
    static final int ERROR_DS_INIT_FAILURE = 8532;
    static final int ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION = 8533;
    static final int ERROR_DS_SOURCE_DOMAIN_IN_FOREST = 8534;
    static final int ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST = 8535;
    static final int ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED = 8536;
    static final int ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN = 8537;
    static final int ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER = 8538;
    static final int ERROR_DS_SRC_SID_EXISTS_IN_FOREST = 8539;
    static final int ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH = 8540;
    static final int ERROR_SAM_INIT_FAILURE = 8541;
    static final int ERROR_DS_DRA_SCHEMA_INFO_SHIP = 8542;
    static final int ERROR_DS_DRA_SCHEMA_CONFLICT = 8543;
    static final int ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT = 8544;
    static final int ERROR_DS_DRA_OBJ_NC_MISMATCH = 8545;
    static final int ERROR_DS_NC_STILL_HAS_DSAS = 8546;
    static final int ERROR_DS_GC_REQUIRED = 8547;
    static final int ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY = 8548;
    static final int ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS = 8549;
    static final int ERROR_DS_CANT_ADD_TO_GC = 8550;
    static final int ERROR_DS_NO_CHECKPOINT_WITH_PDC = 8551;
    static final int ERROR_DS_SOURCE_AUDITING_NOT_ENABLED = 8552;
    static final int ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC = 8553;
    static final int ERROR_DS_INVALID_NAME_FOR_SPN = 8554;
    static final int ERROR_DS_FILTER_USES_CONSTRUCTED_ATTRS = 8555;
    static final int ERROR_DS_UNICODEPWD_NOT_IN_QUOTES = 8556;
    static final int ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED = 8557;
    static final int ERROR_DS_MUST_BE_RUN_ON_DST_DC = 8558;
    static final int ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER = 8559;
    static final int ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ = 8560;
    static final int ERROR_DS_INIT_FAILURE_CONSOLE = 8561;
    static final int ERROR_DS_SAM_INIT_FAILURE_CONSOLE = 8562;
    static final int ERROR_DS_FOREST_VERSION_TOO_HIGH = 8563;
    static final int ERROR_DS_DOMAIN_VERSION_TOO_HIGH = 8564;
    static final int ERROR_DS_FOREST_VERSION_TOO_LOW = 8565;
    static final int ERROR_DS_DOMAIN_VERSION_TOO_LOW = 8566;
    static final int ERROR_DS_INCOMPATIBLE_VERSION = 8567;
    static final int ERROR_DS_LOW_DSA_VERSION = 8568;
    static final int ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN = 8569;
    static final int ERROR_DS_NOT_SUPPORTED_SORT_ORDER = 8570;
    static final int ERROR_DS_NAME_NOT_UNIQUE = 8571;
    static final int ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4 = 8572;
    static final int ERROR_DS_OUT_OF_VERSION_STORE = 8573;
    static final int ERROR_DS_INCOMPATIBLE_CONTROLS_USED = 8574;
    static final int ERROR_DS_NO_REF_DOMAIN = 8575;
    static final int ERROR_DS_RESERVED_LINK_ID = 8576;
    static final int ERROR_DS_LINK_ID_NOT_AVAILABLE = 8577;
    static final int ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER = 8578;
    static final int ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE = 8579;
    static final int ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC = 8580;
    static final int ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG = 8581;
    static final int ERROR_DS_MODIFYDN_WRONG_GRANDPARENT = 8582;
    static final int ERROR_DS_NAME_ERROR_TRUST_REFERRAL = 8583;
    static final int ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER = 8584;
    static final int ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD = 8585;
    static final int ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2 = 8586;
    static final int ERROR_DS_THREAD_LIMIT_EXCEEDED = 8587;
    static final int ERROR_DS_NOT_CLOSEST = 8588;
    static final int ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF = 8589;
    static final int ERROR_DS_SINGLE_USER_MODE_FAILED = 8590;
    static final int ERROR_DS_NTDSCRIPT_SYNTAX_ERROR = 8591;
    static final int ERROR_DS_NTDSCRIPT_PROCESS_ERROR = 8592;
    static final int ERROR_DS_DIFFERENT_REPL_EPOCHS = 8593;
    static final int ERROR_DS_DRS_EXTENSIONS_CHANGED = 8594;
    static final int ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR = 8595;
    static final int ERROR_DS_NO_MSDS_INTID = 8596;
    static final int ERROR_DS_DUP_MSDS_INTID = 8597;
    static final int ERROR_DS_EXISTS_IN_RDNATTID = 8598;
    static final int ERROR_DS_AUTHORIZATION_FAILED = 8599;
    static final int ERROR_DS_INVALID_SCRIPT = 8600;
    static final int ERROR_DS_REMOTE_CROSSREF_OP_FAILED = 8601;
    static final int ERROR_DS_CROSS_REF_BUSY = 8602;
    static final int ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN = 8603;
    static final int ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC = 8604;
    static final int ERROR_DS_DUPLICATE_ID_FOUND = 8605;
    static final int ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT = 8606;
    static final int ERROR_DS_GROUP_CONVERSION_ERROR = 8607;
    static final int ERROR_DS_CANT_MOVE_APP_BASIC_GROUP = 8608;
    static final int ERROR_DS_CANT_MOVE_APP_QUERY_GROUP = 8609;
    static final int ERROR_DS_ROLE_NOT_VERIFIED = 8610;
    static final int ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL = 8611;
    static final int ERROR_DS_DOMAIN_RENAME_IN_PROGRESS = 8612;
    static final int ERROR_DS_EXISTING_AD_CHILD_NC = 8613;
    static final int ERROR_DS_REPL_LIFETIME_EXCEEDED = 8614;
    static final int ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER = 8615;
    static final int ERROR_DS_LDAP_SEND_QUEUE_FULL = 8616;
    static final int DNS_ERROR_RESPONSE_CODES_BASE = 9000;
    static final int DNS_ERROR_RCODE_NO_ERROR = NO_ERROR;
    static final int DNS_ERROR_MASK = 0x00002328;
    static final int DNS_ERROR_RCODE_FORMAT_ERROR = 9001;
    static final int DNS_ERROR_RCODE_SERVER_FAILURE = 9002;
    static final int DNS_ERROR_RCODE_NAME_ERROR = 9003;
    static final int DNS_ERROR_RCODE_NOT_IMPLEMENTED = 9004;
    static final int DNS_ERROR_RCODE_REFUSED = 9005;
    static final int DNS_ERROR_RCODE_YXDOMAIN = 9006;
    static final int DNS_ERROR_RCODE_YXRRSET = 9007;
    static final int DNS_ERROR_RCODE_NXRRSET = 9008;
    static final int DNS_ERROR_RCODE_NOTAUTH = 9009;
    static final int DNS_ERROR_RCODE_NOTZONE = 9010;
    static final int DNS_ERROR_RCODE_BADSIG = 9016;
    static final int DNS_ERROR_RCODE_BADKEY = 9017;
    static final int DNS_ERROR_RCODE_BADTIME = 9018;
    static final int DNS_ERROR_RCODE_LAST = DNS_ERROR_RCODE_BADTIME;
    static final int DNS_ERROR_PACKET_FMT_BASE = 9500;
    static final int DNS_INFO_NO_RECORDS = 9501;
    static final int DNS_ERROR_BAD_PACKET = 9502;
    static final int DNS_ERROR_NO_PACKET = 9503;
    static final int DNS_ERROR_RCODE = 9504;
    static final int DNS_ERROR_UNSECURE_PACKET = 9505;
    static final int DNS_STATUS_PACKET_UNSECURE = DNS_ERROR_UNSECURE_PACKET;
    static final int DNS_ERROR_NO_MEMORY = ERROR_OUTOFMEMORY;
    static final int DNS_ERROR_INVALID_NAME = ERROR_INVALID_NAME;
    static final int DNS_ERROR_INVALID_DATA = ERROR_INVALID_DATA;
    static final int DNS_ERROR_GENERAL_API_BASE = 9550;
    static final int DNS_ERROR_INVALID_TYPE = 9551;
    static final int DNS_ERROR_INVALID_IP_ADDRESS = 9552;
    static final int DNS_ERROR_INVALID_PROPERTY = 9553;
    static final int DNS_ERROR_TRY_AGAIN_LATER = 9554;
    static final int DNS_ERROR_NOT_UNIQUE = 9555;
    static final int DNS_ERROR_NON_RFC_NAME = 9556;
    static final int DNS_STATUS_FQDN = 9557;
    static final int DNS_STATUS_DOTTED_NAME = 9558;
    static final int DNS_STATUS_SINGLE_PART_NAME = 9559;
    static final int DNS_ERROR_INVALID_NAME_CHAR = 9560;
    static final int DNS_ERROR_NUMERIC_NAME = 9561;
    static final int DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER = 9562;
    static final int DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION = 9563;
    static final int DNS_ERROR_CANNOT_FIND_ROOT_HINTS = 9564;
    static final int DNS_ERROR_INCONSISTENT_ROOT_HINTS = 9565;
    static final int DNS_ERROR_ZONE_BASE = 9600;
    static final int DNS_ERROR_ZONE_DOES_NOT_EXIST = 9601;
    static final int DNS_ERROR_NO_ZONE_INFO = 9602;
    static final int DNS_ERROR_INVALID_ZONE_OPERATION = 9603;
    static final int DNS_ERROR_ZONE_CONFIGURATION_ERROR = 9604;
    static final int DNS_ERROR_ZONE_HAS_NO_SOA_RECORD = 9605;
    static final int DNS_ERROR_ZONE_HAS_NO_NS_RECORDS = 9606;
    static final int DNS_ERROR_ZONE_LOCKED = 9607;
    static final int DNS_ERROR_ZONE_CREATION_FAILED = 9608;
    static final int DNS_ERROR_ZONE_ALREADY_EXISTS = 9609;
    static final int DNS_ERROR_AUTOZONE_ALREADY_EXISTS = 9610;
    static final int DNS_ERROR_INVALID_ZONE_TYPE = 9611;
    static final int DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP = 9612;
    static final int DNS_ERROR_ZONE_NOT_SECONDARY = 9613;
    static final int DNS_ERROR_NEED_SECONDARY_ADDRESSES = 9614;
    static final int DNS_ERROR_WINS_INIT_FAILED = 9615;
    static final int DNS_ERROR_NEED_WINS_SERVERS = 9616;
    static final int DNS_ERROR_NBSTAT_INIT_FAILED = 9617;
    static final int DNS_ERROR_SOA_DELETE_INVALID = 9618;
    static final int DNS_ERROR_FORWARDER_ALREADY_EXISTS = 9619;
    static final int DNS_ERROR_ZONE_REQUIRES_MASTER_IP = 9620;
    static final int DNS_ERROR_ZONE_IS_SHUTDOWN = 9621;
    static final int DNS_ERROR_DATAFILE_BASE = 9650;
    static final int DNS_ERROR_PRIMARY_REQUIRES_DATAFILE = 9651;
    static final int DNS_ERROR_INVALID_DATAFILE_NAME = 9652;
    static final int DNS_ERROR_DATAFILE_OPEN_FAILURE = 9653;
    static final int DNS_ERROR_FILE_WRITEBACK_FAILED = 9654;
    static final int DNS_ERROR_DATAFILE_PARSING = 9655;
    static final int DNS_ERROR_DATABASE_BASE = 9700;
    static final int DNS_ERROR_RECORD_DOES_NOT_EXIST = 9701;
    static final int DNS_ERROR_RECORD_FORMAT = 9702;
    static final int DNS_ERROR_NODE_CREATION_FAILED = 9703;
    static final int DNS_ERROR_UNKNOWN_RECORD_TYPE = 9704;
    static final int DNS_ERROR_RECORD_TIMED_OUT = 9705;
    static final int DNS_ERROR_NAME_NOT_IN_ZONE = 9706;
    static final int DNS_ERROR_CNAME_LOOP = 9707;
    static final int DNS_ERROR_NODE_IS_CNAME = 9708;
    static final int DNS_ERROR_CNAME_COLLISION = 9709;
    static final int DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT = 9710;
    static final int DNS_ERROR_RECORD_ALREADY_EXISTS = 9711;
    static final int DNS_ERROR_SECONDARY_DATA = 9712;
    static final int DNS_ERROR_NO_CREATE_CACHE_DATA = 9713;
    static final int DNS_ERROR_NAME_DOES_NOT_EXIST = 9714;
    static final int DNS_WARNING_PTR_CREATE_FAILED = 9715;
    static final int DNS_WARNING_DOMAIN_UNDELETED = 9716;
    static final int DNS_ERROR_DS_UNAVAILABLE = 9717;
    static final int DNS_ERROR_DS_ZONE_ALREADY_EXISTS = 9718;
    static final int DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE = 9719;
    static final int DNS_ERROR_OPERATION_BASE = 9750;
    static final int DNS_INFO_AXFR_COMPLETE = 9751;
    static final int DNS_ERROR_AXFR = 9752;
    static final int DNS_INFO_ADDED_LOCAL_WINS = 9753;
    static final int DNS_ERROR_SECURE_BASE = 9800;
    static final int DNS_STATUS_CONTINUE_NEEDED = 9801;
    static final int DNS_ERROR_SETUP_BASE = 9850;
    static final int DNS_ERROR_NO_TCPIP = 9851;
    static final int DNS_ERROR_NO_DNS_SERVERS = 9852;
    static final int DNS_ERROR_DP_BASE = 9900;
    static final int DNS_ERROR_DP_DOES_NOT_EXIST = 9901;
    static final int DNS_ERROR_DP_ALREADY_EXISTS = 9902;
    static final int DNS_ERROR_DP_NOT_ENLISTED = 9903;
    static final int DNS_ERROR_DP_ALREADY_ENLISTED = 9904;
    static final int DNS_ERROR_DP_NOT_AVAILABLE = 9905;
    static final int WSABASEERR = 10000;
    static final int WSAEINTR = 10004;
    static final int WSAEBADF = 10009;
    static final int WSAEACCES = 10013;
    static final int WSAEFAULT = 10014;
    static final int WSAEINVAL = 10022;
    static final int WSAEMFILE = 10024;
    static final int WSAEWOULDBLOCK = 10035;
    static final int WSAEINPROGRESS = 10036;
    static final int WSAEALREADY = 10037;
    static final int WSAENOTSOCK = 10038;
    static final int WSAEDESTADDRREQ = 10039;
    static final int WSAEMSGSIZE = 10040;
    static final int WSAEPROTOTYPE = 10041;
    static final int WSAENOPROTOOPT = 10042;
    static final int WSAEPROTONOSUPPORT = 10043;
    static final int WSAESOCKTNOSUPPORT = 10044;
    static final int WSAEOPNOTSUPP = 10045;
    static final int WSAEPFNOSUPPORT = 10046;
    static final int WSAEAFNOSUPPORT = 10047;
    static final int WSAEADDRINUSE = 10048;
    static final int WSAEADDRNOTAVAIL = 10049;
    static final int WSAENETDOWN = 10050;
    static final int WSAENETUNREACH = 10051;
    static final int WSAENETRESET = 10052;
    static final int WSAECONNABORTED = 10053;
    static final int WSAECONNRESET = 10054;
    static final int WSAENOBUFS = 10055;
    static final int WSAEISCONN = 10056;
    static final int WSAENOTCONN = 10057;
    static final int WSAESHUTDOWN = 10058;
    static final int WSAETOOMANYREFS = 10059;
    static final int WSAETIMEDOUT = 10060;
    static final int WSAECONNREFUSED = 10061;
    static final int WSAELOOP = 10062;
    static final int WSAENAMETOOLONG = 10063;
    static final int WSAEHOSTDOWN = 10064;
    static final int WSAEHOSTUNREACH = 10065;
    static final int WSAENOTEMPTY = 10066;
    static final int WSAEPROCLIM = 10067;
    static final int WSAEUSERS = 10068;
    static final int WSAEDQUOT = 10069;
    static final int WSAESTALE = 10070;
    static final int WSAEREMOTE = 10071;
    static final int WSASYSNOTREADY = 10091;
    static final int WSAVERNOTSUPPORTED = 10092;
    static final int WSANOTINITIALISED = 10093;
    static final int WSAEDISCON = 10101;
    static final int WSAENOMORE = 10102;
    static final int WSAECANCELLED = 10103;
    static final int WSAEINVALIDPROCTABLE = 10104;
    static final int WSAEINVALIDPROVIDER = 10105;
    static final int WSAEPROVIDERFAILEDINIT = 10106;
    static final int WSASYSCALLFAILURE = 10107;
    static final int WSASERVICE_NOT_FOUND = 10108;
    static final int WSATYPE_NOT_FOUND = 10109;
    static final int WSA_E_NO_MORE = 10110;
    static final int WSA_E_CANCELLED = 10111;
    static final int WSAEREFUSED = 10112;
    static final int WSAHOST_NOT_FOUND = 11001;
    static final int WSATRY_AGAIN = 11002;
    static final int WSANO_RECOVERY = 11003;
    static final int WSANO_DATA = 11004;
    static final int WSA_QOS_RECEIVERS = 11005;
    static final int WSA_QOS_SENDERS = 11006;
    static final int WSA_QOS_NO_SENDERS = 11007;
    static final int WSA_QOS_NO_RECEIVERS = 11008;
    static final int WSA_QOS_REQUEST_CONFIRMED = 11009;
    static final int WSA_QOS_ADMISSION_FAILURE = 11010;
    static final int WSA_QOS_POLICY_FAILURE = 11011;
    static final int WSA_QOS_BAD_STYLE = 11012;
    static final int WSA_QOS_BAD_OBJECT = 11013;
    static final int WSA_QOS_TRAFFIC_CTRL_ERROR = 11014;
    static final int WSA_QOS_GENERIC_ERROR = 11015;
    static final int WSA_QOS_ESERVICETYPE = 11016;
    static final int WSA_QOS_EFLOWSPEC = 11017;
    static final int WSA_QOS_EPROVSPECBUF = 11018;
    static final int WSA_QOS_EFILTERSTYLE = 11019;
    static final int WSA_QOS_EFILTERTYPE = 11020;
    static final int WSA_QOS_EFILTERCOUNT = 11021;
    static final int WSA_QOS_EOBJLENGTH = 11022;
    static final int WSA_QOS_EFLOWCOUNT = 11023;
    static final int WSA_QOS_EUNKOWNPSOBJ = 11024;
    static final int WSA_QOS_EPOLICYOBJ = 11025;
    static final int WSA_QOS_EFLOWDESC = 11026;
    static final int WSA_QOS_EPSFLOWSPEC = 11027;
    static final int WSA_QOS_EPSFILTERSPEC = 11028;
    static final int WSA_QOS_ESDMODEOBJ = 11029;
    static final int WSA_QOS_ESHAPERATEOBJ = 11030;
    static final int WSA_QOS_RESERVED_PETYPE = 11031;
    static final int ERROR_SXS_SECTION_NOT_FOUND = 14000;
    static final int ERROR_SXS_CANT_GEN_ACTCTX = 14001;
    static final int ERROR_SXS_INVALID_ACTCTXDATA_FORMAT = 14002;
    static final int ERROR_SXS_ASSEMBLY_NOT_FOUND = 14003;
    static final int ERROR_SXS_MANIFEST_FORMAT_ERROR = 14004;
    static final int ERROR_SXS_MANIFEST_PARSE_ERROR = 14005;
    static final int ERROR_SXS_ACTIVATION_CONTEXT_DISABLED = 14006;
    static final int ERROR_SXS_KEY_NOT_FOUND = 14007;
    static final int ERROR_SXS_VERSION_CONFLICT = 14008;
    static final int ERROR_SXS_WRONG_SECTION_TYPE = 14009;
    static final int ERROR_SXS_THREAD_QUERIES_DISABLED = 14010;
    static final int ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET = 14011;
    static final int ERROR_SXS_UNKNOWN_ENCODING_GROUP = 14012;
    static final int ERROR_SXS_UNKNOWN_ENCODING = 14013;
    static final int ERROR_SXS_INVALID_XML_NAMESPACE_URI = 14014;
    static final int ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14015;
    static final int ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14016;
    static final int ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE = 14017;
    static final int ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE = 14018;
    static final int ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE = 14019;
    static final int ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT = 14020;
    static final int ERROR_SXS_DUPLICATE_DLL_NAME = 14021;
    static final int ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME = 14022;
    static final int ERROR_SXS_DUPLICATE_CLSID = 14023;
    static final int ERROR_SXS_DUPLICATE_IID = 14024;
    static final int ERROR_SXS_DUPLICATE_TLBID = 14025;
    static final int ERROR_SXS_DUPLICATE_PROGID = 14026;
    static final int ERROR_SXS_DUPLICATE_ASSEMBLY_NAME = 14027;
    static final int ERROR_SXS_FILE_HASH_MISMATCH = 14028;
    static final int ERROR_SXS_POLICY_PARSE_ERROR = 14029;
    static final int ERROR_SXS_XML_E_MISSINGQUOTE = 14030;
    static final int ERROR_SXS_XML_E_COMMENTSYNTAX = 14031;
    static final int ERROR_SXS_XML_E_BADSTARTNAMECHAR = 14032;
    static final int ERROR_SXS_XML_E_BADNAMECHAR = 14033;
    static final int ERROR_SXS_XML_E_BADCHARINSTRING = 14034;
    static final int ERROR_SXS_XML_E_XMLDECLSYNTAX = 14035;
    static final int ERROR_SXS_XML_E_BADCHARDATA = 14036;
    static final int ERROR_SXS_XML_E_MISSINGWHITESPACE = 14037;
    static final int ERROR_SXS_XML_E_EXPECTINGTAGEND = 14038;
    static final int ERROR_SXS_XML_E_MISSINGSEMICOLON = 14039;
    static final int ERROR_SXS_XML_E_UNBALANCEDPAREN = 14040;
    static final int ERROR_SXS_XML_E_INTERNALERROR = 14041;
    static final int ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE = 14042;
    static final int ERROR_SXS_XML_E_INCOMPLETE_ENCODING = 14043;
    static final int ERROR_SXS_XML_E_MISSING_PAREN = 14044;
    static final int ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE = 14045;
    static final int ERROR_SXS_XML_E_MULTIPLE_COLONS = 14046;
    static final int ERROR_SXS_XML_E_INVALID_DECIMAL = 14047;
    static final int ERROR_SXS_XML_E_INVALID_HEXIDECIMAL = 14048;
    static final int ERROR_SXS_XML_E_INVALID_UNICODE = 14049;
    static final int ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK = 14050;
    static final int ERROR_SXS_XML_E_UNEXPECTEDENDTAG = 14051;
    static final int ERROR_SXS_XML_E_UNCLOSEDTAG = 14052;
    static final int ERROR_SXS_XML_E_DUPLICATEATTRIBUTE = 14053;
    static final int ERROR_SXS_XML_E_MULTIPLEROOTS = 14054;
    static final int ERROR_SXS_XML_E_INVALIDATROOTLEVEL = 14055;
    static final int ERROR_SXS_XML_E_BADXMLDECL = 14056;
    static final int ERROR_SXS_XML_E_MISSINGROOT = 14057;
    static final int ERROR_SXS_XML_E_UNEXPECTEDEOF = 14058;
    static final int ERROR_SXS_XML_E_BADPEREFINSUBSET = 14059;
    static final int ERROR_SXS_XML_E_UNCLOSEDSTARTTAG = 14060;
    static final int ERROR_SXS_XML_E_UNCLOSEDENDTAG = 14061;
    static final int ERROR_SXS_XML_E_UNCLOSEDSTRING = 14062;
    static final int ERROR_SXS_XML_E_UNCLOSEDCOMMENT = 14063;
    static final int ERROR_SXS_XML_E_UNCLOSEDDECL = 14064;
    static final int ERROR_SXS_XML_E_UNCLOSEDCDATA = 14065;
    static final int ERROR_SXS_XML_E_RESERVEDNAMESPACE = 14066;
    static final int ERROR_SXS_XML_E_INVALIDENCODING = 14067;
    static final int ERROR_SXS_XML_E_INVALIDSWITCH = 14068;
    static final int ERROR_SXS_XML_E_BADXMLCASE = 14069;
    static final int ERROR_SXS_XML_E_INVALID_STANDALONE = 14070;
    static final int ERROR_SXS_XML_E_UNEXPECTED_STANDALONE = 14071;
    static final int ERROR_SXS_XML_E_INVALID_VERSION = 14072;
    static final int ERROR_SXS_XML_E_MISSINGEQUALS = 14073;
    static final int ERROR_SXS_PROTECTION_RECOVERY_FAILED = 14074;
    static final int ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT = 14075;
    static final int ERROR_SXS_PROTECTION_CATALOG_NOT_VALID = 14076;
    static final int ERROR_SXS_UNTRANSLATABLE_HRESULT = 14077;
    static final int ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING = 14078;
    static final int ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE = 14079;
    static final int ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME = 14080;
    static final int ERROR_IPSEC_QM_POLICY_EXISTS = 13000;
    static final int ERROR_IPSEC_QM_POLICY_NOT_FOUND = 13001;
    static final int ERROR_IPSEC_QM_POLICY_IN_USE = 13002;
    static final int ERROR_IPSEC_MM_POLICY_EXISTS = 13003;
    static final int ERROR_IPSEC_MM_POLICY_NOT_FOUND = 13004;
    static final int ERROR_IPSEC_MM_POLICY_IN_USE = 13005;
    static final int ERROR_IPSEC_MM_FILTER_EXISTS = 13006;
    static final int ERROR_IPSEC_MM_FILTER_NOT_FOUND = 13007;
    static final int ERROR_IPSEC_TRANSPORT_FILTER_EXISTS = 13008;
    static final int ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND = 13009;
    static final int ERROR_IPSEC_MM_AUTH_EXISTS = 13010;
    static final int ERROR_IPSEC_MM_AUTH_NOT_FOUND = 13011;
    static final int ERROR_IPSEC_MM_AUTH_IN_USE = 13012;
    static final int ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND = 13013;
    static final int ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND = 13014;
    static final int ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND = 13015;
    static final int ERROR_IPSEC_TUNNEL_FILTER_EXISTS = 13016;
    static final int ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND = 13017;
    static final int ERROR_IPSEC_MM_FILTER_PENDING_DELETION = 13018;
    static final int ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION = 13019;
    static final int ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION = 13020;
    static final int ERROR_IPSEC_MM_POLICY_PENDING_DELETION = 13021;
    static final int ERROR_IPSEC_MM_AUTH_PENDING_DELETION = 13022;
    static final int ERROR_IPSEC_QM_POLICY_PENDING_DELETION = 13023;
    static final int WARNING_IPSEC_MM_POLICY_PRUNED = 13024;
    static final int WARNING_IPSEC_QM_POLICY_PRUNED = 13025;
    static final int ERROR_IPSEC_IKE_NEG_STATUS_BEGIN = 13800;
    static final int ERROR_IPSEC_IKE_AUTH_FAIL = 13801;
    static final int ERROR_IPSEC_IKE_ATTRIB_FAIL = 13802;
    static final int ERROR_IPSEC_IKE_NEGOTIATION_PENDING = 13803;
    static final int ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR = 13804;
    static final int ERROR_IPSEC_IKE_TIMED_OUT = 13805;
    static final int ERROR_IPSEC_IKE_NO_CERT = 13806;
    static final int ERROR_IPSEC_IKE_SA_DELETED = 13807;
    static final int ERROR_IPSEC_IKE_SA_REAPED = 13808;
    static final int ERROR_IPSEC_IKE_MM_ACQUIRE_DROP = 13809;
    static final int ERROR_IPSEC_IKE_QM_ACQUIRE_DROP = 13810;
    static final int ERROR_IPSEC_IKE_QUEUE_DROP_MM = 13811;
    static final int ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM = 13812;
    static final int ERROR_IPSEC_IKE_DROP_NO_RESPONSE = 13813;
    static final int ERROR_IPSEC_IKE_MM_DELAY_DROP = 13814;
    static final int ERROR_IPSEC_IKE_QM_DELAY_DROP = 13815;
    static final int ERROR_IPSEC_IKE_ERROR = 13816;
    static final int ERROR_IPSEC_IKE_CRL_FAILED = 13817;
    static final int ERROR_IPSEC_IKE_INVALID_KEY_USAGE = 13818;
    static final int ERROR_IPSEC_IKE_INVALID_CERT_TYPE = 13819;
    static final int ERROR_IPSEC_IKE_NO_PRIVATE_KEY = 13820;
    static final int ERROR_IPSEC_IKE_DH_FAIL = 13822;
    static final int ERROR_IPSEC_IKE_INVALID_HEADER = 13824;
    static final int ERROR_IPSEC_IKE_NO_POLICY = 13825;
    static final int ERROR_IPSEC_IKE_INVALID_SIGNATURE = 13826;
    static final int ERROR_IPSEC_IKE_KERBEROS_ERROR = 13827;
    static final int ERROR_IPSEC_IKE_NO_PUBLIC_KEY = 13828;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR = 13829;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_SA = 13830;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_PROP = 13831;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_TRANS = 13832;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_KE = 13833;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_ID = 13834;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_CERT = 13835;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ = 13836;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_HASH = 13837;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_SIG = 13838;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_NONCE = 13839;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY = 13840;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_DELETE = 13841;
    static final int ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR = 13842;
    static final int ERROR_IPSEC_IKE_INVALID_PAYLOAD = 13843;
    static final int ERROR_IPSEC_IKE_LOAD_SOFT_SA = 13844;
    static final int ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN = 13845;
    static final int ERROR_IPSEC_IKE_INVALID_COOKIE = 13846;
    static final int ERROR_IPSEC_IKE_NO_PEER_CERT = 13847;
    static final int ERROR_IPSEC_IKE_PEER_CRL_FAILED = 13848;
    static final int ERROR_IPSEC_IKE_POLICY_CHANGE = 13849;
    static final int ERROR_IPSEC_IKE_NO_MM_POLICY = 13850;
    static final int ERROR_IPSEC_IKE_NOTCBPRIV = 13851;
    static final int ERROR_IPSEC_IKE_SECLOADFAIL = 13852;
    static final int ERROR_IPSEC_IKE_FAILSSPINIT = 13853;
    static final int ERROR_IPSEC_IKE_FAILQUERYSSP = 13854;
    static final int ERROR_IPSEC_IKE_SRVACQFAIL = 13855;
    static final int ERROR_IPSEC_IKE_SRVQUERYCRED = 13856;
    static final int ERROR_IPSEC_IKE_GETSPIFAIL = 13857;
    static final int ERROR_IPSEC_IKE_INVALID_FILTER = 13858;
    static final int ERROR_IPSEC_IKE_OUT_OF_MEMORY = 13859;
    static final int ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED = 13860;
    static final int ERROR_IPSEC_IKE_INVALID_POLICY = 13861;
    static final int ERROR_IPSEC_IKE_UNKNOWN_DOI = 13862;
    static final int ERROR_IPSEC_IKE_INVALID_SITUATION = 13863;
    static final int ERROR_IPSEC_IKE_DH_FAILURE = 13864;
    static final int ERROR_IPSEC_IKE_INVALID_GROUP = 13865;
    static final int ERROR_IPSEC_IKE_ENCRYPT = 13866;
    static final int ERROR_IPSEC_IKE_DECRYPT = 13867;
    static final int ERROR_IPSEC_IKE_POLICY_MATCH = 13868;
    static final int ERROR_IPSEC_IKE_UNSUPPORTED_ID = 13869;
    static final int ERROR_IPSEC_IKE_INVALID_HASH = 13870;
    static final int ERROR_IPSEC_IKE_INVALID_HASH_ALG = 13871;
    static final int ERROR_IPSEC_IKE_INVALID_HASH_SIZE = 13872;
    static final int ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG = 13873;
    static final int ERROR_IPSEC_IKE_INVALID_AUTH_ALG = 13874;
    static final int ERROR_IPSEC_IKE_INVALID_SIG = 13875;
    static final int ERROR_IPSEC_IKE_LOAD_FAILED = 13876;
    static final int ERROR_IPSEC_IKE_RPC_DELETE = 13877;
    static final int ERROR_IPSEC_IKE_BENIGN_REINIT = 13878;
    static final int ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY = 13879;
    static final int ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN = 13881;
    static final int ERROR_IPSEC_IKE_MM_LIMIT = 13882;
    static final int ERROR_IPSEC_IKE_NEGOTIATION_DISABLED = 13883;
    static final int ERROR_IPSEC_IKE_NEG_STATUS_END = 13884;
    static final int SEVERITY_SUCCESS = 0;
    static final int SEVERITY_ERROR = 1;
    static final int FACILITY_NT_BIT = 0x10000000;
    static final int NOERROR = 0;
    static final int S_OK = (0x00000000);
    static final int S_FALSE = (0x00000001);
    static final int OLE_E_FIRST = (0x80040000);
    static final int OLE_E_LAST = (0x800400FF);
    static final int OLE_S_FIRST = (0x00040000);
    static final int OLE_S_LAST = (0x000400FF);
    static final int DRAGDROP_E_FIRST = 0x80040100;
    static final int DRAGDROP_E_LAST = 0x8004010F;
    static final int DRAGDROP_S_FIRST = 0x00040100;
    static final int DRAGDROP_S_LAST = 0x0004010F;
    static final int CLASSFACTORY_E_FIRST = 0x80040110;
    static final int CLASSFACTORY_E_LAST = 0x8004011F;
    static final int CLASSFACTORY_S_FIRST = 0x00040110;
    static final int CLASSFACTORY_S_LAST = 0x0004011F;
    static final int MARSHAL_E_FIRST = 0x80040120;
    static final int MARSHAL_E_LAST = 0x8004012F;
    static final int MARSHAL_S_FIRST = 0x00040120;
    static final int MARSHAL_S_LAST = 0x0004012F;
    static final int DATA_E_FIRST = 0x80040130;
    static final int DATA_E_LAST = 0x8004013F;
    static final int DATA_S_FIRST = 0x00040130;
    static final int DATA_S_LAST = 0x0004013F;
    static final int VIEW_E_FIRST = 0x80040140;
    static final int VIEW_E_LAST = 0x8004014F;
    static final int VIEW_S_FIRST = 0x00040140;
    static final int VIEW_S_LAST = 0x0004014F;
    static final int REGDB_E_FIRST = 0x80040150;
    static final int REGDB_E_LAST = 0x8004015F;
    static final int REGDB_S_FIRST = 0x00040150;
    static final int REGDB_S_LAST = 0x0004015F;
    static final int CAT_E_FIRST = 0x80040160;
    static final int CAT_E_LAST = 0x80040161;
    static final int CS_E_FIRST = 0x80040164;
    static final int CS_E_LAST = 0x8004016F;
    static final int CACHE_E_FIRST = 0x80040170;
    static final int CACHE_E_LAST = 0x8004017F;
    static final int CACHE_S_FIRST = 0x00040170;
    static final int CACHE_S_LAST = 0x0004017F;
    static final int OLEOBJ_E_FIRST = 0x80040180;
    static final int OLEOBJ_E_LAST = 0x8004018F;
    static final int OLEOBJ_S_FIRST = 0x00040180;
    static final int OLEOBJ_S_LAST = 0x0004018F;
    static final int CLIENTSITE_E_FIRST = 0x80040190;
    static final int CLIENTSITE_E_LAST = 0x8004019F;
    static final int CLIENTSITE_S_FIRST = 0x00040190;
    static final int CLIENTSITE_S_LAST = 0x0004019F;
    static final int INPLACE_E_FIRST = 0x800401A0;
    static final int INPLACE_E_LAST = 0x800401AF;
    static final int INPLACE_S_FIRST = 0x000401A0;
    static final int INPLACE_S_LAST = 0x000401AF;
    static final int ENUM_E_FIRST = 0x800401B0;
    static final int ENUM_E_LAST = 0x800401BF;
    static final int ENUM_S_FIRST = 0x000401B0;
    static final int ENUM_S_LAST = 0x000401BF;
    static final int CONVERT10_E_FIRST = 0x800401C0;
    static final int CONVERT10_E_LAST = 0x800401CF;
    static final int CONVERT10_S_FIRST = 0x000401C0;
    static final int CONVERT10_S_LAST = 0x000401CF;
    static final int CLIPBRD_E_FIRST = 0x800401D0;
    static final int CLIPBRD_E_LAST = 0x800401DF;
    static final int CLIPBRD_S_FIRST = 0x000401D0;
    static final int CLIPBRD_S_LAST = 0x000401DF;
    static final int MK_E_FIRST = 0x800401E0;
    static final int MK_E_LAST = 0x800401EF;
    static final int MK_S_FIRST = 0x000401E0;
    static final int MK_S_LAST = 0x000401EF;
    static final int CO_E_FIRST = 0x800401F0;
    static final int CO_E_LAST = 0x800401FF;
    static final int CO_S_FIRST = 0x000401F0;
    static final int CO_S_LAST = 0x000401FF;
    static final int EVENT_E_FIRST = 0x80040200;
    static final int EVENT_E_LAST = 0x8004021F;
    static final int EVENT_S_FIRST = 0x00040200;
    static final int EVENT_S_LAST = 0x0004021F;
    static final int XACT_E_FIRST = 0x8004D000;
    static final int XACT_E_LAST = 0x8004D029;
    static final int XACT_S_FIRST = 0x0004D000;
    static final int XACT_S_LAST = 0x0004D010;
    static final int CONTEXT_E_FIRST = 0x8004E000;
    static final int CONTEXT_E_LAST = 0x8004E02F;
    static final int CONTEXT_S_FIRST = 0x0004E000;
    static final int CONTEXT_S_LAST = 0x0004E02F;
    static final int NTE_OP_OK = 0;
    static final int SCARD_S_SUCCESS = NO_ERROR;
    static final int TC_NORMAL = 0;
    static final int TC_HARDERR = 1;
    static final int TC_GP_TRAP = 2;
    static final int TC_SIGNAL = 3;
    static final int AC_LINE_OFFLINE = 0x00;
    static final int AC_LINE_ONLINE = 0x01;
    static final int AC_LINE_BACKUP_POWER = 0x02;
    static final int AC_LINE_UNKNOWN = 0xFF;
    static final int BATTERY_FLAG_HIGH = 0x01;
    static final int BATTERY_FLAG_LOW = 0x02;
    static final int BATTERY_FLAG_CRITICAL = 0x04;
    static final int BATTERY_FLAG_CHARGING = 0x08;
    static final int BATTERY_FLAG_NO_BATTERY = 0x80;
    static final int BATTERY_FLAG_UNKNOWN = 0xFF;
    static final int BATTERY_PERCENTAGE_UNKNOWN = 0xFF;
    static final int BATTERY_LIFE_UNKNOWN = 0xFFFFFFFF;
    static final int ACTCTX_FLAG_PROCESSOR_ARCHITECTURE_VALID = (0x00000001);
    static final int ACTCTX_FLAG_LANGID_VALID = (0x00000002);
    static final int ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID = (0x00000004);
    static final int ACTCTX_FLAG_RESOURCE_NAME_VALID = (0x00000008);
    static final int ACTCTX_FLAG_SET_PROCESS_DEFAULT = (0x00000010);
    static final int ACTCTX_FLAG_APPLICATION_NAME_VALID = (0x00000020);
    static final int ACTCTX_FLAG_SOURCE_IS_ASSEMBLYREF = (0x00000040);
    static final int ACTCTX_FLAG_HMODULE_VALID = (0x00000080);
    static final int DEACTIVATE_ACTCTX_FLAG_FORCE_EARLY_DEACTIVATION = (0x00000001);
    static final int FIND_ACTCTX_SECTION_KEY_RETURN_HACTCTX = (0x00000001);
    static final int FIND_ACTCTX_SECTION_KEY_RETURN_FLAGS = (0x00000002);
    static final int FIND_ACTCTX_SECTION_KEY_RETURN_ASSEMBLY_METADATA = (0x00000004);
    static final int ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED = 1;
    static final int QUERY_ACTCTX_FLAG_USE_ACTIVE_ACTCTX = (0x00000004);
    static final int QUERY_ACTCTX_FLAG_ACTCTX_IS_HMODULE = (0x00000008);
    static final int QUERY_ACTCTX_FLAG_ACTCTX_IS_ADDRESS = (0x00000010);
    static final int QUERY_ACTCTX_FLAG_NO_ADDREF = (0x80000000);
    static final int R2_BLACK = 1;
    static final int R2_NOTMERGEPEN = 2;
    static final int R2_MASKNOTPEN = 3;
    static final int R2_NOTCOPYPEN = 4;
    static final int R2_MASKPENNOT = 5;
    static final int R2_NOT = 6;
    static final int R2_XORPEN = 7;
    static final int R2_NOTMASKPEN = 8;
    static final int R2_MASKPEN = 9;
    static final int R2_NOTXORPEN = 10;
    static final int R2_NOP = 11;
    static final int R2_MERGENOTPEN = 12;
    static final int R2_COPYPEN = 13;
    static final int R2_MERGEPENNOT = 14;
    static final int R2_MERGEPEN = 15;
    static final int R2_WHITE = 16;
    static final int R2_LAST = 16;
    static final int GDI_ERROR = (0xFFFFFFFF);
    static final int ERROR = 0;
    static final int NULLREGION = 1;
    static final int SIMPLEREGION = 2;
    static final int COMPLEXREGION = 3;
    static final int RGN_ERROR = ERROR;
    static final int RGN_AND = 1;
    static final int RGN_OR = 2;
    static final int RGN_XOR = 3;
    static final int RGN_DIFF = 4;
    static final int RGN_COPY = 5;
    static final int RGN_MIN = RGN_AND;
    static final int RGN_MAX = RGN_COPY;
    static final int BLACKONWHITE = 1;
    static final int WHITEONBLACK = 2;
    static final int COLORONCOLOR = 3;
    static final int HALFTONE = 4;
    static final int MAXSTRETCHBLTMODE = 4;
    static final int STRETCH_ANDSCANS = BLACKONWHITE;
    static final int STRETCH_ORSCANS = WHITEONBLACK;
    static final int STRETCH_DELETESCANS = COLORONCOLOR;
    static final int STRETCH_HALFTONE = HALFTONE;
    static final int ALTERNATE = 1;
    static final int WINDING = 2;
    static final int POLYFILL_LAST = 2;
    static final int LAYOUT_RTL = 0x00000001;
    static final int LAYOUT_BTT = 0x00000002;
    static final int LAYOUT_VBH = 0x00000004;
    static final int LAYOUT_ORIENTATIONMASK = (LAYOUT_RTL | LAYOUT_BTT | LAYOUT_VBH);
    static final int LAYOUT_BITMAPORIENTATIONPRESERVED = 0x00000008;
    static final int TA_NOUPDATECP = 0;
    static final int TA_UPDATECP = 1;
    static final int TA_LEFT = 0;
    static final int TA_RIGHT = 2;
    static final int TA_CENTER = 6;
    static final int TA_TOP = 0;
    static final int TA_BOTTOM = 8;
    static final int TA_BASELINE = 24;
    static final int TA_RTLREADING = 256;
    static final int TA_MASK = (TA_BASELINE+TA_CENTER+TA_UPDATECP+TA_RTLREADING);
    static final int VTA_BASELINE = TA_BASELINE;
    static final int VTA_LEFT = TA_BOTTOM;
    static final int VTA_RIGHT = TA_TOP;
    static final int VTA_CENTER = TA_CENTER;
    static final int VTA_BOTTOM = TA_RIGHT;
    static final int VTA_TOP = TA_LEFT;
    static final int ETO_OPAQUE = 0x0002;
    static final int ETO_CLIPPED = 0x0004;
    static final int ETO_GLYPH_INDEX = 0x0010;
    static final int ETO_RTLREADING = 0x0080;
    static final int ETO_NUMERICSLOCAL = 0x0400;
    static final int ETO_NUMERICSLATIN = 0x0800;
    static final int ETO_IGNORELANGUAGE = 0x1000;
    static final int ETO_PDY = 0x2000;
    static final int ASPECT_FILTERING = 0x0001;
    static final int DCB_RESET = 0x0001;
    static final int DCB_ACCUMULATE = 0x0002;
    static final int DCB_DIRTY = DCB_ACCUMULATE;
    static final int DCB_SET = (DCB_RESET | DCB_ACCUMULATE);
    static final int DCB_ENABLE = 0x0004;
    static final int DCB_DISABLE = 0x0008;
    static final int META_SETBKCOLOR = 0x0201;
    static final int META_SETBKMODE = 0x0102;
    static final int META_SETMAPMODE = 0x0103;
    static final int META_SETROP2 = 0x0104;
    static final int META_SETRELABS = 0x0105;
    static final int META_SETPOLYFILLMODE = 0x0106;
    static final int META_SETSTRETCHBLTMODE = 0x0107;
    static final int META_SETTEXTCHAREXTRA = 0x0108;
    static final int META_SETTEXTCOLOR = 0x0209;
    static final int META_SETTEXTJUSTIFICATION = 0x020A;
    static final int META_SETWINDOWORG = 0x020B;
    static final int META_SETWINDOWEXT = 0x020C;
    static final int META_SETVIEWPORTORG = 0x020D;
    static final int META_SETVIEWPORTEXT = 0x020E;
    static final int META_OFFSETWINDOWORG = 0x020F;
    static final int META_SCALEWINDOWEXT = 0x0410;
    static final int META_OFFSETVIEWPORTORG = 0x0211;
    static final int META_SCALEVIEWPORTEXT = 0x0412;
    static final int META_LINETO = 0x0213;
    static final int META_MOVETO = 0x0214;
    static final int META_EXCLUDECLIPRECT = 0x0415;
    static final int META_INTERSECTCLIPRECT = 0x0416;
    static final int META_ARC = 0x0817;
    static final int META_ELLIPSE = 0x0418;
    static final int META_FLOODFILL = 0x0419;
    static final int META_PIE = 0x081A;
    static final int META_RECTANGLE = 0x041B;
    static final int META_ROUNDRECT = 0x061C;
    static final int META_PATBLT = 0x061D;
    static final int META_SAVEDC = 0x001E;
    static final int META_SETPIXEL = 0x041F;
    static final int META_OFFSETCLIPRGN = 0x0220;
    static final int META_TEXTOUT = 0x0521;
    static final int META_BITBLT = 0x0922;
    static final int META_STRETCHBLT = 0x0B23;
    static final int META_POLYGON = 0x0324;
    static final int META_POLYLINE = 0x0325;
    static final int META_ESCAPE = 0x0626;
    static final int META_RESTOREDC = 0x0127;
    static final int META_FILLREGION = 0x0228;
    static final int META_FRAMEREGION = 0x0429;
    static final int META_INVERTREGION = 0x012A;
    static final int META_PAINTREGION = 0x012B;
    static final int META_SELECTCLIPREGION = 0x012C;
    static final int META_SELECTOBJECT = 0x012D;
    static final int META_SETTEXTALIGN = 0x012E;
    static final int META_CHORD = 0x0830;
    static final int META_SETMAPPERFLAGS = 0x0231;
    static final int META_EXTTEXTOUT = 0x0a32;
    static final int META_SETDIBTODEV = 0x0d33;
    static final int META_SELECTPALETTE = 0x0234;
    static final int META_REALIZEPALETTE = 0x0035;
    static final int META_ANIMATEPALETTE = 0x0436;
    static final int META_SETPALENTRIES = 0x0037;
    static final int META_POLYPOLYGON = 0x0538;
    static final int META_RESIZEPALETTE = 0x0139;
    static final int META_DIBBITBLT = 0x0940;
    static final int META_DIBSTRETCHBLT = 0x0b41;
    static final int META_DIBCREATEPATTERNBRUSH = 0x0142;
    static final int META_STRETCHDIB = 0x0f43;
    static final int META_EXTFLOODFILL = 0x0548;
    static final int META_SETLAYOUT = 0x0149;
    static final int META_DELETEOBJECT = 0x01f0;
    static final int META_CREATEPALETTE = 0x00f7;
    static final int META_CREATEPATTERNBRUSH = 0x01F9;
    static final int META_CREATEPENINDIRECT = 0x02FA;
    static final int META_CREATEFONTINDIRECT = 0x02FB;
    static final int META_CREATEBRUSHINDIRECT = 0x02FC;
    static final int META_CREATEREGION = 0x06FF;
    static final int NEWFRAME = 1;
    static final int ABORTDOC = 2;
    static final int NEXTBAND = 3;
    static final int SETCOLORTABLE = 4;
    static final int GETCOLORTABLE = 5;
    static final int FLUSHOUTPUT = 6;
    static final int DRAFTMODE = 7;
    static final int QUERYESCSUPPORT = 8;
    static final int SETABORTPROC = 9;
    static final int STARTDOC = 10;
    static final int ENDDOC = 11;
    static final int GETPHYSPAGESIZE = 12;
    static final int GETPRINTINGOFFSET = 13;
    static final int GETSCALINGFACTOR = 14;
    static final int MFCOMMENT = 15;
    static final int GETPENWIDTH = 16;
    static final int SETCOPYCOUNT = 17;
    static final int SELECTPAPERSOURCE = 18;
    static final int DEVICEDATA = 19;
    static final int PASSTHROUGH = 19;
    static final int GETTECHNOLGY = 20;
    static final int GETTECHNOLOGY = 20;
    static final int SETLINECAP = 21;
    static final int SETLINEJOIN = 22;
    static final int SETMITERLIMIT = 23;
    static final int BANDINFO = 24;
    static final int DRAWPATTERNRECT = 25;
    static final int GETVECTORPENSIZE = 26;
    static final int GETVECTORBRUSHSIZE = 27;
    static final int ENABLEDUPLEX = 28;
    static final int GETSETPAPERBINS = 29;
    static final int GETSETPRINTORIENT = 30;
    static final int ENUMPAPERBINS = 31;
    static final int SETDIBSCALING = 32;
    static final int EPSPRINTING = 33;
    static final int ENUMPAPERMETRICS = 34;
    static final int GETSETPAPERMETRICS = 35;
    static final int POSTSCRIPT_DATA = 37;
    static final int POSTSCRIPT_IGNORE = 38;
    static final int MOUSETRAILS = 39;
    static final int GETDEVICEUNITS = 42;
    static final int GETEXTENDEDTEXTMETRICS = 256;
    static final int GETEXTENTTABLE = 257;
    static final int GETPAIRKERNTABLE = 258;
    static final int GETTRACKKERNTABLE = 259;
    static final int EXTTEXTOUT = 512;
    static final int GETFACENAME = 513;
    static final int DOWNLOADFACE = 514;
    static final int ENABLERELATIVEWIDTHS = 768;
    static final int ENABLEPAIRKERNING = 769;
    static final int SETKERNTRACK = 770;
    static final int SETALLJUSTVALUES = 771;
    static final int SETCHARSET = 772;
    static final int STRETCHBLT = 2048;
    static final int METAFILE_DRIVER = 2049;
    static final int GETSETSCREENPARAMS = 3072;
    static final int QUERYDIBSUPPORT = 3073;
    static final int BEGIN_PATH = 4096;
    static final int CLIP_TO_PATH = 4097;
    static final int END_PATH = 4098;
    static final int EXT_DEVICE_CAPS = 4099;
    static final int RESTORE_CTM = 4100;
    static final int SAVE_CTM = 4101;
    static final int SET_ARC_DIRECTION = 4102;
    static final int SET_BACKGROUND_COLOR = 4103;
    static final int SET_POLY_MODE = 4104;
    static final int SET_SCREEN_ANGLE = 4105;
    static final int SET_SPREAD = 4106;
    static final int TRANSFORM_CTM = 4107;
    static final int SET_CLIP_BOX = 4108;
    static final int SET_BOUNDS = 4109;
    static final int SET_MIRROR_MODE = 4110;
    static final int OPENCHANNEL = 4110;
    static final int DOWNLOADHEADER = 4111;
    static final int CLOSECHANNEL = 4112;
    static final int POSTSCRIPT_PASSTHROUGH = 4115;
    static final int ENCAPSULATED_POSTSCRIPT = 4116;
    static final int POSTSCRIPT_IDENTIFY = 4117;
    static final int POSTSCRIPT_INJECTION = 4118;
    static final int CHECKJPEGFORMAT = 4119;
    static final int CHECKPNGFORMAT = 4120;
    static final int GET_PS_FEATURESETTING = 4121;
    static final int SPCLPASSTHROUGH2 = 4568;
    static final int PSIDENT_GDICENTRIC = 0;
    static final int PSIDENT_PSCENTRIC = 1;
    static final int PSINJECT_BEGINSTREAM = 1;
    static final int PSINJECT_PSADOBE = 2;
    static final int PSINJECT_PAGESATEND = 3;
    static final int PSINJECT_PAGES = 4;
    static final int PSINJECT_DOCNEEDEDRES = 5;
    static final int PSINJECT_DOCSUPPLIEDRES = 6;
    static final int PSINJECT_PAGEORDER = 7;
    static final int PSINJECT_ORIENTATION = 8;
    static final int PSINJECT_BOUNDINGBOX = 9;
    static final int PSINJECT_DOCUMENTPROCESSCOLORS = 10;
    static final int PSINJECT_COMMENTS = 11;
    static final int PSINJECT_BEGINDEFAULTS = 12;
    static final int PSINJECT_ENDDEFAULTS = 13;
    static final int PSINJECT_BEGINPROLOG = 14;
    static final int PSINJECT_ENDPROLOG = 15;
    static final int PSINJECT_BEGINSETUP = 16;
    static final int PSINJECT_ENDSETUP = 17;
    static final int PSINJECT_TRAILER = 18;
    static final int PSINJECT_EOF = 19;
    static final int PSINJECT_ENDSTREAM = 20;
    static final int PSINJECT_DOCUMENTPROCESSCOLORSATEND = 21;
    static final int PSINJECT_PAGENUMBER = 100;
    static final int PSINJECT_BEGINPAGESETUP = 101;
    static final int PSINJECT_ENDPAGESETUP = 102;
    static final int PSINJECT_PAGETRAILER = 103;
    static final int PSINJECT_PLATECOLOR = 104;
    static final int PSINJECT_SHOWPAGE = 105;
    static final int PSINJECT_PAGEBBOX = 106;
    static final int PSINJECT_ENDPAGECOMMENTS = 107;
    static final int PSINJECT_VMSAVE = 200;
    static final int PSINJECT_VMRESTORE = 201;
    static final int FEATURESETTING_NUP = 0;
    static final int FEATURESETTING_OUTPUT = 1;
    static final int FEATURESETTING_PSLEVEL = 2;
    static final int FEATURESETTING_CUSTPAPER = 3;
    static final int FEATURESETTING_MIRROR = 4;
    static final int FEATURESETTING_NEGATIVE = 5;
    static final int FEATURESETTING_PROTOCOL = 6;
    static final int FEATURESETTING_PRIVATE_BEGIN = 0x1000;
    static final int FEATURESETTING_PRIVATE_END = 0x1FFF;
    static final int PSPROTOCOL_ASCII = 0;
    static final int PSPROTOCOL_BCP = 1;
    static final int PSPROTOCOL_TBCP = 2;
    static final int PSPROTOCOL_BINARY = 3;
    static final int QDI_SETDIBITS = 1;
    static final int QDI_GETDIBITS = 2;
    static final int QDI_DIBTOSCREEN = 4;
    static final int QDI_STRETCHDIB = 8;
    static final int SP_NOTREPORTED = 0x4000;
    static final int SP_ERROR = (-1);
    static final int SP_APPABORT = (-2);
    static final int SP_USERABORT = (-3);
    static final int SP_OUTOFDISK = (-4);
    static final int SP_OUTOFMEMORY = (-5);
    static final int PR_JOBSTATUS = 0x0000;
    static final int OBJ_PEN = 1;
    static final int OBJ_BRUSH = 2;
    static final int OBJ_DC = 3;
    static final int OBJ_METADC = 4;
    static final int OBJ_PAL = 5;
    static final int OBJ_FONT = 6;
    static final int OBJ_BITMAP = 7;
    static final int OBJ_REGION = 8;
    static final int OBJ_METAFILE = 9;
    static final int OBJ_MEMDC = 10;
    static final int OBJ_EXTPEN = 11;
    static final int OBJ_ENHMETADC = 12;
    static final int OBJ_ENHMETAFILE = 13;
    static final int OBJ_COLORSPACE = 14;
    static final int MWT_IDENTITY = 1;
    static final int MWT_LEFTMULTIPLY = 2;
    static final int MWT_RIGHTMULTIPLY = 3;
    static final int MWT_MIN = MWT_IDENTITY;
    static final int MWT_MAX = MWT_RIGHTMULTIPLY;
    static final int CS_ENABLE = 0x00000001;
    static final int CS_DISABLE = 0x00000002;
    static final int CS_DELETE_TRANSFORM = 0x00000003;
    static final int LCS_CALIBRATED_RGB = 0x00000000;
    static final int LCS_GM_BUSINESS = 0x00000001;
    static final int LCS_GM_GRAPHICS = 0x00000002;
    static final int LCS_GM_IMAGES = 0x00000004;
    static final int LCS_GM_ABS_COLORIMETRIC = 0x00000008;
    static final int CM_OUT_OF_GAMUT = 255;
    static final int CM_IN_GAMUT = 0;
    static final int ICM_ADDPROFILE = 1;
    static final int ICM_DELETEPROFILE = 2;
    static final int ICM_QUERYPROFILE = 3;
    static final int ICM_SETDEFAULTPROFILE = 4;
    static final int ICM_REGISTERICMATCHER = 5;
    static final int ICM_UNREGISTERICMATCHER = 6;
    static final int ICM_QUERYMATCH = 7;
    static final int BI_RGB = 0;
    static final int BI_RLE8 = 1;
    static final int BI_RLE4 = 2;
    static final int BI_BITFIELDS = 3;
    static final int BI_JPEG = 4;
    static final int BI_PNG = 5;
    static final int TCI_SRCCHARSET = 1;
    static final int TCI_SRCCODEPAGE = 2;
    static final int TCI_SRCFONTSIG = 3;
    static final int TCI_SRCLOCALE = 0x1000;
    static final int TMPF_FIXED_PITCH = 0x01;
    static final int TMPF_VECTOR = 0x02;
    static final int TMPF_DEVICE = 0x08;
    static final int TMPF_TRUETYPE = 0x04;
    static final int NTM_REGULAR = 0x00000040;
    static final int NTM_BOLD = 0x00000020;
    static final int NTM_ITALIC = 0x00000001;
    static final int NTM_NONNEGATIVE_AC = 0x00010000;
    static final int NTM_PS_OPENTYPE = 0x00020000;
    static final int NTM_TT_OPENTYPE = 0x00040000;
    static final int NTM_MULTIPLEMASTER = 0x00080000;
    static final int NTM_TYPE1 = 0x00100000;
    static final int NTM_DSIG = 0x00200000;
    static final int LF_FACESIZE = 32;
    static final int LF_FULLFACESIZE = 64;
    static final int OUT_DEFAULT_PRECIS = 0;
    static final int OUT_STRING_PRECIS = 1;
    static final int OUT_CHARACTER_PRECIS = 2;
    static final int OUT_STROKE_PRECIS = 3;
    static final int OUT_TT_PRECIS = 4;
    static final int OUT_DEVICE_PRECIS = 5;
    static final int OUT_RASTER_PRECIS = 6;
    static final int OUT_TT_ONLY_PRECIS = 7;
    static final int OUT_OUTLINE_PRECIS = 8;
    static final int OUT_SCREEN_OUTLINE_PRECIS = 9;
    static final int OUT_PS_ONLY_PRECIS = 10;
    static final int CLIP_DEFAULT_PRECIS = 0;
    static final int CLIP_CHARACTER_PRECIS = 1;
    static final int CLIP_STROKE_PRECIS = 2;
    static final int CLIP_MASK = 0xf;
    static final int CLIP_LH_ANGLES = (1<<4);
    static final int CLIP_TT_ALWAYS = (2<<4);
    static final int CLIP_EMBEDDED = (8<<4);
    static final int DEFAULT_QUALITY = 0;
    static final int DRAFT_QUALITY = 1;
    static final int PROOF_QUALITY = 2;
    static final int NONANTIALIASED_QUALITY = 3;
    static final int ANTIALIASED_QUALITY = 4;
    static final int CLEARTYPE_QUALITY = 5;
    static final int DEFAULT_PITCH = 0;
    static final int FIXED_PITCH = 1;
    static final int VARIABLE_PITCH = 2;
    static final int MONO_FONT = 8;
    static final int ANSI_CHARSET = 0;
    static final int DEFAULT_CHARSET = 1;
    static final int SYMBOL_CHARSET = 2;
    static final int SHIFTJIS_CHARSET = 128;
    static final int HANGEUL_CHARSET = 129;
    static final int HANGUL_CHARSET = 129;
    static final int GB2312_CHARSET = 134;
    static final int CHINESEBIG5_CHARSET = 136;
    static final int OEM_CHARSET = 255;
    static final int JOHAB_CHARSET = 130;
    static final int HEBREW_CHARSET = 177;
    static final int ARABIC_CHARSET = 178;
    static final int GREEK_CHARSET = 161;
    static final int TURKISH_CHARSET = 162;
    static final int VIETNAMESE_CHARSET = 163;
    static final int THAI_CHARSET = 222;
    static final int EASTEUROPE_CHARSET = 238;
    static final int RUSSIAN_CHARSET = 204;
    static final int MAC_CHARSET = 77;
    static final int BALTIC_CHARSET = 186;
    static final int FS_LATIN1 = 0x00000001;
    static final int FS_LATIN2 = 0x00000002;
    static final int FS_CYRILLIC = 0x00000004;
    static final int FS_GREEK = 0x00000008;
    static final int FS_TURKISH = 0x00000010;
    static final int FS_HEBREW = 0x00000020;
    static final int FS_ARABIC = 0x00000040;
    static final int FS_BALTIC = 0x00000080;
    static final int FS_VIETNAMESE = 0x00000100;
    static final int FS_THAI = 0x00010000;
    static final int FS_JISJAPAN = 0x00020000;
    static final int FS_CHINESESIMP = 0x00040000;
    static final int FS_WANSUNG = 0x00080000;
    static final int FS_CHINESETRAD = 0x00100000;
    static final int FS_JOHAB = 0x00200000;
    static final int FS_SYMBOL = 0x80000000;
    static final int FF_DONTCARE = (0<<4);
    static final int FF_ROMAN = (1<<4);
    static final int FF_SWISS = (2<<4);
    static final int FF_MODERN = (3<<4);
    static final int FF_SCRIPT = (4<<4);
    static final int FF_DECORATIVE = (5<<4);
    static final int FW_DONTCARE = 0;
    static final int FW_THIN = 100;
    static final int FW_EXTRALIGHT = 200;
    static final int FW_LIGHT = 300;
    static final int FW_NORMAL = 400;
    static final int FW_MEDIUM = 500;
    static final int FW_SEMIBOLD = 600;
    static final int FW_BOLD = 700;
    static final int FW_EXTRABOLD = 800;
    static final int FW_HEAVY = 900;
    static final int FW_ULTRALIGHT = FW_EXTRALIGHT;
    static final int FW_REGULAR = FW_NORMAL;
    static final int FW_DEMIBOLD = FW_SEMIBOLD;
    static final int FW_ULTRABOLD = FW_EXTRABOLD;
    static final int FW_BLACK = FW_HEAVY;
    static final int PANOSE_COUNT = 10;
    static final int PAN_FAMILYTYPE_INDEX = 0;
    static final int PAN_SERIFSTYLE_INDEX = 1;
    static final int PAN_WEIGHT_INDEX = 2;
    static final int PAN_PROPORTION_INDEX = 3;
    static final int PAN_CONTRAST_INDEX = 4;
    static final int PAN_STROKEVARIATION_INDEX = 5;
    static final int PAN_ARMSTYLE_INDEX = 6;
    static final int PAN_LETTERFORM_INDEX = 7;
    static final int PAN_MIDLINE_INDEX = 8;
    static final int PAN_XHEIGHT_INDEX = 9;
    static final int PAN_CULTURE_LATIN = 0;
    static final int PAN_ANY = 0;
    static final int PAN_NO_FIT = 1;
    static final int PAN_FAMILY_TEXT_DISPLAY = 2;
    static final int PAN_FAMILY_SCRIPT = 3;
    static final int PAN_FAMILY_DECORATIVE = 4;
    static final int PAN_FAMILY_PICTORIAL = 5;
    static final int PAN_SERIF_COVE = 2;
    static final int PAN_SERIF_OBTUSE_COVE = 3;
    static final int PAN_SERIF_SQUARE_COVE = 4;
    static final int PAN_SERIF_OBTUSE_SQUARE_COVE = 5;
    static final int PAN_SERIF_SQUARE = 6;
    static final int PAN_SERIF_THIN = 7;
    static final int PAN_SERIF_BONE = 8;
    static final int PAN_SERIF_EXAGGERATED = 9;
    static final int PAN_SERIF_TRIANGLE = 10;
    static final int PAN_SERIF_NORMAL_SANS = 11;
    static final int PAN_SERIF_OBTUSE_SANS = 12;
    static final int PAN_SERIF_PERP_SANS = 13;
    static final int PAN_SERIF_FLARED = 14;
    static final int PAN_SERIF_ROUNDED = 15;
    static final int PAN_WEIGHT_VERY_LIGHT = 2;
    static final int PAN_WEIGHT_LIGHT = 3;
    static final int PAN_WEIGHT_THIN = 4;
    static final int PAN_WEIGHT_BOOK = 5;
    static final int PAN_WEIGHT_MEDIUM = 6;
    static final int PAN_WEIGHT_DEMI = 7;
    static final int PAN_WEIGHT_BOLD = 8;
    static final int PAN_WEIGHT_HEAVY = 9;
    static final int PAN_WEIGHT_BLACK = 10;
    static final int PAN_WEIGHT_NORD = 11;
    static final int PAN_PROP_OLD_STYLE = 2;
    static final int PAN_PROP_MODERN = 3;
    static final int PAN_PROP_EVEN_WIDTH = 4;
    static final int PAN_PROP_EXPANDED = 5;
    static final int PAN_PROP_CONDENSED = 6;
    static final int PAN_PROP_VERY_EXPANDED = 7;
    static final int PAN_PROP_VERY_CONDENSED = 8;
    static final int PAN_PROP_MONOSPACED = 9;
    static final int PAN_CONTRAST_NONE = 2;
    static final int PAN_CONTRAST_VERY_LOW = 3;
    static final int PAN_CONTRAST_LOW = 4;
    static final int PAN_CONTRAST_MEDIUM_LOW = 5;
    static final int PAN_CONTRAST_MEDIUM = 6;
    static final int PAN_CONTRAST_MEDIUM_HIGH = 7;
    static final int PAN_CONTRAST_HIGH = 8;
    static final int PAN_CONTRAST_VERY_HIGH = 9;
    static final int PAN_STROKE_GRADUAL_DIAG = 2;
    static final int PAN_STROKE_GRADUAL_TRAN = 3;
    static final int PAN_STROKE_GRADUAL_VERT = 4;
    static final int PAN_STROKE_GRADUAL_HORZ = 5;
    static final int PAN_STROKE_RAPID_VERT = 6;
    static final int PAN_STROKE_RAPID_HORZ = 7;
    static final int PAN_STROKE_INSTANT_VERT = 8;
    static final int PAN_STRAIGHT_ARMS_HORZ = 2;
    static final int PAN_STRAIGHT_ARMS_WEDGE = 3;
    static final int PAN_STRAIGHT_ARMS_VERT = 4;
    static final int PAN_STRAIGHT_ARMS_SINGLE_SERIF = 5;
    static final int PAN_STRAIGHT_ARMS_DOUBLE_SERIF = 6;
    static final int PAN_BENT_ARMS_HORZ = 7;
    static final int PAN_BENT_ARMS_WEDGE = 8;
    static final int PAN_BENT_ARMS_VERT = 9;
    static final int PAN_BENT_ARMS_SINGLE_SERIF = 10;
    static final int PAN_BENT_ARMS_DOUBLE_SERIF = 11;
    static final int PAN_LETT_NORMAL_CONTACT = 2;
    static final int PAN_LETT_NORMAL_WEIGHTED = 3;
    static final int PAN_LETT_NORMAL_BOXED = 4;
    static final int PAN_LETT_NORMAL_FLATTENED = 5;
    static final int PAN_LETT_NORMAL_ROUNDED = 6;
    static final int PAN_LETT_NORMAL_OFF_CENTER = 7;
    static final int PAN_LETT_NORMAL_SQUARE = 8;
    static final int PAN_LETT_OBLIQUE_CONTACT = 9;
    static final int PAN_LETT_OBLIQUE_WEIGHTED = 10;
    static final int PAN_LETT_OBLIQUE_BOXED = 11;
    static final int PAN_LETT_OBLIQUE_FLATTENED = 12;
    static final int PAN_LETT_OBLIQUE_ROUNDED = 13;
    static final int PAN_LETT_OBLIQUE_OFF_CENTER = 14;
    static final int PAN_LETT_OBLIQUE_SQUARE = 15;
    static final int PAN_MIDLINE_STANDARD_TRIMMED = 2;
    static final int PAN_MIDLINE_STANDARD_POINTED = 3;
    static final int PAN_MIDLINE_STANDARD_SERIFED = 4;
    static final int PAN_MIDLINE_HIGH_TRIMMED = 5;
    static final int PAN_MIDLINE_HIGH_POINTED = 6;
    static final int PAN_MIDLINE_HIGH_SERIFED = 7;
    static final int PAN_MIDLINE_CONSTANT_TRIMMED = 8;
    static final int PAN_MIDLINE_CONSTANT_POINTED = 9;
    static final int PAN_MIDLINE_CONSTANT_SERIFED = 10;
    static final int PAN_MIDLINE_LOW_TRIMMED = 11;
    static final int PAN_MIDLINE_LOW_POINTED = 12;
    static final int PAN_MIDLINE_LOW_SERIFED = 13;
    static final int PAN_XHEIGHT_CONSTANT_SMALL = 2;
    static final int PAN_XHEIGHT_CONSTANT_STD = 3;
    static final int PAN_XHEIGHT_CONSTANT_LARGE = 4;
    static final int PAN_XHEIGHT_DUCKING_SMALL = 5;
    static final int PAN_XHEIGHT_DUCKING_STD = 6;
    static final int PAN_XHEIGHT_DUCKING_LARGE = 7;
    static final int ELF_VENDOR_SIZE = 4;
    static final int ELF_VERSION = 0;
    static final int ELF_CULTURE_LATIN = 0;
    static final int RASTER_FONTTYPE = 0x0001;
    static final int DEVICE_FONTTYPE = 0x002;
    static final int TRUETYPE_FONTTYPE = 0x004;
    static final int PC_RESERVED = 0x01;
    static final int PC_EXPLICIT = 0x02;
    static final int PC_NOCOLLAPSE = 0x04;
    static final int TRANSPARENT = 1;
    static final int OPAQUE = 2;
    static final int BKMODE_LAST = 2;
    static final int GM_COMPATIBLE = 1;
    static final int GM_ADVANCED = 2;
    static final int GM_LAST = 2;
    static final int PT_CLOSEFIGURE = 0x01;
    static final int PT_LINETO = 0x02;
    static final int PT_BEZIERTO = 0x04;
    static final int PT_MOVETO = 0x06;
    static final int MM_TEXT = 1;
    static final int MM_LOMETRIC = 2;
    static final int MM_HIMETRIC = 3;
    static final int MM_LOENGLISH = 4;
    static final int MM_HIENGLISH = 5;
    static final int MM_TWIPS = 6;
    static final int MM_ISOTROPIC = 7;
    static final int MM_ANISOTROPIC = 8;
    static final int MM_MIN = MM_TEXT;
    static final int MM_MAX = MM_ANISOTROPIC;
    static final int MM_MAX_FIXEDSCALE = MM_TWIPS;
    static final int ABSOLUTE = 1;
    static final int RELATIVE = 2;
    static final int WHITE_BRUSH = 0;
    static final int LTGRAY_BRUSH = 1;
    static final int GRAY_BRUSH = 2;
    static final int DKGRAY_BRUSH = 3;
    static final int BLACK_BRUSH = 4;
    static final int NULL_BRUSH = 5;
    static final int HOLLOW_BRUSH = NULL_BRUSH;
    static final int WHITE_PEN = 6;
    static final int BLACK_PEN = 7;
    static final int NULL_PEN = 8;
    static final int OEM_FIXED_FONT = 10;
    static final int ANSI_FIXED_FONT = 11;
    static final int ANSI_VAR_FONT = 12;
    static final int SYSTEM_FONT = 13;
    static final int DEVICE_DEFAULT_FONT = 14;
    static final int DEFAULT_PALETTE = 15;
    static final int SYSTEM_FIXED_FONT = 16;
    static final int DEFAULT_GUI_FONT = 17;
    static final int DC_BRUSH = 18;
    static final int DC_PEN = 19;
    static final int STOCK_LAST = 19;
    static final int CLR_INVALID = 0xFFFFFFFF;
    static final int BS_SOLID = 0;
    static final int BS_NULL = 1;
    static final int BS_HOLLOW = BS_NULL;
    static final int BS_HATCHED = 2;
    static final int BS_PATTERN = 3;
    static final int BS_INDEXED = 4;
    static final int BS_DIBPATTERN = 5;
    static final int BS_DIBPATTERNPT = 6;
    static final int BS_PATTERN8X8 = 7;
    static final int BS_DIBPATTERN8X8 = 8;
    static final int BS_MONOPATTERN = 9;
    static final int HS_HORIZONTAL = 0;
    static final int HS_VERTICAL = 1;
    static final int HS_FDIAGONAL = 2;
    static final int HS_BDIAGONAL = 3;
    static final int HS_CROSS = 4;
    static final int HS_DIAGCROSS = 5;
    static final int PS_SOLID = 0;
    static final int PS_DASH = 1;
    static final int PS_DOT = 2;
    static final int PS_DASHDOT = 3;
    static final int PS_DASHDOTDOT = 4;
    static final int PS_NULL = 5;
    static final int PS_INSIDEFRAME = 6;
    static final int PS_USERSTYLE = 7;
    static final int PS_ALTERNATE = 8;
    static final int PS_STYLE_MASK = 0x0000000F;
    static final int PS_ENDCAP_ROUND = 0x00000000;
    static final int PS_ENDCAP_SQUARE = 0x00000100;
    static final int PS_ENDCAP_FLAT = 0x00000200;
    static final int PS_ENDCAP_MASK = 0x00000F00;
    static final int PS_JOIN_ROUND = 0x00000000;
    static final int PS_JOIN_BEVEL = 0x00001000;
    static final int PS_JOIN_MITER = 0x00002000;
    static final int PS_JOIN_MASK = 0x0000F000;
    static final int PS_COSMETIC = 0x00000000;
    static final int PS_GEOMETRIC = 0x00010000;
    static final int PS_TYPE_MASK = 0x000F0000;
    static final int AD_COUNTERCLOCKWISE = 1;
    static final int AD_CLOCKWISE = 2;
    static final int DRIVERVERSION = 0;
    static final int TECHNOLOGY = 2;
    static final int HORZSIZE = 4;
    static final int VERTSIZE = 6;
    static final int HORZRES = 8;
    static final int VERTRES = 10;
    static final int BITSPIXEL = 12;
    static final int PLANES = 14;
    static final int NUMBRUSHES = 16;
    static final int NUMPENS = 18;
    static final int NUMMARKERS = 20;
    static final int NUMFONTS = 22;
    static final int NUMCOLORS = 24;
    static final int PDEVICESIZE = 26;
    static final int CURVECAPS = 28;
    static final int LINECAPS = 30;
    static final int POLYGONALCAPS = 32;
    static final int TEXTCAPS = 34;
    static final int CLIPCAPS = 36;
    static final int RASTERCAPS = 38;
    static final int ASPECTX = 40;
    static final int ASPECTY = 42;
    static final int ASPECTXY = 44;
    static final int LOGPIXELSX = 88;
    static final int LOGPIXELSY = 90;
    static final int SIZEPALETTE = 104;
    static final int NUMRESERVED = 106;
    static final int COLORRES = 108;
    static final int PHYSICALWIDTH = 110;
    static final int PHYSICALHEIGHT = 111;
    static final int PHYSICALOFFSETX = 112;
    static final int PHYSICALOFFSETY = 113;
    static final int SCALINGFACTORX = 114;
    static final int SCALINGFACTORY = 115;
    static final int VREFRESH = 116;
    static final int DESKTOPVERTRES = 117;
    static final int DESKTOPHORZRES = 118;
    static final int BLTALIGNMENT = 119;
    static final int SHADEBLENDCAPS = 120;
    static final int COLORMGMTCAPS = 121;
    static final int DT_PLOTTER = 0;
    static final int DT_RASDISPLAY = 1;
    static final int DT_RASPRINTER = 2;
    static final int DT_RASCAMERA = 3;
    static final int DT_CHARSTREAM = 4;
    static final int DT_METAFILE = 5;
    static final int DT_DISPFILE = 6;
    static final int CC_NONE = 0;
    static final int CC_CIRCLES = 1;
    static final int CC_PIE = 2;
    static final int CC_CHORD = 4;
    static final int CC_ELLIPSES = 8;
    static final int CC_WIDE = 16;
    static final int CC_STYLED = 32;
    static final int CC_WIDESTYLED = 64;
    static final int CC_INTERIORS = 128;
    static final int CC_ROUNDRECT = 256;
    static final int LC_NONE = 0;
    static final int LC_POLYLINE = 2;
    static final int LC_MARKER = 4;
    static final int LC_POLYMARKER = 8;
    static final int LC_WIDE = 16;
    static final int LC_STYLED = 32;
    static final int LC_WIDESTYLED = 64;
    static final int LC_INTERIORS = 128;
    static final int PC_NONE = 0;
    static final int PC_POLYGON = 1;
    static final int PC_RECTANGLE = 2;
    static final int PC_WINDPOLYGON = 4;
    static final int PC_TRAPEZOID = 4;
    static final int PC_SCANLINE = 8;
    static final int PC_WIDE = 16;
    static final int PC_STYLED = 32;
    static final int PC_WIDESTYLED = 64;
    static final int PC_INTERIORS = 128;
    static final int PC_POLYPOLYGON = 256;
    static final int PC_PATHS = 512;
    static final int CP_NONE = 0;
    static final int CP_RECTANGLE = 1;
    static final int CP_REGION = 2;
    static final int TC_OP_CHARACTER = 0x00000001;
    static final int TC_OP_STROKE = 0x00000002;
    static final int TC_CP_STROKE = 0x00000004;
    static final int TC_CR_90 = 0x00000008;
    static final int TC_CR_ANY = 0x00000010;
    static final int TC_SF_X_YINDEP = 0x00000020;
    static final int TC_SA_DOUBLE = 0x00000040;
    static final int TC_SA_INTEGER = 0x00000080;
    static final int TC_SA_CONTIN = 0x00000100;
    static final int TC_EA_DOUBLE = 0x00000200;
    static final int TC_IA_ABLE = 0x00000400;
    static final int TC_UA_ABLE = 0x00000800;
    static final int TC_SO_ABLE = 0x00001000;
    static final int TC_RA_ABLE = 0x00002000;
    static final int TC_VA_ABLE = 0x00004000;
    static final int TC_RESERVED = 0x00008000;
    static final int TC_SCROLLBLT = 0x00010000;
    static final int RC_BITBLT = 1;
    static final int RC_BANDING = 2;
    static final int RC_SCALING = 4;
    static final int RC_BITMAP64 = 8;
    static final int RC_GDI20_OUTPUT = 0x0010;
    static final int RC_GDI20_STATE = 0x0020;
    static final int RC_SAVEBITMAP = 0x0040;
    static final int RC_DI_BITMAP = 0x0080;
    static final int RC_PALETTE = 0x0100;
    static final int RC_DIBTODEV = 0x0200;
    static final int RC_BIGFONT = 0x0400;
    static final int RC_STRETCHBLT = 0x0800;
    static final int RC_FLOODFILL = 0x1000;
    static final int RC_STRETCHDIB = 0x2000;
    static final int RC_OP_DX_OUTPUT = 0x4000;
    static final int RC_DEVBITS = 0x8000;
    static final int SB_NONE = 0x00000000;
    static final int SB_CONST_ALPHA = 0x00000001;
    static final int SB_PIXEL_ALPHA = 0x00000002;
    static final int SB_PREMULT_ALPHA = 0x00000004;
    static final int SB_GRAD_RECT = 0x00000010;
    static final int SB_GRAD_TRI = 0x00000020;
    static final int CM_NONE = 0x00000000;
    static final int CM_DEVICE_ICM = 0x00000001;
    static final int CM_GAMMA_RAMP = 0x00000002;
    static final int CM_CMYK_COLOR = 0x00000004;
    static final int DIB_RGB_COLORS = 0;
    static final int DIB_PAL_COLORS = 1;
    static final int SYSPAL_ERROR = 0;
    static final int SYSPAL_STATIC = 1;
    static final int SYSPAL_NOSTATIC = 2;
    static final int SYSPAL_NOSTATIC256 = 3;
    static final int CBM_INIT = 0x04;
    static final int FLOODFILLBORDER = 0;
    static final int FLOODFILLSURFACE = 1;
    static final int CCHDEVICENAME = 32;
    static final int CCHFORMNAME = 32;
    static final int DM_SPECVERSION = 0x0401;
    static final int DM_ORIENTATION = 0x00000001;
    static final int DM_PAPERSIZE = 0x00000002;
    static final int DM_PAPERLENGTH = 0x00000004;
    static final int DM_PAPERWIDTH = 0x00000008;
    static final int DM_SCALE = 0x00000010;
    static final int DM_POSITION = 0x00000020;
    static final int DM_NUP = 0x00000040;
    static final int DM_DISPLAYORIENTATION = 0x00000080;
    static final int DM_COPIES = 0x00000100;
    static final int DM_DEFAULTSOURCE = 0x00000200;
    static final int DM_PRINTQUALITY = 0x00000400;
    static final int DM_COLOR = 0x00000800;
    static final int DM_DUPLEX = 0x00001000;
    static final int DM_YRESOLUTION = 0x00002000;
    static final int DM_TTOPTION = 0x00004000;
    static final int DM_COLLATE = 0x00008000;
    static final int DM_FORMNAME = 0x00010000;
    static final int DM_LOGPIXELS = 0x00020000;
    static final int DM_BITSPERPEL = 0x00040000;
    static final int DM_PELSWIDTH = 0x00080000;
    static final int DM_PELSHEIGHT = 0x00100000;
    static final int DM_DISPLAYFLAGS = 0x00200000;
    static final int DM_DISPLAYFREQUENCY = 0x00400000;
    static final int DM_ICMMETHOD = 0x00800000;
    static final int DM_ICMINTENT = 0x01000000;
    static final int DM_MEDIATYPE = 0x02000000;
    static final int DM_DITHERTYPE = 0x04000000;
    static final int DM_PANNINGWIDTH = 0x08000000;
    static final int DM_PANNINGHEIGHT = 0x10000000;
    static final int DM_DISPLAYFIXEDOUTPUT = 0x20000000;
    static final int DMORIENT_PORTRAIT = 1;
    static final int DMORIENT_LANDSCAPE = 2;
    static final int DMPAPER_LETTER = 1;
    static final int DMPAPER_LETTERSMALL = 2;
    static final int DMPAPER_TABLOID = 3;
    static final int DMPAPER_LEDGER = 4;
    static final int DMPAPER_LEGAL = 5;
    static final int DMPAPER_STATEMENT = 6;
    static final int DMPAPER_EXECUTIVE = 7;
    static final int DMPAPER_A3 = 8;
    static final int DMPAPER_A4 = 9;
    static final int DMPAPER_A4SMALL = 10;
    static final int DMPAPER_A5 = 11;
    static final int DMPAPER_B4 = 12;
    static final int DMPAPER_B5 = 13;
    static final int DMPAPER_FOLIO = 14;
    static final int DMPAPER_QUARTO = 15;
    static final int DMPAPER_10X14 = 16;
    static final int DMPAPER_11X17 = 17;
    static final int DMPAPER_NOTE = 18;
    static final int DMPAPER_ENV_9 = 19;
    static final int DMPAPER_ENV_10 = 20;
    static final int DMPAPER_ENV_11 = 21;
    static final int DMPAPER_ENV_12 = 22;
    static final int DMPAPER_ENV_14 = 23;
    static final int DMPAPER_CSHEET = 24;
    static final int DMPAPER_DSHEET = 25;
    static final int DMPAPER_ESHEET = 26;
    static final int DMPAPER_ENV_DL = 27;
    static final int DMPAPER_ENV_C5 = 28;
    static final int DMPAPER_ENV_C3 = 29;
    static final int DMPAPER_ENV_C4 = 30;
    static final int DMPAPER_ENV_C6 = 31;
    static final int DMPAPER_ENV_C65 = 32;
    static final int DMPAPER_ENV_B4 = 33;
    static final int DMPAPER_ENV_B5 = 34;
    static final int DMPAPER_ENV_B6 = 35;
    static final int DMPAPER_ENV_ITALY = 36;
    static final int DMPAPER_ENV_MONARCH = 37;
    static final int DMPAPER_ENV_PERSONAL = 38;
    static final int DMPAPER_FANFOLD_US = 39;
    static final int DMPAPER_FANFOLD_STD_GERMAN = 40;
    static final int DMPAPER_FANFOLD_LGL_GERMAN = 41;
    static final int DMPAPER_ISO_B4 = 42;
    static final int DMPAPER_JAPANESE_POSTCARD = 43;
    static final int DMPAPER_9X11 = 44;
    static final int DMPAPER_10X11 = 45;
    static final int DMPAPER_15X11 = 46;
    static final int DMPAPER_ENV_INVITE = 47;
    static final int DMPAPER_RESERVED_48 = 48;
    static final int DMPAPER_RESERVED_49 = 49;
    static final int DMPAPER_LETTER_EXTRA = 50;
    static final int DMPAPER_LEGAL_EXTRA = 51;
    static final int DMPAPER_TABLOID_EXTRA = 52;
    static final int DMPAPER_A4_EXTRA = 53;
    static final int DMPAPER_LETTER_TRANSVERSE = 54;
    static final int DMPAPER_A4_TRANSVERSE = 55;
    static final int DMPAPER_LETTER_EXTRA_TRANSVERSE = 56;
    static final int DMPAPER_A_PLUS = 57;
    static final int DMPAPER_B_PLUS = 58;
    static final int DMPAPER_LETTER_PLUS = 59;
    static final int DMPAPER_A4_PLUS = 60;
    static final int DMPAPER_A5_TRANSVERSE = 61;
    static final int DMPAPER_B5_TRANSVERSE = 62;
    static final int DMPAPER_A3_EXTRA = 63;
    static final int DMPAPER_A5_EXTRA = 64;
    static final int DMPAPER_B5_EXTRA = 65;
    static final int DMPAPER_A2 = 66;
    static final int DMPAPER_A3_TRANSVERSE = 67;
    static final int DMPAPER_A3_EXTRA_TRANSVERSE = 68;
    static final int DMPAPER_DBL_JAPANESE_POSTCARD = 69;
    static final int DMPAPER_A6 = 70;
    static final int DMPAPER_JENV_KAKU2 = 71;
    static final int DMPAPER_JENV_KAKU3 = 72;
    static final int DMPAPER_JENV_CHOU3 = 73;
    static final int DMPAPER_JENV_CHOU4 = 74;
    static final int DMPAPER_LETTER_ROTATED = 75;
    static final int DMPAPER_A3_ROTATED = 76;
    static final int DMPAPER_A4_ROTATED = 77;
    static final int DMPAPER_A5_ROTATED = 78;
    static final int DMPAPER_B4_JIS_ROTATED = 79;
    static final int DMPAPER_B5_JIS_ROTATED = 80;
    static final int DMPAPER_JAPANESE_POSTCARD_ROTATED = 81;
    static final int DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED = 82;
    static final int DMPAPER_A6_ROTATED = 83;
    static final int DMPAPER_JENV_KAKU2_ROTATED = 84;
    static final int DMPAPER_JENV_KAKU3_ROTATED = 85;
    static final int DMPAPER_JENV_CHOU3_ROTATED = 86;
    static final int DMPAPER_JENV_CHOU4_ROTATED = 87;
    static final int DMPAPER_B6_JIS = 88;
    static final int DMPAPER_B6_JIS_ROTATED = 89;
    static final int DMPAPER_12X11 = 90;
    static final int DMPAPER_JENV_YOU4 = 91;
    static final int DMPAPER_JENV_YOU4_ROTATED = 92;
    static final int DMPAPER_P16K = 93;
    static final int DMPAPER_P32K = 94;
    static final int DMPAPER_P32KBIG = 95;
    static final int DMPAPER_PENV_1 = 96;
    static final int DMPAPER_PENV_2 = 97;
    static final int DMPAPER_PENV_3 = 98;
    static final int DMPAPER_PENV_4 = 99;
    static final int DMPAPER_PENV_5 = 100;
    static final int DMPAPER_PENV_6 = 101;
    static final int DMPAPER_PENV_7 = 102;
    static final int DMPAPER_PENV_8 = 103;
    static final int DMPAPER_PENV_9 = 104;
    static final int DMPAPER_PENV_10 = 105;
    static final int DMPAPER_P16K_ROTATED = 106;
    static final int DMPAPER_P32K_ROTATED = 107;
    static final int DMPAPER_P32KBIG_ROTATED = 108;
    static final int DMPAPER_PENV_1_ROTATED = 109;
    static final int DMPAPER_PENV_2_ROTATED = 110;
    static final int DMPAPER_PENV_3_ROTATED = 111;
    static final int DMPAPER_PENV_4_ROTATED = 112;
    static final int DMPAPER_PENV_5_ROTATED = 113;
    static final int DMPAPER_PENV_6_ROTATED = 114;
    static final int DMPAPER_PENV_7_ROTATED = 115;
    static final int DMPAPER_PENV_8_ROTATED = 116;
    static final int DMPAPER_PENV_9_ROTATED = 117;
    static final int DMPAPER_PENV_10_ROTATED = 118;
    static final int DMPAPER_LAST = DMPAPER_PENV_10_ROTATED;
    static final int DMPAPER_USER = 256;
    static final int DMBIN_UPPER = 1;
    static final int DMBIN_ONLYONE = 1;
    static final int DMBIN_LOWER = 2;
    static final int DMBIN_MIDDLE = 3;
    static final int DMBIN_MANUAL = 4;
    static final int DMBIN_ENVELOPE = 5;
    static final int DMBIN_ENVMANUAL = 6;
    static final int DMBIN_AUTO = 7;
    static final int DMBIN_TRACTOR = 8;
    static final int DMBIN_SMALLFMT = 9;
    static final int DMBIN_LARGEFMT = 10;
    static final int DMBIN_LARGECAPACITY = 11;
    static final int DMBIN_CASSETTE = 14;
    static final int DMBIN_FORMSOURCE = 15;
    static final int DMBIN_LAST = DMBIN_FORMSOURCE;
    static final int DMBIN_USER = 256;
    static final int DMRES_DRAFT = (-1);
    static final int DMRES_LOW = (-2);
    static final int DMRES_MEDIUM = (-3);
    static final int DMRES_HIGH = (-4);
    static final int DMCOLOR_MONOCHROME = 1;
    static final int DMCOLOR_COLOR = 2;
    static final int DMDUP_SIMPLEX = 1;
    static final int DMDUP_VERTICAL = 2;
    static final int DMDUP_HORIZONTAL = 3;
    static final int DMTT_BITMAP = 1;
    static final int DMTT_DOWNLOAD = 2;
    static final int DMTT_SUBDEV = 3;
    static final int DMTT_DOWNLOAD_OUTLINE = 4;
    static final int DMCOLLATE_FALSE = 0;
    static final int DMCOLLATE_TRUE = 1;
    static final int DMDO_DEFAULT = 0;
    static final int DMDO_90 = 1;
    static final int DMDO_180 = 2;
    static final int DMDO_270 = 3;
    static final int DMDFO_DEFAULT = 0;
    static final int DMDFO_STRETCH = 1;
    static final int DMDFO_CENTER = 2;
    static final int DMDISPLAYFLAGS_TEXTMODE = 0x00000004;
    static final int DMNUP_SYSTEM = 1;
    static final int DMNUP_ONEUP = 2;
    static final int DMICMMETHOD_NONE = 1;
    static final int DMICMMETHOD_SYSTEM = 2;
    static final int DMICMMETHOD_DRIVER = 3;
    static final int DMICMMETHOD_DEVICE = 4;
    static final int DMICMMETHOD_USER = 256;
    static final int DMICM_SATURATE = 1;
    static final int DMICM_CONTRAST = 2;
    static final int DMICM_COLORIMETRIC = 3;
    static final int DMICM_ABS_COLORIMETRIC = 4;
    static final int DMICM_USER = 256;
    static final int DMMEDIA_STANDARD = 1;
    static final int DMMEDIA_TRANSPARENCY = 2;
    static final int DMMEDIA_GLOSSY = 3;
    static final int DMMEDIA_USER = 256;
    static final int DMDITHER_NONE = 1;
    static final int DMDITHER_COARSE = 2;
    static final int DMDITHER_FINE = 3;
    static final int DMDITHER_LINEART = 4;
    static final int DMDITHER_ERRORDIFFUSION = 5;
    static final int DMDITHER_RESERVED6 = 6;
    static final int DMDITHER_RESERVED7 = 7;
    static final int DMDITHER_RESERVED8 = 8;
    static final int DMDITHER_RESERVED9 = 9;
    static final int DMDITHER_GRAYSCALE = 10;
    static final int DMDITHER_USER = 256;
    static final int DISPLAY_DEVICE_ATTACHED_TO_DESKTOP = 0x00000001;
    static final int DISPLAY_DEVICE_MULTI_DRIVER = 0x00000002;
    static final int DISPLAY_DEVICE_PRIMARY_DEVICE = 0x00000004;
    static final int DISPLAY_DEVICE_MIRRORING_DRIVER = 0x00000008;
    static final int DISPLAY_DEVICE_VGA_COMPATIBLE = 0x00000010;
    static final int DISPLAY_DEVICE_REMOVABLE = 0x00000020;
    static final int DISPLAY_DEVICE_MODESPRUNED = 0x08000000;
    static final int DISPLAY_DEVICE_REMOTE = 0x04000000;
    static final int DISPLAY_DEVICE_DISCONNECT = 0x02000000;
    static final int DISPLAY_DEVICE_ACTIVE = 0x00000001;
    static final int DISPLAY_DEVICE_ATTACHED = 0x00000002;
    static final int RDH_RECTANGLES = 1;
    static final int SYSRGN = 4;
    static final int GGO_METRICS = 0;
    static final int GGO_BITMAP = 1;
    static final int GGO_NATIVE = 2;
    static final int GGO_BEZIER = 3;
    static final int GGO_GRAY2_BITMAP = 4;
    static final int GGO_GRAY4_BITMAP = 5;
    static final int GGO_GRAY8_BITMAP = 6;
    static final int GGO_GLYPH_INDEX = 0x0080;
    static final int GGO_UNHINTED = 0x0100;
    static final int TT_POLYGON_TYPE = 24;
    static final int TT_PRIM_LINE = 1;
    static final int TT_PRIM_QSPLINE = 2;
    static final int TT_PRIM_CSPLINE = 3;
    static final int GCP_DBCS = 0x0001;
    static final int GCP_REORDER = 0x0002;
    static final int GCP_USEKERNING = 0x0008;
    static final int GCP_GLYPHSHAPE = 0x0010;
    static final int GCP_LIGATE = 0x0020;
    static final int GCP_DIACRITIC = 0x0100;
    static final int GCP_KASHIDA = 0x0400;
    static final int GCP_ERROR = 0x8000;
    static final int FLI_MASK = 0x103B;
    static final int GCP_JUSTIFY = 0x00010000;
    static final int FLI_GLYPHS = 0x00040000;
    static final int GCP_CLASSIN = 0x00080000;
    static final int GCP_MAXEXTENT = 0x00100000;
    static final int GCP_JUSTIFYIN = 0x00200000;
    static final int GCP_DISPLAYZWG = 0x00400000;
    static final int GCP_SYMSWAPOFF = 0x00800000;
    static final int GCP_NUMERICOVERRIDE = 0x01000000;
    static final int GCP_NEUTRALOVERRIDE = 0x02000000;
    static final int GCP_NUMERICSLATIN = 0x04000000;
    static final int GCP_NUMERICSLOCAL = 0x08000000;
    static final int GCPCLASS_LATIN = 1;
    static final int GCPCLASS_HEBREW = 2;
    static final int GCPCLASS_ARABIC = 2;
    static final int GCPCLASS_NEUTRAL = 3;
    static final int GCPCLASS_LOCALNUMBER = 4;
    static final int GCPCLASS_LATINNUMBER = 5;
    static final int GCPCLASS_LATINNUMERICTERMINATOR = 6;
    static final int GCPCLASS_LATINNUMERICSEPARATOR = 7;
    static final int GCPCLASS_NUMERICSEPARATOR = 8;
    static final int GCPCLASS_PREBOUNDLTR = 0x80;
    static final int GCPCLASS_PREBOUNDRTL = 0x40;
    static final int GCPCLASS_POSTBOUNDLTR = 0x20;
    static final int GCPCLASS_POSTBOUNDRTL = 0x10;
    static final int GCPGLYPH_LINKBEFORE = 0x8000;
    static final int GCPGLYPH_LINKAFTER = 0x4000;
    static final int TT_AVAILABLE = 0x0001;
    static final int TT_ENABLED = 0x0002;
    static final int PFD_TYPE_RGBA = 0;
    static final int PFD_TYPE_COLORINDEX = 1;
    static final int PFD_MAIN_PLANE = 0;
    static final int PFD_OVERLAY_PLANE = 1;
    static final int PFD_UNDERLAY_PLANE = (-1);
    static final int PFD_DOUBLEBUFFER = 0x00000001;
    static final int PFD_STEREO = 0x00000002;
    static final int PFD_DRAW_TO_WINDOW = 0x00000004;
    static final int PFD_DRAW_TO_BITMAP = 0x00000008;
    static final int PFD_SUPPORT_GDI = 0x00000010;
    static final int PFD_SUPPORT_OPENGL = 0x00000020;
    static final int PFD_GENERIC_FORMAT = 0x00000040;
    static final int PFD_NEED_PALETTE = 0x00000080;
    static final int PFD_NEED_SYSTEM_PALETTE = 0x00000100;
    static final int PFD_SWAP_EXCHANGE = 0x00000200;
    static final int PFD_SWAP_COPY = 0x00000400;
    static final int PFD_SWAP_LAYER_BUFFERS = 0x00000800;
    static final int PFD_GENERIC_ACCELERATED = 0x00001000;
    static final int PFD_SUPPORT_DIRECTDRAW = 0x00002000;
    static final int PFD_DEPTH_DONTCARE = 0x20000000;
    static final int PFD_DOUBLEBUFFER_DONTCARE = 0x40000000;
    static final int PFD_STEREO_DONTCARE = 0x80000000;
    static final int DM_UPDATE = 1;
    static final int DM_COPY = 2;
    static final int DM_PROMPT = 4;
    static final int DM_MODIFY = 8;
    static final int DM_IN_BUFFER = DM_MODIFY;
    static final int DM_IN_PROMPT = DM_PROMPT;
    static final int DM_OUT_BUFFER = DM_COPY;
    static final int DM_OUT_DEFAULT = DM_UPDATE;
    static final int DC_FIELDS = 1;
    static final int DC_PAPERS = 2;
    static final int DC_PAPERSIZE = 3;
    static final int DC_MINEXTENT = 4;
    static final int DC_MAXEXTENT = 5;
    static final int DC_BINS = 6;
    static final int DC_DUPLEX = 7;
    static final int DC_SIZE = 8;
    static final int DC_EXTRA = 9;
    static final int DC_VERSION = 10;
    static final int DC_DRIVER = 11;
    static final int DC_BINNAMES = 12;
    static final int DC_ENUMRESOLUTIONS = 13;
    static final int DC_FILEDEPENDENCIES = 14;
    static final int DC_TRUETYPE = 15;
    static final int DC_PAPERNAMES = 16;
    static final int DC_ORIENTATION = 17;
    static final int DC_COPIES = 18;
    static final int DC_BINADJUST = 19;
    static final int DC_EMF_COMPLIANT = 20;
    static final int DC_DATATYPE_PRODUCED = 21;
    static final int DC_COLLATE = 22;
    static final int DC_MANUFACTURER = 23;
    static final int DC_MODEL = 24;
    static final int DC_PERSONALITY = 25;
    static final int DC_PRINTRATE = 26;
    static final int DC_PRINTRATEUNIT = 27;
    static final int PRINTRATEUNIT_PPM = 1;
    static final int PRINTRATEUNIT_CPS = 2;
    static final int PRINTRATEUNIT_LPM = 3;
    static final int PRINTRATEUNIT_IPM = 4;
    static final int DC_PRINTERMEM = 28;
    static final int DC_MEDIAREADY = 29;
    static final int DC_STAPLE = 30;
    static final int DC_PRINTRATEPPM = 31;
    static final int DC_COLORDEVICE = 32;
    static final int DC_NUP = 33;
    static final int DC_MEDIATYPENAMES = 34;
    static final int DC_MEDIATYPES = 35;
    static final int DCTT_BITMAP = 0x0000001;
    static final int DCTT_DOWNLOAD = 0x0000002;
    static final int DCTT_SUBDEV = 0x0000004;
    static final int DCTT_DOWNLOAD_OUTLINE = 0x0000008;
    static final int DCBA_FACEUPNONE = 0x0000;
    static final int DCBA_FACEUPCENTER = 0x0001;
    static final int DCBA_FACEUPLEFT = 0x0002;
    static final int DCBA_FACEUPRIGHT = 0x0003;
    static final int DCBA_FACEDOWNNONE = 0x0100;
    static final int DCBA_FACEDOWNCENTER = 0x0101;
    static final int DCBA_FACEDOWNLEFT = 0x0102;
    static final int DCBA_FACEDOWNRIGHT = 0x0103;
    static final int GS_8BIT_INDICES = 0x00000001;
    static final int GGI_MARK_NONEXISTING_GLYPHS = 0X0001;
    static final int MM_MAX_NUMAXES = 16;
    static final int FR_PRIVATE = 0x10;
    static final int FR_NOT_ENUM = 0x20;
    static final int MM_MAX_AXES_NAMELEN = 16;
    static final int AC_SRC_OVER = 0x00;
    static final int AC_SRC_ALPHA = 0x01;
    static final int GRADIENT_FILL_RECT_H = 0x00000000;
    static final int GRADIENT_FILL_RECT_V = 0x00000001;
    static final int GRADIENT_FILL_TRIANGLE = 0x00000002;
    static final int GRADIENT_FILL_OP_FLAG = 0x000000ff;
    static final int CA_NEGATIVE = 0x0001;
    static final int CA_LOG_FILTER = 0x0002;
    static final int ILLUMINANT_DEVICE_DEFAULT = 0;
    static final int ILLUMINANT_A = 1;
    static final int ILLUMINANT_B = 2;
    static final int ILLUMINANT_C = 3;
    static final int ILLUMINANT_D50 = 4;
    static final int ILLUMINANT_D55 = 5;
    static final int ILLUMINANT_D65 = 6;
    static final int ILLUMINANT_D75 = 7;
    static final int ILLUMINANT_F2 = 8;
    static final int ILLUMINANT_MAX_INDEX = ILLUMINANT_F2;
    static final int ILLUMINANT_TUNGSTEN = ILLUMINANT_A;
    static final int ILLUMINANT_DAYLIGHT = ILLUMINANT_C;
    static final int ILLUMINANT_FLUORESCENT = ILLUMINANT_F2;
    static final int ILLUMINANT_NTSC = ILLUMINANT_C;
    static final int DI_APPBANDING = 0x00000001;
    static final int DI_ROPS_READ_DESTINATION = 0x00000002;
    static final int FONTMAPPER_MAX = 10;
    static final int ICM_OFF = 1;
    static final int ICM_ON = 2;
    static final int ICM_QUERY = 3;
    static final int ICM_DONE_OUTSIDEDC = 4;
    static final int ENHMETA_SIGNATURE = 0x464D4520;
    static final int ENHMETA_STOCK_OBJECT = 0x80000000;
    static final int EMR_HEADER = 1;
    static final int EMR_POLYBEZIER = 2;
    static final int EMR_POLYGON = 3;
    static final int EMR_POLYLINE = 4;
    static final int EMR_POLYBEZIERTO = 5;
    static final int EMR_POLYLINETO = 6;
    static final int EMR_POLYPOLYLINE = 7;
    static final int EMR_POLYPOLYGON = 8;
    static final int EMR_SETWINDOWEXTEX = 9;
    static final int EMR_SETWINDOWORGEX = 10;
    static final int EMR_SETVIEWPORTEXTEX = 11;
    static final int EMR_SETVIEWPORTORGEX = 12;
    static final int EMR_SETBRUSHORGEX = 13;
    static final int EMR_EOF = 14;
    static final int EMR_SETPIXELV = 15;
    static final int EMR_SETMAPPERFLAGS = 16;
    static final int EMR_SETMAPMODE = 17;
    static final int EMR_SETBKMODE = 18;
    static final int EMR_SETPOLYFILLMODE = 19;
    static final int EMR_SETROP2 = 20;
    static final int EMR_SETSTRETCHBLTMODE = 21;
    static final int EMR_SETTEXTALIGN = 22;
    static final int EMR_SETCOLORADJUSTMENT = 23;
    static final int EMR_SETTEXTCOLOR = 24;
    static final int EMR_SETBKCOLOR = 25;
    static final int EMR_OFFSETCLIPRGN = 26;
    static final int EMR_MOVETOEX = 27;
    static final int EMR_SETMETARGN = 28;
    static final int EMR_EXCLUDECLIPRECT = 29;
    static final int EMR_INTERSECTCLIPRECT = 30;
    static final int EMR_SCALEVIEWPORTEXTEX = 31;
    static final int EMR_SCALEWINDOWEXTEX = 32;
    static final int EMR_SAVEDC = 33;
    static final int EMR_RESTOREDC = 34;
    static final int EMR_SETWORLDTRANSFORM = 35;
    static final int EMR_MODIFYWORLDTRANSFORM = 36;
    static final int EMR_SELECTOBJECT = 37;
    static final int EMR_CREATEPEN = 38;
    static final int EMR_CREATEBRUSHINDIRECT = 39;
    static final int EMR_DELETEOBJECT = 40;
    static final int EMR_ANGLEARC = 41;
    static final int EMR_ELLIPSE = 42;
    static final int EMR_RECTANGLE = 43;
    static final int EMR_ROUNDRECT = 44;
    static final int EMR_ARC = 45;
    static final int EMR_CHORD = 46;
    static final int EMR_PIE = 47;
    static final int EMR_SELECTPALETTE = 48;
    static final int EMR_CREATEPALETTE = 49;
    static final int EMR_SETPALETTEENTRIES = 50;
    static final int EMR_RESIZEPALETTE = 51;
    static final int EMR_REALIZEPALETTE = 52;
    static final int EMR_EXTFLOODFILL = 53;
    static final int EMR_LINETO = 54;
    static final int EMR_ARCTO = 55;
    static final int EMR_POLYDRAW = 56;
    static final int EMR_SETARCDIRECTION = 57;
    static final int EMR_SETMITERLIMIT = 58;
    static final int EMR_BEGINPATH = 59;
    static final int EMR_ENDPATH = 60;
    static final int EMR_CLOSEFIGURE = 61;
    static final int EMR_FILLPATH = 62;
    static final int EMR_STROKEANDFILLPATH = 63;
    static final int EMR_STROKEPATH = 64;
    static final int EMR_FLATTENPATH = 65;
    static final int EMR_WIDENPATH = 66;
    static final int EMR_SELECTCLIPPATH = 67;
    static final int EMR_ABORTPATH = 68;
    static final int EMR_GDICOMMENT = 70;
    static final int EMR_FILLRGN = 71;
    static final int EMR_FRAMERGN = 72;
    static final int EMR_INVERTRGN = 73;
    static final int EMR_PAINTRGN = 74;
    static final int EMR_EXTSELECTCLIPRGN = 75;
    static final int EMR_BITBLT = 76;
    static final int EMR_STRETCHBLT = 77;
    static final int EMR_MASKBLT = 78;
    static final int EMR_PLGBLT = 79;
    static final int EMR_SETDIBITSTODEVICE = 80;
    static final int EMR_STRETCHDIBITS = 81;
    static final int EMR_EXTCREATEFONTINDIRECTW = 82;
    static final int EMR_EXTTEXTOUTA = 83;
    static final int EMR_EXTTEXTOUTW = 84;
    static final int EMR_POLYBEZIER16 = 85;
    static final int EMR_POLYGON16 = 86;
    static final int EMR_POLYLINE16 = 87;
    static final int EMR_POLYBEZIERTO16 = 88;
    static final int EMR_POLYLINETO16 = 89;
    static final int EMR_POLYPOLYLINE16 = 90;
    static final int EMR_POLYPOLYGON16 = 91;
    static final int EMR_POLYDRAW16 = 92;
    static final int EMR_CREATEMONOBRUSH = 93;
    static final int EMR_CREATEDIBPATTERNBRUSHPT = 94;
    static final int EMR_EXTCREATEPEN = 95;
    static final int EMR_POLYTEXTOUTA = 96;
    static final int EMR_POLYTEXTOUTW = 97;
    static final int EMR_SETICMMODE = 98;
    static final int EMR_CREATECOLORSPACE = 99;
    static final int EMR_SETCOLORSPACE = 100;
    static final int EMR_DELETECOLORSPACE = 101;
    static final int EMR_GLSRECORD = 102;
    static final int EMR_GLSBOUNDEDRECORD = 103;
    static final int EMR_PIXELFORMAT = 104;
    static final int EMR_RESERVED_105 = 105;
    static final int EMR_RESERVED_106 = 106;
    static final int EMR_RESERVED_107 = 107;
    static final int EMR_RESERVED_108 = 108;
    static final int EMR_RESERVED_109 = 109;
    static final int EMR_RESERVED_110 = 110;
    static final int EMR_COLORCORRECTPALETTE = 111;
    static final int EMR_SETICMPROFILEA = 112;
    static final int EMR_SETICMPROFILEW = 113;
    static final int EMR_ALPHABLEND = 114;
    static final int EMR_SETLAYOUT = 115;
    static final int EMR_TRANSPARENTBLT = 116;
    static final int EMR_RESERVED_117 = 117;
    static final int EMR_GRADIENTFILL = 118;
    static final int EMR_RESERVED_119 = 119;
    static final int EMR_RESERVED_120 = 120;
    static final int EMR_COLORMATCHTOTARGETW = 121;
    static final int EMR_CREATECOLORSPACEW = 122;
    static final int EMR_MIN = 1;
    static final int EMR_MAX = 122;
    static final int SETICMPROFILE_EMBEDED = 0x00000001;
    static final int CREATECOLORSPACE_EMBEDED = 0x00000001;
    static final int COLORMATCHTOTARGET_EMBEDED = 0x00000001;
    static final int GDICOMMENT_IDENTIFIER = 0x43494447;
    static final int GDICOMMENT_WINDOWS_METAFILE = 0x80000001;
    static final int GDICOMMENT_BEGINGROUP = 0x00000002;
    static final int GDICOMMENT_ENDGROUP = 0x00000003;
    static final int GDICOMMENT_MULTIFORMATS = 0x40000004;
    static final int EPS_SIGNATURE = 0x46535045;
    static final int GDICOMMENT_UNICODE_STRING = 0x00000040;
    static final int GDICOMMENT_UNICODE_END = 0x00000080;
    static final int WGL_FONT_LINES = 0;
    static final int WGL_FONT_POLYGONS = 1;
    static final int LPD_DOUBLEBUFFER = 0x00000001;
    static final int LPD_STEREO = 0x00000002;
    static final int LPD_SUPPORT_GDI = 0x00000010;
    static final int LPD_SUPPORT_OPENGL = 0x00000020;
    static final int LPD_SHARE_DEPTH = 0x00000040;
    static final int LPD_SHARE_STENCIL = 0x00000080;
    static final int LPD_SHARE_ACCUM = 0x00000100;
    static final int LPD_SWAP_EXCHANGE = 0x00000200;
    static final int LPD_SWAP_COPY = 0x00000400;
    static final int LPD_TRANSPARENT = 0x00001000;
    static final int LPD_TYPE_RGBA = 0;
    static final int LPD_TYPE_COLORINDEX = 1;
    static final int WGL_SWAP_MAIN_PLANE = 0x00000001;
    static final int WGL_SWAP_OVERLAY1 = 0x00000002;
    static final int WGL_SWAP_OVERLAY2 = 0x00000004;
    static final int WGL_SWAP_OVERLAY3 = 0x00000008;
    static final int WGL_SWAP_OVERLAY4 = 0x00000010;
    static final int WGL_SWAP_OVERLAY5 = 0x00000020;
    static final int WGL_SWAP_OVERLAY6 = 0x00000040;
    static final int WGL_SWAP_OVERLAY7 = 0x00000080;
    static final int WGL_SWAP_OVERLAY8 = 0x00000100;
    static final int WGL_SWAP_OVERLAY9 = 0x00000200;
    static final int WGL_SWAP_OVERLAY10 = 0x00000400;
    static final int WGL_SWAP_OVERLAY11 = 0x00000800;
    static final int WGL_SWAP_OVERLAY12 = 0x00001000;
    static final int WGL_SWAP_OVERLAY13 = 0x00002000;
    static final int WGL_SWAP_OVERLAY14 = 0x00004000;
    static final int WGL_SWAP_OVERLAY15 = 0x00008000;
    static final int WGL_SWAP_UNDERLAY1 = 0x00010000;
    static final int WGL_SWAP_UNDERLAY2 = 0x00020000;
    static final int WGL_SWAP_UNDERLAY3 = 0x00040000;
    static final int WGL_SWAP_UNDERLAY4 = 0x00080000;
    static final int WGL_SWAP_UNDERLAY5 = 0x00100000;
    static final int WGL_SWAP_UNDERLAY6 = 0x00200000;
    static final int WGL_SWAP_UNDERLAY7 = 0x00400000;
    static final int WGL_SWAP_UNDERLAY8 = 0x00800000;
    static final int WGL_SWAP_UNDERLAY9 = 0x01000000;
    static final int WGL_SWAP_UNDERLAY10 = 0x02000000;
    static final int WGL_SWAP_UNDERLAY11 = 0x04000000;
    static final int WGL_SWAP_UNDERLAY12 = 0x08000000;
    static final int WGL_SWAP_UNDERLAY13 = 0x10000000;
    static final int WGL_SWAP_UNDERLAY14 = 0x20000000;
    static final int WGL_SWAP_UNDERLAY15 = 0x40000000;
    static final int WGL_SWAPMULTIPLE_MAX = 16;
    static final long RT_CURSOR = (1);
    static final long RT_BITMAP = (2);
    static final long RT_ICON = (3);
    static final long RT_MENU = (4);
    static final long RT_DIALOG = (5);
    static final long RT_STRING = (6);
    static final long RT_FONTDIR = (7);
    static final long RT_FONT = (8);
    static final long RT_ACCELERATOR = (9);
    static final long RT_RCDATA = (10);
    static final long RT_MESSAGETABLE = (11);
    static final int DIFFERENCE = 11;
    static final long RT_VERSION = (16);
    static final long RT_DLGINCLUDE = (17);
    static final long RT_PLUGPLAY = (19);
    static final long RT_VXD = (20);
    static final long RT_ANICURSOR = (21);
    static final long RT_ANIICON = (22);
    static final long RT_HTML = (23);
    static final long RT_MANIFEST = (24);
    static final long CREATEPROCESS_MANIFEST_RESOURCE_ID = ( 1);
    static final long ISOLATIONAWARE_MANIFEST_RESOURCE_ID = (2);
    static final long ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID = (3);
    static final long MINIMUM_RESERVED_MANIFEST_RESOURCE_ID = ( 1 );
    static final long MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID = (16 );
    static final int SB_HORZ = 0;
    static final int SB_VERT = 1;
    static final int SB_CTL = 2;
    static final int SB_BOTH = 3;
    static final int SB_LINEUP = 0;
    static final int SB_LINELEFT = 0;
    static final int SB_LINEDOWN = 1;
    static final int SB_LINERIGHT = 1;
    static final int SB_PAGEUP = 2;
    static final int SB_PAGELEFT = 2;
    static final int SB_PAGEDOWN = 3;
    static final int SB_PAGERIGHT = 3;
    static final int SB_THUMBPOSITION = 4;
    static final int SB_THUMBTRACK = 5;
    static final int SB_TOP = 6;
    static final int SB_LEFT = 6;
    static final int SB_BOTTOM = 7;
    static final int SB_RIGHT = 7;
    static final int SB_ENDSCROLL = 8;
    static final int SW_HIDE = 0;
    static final int SW_SHOWNORMAL = 1;
    static final int SW_NORMAL = 1;
    static final int SW_SHOWMINIMIZED = 2;
    static final int SW_SHOWMAXIMIZED = 3;
    static final int SW_MAXIMIZE = 3;
    static final int SW_SHOWNOACTIVATE = 4;
    static final int SW_SHOW = 5;
    static final int SW_MINIMIZE = 6;
    static final int SW_SHOWMINNOACTIVE = 7;
    static final int SW_SHOWNA = 8;
    static final int SW_RESTORE = 9;
    static final int SW_SHOWDEFAULT = 10;
    static final int SW_FORCEMINIMIZE = 11;
    static final int SW_MAX = 11;
    static final int HIDE_WINDOW = 0;
    static final int SHOW_OPENWINDOW = 1;
    static final int SHOW_ICONWINDOW = 2;
    static final int SHOW_FULLSCREEN = 3;
    static final int SHOW_OPENNOACTIVATE = 4;
    static final int SW_PARENTCLOSING = 1;
    static final int SW_OTHERZOOM = 2;
    static final int SW_PARENTOPENING = 3;
    static final int SW_OTHERUNZOOM = 4;
    static final int AW_HOR_POSITIVE = 0x00000001;
    static final int AW_HOR_NEGATIVE = 0x00000002;
    static final int AW_VER_POSITIVE = 0x00000004;
    static final int AW_VER_NEGATIVE = 0x00000008;
    static final int AW_CENTER = 0x00000010;
    static final int AW_HIDE = 0x00010000;
    static final int AW_ACTIVATE = 0x00020000;
    static final int AW_SLIDE = 0x00040000;
    static final int AW_BLEND = 0x00080000;
    static final int KF_EXTENDED = 0x0100;
    static final int KF_DLGMODE = 0x0800;
    static final int KF_MENUMODE = 0x1000;
    static final int KF_ALTDOWN = 0x2000;
    static final int KF_REPEAT = 0x4000;
    static final int KF_UP = 0x8000;
    static final int VK_LBUTTON = 0x01;
    static final int VK_RBUTTON = 0x02;
    static final int VK_CANCEL = 0x03;
    static final int VK_MBUTTON = 0x04;
    static final int VK_XBUTTON1 = 0x05;
    static final int VK_XBUTTON2 = 0x06;
    static final int VK_BACK = 0x08;
    static final int VK_TAB = 0x09;
    static final int VK_CLEAR = 0x0C;
    static final int VK_RETURN = 0x0D;
    static final int VK_SHIFT = 0x10;
    static final int VK_CONTROL = 0x11;
    static final int VK_MENU = 0x12;
    static final int VK_PAUSE = 0x13;
    static final int VK_CAPITAL = 0x14;
    static final int VK_KANA = 0x15;
    static final int VK_HANGEUL = 0x15;
    static final int VK_HANGUL = 0x15;
    static final int VK_JUNJA = 0x17;
    static final int VK_FINAL = 0x18;
    static final int VK_HANJA = 0x19;
    static final int VK_KANJI = 0x19;
    static final int VK_ESCAPE = 0x1B;
    static final int VK_CONVERT = 0x1C;
    static final int VK_NONCONVERT = 0x1D;
    static final int VK_ACCEPT = 0x1E;
    static final int VK_MODECHANGE = 0x1F;
    static final int VK_SPACE = 0x20;
    static final int VK_PRIOR = 0x21;
    static final int VK_NEXT = 0x22;
    static final int VK_END = 0x23;
    static final int VK_HOME = 0x24;
    static final int VK_LEFT = 0x25;
    static final int VK_UP = 0x26;
    static final int VK_RIGHT = 0x27;
    static final int VK_DOWN = 0x28;
    static final int VK_SELECT = 0x29;
    static final int VK_PRINT = 0x2A;
    static final int VK_EXECUTE = 0x2B;
    static final int VK_SNAPSHOT = 0x2C;
    static final int VK_INSERT = 0x2D;
    static final int VK_DELETE = 0x2E;
    static final int VK_HELP = 0x2F;
    static final int VK_LWIN = 0x5B;
    static final int VK_RWIN = 0x5C;
    static final int VK_APPS = 0x5D;
    static final int VK_SLEEP = 0x5F;
    static final int VK_NUMPAD0 = 0x60;
    static final int VK_NUMPAD1 = 0x61;
    static final int VK_NUMPAD2 = 0x62;
    static final int VK_NUMPAD3 = 0x63;
    static final int VK_NUMPAD4 = 0x64;
    static final int VK_NUMPAD5 = 0x65;
    static final int VK_NUMPAD6 = 0x66;
    static final int VK_NUMPAD7 = 0x67;
    static final int VK_NUMPAD8 = 0x68;
    static final int VK_NUMPAD9 = 0x69;
    static final int VK_MULTIPLY = 0x6A;
    static final int VK_ADD = 0x6B;
    static final int VK_SEPARATOR = 0x6C;
    static final int VK_SUBTRACT = 0x6D;
    static final int VK_DECIMAL = 0x6E;
    static final int VK_DIVIDE = 0x6F;
    static final int VK_F1 = 0x70;
    static final int VK_F2 = 0x71;
    static final int VK_F3 = 0x72;
    static final int VK_F4 = 0x73;
    static final int VK_F5 = 0x74;
    static final int VK_F6 = 0x75;
    static final int VK_F7 = 0x76;
    static final int VK_F8 = 0x77;
    static final int VK_F9 = 0x78;
    static final int VK_F10 = 0x79;
    static final int VK_F11 = 0x7A;
    static final int VK_F12 = 0x7B;
    static final int VK_F13 = 0x7C;
    static final int VK_F14 = 0x7D;
    static final int VK_F15 = 0x7E;
    static final int VK_F16 = 0x7F;
    static final int VK_F17 = 0x80;
    static final int VK_F18 = 0x81;
    static final int VK_F19 = 0x82;
    static final int VK_F20 = 0x83;
    static final int VK_F21 = 0x84;
    static final int VK_F22 = 0x85;
    static final int VK_F23 = 0x86;
    static final int VK_F24 = 0x87;
    static final int VK_NUMLOCK = 0x90;
    static final int VK_SCROLL = 0x91;
    static final int VK_OEM_NEC_EQUAL = 0x92;
    static final int VK_OEM_FJ_JISHO = 0x92;
    static final int VK_OEM_FJ_MASSHOU = 0x93;
    static final int VK_OEM_FJ_TOUROKU = 0x94;
    static final int VK_OEM_FJ_LOYA = 0x95;
    static final int VK_OEM_FJ_ROYA = 0x96;
    static final int VK_LSHIFT = 0xA0;
    static final int VK_RSHIFT = 0xA1;
    static final int VK_LCONTROL = 0xA2;
    static final int VK_RCONTROL = 0xA3;
    static final int VK_LMENU = 0xA4;
    static final int VK_RMENU = 0xA5;
    static final int VK_BROWSER_BACK = 0xA6;
    static final int VK_BROWSER_FORWARD = 0xA7;
    static final int VK_BROWSER_REFRESH = 0xA8;
    static final int VK_BROWSER_STOP = 0xA9;
    static final int VK_BROWSER_SEARCH = 0xAA;
    static final int VK_BROWSER_FAVORITES = 0xAB;
    static final int VK_BROWSER_HOME = 0xAC;
    static final int VK_VOLUME_MUTE = 0xAD;
    static final int VK_VOLUME_DOWN = 0xAE;
    static final int VK_VOLUME_UP = 0xAF;
    static final int VK_MEDIA_NEXT_TRACK = 0xB0;
    static final int VK_MEDIA_PREV_TRACK = 0xB1;
    static final int VK_MEDIA_STOP = 0xB2;
    static final int VK_MEDIA_PLAY_PAUSE = 0xB3;
    static final int VK_LAUNCH_MAIL = 0xB4;
    static final int VK_LAUNCH_MEDIA_SELECT = 0xB5;
    static final int VK_LAUNCH_APP1 = 0xB6;
    static final int VK_LAUNCH_APP2 = 0xB7;
    static final int VK_OEM_1 = 0xBA;
    static final int VK_OEM_PLUS = 0xBB;
    static final int VK_OEM_COMMA = 0xBC;
    static final int VK_OEM_MINUS = 0xBD;
    static final int VK_OEM_PERIOD = 0xBE;
    static final int VK_OEM_2 = 0xBF;
    static final int VK_OEM_3 = 0xC0;
    static final int VK_OEM_4 = 0xDB;
    static final int VK_OEM_5 = 0xDC;
    static final int VK_OEM_6 = 0xDD;
    static final int VK_OEM_7 = 0xDE;
    static final int VK_OEM_8 = 0xDF;
    static final int VK_OEM_AX = 0xE1;
    static final int VK_OEM_102 = 0xE2;
    static final int VK_ICO_HELP = 0xE3;
    static final int VK_ICO_00 = 0xE4;
    static final int VK_PROCESSKEY = 0xE5;
    static final int VK_ICO_CLEAR = 0xE6;
    static final int VK_PACKET = 0xE7;
    static final int VK_OEM_RESET = 0xE9;
    static final int VK_OEM_JUMP = 0xEA;
    static final int VK_OEM_PA1 = 0xEB;
    static final int VK_OEM_PA2 = 0xEC;
    static final int VK_OEM_PA3 = 0xED;
    static final int VK_OEM_WSCTRL = 0xEE;
    static final int VK_OEM_CUSEL = 0xEF;
    static final int VK_OEM_ATTN = 0xF0;
    static final int VK_OEM_FINISH = 0xF1;
    static final int VK_OEM_COPY = 0xF2;
    static final int VK_OEM_AUTO = 0xF3;
    static final int VK_OEM_ENLW = 0xF4;
    static final int VK_OEM_BACKTAB = 0xF5;
    static final int VK_ATTN = 0xF6;
    static final int VK_CRSEL = 0xF7;
    static final int VK_EXSEL = 0xF8;
    static final int VK_EREOF = 0xF9;
    static final int VK_PLAY = 0xFA;
    static final int VK_ZOOM = 0xFB;
    static final int VK_NONAME = 0xFC;
    static final int VK_PA1 = 0xFD;
    static final int VK_OEM_CLEAR = 0xFE;
    static final int WH_MIN = (-1);
    static final int WH_MSGFILTER = (-1);
    static final int WH_JOURNALRECORD = 0;
    static final int WH_JOURNALPLAYBACK = 1;
    static final int WH_KEYBOARD = 2;
    static final int WH_GETMESSAGE = 3;
    static final int WH_CALLWNDPROC = 4;
    static final int WH_CBT = 5;
    static final int WH_SYSMSGFILTER = 6;
    static final int WH_MOUSE = 7;
    static final int WH_DEBUG = 9;
    static final int WH_SHELL = 10;
    static final int WH_FOREGROUNDIDLE = 11;
    static final int WH_CALLWNDPROCRET = 12;
    static final int WH_KEYBOARD_LL = 13;
    static final int WH_MOUSE_LL = 14;
    static final int WH_MAX = 14;
    static final int WH_MINHOOK = WH_MIN;
    static final int WH_MAXHOOK = WH_MAX;
    static final int HC_ACTION = 0;
    static final int HC_GETNEXT = 1;
    static final int HC_SKIP = 2;
    static final int HC_NOREMOVE = 3;
    static final int HC_NOREM = HC_NOREMOVE;
    static final int HC_SYSMODALON = 4;
    static final int HC_SYSMODALOFF = 5;
    static final int HCBT_MOVESIZE = 0;
    static final int HCBT_MINMAX = 1;
    static final int HCBT_QS = 2;
    static final int HCBT_CREATEWND = 3;
    static final int HCBT_DESTROYWND = 4;
    static final int HCBT_ACTIVATE = 5;
    static final int HCBT_CLICKSKIPPED = 6;
    static final int HCBT_KEYSKIPPED = 7;
    static final int HCBT_SYSCOMMAND = 8;
    static final int HCBT_SETFOCUS = 9;
    static final int MSGF_DIALOGBOX = 0;
    static final int MSGF_MESSAGEBOX = 1;
    static final int MSGF_MENU = 2;
    static final int MSGF_SCROLLBAR = 5;
    static final int MSGF_NEXTWINDOW = 6;
    static final int MSGF_MAX = 8;
    static final int MSGF_USER = 4096;
    static final int HSHELL_WINDOWCREATED = 1;
    static final int HSHELL_WINDOWDESTROYED = 2;
    static final int HSHELL_ACTIVATESHELLWINDOW = 3;
    static final int HSHELL_WINDOWACTIVATED = 4;
    static final int HSHELL_GETMINRECT = 5;
    static final int HSHELL_REDRAW = 6;
    static final int HSHELL_TASKMAN = 7;
    static final int HSHELL_LANGUAGE = 8;
    static final int HSHELL_SYSMENU = 9;
    static final int HSHELL_ENDTASK = 10;
    static final int HSHELL_ACCESSIBILITYSTATE = 11;
    static final int HSHELL_APPCOMMAND = 12;
    static final int HSHELL_HIGHBIT = 0x8000;
    static final int HSHELL_FLASH = (HSHELL_REDRAW|HSHELL_HIGHBIT);
    static final int HSHELL_RUDEAPPACTIVATED = (HSHELL_WINDOWACTIVATED|HSHELL_HIGHBIT);
    static final int ACCESS_STICKYKEYS = 0x0001;
    static final int ACCESS_FILTERKEYS = 0x0002;
    static final int ACCESS_MOUSEKEYS = 0x0003;
    static final int APPCOMMAND_BROWSER_BACKWARD = 1;
    static final int APPCOMMAND_BROWSER_FORWARD = 2;
    static final int APPCOMMAND_BROWSER_REFRESH = 3;
    static final int APPCOMMAND_BROWSER_STOP = 4;
    static final int APPCOMMAND_BROWSER_SEARCH = 5;
    static final int APPCOMMAND_BROWSER_FAVORITES = 6;
    static final int APPCOMMAND_BROWSER_HOME = 7;
    static final int APPCOMMAND_VOLUME_MUTE = 8;
    static final int APPCOMMAND_VOLUME_DOWN = 9;
    static final int APPCOMMAND_VOLUME_UP = 10;
    static final int APPCOMMAND_MEDIA_NEXTTRACK = 11;
    static final int APPCOMMAND_MEDIA_PREVIOUSTRACK = 12;
    static final int APPCOMMAND_MEDIA_STOP = 13;
    static final int APPCOMMAND_MEDIA_PLAY_PAUSE = 14;
    static final int APPCOMMAND_LAUNCH_MAIL = 15;
    static final int APPCOMMAND_LAUNCH_MEDIA_SELECT = 16;
    static final int APPCOMMAND_LAUNCH_APP1 = 17;
    static final int APPCOMMAND_LAUNCH_APP2 = 18;
    static final int APPCOMMAND_BASS_DOWN = 19;
    static final int APPCOMMAND_BASS_BOOST = 20;
    static final int APPCOMMAND_BASS_UP = 21;
    static final int APPCOMMAND_TREBLE_DOWN = 22;
    static final int APPCOMMAND_TREBLE_UP = 23;
    static final int FAPPCOMMAND_MOUSE = 0x8000;
    static final int FAPPCOMMAND_KEY = 0;
    static final int FAPPCOMMAND_OEM = 0x1000;
    static final int FAPPCOMMAND_MASK = 0xF000;
    static final int LLKHF_EXTENDED = (KF_EXTENDED >> 8);
    static final int LLKHF_INJECTED = 0x00000010;
    static final int LLKHF_ALTDOWN = (KF_ALTDOWN >> 8);
    static final int LLKHF_UP = (KF_UP >> 8);
    static final int LLMHF_INJECTED = 0x00000001;
    static final int HKL_PREV = 0;
    static final int HKL_NEXT = 1;
    static final int KLF_ACTIVATE = 0x00000001;
    static final int KLF_SUBSTITUTE_OK = 0x00000002;
    static final int KLF_REORDER = 0x00000008;
    static final int KLF_REPLACELANG = 0x00000010;
    static final int KLF_NOTELLSHELL = 0x00000080;
    static final int KLF_SETFORPROCESS = 0x00000100;
    static final int KLF_SHIFTLOCK = 0x00010000;
    static final int KLF_RESET = 0x40000000;
    static final int INPUTLANGCHANGE_SYSCHARSET = 0x0001;
    static final int INPUTLANGCHANGE_FORWARD = 0x0002;
    static final int INPUTLANGCHANGE_BACKWARD = 0x0004;
    static final int KL_NAMELENGTH = 9;
    static final int GMMP_USE_DISPLAY_POINTS = 1;
    static final int GMMP_USE_HIGH_RESOLUTION_POINTS = 2;
    static final int DESKTOP_READOBJECTS = 0x0001;
    static final int DESKTOP_CREATEWINDOW = 0x0002;
    static final int DESKTOP_CREATEMENU = 0x0004;
    static final int DESKTOP_HOOKCONTROL = 0x0008;
    static final int DESKTOP_JOURNALRECORD = 0x0010;
    static final int DESKTOP_JOURNALPLAYBACK = 0x0020;
    static final int DESKTOP_ENUMERATE = 0x0040;
    static final int DESKTOP_WRITEOBJECTS = 0x0080;
    static final int DESKTOP_SWITCHDESKTOP = 0x0100;
    static final int DF_ALLOWOTHERACCOUNTHOOK = 0x0001;
    static final int WINSTA_ENUMDESKTOPS = 0x0001;
    static final int WINSTA_READATTRIBUTES = 0x0002;
    static final int WINSTA_ACCESSCLIPBOARD = 0x0004;
    static final int WINSTA_CREATEDESKTOP = 0x0008;
    static final int WINSTA_WRITEATTRIBUTES = 0x0010;
    static final int WINSTA_ACCESSGLOBALATOMS = 0x0020;
    static final int WINSTA_EXITWINDOWS = 0x0040;
    static final int WINSTA_ENUMERATE = 0x0100;
    static final int WINSTA_READSCREEN = 0x0200;
    static final int WINSTA_ALL_ACCESS = (WINSTA_ENUMDESKTOPS | WINSTA_READATTRIBUTES | WINSTA_ACCESSCLIPBOARD | WINSTA_CREATEDESKTOP | WINSTA_WRITEATTRIBUTES | WINSTA_ACCESSGLOBALATOMS | WINSTA_EXITWINDOWS | WINSTA_ENUMERATE | WINSTA_READSCREEN);
    static final int WSF_VISIBLE = 0x0001;
    static final int UOI_FLAGS = 1;
    static final int UOI_NAME = 2;
    static final int UOI_TYPE = 3;
    static final int UOI_USER_SID = 4;
    static final int GWL_WNDPROC = (-4);
    static final int GWL_HINSTANCE = (-6);
    static final int GWL_HWNDPARENT = (-8);
    static final int GWL_STYLE = (-16);
    static final int GWL_EXSTYLE = (-20);
    static final int GWL_USERDATA = (-21);
    static final int GWL_ID = (-12);
    static final int GWLP_WNDPROC = (-4);
    static final int GWLP_HINSTANCE = (-6);
    static final int GWLP_HWNDPARENT = (-8);
    static final int GWLP_USERDATA = (-21);
    static final int GWLP_ID = (-12);
    static final int GCL_MENUNAME = (-8);
    static final int GCL_HBRBACKGROUND = (-10);
    static final int GCL_HCURSOR = (-12);
    static final int GCL_HICON = (-14);
    static final int GCL_HMODULE = (-16);
    static final int GCL_CBWNDEXTRA = (-18);
    static final int GCL_CBCLSEXTRA = (-20);
    static final int GCL_WNDPROC = (-24);
    static final int GCL_STYLE = (-26);
    static final int GCW_ATOM = (-32);
    static final int GCL_HICONSM = (-34);
    static final int GCLP_MENUNAME = (-8);
    static final int GCLP_HBRBACKGROUND = (-10);
    static final int GCLP_HCURSOR = (-12);
    static final int GCLP_HICON = (-14);
    static final int GCLP_HMODULE = (-16);
    static final int GCLP_WNDPROC = (-24);
    static final int GCLP_HICONSM = (-34);
    static final int WM_NULL = 0x0000;
    static final int WM_CREATE = 0x0001;
    static final int WM_DESTROY = 0x0002;
    static final int WM_MOVE = 0x0003;
    static final int WM_SIZE = 0x0005;
    static final int WM_ACTIVATE = 0x0006;
    static final int WA_INACTIVE = 0;
    static final int WA_ACTIVE = 1;
    static final int WA_CLICKACTIVE = 2;
    static final int WM_SETFOCUS = 0x0007;
    static final int WM_KILLFOCUS = 0x0008;
    static final int WM_ENABLE = 0x000A;
    static final int WM_SETREDRAW = 0x000B;
    static final int WM_SETTEXT = 0x000C;
    static final int WM_GETTEXT = 0x000D;
    static final int WM_GETTEXTLENGTH = 0x000E;
    static final int WM_PAINT = 0x000F;
    static final int WM_CLOSE = 0x0010;
    static final int WM_QUERYENDSESSION = 0x0011;
    static final int WM_QUERYOPEN = 0x0013;
    static final int WM_ENDSESSION = 0x0016;
    static final int WM_QUIT = 0x0012;
    static final int WM_ERASEBKGND = 0x0014;
    static final int WM_SYSCOLORCHANGE = 0x0015;
    static final int WM_SHOWWINDOW = 0x0018;
    static final int WM_WININICHANGE = 0x001A;
    static final int WM_SETTINGCHANGE = WM_WININICHANGE;
    static final int WM_DEVMODECHANGE = 0x001B;
    static final int WM_ACTIVATEAPP = 0x001C;
    static final int WM_FONTCHANGE = 0x001D;
    static final int WM_TIMECHANGE = 0x001E;
    static final int WM_CANCELMODE = 0x001F;
    static final int WM_SETCURSOR = 0x0020;
    static final int WM_MOUSEACTIVATE = 0x0021;
    static final int WM_CHILDACTIVATE = 0x0022;
    static final int WM_QUEUESYNC = 0x0023;
    static final int WM_GETMINMAXINFO = 0x0024;
    static final int WM_PAINTICON = 0x0026;
    static final int WM_ICONERASEBKGND = 0x0027;
    static final int WM_NEXTDLGCTL = 0x0028;
    static final int WM_SPOOLERSTATUS = 0x002A;
    static final int WM_DRAWITEM = 0x002B;
    static final int WM_MEASUREITEM = 0x002C;
    static final int WM_DELETEITEM = 0x002D;
    static final int WM_VKEYTOITEM = 0x002E;
    static final int WM_CHARTOITEM = 0x002F;
    static final int WM_SETFONT = 0x0030;
    static final int WM_GETFONT = 0x0031;
    static final int WM_SETHOTKEY = 0x0032;
    static final int WM_GETHOTKEY = 0x0033;
    static final int WM_QUERYDRAGICON = 0x0037;
    static final int WM_COMPAREITEM = 0x0039;
    static final int WM_GETOBJECT = 0x003D;
    static final int WM_COMPACTING = 0x0041;
    static final int WM_COMMNOTIFY = 0x0044;
    static final int WM_WINDOWPOSCHANGING = 0x0046;
    static final int WM_WINDOWPOSCHANGED = 0x0047;
    static final int WM_POWER = 0x0048;
    static final int PWR_OK = 1;
    static final int PWR_FAIL = (-1);
    static final int PWR_SUSPENDREQUEST = 1;
    static final int PWR_SUSPENDRESUME = 2;
    static final int PWR_CRITICALRESUME = 3;
    static final int WM_COPYDATA = 0x004A;
    static final int WM_CANCELJOURNAL = 0x004B;
    static final int WM_NOTIFY = 0x004E;
    static final int WM_INPUTLANGCHANGEREQUEST = 0x0050;
    static final int WM_INPUTLANGCHANGE = 0x0051;
    static final int WM_TCARD = 0x0052;
    static final int WM_HELP = 0x0053;
    static final int WM_USERCHANGED = 0x0054;
    static final int WM_NOTIFYFORMAT = 0x0055;
    static final int NFR_ANSI = 1;
    static final int NFR_UNICODE = 2;
    static final int NF_QUERY = 3;
    static final int NF_REQUERY = 4;
    static final int WM_CONTEXTMENU = 0x007B;
    static final int WM_STYLECHANGING = 0x007C;
    static final int WM_STYLECHANGED = 0x007D;
    static final int WM_DISPLAYCHANGE = 0x007E;
    static final int WM_GETICON = 0x007F;
    static final int WM_SETICON = 0x0080;
    static final int WM_NCCREATE = 0x0081;
    static final int WM_NCDESTROY = 0x0082;
    static final int WM_NCCALCSIZE = 0x0083;
    static final int WM_NCHITTEST = 0x0084;
    static final int WM_NCPAINT = 0x0085;
    static final int WM_NCACTIVATE = 0x0086;
    static final int WM_GETDLGCODE = 0x0087;
    static final int WM_SYNCPAINT = 0x0088;
    static final int WM_NCMOUSEMOVE = 0x00A0;
    static final int WM_NCLBUTTONDOWN = 0x00A1;
    static final int WM_NCLBUTTONUP = 0x00A2;
    static final int WM_NCLBUTTONDBLCLK = 0x00A3;
    static final int WM_NCRBUTTONDOWN = 0x00A4;
    static final int WM_NCRBUTTONUP = 0x00A5;
    static final int WM_NCRBUTTONDBLCLK = 0x00A6;
    static final int WM_NCMBUTTONDOWN = 0x00A7;
    static final int WM_NCMBUTTONUP = 0x00A8;
    static final int WM_NCMBUTTONDBLCLK = 0x00A9;
    static final int WM_NCXBUTTONDOWN = 0x00AB;
    static final int WM_NCXBUTTONUP = 0x00AC;
    static final int WM_NCXBUTTONDBLCLK = 0x00AD;
    static final int WM_KEYFIRST = 0x0100;
    static final int WM_KEYDOWN = 0x0100;
    static final int WM_KEYUP = 0x0101;
    static final int WM_CHAR = 0x0102;
    static final int WM_DEADCHAR = 0x0103;
    static final int WM_SYSKEYDOWN = 0x0104;
    static final int WM_SYSKEYUP = 0x0105;
    static final int WM_SYSCHAR = 0x0106;
    static final int WM_SYSDEADCHAR = 0x0107;
    static final int WM_KEYLAST = 0x0108;
    static final int WM_IME_STARTCOMPOSITION = 0x010D;
    static final int WM_IME_ENDCOMPOSITION = 0x010E;
    static final int WM_IME_COMPOSITION = 0x010F;
    static final int WM_IME_KEYLAST = 0x010F;
    static final int WM_INITDIALOG = 0x0110;
    static final int WM_COMMAND = 0x0111;
    static final int WM_SYSCOMMAND = 0x0112;
    static final int WM_TIMER = 0x0113;
    static final int WM_HSCROLL = 0x0114;
    static final int WM_VSCROLL = 0x0115;
    static final int WM_INITMENU = 0x0116;
    static final int WM_INITMENUPOPUP = 0x0117;
    static final int WM_MENUSELECT = 0x011F;
    static final int WM_MENUCHAR = 0x0120;
    static final int WM_ENTERIDLE = 0x0121;
    static final int WM_MENURBUTTONUP = 0x0122;
    static final int WM_MENUDRAG = 0x0123;
    static final int WM_MENUGETOBJECT = 0x0124;
    static final int WM_UNINITMENUPOPUP = 0x0125;
    static final int WM_MENUCOMMAND = 0x0126;
    static final int WM_CHANGEUISTATE = 0x0127;
    static final int WM_UPDATEUISTATE = 0x0128;
    static final int WM_QUERYUISTATE = 0x0129;
    static final int UIS_SET = 1;
    static final int UIS_CLEAR = 2;
    static final int UIS_INITIALIZE = 3;
    static final int UISF_HIDEFOCUS = 0x1;
    static final int UISF_HIDEACCEL = 0x2;
    static final int WM_CTLCOLORMSGBOX = 0x0132;
    static final int WM_CTLCOLOREDIT = 0x0133;
    static final int WM_CTLCOLORLISTBOX = 0x0134;
    static final int WM_CTLCOLORBTN = 0x0135;
    static final int WM_CTLCOLORDLG = 0x0136;
    static final int WM_CTLCOLORSCROLLBAR = 0x0137;
    static final int WM_CTLCOLORSTATIC = 0x0138;
    static final int MN_GETHMENU = 0x01E1;
    static final int WM_MOUSEFIRST = 0x0200;
    static final int WM_MOUSEMOVE = 0x0200;
    static final int WM_LBUTTONDOWN = 0x0201;
    static final int WM_LBUTTONUP = 0x0202;
    static final int WM_LBUTTONDBLCLK = 0x0203;
    static final int WM_RBUTTONDOWN = 0x0204;
    static final int WM_RBUTTONUP = 0x0205;
    static final int WM_RBUTTONDBLCLK = 0x0206;
    static final int WM_MBUTTONDOWN = 0x0207;
    static final int WM_MBUTTONUP = 0x0208;
    static final int WM_MBUTTONDBLCLK = 0x0209;
    static final int WM_MOUSEWHEEL = 0x020A;
    static final int WM_XBUTTONDOWN = 0x020B;
    static final int WM_XBUTTONUP = 0x020C;
    static final int WM_XBUTTONDBLCLK = 0x020D;
    static final int WM_MOUSELAST = 0x020D;
    static final int WHEEL_DELTA = 120;
    static final int XBUTTON1 = 0x0001;
    static final int XBUTTON2 = 0x0002;
    static final int WM_PARENTNOTIFY = 0x0210;
    static final int WM_ENTERMENULOOP = 0x0211;
    static final int WM_EXITMENULOOP = 0x0212;
    static final int WM_NEXTMENU = 0x0213;
    static final int WM_SIZING = 0x0214;
    static final int WM_CAPTURECHANGED = 0x0215;
    static final int WM_MOVING = 0x0216;
    static final int WM_POWERBROADCAST = 0x0218;
    static final int PBT_APMQUERYSUSPEND = 0x0000;
    static final int PBT_APMQUERYSTANDBY = 0x0001;
    static final int PBT_APMQUERYSUSPENDFAILED = 0x0002;
    static final int PBT_APMQUERYSTANDBYFAILED = 0x0003;
    static final int PBT_APMSUSPEND = 0x0004;
    static final int PBT_APMSTANDBY = 0x0005;
    static final int PBT_APMRESUMECRITICAL = 0x0006;
    static final int PBT_APMRESUMESUSPEND = 0x0007;
    static final int PBT_APMRESUMESTANDBY = 0x0008;
    static final int PBTF_APMRESUMEFROMFAILURE = 0x00000001;
    static final int PBT_APMBATTERYLOW = 0x0009;
    static final int PBT_APMPOWERSTATUSCHANGE = 0x000A;
    static final int PBT_APMOEMEVENT = 0x000B;
    static final int PBT_APMRESUMEAUTOMATIC = 0x0012;
    static final int WM_DEVICECHANGE = 0x0219;
    static final int WM_MDICREATE = 0x0220;
    static final int WM_MDIDESTROY = 0x0221;
    static final int WM_MDIACTIVATE = 0x0222;
    static final int WM_MDIRESTORE = 0x0223;
    static final int WM_MDINEXT = 0x0224;
    static final int WM_MDIMAXIMIZE = 0x0225;
    static final int WM_MDITILE = 0x0226;
    static final int WM_MDICASCADE = 0x0227;
    static final int WM_MDIICONARRANGE = 0x0228;
    static final int WM_MDIGETACTIVE = 0x0229;
    static final int WM_MDISETMENU = 0x0230;
    static final int WM_ENTERSIZEMOVE = 0x0231;
    static final int WM_EXITSIZEMOVE = 0x0232;
    static final int WM_DROPFILES = 0x0233;
    static final int WM_MDIREFRESHMENU = 0x0234;
    static final int WM_IME_SETCONTEXT = 0x0281;
    static final int WM_IME_NOTIFY = 0x0282;
    static final int WM_IME_CONTROL = 0x0283;
    static final int WM_IME_COMPOSITIONFULL = 0x0284;
    static final int WM_IME_SELECT = 0x0285;
    static final int WM_IME_CHAR = 0x0286;
    static final int WM_IME_REQUEST = 0x0288;
    static final int WM_IME_KEYDOWN = 0x0290;
    static final int WM_IME_KEYUP = 0x0291;
    static final int WM_MOUSEHOVER = 0x02A1;
    static final int WM_MOUSELEAVE = 0x02A3;
    static final int WM_NCMOUSEHOVER = 0x02A0;
    static final int WM_NCMOUSELEAVE = 0x02A2;
    static final int WM_CUT = 0x0300;
    static final int WM_COPY = 0x0301;
    static final int WM_PASTE = 0x0302;
    static final int WM_CLEAR = 0x0303;
    static final int WM_UNDO = 0x0304;
    static final int WM_RENDERFORMAT = 0x0305;
    static final int WM_RENDERALLFORMATS = 0x0306;
    static final int WM_DESTROYCLIPBOARD = 0x0307;
    static final int WM_DRAWCLIPBOARD = 0x0308;
    static final int WM_PAINTCLIPBOARD = 0x0309;
    static final int WM_VSCROLLCLIPBOARD = 0x030A;
    static final int WM_SIZECLIPBOARD = 0x030B;
    static final int WM_ASKCBFORMATNAME = 0x030C;
    static final int WM_CHANGECBCHAIN = 0x030D;
    static final int WM_HSCROLLCLIPBOARD = 0x030E;
    static final int WM_QUERYNEWPALETTE = 0x030F;
    static final int WM_PALETTEISCHANGING = 0x0310;
    static final int WM_PALETTECHANGED = 0x0311;
    static final int WM_HOTKEY = 0x0312;
    static final int WM_PRINT = 0x0317;
    static final int WM_PRINTCLIENT = 0x0318;
    static final int WM_APPCOMMAND = 0x0319;
    static final int WM_HANDHELDFIRST = 0x0358;
    static final int WM_HANDHELDLAST = 0x035F;
    static final int WM_AFXFIRST = 0x0360;
    static final int WM_AFXLAST = 0x037F;
    static final int WM_PENWINFIRST = 0x0380;
    static final int WM_PENWINLAST = 0x038F;
    static final int WM_APP = 0x8000;
    static final int WM_USER = 0x0400;
    static final int WMSZ_LEFT = 1;
    static final int WMSZ_RIGHT = 2;
    static final int WMSZ_TOP = 3;
    static final int WMSZ_TOPLEFT = 4;
    static final int WMSZ_TOPRIGHT = 5;
    static final int WMSZ_BOTTOM = 6;
    static final int WMSZ_BOTTOMLEFT = 7;
    static final int WMSZ_BOTTOMRIGHT = 8;
    static final int HTERROR = (-2);
    static final int HTTRANSPARENT = (-1);
    static final int HTNOWHERE = 0;
    static final int HTCLIENT = 1;
    static final int HTCAPTION = 2;
    static final int HTSYSMENU = 3;
    static final int HTGROWBOX = 4;
    static final int HTSIZE = HTGROWBOX;
    static final int HTMENU = 5;
    static final int HTHSCROLL = 6;
    static final int HTVSCROLL = 7;
    static final int HTMINBUTTON = 8;
    static final int HTMAXBUTTON = 9;
    static final int HTLEFT = 10;
    static final int HTRIGHT = 11;
    static final int HTTOP = 12;
    static final int HTTOPLEFT = 13;
    static final int HTTOPRIGHT = 14;
    static final int HTBOTTOM = 15;
    static final int HTBOTTOMLEFT = 16;
    static final int HTBOTTOMRIGHT = 17;
    static final int HTBORDER = 18;
    static final int HTREDUCE = HTMINBUTTON;
    static final int HTZOOM = HTMAXBUTTON;
    static final int HTSIZEFIRST = HTLEFT;
    static final int HTSIZELAST = HTBOTTOMRIGHT;
    static final int HTOBJECT = 19;
    static final int HTCLOSE = 20;
    static final int HTHELP = 21;
    static final int SMTO_NORMAL = 0x0000;
    static final int SMTO_BLOCK = 0x0001;
    static final int SMTO_ABORTIFHUNG = 0x0002;
    static final int SMTO_NOTIMEOUTIFNOTHUNG = 0x0008;
    static final int MA_ACTIVATE = 1;
    static final int MA_ACTIVATEANDEAT = 2;
    static final int MA_NOACTIVATE = 3;
    static final int MA_NOACTIVATEANDEAT = 4;
    static final int ICON_SMALL = 0;
    static final int ICON_BIG = 1;
    static final int SIZE_RESTORED = 0;
    static final int SIZE_MINIMIZED = 1;
    static final int SIZE_MAXIMIZED = 2;
    static final int SIZE_MAXSHOW = 3;
    static final int SIZE_MAXHIDE = 4;
    static final int SIZENORMAL = SIZE_RESTORED;
    static final int SIZEICONIC = SIZE_MINIMIZED;
    static final int SIZEFULLSCREEN = SIZE_MAXIMIZED;
    static final int SIZEZOOMSHOW = SIZE_MAXSHOW;
    static final int SIZEZOOMHIDE = SIZE_MAXHIDE;
    static final int WVR_ALIGNTOP = 0x0010;
    static final int WVR_ALIGNLEFT = 0x0020;
    static final int WVR_ALIGNBOTTOM = 0x0040;
    static final int WVR_ALIGNRIGHT = 0x0080;
    static final int WVR_HREDRAW = 0x0100;
    static final int WVR_VREDRAW = 0x0200;
    static final int WVR_REDRAW = (WVR_HREDRAW | WVR_VREDRAW);
    static final int WVR_VALIDRECTS = 0x0400;
    static final int MK_LBUTTON = 0x0001;
    static final int MK_RBUTTON = 0x0002;
    static final int MK_SHIFT = 0x0004;
    static final int MK_CONTROL = 0x0008;
    static final int MK_MBUTTON = 0x0010;
    static final int MK_XBUTTON1 = 0x0020;
    static final int MK_XBUTTON2 = 0x0040;
    static final int TME_HOVER = 0x00000001;
    static final int TME_LEAVE = 0x00000002;
    static final int TME_NONCLIENT = 0x00000010;
    static final int TME_QUERY = 0x40000000;
    static final int TME_CANCEL = 0x80000000;
    static final int HOVER_DEFAULT = 0xFFFFFFFF;
    static final int WS_OVERLAPPED = 0x00000000;
    static final int WS_POPUP = 0x80000000;
    static final int WS_CHILD = 0x40000000;
    static final int WS_MINIMIZE = 0x20000000;
    static final int WS_VISIBLE = 0x10000000;
    static final int WS_DISABLED = 0x08000000;
    static final int WS_CLIPSIBLINGS = 0x04000000;
    static final int WS_CLIPCHILDREN = 0x02000000;
    static final int WS_MAXIMIZE = 0x01000000;
    static final int WS_CAPTION = 0x00C00000;
    static final int WS_BORDER = 0x00800000;
    static final int WS_DLGFRAME = 0x00400000;
    static final int WS_VSCROLL = 0x00200000;
    static final int WS_HSCROLL = 0x00100000;
    static final int WS_SYSMENU = 0x00080000;
    static final int WS_THICKFRAME = 0x00040000;
    static final int WS_GROUP = 0x00020000;
    static final int WS_TABSTOP = 0x00010000;
    static final int WS_MINIMIZEBOX = 0x00020000;
    static final int WS_MAXIMIZEBOX = 0x00010000;
    static final int WS_TILED = WS_OVERLAPPED;
    static final int WS_ICONIC = WS_MINIMIZE;
    static final int WS_SIZEBOX = WS_THICKFRAME;
    static final int WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX);
    static final int WS_POPUPWINDOW = (WS_POPUP | WS_BORDER | WS_SYSMENU);
    static final int WS_CHILDWINDOW = (WS_CHILD);
    static final int WS_EX_DLGMODALFRAME = 0x00000001;
    static final int WS_EX_NOPARENTNOTIFY = 0x00000004;
    static final int WS_EX_TOPMOST = 0x00000008;
    static final int WS_EX_ACCEPTFILES = 0x00000010;
    static final int WS_EX_TRANSPARENT = 0x00000020;
    static final int WS_EX_MDICHILD = 0x00000040;
    static final int WS_EX_TOOLWINDOW = 0x00000080;
    static final int WS_EX_WINDOWEDGE = 0x00000100;
    static final int WS_EX_CLIENTEDGE = 0x00000200;
    static final int WS_EX_CONTEXTHELP = 0x00000400;
    static final int WS_EX_RIGHT = 0x00001000;
    static final int WS_EX_LEFT = 0x00000000;
    static final int WS_EX_RTLREADING = 0x00002000;
    static final int WS_EX_LTRREADING = 0x00000000;
    static final int WS_EX_LEFTSCROLLBAR = 0x00004000;
    static final int WS_EX_RIGHTSCROLLBAR = 0x00000000;
    static final int WS_EX_CONTROLPARENT = 0x00010000;
    static final int WS_EX_STATICEDGE = 0x00020000;
    static final int WS_EX_APPWINDOW = 0x00040000;
    static final int WS_EX_OVERLAPPEDWINDOW = (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE);
    static final int WS_EX_PALETTEWINDOW = (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST);
    static final int WS_EX_LAYERED = 0x00080000;
    static final int WS_EX_NOINHERITLAYOUT = 0x00100000;
    static final int WS_EX_LAYOUTRTL = 0x00400000;
    static final int WS_EX_COMPOSITED = 0x02000000;
    static final int WS_EX_NOACTIVATE = 0x08000000;
    static final int CS_VREDRAW = 0x0001;
    static final int CS_HREDRAW = 0x0002;
    static final int CS_DBLCLKS = 0x0008;
    static final int CS_OWNDC = 0x0020;
    static final int CS_CLASSDC = 0x0040;
    static final int CS_PARENTDC = 0x0080;
    static final int CS_NOCLOSE = 0x0200;
    static final int CS_SAVEBITS = 0x0800;
    static final int CS_BYTEALIGNCLIENT = 0x1000;
    static final int CS_BYTEALIGNWINDOW = 0x2000;
    static final int CS_GLOBALCLASS = 0x4000;
    static final int CS_IME = 0x00010000;
    static final int PRF_CHECKVISIBLE = 0x00000001;
    static final int PRF_NONCLIENT = 0x00000002;
    static final int PRF_CLIENT = 0x00000004;
    static final int PRF_ERASEBKGND = 0x00000008;
    static final int PRF_CHILDREN = 0x00000010;
    static final int PRF_OWNED = 0x00000020;
    static final int BDR_RAISEDOUTER = 0x0001;
    static final int BDR_SUNKENOUTER = 0x0002;
    static final int BDR_RAISEDINNER = 0x0004;
    static final int BDR_SUNKENINNER = 0x0008;
    static final int BDR_OUTER = (BDR_RAISEDOUTER | BDR_SUNKENOUTER);
    static final int BDR_INNER = (BDR_RAISEDINNER | BDR_SUNKENINNER);
    static final int BDR_RAISED = (BDR_RAISEDOUTER | BDR_RAISEDINNER);
    static final int BDR_SUNKEN = (BDR_SUNKENOUTER | BDR_SUNKENINNER);
    static final int EDGE_RAISED = (BDR_RAISEDOUTER | BDR_RAISEDINNER);
    static final int EDGE_SUNKEN = (BDR_SUNKENOUTER | BDR_SUNKENINNER);
    static final int EDGE_ETCHED = (BDR_SUNKENOUTER | BDR_RAISEDINNER);
    static final int EDGE_BUMP = (BDR_RAISEDOUTER | BDR_SUNKENINNER);
    static final int BF_LEFT = 0x0001;
    static final int BF_TOP = 0x0002;
    static final int BF_RIGHT = 0x0004;
    static final int BF_BOTTOM = 0x0008;
    static final int BF_TOPLEFT = (BF_TOP | BF_LEFT);
    static final int BF_TOPRIGHT = (BF_TOP | BF_RIGHT);
    static final int BF_BOTTOMLEFT = (BF_BOTTOM | BF_LEFT);
    static final int BF_BOTTOMRIGHT = (BF_BOTTOM | BF_RIGHT);
    static final int BF_RECT = (BF_LEFT | BF_TOP | BF_RIGHT | BF_BOTTOM);
    static final int BF_DIAGONAL = 0x0010;
    static final int BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL | BF_TOP | BF_RIGHT);
    static final int BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL | BF_TOP | BF_LEFT);
    static final int BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL | BF_BOTTOM | BF_LEFT);
    static final int BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL | BF_BOTTOM | BF_RIGHT);
    static final int BF_MIDDLE = 0x0800;
    static final int BF_SOFT = 0x1000;
    static final int BF_ADJUST = 0x2000;
    static final int BF_FLAT = 0x4000;
    static final int BF_MONO = 0x8000;
    static final int DFC_CAPTION = 1;
    static final int DFC_MENU = 2;
    static final int DFC_SCROLL = 3;
    static final int DFC_BUTTON = 4;
    static final int DFC_POPUPMENU = 5;
    static final int DFCS_CAPTIONCLOSE = 0x0000;
    static final int DFCS_CAPTIONMIN = 0x0001;
    static final int DFCS_CAPTIONMAX = 0x0002;
    static final int DFCS_CAPTIONRESTORE = 0x0003;
    static final int DFCS_CAPTIONHELP = 0x0004;
    static final int DFCS_MENUARROW = 0x0000;
    static final int DFCS_MENUCHECK = 0x0001;
    static final int DFCS_MENUBULLET = 0x0002;
    static final int DFCS_MENUARROWRIGHT = 0x0004;
    static final int DFCS_SCROLLUP = 0x0000;
    static final int DFCS_SCROLLDOWN = 0x0001;
    static final int DFCS_SCROLLLEFT = 0x0002;
    static final int DFCS_SCROLLRIGHT = 0x0003;
    static final int DFCS_SCROLLCOMBOBOX = 0x0005;
    static final int DFCS_SCROLLSIZEGRIP = 0x0008;
    static final int DFCS_SCROLLSIZEGRIPRIGHT = 0x0010;
    static final int DFCS_BUTTONCHECK = 0x0000;
    static final int DFCS_BUTTONRADIOIMAGE = 0x0001;
    static final int DFCS_BUTTONRADIOMASK = 0x0002;
    static final int DFCS_BUTTONRADIO = 0x0004;
    static final int DFCS_BUTTON3STATE = 0x0008;
    static final int DFCS_BUTTONPUSH = 0x0010;
    static final int DFCS_INACTIVE = 0x0100;
    static final int DFCS_PUSHED = 0x0200;
    static final int DFCS_CHECKED = 0x0400;
    static final int DFCS_TRANSPARENT = 0x0800;
    static final int DFCS_HOT = 0x1000;
    static final int DFCS_ADJUSTRECT = 0x2000;
    static final int DFCS_FLAT = 0x4000;
    static final int DFCS_MONO = 0x8000;
    static final int DC_ACTIVE = 0x0001;
    static final int DC_SMALLCAP = 0x0002;
    static final int DC_ICON = 0x0004;
    static final int DC_TEXT = 0x0008;
    static final int DC_INBUTTON = 0x0010;
    static final int DC_GRADIENT = 0x0020;
    static final int IDANI_OPEN = 1;
    static final int IDANI_CAPTION = 3;
    static final int CF_TEXT = 1;
    static final int CF_BITMAP = 2;
    static final int CF_METAFILEPICT = 3;
    static final int CF_SYLK = 4;
    static final int CF_DIF = 5;
    static final int CF_TIFF = 6;
    static final int CF_OEMTEXT = 7;
    static final int CF_DIB = 8;
    static final int CF_PALETTE = 9;
    static final int CF_PENDATA = 10;
    static final int CF_RIFF = 11;
    static final int CF_WAVE = 12;
    static final int CF_UNICODETEXT = 13;
    static final int CF_ENHMETAFILE = 14;
    static final int CF_HDROP = 15;
    static final int CF_LOCALE = 16;
    static final int CF_DIBV5 = 17;
    static final int CF_MAX = 18;
    static final int CF_OWNERDISPLAY = 0x0080;
    static final int CF_DSPTEXT = 0x0081;
    static final int CF_DSPBITMAP = 0x0082;
    static final int CF_DSPMETAFILEPICT = 0x0083;
    static final int CF_DSPENHMETAFILE = 0x008E;
    static final int CF_PRIVATEFIRST = 0x0200;
    static final int CF_PRIVATELAST = 0x02FF;
    static final int CF_GDIOBJFIRST = 0x0300;
    static final int CF_GDIOBJLAST = 0x03FF;
    static final int FVIRTKEY = TRUE;
    static final int FNOINVERT = 0x02;
    static final int FSHIFT = 0x04;
    static final int FCONTROL = 0x08;
    static final int FALT = 0x10;
    static final int WPF_SETMINPOSITION = 0x0001;
    static final int WPF_RESTORETOMAXIMIZED = 0x0002;
    static final int WPF_ASYNCWINDOWPLACEMENT = 0x0004;
    static final int ODT_MENU = 1;
    static final int ODT_LISTBOX = 2;
    static final int ODT_COMBOBOX = 3;
    static final int ODT_BUTTON = 4;
    static final int ODT_STATIC = 5;
    static final int ODA_DRAWENTIRE = 0x0001;
    static final int ODA_SELECT = 0x0002;
    static final int ODA_FOCUS = 0x0004;
    static final int ODS_SELECTED = 0x0001;
    static final int ODS_GRAYED = 0x0002;
    static final int ODS_DISABLED = 0x0004;
    static final int ODS_CHECKED = 0x0008;
    static final int ODS_FOCUS = 0x0010;
    static final int ODS_DEFAULT = 0x0020;
    static final int ODS_COMBOBOXEDIT = 0x1000;
    static final int ODS_HOTLIGHT = 0x0040;
    static final int ODS_INACTIVE = 0x0080;
    static final int ODS_NOACCEL = 0x0100;
    static final int ODS_NOFOCUSRECT = 0x0200;
    static final int PM_NOREMOVE = 0x0000;
    static final int PM_REMOVE = 0x0001;
    static final int PM_NOYIELD = 0x0002;
    static final int MOD_WIN = 0x0008;
    static final int IDHOT_SNAPWINDOW = (-1);
    static final int IDHOT_SNAPDESKTOP = (-2);
    static final int ENDSESSION_LOGOFF = 0x80000000;
    static final int EWX_LOGOFF = 0;
    static final int EWX_SHUTDOWN = 0x00000001;
    static final int EWX_REBOOT = 0x00000002;
    static final int EWX_FORCE = 0x00000004;
    static final int EWX_POWEROFF = 0x00000008;
    static final int EWX_FORCEIFHUNG = 0x00000010;
    static final int BSM_ALLCOMPONENTS = 0x00000000;
    static final int BSM_VXDS = 0x00000001;
    static final int BSM_NETDRIVER = 0x00000002;
    static final int BSM_INSTALLABLEDRIVERS = 0x00000004;
    static final int BSM_APPLICATIONS = 0x00000008;
    static final int BSM_ALLDESKTOPS = 0x00000010;
    static final int BSF_QUERY = 0x00000001;
    static final int BSF_IGNORECURRENTTASK = 0x00000002;
    static final int BSF_FLUSHDISK = 0x00000004;
    static final int BSF_NOHANG = 0x00000008;
    static final int BSF_POSTMESSAGE = 0x00000010;
    static final int BSF_FORCEIFHUNG = 0x00000020;
    static final int BSF_NOTIMEOUTIFNOTHUNG = 0x00000040;
    static final int BSF_ALLOWSFW = 0x00000080;
    static final int BSF_SENDNOTIFYMESSAGE = 0x00000100;
    static final int BROADCAST_QUERY_DENY = 0x424D5144;
    static final int DEVICE_NOTIFY_WINDOW_HANDLE = 0x00000000;
    static final int DEVICE_NOTIFY_SERVICE_HANDLE = 0x00000001;
    static final int HWND_BROADCAST = (0xffff);
    static final int HWND_MESSAGE = (-3);
    static final int ISMEX_NOSEND = 0x00000000;
    static final int ISMEX_SEND = 0x00000001;
    static final int ISMEX_NOTIFY = 0x00000002;
    static final int ISMEX_CALLBACK = 0x00000004;
    static final int ISMEX_REPLIED = 0x00000008;
    static final int CW_USEDEFAULT = (0x80000000);
    static final int HWND_DESKTOP = (0);
    static final int LWA_COLORKEY = 0x00000001;
    static final int LWA_ALPHA = 0x00000002;
    static final int ULW_COLORKEY = 0x00000001;
    static final int ULW_ALPHA = 0x00000002;
    static final int ULW_OPAQUE = 0x00000004;
    static final int FLASHW_STOP = 0;
    static final int FLASHW_CAPTION = 0x00000001;
    static final int FLASHW_TRAY = 0x00000002;
    static final int FLASHW_ALL = (FLASHW_CAPTION | FLASHW_TRAY);
    static final int FLASHW_TIMER = 0x00000004;
    static final int FLASHW_TIMERNOFG = 0x0000000C;
    static final int SWP_NOSIZE = 0x0001;
    static final int SWP_NOMOVE = 0x0002;
    static final int SWP_NOZORDER = 0x0004;
    static final int SWP_NOREDRAW = 0x0008;
    static final int SWP_NOACTIVATE = 0x0010;
    static final int SWP_FRAMECHANGED = 0x0020;
    static final int SWP_SHOWWINDOW = 0x0040;
    static final int SWP_HIDEWINDOW = 0x0080;
    static final int SWP_NOCOPYBITS = 0x0100;
    static final int SWP_NOOWNERZORDER = 0x0200;
    static final int SWP_NOSENDCHANGING = 0x0400;
    static final int SWP_DRAWFRAME = SWP_FRAMECHANGED;
    static final int SWP_NOREPOSITION = SWP_NOOWNERZORDER;
    static final int SWP_DEFERERASE = 0x2000;
    static final int SWP_ASYNCWINDOWPOS = 0x4000;
    static final int HWND_TOP = (0);
    static final int HWND_BOTTOM = (1);
    static final int HWND_TOPMOST = (-1);
    static final int HWND_NOTOPMOST = (-2);
    static final int DLGWINDOWEXTRA = 30;
    static final int KEYEVENTF_EXTENDEDKEY = 0x0001;
    static final int KEYEVENTF_KEYUP = 0x0002;
    static final int KEYEVENTF_UNICODE = 0x0004;
    static final int KEYEVENTF_SCANCODE = 0x0008;
    static final int MOUSEEVENTF_MOVE = 0x0001;
    static final int MOUSEEVENTF_LEFTDOWN = 0x0002;
    static final int MOUSEEVENTF_LEFTUP = 0x0004;
    static final int MOUSEEVENTF_RIGHTDOWN = 0x0008;
    static final int MOUSEEVENTF_RIGHTUP = 0x0010;
    static final int MOUSEEVENTF_MIDDLEDOWN = 0x0020;
    static final int MOUSEEVENTF_MIDDLEUP = 0x0040;
    static final int MOUSEEVENTF_XDOWN = 0x0080;
    static final int MOUSEEVENTF_XUP = 0x0100;
    static final int MOUSEEVENTF_WHEEL = 0x0800;
    static final int MOUSEEVENTF_VIRTUALDESK = 0x4000;
    static final int MOUSEEVENTF_ABSOLUTE = 0x8000;
    static final int INPUT_MOUSE = 0;
    static final int INPUT_KEYBOARD = 1;
    static final int INPUT_HARDWARE = 2;
    static final int MWMO_WAITALL = 0x0001;
    static final int MWMO_ALERTABLE = 0x0002;
    static final int MWMO_INPUTAVAILABLE = 0x0004;
    static final int QS_KEY = 0x0001;
    static final int QS_MOUSEMOVE = 0x0002;
    static final int QS_MOUSEBUTTON = 0x0004;
    static final int QS_POSTMESSAGE = 0x0008;
    static final int QS_TIMER = 0x0010;
    static final int QS_PAINT = 0x0020;
    static final int QS_SENDMESSAGE = 0x0040;
    static final int QS_HOTKEY = 0x0080;
    static final int QS_ALLPOSTMESSAGE = 0x0100;
    static final int QS_MOUSE = (QS_MOUSEMOVE | QS_MOUSEBUTTON);
    static final int QS_INPUT = (QS_MOUSE | QS_KEY);
    static final int QS_ALLEVENTS = (QS_INPUT | QS_POSTMESSAGE | QS_TIMER | QS_PAINT | QS_HOTKEY);
    static final int QS_ALLINPUT = (QS_INPUT | QS_POSTMESSAGE | QS_TIMER | QS_PAINT | QS_HOTKEY | QS_SENDMESSAGE);
    static final int SM_CXSCREEN = 0;
    static final int SM_CYSCREEN = 1;
    static final int SM_CXVSCROLL = 2;
    static final int SM_CYHSCROLL = 3;
    static final int SM_CYCAPTION = 4;
    static final int SM_CXBORDER = 5;
    static final int SM_CYBORDER = 6;
    static final int SM_CXDLGFRAME = 7;
    static final int SM_CYDLGFRAME = 8;
    static final int SM_CYVTHUMB = 9;
    static final int SM_CXHTHUMB = 10;
    static final int SM_CXICON = 11;
    static final int SM_CYICON = 12;
    static final int SM_CXCURSOR = 13;
    static final int SM_CYCURSOR = 14;
    static final int SM_CYMENU = 15;
    static final int SM_CXFULLSCREEN = 16;
    static final int SM_CYFULLSCREEN = 17;
    static final int SM_CYKANJIWINDOW = 18;
    static final int SM_MOUSEPRESENT = 19;
    static final int SM_CYVSCROLL = 20;
    static final int SM_CXHSCROLL = 21;
    static final int SM_DEBUG = 22;
    static final int SM_SWAPBUTTON = 23;
    static final int SM_RESERVED1 = 24;
    static final int SM_RESERVED2 = 25;
    static final int SM_RESERVED3 = 26;
    static final int SM_RESERVED4 = 27;
    static final int SM_CXMIN = 28;
    static final int SM_CYMIN = 29;
    static final int SM_CXSIZE = 30;
    static final int SM_CYSIZE = 31;
    static final int SM_CXFRAME = 32;
    static final int SM_CYFRAME = 33;
    static final int SM_CXMINTRACK = 34;
    static final int SM_CYMINTRACK = 35;
    static final int SM_CXDOUBLECLK = 36;
    static final int SM_CYDOUBLECLK = 37;
    static final int SM_CXICONSPACING = 38;
    static final int SM_CYICONSPACING = 39;
    static final int SM_MENUDROPALIGNMENT = 40;
    static final int SM_PENWINDOWS = 41;
    static final int SM_DBCSENABLED = 42;
    static final int SM_CMOUSEBUTTONS = 43;
    static final int SM_CXFIXEDFRAME = SM_CXDLGFRAME;
    static final int SM_CYFIXEDFRAME = SM_CYDLGFRAME;
    static final int SM_CXSIZEFRAME = SM_CXFRAME;
    static final int SM_CYSIZEFRAME = SM_CYFRAME;
    static final int SM_SECURE = 44;
    static final int SM_CXEDGE = 45;
    static final int SM_CYEDGE = 46;
    static final int SM_CXMINSPACING = 47;
    static final int SM_CYMINSPACING = 48;
    static final int SM_CXSMICON = 49;
    static final int SM_CYSMICON = 50;
    static final int SM_CYSMCAPTION = 51;
    static final int SM_CXSMSIZE = 52;
    static final int SM_CYSMSIZE = 53;
    static final int SM_CXMENUSIZE = 54;
    static final int SM_CYMENUSIZE = 55;
    static final int SM_ARRANGE = 56;
    static final int SM_CXMINIMIZED = 57;
    static final int SM_CYMINIMIZED = 58;
    static final int SM_CXMAXTRACK = 59;
    static final int SM_CYMAXTRACK = 60;
    static final int SM_CXMAXIMIZED = 61;
    static final int SM_CYMAXIMIZED = 62;
    static final int SM_NETWORK = 63;
    static final int SM_CLEANBOOT = 67;
    static final int SM_CXDRAG = 68;
    static final int SM_CYDRAG = 69;
    static final int SM_SHOWSOUNDS = 70;
    static final int SM_CXMENUCHECK = 71;
    static final int SM_CYMENUCHECK = 72;
    static final int SM_SLOWMACHINE = 73;
    static final int SM_MIDEASTENABLED = 74;
    static final int SM_MOUSEWHEELPRESENT = 75;
    static final int SM_XVIRTUALSCREEN = 76;
    static final int SM_YVIRTUALSCREEN = 77;
    static final int SM_CXVIRTUALSCREEN = 78;
    static final int SM_CYVIRTUALSCREEN = 79;
    static final int SM_CMONITORS = 80;
    static final int SM_SAMEDISPLAYFORMAT = 81;
    static final int SM_IMMENABLED = 82;
    static final int SM_CMETRICS = 88;
    static final int SM_REMOTESESSION = 0x1000;
    static final int SM_REMOTECONTROL = 0x2001;
    static final int MNC_IGNORE = 0;
    static final int MNC_CLOSE = 1;
    static final int MNC_EXECUTE = 2;
    static final int MNC_SELECT = 3;
    static final int MNS_NOCHECK = 0x80000000;
    static final int MNS_MODELESS = 0x40000000;
    static final int MNS_DRAGDROP = 0x20000000;
    static final int MNS_AUTODISMISS = 0x10000000;
    static final int MNS_NOTIFYBYPOS = 0x08000000;
    static final int MNS_CHECKORBMP = 0x04000000;
    static final int MIM_MAXHEIGHT = 0x00000001;
    static final int MIM_BACKGROUND = 0x00000002;
    static final int MIM_HELPID = 0x00000004;
    static final int MIM_MENUDATA = 0x00000008;
    static final int MIM_STYLE = 0x00000010;
    static final int MIM_APPLYTOSUBMENUS = 0x80000000;
    static final int MND_CONTINUE = 0;
    static final int MND_ENDMENU = 1;
    static final int MNGOF_TOPGAP = 0x00000001;
    static final int MNGOF_BOTTOMGAP = 0x00000002;
    static final int MNGO_NOINTERFACE = 0x00000000;
    static final int MNGO_NOERROR = 0x00000001;
    static final int MIIM_STATE = 0x00000001;
    static final int MIIM_ID = 0x00000002;
    static final int MIIM_SUBMENU = 0x00000004;
    static final int MIIM_CHECKMARKS = 0x00000008;
    static final int MIIM_TYPE = 0x00000010;
    static final int MIIM_DATA = 0x00000020;
    static final int MIIM_STRING = 0x00000040;
    static final int MIIM_BITMAP = 0x00000080;
    static final int MIIM_FTYPE = 0x00000100;
    static final int GMDI_USEDISABLED = 0x0001;
    static final int GMDI_GOINTOPOPUPS = 0x0002;
    static final int TPM_LEFTBUTTON = 0x0000;
    static final int TPM_RIGHTBUTTON = 0x0002;
    static final int TPM_LEFTALIGN = 0x0000;
    static final int TPM_CENTERALIGN = 0x0004;
    static final int TPM_RIGHTALIGN = 0x0008;
    static final int TPM_TOPALIGN = 0x0000;
    static final int TPM_VCENTERALIGN = 0x0010;
    static final int TPM_BOTTOMALIGN = 0x0020;
    static final int TPM_HORIZONTAL = 0x0000;
    static final int TPM_VERTICAL = 0x0040;
    static final int TPM_NONOTIFY = 0x0080;
    static final int TPM_RETURNCMD = 0x0100;
    static final int TPM_RECURSE = 0x0001;
    static final int TPM_HORPOSANIMATION = 0x0400;
    static final int TPM_HORNEGANIMATION = 0x0800;
    static final int TPM_VERPOSANIMATION = 0x1000;
    static final int TPM_VERNEGANIMATION = 0x2000;
    static final int TPM_NOANIMATION = 0x4000;
    static final int DOF_EXECUTABLE = 0x8001;
    static final int DOF_DOCUMENT = 0x8002;
    static final int DOF_DIRECTORY = 0x8003;
    static final int DOF_MULTIPLE = 0x8004;
    static final int DOF_PROGMAN = 0x0001;
    static final int DOF_SHELLDATA = 0x0002;
    static final int DO_DROPFILE = 0x454C4946;
    static final int DO_PRINTFILE = 0x544E5250;
    static final int DT_TOP = 0x00000000;
    static final int DT_LEFT = 0x00000000;
    static final int DT_CENTER = 0x00000001;
    static final int DT_RIGHT = 0x00000002;
    static final int DT_VCENTER = 0x00000004;
    static final int DT_BOTTOM = 0x00000008;
    static final int DT_WORDBREAK = 0x00000010;
    static final int DT_SINGLELINE = 0x00000020;
    static final int DT_EXPANDTABS = 0x00000040;
    static final int DT_TABSTOP = 0x00000080;
    static final int DT_NOCLIP = 0x00000100;
    static final int DT_EXTERNALLEADING = 0x00000200;
    static final int DT_CALCRECT = 0x00000400;
    static final int DT_NOPREFIX = 0x00000800;
    static final int DT_INTERNAL = 0x00001000;
    static final int DT_EDITCONTROL = 0x00002000;
    static final int DT_PATH_ELLIPSIS = 0x00004000;
    static final int DT_END_ELLIPSIS = 0x00008000;
    static final int DT_MODIFYSTRING = 0x00010000;
    static final int DT_RTLREADING = 0x00020000;
    static final int DT_WORD_ELLIPSIS = 0x00040000;
    static final int DT_NOFULLWIDTHCHARBREAK = 0x00080000;
    static final int DT_HIDEPREFIX = 0x00100000;
    static final int DT_PREFIXONLY = 0x00200000;
    static final int DST_COMPLEX = 0x0000;
    static final int DST_TEXT = 0x0001;
    static final int DST_PREFIXTEXT = 0x0002;
    static final int DST_ICON = 0x0003;
    static final int DST_BITMAP = 0x0004;
    static final int DSS_NORMAL = 0x0000;
    static final int DSS_UNION = 0x0010;
    static final int DSS_DISABLED = 0x0020;
    static final int DSS_MONO = 0x0080;
    static final int DSS_HIDEPREFIX = 0x0200;
    static final int DSS_PREFIXONLY = 0x0400;
    static final int DSS_RIGHT = 0x8000;
    static final int LSFW_LOCK = 1;
    static final int LSFW_UNLOCK = 2;
    static final int DCX_WINDOW = 0x00000001;
    static final int DCX_CACHE = 0x00000002;
    static final int DCX_NORESETATTRS = 0x00000004;
    static final int DCX_CLIPCHILDREN = 0x00000008;
    static final int DCX_CLIPSIBLINGS = 0x00000010;
    static final int DCX_PARENTCLIP = 0x00000020;
    static final int DCX_EXCLUDERGN = 0x00000040;
    static final int DCX_INTERSECTRGN = 0x00000080;
    static final int DCX_EXCLUDEUPDATE = 0x00000100;
    static final int DCX_INTERSECTUPDATE = 0x00000200;
    static final int DCX_LOCKWINDOWUPDATE = 0x00000400;
    static final int DCX_VALIDATE = 0x00200000;
    static final int RDW_INVALIDATE = 0x0001;
    static final int RDW_INTERNALPAINT = 0x0002;
    static final int RDW_ERASE = 0x0004;
    static final int RDW_VALIDATE = 0x0008;
    static final int RDW_NOINTERNALPAINT = 0x0010;
    static final int RDW_NOERASE = 0x0020;
    static final int RDW_NOCHILDREN = 0x0040;
    static final int RDW_ALLCHILDREN = 0x0080;
    static final int RDW_UPDATENOW = 0x0100;
    static final int RDW_ERASENOW = 0x0200;
    static final int RDW_FRAME = 0x0400;
    static final int RDW_NOFRAME = 0x0800;
    static final int SW_SCROLLCHILDREN = 0x0001;
    static final int SW_INVALIDATE = 0x0002;
    static final int SW_ERASE = 0x0004;
    static final int SW_SMOOTHSCROLL = 0x0010;
    static final int ESB_ENABLE_BOTH = 0x0000;
    static final int ESB_DISABLE_BOTH = 0x0003;
    static final int ESB_DISABLE_LEFT = 0x0001;
    static final int ESB_DISABLE_RIGHT = 0x0002;
    static final int ESB_DISABLE_UP = 0x0001;
    static final int ESB_DISABLE_DOWN = 0x0002;
    static final int ESB_DISABLE_LTUP = ESB_DISABLE_LEFT;
    static final int ESB_DISABLE_RTDN = ESB_DISABLE_RIGHT;
    static final int HELPINFO_WINDOW = 0x0001;
    static final int HELPINFO_MENUITEM = 0x0002;
    static final int MB_OK = 0x00000000;
    static final int MB_OKCANCEL = 0x00000001;
    static final int MB_ABORTRETRYIGNORE = 0x00000002;
    static final int MB_YESNOCANCEL = 0x00000003;
    static final int MB_YESNO = 0x00000004;
    static final int MB_RETRYCANCEL = 0x00000005;
    static final int MB_CANCELTRYCONTINUE = 0x00000006;
    static final int MB_ICONHAND = 0x00000010;
    static final int MB_ICONQUESTION = 0x00000020;
    static final int MB_ICONEXCLAMATION = 0x00000030;
    static final int MB_ICONASTERISK = 0x00000040;
    static final int MB_USERICON = 0x00000080;
    static final int MB_ICONWARNING = MB_ICONEXCLAMATION;
    static final int MB_ICONERROR = MB_ICONHAND;
    static final int MB_ICONINFORMATION = MB_ICONASTERISK;
    static final int MB_ICONSTOP = MB_ICONHAND;
    static final int MB_DEFBUTTON1 = 0x00000000;
    static final int MB_DEFBUTTON2 = 0x00000100;
    static final int MB_DEFBUTTON3 = 0x00000200;
    static final int MB_DEFBUTTON4 = 0x00000300;
    static final int MB_APPLMODAL = 0x00000000;
    static final int MB_SYSTEMMODAL = 0x00001000;
    static final int MB_TASKMODAL = 0x00002000;
    static final int MB_HELP = 0x00004000;
    static final int MB_NOFOCUS = 0x00008000;
    static final int MB_SETFOREGROUND = 0x00010000;
    static final int MB_DEFAULT_DESKTOP_ONLY = 0x00020000;
    static final int MB_TOPMOST = 0x00040000;
    static final int MB_RIGHT = 0x00080000;
    static final int MB_RTLREADING = 0x00100000;
    static final int MB_SERVICE_NOTIFICATION = 0x00200000;
    static final int MB_SERVICE_NOTIFICATION_NT3X = 0x00040000;
    static final int MB_TYPEMASK = 0x0000000F;
    static final int MB_ICONMASK = 0x000000F0;
    static final int MB_DEFMASK = 0x00000F00;
    static final int MB_MODEMASK = 0x00003000;
    static final int MB_MISCMASK = 0x0000C000;
    static final int CWP_ALL = 0x0000;
    static final int CWP_SKIPINVISIBLE = 0x0001;
    static final int CWP_SKIPDISABLED = 0x0002;
    static final int CWP_SKIPTRANSPARENT = 0x0004;
    static final int CTLCOLOR_MSGBOX = 0;
    static final int CTLCOLOR_EDIT = 1;
    static final int CTLCOLOR_LISTBOX = 2;
    static final int CTLCOLOR_BTN = 3;
    static final int CTLCOLOR_DLG = 4;
    static final int CTLCOLOR_SCROLLBAR = 5;
    static final int CTLCOLOR_STATIC = 6;
    static final int CTLCOLOR_MAX = 7;
    static final int COLOR_SCROLLBAR = 0;
    static final int COLOR_BACKGROUND = 1;
    static final int COLOR_ACTIVECAPTION = 2;
    static final int COLOR_INACTIVECAPTION = 3;
    static final int COLOR_MENU = 4;
    static final int COLOR_WINDOW = 5;
    static final int COLOR_WINDOWFRAME = 6;
    static final int COLOR_MENUTEXT = 7;
    static final int COLOR_WINDOWTEXT = 8;
    static final int COLOR_CAPTIONTEXT = 9;
    static final int COLOR_ACTIVEBORDER = 10;
    static final int COLOR_INACTIVEBORDER = 11;
    static final int COLOR_APPWORKSPACE = 12;
    static final int COLOR_HIGHLIGHT = 13;
    static final int COLOR_HIGHLIGHTTEXT = 14;
    static final int COLOR_BTNFACE = 15;
    static final int COLOR_BTNSHADOW = 16;
    static final int COLOR_GRAYTEXT = 17;
    static final int COLOR_BTNTEXT = 18;
    static final int COLOR_INACTIVECAPTIONTEXT = 19;
    static final int COLOR_BTNHIGHLIGHT = 20;
    static final int COLOR_3DDKSHADOW = 21;
    static final int COLOR_3DLIGHT = 22;
    static final int COLOR_INFOTEXT = 23;
    static final int COLOR_INFOBK = 24;
    static final int COLOR_HOTLIGHT = 26;
    static final int COLOR_GRADIENTACTIVECAPTION = 27;
    static final int COLOR_GRADIENTINACTIVECAPTION = 28;
    static final int COLOR_MENUHILIGHT = 29;
    static final int COLOR_MENUBAR = 30;
    static final int COLOR_DESKTOP = COLOR_BACKGROUND;
    static final int COLOR_3DFACE = COLOR_BTNFACE;
    static final int COLOR_3DSHADOW = COLOR_BTNSHADOW;
    static final int COLOR_3DHIGHLIGHT = COLOR_BTNHIGHLIGHT;
    static final int COLOR_3DHILIGHT = COLOR_BTNHIGHLIGHT;
    static final int COLOR_BTNHILIGHT = COLOR_BTNHIGHLIGHT;
    static final int GW_HWNDFIRST = 0;
    static final int GW_HWNDLAST = 1;
    static final int GW_HWNDNEXT = 2;
    static final int GW_HWNDPREV = 3;
    static final int GW_OWNER = 4;
    static final int GW_CHILD = 5;
    static final int GW_ENABLEDPOPUP = 6;
    static final int GW_MAX = 6;
    static final int MF_INSERT = 0x00000000;
    static final int MF_CHANGE = 0x00000080;
    static final int MF_APPEND = 0x00000100;
    static final int MF_DELETE = 0x00000200;
    static final int MF_REMOVE = 0x00001000;
    static final int MF_BYCOMMAND = 0x00000000;
    static final int MF_BYPOSITION = 0x00000400;
    static final int MF_SEPARATOR = 0x00000800;
    static final int MF_ENABLED = 0x00000000;
    static final int MF_GRAYED = 0x00000001;
    static final int MF_DISABLED = 0x00000002;
    static final int MF_UNCHECKED = 0x00000000;
    static final int MF_CHECKED = 0x00000008;
    static final int MF_USECHECKBITMAPS = 0x00000200;
    static final int MF_STRING = 0x00000000;
    static final int MF_BITMAP = 0x00000004;
    static final int MF_OWNERDRAW = 0x00000100;
    static final int MF_POPUP = 0x00000010;
    static final int MF_MENUBARBREAK = 0x00000020;
    static final int MF_MENUBREAK = 0x00000040;
    static final int MF_UNHILITE = 0x00000000;
    static final int MF_HILITE = 0x00000080;
    static final int MF_DEFAULT = 0x00001000;
    static final int MF_SYSMENU = 0x00002000;
    static final int MF_HELP = 0x00004000;
    static final int MF_RIGHTJUSTIFY = 0x00004000;
    static final int MF_MOUSESELECT = 0x00008000;
    static final int MFT_STRING = MF_STRING;
    static final int MFT_BITMAP = MF_BITMAP;
    static final int MFT_MENUBARBREAK = MF_MENUBARBREAK;
    static final int MFT_MENUBREAK = MF_MENUBREAK;
    static final int MFT_OWNERDRAW = MF_OWNERDRAW;
    static final int MFT_RADIOCHECK = 0x00000200;
    static final int MFT_SEPARATOR = MF_SEPARATOR;
    static final int MFT_RIGHTORDER = 0x00002000;
    static final int MFT_RIGHTJUSTIFY = MF_RIGHTJUSTIFY;
    static final int MFS_GRAYED = 0x00000003;
    static final int MFS_DISABLED = MFS_GRAYED;
    static final int MFS_CHECKED = MF_CHECKED;
    static final int MFS_HILITE = MF_HILITE;
    static final int MFS_ENABLED = MF_ENABLED;
    static final int MFS_UNCHECKED = MF_UNCHECKED;
    static final int MFS_UNHILITE = MF_UNHILITE;
    static final int MFS_DEFAULT = MF_DEFAULT;
    static final int MF_END = 0x00000080;
    static final int SC_SIZE = 0xF000;
    static final int SC_MOVE = 0xF010;
    static final int SC_MINIMIZE = 0xF020;
    static final int SC_MAXIMIZE = 0xF030;
    static final int SC_NEXTWINDOW = 0xF040;
    static final int SC_PREVWINDOW = 0xF050;
    static final int SC_CLOSE = 0xF060;
    static final int SC_VSCROLL = 0xF070;
    static final int SC_HSCROLL = 0xF080;
    static final int SC_MOUSEMENU = 0xF090;
    static final int SC_KEYMENU = 0xF100;
    static final int SC_ARRANGE = 0xF110;
    static final int SC_RESTORE = 0xF120;
    static final int SC_TASKLIST = 0xF130;
    static final int SC_SCREENSAVE = 0xF140;
    static final int SC_HOTKEY = 0xF150;
    static final int SC_DEFAULT = 0xF160;
    static final int SC_MONITORPOWER = 0xF170;
    static final int SC_CONTEXTHELP = 0xF180;
    static final int SC_SEPARATOR = 0xF00F;
    static final int SC_ICON = SC_MINIMIZE;
    static final int SC_ZOOM = SC_MAXIMIZE;
    static final long IDC_ARROW = (32512);
    static final long IDC_IBEAM = (32513);
    static final long IDC_WAIT = (32514);
    static final long IDC_CROSS = (32515);
    static final long IDC_UPARROW = (32516);
    static final long IDC_SIZE = (32640);
    static final long IDC_ICON = (32641);
    static final long IDC_SIZENWSE = (32642);
    static final long IDC_SIZENESW = (32643);
    static final long IDC_SIZEWE = (32644);
    static final long IDC_SIZENS = (32645);
    static final long IDC_SIZEALL = (32646);
    static final long IDC_NO = (32648);
    static final long IDC_HAND = (32649);
    static final long IDC_APPSTARTING = (32650);
    static final long IDC_HELP = (32651);
    static final int IMAGE_BITMAP = 0;
    static final int IMAGE_ICON = 1;
    static final int IMAGE_CURSOR = 2;
    static final int IMAGE_ENHMETAFILE = 3;
    static final int LR_DEFAULTCOLOR = 0x0000;
    static final int LR_MONOCHROME = 0x0001;
    static final int LR_COLOR = 0x0002;
    static final int LR_COPYRETURNORG = 0x0004;
    static final int LR_COPYDELETEORG = 0x0008;
    static final int LR_LOADFROMFILE = 0x0010;
    static final int LR_LOADTRANSPARENT = 0x0020;
    static final int LR_DEFAULTSIZE = 0x0040;
    static final int LR_VGACOLOR = 0x0080;
    static final int LR_LOADMAP3DCOLORS = 0x1000;
    static final int LR_CREATEDIBSECTION = 0x2000;
    static final int LR_COPYFROMRESOURCE = 0x4000;
    static final int LR_SHARED = 0x8000;
    static final int DI_MASK = 0x0001;
    static final int DI_IMAGE = 0x0002;
    static final int DI_NORMAL = 0x0003;
    static final int DI_COMPAT = 0x0004;
    static final int DI_DEFAULTSIZE = 0x0008;
    static final int RES_ICON = 1;
    static final int RES_CURSOR = 2;
    static final int ORD_LANGDRIVER = 1;
    static final long IDI_APPLICATION = (32512);
    static final long IDI_HAND = (32513);
    static final long IDI_QUESTION = (32514);
    static final long IDI_EXCLAMATION = (32515);
    static final long IDI_ASTERISK = (32516);
    static final long IDI_WINLOGO = (32517);
    static final long IDI_WARNING = IDI_EXCLAMATION;
    static final long IDI_ERROR = IDI_HAND;
    static final long IDI_INFORMATION = IDI_ASTERISK;
    static final int IDOK = 1;
    static final int IDCANCEL = 2;
    static final int IDABORT = 3;
    static final int IDRETRY = 4;
    static final int IDIGNORE = 5;
    static final int IDYES = 6;
    static final int IDNO = 7;
    static final int IDCLOSE = 8;
    static final int IDHELP = 9;
    static final int IDTRYAGAIN = 10;
    static final int IDCONTINUE = 11;
    static final int IDTIMEOUT = 32000;
    static final int ES_LEFT = 0x0000;
    static final int ES_CENTER = 0x0001;
    static final int ES_RIGHT = 0x0002;
    static final int ES_MULTILINE = 0x0004;
    static final int ES_UPPERCASE = 0x0008;
    static final int ES_LOWERCASE = 0x0010;
    static final int ES_PASSWORD = 0x0020;
    static final int ES_AUTOVSCROLL = 0x0040;
    static final int ES_AUTOHSCROLL = 0x0080;
    static final int ES_NOHIDESEL = 0x0100;
    static final int ES_OEMCONVERT = 0x0400;
    static final int ES_READONLY = 0x0800;
    static final int ES_WANTRETURN = 0x1000;
    static final int ES_NUMBER = 0x2000;
    static final int EN_SETFOCUS = 0x0100;
    static final int EN_KILLFOCUS = 0x0200;
    static final int EN_CHANGE = 0x0300;
    static final int EN_UPDATE = 0x0400;
    static final int EN_ERRSPACE = 0x0500;
    static final int EN_MAXTEXT = 0x0501;
    static final int EN_HSCROLL = 0x0601;
    static final int EN_VSCROLL = 0x0602;
    static final int EN_ALIGN_LTR_EC = 0x0700;
    static final int EN_ALIGN_RTL_EC = 0x0701;
    static final int EC_LEFTMARGIN = 0x0001;
    static final int EC_RIGHTMARGIN = 0x0002;
    static final int EC_USEFONTINFO = 0xffff;
    static final int EMSIS_COMPOSITIONSTRING = 0x0001;
    static final int EIMES_GETCOMPSTRATONCE = 0x0001;
    static final int EIMES_CANCELCOMPSTRINFOCUS = 0x0002;
    static final int EIMES_COMPLETECOMPSTRKILLFOCUS = 0x0004;
    static final int EM_GETSEL = 0x00B0;
    static final int EM_SETSEL = 0x00B1;
    static final int EM_GETRECT = 0x00B2;
    static final int EM_SETRECT = 0x00B3;
    static final int EM_SETRECTNP = 0x00B4;
    static final int EM_SCROLL = 0x00B5;
    static final int EM_LINESCROLL = 0x00B6;
    static final int EM_SCROLLCARET = 0x00B7;
    static final int EM_GETMODIFY = 0x00B8;
    static final int EM_SETMODIFY = 0x00B9;
    static final int EM_GETLINECOUNT = 0x00BA;
    static final int EM_LINEINDEX = 0x00BB;
    static final int EM_SETHANDLE = 0x00BC;
    static final int EM_GETHANDLE = 0x00BD;
    static final int EM_GETTHUMB = 0x00BE;
    static final int EM_LINELENGTH = 0x00C1;
    static final int EM_REPLACESEL = 0x00C2;
    static final int EM_GETLINE = 0x00C4;
    static final int EM_LIMITTEXT = 0x00C5;
    static final int EM_CANUNDO = 0x00C6;
    static final int EM_UNDO = 0x00C7;
    static final int EM_FMTLINES = 0x00C8;
    static final int EM_LINEFROMCHAR = 0x00C9;
    static final int EM_SETTABSTOPS = 0x00CB;
    static final int EM_SETPASSWORDCHAR = 0x00CC;
    static final int EM_EMPTYUNDOBUFFER = 0x00CD;
    static final int EM_GETFIRSTVISIBLELINE = 0x00CE;
    static final int EM_SETREADONLY = 0x00CF;
    static final int EM_SETWORDBREAKPROC = 0x00D0;
    static final int EM_GETWORDBREAKPROC = 0x00D1;
    static final int EM_GETPASSWORDCHAR = 0x00D2;
    static final int EM_SETMARGINS = 0x00D3;
    static final int EM_GETMARGINS = 0x00D4;
    static final int EM_SETLIMITTEXT = EM_LIMITTEXT;
    static final int EM_GETLIMITTEXT = 0x00D5;
    static final int EM_POSFROMCHAR = 0x00D6;
    static final int EM_CHARFROMPOS = 0x00D7;
    static final int EM_SETIMESTATUS = 0x00D8;
    static final int EM_GETIMESTATUS = 0x00D9;
    static final int WB_LEFT = 0;
    static final int WB_RIGHT = 1;
    static final int WB_ISDELIMITER = 2;
    static final int BS_PUSHBUTTON = 0x00000000;
    static final int BS_DEFPUSHBUTTON = 0x00000001;
    static final int BS_CHECKBOX = 0x00000002;
    static final int BS_AUTOCHECKBOX = 0x00000003;
    static final int BS_RADIOBUTTON = 0x00000004;
    static final int BS_3STATE = 0x00000005;
    static final int BS_AUTO3STATE = 0x00000006;
    static final int BS_GROUPBOX = 0x00000007;
    static final int BS_USERBUTTON = 0x00000008;
    static final int BS_AUTORADIOBUTTON = 0x00000009;
    static final int BS_PUSHBOX = 0x0000000A;
    static final int BS_OWNERDRAW = 0x0000000B;
    static final int BS_TYPEMASK = 0x0000000F;
    static final int BS_LEFTTEXT = 0x00000020;
    static final int BS_TEXT = 0x00000000;
    static final int BS_ICON = 0x00000040;
    static final int BS_BITMAP = 0x00000080;
    static final int BS_LEFT = 0x00000100;
    static final int BS_RIGHT = 0x00000200;
    static final int BS_CENTER = 0x00000300;
    static final int BS_TOP = 0x00000400;
    static final int BS_BOTTOM = 0x00000800;
    static final int BS_VCENTER = 0x00000C00;
    static final int BS_PUSHLIKE = 0x00001000;
    static final int BS_MULTILINE = 0x00002000;
    static final int BS_NOTIFY = 0x00004000;
    static final int BS_FLAT = 0x00008000;
    static final int BS_RIGHTBUTTON = BS_LEFTTEXT;
    static final int BN_CLICKED = 0;
    static final int BN_PAINT = 1;
    static final int BN_HILITE = 2;
    static final int BN_UNHILITE = 3;
    static final int BN_DISABLE = 4;
    static final int BN_DOUBLECLICKED = 5;
    static final int BN_PUSHED = BN_HILITE;
    static final int BN_UNPUSHED = BN_UNHILITE;
    static final int BN_DBLCLK = BN_DOUBLECLICKED;
    static final int BN_SETFOCUS = 6;
    static final int BN_KILLFOCUS = 7;
    static final int BM_GETCHECK = 0x00F0;
    static final int BM_SETCHECK = 0x00F1;
    static final int BM_GETSTATE = 0x00F2;
    static final int BM_SETSTATE = 0x00F3;
    static final int BM_SETSTYLE = 0x00F4;
    static final int BM_CLICK = 0x00F5;
    static final int BM_GETIMAGE = 0x00F6;
    static final int BM_SETIMAGE = 0x00F7;
    static final int BST_UNCHECKED = 0x0000;
    static final int BST_CHECKED = 0x0001;
    static final int BST_INDETERMINATE = 0x0002;
    static final int BST_PUSHED = 0x0004;
    static final int BST_FOCUS = 0x0008;
    static final int SS_LEFT = 0x00000000;
    static final int SS_CENTER = 0x00000001;
    static final int SS_RIGHT = 0x00000002;
    static final int SS_ICON = 0x00000003;
    static final int SS_BLACKRECT = 0x00000004;
    static final int SS_GRAYRECT = 0x00000005;
    static final int SS_WHITERECT = 0x00000006;
    static final int SS_BLACKFRAME = 0x00000007;
    static final int SS_GRAYFRAME = 0x00000008;
    static final int SS_WHITEFRAME = 0x00000009;
    static final int SS_USERITEM = 0x0000000A;
    static final int SS_SIMPLE = 0x0000000B;
    static final int SS_LEFTNOWORDWRAP = 0x0000000C;
    static final int SS_OWNERDRAW = 0x0000000D;
    static final int SS_BITMAP = 0x0000000E;
    static final int SS_ENHMETAFILE = 0x0000000F;
    static final int SS_ETCHEDHORZ = 0x00000010;
    static final int SS_ETCHEDVERT = 0x00000011;
    static final int SS_ETCHEDFRAME = 0x00000012;
    static final int SS_TYPEMASK = 0x0000001F;
    static final int SS_REALSIZECONTROL = 0x00000040;
    static final int SS_NOPREFIX = 0x00000080;
    static final int SS_NOTIFY = 0x00000100;
    static final int SS_CENTERIMAGE = 0x00000200;
    static final int SS_RIGHTJUST = 0x00000400;
    static final int SS_REALSIZEIMAGE = 0x00000800;
    static final int SS_SUNKEN = 0x00001000;
    static final int SS_EDITCONTROL = 0x00002000;
    static final int SS_ENDELLIPSIS = 0x00004000;
    static final int SS_PATHELLIPSIS = 0x00008000;
    static final int SS_WORDELLIPSIS = 0x0000C000;
    static final int SS_ELLIPSISMASK = 0x0000C000;
    static final int STM_SETICON = 0x0170;
    static final int STM_GETICON = 0x0171;
    static final int STM_SETIMAGE = 0x0172;
    static final int STM_GETIMAGE = 0x0173;
    static final int STN_CLICKED = 0;
    static final int STN_DBLCLK = 1;
    static final int STN_ENABLE = 2;
    static final int STN_DISABLE = 3;
    static final int STM_MSGMAX = 0x0174;
    static final long WC_DIALOG = ((0x8002));
    static final int DWL_MSGRESULT = 0;
    static final int DWL_DLGPROC = 4;
    static final int DWL_USER = 8;
    static final int DWLP_MSGRESULT = 0;
    static final int DDL_READWRITE = 0x0000;
    static final int DDL_READONLY = 0x0001;
    static final int DDL_HIDDEN = 0x0002;
    static final int DDL_SYSTEM = 0x0004;
    static final int DDL_DIRECTORY = 0x0010;
    static final int DDL_ARCHIVE = 0x0020;
    static final int DDL_POSTMSGS = 0x2000;
    static final int DDL_DRIVES = 0x4000;
    static final int DDL_EXCLUSIVE = 0x8000;
    static final int DS_ABSALIGN = 0x01;
    static final int DS_SYSMODAL = 0x02;
    static final int DS_LOCALEDIT = 0x20;
    static final int DS_SETFONT = 0x40;
    static final int DS_MODALFRAME = 0x80;
    static final int DS_NOIDLEMSG = 0x100;
    static final int DS_SETFOREGROUND = 0x200;
    static final int DS_3DLOOK = 0x0004;
    static final int DS_FIXEDSYS = 0x0008;
    static final int DS_NOFAILCREATE = 0x0010;
    static final int DS_CONTROL = 0x0400;
    static final int DS_CENTER = 0x0800;
    static final int DS_CENTERMOUSE = 0x1000;
    static final int DS_CONTEXTHELP = 0x2000;
    static final int DS_SHELLFONT = (DS_SETFONT | DS_FIXEDSYS);
    static final int DM_GETDEFID = (WM_USER+0);
    static final int DM_SETDEFID = (WM_USER+1);
    static final int DM_REPOSITION = (WM_USER+2);
    static final int DC_HASDEFID = 0x534B;
    static final int DLGC_WANTARROWS = 0x0001;
    static final int DLGC_WANTTAB = 0x0002;
    static final int DLGC_WANTALLKEYS = 0x0004;
    static final int DLGC_WANTMESSAGE = 0x0004;
    static final int DLGC_HASSETSEL = 0x0008;
    static final int DLGC_DEFPUSHBUTTON = 0x0010;
    static final int DLGC_UNDEFPUSHBUTTON = 0x0020;
    static final int DLGC_RADIOBUTTON = 0x0040;
    static final int DLGC_WANTCHARS = 0x0080;
    static final int DLGC_STATIC = 0x0100;
    static final int DLGC_BUTTON = 0x2000;
    static final int LB_CTLCODE = 0;
    static final int LB_OKAY = 0;
    static final int LB_ERR = (-1);
    static final int LB_ERRSPACE = (-2);
    static final int LBN_ERRSPACE = (-2);
    static final int LBN_SELCHANGE = 1;
    static final int LBN_DBLCLK = 2;
    static final int LBN_SELCANCEL = 3;
    static final int LBN_SETFOCUS = 4;
    static final int LBN_KILLFOCUS = 5;
    static final int LB_ADDSTRING = 0x0180;
    static final int LB_INSERTSTRING = 0x0181;
    static final int LB_DELETESTRING = 0x0182;
    static final int LB_SELITEMRANGEEX = 0x0183;
    static final int LB_RESETCONTENT = 0x0184;
    static final int LB_SETSEL = 0x0185;
    static final int LB_SETCURSEL = 0x0186;
    static final int LB_GETSEL = 0x0187;
    static final int LB_GETCURSEL = 0x0188;
    static final int LB_GETTEXT = 0x0189;
    static final int LB_GETTEXTLEN = 0x018A;
    static final int LB_GETCOUNT = 0x018B;
    static final int LB_SELECTSTRING = 0x018C;
    static final int LB_DIR = 0x018D;
    static final int LB_GETTOPINDEX = 0x018E;
    static final int LB_FINDSTRING = 0x018F;
    static final int LB_GETSELCOUNT = 0x0190;
    static final int LB_GETSELITEMS = 0x0191;
    static final int LB_SETTABSTOPS = 0x0192;
    static final int LB_GETHORIZONTALEXTENT = 0x0193;
    static final int LB_SETHORIZONTALEXTENT = 0x0194;
    static final int LB_SETCOLUMNWIDTH = 0x0195;
    static final int LB_ADDFILE = 0x0196;
    static final int LB_SETTOPINDEX = 0x0197;
    static final int LB_GETITEMRECT = 0x0198;
    static final int LB_GETITEMDATA = 0x0199;
    static final int LB_SETITEMDATA = 0x019A;
    static final int LB_SELITEMRANGE = 0x019B;
    static final int LB_SETANCHORINDEX = 0x019C;
    static final int LB_GETANCHORINDEX = 0x019D;
    static final int LB_SETCARETINDEX = 0x019E;
    static final int LB_GETCARETINDEX = 0x019F;
    static final int LB_SETITEMHEIGHT = 0x01A0;
    static final int LB_GETITEMHEIGHT = 0x01A1;
    static final int LB_FINDSTRINGEXACT = 0x01A2;
    static final int LB_SETLOCALE = 0x01A5;
    static final int LB_GETLOCALE = 0x01A6;
    static final int LB_SETCOUNT = 0x01A7;
    static final int LB_INITSTORAGE = 0x01A8;
    static final int LB_ITEMFROMPOINT = 0x01A9;
    static final int LB_MSGMAX = 0x01B0;
    static final int LBS_NOTIFY = 0x0001;
    static final int LBS_SORT = 0x0002;
    static final int LBS_NOREDRAW = 0x0004;
    static final int LBS_MULTIPLESEL = 0x0008;
    static final int LBS_OWNERDRAWFIXED = 0x0010;
    static final int LBS_OWNERDRAWVARIABLE = 0x0020;
    static final int LBS_HASSTRINGS = 0x0040;
    static final int LBS_USETABSTOPS = 0x0080;
    static final int LBS_NOINTEGRALHEIGHT = 0x0100;
    static final int LBS_MULTICOLUMN = 0x0200;
    static final int LBS_WANTKEYBOARDINPUT = 0x0400;
    static final int LBS_EXTENDEDSEL = 0x0800;
    static final int LBS_DISABLENOSCROLL = 0x1000;
    static final int LBS_NODATA = 0x2000;
    static final int LBS_NOSEL = 0x4000;
    static final int LBS_COMBOBOX = 0x8000;
    static final int LBS_STANDARD = (LBS_NOTIFY | LBS_SORT | WS_VSCROLL | WS_BORDER);
    static final int CB_OKAY = 0;
    static final int CB_ERR = (-1);
    static final int CB_ERRSPACE = (-2);
    static final int CBN_ERRSPACE = (-1);
    static final int CBN_SELCHANGE = 1;
    static final int CBN_DBLCLK = 2;
    static final int CBN_SETFOCUS = 3;
    static final int CBN_KILLFOCUS = 4;
    static final int CBN_EDITCHANGE = 5;
    static final int CBN_EDITUPDATE = 6;
    static final int CBN_DROPDOWN = 7;
    static final int CBN_CLOSEUP = 8;
    static final int CBN_SELENDOK = 9;
    static final int CBN_SELENDCANCEL = 10;
    static final int CBS_SIMPLE = 0x0001;
    static final int CBS_DROPDOWN = 0x0002;
    static final int CBS_DROPDOWNLIST = 0x0003;
    static final int CBS_OWNERDRAWFIXED = 0x0010;
    static final int CBS_OWNERDRAWVARIABLE = 0x0020;
    static final int CBS_AUTOHSCROLL = 0x0040;
    static final int CBS_OEMCONVERT = 0x0080;
    static final int CBS_SORT = 0x0100;
    static final int CBS_HASSTRINGS = 0x0200;
    static final int CBS_NOINTEGRALHEIGHT = 0x0400;
    static final int CBS_DISABLENOSCROLL = 0x0800;
    static final int CBS_UPPERCASE = 0x2000;
    static final int CBS_LOWERCASE = 0x4000;
    static final int CB_GETEDITSEL = 0x0140;
    static final int CB_LIMITTEXT = 0x0141;
    static final int CB_SETEDITSEL = 0x0142;
    static final int CB_ADDSTRING = 0x0143;
    static final int CB_DELETESTRING = 0x0144;
    static final int CB_DIR = 0x0145;
    static final int CB_GETCOUNT = 0x0146;
    static final int CB_GETCURSEL = 0x0147;
    static final int CB_GETLBTEXT = 0x0148;
    static final int CB_GETLBTEXTLEN = 0x0149;
    static final int CB_INSERTSTRING = 0x014A;
    static final int CB_RESETCONTENT = 0x014B;
    static final int CB_FINDSTRING = 0x014C;
    static final int CB_SELECTSTRING = 0x014D;
    static final int CB_SETCURSEL = 0x014E;
    static final int CB_SHOWDROPDOWN = 0x014F;
    static final int CB_GETITEMDATA = 0x0150;
    static final int CB_SETITEMDATA = 0x0151;
    static final int CB_GETDROPPEDCONTROLRECT = 0x0152;
    static final int CB_SETITEMHEIGHT = 0x0153;
    static final int CB_GETITEMHEIGHT = 0x0154;
    static final int CB_SETEXTENDEDUI = 0x0155;
    static final int CB_GETEXTENDEDUI = 0x0156;
    static final int CB_GETDROPPEDSTATE = 0x0157;
    static final int CB_FINDSTRINGEXACT = 0x0158;
    static final int CB_SETLOCALE = 0x0159;
    static final int CB_GETLOCALE = 0x015A;
    static final int CB_GETTOPINDEX = 0x015b;
    static final int CB_SETTOPINDEX = 0x015c;
    static final int CB_GETHORIZONTALEXTENT = 0x015d;
    static final int CB_SETHORIZONTALEXTENT = 0x015e;
    static final int CB_GETDROPPEDWIDTH = 0x015f;
    static final int CB_SETDROPPEDWIDTH = 0x0160;
    static final int CB_INITSTORAGE = 0x0161;
    static final int CB_MSGMAX = 0x0162;
    static final int SBS_HORZ = 0x0000;
    static final int SBS_VERT = 0x0001;
    static final int SBS_TOPALIGN = 0x0002;
    static final int SBS_LEFTALIGN = 0x0002;
    static final int SBS_BOTTOMALIGN = 0x0004;
    static final int SBS_RIGHTALIGN = 0x0004;
    static final int SBS_SIZEBOXTOPLEFTALIGN = 0x0002;
    static final int SBS_SIZEBOXBOTTOMRIGHTALIGN = 0x0004;
    static final int SBS_SIZEBOX = 0x0008;
    static final int SBS_SIZEGRIP = 0x0010;
    static final int SBM_SETPOS = 0x00E0;
    static final int SBM_GETPOS = 0x00E1;
    static final int SBM_SETRANGE = 0x00E2;
    static final int SBM_SETRANGEREDRAW = 0x00E6;
    static final int SBM_GETRANGE = 0x00E3;
    static final int SBM_ENABLE_ARROWS = 0x00E4;
    static final int SBM_SETSCROLLINFO = 0x00E9;
    static final int SBM_GETSCROLLINFO = 0x00EA;
    static final int SIF_RANGE = 0x0001;
    static final int SIF_PAGE = 0x0002;
    static final int SIF_POS = 0x0004;
    static final int SIF_DISABLENOSCROLL = 0x0008;
    static final int SIF_TRACKPOS = 0x0010;
    static final int SIF_ALL = (SIF_RANGE | SIF_PAGE | SIF_POS | SIF_TRACKPOS);
    static final int MDIS_ALLCHILDSTYLES = 0x0001;
    static final int MDITILE_VERTICAL = 0x0000;
    static final int MDITILE_HORIZONTAL = 0x0001;
    static final int MDITILE_SKIPDISABLED = 0x0002;
    static final int MDITILE_ZORDER = 0x0004;
    static final int HELP_CONTEXT = 0x0001;
    static final int HELP_QUIT = 0x0002;
    static final int HELP_INDEX = 0x0003;
    static final int HELP_CONTENTS = 0x0003;
    static final int HELP_HELPONHELP = 0x0004;
    static final int HELP_SETINDEX = 0x0005;
    static final int HELP_SETCONTENTS = 0x0005;
    static final int HELP_CONTEXTPOPUP = 0x0008;
    static final int HELP_FORCEFILE = 0x0009;
    static final int HELP_KEY = 0x0101;
    static final int HELP_COMMAND = 0x0102;
    static final int HELP_PARTIALKEY = 0x0105;
    static final int HELP_MULTIKEY = 0x0201;
    static final int HELP_SETWINPOS = 0x0203;
    static final int HELP_CONTEXTMENU = 0x000a;
    static final int HELP_FINDER = 0x000b;
    static final int HELP_WM_HELP = 0x000c;
    static final int HELP_SETPOPUP_POS = 0x000d;
    static final int HELP_TCARD = 0x8000;
    static final int HELP_TCARD_DATA = 0x0010;
    static final int HELP_TCARD_OTHER_CALLER = 0x0011;
    static final int IDH_NO_HELP = 28440;
    static final int IDH_MISSING_CONTEXT = 28441;
    static final int IDH_GENERIC_HELP_BUTTON = 28442;
    static final int IDH_OK = 28443;
    static final int IDH_CANCEL = 28444;
    static final int IDH_HELP = 28445;
    static final int GR_GDIOBJECTS = 0;
    static final int GR_USEROBJECTS = 1;
    static final int SPI_GETBEEP = 0x0001;
    static final int SPI_SETBEEP = 0x0002;
    static final int SPI_GETMOUSE = 0x0003;
    static final int SPI_SETMOUSE = 0x0004;
    static final int SPI_GETBORDER = 0x0005;
    static final int SPI_SETBORDER = 0x0006;
    static final int SPI_GETKEYBOARDSPEED = 0x000A;
    static final int SPI_SETKEYBOARDSPEED = 0x000B;
    static final int SPI_LANGDRIVER = 0x000C;
    static final int SPI_ICONHORIZONTALSPACING = 0x000D;
    static final int SPI_GETSCREENSAVETIMEOUT = 0x000E;
    static final int SPI_SETSCREENSAVETIMEOUT = 0x000F;
    static final int SPI_GETSCREENSAVEACTIVE = 0x0010;
    static final int SPI_SETSCREENSAVEACTIVE = 0x0011;
    static final int SPI_GETGRIDGRANULARITY = 0x0012;
    static final int SPI_SETGRIDGRANULARITY = 0x0013;
    static final int SPI_SETDESKWALLPAPER = 0x0014;
    static final int SPI_SETDESKPATTERN = 0x0015;
    static final int SPI_GETKEYBOARDDELAY = 0x0016;
    static final int SPI_SETKEYBOARDDELAY = 0x0017;
    static final int SPI_ICONVERTICALSPACING = 0x0018;
    static final int SPI_GETICONTITLEWRAP = 0x0019;
    static final int SPI_SETICONTITLEWRAP = 0x001A;
    static final int SPI_GETMENUDROPALIGNMENT = 0x001B;
    static final int SPI_SETMENUDROPALIGNMENT = 0x001C;
    static final int SPI_SETDOUBLECLKWIDTH = 0x001D;
    static final int SPI_SETDOUBLECLKHEIGHT = 0x001E;
    static final int SPI_GETICONTITLELOGFONT = 0x001F;
    static final int SPI_SETDOUBLECLICKTIME = 0x0020;
    static final int SPI_SETMOUSEBUTTONSWAP = 0x0021;
    static final int SPI_SETICONTITLELOGFONT = 0x0022;
    static final int SPI_GETFASTTASKSWITCH = 0x0023;
    static final int SPI_SETFASTTASKSWITCH = 0x0024;
    static final int SPI_SETDRAGFULLWINDOWS = 0x0025;
    static final int SPI_GETDRAGFULLWINDOWS = 0x0026;
    static final int SPI_GETNONCLIENTMETRICS = 0x0029;
    static final int SPI_SETNONCLIENTMETRICS = 0x002A;
    static final int SPI_GETMINIMIZEDMETRICS = 0x002B;
    static final int SPI_SETMINIMIZEDMETRICS = 0x002C;
    static final int SPI_GETICONMETRICS = 0x002D;
    static final int SPI_SETICONMETRICS = 0x002E;
    static final int SPI_SETWORKAREA = 0x002F;
    static final int SPI_GETWORKAREA = 0x0030;
    static final int SPI_SETPENWINDOWS = 0x0031;
    static final int SPI_GETHIGHCONTRAST = 0x0042;
    static final int SPI_SETHIGHCONTRAST = 0x0043;
    static final int SPI_GETKEYBOARDPREF = 0x0044;
    static final int SPI_SETKEYBOARDPREF = 0x0045;
    static final int SPI_GETSCREENREADER = 0x0046;
    static final int SPI_SETSCREENREADER = 0x0047;
    static final int SPI_GETANIMATION = 0x0048;
    static final int SPI_SETANIMATION = 0x0049;
    static final int SPI_GETFONTSMOOTHING = 0x004A;
    static final int SPI_SETFONTSMOOTHING = 0x004B;
    static final int SPI_SETDRAGWIDTH = 0x004C;
    static final int SPI_SETDRAGHEIGHT = 0x004D;
    static final int SPI_SETHANDHELD = 0x004E;
    static final int SPI_GETLOWPOWERTIMEOUT = 0x004F;
    static final int SPI_GETPOWEROFFTIMEOUT = 0x0050;
    static final int SPI_SETLOWPOWERTIMEOUT = 0x0051;
    static final int SPI_SETPOWEROFFTIMEOUT = 0x0052;
    static final int SPI_GETLOWPOWERACTIVE = 0x0053;
    static final int SPI_GETPOWEROFFACTIVE = 0x0054;
    static final int SPI_SETLOWPOWERACTIVE = 0x0055;
    static final int SPI_SETPOWEROFFACTIVE = 0x0056;
    static final int SPI_SETCURSORS = 0x0057;
    static final int SPI_SETICONS = 0x0058;
    static final int SPI_GETDEFAULTINPUTLANG = 0x0059;
    static final int SPI_SETDEFAULTINPUTLANG = 0x005A;
    static final int SPI_SETLANGTOGGLE = 0x005B;
    static final int SPI_GETWINDOWSEXTENSION = 0x005C;
    static final int SPI_SETMOUSETRAILS = 0x005D;
    static final int SPI_GETMOUSETRAILS = 0x005E;
    static final int SPI_SETSCREENSAVERRUNNING = 0x0061;
    static final int SPI_SCREENSAVERRUNNING = SPI_SETSCREENSAVERRUNNING;
    static final int SPI_GETFILTERKEYS = 0x0032;
    static final int SPI_SETFILTERKEYS = 0x0033;
    static final int SPI_GETTOGGLEKEYS = 0x0034;
    static final int SPI_SETTOGGLEKEYS = 0x0035;
    static final int SPI_GETMOUSEKEYS = 0x0036;
    static final int SPI_SETMOUSEKEYS = 0x0037;
    static final int SPI_GETSHOWSOUNDS = 0x0038;
    static final int SPI_SETSHOWSOUNDS = 0x0039;
    static final int SPI_GETSTICKYKEYS = 0x003A;
    static final int SPI_SETSTICKYKEYS = 0x003B;
    static final int SPI_GETACCESSTIMEOUT = 0x003C;
    static final int SPI_SETACCESSTIMEOUT = 0x003D;
    static final int SPI_GETSERIALKEYS = 0x003E;
    static final int SPI_SETSERIALKEYS = 0x003F;
    static final int SPI_GETSOUNDSENTRY = 0x0040;
    static final int SPI_SETSOUNDSENTRY = 0x0041;
    static final int SPI_GETSNAPTODEFBUTTON = 0x005F;
    static final int SPI_SETSNAPTODEFBUTTON = 0x0060;
    static final int SPI_GETMOUSEHOVERWIDTH = 0x0062;
    static final int SPI_SETMOUSEHOVERWIDTH = 0x0063;
    static final int SPI_GETMOUSEHOVERHEIGHT = 0x0064;
    static final int SPI_SETMOUSEHOVERHEIGHT = 0x0065;
    static final int SPI_GETMOUSEHOVERTIME = 0x0066;
    static final int SPI_SETMOUSEHOVERTIME = 0x0067;
    static final int SPI_GETWHEELSCROLLLINES = 0x0068;
    static final int SPI_SETWHEELSCROLLLINES = 0x0069;
    static final int SPI_GETMENUSHOWDELAY = 0x006A;
    static final int SPI_SETMENUSHOWDELAY = 0x006B;
    static final int SPI_GETSHOWIMEUI = 0x006E;
    static final int SPI_SETSHOWIMEUI = 0x006F;
    static final int SPI_GETMOUSESPEED = 0x0070;
    static final int SPI_SETMOUSESPEED = 0x0071;
    static final int SPI_GETSCREENSAVERRUNNING = 0x0072;
    static final int SPI_GETDESKWALLPAPER = 0x0073;
    static final int SPI_GETACTIVEWINDOWTRACKING = 0x1000;
    static final int SPI_SETACTIVEWINDOWTRACKING = 0x1001;
    static final int SPI_GETMENUANIMATION = 0x1002;
    static final int SPI_SETMENUANIMATION = 0x1003;
    static final int SPI_GETCOMBOBOXANIMATION = 0x1004;
    static final int SPI_SETCOMBOBOXANIMATION = 0x1005;
    static final int SPI_GETLISTBOXSMOOTHSCROLLING = 0x1006;
    static final int SPI_SETLISTBOXSMOOTHSCROLLING = 0x1007;
    static final int SPI_GETGRADIENTCAPTIONS = 0x1008;
    static final int SPI_SETGRADIENTCAPTIONS = 0x1009;
    static final int SPI_GETKEYBOARDCUES = 0x100A;
    static final int SPI_SETKEYBOARDCUES = 0x100B;
    static final int SPI_GETMENUUNDERLINES = SPI_GETKEYBOARDCUES;
    static final int SPI_SETMENUUNDERLINES = SPI_SETKEYBOARDCUES;
    static final int SPI_GETACTIVEWNDTRKZORDER = 0x100C;
    static final int SPI_SETACTIVEWNDTRKZORDER = 0x100D;
    static final int SPI_GETHOTTRACKING = 0x100E;
    static final int SPI_SETHOTTRACKING = 0x100F;
    static final int SPI_GETMENUFADE = 0x1012;
    static final int SPI_SETMENUFADE = 0x1013;
    static final int SPI_GETSELECTIONFADE = 0x1014;
    static final int SPI_SETSELECTIONFADE = 0x1015;
    static final int SPI_GETTOOLTIPANIMATION = 0x1016;
    static final int SPI_SETTOOLTIPANIMATION = 0x1017;
    static final int SPI_GETTOOLTIPFADE = 0x1018;
    static final int SPI_SETTOOLTIPFADE = 0x1019;
    static final int SPI_GETCURSORSHADOW = 0x101A;
    static final int SPI_SETCURSORSHADOW = 0x101B;
    static final int SPI_GETUIEFFECTS = 0x103E;
    static final int SPI_SETUIEFFECTS = 0x103F;
    static final int SPI_GETFOREGROUNDLOCKTIMEOUT = 0x2000;
    static final int SPI_SETFOREGROUNDLOCKTIMEOUT = 0x2001;
    static final int SPI_GETACTIVEWNDTRKTIMEOUT = 0x2002;
    static final int SPI_SETACTIVEWNDTRKTIMEOUT = 0x2003;
    static final int SPI_GETFOREGROUNDFLASHCOUNT = 0x2004;
    static final int SPI_SETFOREGROUNDFLASHCOUNT = 0x2005;
    static final int SPI_GETCARETWIDTH = 0x2006;
    static final int SPI_SETCARETWIDTH = 0x2007;
    static final int SPIF_UPDATEINIFILE = 0x0001;
    static final int SPIF_SENDWININICHANGE = 0x0002;
    static final int SPIF_SENDCHANGE = SPIF_SENDWININICHANGE;
    static final int METRICS_USEDEFAULT = -1;
    static final int ARW_BOTTOMLEFT = 0x0000;
    static final int ARW_BOTTOMRIGHT = 0x0001;
    static final int ARW_TOPLEFT = 0x0002;
    static final int ARW_TOPRIGHT = 0x0003;
    static final int ARW_STARTMASK = 0x0003;
    static final int ARW_STARTRIGHT = 0x0001;
    static final int ARW_STARTTOP = 0x0002;
    static final int ARW_LEFT = 0x0000;
    static final int ARW_RIGHT = 0x0000;
    static final int ARW_UP = 0x0004;
    static final int ARW_DOWN = 0x0004;
    static final int ARW_HIDE = 0x0008;
    static final int SERKF_SERIALKEYSON = 0x00000001;
    static final int SERKF_AVAILABLE = 0x00000002;
    static final int SERKF_INDICATOR = 0x00000004;
    static final int HCF_HIGHCONTRASTON = 0x00000001;
    static final int HCF_AVAILABLE = 0x00000002;
    static final int HCF_HOTKEYACTIVE = 0x00000004;
    static final int HCF_CONFIRMHOTKEY = 0x00000008;
    static final int HCF_HOTKEYSOUND = 0x00000010;
    static final int HCF_INDICATOR = 0x00000020;
    static final int HCF_HOTKEYAVAILABLE = 0x00000040;
    static final int CDS_UPDATEREGISTRY = 0x00000001;
    static final int CDS_TEST = 0x00000002;
    static final int CDS_FULLSCREEN = 0x00000004;
    static final int CDS_GLOBAL = 0x00000008;
    static final int CDS_SET_PRIMARY = 0x00000010;
    static final int CDS_VIDEOPARAMETERS = 0x00000020;
    static final int CDS_RESET = 0x40000000;
    static final int CDS_NORESET = 0x10000000;
    static final int VP_COMMAND_GET = 0x0001;
    static final int VP_COMMAND_SET = 0x0002;
    static final int VP_FLAGS_TV_MODE = 0x0001;
    static final int VP_FLAGS_TV_STANDARD = 0x0002;
    static final int VP_FLAGS_FLICKER = 0x0004;
    static final int VP_FLAGS_OVERSCAN = 0x0008;
    static final int VP_FLAGS_MAX_UNSCALED = 0x0010;
    static final int VP_FLAGS_POSITION = 0x0020;
    static final int VP_FLAGS_BRIGHTNESS = 0x0040;
    static final int VP_FLAGS_CONTRAST = 0x0080;
    static final int VP_FLAGS_COPYPROTECT = 0x0100;
    static final int VP_MODE_WIN_GRAPHICS = 0x0001;
    static final int VP_MODE_TV_PLAYBACK = 0x0002;
    static final int VP_TV_STANDARD_NTSC_M = 0x0001;
    static final int VP_TV_STANDARD_NTSC_M_J = 0x0002;
    static final int VP_TV_STANDARD_PAL_B = 0x0004;
    static final int VP_TV_STANDARD_PAL_D = 0x0008;
    static final int VP_TV_STANDARD_PAL_H = 0x0010;
    static final int VP_TV_STANDARD_PAL_I = 0x0020;
    static final int VP_TV_STANDARD_PAL_M = 0x0040;
    static final int VP_TV_STANDARD_PAL_N = 0x0080;
    static final int VP_TV_STANDARD_SECAM_B = 0x0100;
    static final int VP_TV_STANDARD_SECAM_D = 0x0200;
    static final int VP_TV_STANDARD_SECAM_G = 0x0400;
    static final int VP_TV_STANDARD_SECAM_H = 0x0800;
    static final int VP_TV_STANDARD_SECAM_K = 0x1000;
    static final int VP_TV_STANDARD_SECAM_K1 = 0x2000;
    static final int VP_TV_STANDARD_SECAM_L = 0x4000;
    static final int VP_TV_STANDARD_WIN_VGA = 0x8000;
    static final int VP_TV_STANDARD_NTSC_433 = 0x00010000;
    static final int VP_TV_STANDARD_PAL_G = 0x00020000;
    static final int VP_TV_STANDARD_PAL_60 = 0x00040000;
    static final int VP_TV_STANDARD_SECAM_L1 = 0x00080000;
    static final int VP_CP_TYPE_APS_TRIGGER = 0x0001;
    static final int VP_CP_TYPE_MACROVISION = 0x0002;
    static final int VP_CP_CMD_ACTIVATE = 0x0001;
    static final int VP_CP_CMD_DEACTIVATE = 0x0002;
    static final int VP_CP_CMD_CHANGE = 0x0004;
    static final int DISP_CHANGE_SUCCESSFUL = 0;
    static final int DISP_CHANGE_RESTART = 1;
    static final int DISP_CHANGE_FAILED = -1;
    static final int DISP_CHANGE_BADMODE = -2;
    static final int DISP_CHANGE_NOTUPDATED = -3;
    static final int DISP_CHANGE_BADFLAGS = -4;
    static final int DISP_CHANGE_BADPARAM = -5;
    static final int EDS_RAWMODE = 0x00000002;
    static final int FKF_FILTERKEYSON = 0x00000001;
    static final int FKF_AVAILABLE = 0x00000002;
    static final int FKF_HOTKEYACTIVE = 0x00000004;
    static final int FKF_CONFIRMHOTKEY = 0x00000008;
    static final int FKF_HOTKEYSOUND = 0x00000010;
    static final int FKF_INDICATOR = 0x00000020;
    static final int FKF_CLICKON = 0x00000040;
    static final int SKF_STICKYKEYSON = 0x00000001;
    static final int SKF_AVAILABLE = 0x00000002;
    static final int SKF_HOTKEYACTIVE = 0x00000004;
    static final int SKF_CONFIRMHOTKEY = 0x00000008;
    static final int SKF_HOTKEYSOUND = 0x00000010;
    static final int SKF_INDICATOR = 0x00000020;
    static final int SKF_AUDIBLEFEEDBACK = 0x00000040;
    static final int SKF_TRISTATE = 0x00000080;
    static final int SKF_TWOKEYSOFF = 0x00000100;
    static final int SKF_LALTLATCHED = 0x10000000;
    static final int SKF_LCTLLATCHED = 0x04000000;
    static final int SKF_LSHIFTLATCHED = 0x01000000;
    static final int SKF_RALTLATCHED = 0x20000000;
    static final int SKF_RCTLLATCHED = 0x08000000;
    static final int SKF_RSHIFTLATCHED = 0x02000000;
    static final int SKF_LWINLATCHED = 0x40000000;
    static final int SKF_RWINLATCHED = 0x80000000;
    static final int SKF_LALTLOCKED = 0x00100000;
    static final int SKF_LCTLLOCKED = 0x00040000;
    static final int SKF_LSHIFTLOCKED = 0x00010000;
    static final int SKF_RALTLOCKED = 0x00200000;
    static final int SKF_RCTLLOCKED = 0x00080000;
    static final int SKF_RSHIFTLOCKED = 0x00020000;
    static final int SKF_LWINLOCKED = 0x00400000;
    static final int SKF_RWINLOCKED = 0x00800000;
    static final int MKF_MOUSEKEYSON = 0x00000001;
    static final int MKF_AVAILABLE = 0x00000002;
    static final int MKF_HOTKEYACTIVE = 0x00000004;
    static final int MKF_CONFIRMHOTKEY = 0x00000008;
    static final int MKF_HOTKEYSOUND = 0x00000010;
    static final int MKF_INDICATOR = 0x00000020;
    static final int MKF_MODIFIERS = 0x00000040;
    static final int MKF_REPLACENUMBERS = 0x00000080;
    static final int MKF_LEFTBUTTONSEL = 0x10000000;
    static final int MKF_RIGHTBUTTONSEL = 0x20000000;
    static final int MKF_LEFTBUTTONDOWN = 0x01000000;
    static final int MKF_RIGHTBUTTONDOWN = 0x02000000;
    static final int MKF_MOUSEMODE = 0x80000000;
    static final int ATF_TIMEOUTON = 0x00000001;
    static final int ATF_ONOFFFEEDBACK = 0x00000002;
    static final int SSGF_NONE = 0;
    static final int SSGF_DISPLAY = 3;
    static final int SSTF_NONE = 0;
    static final int SSTF_CHARS = 1;
    static final int SSTF_BORDER = 2;
    static final int SSTF_DISPLAY = 3;
    static final int SSWF_NONE = 0;
    static final int SSWF_TITLE = 1;
    static final int SSWF_WINDOW = 2;
    static final int SSWF_DISPLAY = 3;
    static final int SSWF_CUSTOM = 4;
    static final int SSF_SOUNDSENTRYON = 0x00000001;
    static final int SSF_AVAILABLE = 0x00000002;
    static final int SSF_INDICATOR = 0x00000004;
    static final int TKF_TOGGLEKEYSON = 0x00000001;
    static final int TKF_AVAILABLE = 0x00000002;
    static final int TKF_HOTKEYACTIVE = 0x00000004;
    static final int TKF_CONFIRMHOTKEY = 0x00000008;
    static final int TKF_HOTKEYSOUND = 0x00000010;
    static final int TKF_INDICATOR = 0x00000020;
    static final int SLE_ERROR = 0x00000001;
    static final int SLE_MINORERROR = 0x00000002;
    static final int SLE_WARNING = 0x00000003;
    static final int MONITOR_DEFAULTTONULL = 0x00000000;
    static final int MONITOR_DEFAULTTOPRIMARY = 0x00000001;
    static final int MONITOR_DEFAULTTONEAREST = 0x00000002;
    static final int MONITORINFOF_PRIMARY = 0x00000001;
    static final int WINEVENT_OUTOFCONTEXT = 0x0000;
    static final int WINEVENT_SKIPOWNTHREAD = 0x0001;
    static final int WINEVENT_SKIPOWNPROCESS = 0x0002;
    static final int WINEVENT_INCONTEXT = 0x0004;
    static final int CHILDID_SELF = 0;
    static final int INDEXID_OBJECT = 0;
    static final int INDEXID_CONTAINER = 0;
    static final int EVENT_MIN = 0x00000001;
    static final int EVENT_MAX = 0x7FFFFFFF;
    static final int EVENT_SYSTEM_SOUND = 0x0001;
    static final int EVENT_SYSTEM_ALERT = 0x0002;
    static final int EVENT_SYSTEM_FOREGROUND = 0x0003;
    static final int EVENT_SYSTEM_MENUSTART = 0x0004;
    static final int EVENT_SYSTEM_MENUEND = 0x0005;
    static final int EVENT_SYSTEM_MENUPOPUPSTART = 0x0006;
    static final int EVENT_SYSTEM_MENUPOPUPEND = 0x0007;
    static final int EVENT_SYSTEM_CAPTURESTART = 0x0008;
    static final int EVENT_SYSTEM_CAPTUREEND = 0x0009;
    static final int EVENT_SYSTEM_MOVESIZESTART = 0x000A;
    static final int EVENT_SYSTEM_MOVESIZEEND = 0x000B;
    static final int EVENT_SYSTEM_CONTEXTHELPSTART = 0x000C;
    static final int EVENT_SYSTEM_CONTEXTHELPEND = 0x000D;
    static final int EVENT_SYSTEM_DRAGDROPSTART = 0x000E;
    static final int EVENT_SYSTEM_DRAGDROPEND = 0x000F;
    static final int EVENT_SYSTEM_DIALOGSTART = 0x0010;
    static final int EVENT_SYSTEM_DIALOGEND = 0x0011;
    static final int EVENT_SYSTEM_SCROLLINGSTART = 0x0012;
    static final int EVENT_SYSTEM_SCROLLINGEND = 0x0013;
    static final int EVENT_SYSTEM_SWITCHSTART = 0x0014;
    static final int EVENT_SYSTEM_SWITCHEND = 0x0015;
    static final int EVENT_SYSTEM_MINIMIZESTART = 0x0016;
    static final int EVENT_SYSTEM_MINIMIZEEND = 0x0017;
    static final int EVENT_OBJECT_CREATE = 0x8000;
    static final int EVENT_OBJECT_DESTROY = 0x8001;
    static final int EVENT_OBJECT_SHOW = 0x8002;
    static final int EVENT_OBJECT_HIDE = 0x8003;
    static final int EVENT_OBJECT_REORDER = 0x8004;
    static final int EVENT_OBJECT_FOCUS = 0x8005;
    static final int EVENT_OBJECT_SELECTION = 0x8006;
    static final int EVENT_OBJECT_SELECTIONADD = 0x8007;
    static final int EVENT_OBJECT_SELECTIONREMOVE = 0x8008;
    static final int EVENT_OBJECT_SELECTIONWITHIN = 0x8009;
    static final int EVENT_OBJECT_STATECHANGE = 0x800A;
    static final int EVENT_OBJECT_LOCATIONCHANGE = 0x800B;
    static final int EVENT_OBJECT_NAMECHANGE = 0x800C;
    static final int EVENT_OBJECT_DESCRIPTIONCHANGE = 0x800D;
    static final int EVENT_OBJECT_VALUECHANGE = 0x800E;
    static final int EVENT_OBJECT_PARENTCHANGE = 0x800F;
    static final int EVENT_OBJECT_HELPCHANGE = 0x8010;
    static final int EVENT_OBJECT_DEFACTIONCHANGE = 0x8011;
    static final int EVENT_OBJECT_ACCELERATORCHANGE = 0x8012;
    static final int SOUND_SYSTEM_STARTUP = 1;
    static final int SOUND_SYSTEM_SHUTDOWN = 2;
    static final int SOUND_SYSTEM_BEEP = 3;
    static final int SOUND_SYSTEM_ERROR = 4;
    static final int SOUND_SYSTEM_QUESTION = 5;
    static final int SOUND_SYSTEM_WARNING = 6;
    static final int SOUND_SYSTEM_INFORMATION = 7;
    static final int SOUND_SYSTEM_MAXIMIZE = 8;
    static final int SOUND_SYSTEM_MINIMIZE = 9;
    static final int SOUND_SYSTEM_RESTOREUP = 10;
    static final int SOUND_SYSTEM_RESTOREDOWN = 11;
    static final int SOUND_SYSTEM_APPSTART = 12;
    static final int SOUND_SYSTEM_FAULT = 13;
    static final int SOUND_SYSTEM_APPEND = 14;
    static final int SOUND_SYSTEM_MENUCOMMAND = 15;
    static final int SOUND_SYSTEM_MENUPOPUP = 16;
    static final int CSOUND_SYSTEM = 16;
    static final int ALERT_SYSTEM_INFORMATIONAL = 1;
    static final int ALERT_SYSTEM_WARNING = 2;
    static final int ALERT_SYSTEM_ERROR = 3;
    static final int ALERT_SYSTEM_QUERY = 4;
    static final int ALERT_SYSTEM_CRITICAL = 5;
    static final int CALERT_SYSTEM = 6;
    static final int GUI_CARETBLINKING = 0x00000001;
    static final int GUI_INMOVESIZE = 0x00000002;
    static final int GUI_INMENUMODE = 0x00000004;
    static final int GUI_SYSTEMMENUMODE = 0x00000008;
    static final int GUI_POPUPMENUMODE = 0x00000010;
    static final int STATE_SYSTEM_UNAVAILABLE = 0x00000001;
    static final int STATE_SYSTEM_SELECTED = 0x00000002;
    static final int STATE_SYSTEM_FOCUSED = 0x00000004;
    static final int STATE_SYSTEM_PRESSED = 0x00000008;
    static final int STATE_SYSTEM_CHECKED = 0x00000010;
    static final int STATE_SYSTEM_MIXED = 0x00000020;
    static final int STATE_SYSTEM_INDETERMINATE = STATE_SYSTEM_MIXED;
    static final int STATE_SYSTEM_READONLY = 0x00000040;
    static final int STATE_SYSTEM_HOTTRACKED = 0x00000080;
    static final int STATE_SYSTEM_DEFAULT = 0x00000100;
    static final int STATE_SYSTEM_EXPANDED = 0x00000200;
    static final int STATE_SYSTEM_COLLAPSED = 0x00000400;
    static final int STATE_SYSTEM_BUSY = 0x00000800;
    static final int STATE_SYSTEM_FLOATING = 0x00001000;
    static final int STATE_SYSTEM_MARQUEED = 0x00002000;
    static final int STATE_SYSTEM_ANIMATED = 0x00004000;
    static final int STATE_SYSTEM_INVISIBLE = 0x00008000;
    static final int STATE_SYSTEM_OFFSCREEN = 0x00010000;
    static final int STATE_SYSTEM_SIZEABLE = 0x00020000;
    static final int STATE_SYSTEM_MOVEABLE = 0x00040000;
    static final int STATE_SYSTEM_SELFVOICING = 0x00080000;
    static final int STATE_SYSTEM_FOCUSABLE = 0x00100000;
    static final int STATE_SYSTEM_SELECTABLE = 0x00200000;
    static final int STATE_SYSTEM_LINKED = 0x00400000;
    static final int STATE_SYSTEM_TRAVERSED = 0x00800000;
    static final int STATE_SYSTEM_MULTISELECTABLE = 0x01000000;
    static final int STATE_SYSTEM_EXTSELECTABLE = 0x02000000;
    static final int STATE_SYSTEM_ALERT_LOW = 0x04000000;
    static final int STATE_SYSTEM_ALERT_MEDIUM = 0x08000000;
    static final int STATE_SYSTEM_ALERT_HIGH = 0x10000000;
    static final int STATE_SYSTEM_PROTECTED = 0x20000000;
    static final int STATE_SYSTEM_VALID = 0x3FFFFFFF;
    static final int CCHILDREN_TITLEBAR = 5;
    static final int CCHILDREN_SCROLLBAR = 5;
    static final int CURSOR_SHOWING = 0x00000001;
    static final int WS_ACTIVECAPTION = 0x0001;
    static final int GA_PARENT = 1;
    static final int GA_ROOT = 2;
    static final int GA_ROOTOWNER = 3;
    static final int MAX_LEADBYTES = 12;
    static final int MAX_DEFAULTCHAR = 2;
    static final int MB_PRECOMPOSED = 0x00000001;
    static final int MB_COMPOSITE = 0x00000002;
    static final int MB_USEGLYPHCHARS = 0x00000004;
    static final int MB_ERR_INVALID_CHARS = 0x00000008;
    static final int WC_COMPOSITECHECK = 0x00000200;
    static final int WC_DISCARDNS = 0x00000010;
    static final int WC_SEPCHARS = 0x00000020;
    static final int WC_DEFAULTCHAR = 0x00000040;
    static final int WC_NO_BEST_FIT_CHARS = 0x00000400;
    static final int CT_CTYPE1 = 0x00000001;
    static final int CT_CTYPE2 = 0x00000002;
    static final int CT_CTYPE3 = 0x00000004;
    static final int C1_UPPER = 0x0001;
    static final int C1_LOWER = 0x0002;
    static final int C1_DIGIT = 0x0004;
    static final int C1_SPACE = 0x0008;
    static final int C1_PUNCT = 0x0010;
    static final int C1_CNTRL = 0x0020;
    static final int C1_BLANK = 0x0040;
    static final int C1_XDIGIT = 0x0080;
    static final int C1_ALPHA = 0x0100;
    static final int C1_DEFINED = 0x0200;
    static final int C2_LEFTTORIGHT = 0x0001;
    static final int C2_RIGHTTOLEFT = 0x0002;
    static final int C2_EUROPENUMBER = 0x0003;
    static final int C2_EUROPESEPARATOR = 0x0004;
    static final int C2_EUROPETERMINATOR = 0x0005;
    static final int C2_ARABICNUMBER = 0x0006;
    static final int C2_COMMONSEPARATOR = 0x0007;
    static final int C2_BLOCKSEPARATOR = 0x0008;
    static final int C2_SEGMENTSEPARATOR = 0x0009;
    static final int C2_WHITESPACE = 0x000A;
    static final int C2_OTHERNEUTRAL = 0x000B;
    static final int C2_NOTAPPLICABLE = 0x0000;
    static final int C3_NONSPACING = 0x0001;
    static final int C3_DIACRITIC = 0x0002;
    static final int C3_VOWELMARK = 0x0004;
    static final int C3_SYMBOL = 0x0008;
    static final int C3_KATAKANA = 0x0010;
    static final int C3_HIRAGANA = 0x0020;
    static final int C3_HALFWIDTH = 0x0040;
    static final int C3_FULLWIDTH = 0x0080;
    static final int C3_IDEOGRAPH = 0x0100;
    static final int C3_KASHIDA = 0x0200;
    static final int C3_LEXICAL = 0x0400;
    static final int C3_ALPHA = 0x8000;
    static final int C3_NOTAPPLICABLE = 0x0000;
    static final int NORM_IGNORECASE = 0x00000001;
    static final int NORM_IGNORENONSPACE = 0x00000002;
    static final int NORM_IGNORESYMBOLS = 0x00000004;
    static final int NORM_IGNOREKANATYPE = 0x00010000;
    static final int NORM_IGNOREWIDTH = 0x00020000;
    static final int MAP_FOLDCZONE = 0x00000010;
    static final int MAP_PRECOMPOSED = 0x00000020;
    static final int MAP_COMPOSITE = 0x00000040;
    static final int MAP_FOLDDIGITS = 0x00000080;
    static final int MAP_EXPAND_LIGATURES = 0x00002000;
    static final int LCMAP_LOWERCASE = 0x00000100;
    static final int LCMAP_UPPERCASE = 0x00000200;
    static final int LCMAP_SORTKEY = 0x00000400;
    static final int LCMAP_BYTEREV = 0x00000800;
    static final int LCMAP_HIRAGANA = 0x00100000;
    static final int LCMAP_KATAKANA = 0x00200000;
    static final int LCMAP_HALFWIDTH = 0x00400000;
    static final int LCMAP_FULLWIDTH = 0x00800000;
    static final int LCMAP_LINGUISTIC_CASING = 0x01000000;
    static final int LCMAP_SIMPLIFIED_CHINESE = 0x02000000;
    static final int LCMAP_TRADITIONAL_CHINESE = 0x04000000;
    static final int LGRPID_INSTALLED = 0x00000001;
    static final int LGRPID_SUPPORTED = 0x00000002;
    static final int LCID_INSTALLED = 0x00000001;
    static final int LCID_SUPPORTED = 0x00000002;
    static final int LCID_ALTERNATE_SORTS = 0x00000004;
    static final int CP_INSTALLED = 0x00000001;
    static final int CP_SUPPORTED = 0x00000002;
    static final int SORT_STRINGSORT = 0x00001000;
    static final int CSTR_LESS_THAN = 1;
    static final int CSTR_EQUAL = 2;
    static final int CSTR_GREATER_THAN = 3;
    static final int CP_ACP = 0;
    static final int CP_OEMCP = 1;
    static final int CP_MACCP = 2;
    static final int CP_THREAD_ACP = 3;
    static final int CP_SYMBOL = 42;
    static final int CP_UTF7 = 65000;
    static final int CP_UTF8 = 65001;
    static final int CTRY_DEFAULT = 0;
    static final int CTRY_ALBANIA = 355;
    static final int CTRY_ALGERIA = 213;
    static final int CTRY_ARGENTINA = 54;
    static final int CTRY_ARMENIA = 374;
    static final int CTRY_AUSTRALIA = 61;
    static final int CTRY_AUSTRIA = 43;
    static final int CTRY_AZERBAIJAN = 994;
    static final int CTRY_BAHRAIN = 973;
    static final int CTRY_BELARUS = 375;
    static final int CTRY_BELGIUM = 32;
    static final int CTRY_BELIZE = 501;
    static final int CTRY_BOLIVIA = 591;
    static final int CTRY_BRAZIL = 55;
    static final int CTRY_BRUNEI_DARUSSALAM = 673;
    static final int CTRY_BULGARIA = 359;
    static final int CTRY_CANADA = 2;
    static final int CTRY_CARIBBEAN = 1;
    static final int CTRY_CHILE = 56;
    static final int CTRY_COLOMBIA = 57;
    static final int CTRY_COSTA_RICA = 506;
    static final int CTRY_CROATIA = 385;
    static final int CTRY_CZECH = 420;
    static final int CTRY_DENMARK = 45;
    static final int CTRY_DOMINICAN_REPUBLIC = 1;
    static final int CTRY_ECUADOR = 593;
    static final int CTRY_EGYPT = 20;
    static final int CTRY_EL_SALVADOR = 503;
    static final int CTRY_ESTONIA = 372;
    static final int CTRY_FAEROE_ISLANDS = 298;
    static final int CTRY_FINLAND = 358;
    static final int CTRY_FRANCE = 33;
    static final int CTRY_GEORGIA = 995;
    static final int CTRY_GERMANY = 49;
    static final int CTRY_GREECE = 30;
    static final int CTRY_GUATEMALA = 502;
    static final int CTRY_HONDURAS = 504;
    static final int CTRY_HONG_KONG = 852;
    static final int CTRY_HUNGARY = 36;
    static final int CTRY_ICELAND = 354;
    static final int CTRY_INDIA = 91;
    static final int CTRY_INDONESIA = 62;
    static final int CTRY_IRAN = 981;
    static final int CTRY_IRAQ = 964;
    static final int CTRY_IRELAND = 353;
    static final int CTRY_ISRAEL = 972;
    static final int CTRY_ITALY = 39;
    static final int CTRY_JAMAICA = 1;
    static final int CTRY_JAPAN = 81;
    static final int CTRY_JORDAN = 962;
    static final int CTRY_KAZAKSTAN = 7;
    static final int CTRY_KENYA = 254;
    static final int CTRY_KUWAIT = 965;
    static final int CTRY_KYRGYZSTAN = 996;
    static final int CTRY_LATVIA = 371;
    static final int CTRY_LEBANON = 961;
    static final int CTRY_LIBYA = 218;
    static final int CTRY_LIECHTENSTEIN = 41;
    static final int CTRY_LITHUANIA = 370;
    static final int CTRY_LUXEMBOURG = 352;
    static final int CTRY_MACAU = 853;
    static final int CTRY_MACEDONIA = 389;
    static final int CTRY_MALAYSIA = 60;
    static final int CTRY_MALDIVES = 960;
    static final int CTRY_MEXICO = 52;
    static final int CTRY_MONACO = 33;
    static final int CTRY_MONGOLIA = 976;
    static final int CTRY_MOROCCO = 212;
    static final int CTRY_NETHERLANDS = 31;
    static final int CTRY_NEW_ZEALAND = 64;
    static final int CTRY_NICARAGUA = 505;
    static final int CTRY_NORWAY = 47;
    static final int CTRY_OMAN = 968;
    static final int CTRY_PAKISTAN = 92;
    static final int CTRY_PANAMA = 507;
    static final int CTRY_PARAGUAY = 595;
    static final int CTRY_PERU = 51;
    static final int CTRY_PHILIPPINES = 63;
    static final int CTRY_POLAND = 48;
    static final int CTRY_PORTUGAL = 351;
    static final int CTRY_PRCHINA = 86;
    static final int CTRY_PUERTO_RICO = 1;
    static final int CTRY_QATAR = 974;
    static final int CTRY_ROMANIA = 40;
    static final int CTRY_RUSSIA = 7;
    static final int CTRY_SAUDI_ARABIA = 966;
    static final int CTRY_SERBIA = 381;
    static final int CTRY_SINGAPORE = 65;
    static final int CTRY_SLOVAK = 421;
    static final int CTRY_SLOVENIA = 386;
    static final int CTRY_SOUTH_AFRICA = 27;
    static final int CTRY_SOUTH_KOREA = 82;
    static final int CTRY_SPAIN = 34;
    static final int CTRY_SWEDEN = 46;
    static final int CTRY_SWITZERLAND = 41;
    static final int CTRY_SYRIA = 963;
    static final int CTRY_TAIWAN = 886;
    static final int CTRY_TATARSTAN = 7;
    static final int CTRY_THAILAND = 66;
    static final int CTRY_TRINIDAD_Y_TOBAGO = 1;
    static final int CTRY_TUNISIA = 216;
    static final int CTRY_TURKEY = 90;
    static final int CTRY_UAE = 971;
    static final int CTRY_UKRAINE = 380;
    static final int CTRY_UNITED_KINGDOM = 44;
    static final int CTRY_UNITED_STATES = 1;
    static final int CTRY_URUGUAY = 598;
    static final int CTRY_UZBEKISTAN = 7;
    static final int CTRY_VENEZUELA = 58;
    static final int CTRY_VIET_NAM = 84;
    static final int CTRY_YEMEN = 967;
    static final int CTRY_ZIMBABWE = 263;
    static final int LOCALE_NOUSEROVERRIDE = 0x80000000;
    static final int LOCALE_USE_CP_ACP = 0x40000000;
    static final int LOCALE_RETURN_NUMBER = 0x20000000;
    static final int LOCALE_ILANGUAGE = 0x00000001;
    static final int LOCALE_SLANGUAGE = 0x00000002;
    static final int LOCALE_SENGLANGUAGE = 0x00001001;
    static final int LOCALE_SABBREVLANGNAME = 0x00000003;
    static final int LOCALE_SNATIVELANGNAME = 0x00000004;
    static final int LOCALE_ICOUNTRY = 0x00000005;
    static final int LOCALE_SCOUNTRY = 0x00000006;
    static final int LOCALE_SENGCOUNTRY = 0x00001002;
    static final int LOCALE_SABBREVCTRYNAME = 0x00000007;
    static final int LOCALE_SNATIVECTRYNAME = 0x00000008;
    static final int LOCALE_IDEFAULTLANGUAGE = 0x00000009;
    static final int LOCALE_IDEFAULTCOUNTRY = 0x0000000A;
    static final int LOCALE_IDEFAULTCODEPAGE = 0x0000000B;
    static final int LOCALE_IDEFAULTANSICODEPAGE = 0x00001004;
    static final int LOCALE_IDEFAULTMACCODEPAGE = 0x00001011;
    static final int LOCALE_SLIST = 0x0000000C;
    static final int LOCALE_IMEASURE = 0x0000000D;
    static final int LOCALE_SDECIMAL = 0x0000000E;
    static final int LOCALE_STHOUSAND = 0x0000000F;
    static final int LOCALE_SGROUPING = 0x00000010;
    static final int LOCALE_IDIGITS = 0x00000011;
    static final int LOCALE_ILZERO = 0x00000012;
    static final int LOCALE_INEGNUMBER = 0x00001010;
    static final int LOCALE_SNATIVEDIGITS = 0x00000013;
    static final int LOCALE_SCURRENCY = 0x00000014;
    static final int LOCALE_SINTLSYMBOL = 0x00000015;
    static final int LOCALE_SMONDECIMALSEP = 0x00000016;
    static final int LOCALE_SMONTHOUSANDSEP = 0x00000017;
    static final int LOCALE_SMONGROUPING = 0x00000018;
    static final int LOCALE_ICURRDIGITS = 0x00000019;
    static final int LOCALE_IINTLCURRDIGITS = 0x0000001A;
    static final int LOCALE_ICURRENCY = 0x0000001B;
    static final int LOCALE_INEGCURR = 0x0000001C;
    static final int LOCALE_SDATE = 0x0000001D;
    static final int LOCALE_STIME = 0x0000001E;
    static final int LOCALE_SSHORTDATE = 0x0000001F;
    static final int LOCALE_SLONGDATE = 0x00000020;
    static final int LOCALE_STIMEFORMAT = 0x00001003;
    static final int LOCALE_IDATE = 0x00000021;
    static final int LOCALE_ILDATE = 0x00000022;
    static final int LOCALE_ITIME = 0x00000023;
    static final int LOCALE_ITIMEMARKPOSN = 0x00001005;
    static final int LOCALE_ICENTURY = 0x00000024;
    static final int LOCALE_ITLZERO = 0x00000025;
    static final int LOCALE_IDAYLZERO = 0x00000026;
    static final int LOCALE_IMONLZERO = 0x00000027;
    static final int LOCALE_S1159 = 0x00000028;
    static final int LOCALE_S2359 = 0x00000029;
    static final int LOCALE_ICALENDARTYPE = 0x00001009;
    static final int LOCALE_IOPTIONALCALENDAR = 0x0000100B;
    static final int LOCALE_IFIRSTDAYOFWEEK = 0x0000100C;
    static final int LOCALE_IFIRSTWEEKOFYEAR = 0x0000100D;
    static final int LOCALE_SDAYNAME1 = 0x0000002A;
    static final int LOCALE_SDAYNAME2 = 0x0000002B;
    static final int LOCALE_SDAYNAME3 = 0x0000002C;
    static final int LOCALE_SDAYNAME4 = 0x0000002D;
    static final int LOCALE_SDAYNAME5 = 0x0000002E;
    static final int LOCALE_SDAYNAME6 = 0x0000002F;
    static final int LOCALE_SDAYNAME7 = 0x00000030;
    static final int LOCALE_SABBREVDAYNAME1 = 0x00000031;
    static final int LOCALE_SABBREVDAYNAME2 = 0x00000032;
    static final int LOCALE_SABBREVDAYNAME3 = 0x00000033;
    static final int LOCALE_SABBREVDAYNAME4 = 0x00000034;
    static final int LOCALE_SABBREVDAYNAME5 = 0x00000035;
    static final int LOCALE_SABBREVDAYNAME6 = 0x00000036;
    static final int LOCALE_SABBREVDAYNAME7 = 0x00000037;
    static final int LOCALE_SMONTHNAME1 = 0x00000038;
    static final int LOCALE_SMONTHNAME2 = 0x00000039;
    static final int LOCALE_SMONTHNAME3 = 0x0000003A;
    static final int LOCALE_SMONTHNAME4 = 0x0000003B;
    static final int LOCALE_SMONTHNAME5 = 0x0000003C;
    static final int LOCALE_SMONTHNAME6 = 0x0000003D;
    static final int LOCALE_SMONTHNAME7 = 0x0000003E;
    static final int LOCALE_SMONTHNAME8 = 0x0000003F;
    static final int LOCALE_SMONTHNAME9 = 0x00000040;
    static final int LOCALE_SMONTHNAME10 = 0x00000041;
    static final int LOCALE_SMONTHNAME11 = 0x00000042;
    static final int LOCALE_SMONTHNAME12 = 0x00000043;
    static final int LOCALE_SMONTHNAME13 = 0x0000100E;
    static final int LOCALE_SABBREVMONTHNAME1 = 0x00000044;
    static final int LOCALE_SABBREVMONTHNAME2 = 0x00000045;
    static final int LOCALE_SABBREVMONTHNAME3 = 0x00000046;
    static final int LOCALE_SABBREVMONTHNAME4 = 0x00000047;
    static final int LOCALE_SABBREVMONTHNAME5 = 0x00000048;
    static final int LOCALE_SABBREVMONTHNAME6 = 0x00000049;
    static final int LOCALE_SABBREVMONTHNAME7 = 0x0000004A;
    static final int LOCALE_SABBREVMONTHNAME8 = 0x0000004B;
    static final int LOCALE_SABBREVMONTHNAME9 = 0x0000004C;
    static final int LOCALE_SABBREVMONTHNAME10 = 0x0000004D;
    static final int LOCALE_SABBREVMONTHNAME11 = 0x0000004E;
    static final int LOCALE_SABBREVMONTHNAME12 = 0x0000004F;
    static final int LOCALE_SABBREVMONTHNAME13 = 0x0000100F;
    static final int LOCALE_SPOSITIVESIGN = 0x00000050;
    static final int LOCALE_SNEGATIVESIGN = 0x00000051;
    static final int LOCALE_IPOSSIGNPOSN = 0x00000052;
    static final int LOCALE_INEGSIGNPOSN = 0x00000053;
    static final int LOCALE_IPOSSYMPRECEDES = 0x00000054;
    static final int LOCALE_IPOSSEPBYSPACE = 0x00000055;
    static final int LOCALE_INEGSYMPRECEDES = 0x00000056;
    static final int LOCALE_INEGSEPBYSPACE = 0x00000057;
    static final int LOCALE_FONTSIGNATURE = 0x00000058;
    static final int LOCALE_SISO639LANGNAME = 0x00000059;
    static final int LOCALE_SISO3166CTRYNAME = 0x0000005A;
    static final int LOCALE_IDEFAULTEBCDICCODEPAGE = 0x00001012;
    static final int LOCALE_IPAPERSIZE = 0x0000100A;
    static final int LOCALE_SENGCURRNAME = 0x00001007;
    static final int LOCALE_SNATIVECURRNAME = 0x00001008;
    static final int LOCALE_SYEARMONTH = 0x00001006;
    static final int LOCALE_SSORTNAME = 0x00001013;
    static final int LOCALE_IDIGITSUBSTITUTION = 0x00001014;
    static final int TIME_NOMINUTESORSECONDS = 0x00000001;
    static final int TIME_NOSECONDS = 0x00000002;
    static final int TIME_NOTIMEMARKER = 0x00000004;
    static final int TIME_FORCE24HOURFORMAT = 0x00000008;
    static final int DATE_SHORTDATE = 0x00000001;
    static final int DATE_LONGDATE = 0x00000002;
    static final int DATE_USE_ALT_CALENDAR = 0x00000004;
    static final int DATE_YEARMONTH = 0x00000008;
    static final int DATE_LTRREADING = 0x00000010;
    static final int DATE_RTLREADING = 0x00000020;
    static final int CAL_NOUSEROVERRIDE = LOCALE_NOUSEROVERRIDE;
    static final int CAL_USE_CP_ACP = LOCALE_USE_CP_ACP;
    static final int CAL_RETURN_NUMBER = LOCALE_RETURN_NUMBER;
    static final int CAL_ICALINTVALUE = 0x00000001;
    static final int CAL_SCALNAME = 0x00000002;
    static final int CAL_IYEAROFFSETRANGE = 0x00000003;
    static final int CAL_SERASTRING = 0x00000004;
    static final int CAL_SSHORTDATE = 0x00000005;
    static final int CAL_SLONGDATE = 0x00000006;
    static final int CAL_SDAYNAME1 = 0x00000007;
    static final int CAL_SDAYNAME2 = 0x00000008;
    static final int CAL_SDAYNAME3 = 0x00000009;
    static final int CAL_SDAYNAME4 = 0x0000000a;
    static final int CAL_SDAYNAME5 = 0x0000000b;
    static final int CAL_SDAYNAME6 = 0x0000000c;
    static final int CAL_SDAYNAME7 = 0x0000000d;
    static final int CAL_SABBREVDAYNAME1 = 0x0000000e;
    static final int CAL_SABBREVDAYNAME2 = 0x0000000f;
    static final int CAL_SABBREVDAYNAME3 = 0x00000010;
    static final int CAL_SABBREVDAYNAME4 = 0x00000011;
    static final int CAL_SABBREVDAYNAME5 = 0x00000012;
    static final int CAL_SABBREVDAYNAME6 = 0x00000013;
    static final int CAL_SABBREVDAYNAME7 = 0x00000014;
    static final int CAL_SMONTHNAME1 = 0x00000015;
    static final int CAL_SMONTHNAME2 = 0x00000016;
    static final int CAL_SMONTHNAME3 = 0x00000017;
    static final int CAL_SMONTHNAME4 = 0x00000018;
    static final int CAL_SMONTHNAME5 = 0x00000019;
    static final int CAL_SMONTHNAME6 = 0x0000001a;
    static final int CAL_SMONTHNAME7 = 0x0000001b;
    static final int CAL_SMONTHNAME8 = 0x0000001c;
    static final int CAL_SMONTHNAME9 = 0x0000001d;
    static final int CAL_SMONTHNAME10 = 0x0000001e;
    static final int CAL_SMONTHNAME11 = 0x0000001f;
    static final int CAL_SMONTHNAME12 = 0x00000020;
    static final int CAL_SMONTHNAME13 = 0x00000021;
    static final int CAL_SABBREVMONTHNAME1 = 0x00000022;
    static final int CAL_SABBREVMONTHNAME2 = 0x00000023;
    static final int CAL_SABBREVMONTHNAME3 = 0x00000024;
    static final int CAL_SABBREVMONTHNAME4 = 0x00000025;
    static final int CAL_SABBREVMONTHNAME5 = 0x00000026;
    static final int CAL_SABBREVMONTHNAME6 = 0x00000027;
    static final int CAL_SABBREVMONTHNAME7 = 0x00000028;
    static final int CAL_SABBREVMONTHNAME8 = 0x00000029;
    static final int CAL_SABBREVMONTHNAME9 = 0x0000002a;
    static final int CAL_SABBREVMONTHNAME10 = 0x0000002b;
    static final int CAL_SABBREVMONTHNAME11 = 0x0000002c;
    static final int CAL_SABBREVMONTHNAME12 = 0x0000002d;
    static final int CAL_SABBREVMONTHNAME13 = 0x0000002e;
    static final int CAL_SYEARMONTH = 0x0000002f;
    static final int CAL_ITWODIGITYEARMAX = 0x00000030;
    static final int ENUM_ALL_CALENDARS = 0xffffffff;
    static final int CAL_GREGORIAN = 1;
    static final int CAL_GREGORIAN_US = 2;
    static final int CAL_JAPAN = 3;
    static final int CAL_TAIWAN = 4;
    static final int CAL_KOREA = 5;
    static final int CAL_HIJRI = 6;
    static final int CAL_THAI = 7;
    static final int CAL_HEBREW = 8;
    static final int CAL_GREGORIAN_ME_FRENCH = 9;
    static final int CAL_GREGORIAN_ARABIC = 10;
    static final int CAL_GREGORIAN_XLIT_ENGLISH = 11;
    static final int CAL_GREGORIAN_XLIT_FRENCH = 12;
    static final int LGRPID_WESTERN_EUROPE = 0x0001;
    static final int LGRPID_CENTRAL_EUROPE = 0x0002;
    static final int LGRPID_BALTIC = 0x0003;
    static final int LGRPID_GREEK = 0x0004;
    static final int LGRPID_CYRILLIC = 0x0005;
    static final int LGRPID_TURKISH = 0x0006;
    static final int LGRPID_JAPANESE = 0x0007;
    static final int LGRPID_KOREAN = 0x0008;
    static final int LGRPID_TRADITIONAL_CHINESE = 0x0009;
    static final int LGRPID_SIMPLIFIED_CHINESE = 0x000a;
    static final int LGRPID_THAI = 0x000b;
    static final int LGRPID_HEBREW = 0x000c;
    static final int LGRPID_ARABIC = 0x000d;
    static final int LGRPID_VIETNAMESE = 0x000e;
    static final int LGRPID_INDIC = 0x000f;
    static final int LGRPID_GEORGIAN = 0x0010;
    static final int LGRPID_ARMENIAN = 0x0011;
    static final int GEOID_NOT_AVAILABLE = -1;
    static final int RIGHT_ALT_PRESSED = 0x0001;
    static final int LEFT_ALT_PRESSED = 0x0002;
    static final int RIGHT_CTRL_PRESSED = 0x0004;
    static final int LEFT_CTRL_PRESSED = 0x0008;
    static final int SHIFT_PRESSED = 0x0010;
    static final int NUMLOCK_ON = 0x0020;
    static final int SCROLLLOCK_ON = 0x0040;
    static final int CAPSLOCK_ON = 0x0080;
    static final int ENHANCED_KEY = 0x0100;
    static final int NLS_DBCSCHAR = 0x00010000;
    static final int NLS_ALPHANUMERIC = 0x00000000;
    static final int NLS_KATAKANA = 0x00020000;
    static final int NLS_HIRAGANA = 0x00040000;
    static final int NLS_ROMAN = 0x00400000;
    static final int NLS_IME_CONVERSION = 0x00800000;
    static final int NLS_IME_DISABLE = 0x20000000;
    static final int FROM_LEFT_1ST_BUTTON_PRESSED = 0x0001;
    static final int RIGHTMOST_BUTTON_PRESSED = 0x0002;
    static final int FROM_LEFT_2ND_BUTTON_PRESSED = 0x0004;
    static final int FROM_LEFT_3RD_BUTTON_PRESSED = 0x0008;
    static final int FROM_LEFT_4TH_BUTTON_PRESSED = 0x0010;
    static final int MOUSE_MOVED = 0x0001;
    static final int DOUBLE_CLICK = 0x0002;
    static final int MOUSE_WHEELED = 0x0004;
    static final int KEY_EVENT = 0x0001;
    static final int MOUSE_EVENT = 0x0002;
    static final int WINDOW_BUFFER_SIZE_EVENT = 0x0004;
    static final int MENU_EVENT = 0x0008;
    static final int FOCUS_EVENT = 0x0010;
    static final int FOREGROUND_BLUE = 0x0001;
    static final int FOREGROUND_GREEN = 0x0002;
    static final int FOREGROUND_RED = 0x0004;
    static final int FOREGROUND_INTENSITY = 0x0008;
    static final int BACKGROUND_BLUE = 0x0010;
    static final int BACKGROUND_GREEN = 0x0020;
    static final int BACKGROUND_RED = 0x0040;
    static final int BACKGROUND_INTENSITY = 0x0080;
    static final int COMMON_LVB_LEADING_BYTE = 0x0100;
    static final int COMMON_LVB_TRAILING_BYTE = 0x0200;
    static final int COMMON_LVB_GRID_HORIZONTAL = 0x0400;
    static final int COMMON_LVB_GRID_LVERTICAL = 0x0800;
    static final int COMMON_LVB_GRID_RVERTICAL = 0x1000;
    static final int COMMON_LVB_REVERSE_VIDEO = 0x4000;
    static final int COMMON_LVB_UNDERSCORE = 0x8000;
    static final int COMMON_LVB_SBCSDBCS = 0x0300;
    static final int CONSOLE_NO_SELECTION = 0x0000;
    static final int CONSOLE_SELECTION_IN_PROGRESS = 0x0001;
    static final int CONSOLE_SELECTION_NOT_EMPTY = 0x0002;
    static final int CONSOLE_MOUSE_SELECTION = 0x0004;
    static final int CONSOLE_MOUSE_DOWN = 0x0008;
    static final int CTRL_C_EVENT = 0;
    static final int CTRL_BREAK_EVENT = 1;
    static final int CTRL_CLOSE_EVENT = 2;
    static final int CTRL_LOGOFF_EVENT = 5;
    static final int CTRL_SHUTDOWN_EVENT = 6;
    static final int ENABLE_PROCESSED_INPUT = 0x0001;
    static final int ENABLE_LINE_INPUT = 0x0002;
    static final int ENABLE_ECHO_INPUT = 0x0004;
    static final int ENABLE_WINDOW_INPUT = 0x0008;
    static final int ENABLE_MOUSE_INPUT = 0x0010;
    static final int ENABLE_PROCESSED_OUTPUT = 0x0001;
    static final int ENABLE_WRAP_AT_EOL_OUTPUT = 0x0002;
    static final int CONSOLE_TEXTMODE_BUFFER = 1;
    static final int CONSOLE_FULLSCREEN = 1;
    static final int CONSOLE_FULLSCREEN_HARDWARE = 2;
    static final long VS_FILE_INFO = RT_VERSION;
    static final int VS_VERSION_INFO = 1;
    static final int VS_USER_DEFINED = 100;
    static final int VS_FFI_SIGNATURE = 0xFEEF04BD;
    static final int VS_FFI_STRUCVERSION = 0x00010000;
    static final int VS_FFI_FILEFLAGSMASK = 0x0000003F;
    static final int VS_FF_DEBUG = 0x00000001;
    static final int VS_FF_PRERELEASE = 0x00000002;
    static final int VS_FF_PATCHED = 0x00000004;
    static final int VS_FF_PRIVATEBUILD = 0x00000008;
    static final int VS_FF_INFOINFERRED = 0x00000010;
    static final int VS_FF_SPECIALBUILD = 0x00000020;
    static final int VOS_UNKNOWN = 0x00000000;
    static final int VOS_DOS = 0x00010000;
    static final int VOS_OS216 = 0x00020000;
    static final int VOS_OS232 = 0x00030000;
    static final int VOS_NT = 0x00040000;
    static final int VOS_WINCE = 0x00050000;
    static final int VOS__BASE = 0x00000000;
    static final int VOS__WINDOWS16 = 0x00000001;
    static final int VOS__PM16 = 0x00000002;
    static final int VOS__PM32 = 0x00000003;
    static final int VOS__WINDOWS32 = 0x00000004;
    static final int VOS_DOS_WINDOWS16 = 0x00010001;
    static final int VOS_DOS_WINDOWS32 = 0x00010004;
    static final int VOS_OS216_PM16 = 0x00020002;
    static final int VOS_OS232_PM32 = 0x00030003;
    static final int VOS_NT_WINDOWS32 = 0x00040004;
    static final int VFT_UNKNOWN = 0x00000000;
    static final int VFT_APP = 0x00000001;
    static final int VFT_DLL = 0x00000002;
    static final int VFT_DRV = 0x00000003;
    static final int VFT_FONT = 0x00000004;
    static final int VFT_VXD = 0x00000005;
    static final int VFT_STATIC_LIB = 0x00000007;
    static final int VFT2_UNKNOWN = 0x00000000;
    static final int VFT2_DRV_PRINTER = 0x00000001;
    static final int VFT2_DRV_KEYBOARD = 0x00000002;
    static final int VFT2_DRV_LANGUAGE = 0x00000003;
    static final int VFT2_DRV_DISPLAY = 0x00000004;
    static final int VFT2_DRV_MOUSE = 0x00000005;
    static final int VFT2_DRV_NETWORK = 0x00000006;
    static final int VFT2_DRV_SYSTEM = 0x00000007;
    static final int VFT2_DRV_INSTALLABLE = 0x00000008;
    static final int VFT2_DRV_SOUND = 0x00000009;
    static final int VFT2_DRV_COMM = 0x0000000A;
    static final int VFT2_DRV_INPUTMETHOD = 0x0000000B;
    static final int VFT2_DRV_VERSIONED_PRINTER = 0x0000000C;
    static final int VFT2_FONT_RASTER = 0x00000001;
    static final int VFT2_FONT_VECTOR = 0x00000002;
    static final int VFT2_FONT_TRUETYPE = 0x00000003;
    static final int VFFF_ISSHAREDFILE = 0x0001;
    static final int VFF_CURNEDEST = 0x0001;
    static final int VFF_FILEINUSE = 0x0002;
    static final int VFF_BUFFTOOSMALL = 0x0004;
    static final int VIFF_FORCEINSTALL = 0x0001;
    static final int VIFF_DONTDELETEOLD = 0x0002;
    static final int VIF_TEMPFILE = 0x00000001;
    static final int VIF_MISMATCH = 0x00000002;
    static final int VIF_SRCOLD = 0x00000004;
    static final int VIF_DIFFLANG = 0x00000008;
    static final int VIF_DIFFCODEPG = 0x00000010;
    static final int VIF_DIFFTYPE = 0x00000020;
    static final int VIF_WRITEPROT = 0x00000040;
    static final int VIF_FILEINUSE = 0x00000080;
    static final int VIF_OUTOFSPACE = 0x00000100;
    static final int VIF_ACCESSVIOLATION = 0x00000200;
    static final int VIF_SHARINGVIOLATION = 0x00000400;
    static final int VIF_CANNOTCREATE = 0x00000800;
    static final int VIF_CANNOTDELETE = 0x00001000;
    static final int VIF_CANNOTRENAME = 0x00002000;
    static final int VIF_CANNOTDELETECUR = 0x00004000;
    static final int VIF_OUTOFMEMORY = 0x00008000;
    static final int VIF_CANNOTREADSRC = 0x00010000;
    static final int VIF_CANNOTREADDST = 0x00020000;
    static final int VIF_BUFFTOOSMALL = 0x00040000;
    static final int VIF_CANNOTLOADLZ32 = 0x00080000;
    static final int VIF_CANNOTLOADCABINET = 0x00100000;
    static final int PROVIDER_KEEPS_VALUE_LENGTH = 0x1;
    static final int SHTDN_REASON_FLAG_COMMENT_REQUIRED = 0x01000000;
    static final int SHTDN_REASON_FLAG_DIRTY_PROBLEM_ID_REQUIRED = 0x02000000;
    static final int SHTDN_REASON_FLAG_CLEAN_UI = 0x04000000;
    static final int SHTDN_REASON_FLAG_DIRTY_UI = 0x08000000;
    static final int SHTDN_REASON_FLAG_USER_DEFINED = 0x40000000;
    static final int SHTDN_REASON_FLAG_PLANNED = 0x80000000;
    static final int SHTDN_REASON_MAJOR_OTHER = 0x00000000;
    static final int SHTDN_REASON_MAJOR_NONE = 0x00000000;
    static final int SHTDN_REASON_MAJOR_HARDWARE = 0x00010000;
    static final int SHTDN_REASON_MAJOR_OPERATINGSYSTEM = 0x00020000;
    static final int SHTDN_REASON_MAJOR_SOFTWARE = 0x00030000;
    static final int SHTDN_REASON_MAJOR_APPLICATION = 0x00040000;
    static final int SHTDN_REASON_MAJOR_SYSTEM = 0x00050000;
    static final int SHTDN_REASON_MAJOR_POWER = 0x00060000;
    static final int SHTDN_REASON_MAJOR_LEGACY_API = 0x00070000;
    static final int SHTDN_REASON_MINOR_OTHER = 0x00000000;
    static final int SHTDN_REASON_MINOR_NONE = 0x000000ff;
    static final int SHTDN_REASON_MINOR_MAINTENANCE = 0x00000001;
    static final int SHTDN_REASON_MINOR_INSTALLATION = 0x00000002;
    static final int SHTDN_REASON_MINOR_UPGRADE = 0x00000003;
    static final int SHTDN_REASON_MINOR_RECONFIG = 0x00000004;
    static final int SHTDN_REASON_MINOR_HUNG = 0x00000005;
    static final int SHTDN_REASON_MINOR_UNSTABLE = 0x00000006;
    static final int SHTDN_REASON_MINOR_DISK = 0x00000007;
    static final int SHTDN_REASON_MINOR_PROCESSOR = 0x00000008;
    static final int SHTDN_REASON_MINOR_NETWORKCARD = 0x00000009;
    static final int SHTDN_REASON_MINOR_POWER_SUPPLY = 0x0000000a;
    static final int SHTDN_REASON_MINOR_CORDUNPLUGGED = 0x0000000b;
    static final int SHTDN_REASON_MINOR_ENVIRONMENT = 0x0000000c;
    static final int SHTDN_REASON_MINOR_HARDWARE_DRIVER = 0x0000000d;
    static final int SHTDN_REASON_MINOR_OTHERDRIVER = 0x0000000e;
    static final int SHTDN_REASON_MINOR_BLUESCREEN = 0x0000000F;
    static final int SHTDN_REASON_MINOR_SERVICEPACK = 0x00000010;
    static final int SHTDN_REASON_MINOR_HOTFIX = 0x00000011;
    static final int SHTDN_REASON_MINOR_SECURITYFIX = 0x00000012;
    static final int SHTDN_REASON_MINOR_SECURITY = 0x00000013;
    static final int SHTDN_REASON_MINOR_NETWORK_CONNECTIVITY = 0x00000014;
    static final int SHTDN_REASON_MINOR_WMI = 0x00000015;
    static final int SHTDN_REASON_MINOR_SERVICEPACK_UNINSTALL = 0x00000016;
    static final int SHTDN_REASON_MINOR_HOTFIX_UNINSTALL = 0x00000017;
    static final int SHTDN_REASON_MINOR_SECURITYFIX_UNINSTALL = 0x00000018;
    static final int SHTDN_REASON_MINOR_MMC = 0x00000019;
    static final int SHTDN_REASON_MINOR_TERMSRV = 0x00000020;
    static final int SHTDN_REASON_UNKNOWN = SHTDN_REASON_MINOR_NONE;
    static final int SHTDN_REASON_LEGACY_API = (SHTDN_REASON_MAJOR_LEGACY_API | SHTDN_REASON_FLAG_PLANNED);
    static final int SHTDN_REASON_VALID_BIT_MASK = 0xc0ffffff;
    static final int PCLEANUI = (SHTDN_REASON_FLAG_PLANNED | SHTDN_REASON_FLAG_CLEAN_UI);
    static final int UCLEANUI = (SHTDN_REASON_FLAG_CLEAN_UI);
    static final int PDIRTYUI = (SHTDN_REASON_FLAG_PLANNED | SHTDN_REASON_FLAG_DIRTY_UI);
    static final int UDIRTYUI = (SHTDN_REASON_FLAG_DIRTY_UI);
    static final int MAX_REASON_NAME_LEN = 64;
    static final int MAX_REASON_DESC_LEN = 256;
    static final int MAX_REASON_BUGID_LEN = 32;
    static final int MAX_REASON_COMMENT_LEN = 512;
    static final int SHUTDOWN_TYPE_LEN = 32;
    static final int POLICY_SHOWREASONUI_NEVER = 0;
    static final int POLICY_SHOWREASONUI_ALWAYS = 1;
    static final int POLICY_SHOWREASONUI_WORKSTATIONONLY = 2;
    static final int POLICY_SHOWREASONUI_SERVERONLY = 3;
    static final int SNAPSHOT_POLICY_NEVER = 0;
    static final int SNAPSHOT_POLICY_ALWAYS = 1;
    static final int SNAPSHOT_POLICY_UNPLANNED = 2;
    static final int MAX_NUM_REASONS = 256;
    static final int REASON_SWINSTALL = SHTDN_REASON_MAJOR_SOFTWARE|SHTDN_REASON_MINOR_INSTALLATION;
    static final int REASON_HWINSTALL = SHTDN_REASON_MAJOR_HARDWARE|SHTDN_REASON_MINOR_INSTALLATION;
    static final int REASON_SERVICEHANG = SHTDN_REASON_MAJOR_SOFTWARE|SHTDN_REASON_MINOR_HUNG;
    static final int REASON_UNSTABLE = SHTDN_REASON_MAJOR_SYSTEM|SHTDN_REASON_MINOR_UNSTABLE;
    static final int REASON_SWHWRECONF = SHTDN_REASON_MAJOR_SOFTWARE|SHTDN_REASON_MINOR_RECONFIG;
    static final int REASON_OTHER = SHTDN_REASON_MAJOR_OTHER|SHTDN_REASON_MINOR_OTHER;
    static final int REASON_UNKNOWN = SHTDN_REASON_UNKNOWN;
    static final int REASON_LEGACY_API = SHTDN_REASON_LEGACY_API;
    static final int REASON_PLANNED_FLAG = SHTDN_REASON_FLAG_PLANNED;
    static final int WNNC_NET_MSNET = 0x00010000;
    static final int WNNC_NET_LANMAN = 0x00020000;
    static final int WNNC_NET_NETWARE = 0x00030000;
    static final int WNNC_NET_VINES = 0x00040000;
    static final int WNNC_NET_10NET = 0x00050000;
    static final int WNNC_NET_LOCUS = 0x00060000;
    static final int WNNC_NET_SUN_PC_NFS = 0x00070000;
    static final int WNNC_NET_LANSTEP = 0x00080000;
    static final int WNNC_NET_9TILES = 0x00090000;
    static final int WNNC_NET_LANTASTIC = 0x000A0000;
    static final int WNNC_NET_AS400 = 0x000B0000;
    static final int WNNC_NET_FTP_NFS = 0x000C0000;
    static final int WNNC_NET_PATHWORKS = 0x000D0000;
    static final int WNNC_NET_LIFENET = 0x000E0000;
    static final int WNNC_NET_POWERLAN = 0x000F0000;
    static final int WNNC_NET_BWNFS = 0x00100000;
    static final int WNNC_NET_COGENT = 0x00110000;
    static final int WNNC_NET_FARALLON = 0x00120000;
    static final int WNNC_NET_APPLETALK = 0x00130000;
    static final int WNNC_NET_INTERGRAPH = 0x00140000;
    static final int WNNC_NET_SYMFONET = 0x00150000;
    static final int WNNC_NET_CLEARCASE = 0x00160000;
    static final int WNNC_NET_FRONTIER = 0x00170000;
    static final int WNNC_NET_BMC = 0x00180000;
    static final int WNNC_NET_DCE = 0x00190000;
    static final int WNNC_NET_AVID = 0x001A0000;
    static final int WNNC_NET_DOCUSPACE = 0x001B0000;
    static final int WNNC_NET_MANGOSOFT = 0x001C0000;
    static final int WNNC_NET_SERNET = 0x001D0000;
    static final int WNNC_NET_RIVERFRONT1 = 0X001E0000;
    static final int WNNC_NET_RIVERFRONT2 = 0x001F0000;
    static final int WNNC_NET_DECORB = 0x00200000;
    static final int WNNC_NET_PROTSTOR = 0x00210000;
    static final int WNNC_NET_FJ_REDIR = 0x00220000;
    static final int WNNC_NET_DISTINCT = 0x00230000;
    static final int WNNC_NET_TWINS = 0x00240000;
    static final int WNNC_NET_RDR2SAMPLE = 0x00250000;
    static final int WNNC_NET_CSC = 0x00260000;
    static final int WNNC_NET_3IN1 = 0x00270000;
    static final int WNNC_NET_EXTENDNET = 0x00290000;
    static final int WNNC_NET_STAC = 0x002A0000;
    static final int WNNC_NET_FOXBAT = 0x002B0000;
    static final int WNNC_NET_YAHOO = 0x002C0000;
    static final int WNNC_NET_EXIFS = 0x002D0000;
    static final int WNNC_NET_DAV = 0x002E0000;
    static final int WNNC_NET_KNOWARE = 0x002F0000;
    static final int WNNC_NET_OBJECT_DIRE = 0x00300000;
    static final int WNNC_NET_MASFAX = 0x00310000;
    static final int WNNC_NET_HOB_NFS = 0x00320000;
    static final int WNNC_NET_SHIVA = 0x00330000;
    static final int WNNC_NET_IBMAL = 0x00340000;
    static final int WNNC_NET_LOCK = 0x00350000;
    static final int WNNC_NET_TERMSRV = 0x00360000;
    static final int WNNC_NET_SRT = 0x00370000;
    static final int WNNC_CRED_MANAGER = 0xFFFF0000;
    static final int RESOURCE_CONNECTED = 0x00000001;
    static final int RESOURCE_GLOBALNET = 0x00000002;
    static final int RESOURCE_REMEMBERED = 0x00000003;
    static final int RESOURCE_RECENT = 0x00000004;
    static final int RESOURCE_CONTEXT = 0x00000005;
    static final int RESOURCETYPE_ANY = 0x00000000;
    static final int RESOURCETYPE_DISK = 0x00000001;
    static final int RESOURCETYPE_PRINT = 0x00000002;
    static final int RESOURCETYPE_RESERVED = 0x00000008;
    static final int RESOURCETYPE_UNKNOWN = 0xFFFFFFFF;
    static final int RESOURCEUSAGE_CONNECTABLE = 0x00000001;
    static final int RESOURCEUSAGE_CONTAINER = 0x00000002;
    static final int RESOURCEUSAGE_NOLOCALDEVICE = 0x00000004;
    static final int RESOURCEUSAGE_SIBLING = 0x00000008;
    static final int RESOURCEUSAGE_ATTACHED = 0x00000010;
    static final int RESOURCEUSAGE_ALL = (RESOURCEUSAGE_CONNECTABLE | RESOURCEUSAGE_CONTAINER | RESOURCEUSAGE_ATTACHED);
    static final int RESOURCEUSAGE_RESERVED = 0x80000000;
    static final int RESOURCEDISPLAYTYPE_GENERIC = 0x00000000;
    static final int RESOURCEDISPLAYTYPE_DOMAIN = 0x00000001;
    static final int RESOURCEDISPLAYTYPE_SERVER = 0x00000002;
    static final int RESOURCEDISPLAYTYPE_SHARE = 0x00000003;
    static final int RESOURCEDISPLAYTYPE_FILE = 0x00000004;
    static final int RESOURCEDISPLAYTYPE_GROUP = 0x00000005;
    static final int RESOURCEDISPLAYTYPE_NETWORK = 0x00000006;
    static final int RESOURCEDISPLAYTYPE_ROOT = 0x00000007;
    static final int RESOURCEDISPLAYTYPE_SHAREADMIN = 0x00000008;
    static final int RESOURCEDISPLAYTYPE_DIRECTORY = 0x00000009;
    static final int RESOURCEDISPLAYTYPE_TREE = 0x0000000A;
    static final int RESOURCEDISPLAYTYPE_NDSCONTAINER = 0x0000000B;
    static final int NETPROPERTY_PERSISTENT = 1;
    static final int CONNECT_UPDATE_PROFILE = 0x00000001;
    static final int CONNECT_UPDATE_RECENT = 0x00000002;
    static final int CONNECT_TEMPORARY = 0x00000004;
    static final int CONNECT_INTERACTIVE = 0x00000008;
    static final int CONNECT_PROMPT = 0x00000010;
    static final int CONNECT_NEED_DRIVE = 0x00000020;
    static final int CONNECT_REFCOUNT = 0x00000040;
    static final int CONNECT_REDIRECT = 0x00000080;
    static final int CONNECT_LOCALDRIVE = 0x00000100;
    static final int CONNECT_CURRENT_MEDIA = 0x00000200;
    static final int CONNECT_DEFERRED = 0x00000400;
    static final int CONNECT_RESERVED = 0xFF000000;
    static final int CONNECT_COMMANDLINE = 0x00000800;
    static final int CONNECT_CMD_SAVECRED = 0x00001000;
    static final int CONNDLG_RO_PATH = 0x00000001;
    static final int CONNDLG_CONN_POINT = 0x00000002;
    static final int CONNDLG_USE_MRU = 0x00000004;
    static final int CONNDLG_HIDE_BOX = 0x00000008;
    static final int CONNDLG_PERSIST = 0x00000010;
    static final int CONNDLG_NOT_PERSIST = 0x00000020;
    static final int DISC_UPDATE_PROFILE = 0x00000001;
    static final int DISC_NO_FORCE = 0x00000040;
    static final int UNIVERSAL_NAME_INFO_LEVEL = 0x00000001;
    static final int REMOTE_NAME_INFO_LEVEL = 0x00000002;
    static final int WNFMT_MULTILINE = 0x01;
    static final int WNFMT_ABBREVIATED = 0x02;
    static final int WNFMT_INENUM = 0x10;
    static final int WNFMT_CONNECTION = 0x20;
    static final int NETINFO_DLL16 = 0x00000001;
    static final int NETINFO_DISKRED = 0x00000004;
    static final int NETINFO_PRINTERRED = 0x00000008;
    static final int RP_LOGON = 0x01;
    static final int RP_INIFILE = 0x02;
    static final int PP_DISPLAYERRORS = 0x01;
    static final int WN_SUCCESS = NO_ERROR;
    static final int WN_NO_ERROR = NO_ERROR;
    static final int WN_NOT_SUPPORTED = ERROR_NOT_SUPPORTED;
    static final int WN_CANCEL = ERROR_CANCELLED;
    static final int WN_RETRY = ERROR_RETRY;
    static final int WN_NET_ERROR = ERROR_UNEXP_NET_ERR;
    static final int WN_MORE_DATA = ERROR_MORE_DATA;
    static final int WN_BAD_POINTER = ERROR_INVALID_ADDRESS;
    static final int WN_BAD_VALUE = ERROR_INVALID_PARAMETER;
    static final int WN_BAD_USER = ERROR_BAD_USERNAME;
    static final int WN_BAD_PASSWORD = ERROR_INVALID_PASSWORD;
    static final int WN_ACCESS_DENIED = ERROR_ACCESS_DENIED;
    static final int WN_FUNCTION_BUSY = ERROR_BUSY;
    static final int WN_WINDOWS_ERROR = ERROR_UNEXP_NET_ERR;
    static final int WN_OUT_OF_MEMORY = ERROR_NOT_ENOUGH_MEMORY;
    static final int WN_NO_NETWORK = ERROR_NO_NETWORK;
    static final int WN_EXTENDED_ERROR = ERROR_EXTENDED_ERROR;
    static final int WN_BAD_LEVEL = ERROR_INVALID_LEVEL;
    static final int WN_BAD_HANDLE = ERROR_INVALID_HANDLE;
    static final int WN_NOT_INITIALIZING = ERROR_ALREADY_INITIALIZED;
    static final int WN_NO_MORE_DEVICES = ERROR_NO_MORE_DEVICES;
    static final int WN_NOT_CONNECTED = ERROR_NOT_CONNECTED;
    static final int WN_OPEN_FILES = ERROR_OPEN_FILES;
    static final int WN_DEVICE_IN_USE = ERROR_DEVICE_IN_USE;
    static final int WN_BAD_NETNAME = ERROR_BAD_NET_NAME;
    static final int WN_BAD_LOCALNAME = ERROR_BAD_DEVICE;
    static final int WN_ALREADY_CONNECTED = ERROR_ALREADY_ASSIGNED;
    static final int WN_DEVICE_ERROR = ERROR_GEN_FAILURE;
    static final int WN_CONNECTION_CLOSED = ERROR_CONNECTION_UNAVAIL;
    static final int WN_NO_NET_OR_BAD_PATH = ERROR_NO_NET_OR_BAD_PATH;
    static final int WN_BAD_PROVIDER = ERROR_BAD_PROVIDER;
    static final int WN_CANNOT_OPEN_PROFILE = ERROR_CANNOT_OPEN_PROFILE;
    static final int WN_BAD_PROFILE = ERROR_BAD_PROFILE;
    static final int WN_BAD_DEV_TYPE = ERROR_BAD_DEV_TYPE;
    static final int WN_DEVICE_ALREADY_REMEMBERED = ERROR_DEVICE_ALREADY_REMEMBERED;
    static final int WN_CONNECTED_OTHER_PASSWORD = ERROR_CONNECTED_OTHER_PASSWORD;
    static final int WN_CONNECTED_OTHER_PASSWORD_DEFAULT = ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT;
    static final int WN_NO_MORE_ENTRIES = ERROR_NO_MORE_ITEMS;
    static final int WN_NOT_CONTAINER = ERROR_NOT_CONTAINER;
    static final int WN_NOT_AUTHENTICATED = ERROR_NOT_AUTHENTICATED;
    static final int WN_NOT_LOGGED_ON = ERROR_NOT_LOGGED_ON;
    static final int WN_NOT_VALIDATED = ERROR_NO_LOGON_SERVERS;
    static final int WNCON_FORNETCARD = 0x00000001;
    static final int WNCON_NOTROUTED = 0x00000002;
    static final int WNCON_SLOWLINK = 0x00000004;
    static final int WNCON_DYNAMIC = 0x00000008;
    static final int CDERR_DIALOGFAILURE = 0xFFFF;
    static final int CDERR_GENERALCODES = 0x0000;
    static final int CDERR_STRUCTSIZE = 0x0001;
    static final int CDERR_INITIALIZATION = 0x0002;
    static final int CDERR_NOTEMPLATE = 0x0003;
    static final int CDERR_NOHINSTANCE = 0x0004;
    static final int CDERR_LOADSTRFAILURE = 0x0005;
    static final int CDERR_FINDRESFAILURE = 0x0006;
    static final int CDERR_LOADRESFAILURE = 0x0007;
    static final int CDERR_LOCKRESFAILURE = 0x0008;
    static final int CDERR_MEMALLOCFAILURE = 0x0009;
    static final int CDERR_MEMLOCKFAILURE = 0x000A;
    static final int CDERR_NOHOOK = 0x000B;
    static final int CDERR_REGISTERMSGFAIL = 0x000C;
    static final int PDERR_PRINTERCODES = 0x1000;
    static final int PDERR_SETUPFAILURE = 0x1001;
    static final int PDERR_PARSEFAILURE = 0x1002;
    static final int PDERR_RETDEFFAILURE = 0x1003;
    static final int PDERR_LOADDRVFAILURE = 0x1004;
    static final int PDERR_GETDEVMODEFAIL = 0x1005;
    static final int PDERR_INITFAILURE = 0x1006;
    static final int PDERR_NODEVICES = 0x1007;
    static final int PDERR_NODEFAULTPRN = 0x1008;
    static final int PDERR_DNDMMISMATCH = 0x1009;
    static final int PDERR_CREATEICFAILURE = 0x100A;
    static final int PDERR_PRINTERNOTFOUND = 0x100B;
    static final int PDERR_DEFAULTDIFFERENT = 0x100C;
    static final int CFERR_CHOOSEFONTCODES = 0x2000;
    static final int CFERR_NOFONTS = 0x2001;
    static final int CFERR_MAXLESSTHANMIN = 0x2002;
    static final int FNERR_FILENAMECODES = 0x3000;
    static final int FNERR_SUBCLASSFAILURE = 0x3001;
    static final int FNERR_INVALIDFILENAME = 0x3002;
    static final int FNERR_BUFFERTOOSMALL = 0x3003;
    static final int FRERR_FINDREPLACECODES = 0x4000;
    static final int FRERR_BUFFERLENGTHZERO = 0x4001;
    static final int CCERR_CHOOSECOLORCODES = 0x5000;
    static final int WM_DDE_FIRST = 0x03E0;
    static final int WM_DDE_INITIATE = (WM_DDE_FIRST);
    static final int WM_DDE_TERMINATE = (WM_DDE_FIRST+1);
    static final int WM_DDE_ADVISE = (WM_DDE_FIRST+2);
    static final int WM_DDE_UNADVISE = (WM_DDE_FIRST+3);
    static final int WM_DDE_ACK = (WM_DDE_FIRST+4);
    static final int WM_DDE_DATA = (WM_DDE_FIRST+5);
    static final int WM_DDE_REQUEST = (WM_DDE_FIRST+6);
    static final int WM_DDE_POKE = (WM_DDE_FIRST+7);
    static final int WM_DDE_EXECUTE = (WM_DDE_FIRST+8);
    static final int WM_DDE_LAST = (WM_DDE_FIRST+8);
    static final int XST_NULL = 0;
    static final int XST_INCOMPLETE = 1;
    static final int XST_CONNECTED = 2;
    static final int XST_INIT1 = 3;
    static final int XST_INIT2 = 4;
    static final int XST_REQSENT = 5;
    static final int XST_DATARCVD = 6;
    static final int XST_POKESENT = 7;
    static final int XST_POKEACKRCVD = 8;
    static final int XST_EXECSENT = 9;
    static final int XST_EXECACKRCVD = 10;
    static final int XST_ADVSENT = 11;
    static final int XST_UNADVSENT = 12;
    static final int XST_ADVACKRCVD = 13;
    static final int XST_UNADVACKRCVD = 14;
    static final int XST_ADVDATASENT = 15;
    static final int XST_ADVDATAACKRCVD = 16;
    static final int CADV_LATEACK = 0xFFFF;
    static final int ST_CONNECTED = 0x0001;
    static final int ST_ADVISE = 0x0002;
    static final int ST_ISLOCAL = 0x0004;
    static final int ST_BLOCKED = 0x0008;
    static final int ST_CLIENT = 0x0010;
    static final int ST_TERMINATED = 0x0020;
    static final int ST_INLIST = 0x0040;
    static final int ST_BLOCKNEXT = 0x0080;
    static final int ST_ISSELF = 0x0100;
    static final int DDE_FACK = 0x8000;
    static final int DDE_FBUSY = 0x4000;
    static final int DDE_FDEFERUPD = 0x4000;
    static final int DDE_FACKREQ = 0x8000;
    static final int DDE_FRELEASE = 0x2000;
    static final int DDE_FREQUESTED = 0x1000;
    static final int DDE_FAPPSTATUS = 0x00ff;
    static final int DDE_FNOTPROCESSED = 0x0000;
    static final int MSGF_DDEMGR = 0x8001;
    static final int CP_WINANSI = 1004;
    static final int CP_WINUNICODE = 1200;
    static final int CP_WINNEUTRAL = CP_WINANSI;
    static final int XTYPF_NOBLOCK = 0x0002;
    static final int XTYPF_NODATA = 0x0004;
    static final int XTYPF_ACKREQ = 0x0008;
    static final int XCLASS_MASK = 0xFC00;
    static final int XCLASS_BOOL = 0x1000;
    static final int XCLASS_DATA = 0x2000;
    static final int XCLASS_FLAGS = 0x4000;
    static final int XCLASS_NOTIFICATION = 0x8000;
    static final int XTYP_ERROR = (0x0000 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK );
    static final int XTYP_ADVDATA = (0x0010 | XCLASS_FLAGS );
    static final int XTYP_ADVREQ = (0x0020 | XCLASS_DATA | XTYPF_NOBLOCK );
    static final int XTYP_ADVSTART = (0x0030 | XCLASS_BOOL );
    static final int XTYP_ADVSTOP = (0x0040 | XCLASS_NOTIFICATION);
    static final int XTYP_EXECUTE = (0x0050 | XCLASS_FLAGS );
    static final int XTYP_CONNECT = (0x0060 | XCLASS_BOOL | XTYPF_NOBLOCK);
    static final int XTYP_CONNECT_CONFIRM = (0x0070 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK);
    static final int XTYP_XACT_COMPLETE = (0x0080 | XCLASS_NOTIFICATION );
    static final int XTYP_POKE = (0x0090 | XCLASS_FLAGS );
    static final int XTYP_REGISTER = (0x00A0 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK);
    static final int XTYP_REQUEST = (0x00B0 | XCLASS_DATA );
    static final int XTYP_DISCONNECT = (0x00C0 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK);
    static final int XTYP_UNREGISTER = (0x00D0 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK);
    static final int XTYP_WILDCONNECT = (0x00E0 | XCLASS_DATA | XTYPF_NOBLOCK);
    static final int XTYP_MASK = 0x00F0;
    static final int XTYP_SHIFT = 4;
    static final int TIMEOUT_ASYNC = 0xFFFFFFFF;
    static final int QID_SYNC = 0xFFFFFFFF;
    static final int CBF_FAIL_SELFCONNECTIONS = 0x00001000;
    static final int CBF_FAIL_CONNECTIONS = 0x00002000;
    static final int CBF_FAIL_ADVISES = 0x00004000;
    static final int CBF_FAIL_EXECUTES = 0x00008000;
    static final int CBF_FAIL_POKES = 0x00010000;
    static final int CBF_FAIL_REQUESTS = 0x00020000;
    static final int CBF_FAIL_ALLSVRXACTIONS = 0x0003f000;
    static final int CBF_SKIP_CONNECT_CONFIRMS = 0x00040000;
    static final int CBF_SKIP_REGISTRATIONS = 0x00080000;
    static final int CBF_SKIP_UNREGISTRATIONS = 0x00100000;
    static final int CBF_SKIP_DISCONNECTS = 0x00200000;
    static final int CBF_SKIP_ALLNOTIFICATIONS = 0x003c0000;
    static final int APPCMD_CLIENTONLY = 0x00000010;
    static final int APPCMD_FILTERINITS = 0x00000020;
    static final int APPCMD_MASK = 0x00000FF0;
    static final int APPCLASS_STANDARD = 0x00000000;
    static final int APPCLASS_MASK = 0x0000000F;
    static final int EC_ENABLEALL = 0;
    static final int EC_ENABLEONE = ST_BLOCKNEXT;
    static final int EC_DISABLE = ST_BLOCKED;
    static final int EC_QUERYWAITING = 2;
    static final int DNS_REGISTER = 0x0001;
    static final int DNS_UNREGISTER = 0x0002;
    static final int DNS_FILTERON = 0x0004;
    static final int DNS_FILTEROFF = 0x0008;
    static final int HDATA_APPOWNED = 0x0001;
    static final int DMLERR_NO_ERROR = 0;
    static final int DMLERR_FIRST = 0x4000;
    static final int DMLERR_ADVACKTIMEOUT = 0x4000;
    static final int DMLERR_BUSY = 0x4001;
    static final int DMLERR_DATAACKTIMEOUT = 0x4002;
    static final int DMLERR_DLL_NOT_INITIALIZED = 0x4003;
    static final int DMLERR_DLL_USAGE = 0x4004;
    static final int DMLERR_EXECACKTIMEOUT = 0x4005;
    static final int DMLERR_INVALIDPARAMETER = 0x4006;
    static final int DMLERR_LOW_MEMORY = 0x4007;
    static final int DMLERR_MEMORY_ERROR = 0x4008;
    static final int DMLERR_NOTPROCESSED = 0x4009;
    static final int DMLERR_NO_CONV_ESTABLISHED = 0x400a;
    static final int DMLERR_POKEACKTIMEOUT = 0x400b;
    static final int DMLERR_POSTMSG_FAILED = 0x400c;
    static final int DMLERR_REENTRANCY = 0x400d;
    static final int DMLERR_SERVER_DIED = 0x400e;
    static final int DMLERR_SYS_ERROR = 0x400f;
    static final int DMLERR_UNADVACKTIMEOUT = 0x4010;
    static final int DMLERR_UNFOUND_QUEUE_ID = 0x4011;
    static final int DMLERR_LAST = 0x4011;
    static final int MH_CREATE = 1;
    static final int MH_KEEP = 2;
    static final int MH_DELETE = 3;
    static final int MH_CLEANUP = 4;
    static final int MAX_MONITORS = 4;
    static final int APPCLASS_MONITOR = 0x00000001;
    static final int XTYP_MONITOR = (0x00F0 | XCLASS_NOTIFICATION | XTYPF_NOBLOCK);
    static final int MF_HSZ_INFO = 0x01000000;
    static final int MF_SENDMSGS = 0x02000000;
    static final int MF_POSTMSGS = 0x04000000;
    static final int MF_CALLBACKS = 0x08000000;
    static final int MF_ERRORS = 0x10000000;
    static final int MF_LINKS = 0x20000000;
    static final int MF_CONV = 0x40000000;
    static final int MF_MASK = 0xFF000000;
    static final int ctlFirst = 0x0400;
    static final int ctlLast = 0x04ff;
    static final int psh1 = 0x0400;
    static final int psh2 = 0x0401;
    static final int psh3 = 0x0402;
    static final int psh4 = 0x0403;
    static final int psh5 = 0x0404;
    static final int psh6 = 0x0405;
    static final int psh7 = 0x0406;
    static final int psh8 = 0x0407;
    static final int psh9 = 0x0408;
    static final int psh10 = 0x0409;
    static final int psh11 = 0x040a;
    static final int psh12 = 0x040b;
    static final int psh13 = 0x040c;
    static final int psh14 = 0x040d;
    static final int psh15 = 0x040e;
    static final int pshHelp = psh15;
    static final int psh16 = 0x040f;
    static final int chx1 = 0x0410;
    static final int chx2 = 0x0411;
    static final int chx3 = 0x0412;
    static final int chx4 = 0x0413;
    static final int chx5 = 0x0414;
    static final int chx6 = 0x0415;
    static final int chx7 = 0x0416;
    static final int chx8 = 0x0417;
    static final int chx9 = 0x0418;
    static final int chx10 = 0x0419;
    static final int chx11 = 0x041a;
    static final int chx12 = 0x041b;
    static final int chx13 = 0x041c;
    static final int chx14 = 0x041d;
    static final int chx15 = 0x041e;
    static final int chx16 = 0x041f;
    static final int rad1 = 0x0420;
    static final int rad2 = 0x0421;
    static final int rad3 = 0x0422;
    static final int rad4 = 0x0423;
    static final int rad5 = 0x0424;
    static final int rad6 = 0x0425;
    static final int rad7 = 0x0426;
    static final int rad8 = 0x0427;
    static final int rad9 = 0x0428;
    static final int rad10 = 0x0429;
    static final int rad11 = 0x042a;
    static final int rad12 = 0x042b;
    static final int rad13 = 0x042c;
    static final int rad14 = 0x042d;
    static final int rad15 = 0x042e;
    static final int rad16 = 0x042f;
    static final int grp1 = 0x0430;
    static final int grp2 = 0x0431;
    static final int grp3 = 0x0432;
    static final int grp4 = 0x0433;
    static final int frm1 = 0x0434;
    static final int frm2 = 0x0435;
    static final int frm3 = 0x0436;
    static final int frm4 = 0x0437;
    static final int rct1 = 0x0438;
    static final int rct2 = 0x0439;
    static final int rct3 = 0x043a;
    static final int rct4 = 0x043b;
    static final int ico1 = 0x043c;
    static final int ico2 = 0x043d;
    static final int ico3 = 0x043e;
    static final int ico4 = 0x043f;
    static final int stc1 = 0x0440;
    static final int stc2 = 0x0441;
    static final int stc3 = 0x0442;
    static final int stc4 = 0x0443;
    static final int stc5 = 0x0444;
    static final int stc6 = 0x0445;
    static final int stc7 = 0x0446;
    static final int stc8 = 0x0447;
    static final int stc9 = 0x0448;
    static final int stc10 = 0x0449;
    static final int stc11 = 0x044a;
    static final int stc12 = 0x044b;
    static final int stc13 = 0x044c;
    static final int stc14 = 0x044d;
    static final int stc15 = 0x044e;
    static final int stc16 = 0x044f;
    static final int stc17 = 0x0450;
    static final int stc18 = 0x0451;
    static final int stc19 = 0x0452;
    static final int stc20 = 0x0453;
    static final int stc21 = 0x0454;
    static final int stc22 = 0x0455;
    static final int stc23 = 0x0456;
    static final int stc24 = 0x0457;
    static final int stc25 = 0x0458;
    static final int stc26 = 0x0459;
    static final int stc27 = 0x045a;
    static final int stc28 = 0x045b;
    static final int stc29 = 0x045c;
    static final int stc30 = 0x045d;
    static final int stc31 = 0x045e;
    static final int stc32 = 0x045f;
    static final int lst1 = 0x0460;
    static final int lst2 = 0x0461;
    static final int lst3 = 0x0462;
    static final int lst4 = 0x0463;
    static final int lst5 = 0x0464;
    static final int lst6 = 0x0465;
    static final int lst7 = 0x0466;
    static final int lst8 = 0x0467;
    static final int lst9 = 0x0468;
    static final int lst10 = 0x0469;
    static final int lst11 = 0x046a;
    static final int lst12 = 0x046b;
    static final int lst13 = 0x046c;
    static final int lst14 = 0x046d;
    static final int lst15 = 0x046e;
    static final int lst16 = 0x046f;
    static final int cmb1 = 0x0470;
    static final int cmb2 = 0x0471;
    static final int cmb3 = 0x0472;
    static final int cmb4 = 0x0473;
    static final int cmb5 = 0x0474;
    static final int cmb6 = 0x0475;
    static final int cmb7 = 0x0476;
    static final int cmb8 = 0x0477;
    static final int cmb9 = 0x0478;
    static final int cmb10 = 0x0479;
    static final int cmb11 = 0x047a;
    static final int cmb12 = 0x047b;
    static final int cmb13 = 0x047c;
    static final int cmb14 = 0x047d;
    static final int cmb15 = 0x047e;
    static final int cmb16 = 0x047f;
    static final int edt1 = 0x0480;
    static final int edt2 = 0x0481;
    static final int edt3 = 0x0482;
    static final int edt4 = 0x0483;
    static final int edt5 = 0x0484;
    static final int edt6 = 0x0485;
    static final int edt7 = 0x0486;
    static final int edt8 = 0x0487;
    static final int edt9 = 0x0488;
    static final int edt10 = 0x0489;
    static final int edt11 = 0x048a;
    static final int edt12 = 0x048b;
    static final int edt13 = 0x048c;
    static final int edt14 = 0x048d;
    static final int edt15 = 0x048e;
    static final int edt16 = 0x048f;
    static final int scr1 = 0x0490;
    static final int scr2 = 0x0491;
    static final int scr3 = 0x0492;
    static final int scr4 = 0x0493;
    static final int scr5 = 0x0494;
    static final int scr6 = 0x0495;
    static final int scr7 = 0x0496;
    static final int scr8 = 0x0497;
    static final int ctl1 = 0x04A0;
    static final int FILEOPENORD = 1536;
    static final int MULTIFILEOPENORD = 1537;
    static final int PRINTDLGORD = 1538;
    static final int PRNSETUPDLGORD = 1539;
    static final int FINDDLGORD = 1540;
    static final int REPLACEDLGORD = 1541;
    static final int FONTDLGORD = 1542;
    static final int FORMATDLGORD31 = 1543;
    static final int FORMATDLGORD30 = 1544;
    static final int RUNDLGORD = 1545;
    static final int PAGESETUPDLGORD = 1546;
    static final int NEWFILEOPENORD = 1547;
    static final int PRINTDLGEXORD = 1549;
    static final int PAGESETUPDLGORDMOTIF = 1550;
    static final int COLORMGMTDLGORD = 1551;
    static final int NEWFILEOPENV2ORD = 1552;
    static final int LZERROR_BADINHANDLE = (-1);
    static final int LZERROR_BADOUTHANDLE = (-2);
    static final int LZERROR_READ = (-3);
    static final int LZERROR_WRITE = (-4);
    static final int LZERROR_GLOBALLOC = (-5);
    static final int LZERROR_GLOBLOCK = (-6);
    static final int LZERROR_BADVALUE = (-7);
    static final int LZERROR_UNKNOWNALG = (-8);
    static final int MAXPNAMELEN = 32;
    static final int MAXERRORLENGTH = 256;
    static final int MAX_JOYSTICKOEMVXDNAME = 260;
    static final int TIME_MS = 0x0001;
    static final int TIME_SAMPLES = 0x0002;
    static final int TIME_BYTES = 0x0004;
    static final int TIME_SMPTE = 0x0008;
    static final int TIME_MIDI = 0x0010;
    static final int TIME_TICKS = 0x0020;
    static final int MM_JOY1MOVE = 0x3A0;
    static final int MM_JOY2MOVE = 0x3A1;
    static final int MM_JOY1ZMOVE = 0x3A2;
    static final int MM_JOY2ZMOVE = 0x3A3;
    static final int MM_JOY1BUTTONDOWN = 0x3B5;
    static final int MM_JOY2BUTTONDOWN = 0x3B6;
    static final int MM_JOY1BUTTONUP = 0x3B7;
    static final int MM_JOY2BUTTONUP = 0x3B8;
    static final int MM_MCINOTIFY = 0x3B9;
    static final int MM_WOM_OPEN = 0x3BB;
    static final int MM_WOM_CLOSE = 0x3BC;
    static final int MM_WOM_DONE = 0x3BD;
    static final int MM_WIM_OPEN = 0x3BE;
    static final int MM_WIM_CLOSE = 0x3BF;
    static final int MM_WIM_DATA = 0x3C0;
    static final int MM_MIM_OPEN = 0x3C1;
    static final int MM_MIM_CLOSE = 0x3C2;
    static final int MM_MIM_DATA = 0x3C3;
    static final int MM_MIM_LONGDATA = 0x3C4;
    static final int MM_MIM_ERROR = 0x3C5;
    static final int MM_MIM_LONGERROR = 0x3C6;
    static final int MM_MOM_OPEN = 0x3C7;
    static final int MM_MOM_CLOSE = 0x3C8;
    static final int MM_MOM_DONE = 0x3C9;
    static final int MM_DRVM_OPEN = 0x3D0;
    static final int MM_DRVM_CLOSE = 0x3D1;
    static final int MM_DRVM_DATA = 0x3D2;
    static final int MM_DRVM_ERROR = 0x3D3;
    static final int MM_STREAM_OPEN = 0x3D4;
    static final int MM_STREAM_CLOSE = 0x3D5;
    static final int MM_STREAM_DONE = 0x3D6;
    static final int MM_STREAM_ERROR = 0x3D7;
    static final int MM_MOM_POSITIONCB = 0x3CA;
    static final int MM_MCISIGNAL = 0x3CB;
    static final int MM_MIM_MOREDATA = 0x3CC;
    static final int MM_MIXM_LINE_CHANGE = 0x3D0;
    static final int MM_MIXM_CONTROL_CHANGE = 0x3D1;
    static final int MMSYSERR_BASE = 0;
    static final int WAVERR_BASE = 32;
    static final int MIDIERR_BASE = 64;
    static final int TIMERR_BASE = 96;
    static final int JOYERR_BASE = 160;
    static final int MCIERR_BASE = 256;
    static final int MIXERR_BASE = 1024;
    static final int MCI_STRING_OFFSET = 512;
    static final int MCI_VD_OFFSET = 1024;
    static final int MCI_CD_OFFSET = 1088;
    static final int MCI_WAVE_OFFSET = 1152;
    static final int MCI_SEQ_OFFSET = 1216;
    static final int MMSYSERR_NOERROR = 0;
    static final int MMSYSERR_ERROR = (MMSYSERR_BASE + 1);
    static final int MMSYSERR_BADDEVICEID = (MMSYSERR_BASE + 2);
    static final int MMSYSERR_NOTENABLED = (MMSYSERR_BASE + 3);
    static final int MMSYSERR_ALLOCATED = (MMSYSERR_BASE + 4);
    static final int MMSYSERR_INVALHANDLE = (MMSYSERR_BASE + 5);
    static final int MMSYSERR_NODRIVER = (MMSYSERR_BASE + 6);
    static final int MMSYSERR_NOMEM = (MMSYSERR_BASE + 7);
    static final int MMSYSERR_NOTSUPPORTED = (MMSYSERR_BASE + 8);
    static final int MMSYSERR_BADERRNUM = (MMSYSERR_BASE + 9);
    static final int MMSYSERR_INVALFLAG = (MMSYSERR_BASE + 10);
    static final int MMSYSERR_INVALPARAM = (MMSYSERR_BASE + 11);
    static final int MMSYSERR_HANDLEBUSY = (MMSYSERR_BASE + 12);
    static final int MMSYSERR_INVALIDALIAS = (MMSYSERR_BASE + 13);
    static final int MMSYSERR_BADDB = (MMSYSERR_BASE + 14);
    static final int MMSYSERR_KEYNOTFOUND = (MMSYSERR_BASE + 15);
    static final int MMSYSERR_READERROR = (MMSYSERR_BASE + 16);
    static final int MMSYSERR_WRITEERROR = (MMSYSERR_BASE + 17);
    static final int MMSYSERR_DELETEERROR = (MMSYSERR_BASE + 18);
    static final int MMSYSERR_VALNOTFOUND = (MMSYSERR_BASE + 19);
    static final int MMSYSERR_NODRIVERCB = (MMSYSERR_BASE + 20);
    static final int MMSYSERR_MOREDATA = (MMSYSERR_BASE + 21);
    static final int MMSYSERR_LASTERROR = (MMSYSERR_BASE + 21);
    static final int DRV_LOAD = 0x0001;
    static final int DRV_ENABLE = 0x0002;
    static final int DRV_OPEN = 0x0003;
    static final int DRV_CLOSE = 0x0004;
    static final int DRV_DISABLE = 0x0005;
    static final int DRV_FREE = 0x0006;
    static final int DRV_CONFIGURE = 0x0007;
    static final int DRV_QUERYCONFIGURE = 0x0008;
    static final int DRV_INSTALL = 0x0009;
    static final int DRV_REMOVE = 0x000A;
    static final int DRV_EXITSESSION = 0x000B;
    static final int DRV_POWER = 0x000F;
    static final int DRV_RESERVED = 0x0800;
    static final int DRV_USER = 0x4000;
    static final int DRVCNF_CANCEL = 0x0000;
    static final int DRVCNF_OK = 0x0001;
    static final int DRVCNF_RESTART = 0x0002;
    static final int DRV_CANCEL = DRVCNF_CANCEL;
    static final int DRV_OK = DRVCNF_OK;
    static final int DRV_RESTART = DRVCNF_RESTART;
    static final int DRV_MCI_FIRST = DRV_RESERVED;
    static final int DRV_MCI_LAST = (DRV_RESERVED + 0xFFF);
    static final int SND_SYNC = 0x0000;
    static final int SND_ASYNC = 0x0001;
    static final int SND_NODEFAULT = 0x0002;
    static final int SND_MEMORY = 0x0004;
    static final int SND_LOOP = 0x0008;
    static final int SND_NOSTOP = 0x0010;
    static final int SND_NOWAIT = 0x00002000;
    static final int SND_ALIAS = 0x00010000;
    static final int SND_ALIAS_ID = 0x00110000;
    static final int SND_FILENAME = 0x00020000;
    static final int SND_RESOURCE = 0x00040004;
    static final int SND_PURGE = 0x0040;
    static final int SND_APPLICATION = 0x0080;
    static final int SND_ALIAS_START = 0;
    static final int WAVERR_BADFORMAT = (WAVERR_BASE + 0);
    static final int WAVERR_STILLPLAYING = (WAVERR_BASE + 1);
    static final int WAVERR_UNPREPARED = (WAVERR_BASE + 2);
    static final int WAVERR_SYNC = (WAVERR_BASE + 3);
    static final int WAVERR_LASTERROR = (WAVERR_BASE + 3);
    static final int WOM_OPEN = MM_WOM_OPEN;
    static final int WOM_CLOSE = MM_WOM_CLOSE;
    static final int WOM_DONE = MM_WOM_DONE;
    static final int WIM_OPEN = MM_WIM_OPEN;
    static final int WIM_CLOSE = MM_WIM_CLOSE;
    static final int WIM_DATA = MM_WIM_DATA;
    static final int WAVE_FORMAT_QUERY = 0x0001;
    static final int WAVE_ALLOWSYNC = 0x0002;
    static final int WAVE_MAPPED = 0x0004;
    static final int WAVE_FORMAT_DIRECT = 0x0008;
    static final int WAVE_FORMAT_DIRECT_QUERY = (WAVE_FORMAT_QUERY | WAVE_FORMAT_DIRECT);
    static final int WHDR_DONE = 0x00000001;
    static final int WHDR_PREPARED = 0x00000002;
    static final int WHDR_BEGINLOOP = 0x00000004;
    static final int WHDR_ENDLOOP = 0x00000008;
    static final int WHDR_INQUEUE = 0x00000010;
    static final int WAVECAPS_PITCH = 0x0001;
    static final int WAVECAPS_PLAYBACKRATE = 0x0002;
    static final int WAVECAPS_VOLUME = 0x0004;
    static final int WAVECAPS_LRVOLUME = 0x0008;
    static final int WAVECAPS_SYNC = 0x0010;
    static final int WAVECAPS_SAMPLEACCURATE = 0x0020;
    static final int WAVE_INVALIDFORMAT = 0x00000000;
    static final int WAVE_FORMAT_1M08 = 0x00000001;
    static final int WAVE_FORMAT_1S08 = 0x00000002;
    static final int WAVE_FORMAT_1M16 = 0x00000004;
    static final int WAVE_FORMAT_1S16 = 0x00000008;
    static final int WAVE_FORMAT_2M08 = 0x00000010;
    static final int WAVE_FORMAT_2S08 = 0x00000020;
    static final int WAVE_FORMAT_2M16 = 0x00000040;
    static final int WAVE_FORMAT_2S16 = 0x00000080;
    static final int WAVE_FORMAT_4M08 = 0x00000100;
    static final int WAVE_FORMAT_4S08 = 0x00000200;
    static final int WAVE_FORMAT_4M16 = 0x00000400;
    static final int WAVE_FORMAT_4S16 = 0x00000800;
    static final int WAVE_FORMAT_44M08 = 0x00000100;
    static final int WAVE_FORMAT_44S08 = 0x00000200;
    static final int WAVE_FORMAT_44M16 = 0x00000400;
    static final int WAVE_FORMAT_44S16 = 0x00000800;
    static final int WAVE_FORMAT_48M08 = 0x00001000;
    static final int WAVE_FORMAT_48S08 = 0x00002000;
    static final int WAVE_FORMAT_48M16 = 0x00004000;
    static final int WAVE_FORMAT_48S16 = 0x00008000;
    static final int WAVE_FORMAT_96M08 = 0x00010000;
    static final int WAVE_FORMAT_96S08 = 0x00020000;
    static final int WAVE_FORMAT_96M16 = 0x00040000;
    static final int WAVE_FORMAT_96S16 = 0x00080000;
    static final int WAVE_FORMAT_PCM = 1;
    static final int MIDIERR_UNPREPARED = (MIDIERR_BASE + 0);
    static final int MIDIERR_STILLPLAYING = (MIDIERR_BASE + 1);
    static final int MIDIERR_NOMAP = (MIDIERR_BASE + 2);
    static final int MIDIERR_NOTREADY = (MIDIERR_BASE + 3);
    static final int MIDIERR_NODEVICE = (MIDIERR_BASE + 4);
    static final int MIDIERR_INVALIDSETUP = (MIDIERR_BASE + 5);
    static final int MIDIERR_BADOPENMODE = (MIDIERR_BASE + 6);
    static final int MIDIERR_DONT_CONTINUE = (MIDIERR_BASE + 7);
    static final int MIDIERR_LASTERROR = (MIDIERR_BASE + 7);
    static final int MIDIPATCHSIZE = 128;
    static final int MIM_OPEN = MM_MIM_OPEN;
    static final int MIM_CLOSE = MM_MIM_CLOSE;
    static final int MIM_DATA = MM_MIM_DATA;
    static final int MIM_LONGDATA = MM_MIM_LONGDATA;
    static final int MIM_ERROR = MM_MIM_ERROR;
    static final int MIM_LONGERROR = MM_MIM_LONGERROR;
    static final int MOM_OPEN = MM_MOM_OPEN;
    static final int MOM_CLOSE = MM_MOM_CLOSE;
    static final int MOM_DONE = MM_MOM_DONE;
    static final int MIM_MOREDATA = MM_MIM_MOREDATA;
    static final int MOM_POSITIONCB = MM_MOM_POSITIONCB;
    static final int MIDI_IO_STATUS = 0x00000020;
    static final int MIDI_CACHE_ALL = 1;
    static final int MIDI_CACHE_BESTFIT = 2;
    static final int MIDI_CACHE_QUERY = 3;
    static final int MIDI_UNCACHE = 4;
    static final int MOD_MIDIPORT = 1;
    static final int MOD_SYNTH = 2;
    static final int MOD_SQSYNTH = 3;
    static final int MOD_FMSYNTH = 4;
    static final int MOD_MAPPER = 5;
    static final int MOD_WAVETABLE = 6;
    static final int MOD_SWSYNTH = 7;
    static final int MIDICAPS_VOLUME = 0x0001;
    static final int MIDICAPS_LRVOLUME = 0x0002;
    static final int MIDICAPS_CACHE = 0x0004;
    static final int MIDICAPS_STREAM = 0x0008;
    static final int MHDR_DONE = 0x00000001;
    static final int MHDR_PREPARED = 0x00000002;
    static final int MHDR_INQUEUE = 0x00000004;
    static final int MHDR_ISSTRM = 0x00000008;
    static final int MEVT_F_SHORT = 0x00000000;
    static final int MEVT_F_LONG = 0x80000000;
    static final int MEVT_F_CALLBACK = 0x40000000;
    static final byte MEVT_SHORTMSG = ((byte)0x00);
    static final byte MEVT_TEMPO = ((byte)0x01);
    static final byte MEVT_NOP = ((byte)0x02);
    static final byte MEVT_LONGMSG = ((byte)0x80);
    static final byte MEVT_COMMENT = ((byte)0x82);
    static final byte MEVT_VERSION = ((byte)0x84);
    static final int MIDISTRM_ERROR = (-2);
    static final int MIDIPROP_SET = 0x80000000;
    static final int MIDIPROP_GET = 0x40000000;
    static final int MIDIPROP_TIMEDIV = 0x00000001;
    static final int MIDIPROP_TEMPO = 0x00000002;
    static final int AUXCAPS_CDAUDIO = 1;
    static final int AUXCAPS_AUXIN = 2;
    static final int AUXCAPS_VOLUME = 0x0001;
    static final int AUXCAPS_LRVOLUME = 0x0002;
    static final int MIXER_SHORT_NAME_CHARS = 16;
    static final int MIXER_LONG_NAME_CHARS = 64;
    static final int MIXERR_INVALLINE = (MIXERR_BASE + 0);
    static final int MIXERR_INVALCONTROL = (MIXERR_BASE + 1);
    static final int MIXERR_INVALVALUE = (MIXERR_BASE + 2);
    static final int MIXERR_LASTERROR = (MIXERR_BASE + 2);
    static final int MIXER_OBJECTF_HANDLE = 0x80000000;
    static final int MIXER_OBJECTF_MIXER = 0x00000000;
    static final int MIXER_OBJECTF_HMIXER = (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIXER);
    static final int MIXER_OBJECTF_WAVEOUT = 0x10000000;
    static final int MIXER_OBJECTF_HWAVEOUT = (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_WAVEOUT);
    static final int MIXER_OBJECTF_WAVEIN = 0x20000000;
    static final int MIXER_OBJECTF_HWAVEIN = (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_WAVEIN);
    static final int MIXER_OBJECTF_MIDIOUT = 0x30000000;
    static final int MIXER_OBJECTF_HMIDIOUT = (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIDIOUT);
    static final int MIXER_OBJECTF_MIDIIN = 0x40000000;
    static final int MIXER_OBJECTF_HMIDIIN = (MIXER_OBJECTF_HANDLE|MIXER_OBJECTF_MIDIIN);
    static final int MIXER_OBJECTF_AUX = 0x50000000;
    static final int MIXERLINE_LINEF_ACTIVE = 0x00000001;
    static final int MIXERLINE_LINEF_DISCONNECTED = 0x00008000;
    static final int MIXERLINE_LINEF_SOURCE = 0x80000000;
    static final int MIXERLINE_COMPONENTTYPE_DST_FIRST = 0x00000000;
    static final int MIXERLINE_COMPONENTTYPE_DST_UNDEFINED = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 0);
    static final int MIXERLINE_COMPONENTTYPE_DST_DIGITAL = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 1);
    static final int MIXERLINE_COMPONENTTYPE_DST_LINE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 2);
    static final int MIXERLINE_COMPONENTTYPE_DST_MONITOR = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 3);
    static final int MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 4);
    static final int MIXERLINE_COMPONENTTYPE_DST_HEADPHONES = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 5);
    static final int MIXERLINE_COMPONENTTYPE_DST_TELEPHONE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 6);
    static final int MIXERLINE_COMPONENTTYPE_DST_WAVEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 7);
    static final int MIXERLINE_COMPONENTTYPE_DST_VOICEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8);
    static final int MIXERLINE_COMPONENTTYPE_DST_LAST = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8);
    static final int MIXERLINE_COMPONENTTYPE_SRC_FIRST = 0x00001000;
    static final int MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0);
    static final int MIXERLINE_COMPONENTTYPE_SRC_DIGITAL = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1);
    static final int MIXERLINE_COMPONENTTYPE_SRC_LINE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2);
    static final int MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3);
    static final int MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4);
    static final int MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5);
    static final int MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6);
    static final int MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7);
    static final int MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8);
    static final int MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9);
    static final int MIXERLINE_COMPONENTTYPE_SRC_ANALOG = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10);
    static final int MIXERLINE_COMPONENTTYPE_SRC_LAST = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10);
    static final int MIXERLINE_TARGETTYPE_UNDEFINED = 0;
    static final int MIXERLINE_TARGETTYPE_WAVEOUT = 1;
    static final int MIXERLINE_TARGETTYPE_WAVEIN = 2;
    static final int MIXERLINE_TARGETTYPE_MIDIOUT = 3;
    static final int MIXERLINE_TARGETTYPE_MIDIIN = 4;
    static final int MIXERLINE_TARGETTYPE_AUX = 5;
    static final int MIXER_GETLINEINFOF_DESTINATION = 0x00000000;
    static final int MIXER_GETLINEINFOF_SOURCE = 0x00000001;
    static final int MIXER_GETLINEINFOF_LINEID = 0x00000002;
    static final int MIXER_GETLINEINFOF_COMPONENTTYPE = 0x00000003;
    static final int MIXER_GETLINEINFOF_TARGETTYPE = 0x00000004;
    static final int MIXER_GETLINEINFOF_QUERYMASK = 0x0000000F;
    static final int MIXERCONTROL_CONTROLF_UNIFORM = 0x00000001;
    static final int MIXERCONTROL_CONTROLF_MULTIPLE = 0x00000002;
    static final int MIXERCONTROL_CONTROLF_DISABLED = 0x80000000;
    static final int MIXERCONTROL_CT_CLASS_MASK = 0xF0000000;
    static final int MIXERCONTROL_CT_CLASS_CUSTOM = 0x00000000;
    static final int MIXERCONTROL_CT_CLASS_METER = 0x10000000;
    static final int MIXERCONTROL_CT_CLASS_SWITCH = 0x20000000;
    static final int MIXERCONTROL_CT_CLASS_NUMBER = 0x30000000;
    static final int MIXERCONTROL_CT_CLASS_SLIDER = 0x40000000;
    static final int MIXERCONTROL_CT_CLASS_FADER = 0x50000000;
    static final int MIXERCONTROL_CT_CLASS_TIME = 0x60000000;
    static final int MIXERCONTROL_CT_CLASS_LIST = 0x70000000;
    static final int MIXERCONTROL_CT_SUBCLASS_MASK = 0x0F000000;
    static final int MIXERCONTROL_CT_SC_SWITCH_BOOLEAN = 0x00000000;
    static final int MIXERCONTROL_CT_SC_SWITCH_BUTTON = 0x01000000;
    static final int MIXERCONTROL_CT_SC_METER_POLLED = 0x00000000;
    static final int MIXERCONTROL_CT_SC_TIME_MICROSECS = 0x00000000;
    static final int MIXERCONTROL_CT_SC_TIME_MILLISECS = 0x01000000;
    static final int MIXERCONTROL_CT_SC_LIST_SINGLE = 0x00000000;
    static final int MIXERCONTROL_CT_SC_LIST_MULTIPLE = 0x01000000;
    static final int MIXERCONTROL_CT_UNITS_MASK = 0x00FF0000;
    static final int MIXERCONTROL_CT_UNITS_CUSTOM = 0x00000000;
    static final int MIXERCONTROL_CT_UNITS_BOOLEAN = 0x00010000;
    static final int MIXERCONTROL_CT_UNITS_SIGNED = 0x00020000;
    static final int MIXERCONTROL_CT_UNITS_UNSIGNED = 0x00030000;
    static final int MIXERCONTROL_CT_UNITS_DECIBELS = 0x00040000;
    static final int MIXERCONTROL_CT_UNITS_PERCENT = 0x00050000;
    static final int MIXERCONTROL_CONTROLTYPE_CUSTOM = (MIXERCONTROL_CT_CLASS_CUSTOM | MIXERCONTROL_CT_UNITS_CUSTOM);
    static final int MIXERCONTROL_CONTROLTYPE_BOOLEANMETER = (MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_BOOLEAN);
    static final int MIXERCONTROL_CONTROLTYPE_SIGNEDMETER = (MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_SIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_PEAKMETER = (MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1);
    static final int MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER = (MIXERCONTROL_CT_CLASS_METER | MIXERCONTROL_CT_SC_METER_POLLED | MIXERCONTROL_CT_UNITS_UNSIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_BOOLEAN = (MIXERCONTROL_CT_CLASS_SWITCH | MIXERCONTROL_CT_SC_SWITCH_BOOLEAN | MIXERCONTROL_CT_UNITS_BOOLEAN);
    static final int MIXERCONTROL_CONTROLTYPE_ONOFF = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 1);
    static final int MIXERCONTROL_CONTROLTYPE_MUTE = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2);
    static final int MIXERCONTROL_CONTROLTYPE_MONO = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3);
    static final int MIXERCONTROL_CONTROLTYPE_LOUDNESS = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4);
    static final int MIXERCONTROL_CONTROLTYPE_STEREOENH = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5);
    static final int MIXERCONTROL_CONTROLTYPE_BASS_BOOST = (MIXERCONTROL_CONTROLTYPE_BOOLEAN + 0x00002277);
    static final int MIXERCONTROL_CONTROLTYPE_BUTTON = (MIXERCONTROL_CT_CLASS_SWITCH | MIXERCONTROL_CT_SC_SWITCH_BUTTON | MIXERCONTROL_CT_UNITS_BOOLEAN);
    static final int MIXERCONTROL_CONTROLTYPE_DECIBELS = (MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_DECIBELS);
    static final int MIXERCONTROL_CONTROLTYPE_SIGNED = (MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_SIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_UNSIGNED = (MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_UNSIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_PERCENT = (MIXERCONTROL_CT_CLASS_NUMBER | MIXERCONTROL_CT_UNITS_PERCENT);
    static final int MIXERCONTROL_CONTROLTYPE_SLIDER = (MIXERCONTROL_CT_CLASS_SLIDER | MIXERCONTROL_CT_UNITS_SIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_PAN = (MIXERCONTROL_CONTROLTYPE_SLIDER + 1);
    static final int MIXERCONTROL_CONTROLTYPE_QSOUNDPAN = (MIXERCONTROL_CONTROLTYPE_SLIDER + 2);
    static final int MIXERCONTROL_CONTROLTYPE_FADER = (MIXERCONTROL_CT_CLASS_FADER | MIXERCONTROL_CT_UNITS_UNSIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_VOLUME = (MIXERCONTROL_CONTROLTYPE_FADER + 1);
    static final int MIXERCONTROL_CONTROLTYPE_BASS = (MIXERCONTROL_CONTROLTYPE_FADER + 2);
    static final int MIXERCONTROL_CONTROLTYPE_TREBLE = (MIXERCONTROL_CONTROLTYPE_FADER + 3);
    static final int MIXERCONTROL_CONTROLTYPE_EQUALIZER = (MIXERCONTROL_CONTROLTYPE_FADER + 4);
    static final int MIXERCONTROL_CONTROLTYPE_SINGLESELECT = (MIXERCONTROL_CT_CLASS_LIST | MIXERCONTROL_CT_SC_LIST_SINGLE | MIXERCONTROL_CT_UNITS_BOOLEAN);
    static final int MIXERCONTROL_CONTROLTYPE_MUX = (MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1);
    static final int MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT = (MIXERCONTROL_CT_CLASS_LIST | MIXERCONTROL_CT_SC_LIST_MULTIPLE | MIXERCONTROL_CT_UNITS_BOOLEAN);
    static final int MIXERCONTROL_CONTROLTYPE_MIXER = (MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1);
    static final int MIXERCONTROL_CONTROLTYPE_MICROTIME = (MIXERCONTROL_CT_CLASS_TIME | MIXERCONTROL_CT_SC_TIME_MICROSECS | MIXERCONTROL_CT_UNITS_UNSIGNED);
    static final int MIXERCONTROL_CONTROLTYPE_MILLITIME = (MIXERCONTROL_CT_CLASS_TIME | MIXERCONTROL_CT_SC_TIME_MILLISECS | MIXERCONTROL_CT_UNITS_UNSIGNED);
    static final int MIXER_GETLINECONTROLSF_ALL = 0x00000000;
    static final int MIXER_GETLINECONTROLSF_ONEBYID = 0x00000001;
    static final int MIXER_GETLINECONTROLSF_ONEBYTYPE = 0x00000002;
    static final int MIXER_GETLINECONTROLSF_QUERYMASK = 0x0000000F;
    static final int MIXER_GETCONTROLDETAILSF_VALUE = 0x00000000;
    static final int MIXER_GETCONTROLDETAILSF_LISTTEXT = 0x00000001;
    static final int MIXER_GETCONTROLDETAILSF_QUERYMASK = 0x0000000F;
    static final int MIXER_SETCONTROLDETAILSF_VALUE = 0x00000000;
    static final int MIXER_SETCONTROLDETAILSF_CUSTOM = 0x00000001;
    static final int MIXER_SETCONTROLDETAILSF_QUERYMASK = 0x0000000F;
    static final int TIMERR_NOERROR = (0);
    static final int TIMERR_NOCANDO = (TIMERR_BASE+1);
    static final int TIMERR_STRUCT = (TIMERR_BASE+33);
    static final int TIME_ONESHOT = 0x0000;
    static final int TIME_PERIODIC = 0x0001;
    static final int TIME_CALLBACK_FUNCTION = 0x0000;
    static final int TIME_CALLBACK_EVENT_SET = 0x0010;
    static final int TIME_CALLBACK_EVENT_PULSE = 0x0020;
    static final int TIME_KILL_SYNCHRONOUS = 0x0100;
    static final int JOYERR_NOERROR = (0);
    static final int JOYERR_PARMS = (JOYERR_BASE+5);
    static final int JOYERR_NOCANDO = (JOYERR_BASE+6);
    static final int JOYERR_UNPLUGGED = (JOYERR_BASE+7);
    static final int JOY_BUTTON1 = 0x0001;
    static final int JOY_BUTTON2 = 0x0002;
    static final int JOY_BUTTON3 = 0x0004;
    static final int JOY_BUTTON4 = 0x0008;
    static final int JOY_BUTTON1CHG = 0x0100;
    static final int JOY_BUTTON2CHG = 0x0200;
    static final int JOY_BUTTON3CHG = 0x0400;
    static final int JOY_BUTTON4CHG = 0x0800;
    static final int JOY_POVFORWARD = 0;
    static final int JOY_POVRIGHT = 9000;
    static final int JOY_POVBACKWARD = 18000;
    static final int JOY_POVLEFT = 27000;
    static final int JOYSTICKID1 = 0;
    static final int JOYSTICKID2 = 1;
    static final int JOYCAPS_HASZ = 0x0001;
    static final int JOYCAPS_HASR = 0x0002;
    static final int JOYCAPS_HASU = 0x0004;
    static final int JOYCAPS_HASV = 0x0008;
    static final int JOYCAPS_HASPOV = 0x0010;
    static final int JOYCAPS_POV4DIR = 0x0020;
    static final int JOYCAPS_POVCTS = 0x0040;
    static final int MMIOERR_BASE = 256;
    static final int MMIOERR_FILENOTFOUND = (MMIOERR_BASE + 1);
    static final int MMIOERR_OUTOFMEMORY = (MMIOERR_BASE + 2);
    static final int MMIOERR_CANNOTOPEN = (MMIOERR_BASE + 3);
    static final int MMIOERR_CANNOTCLOSE = (MMIOERR_BASE + 4);
    static final int MMIOERR_CANNOTREAD = (MMIOERR_BASE + 5);
    static final int MMIOERR_CANNOTWRITE = (MMIOERR_BASE + 6);
    static final int MMIOERR_CANNOTSEEK = (MMIOERR_BASE + 7);
    static final int MMIOERR_CANNOTEXPAND = (MMIOERR_BASE + 8);
    static final int MMIOERR_CHUNKNOTFOUND = (MMIOERR_BASE + 9);
    static final int MMIOERR_UNBUFFERED = (MMIOERR_BASE + 10);
    static final int MMIOERR_PATHNOTFOUND = (MMIOERR_BASE + 11);
    static final int MMIOERR_ACCESSDENIED = (MMIOERR_BASE + 12);
    static final int MMIOERR_SHARINGVIOLATION = (MMIOERR_BASE + 13);
    static final int MMIOERR_NETWORKERROR = (MMIOERR_BASE + 14);
    static final int MMIOERR_TOOMANYOPENFILES = (MMIOERR_BASE + 15);
    static final int MMIOERR_INVALIDFILE = (MMIOERR_BASE + 16);
    static final int MMIO_RWMODE = 0x00000003;
    static final int MMIO_SHAREMODE = 0x00000070;
    static final int MMIO_CREATE = 0x00001000;
    static final int MMIO_PARSE = 0x00000100;
    static final int MMIO_DELETE = 0x00000200;
    static final int MMIO_EXIST = 0x00004000;
    static final int MMIO_ALLOCBUF = 0x00010000;
    static final int MMIO_GETTEMP = 0x00020000;
    static final int MMIO_DIRTY = 0x10000000;
    static final int MMIO_READ = 0x00000000;
    static final int MMIO_WRITE = 0x00000001;
    static final int MMIO_READWRITE = 0x00000002;
    static final int MMIO_COMPAT = 0x00000000;
    static final int MMIO_EXCLUSIVE = 0x00000010;
    static final int MMIO_DENYWRITE = 0x00000020;
    static final int MMIO_DENYREAD = 0x00000030;
    static final int MMIO_DENYNONE = 0x00000040;
    static final int MMIO_FHOPEN = 0x0010;
    static final int MMIO_EMPTYBUF = 0x0010;
    static final int MMIO_TOUPPER = 0x0010;
    static final int MMIO_INSTALLPROC = 0x00010000;
    static final int MMIO_GLOBALPROC = 0x10000000;
    static final int MMIO_REMOVEPROC = 0x00020000;
    static final int MMIO_UNICODEPROC = 0x01000000;
    static final int MMIO_FINDPROC = 0x00040000;
    static final int MMIO_FINDCHUNK = 0x0010;
    static final int MMIO_FINDRIFF = 0x0020;
    static final int MMIO_FINDLIST = 0x0040;
    static final int MMIO_CREATERIFF = 0x0020;
    static final int MMIO_CREATELIST = 0x0040;
    static final int MMIOM_READ = MMIO_READ;
    static final int MMIOM_WRITE = MMIO_WRITE;
    static final int MMIOM_SEEK = 2;
    static final int MMIOM_OPEN = 3;
    static final int MMIOM_CLOSE = 4;
    static final int MMIOM_WRITEFLUSH = 5;
    static final int MMIOM_RENAME = 6;
    static final int MMIOM_USER = 0x8000;
    static final int SEEK_SET = 0;
    static final int SEEK_CUR = 1;
    static final int SEEK_END = 2;
    static final int MMIO_DEFAULTBUFFER = 8192;
    static final int MCIERR_INVALID_DEVICE_ID = (MCIERR_BASE + 1);
    static final int MCIERR_UNRECOGNIZED_KEYWORD = (MCIERR_BASE + 3);
    static final int MCIERR_UNRECOGNIZED_COMMAND = (MCIERR_BASE + 5);
    static final int MCIERR_HARDWARE = (MCIERR_BASE + 6);
    static final int MCIERR_INVALID_DEVICE_NAME = (MCIERR_BASE + 7);
    static final int MCIERR_OUT_OF_MEMORY = (MCIERR_BASE + 8);
    static final int MCIERR_DEVICE_OPEN = (MCIERR_BASE + 9);
    static final int MCIERR_CANNOT_LOAD_DRIVER = (MCIERR_BASE + 10);
    static final int MCIERR_MISSING_COMMAND_STRING = (MCIERR_BASE + 11);
    static final int MCIERR_PARAM_OVERFLOW = (MCIERR_BASE + 12);
    static final int MCIERR_MISSING_STRING_ARGUMENT = (MCIERR_BASE + 13);
    static final int MCIERR_BAD_INTEGER = (MCIERR_BASE + 14);
    static final int MCIERR_PARSER_INTERNAL = (MCIERR_BASE + 15);
    static final int MCIERR_DRIVER_INTERNAL = (MCIERR_BASE + 16);
    static final int MCIERR_MISSING_PARAMETER = (MCIERR_BASE + 17);
    static final int MCIERR_UNSUPPORTED_FUNCTION = (MCIERR_BASE + 18);
    static final int MCIERR_FILE_NOT_FOUND = (MCIERR_BASE + 19);
    static final int MCIERR_DEVICE_NOT_READY = (MCIERR_BASE + 20);
    static final int MCIERR_INTERNAL = (MCIERR_BASE + 21);
    static final int MCIERR_DRIVER = (MCIERR_BASE + 22);
    static final int MCIERR_CANNOT_USE_ALL = (MCIERR_BASE + 23);
    static final int MCIERR_MULTIPLE = (MCIERR_BASE + 24);
    static final int MCIERR_EXTENSION_NOT_FOUND = (MCIERR_BASE + 25);
    static final int MCIERR_OUTOFRANGE = (MCIERR_BASE + 26);
    static final int MCIERR_FLAGS_NOT_COMPATIBLE = (MCIERR_BASE + 28);
    static final int MCIERR_FILE_NOT_SAVED = (MCIERR_BASE + 30);
    static final int MCIERR_DEVICE_TYPE_REQUIRED = (MCIERR_BASE + 31);
    static final int MCIERR_DEVICE_LOCKED = (MCIERR_BASE + 32);
    static final int MCIERR_DUPLICATE_ALIAS = (MCIERR_BASE + 33);
    static final int MCIERR_BAD_CONSTANT = (MCIERR_BASE + 34);
    static final int MCIERR_MUST_USE_SHAREABLE = (MCIERR_BASE + 35);
    static final int MCIERR_MISSING_DEVICE_NAME = (MCIERR_BASE + 36);
    static final int MCIERR_BAD_TIME_FORMAT = (MCIERR_BASE + 37);
    static final int MCIERR_NO_CLOSING_QUOTE = (MCIERR_BASE + 38);
    static final int MCIERR_DUPLICATE_FLAGS = (MCIERR_BASE + 39);
    static final int MCIERR_INVALID_FILE = (MCIERR_BASE + 40);
    static final int MCIERR_NULL_PARAMETER_BLOCK = (MCIERR_BASE + 41);
    static final int MCIERR_UNNAMED_RESOURCE = (MCIERR_BASE + 42);
    static final int MCIERR_NEW_REQUIRES_ALIAS = (MCIERR_BASE + 43);
    static final int MCIERR_NOTIFY_ON_AUTO_OPEN = (MCIERR_BASE + 44);
    static final int MCIERR_NO_ELEMENT_ALLOWED = (MCIERR_BASE + 45);
    static final int MCIERR_NONAPPLICABLE_FUNCTION = (MCIERR_BASE + 46);
    static final int MCIERR_ILLEGAL_FOR_AUTO_OPEN = (MCIERR_BASE + 47);
    static final int MCIERR_FILENAME_REQUIRED = (MCIERR_BASE + 48);
    static final int MCIERR_EXTRA_CHARACTERS = (MCIERR_BASE + 49);
    static final int MCIERR_DEVICE_NOT_INSTALLED = (MCIERR_BASE + 50);
    static final int MCIERR_GET_CD = (MCIERR_BASE + 51);
    static final int MCIERR_SET_CD = (MCIERR_BASE + 52);
    static final int MCIERR_SET_DRIVE = (MCIERR_BASE + 53);
    static final int MCIERR_DEVICE_LENGTH = (MCIERR_BASE + 54);
    static final int MCIERR_DEVICE_ORD_LENGTH = (MCIERR_BASE + 55);
    static final int MCIERR_NO_INTEGER = (MCIERR_BASE + 56);
    static final int MCIERR_WAVE_OUTPUTSINUSE = (MCIERR_BASE + 64);
    static final int MCIERR_WAVE_SETOUTPUTINUSE = (MCIERR_BASE + 65);
    static final int MCIERR_WAVE_INPUTSINUSE = (MCIERR_BASE + 66);
    static final int MCIERR_WAVE_SETINPUTINUSE = (MCIERR_BASE + 67);
    static final int MCIERR_WAVE_OUTPUTUNSPECIFIED = (MCIERR_BASE + 68);
    static final int MCIERR_WAVE_INPUTUNSPECIFIED = (MCIERR_BASE + 69);
    static final int MCIERR_WAVE_OUTPUTSUNSUITABLE = (MCIERR_BASE + 70);
    static final int MCIERR_WAVE_SETOUTPUTUNSUITABLE = (MCIERR_BASE + 71);
    static final int MCIERR_WAVE_INPUTSUNSUITABLE = (MCIERR_BASE + 72);
    static final int MCIERR_WAVE_SETINPUTUNSUITABLE = (MCIERR_BASE + 73);
    static final int MCIERR_SEQ_DIV_INCOMPATIBLE = (MCIERR_BASE + 80);
    static final int MCIERR_SEQ_PORT_INUSE = (MCIERR_BASE + 81);
    static final int MCIERR_SEQ_PORT_NONEXISTENT = (MCIERR_BASE + 82);
    static final int MCIERR_SEQ_PORT_MAPNODEVICE = (MCIERR_BASE + 83);
    static final int MCIERR_SEQ_PORT_MISCERROR = (MCIERR_BASE + 84);
    static final int MCIERR_SEQ_TIMER = (MCIERR_BASE + 85);
    static final int MCIERR_SEQ_PORTUNSPECIFIED = (MCIERR_BASE + 86);
    static final int MCIERR_SEQ_NOMIDIPRESENT = (MCIERR_BASE + 87);
    static final int MCIERR_NO_WINDOW = (MCIERR_BASE + 90);
    static final int MCIERR_CREATEWINDOW = (MCIERR_BASE + 91);
    static final int MCIERR_FILE_READ = (MCIERR_BASE + 92);
    static final int MCIERR_FILE_WRITE = (MCIERR_BASE + 93);
    static final int MCIERR_NO_IDENTITY = (MCIERR_BASE + 94);
    static final int MCIERR_CUSTOM_DRIVER_BASE = (MCIERR_BASE + 256);
    static final int MCI_FIRST = DRV_MCI_FIRST;
    static final int MCI_OPEN = 0x0803;
    static final int MCI_CLOSE = 0x0804;
    static final int MCI_ESCAPE = 0x0805;
    static final int MCI_PLAY = 0x0806;
    static final int MCI_SEEK = 0x0807;
    static final int MCI_STOP = 0x0808;
    static final int MCI_PAUSE = 0x0809;
    static final int MCI_INFO = 0x080A;
    static final int MCI_GETDEVCAPS = 0x080B;
    static final int MCI_SPIN = 0x080C;
    static final int MCI_SET = 0x080D;
    static final int MCI_STEP = 0x080E;
    static final int MCI_RECORD = 0x080F;
    static final int MCI_SYSINFO = 0x0810;
    static final int MCI_BREAK = 0x0811;
    static final int MCI_SAVE = 0x0813;
    static final int MCI_STATUS = 0x0814;
    static final int MCI_CUE = 0x0830;
    static final int MCI_REALIZE = 0x0840;
    static final int MCI_WINDOW = 0x0841;
    static final int MCI_PUT = 0x0842;
    static final int MCI_WHERE = 0x0843;
    static final int MCI_FREEZE = 0x0844;
    static final int MCI_UNFREEZE = 0x0845;
    static final int MCI_LOAD = 0x0850;
    static final int MCI_CUT = 0x0851;
    static final int MCI_COPY = 0x0852;
    static final int MCI_PASTE = 0x0853;
    static final int MCI_UPDATE = 0x0854;
    static final int MCI_RESUME = 0x0855;
    static final int MCI_DELETE = 0x0856;
    static final int MCI_USER_MESSAGES = (DRV_MCI_FIRST + 0x400);
    static final int MCI_LAST = 0x0FFF;
    static final int MCI_DEVTYPE_VCR = 513;
    static final int MCI_DEVTYPE_VIDEODISC = 514;
    static final int MCI_DEVTYPE_OVERLAY = 515;
    static final int MCI_DEVTYPE_CD_AUDIO = 516;
    static final int MCI_DEVTYPE_DAT = 517;
    static final int MCI_DEVTYPE_SCANNER = 518;
    static final int MCI_DEVTYPE_ANIMATION = 519;
    static final int MCI_DEVTYPE_DIGITAL_VIDEO = 520;
    static final int MCI_DEVTYPE_OTHER = 521;
    static final int MCI_DEVTYPE_WAVEFORM_AUDIO = 522;
    static final int MCI_DEVTYPE_SEQUENCER = 523;
    static final int MCI_DEVTYPE_FIRST = MCI_DEVTYPE_VCR;
    static final int MCI_DEVTYPE_LAST = MCI_DEVTYPE_SEQUENCER;
    static final int MCI_DEVTYPE_FIRST_USER = 0x1000;
    static final int MCI_MODE_NOT_READY = (MCI_STRING_OFFSET + 12);
    static final int MCI_MODE_STOP = (MCI_STRING_OFFSET + 13);
    static final int MCI_MODE_PLAY = (MCI_STRING_OFFSET + 14);
    static final int MCI_MODE_RECORD = (MCI_STRING_OFFSET + 15);
    static final int MCI_MODE_SEEK = (MCI_STRING_OFFSET + 16);
    static final int MCI_MODE_PAUSE = (MCI_STRING_OFFSET + 17);
    static final int MCI_MODE_OPEN = (MCI_STRING_OFFSET + 18);
    static final int MCI_FORMAT_MILLISECONDS = 0;
    static final int MCI_FORMAT_HMS = 1;
    static final int MCI_FORMAT_MSF = 2;
    static final int MCI_FORMAT_FRAMES = 3;
    static final int MCI_FORMAT_SMPTE_24 = 4;
    static final int MCI_FORMAT_SMPTE_25 = 5;
    static final int MCI_FORMAT_SMPTE_30 = 6;
    static final int MCI_FORMAT_SMPTE_30DROP = 7;
    static final int MCI_FORMAT_BYTES = 8;
    static final int MCI_FORMAT_SAMPLES = 9;
    static final int MCI_FORMAT_TMSF = 10;
    static final int MCI_NOTIFY_SUCCESSFUL = 0x0001;
    static final int MCI_NOTIFY_SUPERSEDED = 0x0002;
    static final int MCI_NOTIFY_ABORTED = 0x0004;
    static final int MCI_NOTIFY_FAILURE = 0x0008;
    static final int MCI_NOTIFY = 0x00000001;
    static final int MCI_WAIT = 0x00000002;
    static final int MCI_FROM = 0x00000004;
    static final int MCI_TO = 0x00000008;
    static final int MCI_TRACK = 0x00000010;
    static final int MCI_OPEN_SHAREABLE = 0x00000100;
    static final int MCI_OPEN_ELEMENT = 0x00000200;
    static final int MCI_OPEN_ALIAS = 0x00000400;
    static final int MCI_OPEN_ELEMENT_ID = 0x00000800;
    static final int MCI_OPEN_TYPE_ID = 0x00001000;
    static final int MCI_OPEN_TYPE = 0x00002000;
    static final int MCI_SEEK_TO_START = 0x00000100;
    static final int MCI_SEEK_TO_END = 0x00000200;
    static final int MCI_STATUS_ITEM = 0x00000100;
    static final int MCI_STATUS_START = 0x00000200;
    static final int MCI_STATUS_LENGTH = 0x00000001;
    static final int MCI_STATUS_POSITION = 0x00000002;
    static final int MCI_STATUS_NUMBER_OF_TRACKS = 0x00000003;
    static final int MCI_STATUS_MODE = 0x00000004;
    static final int MCI_STATUS_MEDIA_PRESENT = 0x00000005;
    static final int MCI_STATUS_TIME_FORMAT = 0x00000006;
    static final int MCI_STATUS_READY = 0x00000007;
    static final int MCI_STATUS_CURRENT_TRACK = 0x00000008;
    static final int MCI_INFO_PRODUCT = 0x00000100;
    static final int MCI_INFO_FILE = 0x00000200;
    static final int MCI_INFO_MEDIA_UPC = 0x00000400;
    static final int MCI_INFO_MEDIA_IDENTITY = 0x00000800;
    static final int MCI_INFO_NAME = 0x00001000;
    static final int MCI_INFO_COPYRIGHT = 0x00002000;
    static final int MCI_GETDEVCAPS_ITEM = 0x00000100;
    static final int MCI_GETDEVCAPS_CAN_RECORD = 0x00000001;
    static final int MCI_GETDEVCAPS_HAS_AUDIO = 0x00000002;
    static final int MCI_GETDEVCAPS_HAS_VIDEO = 0x00000003;
    static final int MCI_GETDEVCAPS_DEVICE_TYPE = 0x00000004;
    static final int MCI_GETDEVCAPS_USES_FILES = 0x00000005;
    static final int MCI_GETDEVCAPS_COMPOUND_DEVICE = 0x00000006;
    static final int MCI_GETDEVCAPS_CAN_EJECT = 0x00000007;
    static final int MCI_GETDEVCAPS_CAN_PLAY = 0x00000008;
    static final int MCI_GETDEVCAPS_CAN_SAVE = 0x00000009;
    static final int MCI_SYSINFO_QUANTITY = 0x00000100;
    static final int MCI_SYSINFO_OPEN = 0x00000200;
    static final int MCI_SYSINFO_NAME = 0x00000400;
    static final int MCI_SYSINFO_INSTALLNAME = 0x00000800;
    static final int MCI_SET_DOOR_OPEN = 0x00000100;
    static final int MCI_SET_DOOR_CLOSED = 0x00000200;
    static final int MCI_SET_TIME_FORMAT = 0x00000400;
    static final int MCI_SET_AUDIO = 0x00000800;
    static final int MCI_SET_VIDEO = 0x00001000;
    static final int MCI_SET_ON = 0x00002000;
    static final int MCI_SET_OFF = 0x00004000;
    static final int MCI_SET_AUDIO_ALL = 0x00000000;
    static final int MCI_SET_AUDIO_LEFT = 0x00000001;
    static final int MCI_SET_AUDIO_RIGHT = 0x00000002;
    static final int MCI_BREAK_KEY = 0x00000100;
    static final int MCI_BREAK_HWND = 0x00000200;
    static final int MCI_BREAK_OFF = 0x00000400;
    static final int MCI_RECORD_INSERT = 0x00000100;
    static final int MCI_RECORD_OVERWRITE = 0x00000200;
    static final int MCI_SAVE_FILE = 0x00000100;
    static final int MCI_LOAD_FILE = 0x00000100;
    static final int MCI_VD_MODE_PARK = (MCI_VD_OFFSET + 1);
    static final int MCI_VD_MEDIA_CLV = (MCI_VD_OFFSET + 2);
    static final int MCI_VD_MEDIA_CAV = (MCI_VD_OFFSET + 3);
    static final int MCI_VD_MEDIA_OTHER = (MCI_VD_OFFSET + 4);
    static final int MCI_VD_FORMAT_TRACK = 0x4001;
    static final int MCI_VD_PLAY_REVERSE = 0x00010000;
    static final int MCI_VD_PLAY_FAST = 0x00020000;
    static final int MCI_VD_PLAY_SPEED = 0x00040000;
    static final int MCI_VD_PLAY_SCAN = 0x00080000;
    static final int MCI_VD_PLAY_SLOW = 0x00100000;
    static final int MCI_VD_SEEK_REVERSE = 0x00010000;
    static final int MCI_VD_STATUS_SPEED = 0x00004002;
    static final int MCI_VD_STATUS_FORWARD = 0x00004003;
    static final int MCI_VD_STATUS_MEDIA_TYPE = 0x00004004;
    static final int MCI_VD_STATUS_SIDE = 0x00004005;
    static final int MCI_VD_STATUS_DISC_SIZE = 0x00004006;
    static final int MCI_VD_GETDEVCAPS_CLV = 0x00010000;
    static final int MCI_VD_GETDEVCAPS_CAV = 0x00020000;
    static final int MCI_VD_SPIN_UP = 0x00010000;
    static final int MCI_VD_SPIN_DOWN = 0x00020000;
    static final int MCI_VD_GETDEVCAPS_CAN_REVERSE = 0x00004002;
    static final int MCI_VD_GETDEVCAPS_FAST_RATE = 0x00004003;
    static final int MCI_VD_GETDEVCAPS_SLOW_RATE = 0x00004004;
    static final int MCI_VD_GETDEVCAPS_NORMAL_RATE = 0x00004005;
    static final int MCI_VD_STEP_FRAMES = 0x00010000;
    static final int MCI_VD_STEP_REVERSE = 0x00020000;
    static final int MCI_VD_ESCAPE_STRING = 0x00000100;
    static final int MCI_CDA_STATUS_TYPE_TRACK = 0x00004001;
    static final int MCI_CDA_TRACK_AUDIO = (MCI_CD_OFFSET + 0);
    static final int MCI_CDA_TRACK_OTHER = (MCI_CD_OFFSET + 1);
    static final int MCI_WAVE_PCM = (MCI_WAVE_OFFSET + 0);
    static final int MCI_WAVE_MAPPER = (MCI_WAVE_OFFSET + 1);
    static final int MCI_WAVE_OPEN_BUFFER = 0x00010000;
    static final int MCI_WAVE_SET_FORMATTAG = 0x00010000;
    static final int MCI_WAVE_SET_CHANNELS = 0x00020000;
    static final int MCI_WAVE_SET_SAMPLESPERSEC = 0x00040000;
    static final int MCI_WAVE_SET_AVGBYTESPERSEC = 0x00080000;
    static final int MCI_WAVE_SET_BLOCKALIGN = 0x00100000;
    static final int MCI_WAVE_SET_BITSPERSAMPLE = 0x00200000;
    static final int MCI_WAVE_INPUT = 0x00400000;
    static final int MCI_WAVE_OUTPUT = 0x00800000;
    static final int MCI_WAVE_STATUS_FORMATTAG = 0x00004001;
    static final int MCI_WAVE_STATUS_CHANNELS = 0x00004002;
    static final int MCI_WAVE_STATUS_SAMPLESPERSEC = 0x00004003;
    static final int MCI_WAVE_STATUS_AVGBYTESPERSEC = 0x00004004;
    static final int MCI_WAVE_STATUS_BLOCKALIGN = 0x00004005;
    static final int MCI_WAVE_STATUS_BITSPERSAMPLE = 0x00004006;
    static final int MCI_WAVE_STATUS_LEVEL = 0x00004007;
    static final int MCI_WAVE_SET_ANYINPUT = 0x04000000;
    static final int MCI_WAVE_SET_ANYOUTPUT = 0x08000000;
    static final int MCI_WAVE_GETDEVCAPS_INPUTS = 0x00004001;
    static final int MCI_WAVE_GETDEVCAPS_OUTPUTS = 0x00004002;
    static final int MCI_SEQ_DIV_PPQN = (0 + MCI_SEQ_OFFSET);
    static final int MCI_SEQ_DIV_SMPTE_24 = (1 + MCI_SEQ_OFFSET);
    static final int MCI_SEQ_DIV_SMPTE_25 = (2 + MCI_SEQ_OFFSET);
    static final int MCI_SEQ_DIV_SMPTE_30DROP = (3 + MCI_SEQ_OFFSET);
    static final int MCI_SEQ_DIV_SMPTE_30 = (4 + MCI_SEQ_OFFSET);
    static final int MCI_SEQ_FORMAT_SONGPTR = 0x4001;
    static final int MCI_SEQ_FILE = 0x4002;
    static final int MCI_SEQ_MIDI = 0x4003;
    static final int MCI_SEQ_SMPTE = 0x4004;
    static final int MCI_SEQ_NONE = 65533;
    static final int MCI_SEQ_MAPPER = 65535;
    static final int MCI_SEQ_STATUS_TEMPO = 0x00004002;
    static final int MCI_SEQ_STATUS_PORT = 0x00004003;
    static final int MCI_SEQ_STATUS_SLAVE = 0x00004007;
    static final int MCI_SEQ_STATUS_MASTER = 0x00004008;
    static final int MCI_SEQ_STATUS_OFFSET = 0x00004009;
    static final int MCI_SEQ_STATUS_DIVTYPE = 0x0000400A;
    static final int MCI_SEQ_STATUS_NAME = 0x0000400B;
    static final int MCI_SEQ_STATUS_COPYRIGHT = 0x0000400C;
    static final int MCI_SEQ_SET_TEMPO = 0x00010000;
    static final int MCI_SEQ_SET_PORT = 0x00020000;
    static final int MCI_SEQ_SET_SLAVE = 0x00040000;
    static final int MCI_SEQ_SET_MASTER = 0x00080000;
    static final int MCI_SEQ_SET_OFFSET = 0x01000000;
    static final int MCI_ANIM_OPEN_WS = 0x00010000;
    static final int MCI_ANIM_OPEN_PARENT = 0x00020000;
    static final int MCI_ANIM_OPEN_NOSTATIC = 0x00040000;
    static final int MCI_ANIM_PLAY_SPEED = 0x00010000;
    static final int MCI_ANIM_PLAY_REVERSE = 0x00020000;
    static final int MCI_ANIM_PLAY_FAST = 0x00040000;
    static final int MCI_ANIM_PLAY_SLOW = 0x00080000;
    static final int MCI_ANIM_PLAY_SCAN = 0x00100000;
    static final int MCI_ANIM_STEP_REVERSE = 0x00010000;
    static final int MCI_ANIM_STEP_FRAMES = 0x00020000;
    static final int MCI_ANIM_STATUS_SPEED = 0x00004001;
    static final int MCI_ANIM_STATUS_FORWARD = 0x00004002;
    static final int MCI_ANIM_STATUS_HWND = 0x00004003;
    static final int MCI_ANIM_STATUS_HPAL = 0x00004004;
    static final int MCI_ANIM_STATUS_STRETCH = 0x00004005;
    static final int MCI_ANIM_INFO_TEXT = 0x00010000;
    static final int MCI_ANIM_GETDEVCAPS_CAN_REVERSE = 0x00004001;
    static final int MCI_ANIM_GETDEVCAPS_FAST_RATE = 0x00004002;
    static final int MCI_ANIM_GETDEVCAPS_SLOW_RATE = 0x00004003;
    static final int MCI_ANIM_GETDEVCAPS_NORMAL_RATE = 0x00004004;
    static final int MCI_ANIM_GETDEVCAPS_PALETTES = 0x00004006;
    static final int MCI_ANIM_GETDEVCAPS_CAN_STRETCH = 0x00004007;
    static final int MCI_ANIM_GETDEVCAPS_MAX_WINDOWS = 0x00004008;
    static final int MCI_ANIM_REALIZE_NORM = 0x00010000;
    static final int MCI_ANIM_REALIZE_BKGD = 0x00020000;
    static final int MCI_ANIM_WINDOW_HWND = 0x00010000;
    static final int MCI_ANIM_WINDOW_STATE = 0x00040000;
    static final int MCI_ANIM_WINDOW_TEXT = 0x00080000;
    static final int MCI_ANIM_WINDOW_ENABLE_STRETCH = 0x00100000;
    static final int MCI_ANIM_WINDOW_DISABLE_STRETCH = 0x00200000;
    static final int MCI_ANIM_WINDOW_DEFAULT = 0x00000000;
    static final int MCI_ANIM_RECT = 0x00010000;
    static final int MCI_ANIM_PUT_SOURCE = 0x00020000;
    static final int MCI_ANIM_PUT_DESTINATION = 0x00040000;
    static final int MCI_ANIM_WHERE_SOURCE = 0x00020000;
    static final int MCI_ANIM_WHERE_DESTINATION = 0x00040000;
    static final int MCI_ANIM_UPDATE_HDC = 0x00020000;
    static final int MCI_OVLY_OPEN_WS = 0x00010000;
    static final int MCI_OVLY_OPEN_PARENT = 0x00020000;
    static final int MCI_OVLY_STATUS_HWND = 0x00004001;
    static final int MCI_OVLY_STATUS_STRETCH = 0x00004002;
    static final int MCI_OVLY_INFO_TEXT = 0x00010000;
    static final int MCI_OVLY_GETDEVCAPS_CAN_STRETCH = 0x00004001;
    static final int MCI_OVLY_GETDEVCAPS_CAN_FREEZE = 0x00004002;
    static final int MCI_OVLY_GETDEVCAPS_MAX_WINDOWS = 0x00004003;
    static final int MCI_OVLY_WINDOW_HWND = 0x00010000;
    static final int MCI_OVLY_WINDOW_STATE = 0x00040000;
    static final int MCI_OVLY_WINDOW_TEXT = 0x00080000;
    static final int MCI_OVLY_WINDOW_ENABLE_STRETCH = 0x00100000;
    static final int MCI_OVLY_WINDOW_DISABLE_STRETCH = 0x00200000;
    static final int MCI_OVLY_WINDOW_DEFAULT = 0x00000000;
    static final int MCI_OVLY_RECT = 0x00010000;
    static final int MCI_OVLY_PUT_SOURCE = 0x00020000;
    static final int MCI_OVLY_PUT_DESTINATION = 0x00040000;
    static final int MCI_OVLY_PUT_FRAME = 0x00080000;
    static final int MCI_OVLY_PUT_VIDEO = 0x00100000;
    static final int MCI_OVLY_WHERE_SOURCE = 0x00020000;
    static final int MCI_OVLY_WHERE_DESTINATION = 0x00040000;
    static final int MCI_OVLY_WHERE_FRAME = 0x00080000;
    static final int MCI_OVLY_WHERE_VIDEO = 0x00100000;
    static final int NEWTRANSPARENT = 3;
    static final int QUERYROPSUPPORT = 40;
    static final int SELECTDIB = 41;
    static final int NCBNAMSZ = 16;
    static final int MAX_LANA = 254;
    static final int NAME_FLAGS_MASK = 0x87;
    static final int GROUP_NAME = 0x80;
    static final int UNIQUE_NAME = 0x00;
    static final int REGISTERING = 0x00;
    static final int REGISTERED = 0x04;
    static final int DEREGISTERED = 0x05;
    static final int DUPLICATE = 0x06;
    static final int DUPLICATE_DEREG = 0x07;
    static final int LISTEN_OUTSTANDING = 0x01;
    static final int CALL_PENDING = 0x02;
    static final int SESSION_ESTABLISHED = 0x03;
    static final int HANGUP_PENDING = 0x04;
    static final int HANGUP_COMPLETE = 0x05;
    static final int SESSION_ABORTED = 0x06;
    static final int NCBCALL = 0x10;
    static final int NCBLISTEN = 0x11;
    static final int NCBHANGUP = 0x12;
    static final int NCBSEND = 0x14;
    static final int NCBRECV = 0x15;
    static final int NCBRECVANY = 0x16;
    static final int NCBCHAINSEND = 0x17;
    static final int NCBDGSEND = 0x20;
    static final int NCBDGRECV = 0x21;
    static final int NCBDGSENDBC = 0x22;
    static final int NCBDGRECVBC = 0x23;
    static final int NCBADDNAME = 0x30;
    static final int NCBDELNAME = 0x31;
    static final int NCBRESET = 0x32;
    static final int NCBASTAT = 0x33;
    static final int NCBSSTAT = 0x34;
    static final int NCBCANCEL = 0x35;
    static final int NCBADDGRNAME = 0x36;
    static final int NCBENUM = 0x37;
    static final int NCBUNLINK = 0x70;
    static final int NCBSENDNA = 0x71;
    static final int NCBCHAINSENDNA = 0x72;
    static final int NCBLANSTALERT = 0x73;
    static final int NCBACTION = 0x77;
    static final int NCBFINDNAME = 0x78;
    static final int NCBTRACE = 0x79;
    static final int ASYNCH = 0x80;
    static final int NRC_GOODRET = 0x00;
    static final int NRC_BUFLEN = 0x01;
    static final int NRC_ILLCMD = 0x03;
    static final int NRC_CMDTMO = 0x05;
    static final int NRC_INCOMP = 0x06;
    static final int NRC_BADDR = 0x07;
    static final int NRC_SNUMOUT = 0x08;
    static final int NRC_NORES = 0x09;
    static final int NRC_SCLOSED = 0x0a;
    static final int NRC_CMDCAN = 0x0b;
    static final int NRC_DUPNAME = 0x0d;
    static final int NRC_NAMTFUL = 0x0e;
    static final int NRC_ACTSES = 0x0f;
    static final int NRC_LOCTFUL = 0x11;
    static final int NRC_REMTFUL = 0x12;
    static final int NRC_ILLNN = 0x13;
    static final int NRC_NOCALL = 0x14;
    static final int NRC_NOWILD = 0x15;
    static final int NRC_INUSE = 0x16;
    static final int NRC_NAMERR = 0x17;
    static final int NRC_SABORT = 0x18;
    static final int NRC_NAMCONF = 0x19;
    static final int NRC_IFBUSY = 0x21;
    static final int NRC_TOOMANY = 0x22;
    static final int NRC_BRIDGE = 0x23;
    static final int NRC_CANOCCR = 0x24;
    static final int NRC_CANCEL = 0x26;
    static final int NRC_DUPENV = 0x30;
    static final int NRC_ENVNOTDEF = 0x34;
    static final int NRC_OSRESNOTAV = 0x35;
    static final int NRC_MAXAPPS = 0x36;
    static final int NRC_NOSAPS = 0x37;
    static final int NRC_NORESOURCES = 0x38;
    static final int NRC_INVADDRESS = 0x39;
    static final int NRC_INVDDID = 0x3B;
    static final int NRC_LOCKFAIL = 0x3C;
    static final int NRC_OPENERR = 0x3f;
    static final int NRC_SYSTEM = 0x40;
    static final int NRC_PENDING = 0xff;
    static final int RPC_C_BINDING_INFINITE_TIMEOUT = 10;
    static final int RPC_C_BINDING_MIN_TIMEOUT = 0;
    static final int RPC_C_BINDING_DEFAULT_TIMEOUT = 5;
    static final int RPC_C_BINDING_MAX_TIMEOUT = 9;
    static final int RPC_C_CANCEL_INFINITE_TIMEOUT = -1;
    static final int RPC_C_LISTEN_MAX_CALLS_DEFAULT = 1234;
    static final int RPC_C_PROTSEQ_MAX_REQS_DEFAULT = 10;
    static final int RPC_C_BIND_TO_ALL_NICS = 1;
    static final int RPC_C_USE_INTERNET_PORT = 0x1;
    static final int RPC_C_USE_INTRANET_PORT = 0x2;
    static final int RPC_C_DONT_FAIL = 0x4;
    static final int RPC_C_MQ_TEMPORARY = 0x0000;
    static final int RPC_C_MQ_PERMANENT = 0x0001;
    static final int RPC_C_MQ_CLEAR_ON_OPEN = 0x0002;
    static final int RPC_C_MQ_USE_EXISTING_SECURITY = 0x0004;
    static final int RPC_C_MQ_AUTHN_LEVEL_NONE = 0x0000;
    static final int RPC_C_MQ_AUTHN_LEVEL_PKT_INTEGRITY = 0x0008;
    static final int RPC_C_MQ_AUTHN_LEVEL_PKT_PRIVACY = 0x0010;
    static final int RPC_C_OPT_MQ_DELIVERY = 1;
    static final int RPC_C_OPT_MQ_PRIORITY = 2;
    static final int RPC_C_OPT_MQ_JOURNAL = 3;
    static final int RPC_C_OPT_MQ_ACKNOWLEDGE = 4;
    static final int RPC_C_OPT_MQ_AUTHN_SERVICE = 5;
    static final int RPC_C_OPT_MQ_AUTHN_LEVEL = 6;
    static final int RPC_C_OPT_MQ_TIME_TO_REACH_QUEUE = 7;
    static final int RPC_C_OPT_MQ_TIME_TO_BE_RECEIVED = 8;
    static final int RPC_C_OPT_BINDING_NONCAUSAL = 9;
    static final int RPC_C_OPT_SECURITY_CALLBACK = 10;
    static final int RPC_C_OPT_UNIQUE_BINDING = 11;
    static final int RPC_C_OPT_CALL_TIMEOUT = 12;
    static final int RPC_C_OPT_DONT_LINGER = 13;
    static final int RPC_C_OPT_MAX_OPTIONS = 14;
    static final int RPC_C_MQ_EXPRESS = 0;
    static final int RPC_C_MQ_RECOVERABLE = 1;
    static final int RPC_C_MQ_JOURNAL_NONE = 0;
    static final int RPC_C_MQ_JOURNAL_DEADLETTER = 1;
    static final int RPC_C_MQ_JOURNAL_ALWAYS = 2;
    static final int RPC_C_FULL_CERT_CHAIN = 0x0001;
    static final int RPC_C_STATS_CALLS_IN = 0;
    static final int RPC_C_STATS_CALLS_OUT = 1;
    static final int RPC_C_STATS_PKTS_IN = 2;
    static final int RPC_C_STATS_PKTS_OUT = 3;
    static final int RPC_C_AUTHN_LEVEL_DEFAULT = 0;
    static final int RPC_C_AUTHN_LEVEL_NONE = 1;
    static final int RPC_C_AUTHN_LEVEL_CONNECT = 2;
    static final int RPC_C_AUTHN_LEVEL_CALL = 3;
    static final int RPC_C_AUTHN_LEVEL_PKT = 4;
    static final int RPC_C_AUTHN_LEVEL_PKT_INTEGRITY = 5;
    static final int RPC_C_AUTHN_LEVEL_PKT_PRIVACY = 6;
    static final int RPC_C_IMP_LEVEL_DEFAULT = 0;
    static final int RPC_C_IMP_LEVEL_ANONYMOUS = 1;
    static final int RPC_C_IMP_LEVEL_IDENTIFY = 2;
    static final int RPC_C_IMP_LEVEL_IMPERSONATE = 3;
    static final int RPC_C_IMP_LEVEL_DELEGATE = 4;
    static final int RPC_C_QOS_IDENTITY_STATIC = 0;
    static final int RPC_C_QOS_IDENTITY_DYNAMIC = 1;
    static final int RPC_C_QOS_CAPABILITIES_DEFAULT = 0x0;
    static final int RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH = 0x1;
    static final int RPC_C_QOS_CAPABILITIES_MAKE_FULLSIC = 0x2;
    static final int RPC_C_QOS_CAPABILITIES_ANY_AUTHORITY = 0x4;
    static final int RPC_C_QOS_CAPABILITIES_IGNORE_DELEGATE_FAILURE = 0x8;
    static final int RPC_C_QOS_CAPABILITIES_LOCAL_MA_HINT = 0x10;
    static final int RPC_C_PROTECT_LEVEL_DEFAULT = (RPC_C_AUTHN_LEVEL_DEFAULT);
    static final int RPC_C_PROTECT_LEVEL_NONE = (RPC_C_AUTHN_LEVEL_NONE);
    static final int RPC_C_PROTECT_LEVEL_CONNECT = (RPC_C_AUTHN_LEVEL_CONNECT);
    static final int RPC_C_PROTECT_LEVEL_CALL = (RPC_C_AUTHN_LEVEL_CALL);
    static final int RPC_C_PROTECT_LEVEL_PKT = (RPC_C_AUTHN_LEVEL_PKT);
    static final int RPC_C_PROTECT_LEVEL_PKT_INTEGRITY = (RPC_C_AUTHN_LEVEL_PKT_INTEGRITY);
    static final int RPC_C_PROTECT_LEVEL_PKT_PRIVACY = (RPC_C_AUTHN_LEVEL_PKT_PRIVACY);
    static final int RPC_C_AUTHN_NONE = 0;
    static final int RPC_C_AUTHN_DCE_PRIVATE = 1;
    static final int RPC_C_AUTHN_DCE_PUBLIC = 2;
    static final int RPC_C_AUTHN_DEC_PUBLIC = 4;
    static final int RPC_C_AUTHN_GSS_NEGOTIATE = 9;
    static final int RPC_C_AUTHN_WINNT = 10;
    static final int RPC_C_AUTHN_GSS_SCHANNEL = 14;
    static final int RPC_C_AUTHN_GSS_KERBEROS = 16;
    static final int RPC_C_AUTHN_DPA = 17;
    static final int RPC_C_AUTHN_MSN = 18;
    static final int RPC_C_AUTHN_DIGEST = 21;
    static final int RPC_C_AUTHN_MQ = 100;
    static final int RPC_C_AUTHN_DEFAULT = 0xFFFFFFFF;
    static final int RPC_C_SECURITY_QOS_VERSION = 1;
    static final int RPC_C_SECURITY_QOS_VERSION_1 = 1;
    static final int SEC_WINNT_AUTH_IDENTITY_ANSI = 0x1;
    static final int SEC_WINNT_AUTH_IDENTITY_UNICODE = 0x2;
    static final int RPC_C_SECURITY_QOS_VERSION_2 = 2;
    static final int RPC_C_AUTHN_INFO_TYPE_HTTP = 1;
    static final int RPC_C_HTTP_AUTHN_TARGET_SERVER = 1;
    static final int RPC_C_HTTP_AUTHN_TARGET_PROXY = 2;
    static final int RPC_C_HTTP_AUTHN_SCHEME_BASIC = 0x00000001;
    static final int RPC_C_HTTP_AUTHN_SCHEME_NTLM = 0x00000002;
    static final int RPC_C_HTTP_AUTHN_SCHEME_PASSPORT = 0x00000004;
    static final int RPC_C_HTTP_AUTHN_SCHEME_DIGEST = 0x00000008;
    static final int RPC_C_HTTP_AUTHN_SCHEME_NEGOTIATE = 0x00000010;
    static final int RPC_C_HTTP_FLAG_USE_SSL = 1;
    static final int RPC_C_HTTP_FLAG_USE_FIRST_AUTH_SCHEME = 2;
    static final int RPC_C_SECURITY_QOS_VERSION_3 = 3;
    static final int RPC_C_AUTHZ_NONE = 0;
    static final int RPC_C_AUTHZ_NAME = 1;
    static final int RPC_C_AUTHZ_DCE = 2;
    static final int RPC_C_AUTHZ_DEFAULT = 0xffffffff;
    static final int DCE_C_ERROR_STRING_LEN = 256;
    static final int RPC_C_EP_ALL_ELTS = 0;
    static final int RPC_C_EP_MATCH_BY_IF = 1;
    static final int RPC_C_EP_MATCH_BY_OBJ = 2;
    static final int RPC_C_EP_MATCH_BY_BOTH = 3;
    static final int RPC_C_VERS_ALL = 1;
    static final int RPC_C_VERS_COMPATIBLE = 2;
    static final int RPC_C_VERS_EXACT = 3;
    static final int RPC_C_VERS_MAJOR_ONLY = 4;
    static final int RPC_C_VERS_UPTO = 5;
    static final int RPC_C_MGMT_INQ_IF_IDS = 0;
    static final int RPC_C_MGMT_INQ_PRINC_NAME = 1;
    static final int RPC_C_MGMT_INQ_STATS = 2;
    static final int RPC_C_MGMT_IS_SERVER_LISTEN = 3;
    static final int RPC_C_MGMT_STOP_SERVER_LISTEN = 4;
    static final int RPC_C_PARM_MAX_PACKET_LENGTH = 1;
    static final int RPC_C_PARM_BUFFER_LENGTH = 2;
    static final int RPC_IF_AUTOLISTEN = 0x0001;
    static final int RPC_IF_OLE = 0x0002;
    static final int RPC_IF_ALLOW_UNKNOWN_AUTHORITY = 0x0004;
    static final int RPC_IF_ALLOW_SECURE_ONLY = 0x0008;
    static final int RPC_IF_ALLOW_CALLBACKS_WITH_NO_AUTH = 0x0010;
    static final int RPC_NCA_FLAGS_DEFAULT = 0x00000000;
    static final int RPC_NCA_FLAGS_IDEMPOTENT = 0x00000001;
    static final int RPC_NCA_FLAGS_BROADCAST = 0x00000002;
    static final int RPC_NCA_FLAGS_MAYBE = 0x00000004;
    static final int RPC_BUFFER_COMPLETE = 0x00001000;
    static final int RPC_BUFFER_PARTIAL = 0x00002000;
    static final int RPC_BUFFER_EXTRA = 0x00004000;
    static final int RPC_BUFFER_ASYNC = 0x00008000;
    static final int RPC_BUFFER_NONOTIFY = 0x00010000;
    static final int RPC_FLAGS_VALID_BIT = 0x00008000;
    static final int NT351_INTERFACE_SIZE = 0x40;
    static final int RPC_INTERFACE_HAS_PIPES = 0x0001;
    static final int TRANSPORT_TYPE_CN = 0x01;
    static final int TRANSPORT_TYPE_DG = 0x02;
    static final int TRANSPORT_TYPE_LPC = 0x04;
    static final int TRANSPORT_TYPE_WMSG = 0x08;
    static final int RPC_P_ADDR_FORMAT_TCP_IPV4 = 1;
    static final int RPC_P_ADDR_FORMAT_TCP_IPV6 = 2;
    static final int RPC_PROXY_CONNECTION_TYPE_IN_PROXY = 0;
    static final int RPC_PROXY_CONNECTION_TYPE_OUT_PROXY = 1;
    static final int RPC_C_NS_SYNTAX_DEFAULT = 0;
    static final int RPC_C_NS_SYNTAX_DCE = 3;
    static final int RPC_C_PROFILE_DEFAULT_ELT = 0;
    static final int RPC_C_PROFILE_ALL_ELT = 1;
    static final int RPC_C_PROFILE_ALL_ELTS = RPC_C_PROFILE_ALL_ELT;
    static final int RPC_C_PROFILE_MATCH_BY_IF = 2;
    static final int RPC_C_PROFILE_MATCH_BY_MBR = 3;
    static final int RPC_C_PROFILE_MATCH_BY_BOTH = 4;
    static final int RPC_C_NS_DEFAULT_EXP_AGE = -1;
    static final int RPC_S_OK = ERROR_SUCCESS;
    static final int RPC_S_INVALID_ARG = ERROR_INVALID_PARAMETER;
    static final int RPC_S_OUT_OF_MEMORY = ERROR_OUTOFMEMORY;
    static final int RPC_S_OUT_OF_THREADS = ERROR_MAX_THRDS_REACHED;
    static final int RPC_S_INVALID_LEVEL = ERROR_INVALID_PARAMETER;
    static final int RPC_S_BUFFER_TOO_SMALL = ERROR_INSUFFICIENT_BUFFER;
    static final int RPC_S_INVALID_SECURITY_DESC = ERROR_INVALID_SECURITY_DESCR;
    static final int RPC_S_ACCESS_DENIED = ERROR_ACCESS_DENIED;
    static final int RPC_S_SERVER_OUT_OF_MEMORY = ERROR_NOT_ENOUGH_SERVER_MEMORY;
    static final int RPC_S_ASYNC_CALL_PENDING = ERROR_IO_PENDING;
    static final int RPC_S_UNKNOWN_PRINCIPAL = ERROR_NONE_MAPPED;
    static final int RPC_S_TIMEOUT = ERROR_TIMEOUT;
    static final int RPC_X_NO_MEMORY = RPC_S_OUT_OF_MEMORY;
    static final int RPC_X_INVALID_BOUND = RPC_S_INVALID_BOUND;
    static final int RPC_X_INVALID_TAG = RPC_S_INVALID_TAG;
    static final int RPC_X_ENUM_VALUE_TOO_LARGE = RPC_X_ENUM_VALUE_OUT_OF_RANGE;
    static final int RPC_X_SS_CONTEXT_MISMATCH = ERROR_INVALID_HANDLE;
    static final int RPC_X_INVALID_BUFFER = ERROR_INVALID_USER_BUFFER;
    static final int RPC_X_PIPE_APP_MEMORY = ERROR_OUTOFMEMORY;
    static final int RPC_X_INVALID_PIPE_OPERATION = RPC_X_WRONG_PIPE_ORDER;
    static final int RPC_C_NOTIFY_ON_SEND_COMPLETE = 0x1;
    static final int RPC_C_INFINITE_TIMEOUT = INFINITE;
    static final int MaxNumberOfEEInfoParams = 4;
    static final int RPC_EEINFO_VERSION = 1;
    static final int EEInfoPreviousRecordsMissing = 1;
    static final int EEInfoNextRecordsMissing = 2;
    static final int EEInfoUseFileTime = 4;
    static final int EEInfoGCCOM = 11;
    static final int EEInfoGCFRS = 12;
    static final int RPC_CALL_ATTRIBUTES_VERSION = (1);
    static final int RPC_QUERY_SERVER_PRINCIPAL_NAME = (2);
    static final int RPC_QUERY_CLIENT_PRINCIPAL_NAME = (4);
    static final int ABM_NEW = 0x00000000;
    static final int ABM_REMOVE = 0x00000001;
    static final int ABM_QUERYPOS = 0x00000002;
    static final int ABM_SETPOS = 0x00000003;
    static final int ABM_GETSTATE = 0x00000004;
    static final int ABM_GETTASKBARPOS = 0x00000005;
    static final int ABM_ACTIVATE = 0x00000006;
    static final int ABM_GETAUTOHIDEBAR = 0x00000007;
    static final int ABM_SETAUTOHIDEBAR = 0x00000008;
    static final int ABM_WINDOWPOSCHANGED = 0x0000009;
    static final int ABM_SETSTATE = 0x0000000a;
    static final int ABN_STATECHANGE = 0x0000000;
    static final int ABN_POSCHANGED = 0x0000001;
    static final int ABN_FULLSCREENAPP = 0x0000002;
    static final int ABN_WINDOWARRANGE = 0x0000003;
    static final int ABS_AUTOHIDE = 0x0000001;
    static final int ABS_ALWAYSONTOP = 0x0000002;
    static final int ABE_LEFT = 0;
    static final int ABE_TOP = 1;
    static final int ABE_RIGHT = 2;
    static final int ABE_BOTTOM = 3;
    static final int FO_MOVE = 0x0001;
    static final int FO_COPY = 0x0002;
    static final int FO_DELETE = 0x0003;
    static final int FO_RENAME = 0x0004;
    static final int FOF_MULTIDESTFILES = 0x0001;
    static final int FOF_CONFIRMMOUSE = 0x0002;
    static final int FOF_SILENT = 0x0004;
    static final int FOF_RENAMEONCOLLISION = 0x0008;
    static final int FOF_NOCONFIRMATION = 0x0010;
    static final int FOF_WANTMAPPINGHANDLE = 0x0020;
    static final int FOF_ALLOWUNDO = 0x0040;
    static final int FOF_FILESONLY = 0x0080;
    static final int FOF_SIMPLEPROGRESS = 0x0100;
    static final int FOF_NOCONFIRMMKDIR = 0x0200;
    static final int FOF_NOERRORUI = 0x0400;
    static final int FOF_NOCOPYSECURITYATTRIBS = 0x0800;
    static final int FOF_NORECURSION = 0x1000;
    static final int PO_DELETE = 0x0013;
    static final int PO_RENAME = 0x0014;
    static final int PO_PORTCHANGE = 0x0020;
    static final int PO_REN_PORT = 0x0034;
    static final int SE_ERR_FNF = 2;
    static final int SE_ERR_PNF = 3;
    static final int SE_ERR_ACCESSDENIED = 5;
    static final int SE_ERR_OOM = 8;
    static final int SE_ERR_DLLNOTFOUND = 32;
    static final int SE_ERR_SHARE = 26;
    static final int SE_ERR_ASSOCINCOMPLETE = 27;
    static final int SE_ERR_DDETIMEOUT = 28;
    static final int SE_ERR_DDEFAIL = 29;
    static final int SE_ERR_DDEBUSY = 30;
    static final int SE_ERR_NOASSOC = 31;
    static final int SEE_MASK_CLASSNAME = 0x00000001;
    static final int SEE_MASK_CLASSKEY = 0x00000003;
    static final int SEE_MASK_IDLIST = 0x00000004;
    static final int SEE_MASK_INVOKEIDLIST = 0x0000000c;
    static final int SEE_MASK_ICON = 0x00000010;
    static final int SEE_MASK_HOTKEY = 0x00000020;
    static final int SEE_MASK_NOCLOSEPROCESS = 0x00000040;
    static final int SEE_MASK_CONNECTNETDRV = 0x00000080;
    static final int SEE_MASK_FLAG_DDEWAIT = 0x00000100;
    static final int SEE_MASK_DOENVSUBST = 0x00000200;
    static final int SEE_MASK_FLAG_NO_UI = 0x00000400;
    static final int SEE_MASK_UNICODE = 0x00004000;
    static final int SEE_MASK_NO_CONSOLE = 0x00008000;
    static final int SEE_MASK_ASYNCOK = 0x00100000;
    static final int SEE_MASK_HMONITOR = 0x00200000;
    static final int SHERB_NOCONFIRMATION = 0x00000001;
    static final int SHERB_NOPROGRESSUI = 0x00000002;
    static final int SHERB_NOSOUND = 0x00000004;
    static final int NIM_ADD = 0x00000000;
    static final int NIM_MODIFY = 0x00000001;
    static final int NIM_DELETE = 0x00000002;
    static final int NIF_MESSAGE = 0x00000001;
    static final int NIF_ICON = 0x00000002;
    static final int NIF_TIP = 0x00000004;
    static final int SHGFI_ICON = 0x000000100;
    static final int SHGFI_DISPLAYNAME = 0x000000200;
    static final int SHGFI_TYPENAME = 0x000000400;
    static final int SHGFI_ATTRIBUTES = 0x000000800;
    static final int SHGFI_ICONLOCATION = 0x000001000;
    static final int SHGFI_EXETYPE = 0x000002000;
    static final int SHGFI_SYSICONINDEX = 0x000004000;
    static final int SHGFI_LINKOVERLAY = 0x000008000;
    static final int SHGFI_SELECTED = 0x000010000;
    static final int SHGFI_ATTR_SPECIFIED = 0x000020000;
    static final int SHGFI_LARGEICON = 0x000000000;
    static final int SHGFI_SMALLICON = 0x000000001;
    static final int SHGFI_OPENICON = 0x000000002;
    static final int SHGFI_SHELLICONSIZE = 0x000000004;
    static final int SHGFI_PIDL = 0x000000008;
    static final int SHGFI_USEFILEATTRIBUTES = 0x000000010;
    static final int SHGNLI_PIDL = 0x000000001;
    static final int SHGNLI_PREFIXNAME = 0x000000002;
    static final int SHGNLI_NOUNIQUE = 0x000000004;
    static final int PRINTACTION_OPEN = 0;
    static final int PRINTACTION_PROPERTIES = 1;
    static final int PRINTACTION_NETINSTALL = 2;
    static final int PRINTACTION_NETINSTALLLINK = 3;
    static final int PRINTACTION_TESTPAGE = 4;
    static final int PRINTACTION_OPENNETPRN = 5;
    static final int OFFLINE_STATUS_LOCAL = 0x0001;
    static final int OFFLINE_STATUS_REMOTE = 0x0002;
    static final int OFFLINE_STATUS_INCOMPLETE = 0x0004;
    static final int PERF_DATA_VERSION = 1;
    static final int PERF_DATA_REVISION = 1;
    static final int PERF_NO_INSTANCES = -1;
    static final int PERF_SIZE_DWORD = 0x00000000;
    static final int PERF_SIZE_LARGE = 0x00000100;
    static final int PERF_SIZE_ZERO = 0x00000200;
    static final int PERF_SIZE_VARIABLE_LEN = 0x00000300;
    static final int PERF_TYPE_NUMBER = 0x00000000;
    static final int PERF_TYPE_COUNTER = 0x00000400;
    static final int PERF_TYPE_TEXT = 0x00000800;
    static final int PERF_TYPE_ZERO = 0x00000C00;
    static final int PERF_NUMBER_HEX = 0x00000000;
    static final int PERF_NUMBER_DECIMAL = 0x00010000;
    static final int PERF_NUMBER_DEC_1000 = 0x00020000;
    static final int PERF_COUNTER_VALUE = 0x00000000;
    static final int PERF_COUNTER_RATE = 0x00010000;
    static final int PERF_COUNTER_FRACTION = 0x00020000;
    static final int PERF_COUNTER_BASE = 0x00030000;
    static final int PERF_COUNTER_ELAPSED = 0x00040000;
    static final int PERF_COUNTER_QUEUELEN = 0x00050000;
    static final int PERF_COUNTER_HISTOGRAM = 0x00060000;
    static final int PERF_COUNTER_PRECISION = 0x00070000;
    static final int PERF_TEXT_UNICODE = 0x00000000;
    static final int PERF_TEXT_ASCII = 0x00010000;
    static final int PERF_TIMER_TICK = 0x00000000;
    static final int PERF_TIMER_100NS = 0x00100000;
    static final int PERF_OBJECT_TIMER = 0x00200000;
    static final int PERF_DELTA_COUNTER = 0x00400000;
    static final int PERF_DELTA_BASE = 0x00800000;
    static final int PERF_INVERSE_COUNTER = 0x01000000;
    static final int PERF_MULTI_COUNTER = 0x02000000;
    static final int PERF_DISPLAY_NO_SUFFIX = 0x00000000;
    static final int PERF_DISPLAY_PER_SEC = 0x10000000;
    static final int PERF_DISPLAY_PERCENT = 0x20000000;
    static final int PERF_DISPLAY_SECONDS = 0x30000000;
    static final int PERF_DISPLAY_NOSHOW = 0x40000000;
    static final int PERF_COUNTER_COUNTER = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PER_SEC);
    static final int PERF_COUNTER_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_COUNTER_QUEUELEN_TYPE = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_LARGE_QUEUELEN_TYPE = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_100NS_QUEUELEN_TYPE = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_OBJ_TIME_QUEUELEN_TYPE = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_QUEUELEN | PERF_OBJECT_TIMER | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_BULK_COUNT = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PER_SEC);
    static final int PERF_COUNTER_TEXT = (PERF_SIZE_VARIABLE_LEN | PERF_TYPE_TEXT | PERF_TEXT_UNICODE | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_RAWCOUNT = (PERF_SIZE_DWORD | PERF_TYPE_NUMBER | PERF_NUMBER_DECIMAL | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_LARGE_RAWCOUNT = (PERF_SIZE_LARGE | PERF_TYPE_NUMBER | PERF_NUMBER_DECIMAL | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_RAWCOUNT_HEX = (PERF_SIZE_DWORD | PERF_TYPE_NUMBER | PERF_NUMBER_HEX | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_LARGE_RAWCOUNT_HEX = (PERF_SIZE_LARGE | PERF_TYPE_NUMBER | PERF_NUMBER_HEX | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_SAMPLE_FRACTION = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DELTA_COUNTER | PERF_DELTA_BASE | PERF_DISPLAY_PERCENT);
    static final int PERF_SAMPLE_COUNTER = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_NODATA = (PERF_SIZE_ZERO | PERF_DISPLAY_NOSHOW);
    static final int PERF_COUNTER_TIMER_INV = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_SAMPLE_BASE = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 0x00000001);
    static final int PERF_AVERAGE_TIMER = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_SECONDS);
    static final int PERF_AVERAGE_BASE = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 0x00000002);
    static final int PERF_AVERAGE_BULK = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_NOSHOW);
    static final int PERF_OBJ_TIME_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_OBJECT_TIMER | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_100NSEC_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_100NSEC_TIMER_INV = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_COUNTER_MULTI_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_DELTA_COUNTER | PERF_TIMER_TICK | PERF_MULTI_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_COUNTER_MULTI_TIMER_INV = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_RATE | PERF_DELTA_COUNTER | PERF_MULTI_COUNTER | PERF_TIMER_TICK | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_COUNTER_MULTI_BASE = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_MULTI_COUNTER | PERF_DISPLAY_NOSHOW);
    static final int PERF_100NSEC_MULTI_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_DELTA_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_MULTI_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_100NSEC_MULTI_TIMER_INV = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_DELTA_COUNTER | PERF_COUNTER_RATE | PERF_TIMER_100NS | PERF_MULTI_COUNTER | PERF_INVERSE_COUNTER | PERF_DISPLAY_PERCENT);
    static final int PERF_RAW_FRACTION = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_PERCENT);
    static final int PERF_LARGE_RAW_FRACTION = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_FRACTION | PERF_DISPLAY_PERCENT);
    static final int PERF_RAW_BASE = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW | 0x00000003);
    static final int PERF_LARGE_RAW_BASE = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_BASE | PERF_DISPLAY_NOSHOW );
    static final int PERF_ELAPSED_TIME = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_ELAPSED | PERF_OBJECT_TIMER | PERF_DISPLAY_SECONDS);
    static final int PERF_COUNTER_HISTOGRAM_TYPE = 0x80000000;
    static final int PERF_COUNTER_DELTA = (PERF_SIZE_DWORD | PERF_TYPE_COUNTER | PERF_COUNTER_VALUE | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_COUNTER_LARGE_DELTA = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_VALUE | PERF_DELTA_COUNTER | PERF_DISPLAY_NO_SUFFIX);
    static final int PERF_PRECISION_SYSTEM_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_PRECISION | PERF_TIMER_TICK | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT );
    static final int PERF_PRECISION_100NS_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_PRECISION | PERF_TIMER_100NS | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT );
    static final int PERF_PRECISION_OBJECT_TIMER = (PERF_SIZE_LARGE | PERF_TYPE_COUNTER | PERF_COUNTER_PRECISION | PERF_OBJECT_TIMER | PERF_DELTA_COUNTER | PERF_DISPLAY_PERCENT );
    static final int PERF_PRECISION_TIMESTAMP = PERF_LARGE_RAW_BASE;
    static final int PERF_DETAIL_NOVICE = 100;
    static final int PERF_DETAIL_ADVANCED = 200;
    static final int PERF_DETAIL_EXPERT = 300;
    static final int PERF_DETAIL_WIZARD = 400;
    static final int PERF_NO_UNIQUE_ID = -1;
    static final int MAX_PERF_OBJECTS_IN_QUERY_FUNCTION = (64);
    static final int WINPERF_LOG_NONE = 0;
    static final int WINPERF_LOG_USER = 1;
    static final int WINPERF_LOG_DEBUG = 2;
    static final int WINPERF_LOG_VERBOSE = 3;
    static final int FD_SETSIZE = 64;
    static final int IOCPARM_MASK = 0x7f;
    static final int IOC_VOID = 0x20000000;
    static final int IOC_OUT = 0x40000000;
    static final int IOC_IN = 0x80000000;
    static final int IOC_INOUT = (IOC_IN|IOC_OUT);
    static final int IPPROTO_IP = 0;
    static final int IPPROTO_ICMP = 1;
    static final int IPPROTO_IGMP = 2;
    static final int IPPROTO_GGP = 3;
    static final int IPPROTO_TCP = 6;
    static final int IPPROTO_PUP = 12;
    static final int IPPROTO_UDP = 17;
    static final int IPPROTO_IDP = 22;
    static final int IPPROTO_ND = 77;
    static final int IPPROTO_RAW = 255;
    static final int IPPROTO_MAX = 256;
    static final int IPPORT_ECHO = 7;
    static final int IPPORT_DISCARD = 9;
    static final int IPPORT_SYSTAT = 11;
    static final int IPPORT_DAYTIME = 13;
    static final int IPPORT_NETSTAT = 15;
    static final int IPPORT_FTP = 21;
    static final int IPPORT_TELNET = 23;
    static final int IPPORT_SMTP = 25;
    static final int IPPORT_TIMESERVER = 37;
    static final int IPPORT_NAMESERVER = 42;
    static final int IPPORT_WHOIS = 43;
    static final int IPPORT_MTP = 57;
    static final int IPPORT_TFTP = 69;
    static final int IPPORT_RJE = 77;
    static final int IPPORT_FINGER = 79;
    static final int IPPORT_TTYLINK = 87;
    static final int IPPORT_SUPDUP = 95;
    static final int IPPORT_EXECSERVER = 512;
    static final int IPPORT_LOGINSERVER = 513;
    static final int IPPORT_CMDSERVER = 514;
    static final int IPPORT_EFSSERVER = 520;
    static final int IPPORT_BIFFUDP = 512;
    static final int IPPORT_WHOSERVER = 513;
    static final int IPPORT_ROUTESERVER = 520;
    static final int IPPORT_RESERVED = 1024;
    static final int IMPLINK_IP = 155;
    static final int IMPLINK_LOWEXPER = 156;
    static final int IMPLINK_HIGHEXPER = 158;
    static final int IN_CLASSA_NET = 0xff000000;
    static final int IN_CLASSA_NSHIFT = 24;
    static final int IN_CLASSA_HOST = 0x00ffffff;
    static final int IN_CLASSA_MAX = 128;
    static final int IN_CLASSB_NET = 0xffff0000;
    static final int IN_CLASSB_NSHIFT = 16;
    static final int IN_CLASSB_HOST = 0x0000ffff;
    static final int IN_CLASSB_MAX = 65536;
    static final int IN_CLASSC_NET = 0xffffff00;
    static final int IN_CLASSC_NSHIFT = 8;
    static final int IN_CLASSC_HOST = 0x000000ff;
    static final int INADDR_LOOPBACK = 0x7f000001;
    static final int INADDR_NONE = 0xffffffff;
    static final int WSADESCRIPTION_LEN = 256;
    static final int WSASYS_STATUS_LEN = 128;
    static final int IP_OPTIONS = 1;
    static final int IP_MULTICAST_IF = 2;
    static final int IP_MULTICAST_TTL = 3;
    static final int IP_MULTICAST_LOOP = 4;
    static final int IP_ADD_MEMBERSHIP = 5;
    static final int IP_DROP_MEMBERSHIP = 6;
    static final int IP_TTL = 7;
    static final int IP_TOS = 8;
    static final int IP_DONTFRAGMENT = 9;
    static final int IP_DEFAULT_MULTICAST_TTL = 1;
    static final int IP_DEFAULT_MULTICAST_LOOP = 1;
    static final int IP_MAX_MEMBERSHIPS = 20;
    static final int SOCKET_ERROR = (-1);
    static final int SOCK_STREAM = 1;
    static final int SOCK_DGRAM = 2;
    static final int SOCK_RAW = 3;
    static final int SOCK_RDM = 4;
    static final int SOCK_SEQPACKET = 5;
    static final int SO_DEBUG = 0x0001;
    static final int SO_ACCEPTCONN = 0x0002;
    static final int SO_REUSEADDR = 0x0004;
    static final int SO_KEEPALIVE = 0x0008;
    static final int SO_DONTROUTE = 0x0010;
    static final int SO_BROADCAST = 0x0020;
    static final int SO_USELOOPBACK = 0x0040;
    static final int SO_LINGER = 0x0080;
    static final int SO_OOBINLINE = 0x0100;
    static final int SO_SNDBUF = 0x1001;
    static final int SO_RCVBUF = 0x1002;
    static final int SO_SNDLOWAT = 0x1003;
    static final int SO_RCVLOWAT = 0x1004;
    static final int SO_SNDTIMEO = 0x1005;
    static final int SO_RCVTIMEO = 0x1006;
    static final int SO_ERROR = 0x1007;
    static final int SO_TYPE = 0x1008;
    static final int SO_CONNDATA = 0x7000;
    static final int SO_CONNOPT = 0x7001;
    static final int SO_DISCDATA = 0x7002;
    static final int SO_DISCOPT = 0x7003;
    static final int SO_CONNDATALEN = 0x7004;
    static final int SO_CONNOPTLEN = 0x7005;
    static final int SO_DISCDATALEN = 0x7006;
    static final int SO_DISCOPTLEN = 0x7007;
    static final int SO_OPENTYPE = 0x7008;
    static final int SO_SYNCHRONOUS_ALERT = 0x10;
    static final int SO_SYNCHRONOUS_NONALERT = 0x20;
    static final int SO_MAXDG = 0x7009;
    static final int SO_MAXPATHDG = 0x700A;
    static final int SO_UPDATE_ACCEPT_CONTEXT = 0x700B;
    static final int SO_CONNECT_TIME = 0x700C;
    static final int TCP_NODELAY = 0x0001;
    static final int TCP_BSDURGENT = 0x7000;
    static final int AF_UNSPEC = 0;
    static final int AF_UNIX = 1;
    static final int AF_INET = 2;
    static final int AF_IMPLINK = 3;
    static final int AF_PUP = 4;
    static final int AF_CHAOS = 5;
    static final int AF_IPX = 6;
    static final int AF_NS = 6;
    static final int AF_ISO = 7;
    static final int AF_OSI = AF_ISO;
    static final int AF_ECMA = 8;
    static final int AF_DATAKIT = 9;
    static final int AF_CCITT = 10;
    static final int AF_SNA = 11;
    static final int AF_DECnet = 12;
    static final int AF_DLI = 13;
    static final int AF_LAT = 14;
    static final int AF_HYLINK = 15;
    static final int AF_APPLETALK = 16;
    static final int AF_NETBIOS = 17;
    static final int AF_VOICEVIEW = 18;
    static final int AF_FIREFOX = 19;
    static final int AF_UNKNOWN1 = 20;
    static final int AF_BAN = 21;
    static final int AF_MAX = 22;
    static final int PF_UNSPEC = AF_UNSPEC;
    static final int PF_UNIX = AF_UNIX;
    static final int PF_INET = AF_INET;
    static final int PF_IMPLINK = AF_IMPLINK;
    static final int PF_PUP = AF_PUP;
    static final int PF_CHAOS = AF_CHAOS;
    static final int PF_NS = AF_NS;
    static final int PF_IPX = AF_IPX;
    static final int PF_ISO = AF_ISO;
    static final int PF_OSI = AF_OSI;
    static final int PF_ECMA = AF_ECMA;
    static final int PF_DATAKIT = AF_DATAKIT;
    static final int PF_CCITT = AF_CCITT;
    static final int PF_SNA = AF_SNA;
    static final int PF_DECnet = AF_DECnet;
    static final int PF_DLI = AF_DLI;
    static final int PF_LAT = AF_LAT;
    static final int PF_HYLINK = AF_HYLINK;
    static final int PF_APPLETALK = AF_APPLETALK;
    static final int PF_VOICEVIEW = AF_VOICEVIEW;
    static final int PF_FIREFOX = AF_FIREFOX;
    static final int PF_UNKNOWN1 = AF_UNKNOWN1;
    static final int PF_BAN = AF_BAN;
    static final int PF_MAX = AF_MAX;
    static final int SOL_SOCKET = 0xffff;
    static final int SOMAXCONN = 5;
    static final int MSG_OOB = 0x1;
    static final int MSG_PEEK = 0x2;
    static final int MSG_DONTROUTE = 0x4;
    static final int MSG_MAXIOVLEN = 16;
    static final int MSG_PARTIAL = 0x8000;
    static final int MAXGETHOSTSTRUCT = 1024;
    static final int FD_READ = 0x01;
    static final int FD_WRITE = 0x02;
    static final int FD_OOB = 0x04;
    static final int FD_ACCEPT = 0x08;
    static final int FD_CONNECT = 0x10;
    static final int FD_CLOSE = 0x20;
    static final int HOST_NOT_FOUND = WSAHOST_NOT_FOUND;
    static final int TRY_AGAIN = WSATRY_AGAIN;
    static final int NO_RECOVERY = WSANO_RECOVERY;
    static final int NO_DATA = WSANO_DATA;
    static final int WSANO_ADDRESS = WSANO_DATA;
    static final int NO_ADDRESS = WSANO_ADDRESS;
    static final int TF_DISCONNECT = 0x01;
    static final int TF_REUSE_SOCKET = 0x02;
    static final int TF_WRITE_BEHIND = 0x04;
    static final int ALG_CLASS_ANY = (0);
    static final int ALG_CLASS_SIGNATURE = (1 << 13);
    static final int ALG_CLASS_MSG_ENCRYPT = (2 << 13);
    static final int ALG_CLASS_DATA_ENCRYPT = (3 << 13);
    static final int ALG_CLASS_HASH = (4 << 13);
    static final int ALG_CLASS_KEY_EXCHANGE = (5 << 13);
    static final int ALG_CLASS_ALL = (7 << 13);
    static final int ALG_TYPE_ANY = (0);
    static final int ALG_TYPE_DSS = (1 << 9);
    static final int ALG_TYPE_RSA = (2 << 9);
    static final int ALG_TYPE_BLOCK = (3 << 9);
    static final int ALG_TYPE_STREAM = (4 << 9);
    static final int ALG_TYPE_DH = (5 << 9);
    static final int ALG_TYPE_SECURECHANNEL = (6 << 9);
    static final int ALG_SID_ANY = (0);
    static final int ALG_SID_RSA_ANY = 0;
    static final int ALG_SID_RSA_PKCS = 1;
    static final int ALG_SID_RSA_MSATWORK = 2;
    static final int ALG_SID_RSA_ENTRUST = 3;
    static final int ALG_SID_RSA_PGP = 4;
    static final int ALG_SID_DSS_ANY = 0;
    static final int ALG_SID_DSS_PKCS = 1;
    static final int ALG_SID_DSS_DMS = 2;
    static final int ALG_SID_DES = 1;
    static final int ALG_SID_3DES = 3;
    static final int ALG_SID_DESX = 4;
    static final int ALG_SID_IDEA = 5;
    static final int ALG_SID_CAST = 6;
    static final int ALG_SID_SAFERSK64 = 7;
    static final int ALG_SID_SAFERSK128 = 8;
    static final int ALG_SID_3DES_112 = 9;
    static final int ALG_SID_CYLINK_MEK = 12;
    static final int ALG_SID_RC5 = 13;
    static final int ALG_SID_AES_128 = 14;
    static final int ALG_SID_AES_192 = 15;
    static final int ALG_SID_AES_256 = 16;
    static final int ALG_SID_AES = 17;
    static final int ALG_SID_SKIPJACK = 10;
    static final int ALG_SID_TEK = 11;
    static final int CRYPT_MODE_CBCI = 6;
    static final int CRYPT_MODE_CFBP = 7;
    static final int CRYPT_MODE_OFBP = 8;
    static final int CRYPT_MODE_CBCOFM = 9;
    static final int CRYPT_MODE_CBCOFMI = 10;
    static final int ALG_SID_RC2 = 2;
    static final int ALG_SID_RC4 = 1;
    static final int ALG_SID_SEAL = 2;
    static final int ALG_SID_DH_SANDF = 1;
    static final int ALG_SID_DH_EPHEM = 2;
    static final int ALG_SID_AGREED_KEY_ANY = 3;
    static final int ALG_SID_KEA = 4;
    static final int ALG_SID_MD2 = 1;
    static final int ALG_SID_MD4 = 2;
    static final int ALG_SID_MD5 = 3;
    static final int ALG_SID_SHA = 4;
    static final int ALG_SID_SHA1 = 4;
    static final int ALG_SID_MAC = 5;
    static final int ALG_SID_RIPEMD = 6;
    static final int ALG_SID_RIPEMD160 = 7;
    static final int ALG_SID_SSL3SHAMD5 = 8;
    static final int ALG_SID_HMAC = 9;
    static final int ALG_SID_TLS1PRF = 10;
    static final int ALG_SID_HASH_REPLACE_OWF = 11;
    static final int ALG_SID_SHA_256 = 12;
    static final int ALG_SID_SHA_384 = 13;
    static final int ALG_SID_SHA_512 = 14;
    static final int ALG_SID_SSL3_MASTER = 1;
    static final int ALG_SID_SCHANNEL_MASTER_HASH = 2;
    static final int ALG_SID_SCHANNEL_MAC_KEY = 3;
    static final int ALG_SID_PCT1_MASTER = 4;
    static final int ALG_SID_SSL2_MASTER = 5;
    static final int ALG_SID_TLS1_MASTER = 6;
    static final int ALG_SID_SCHANNEL_ENC_KEY = 7;
    static final int ALG_SID_EXAMPLE = 80;
    static final int CALG_MD2 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD2);
    static final int CALG_MD4 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD4);
    static final int CALG_MD5 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD5);
    static final int CALG_SHA = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA);
    static final int CALG_SHA1 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA1);
    static final int CALG_MAC = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MAC);
    static final int CALG_RSA_SIGN = (ALG_CLASS_SIGNATURE | ALG_TYPE_RSA | ALG_SID_RSA_ANY);
    static final int CALG_DSS_SIGN = (ALG_CLASS_SIGNATURE | ALG_TYPE_DSS | ALG_SID_DSS_ANY);
    static final int CALG_NO_SIGN = (ALG_CLASS_SIGNATURE | ALG_TYPE_ANY | ALG_SID_ANY);
    static final int CALG_RSA_KEYX = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_RSA|ALG_SID_RSA_ANY);
    static final int CALG_DES = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_DES);
    static final int CALG_3DES_112 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_3DES_112);
    static final int CALG_3DES = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_3DES);
    static final int CALG_DESX = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_DESX);
    static final int CALG_RC2 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_RC2);
    static final int CALG_RC4 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_STREAM|ALG_SID_RC4);
    static final int CALG_SEAL = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_STREAM|ALG_SID_SEAL);
    static final int CALG_DH_SF = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_DH_SANDF);
    static final int CALG_DH_EPHEM = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_DH_EPHEM);
    static final int CALG_AGREEDKEY_ANY = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_AGREED_KEY_ANY);
    static final int CALG_KEA_KEYX = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_DH|ALG_SID_KEA);
    static final int CALG_HUGHES_MD5 = (ALG_CLASS_KEY_EXCHANGE|ALG_TYPE_ANY|ALG_SID_MD5);
    static final int CALG_SKIPJACK = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_SKIPJACK);
    static final int CALG_TEK = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_TEK);
    static final int CALG_CYLINK_MEK = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_CYLINK_MEK);
    static final int CALG_SSL3_SHAMD5 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SSL3SHAMD5);
    static final int CALG_SSL3_MASTER = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_SSL3_MASTER);
    static final int CALG_SCHANNEL_MASTER_HASH = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_SCHANNEL_MASTER_HASH);
    static final int CALG_SCHANNEL_MAC_KEY = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_SCHANNEL_MAC_KEY);
    static final int CALG_SCHANNEL_ENC_KEY = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_SCHANNEL_ENC_KEY);
    static final int CALG_PCT1_MASTER = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_PCT1_MASTER);
    static final int CALG_SSL2_MASTER = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_SSL2_MASTER);
    static final int CALG_TLS1_MASTER = (ALG_CLASS_MSG_ENCRYPT|ALG_TYPE_SECURECHANNEL|ALG_SID_TLS1_MASTER);
    static final int CALG_RC5 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_RC5);
    static final int CALG_HMAC = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_HMAC);
    static final int CALG_TLS1PRF = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_TLS1PRF);
    static final int CALG_HASH_REPLACE_OWF = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_HASH_REPLACE_OWF);
    static final int CALG_AES_128 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_AES_128);
    static final int CALG_AES_192 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_AES_192);
    static final int CALG_AES_256 = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_AES_256);
    static final int CALG_AES = (ALG_CLASS_DATA_ENCRYPT|ALG_TYPE_BLOCK|ALG_SID_AES);
    static final int CALG_SHA_256 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA_256);
    static final int CALG_SHA_384 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA_384);
    static final int CALG_SHA_512 = (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA_512);
    static final int CRYPT_VERIFYCONTEXT = 0xF0000000;
    static final int CRYPT_NEWKEYSET = 0x00000008;
    static final int CRYPT_DELETEKEYSET = 0x00000010;
    static final int CRYPT_MACHINE_KEYSET = 0x00000020;
    static final int CRYPT_SILENT = 0x00000040;
    static final int CRYPT_EXPORTABLE = 0x00000001;
    static final int CRYPT_USER_PROTECTED = 0x00000002;
    static final int CRYPT_CREATE_SALT = 0x00000004;
    static final int CRYPT_UPDATE_KEY = 0x00000008;
    static final int CRYPT_NO_SALT = 0x00000010;
    static final int CRYPT_PREGEN = 0x00000040;
    static final int CRYPT_RECIPIENT = 0x00000010;
    static final int CRYPT_INITIATOR = 0x00000040;
    static final int CRYPT_ONLINE = 0x00000080;
    static final int CRYPT_SF = 0x00000100;
    static final int CRYPT_CREATE_IV = 0x00000200;
    static final int CRYPT_KEK = 0x00000400;
    static final int CRYPT_DATA_KEY = 0x00000800;
    static final int CRYPT_VOLATILE = 0x00001000;
    static final int CRYPT_SGCKEY = 0x00002000;
    static final int CRYPT_ARCHIVABLE = 0x00004000;
    static final int RSA1024BIT_KEY = 0x04000000;
    static final int CRYPT_SERVER = 0x00000400;
    static final int KEY_LENGTH_MASK = 0xFFFF0000;
    static final int CRYPT_Y_ONLY = 0x00000001;
    static final int CRYPT_SSL2_FALLBACK = 0x00000002;
    static final int CRYPT_DESTROYKEY = 0x00000004;
    static final int CRYPT_OAEP = 0x00000040;
    static final int CRYPT_BLOB_VER3 = 0x00000080;
    static final int CRYPT_IPSEC_HMAC_KEY = 0x00000100;
    static final int CRYPT_DECRYPT_RSA_NO_PADDING_CHECK = 0x00000020;
    static final int CRYPT_SECRETDIGEST = 0x00000001;
    static final int CRYPT_OWF_REPL_LM_HASH = 0x00000001;
    static final int CRYPT_LITTLE_ENDIAN = 0x00000001;
    static final int CRYPT_NOHASHOID = 0x00000001;
    static final int CRYPT_TYPE2_FORMAT = 0x00000002;
    static final int CRYPT_X931_FORMAT = 0x00000004;
    static final int CRYPT_MACHINE_DEFAULT = 0x00000001;
    static final int CRYPT_USER_DEFAULT = 0x00000002;
    static final int CRYPT_DELETE_DEFAULT = 0x00000004;
    static final int SIMPLEBLOB = 0x1;
    static final int PUBLICKEYBLOB = 0x6;
    static final int PRIVATEKEYBLOB = 0x7;
    static final int PLAINTEXTKEYBLOB = 0x8;
    static final int OPAQUEKEYBLOB = 0x9;
    static final int PUBLICKEYBLOBEX = 0xA;
    static final int SYMMETRICWRAPKEYBLOB = 0xB;
    static final int AT_KEYEXCHANGE = 1;
    static final int AT_SIGNATURE = 2;
    static final int CRYPT_USERDATA = 1;
    static final int KP_IV = 1;
    static final int KP_SALT = 2;
    static final int KP_PADDING = 3;
    static final int KP_MODE = 4;
    static final int KP_MODE_BITS = 5;
    static final int KP_PERMISSIONS = 6;
    static final int KP_ALGID = 7;
    static final int KP_BLOCKLEN = 8;
    static final int KP_KEYLEN = 9;
    static final int KP_SALT_EX = 10;
    static final int KP_P = 11;
    static final int KP_G = 12;
    static final int KP_Q = 13;
    static final int KP_X = 14;
    static final int KP_Y = 15;
    static final int KP_RA = 16;
    static final int KP_RB = 17;
    static final int KP_INFO = 18;
    static final int KP_EFFECTIVE_KEYLEN = 19;
    static final int KP_SCHANNEL_ALG = 20;
    static final int KP_CLIENT_RANDOM = 21;
    static final int KP_SERVER_RANDOM = 22;
    static final int KP_RP = 23;
    static final int KP_PRECOMP_MD5 = 24;
    static final int KP_PRECOMP_SHA = 25;
    static final int KP_CERTIFICATE = 26;
    static final int KP_CLEAR_KEY = 27;
    static final int KP_PUB_EX_LEN = 28;
    static final int KP_PUB_EX_VAL = 29;
    static final int KP_KEYVAL = 30;
    static final int KP_ADMIN_PIN = 31;
    static final int KP_KEYEXCHANGE_PIN = 32;
    static final int KP_SIGNATURE_PIN = 33;
    static final int KP_PREHASH = 34;
    static final int KP_ROUNDS = 35;
    static final int KP_OAEP_PARAMS = 36;
    static final int KP_CMS_KEY_INFO = 37;
    static final int KP_CMS_DH_KEY_INFO = 38;
    static final int KP_PUB_PARAMS = 39;
    static final int KP_VERIFY_PARAMS = 40;
    static final int KP_HIGHEST_VERSION = 41;
    static final int KP_GET_USE_COUNT = 42;
    static final int PKCS5_PADDING = 1;
    static final int RANDOM_PADDING = 2;
    static final int ZERO_PADDING = 3;
    static final int CRYPT_MODE_CBC = 1;
    static final int CRYPT_MODE_ECB = 2;
    static final int CRYPT_MODE_OFB = 3;
    static final int CRYPT_MODE_CFB = 4;
    static final int CRYPT_MODE_CTS = 5;
    static final int CRYPT_ENCRYPT = 0x0001;
    static final int CRYPT_DECRYPT = 0x0002;
    static final int CRYPT_EXPORT = 0x0004;
    static final int CRYPT_READ = 0x0008;
    static final int CRYPT_WRITE = 0x0010;
    static final int CRYPT_MAC = 0x0020;
    static final int CRYPT_EXPORT_KEY = 0x0040;
    static final int CRYPT_IMPORT_KEY = 0x0080;
    static final int CRYPT_ARCHIVE = 0x0100;
    static final int HP_ALGID = 0x0001;
    static final int HP_HASHVAL = 0x0002;
    static final int HP_HASHSIZE = 0x0004;
    static final int HP_HMAC_INFO = 0x0005;
    static final int HP_TLS1PRF_LABEL = 0x0006;
    static final int HP_TLS1PRF_SEED = 0x0007;
    static final int CRYPT_FAILED = FALSE;
    static final int CRYPT_SUCCEED = TRUE;
    static final int PP_ENUMALGS = 1;
    static final int PP_ENUMCONTAINERS = 2;
    static final int PP_IMPTYPE = 3;
    static final int PP_NAME = 4;
    static final int PP_VERSION = 5;
    static final int PP_CONTAINER = 6;
    static final int PP_CHANGE_PASSWORD = 7;
    static final int PP_KEYSET_SEC_DESCR = 8;
    static final int PP_CERTCHAIN = 9;
    static final int PP_KEY_TYPE_SUBTYPE = 10;
    static final int PP_PROVTYPE = 16;
    static final int PP_KEYSTORAGE = 17;
    static final int PP_APPLI_CERT = 18;
    static final int PP_SYM_KEYSIZE = 19;
    static final int PP_SESSION_KEYSIZE = 20;
    static final int PP_UI_PROMPT = 21;
    static final int PP_ENUMALGS_EX = 22;
    static final int PP_ENUMMANDROOTS = 25;
    static final int PP_ENUMELECTROOTS = 26;
    static final int PP_KEYSET_TYPE = 27;
    static final int PP_ADMIN_PIN = 31;
    static final int PP_KEYEXCHANGE_PIN = 32;
    static final int PP_SIGNATURE_PIN = 33;
    static final int PP_SIG_KEYSIZE_INC = 34;
    static final int PP_KEYX_KEYSIZE_INC = 35;
    static final int PP_UNIQUE_CONTAINER = 36;
    static final int PP_SGC_INFO = 37;
    static final int PP_USE_HARDWARE_RNG = 38;
    static final int PP_KEYSPEC = 39;
    static final int PP_ENUMEX_SIGNING_PROT = 40;
    static final int PP_CRYPT_COUNT_KEY_USE = 41;
    static final int CRYPT_FIRST = 1;
    static final int CRYPT_NEXT = 2;
    static final int CRYPT_SGC_ENUM = 4;
    static final int CRYPT_IMPL_HARDWARE = 1;
    static final int CRYPT_IMPL_SOFTWARE = 2;
    static final int CRYPT_IMPL_MIXED = 3;
    static final int CRYPT_IMPL_UNKNOWN = 4;
    static final int CRYPT_IMPL_REMOVABLE = 8;
    static final int CRYPT_SEC_DESCR = 0x00000001;
    static final int CRYPT_PSTORE = 0x00000002;
    static final int CRYPT_UI_PROMPT = 0x00000004;
    static final int CRYPT_FLAG_PCT1 = 0x0001;
    static final int CRYPT_FLAG_SSL2 = 0x0002;
    static final int CRYPT_FLAG_SSL3 = 0x0004;
    static final int CRYPT_FLAG_TLS1 = 0x0008;
    static final int CRYPT_FLAG_IPSEC = 0x0010;
    static final int CRYPT_FLAG_SIGNING = 0x0020;
    static final int CRYPT_SGC = 0x0001;
    static final int CRYPT_FASTSGC = 0x0002;
    static final int PP_CLIENT_HWND = 1;
    static final int PP_CONTEXT_INFO = 11;
    static final int PP_KEYEXCHANGE_KEYSIZE = 12;
    static final int PP_SIGNATURE_KEYSIZE = 13;
    static final int PP_KEYEXCHANGE_ALG = 14;
    static final int PP_SIGNATURE_ALG = 15;
    static final int PP_DELETEKEY = 24;
    static final int PROV_RSA_FULL = 1;
    static final int PROV_RSA_SIG = 2;
    static final int PROV_DSS = 3;
    static final int PROV_FORTEZZA = 4;
    static final int PROV_MS_EXCHANGE = 5;
    static final int PROV_SSL = 6;
    static final int PROV_RSA_SCHANNEL = 12;
    static final int PROV_DSS_DH = 13;
    static final int PROV_EC_ECDSA_SIG = 14;
    static final int PROV_EC_ECNRA_SIG = 15;
    static final int PROV_EC_ECDSA_FULL = 16;
    static final int PROV_EC_ECNRA_FULL = 17;
    static final int PROV_DH_SCHANNEL = 18;
    static final int PROV_SPYRUS_LYNKS = 20;
    static final int PROV_RNG = 21;
    static final int PROV_INTEL_SEC = 22;
    static final int PROV_REPLACE_OWF = 23;
    static final int PROV_RSA_AES = 24;
    static final int MAXUIDLEN = 64;
    static final int dwFORCE_KEY_PROTECTION_DISABLED = 0x0;
    static final int dwFORCE_KEY_PROTECTION_USER_SELECT = 0x1;
    static final int dwFORCE_KEY_PROTECTION_HIGH = 0x2;
    static final int CUR_BLOB_VERSION = 2;
    static final int SCHANNEL_MAC_KEY = 0x00000000;
    static final int SCHANNEL_ENC_KEY = 0x00000001;
    static final int INTERNATIONAL_USAGE = 0x00000001;
    static final int CERT_RDN_ANY_TYPE = 0;
    static final int CERT_RDN_ENCODED_BLOB = 1;
    static final int CERT_RDN_OCTET_STRING = 2;
    static final int CERT_RDN_NUMERIC_STRING = 3;
    static final int CERT_RDN_PRINTABLE_STRING = 4;
    static final int CERT_RDN_TELETEX_STRING = 5;
    static final int CERT_RDN_T61_STRING = 5;
    static final int CERT_RDN_VIDEOTEX_STRING = 6;
    static final int CERT_RDN_IA5_STRING = 7;
    static final int CERT_RDN_GRAPHIC_STRING = 8;
    static final int CERT_RDN_VISIBLE_STRING = 9;
    static final int CERT_RDN_ISO646_STRING = 9;
    static final int CERT_RDN_GENERAL_STRING = 10;
    static final int CERT_RDN_UNIVERSAL_STRING = 11;
    static final int CERT_RDN_INT4_STRING = 11;
    static final int CERT_RDN_BMP_STRING = 12;
    static final int CERT_RDN_UNICODE_STRING = 12;
    static final int CERT_RDN_UTF8_STRING = 13;
    static final int CERT_RDN_TYPE_MASK = 0x000000FF;
    static final int CERT_RDN_FLAGS_MASK = 0xFF000000;
    static final int CERT_RDN_ENABLE_T61_UNICODE_FLAG = 0x80000000;
    static final int CERT_RDN_ENABLE_UTF8_UNICODE_FLAG = 0x20000000;
    static final int CERT_RDN_DISABLE_CHECK_TYPE_FLAG = 0x40000000;
    static final int CERT_RDN_DISABLE_IE4_UTF8_FLAG = 0x01000000;
    static final int CERT_V1 = 0;
    static final int CERT_V2 = 1;
    static final int CERT_V3 = 2;
    static final int CERT_INFO_VERSION_FLAG = 1;
    static final int CERT_INFO_SERIAL_NUMBER_FLAG = 2;
    static final int CERT_INFO_SIGNATURE_ALGORITHM_FLAG = 3;
    static final int CERT_INFO_ISSUER_FLAG = 4;
    static final int CERT_INFO_NOT_BEFORE_FLAG = 5;
    static final int CERT_INFO_NOT_AFTER_FLAG = 6;
    static final int CERT_INFO_SUBJECT_FLAG = 7;
    static final int CERT_INFO_SUBJECT_PUBLIC_KEY_INFO_FLAG = 8;
    static final int CERT_INFO_ISSUER_UNIQUE_ID_FLAG = 9;
    static final int CERT_INFO_SUBJECT_UNIQUE_ID_FLAG = 10;
    static final int CERT_INFO_EXTENSION_FLAG = 11;
    static final int CRL_V1 = 0;
    static final int CRL_V2 = 1;
    static final int CERT_REQUEST_V1 = 0;
    static final int CERT_KEYGEN_REQUEST_V1 = 0;
    static final int CTL_V1 = 0;
    static final int CERT_ENCODING_TYPE_MASK = 0x0000FFFF;
    static final int CMSG_ENCODING_TYPE_MASK = 0xFFFF0000;
    static final int CRYPT_ASN_ENCODING = 0x00000001;
    static final int CRYPT_NDR_ENCODING = 0x00000002;
    static final int X509_ASN_ENCODING = 0x00000001;
    static final int X509_NDR_ENCODING = 0x00000002;
    static final int PKCS_7_ASN_ENCODING = 0x00010000;
    static final int PKCS_7_NDR_ENCODING = 0x00020000;
    static final int CRYPT_FORMAT_STR_MULTI_LINE = 0x0001;
    static final int CRYPT_FORMAT_STR_NO_HEX = 0x0010;
    static final int CRYPT_FORMAT_SIMPLE = 0x0001;
    static final int CRYPT_FORMAT_X509 = 0x0002;
    static final int CRYPT_FORMAT_OID = 0x0004;
    static final int CRYPT_FORMAT_RDN_SEMICOLON = 0x0100;
    static final int CRYPT_FORMAT_RDN_CRLF = 0x0200;
    static final int CRYPT_FORMAT_RDN_UNQUOTE = 0x0400;
    static final int CRYPT_FORMAT_RDN_REVERSE = 0x0800;
    static final int CRYPT_FORMAT_COMMA = 0x1000;
    static final int CRYPT_FORMAT_SEMICOLON = CRYPT_FORMAT_RDN_SEMICOLON;
    static final int CRYPT_FORMAT_CRLF = CRYPT_FORMAT_RDN_CRLF;
    static final int CRYPT_ENCODE_NO_SIGNATURE_BYTE_REVERSAL_FLAG = 0x8;
    static final int CRYPT_ENCODE_ALLOC_FLAG = 0x8000;
    static final int CRYPT_UNICODE_NAME_ENCODE_ENABLE_T61_UNICODE_FLAG = CERT_RDN_ENABLE_T61_UNICODE_FLAG;
    static final int CRYPT_UNICODE_NAME_ENCODE_ENABLE_UTF8_UNICODE_FLAG = CERT_RDN_ENABLE_UTF8_UNICODE_FLAG;
    static final int CRYPT_UNICODE_NAME_ENCODE_DISABLE_CHECK_TYPE_FLAG = CERT_RDN_DISABLE_CHECK_TYPE_FLAG;
    static final int CRYPT_SORTED_CTL_ENCODE_HASHED_SUBJECT_IDENTIFIER_FLAG = 0x10000;
    static final int CRYPT_DECODE_NOCOPY_FLAG = 0x1;
    static final int CRYPT_DECODE_TO_BE_SIGNED_FLAG = 0x2;
    static final int CRYPT_DECODE_SHARE_OID_STRING_FLAG = 0x4;
    static final int CRYPT_DECODE_NO_SIGNATURE_BYTE_REVERSAL_FLAG = 0x8;
    static final int CRYPT_DECODE_ALLOC_FLAG = 0x8000;
    static final int CRYPT_UNICODE_NAME_DECODE_DISABLE_IE4_UTF8_FLAG = CERT_RDN_DISABLE_IE4_UTF8_FLAG;
    static final int CRYPT_ENCODE_DECODE_NONE = 0;
    static final int CERT_UNICODE_RDN_ERR_INDEX_MASK = 0x3FF;
    static final int CERT_UNICODE_RDN_ERR_INDEX_SHIFT = 22;
    static final int CERT_UNICODE_ATTR_ERR_INDEX_MASK = 0x003F;
    static final int CERT_UNICODE_ATTR_ERR_INDEX_SHIFT = 16;
    static final int CERT_UNICODE_VALUE_ERR_INDEX_MASK = 0x0000FFFF;
    static final int CERT_UNICODE_VALUE_ERR_INDEX_SHIFT = 0;
    static final int CERT_DIGITAL_SIGNATURE_KEY_USAGE = 0x80;
    static final int CERT_NON_REPUDIATION_KEY_USAGE = 0x40;
    static final int CERT_KEY_ENCIPHERMENT_KEY_USAGE = 0x20;
    static final int CERT_DATA_ENCIPHERMENT_KEY_USAGE = 0x10;
    static final int CERT_KEY_AGREEMENT_KEY_USAGE = 0x08;
    static final int CERT_KEY_CERT_SIGN_KEY_USAGE = 0x04;
    static final int CERT_OFFLINE_CRL_SIGN_KEY_USAGE = 0x02;
    static final int CERT_CRL_SIGN_KEY_USAGE = 0x02;
    static final int CERT_ENCIPHER_ONLY_KEY_USAGE = 0x01;
    static final int CERT_DECIPHER_ONLY_KEY_USAGE = 0x80;
    static final int CERT_ALT_NAME_OTHER_NAME = 1;
    static final int CERT_ALT_NAME_RFC822_NAME = 2;
    static final int CERT_ALT_NAME_DNS_NAME = 3;
    static final int CERT_ALT_NAME_X400_ADDRESS = 4;
    static final int CERT_ALT_NAME_DIRECTORY_NAME = 5;
    static final int CERT_ALT_NAME_EDI_PARTY_NAME = 6;
    static final int CERT_ALT_NAME_URL = 7;
    static final int CERT_ALT_NAME_IP_ADDRESS = 8;
    static final int CERT_ALT_NAME_REGISTERED_ID = 9;
    static final int CERT_ALT_NAME_ENTRY_ERR_INDEX_MASK = 0xFF;
    static final int CERT_ALT_NAME_ENTRY_ERR_INDEX_SHIFT = 16;
    static final int CERT_ALT_NAME_VALUE_ERR_INDEX_MASK = 0x0000FFFF;
    static final int CERT_ALT_NAME_VALUE_ERR_INDEX_SHIFT = 0;
    static final int CERT_CA_SUBJECT_FLAG = 0x80;
    static final int CERT_END_ENTITY_SUBJECT_FLAG = 0x40;
    static final int CRL_REASON_UNSPECIFIED = 0;
    static final int CRL_REASON_KEY_COMPROMISE = 1;
    static final int CRL_REASON_CA_COMPROMISE = 2;
    static final int CRL_REASON_AFFILIATION_CHANGED = 3;
    static final int CRL_REASON_SUPERSEDED = 4;
    static final int CRL_REASON_CESSATION_OF_OPERATION = 5;
    static final int CRL_REASON_CERTIFICATE_HOLD = 6;
    static final int CRL_REASON_REMOVE_FROM_CRL = 8;
    static final int CRL_DIST_POINT_NO_NAME = 0;
    static final int CRL_DIST_POINT_FULL_NAME = 1;
    static final int CRL_DIST_POINT_ISSUER_RDN_NAME = 2;
    static final int CRL_REASON_UNUSED_FLAG = 0x80;
    static final int CRL_REASON_KEY_COMPROMISE_FLAG = 0x40;
    static final int CRL_REASON_CA_COMPROMISE_FLAG = 0x20;
    static final int CRL_REASON_AFFILIATION_CHANGED_FLAG = 0x10;
    static final int CRL_REASON_SUPERSEDED_FLAG = 0x08;
    static final int CRL_REASON_CESSATION_OF_OPERATION_FLAG = 0x04;
    static final int CRL_REASON_CERTIFICATE_HOLD_FLAG = 0x02;
    static final int CRL_DIST_POINT_ERR_INDEX_MASK = 0x7F;
    static final int CRL_DIST_POINT_ERR_INDEX_SHIFT = 24;
    static final int CRL_DIST_POINT_ERR_CRL_ISSUER_BIT = 0x80000000;
    static final int CROSS_CERT_DIST_POINT_ERR_INDEX_MASK = 0xFF;
    static final int CROSS_CERT_DIST_POINT_ERR_INDEX_SHIFT = 24;
    static final int CERT_EXCLUDED_SUBTREE_BIT = 0x80000000;
    static final int SORTED_CTL_EXT_HASHED_SUBJECT_IDENTIFIER_FLAG = 0x1;
    static final int CERT_DSS_R_LEN = 20;
    static final int CERT_DSS_S_LEN = 20;
    static final int CERT_DSS_SIGNATURE_LEN = (CERT_DSS_R_LEN + CERT_DSS_S_LEN);
    static final int CRYPT_X942_COUNTER_BYTE_LENGTH = 4;
    static final int CRYPT_X942_KEY_LENGTH_BYTE_LENGTH = 4;
    static final int CRYPT_RC2_40BIT_VERSION = 160;
    static final int CRYPT_RC2_56BIT_VERSION = 52;
    static final int CRYPT_RC2_64BIT_VERSION = 120;
    static final int CRYPT_RC2_128BIT_VERSION = 58;
    static final int NETSCAPE_SSL_CLIENT_AUTH_CERT_TYPE = 0x80;
    static final int NETSCAPE_SSL_SERVER_AUTH_CERT_TYPE = 0x40;
    static final int NETSCAPE_SMIME_CERT_TYPE = 0x20;
    static final int NETSCAPE_SIGN_CERT_TYPE = 0x10;
    static final int NETSCAPE_SSL_CA_CERT_TYPE = 0x04;
    static final int NETSCAPE_SMIME_CA_CERT_TYPE = 0x02;
    static final int NETSCAPE_SIGN_CA_CERT_TYPE = 0x01;
    static final int CMC_TAGGED_CERT_REQUEST_CHOICE = 1;
    static final int CMC_OTHER_INFO_NO_CHOICE = 0;
    static final int CMC_OTHER_INFO_FAIL_CHOICE = 1;
    static final int CMC_OTHER_INFO_PEND_CHOICE = 2;
    static final int CMC_STATUS_SUCCESS = 0;
    static final int CMC_STATUS_FAILED = 2;
    static final int CMC_STATUS_PENDING = 3;
    static final int CMC_STATUS_NO_SUPPORT = 4;
    static final int CMC_STATUS_CONFIRM_REQUIRED = 5;
    static final int CMC_FAIL_BAD_ALG = 0;
    static final int CMC_FAIL_BAD_MESSAGE_CHECK = 1;
    static final int CMC_FAIL_BAD_REQUEST = 2;
    static final int CMC_FAIL_BAD_TIME = 3;
    static final int CMC_FAIL_BAD_CERT_ID = 4;
    static final int CMC_FAIL_UNSUPORTED_EXT = 5;
    static final int CMC_FAIL_MUST_ARCHIVE_KEYS = 6;
    static final int CMC_FAIL_BAD_IDENTITY = 7;
    static final int CMC_FAIL_POP_REQUIRED = 8;
    static final int CMC_FAIL_POP_FAILED = 9;
    static final int CMC_FAIL_NO_KEY_REUSE = 10;
    static final int CMC_FAIL_INTERNAL_CA_ERROR = 11;
    static final int CMC_FAIL_TRY_LATER = 12;
    static final int CRYPT_INSTALL_OID_FUNC_BEFORE_FLAG = 1;
    static final int CRYPT_GET_INSTALLED_OID_FUNC_FLAG = 0x1;
    static final int CRYPT_REGISTER_FIRST_INDEX = 0;
    static final int CRYPT_REGISTER_LAST_INDEX = 0xFFFFFFFF;
    static final int CRYPT_MATCH_ANY_ENCODING_TYPE = 0xFFFFFFFF;
    static final int CRYPT_HASH_ALG_OID_GROUP_ID = 1;
    static final int CRYPT_ENCRYPT_ALG_OID_GROUP_ID = 2;
    static final int CRYPT_PUBKEY_ALG_OID_GROUP_ID = 3;
    static final int CRYPT_SIGN_ALG_OID_GROUP_ID = 4;
    static final int CRYPT_RDN_ATTR_OID_GROUP_ID = 5;
    static final int CRYPT_EXT_OR_ATTR_OID_GROUP_ID = 6;
    static final int CRYPT_ENHKEY_USAGE_OID_GROUP_ID = 7;
    static final int CRYPT_POLICY_OID_GROUP_ID = 8;
    static final int CRYPT_TEMPLATE_OID_GROUP_ID = 9;
    static final int CRYPT_LAST_OID_GROUP_ID = 9;
    static final int CRYPT_FIRST_ALG_OID_GROUP_ID = CRYPT_HASH_ALG_OID_GROUP_ID;
    static final int CRYPT_LAST_ALG_OID_GROUP_ID = CRYPT_SIGN_ALG_OID_GROUP_ID;
    static final int CRYPT_OID_INHIBIT_SIGNATURE_FORMAT_FLAG = 0x1;
    static final int CRYPT_OID_USE_PUBKEY_PARA_FOR_PKCS7_FLAG = 0x2;
    static final int CRYPT_OID_NO_NULL_ALGORITHM_PARA_FLAG = 0x4;
    static final int CRYPT_OID_INFO_OID_KEY = 1;
    static final int CRYPT_OID_INFO_NAME_KEY = 2;
    static final int CRYPT_OID_INFO_ALGID_KEY = 3;
    static final int CRYPT_OID_INFO_SIGN_KEY = 4;
    static final int CRYPT_INSTALL_OID_INFO_BEFORE_FLAG = 1;
    static final int CRYPT_LOCALIZED_NAME_ENCODING_TYPE = 0;
    static final int CMSG_DATA = 1;
    static final int CMSG_SIGNED = 2;
    static final int CMSG_ENVELOPED = 3;
    static final int CMSG_SIGNED_AND_ENVELOPED = 4;
    static final int CMSG_HASHED = 5;
    static final int CMSG_ENCRYPTED = 6;
    static final int CMSG_DATA_FLAG = (1 << CMSG_DATA);
    static final int CMSG_SIGNED_FLAG = (1 << CMSG_SIGNED);
    static final int CMSG_ENVELOPED_FLAG = (1 << CMSG_ENVELOPED);
    static final int CMSG_SIGNED_AND_ENVELOPED_FLAG = (1 << CMSG_SIGNED_AND_ENVELOPED);
    static final int CMSG_HASHED_FLAG = (1 << CMSG_HASHED);
    static final int CMSG_ENCRYPTED_FLAG = (1 << CMSG_ENCRYPTED);
    static final int CERT_ID_ISSUER_SERIAL_NUMBER = 1;
    static final int CERT_ID_KEY_IDENTIFIER = 2;
    static final int CERT_ID_SHA1_HASH = 3;
    static final int CMSG_KEY_AGREE_EPHEMERAL_KEY_CHOICE = 1;
    static final int CMSG_KEY_AGREE_STATIC_KEY_CHOICE = 2;
    static final int CMSG_MAIL_LIST_HANDLE_KEY_CHOICE = 1;
    static final int CMSG_KEY_TRANS_RECIPIENT = 1;
    static final int CMSG_KEY_AGREE_RECIPIENT = 2;
    static final int CMSG_MAIL_LIST_RECIPIENT = 3;
    static final int CMSG_SP3_COMPATIBLE_ENCRYPT_FLAG = 0x80000000;
    static final int CMSG_RC4_NO_SALT_FLAG = 0x40000000;
    static final int CMSG_INDEFINITE_LENGTH = (0xFFFFFFFF);
    static final int CMSG_BARE_CONTENT_FLAG = 0x00000001;
    static final int CMSG_LENGTH_ONLY_FLAG = 0x00000002;
    static final int CMSG_DETACHED_FLAG = 0x00000004;
    static final int CMSG_AUTHENTICATED_ATTRIBUTES_FLAG = 0x00000008;
    static final int CMSG_CONTENTS_OCTETS_FLAG = 0x00000010;
    static final int CMSG_MAX_LENGTH_FLAG = 0x00000020;
    static final int CMSG_CMS_ENCAPSULATED_CONTENT_FLAG = 0x00000040;
    static final int CMSG_CRYPT_RELEASE_CONTEXT_FLAG = 0x00008000;
    static final int CMSG_TYPE_PARAM = 1;
    static final int CMSG_CONTENT_PARAM = 2;
    static final int CMSG_BARE_CONTENT_PARAM = 3;
    static final int CMSG_INNER_CONTENT_TYPE_PARAM = 4;
    static final int CMSG_SIGNER_COUNT_PARAM = 5;
    static final int CMSG_SIGNER_INFO_PARAM = 6;
    static final int CMSG_SIGNER_CERT_INFO_PARAM = 7;
    static final int CMSG_SIGNER_HASH_ALGORITHM_PARAM = 8;
    static final int CMSG_SIGNER_AUTH_ATTR_PARAM = 9;
    static final int CMSG_SIGNER_UNAUTH_ATTR_PARAM = 10;
    static final int CMSG_CERT_COUNT_PARAM = 11;
    static final int CMSG_CERT_PARAM = 12;
    static final int CMSG_CRL_COUNT_PARAM = 13;
    static final int CMSG_CRL_PARAM = 14;
    static final int CMSG_ENVELOPE_ALGORITHM_PARAM = 15;
    static final int CMSG_RECIPIENT_COUNT_PARAM = 17;
    static final int CMSG_RECIPIENT_INDEX_PARAM = 18;
    static final int CMSG_RECIPIENT_INFO_PARAM = 19;
    static final int CMSG_HASH_ALGORITHM_PARAM = 20;
    static final int CMSG_HASH_DATA_PARAM = 21;
    static final int CMSG_COMPUTED_HASH_PARAM = 22;
    static final int CMSG_ENCRYPT_PARAM = 26;
    static final int CMSG_ENCRYPTED_DIGEST = 27;
    static final int CMSG_ENCODED_SIGNER = 28;
    static final int CMSG_ENCODED_MESSAGE = 29;
    static final int CMSG_VERSION_PARAM = 30;
    static final int CMSG_ATTR_CERT_COUNT_PARAM = 31;
    static final int CMSG_ATTR_CERT_PARAM = 32;
    static final int CMSG_CMS_RECIPIENT_COUNT_PARAM = 33;
    static final int CMSG_CMS_RECIPIENT_INDEX_PARAM = 34;
    static final int CMSG_CMS_RECIPIENT_ENCRYPTED_KEY_INDEX_PARAM = 35;
    static final int CMSG_CMS_RECIPIENT_INFO_PARAM = 36;
    static final int CMSG_UNPROTECTED_ATTR_PARAM = 37;
    static final int CMSG_SIGNER_CERT_ID_PARAM = 38;
    static final int CMSG_CMS_SIGNER_INFO_PARAM = 39;
    static final int CMSG_SIGNED_DATA_V1 = 1;
    static final int CMSG_SIGNED_DATA_V3 = 3;
    static final int CMSG_SIGNED_DATA_PKCS_1_5_VERSION = CMSG_SIGNED_DATA_V1;
    static final int CMSG_SIGNED_DATA_CMS_VERSION = CMSG_SIGNED_DATA_V3;
    static final int CMSG_SIGNER_INFO_V1 = 1;
    static final int CMSG_SIGNER_INFO_V3 = 3;
    static final int CMSG_SIGNER_INFO_PKCS_1_5_VERSION = CMSG_SIGNER_INFO_V1;
    static final int CMSG_SIGNER_INFO_CMS_VERSION = CMSG_SIGNER_INFO_V3;
    static final int CMSG_HASHED_DATA_V0 = 0;
    static final int CMSG_HASHED_DATA_V2 = 2;
    static final int CMSG_HASHED_DATA_PKCS_1_5_VERSION = CMSG_HASHED_DATA_V0;
    static final int CMSG_HASHED_DATA_CMS_VERSION = CMSG_HASHED_DATA_V2;
    static final int CMSG_ENVELOPED_DATA_V0 = 0;
    static final int CMSG_ENVELOPED_DATA_V2 = 2;
    static final int CMSG_ENVELOPED_DATA_PKCS_1_5_VERSION = CMSG_ENVELOPED_DATA_V0;
    static final int CMSG_ENVELOPED_DATA_CMS_VERSION = CMSG_ENVELOPED_DATA_V2;
    static final int CMSG_KEY_AGREE_ORIGINATOR_CERT = 1;
    static final int CMSG_KEY_AGREE_ORIGINATOR_PUBLIC_KEY = 2;
    static final int CMSG_ENVELOPED_RECIPIENT_V0 = 0;
    static final int CMSG_ENVELOPED_RECIPIENT_V2 = 2;
    static final int CMSG_ENVELOPED_RECIPIENT_V3 = 3;
    static final int CMSG_ENVELOPED_RECIPIENT_V4 = 4;
    static final int CMSG_KEY_TRANS_PKCS_1_5_VERSION = CMSG_ENVELOPED_RECIPIENT_V0;
    static final int CMSG_KEY_TRANS_CMS_VERSION = CMSG_ENVELOPED_RECIPIENT_V2;
    static final int CMSG_KEY_AGREE_VERSION = CMSG_ENVELOPED_RECIPIENT_V3;
    static final int CMSG_MAIL_LIST_VERSION = CMSG_ENVELOPED_RECIPIENT_V4;
    static final int CMSG_CTRL_VERIFY_SIGNATURE = 1;
    static final int CMSG_CTRL_DECRYPT = 2;
    static final int CMSG_CTRL_VERIFY_HASH = 5;
    static final int CMSG_CTRL_ADD_SIGNER = 6;
    static final int CMSG_CTRL_DEL_SIGNER = 7;
    static final int CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR = 8;
    static final int CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR = 9;
    static final int CMSG_CTRL_ADD_CERT = 10;
    static final int CMSG_CTRL_DEL_CERT = 11;
    static final int CMSG_CTRL_ADD_CRL = 12;
    static final int CMSG_CTRL_DEL_CRL = 13;
    static final int CMSG_CTRL_ADD_ATTR_CERT = 14;
    static final int CMSG_CTRL_DEL_ATTR_CERT = 15;
    static final int CMSG_CTRL_KEY_TRANS_DECRYPT = 16;
    static final int CMSG_CTRL_KEY_AGREE_DECRYPT = 17;
    static final int CMSG_CTRL_MAIL_LIST_DECRYPT = 18;
    static final int CMSG_CTRL_VERIFY_SIGNATURE_EX = 19;
    static final int CMSG_CTRL_ADD_CMS_SIGNER_INFO = 20;
    static final int CMSG_VERIFY_SIGNER_PUBKEY = 1;
    static final int CMSG_VERIFY_SIGNER_CERT = 2;
    static final int CMSG_VERIFY_SIGNER_CHAIN = 3;
    static final int CMSG_VERIFY_SIGNER_NULL = 4;
    static final int CMSG_CONTENT_ENCRYPT_PAD_ENCODED_LEN_FLAG = 0x00000001;
    static final int CMSG_CONTENT_ENCRYPT_FREE_PARA_FLAG = 0x00000001;
    static final int CMSG_CONTENT_ENCRYPT_RELEASE_CONTEXT_FLAG = 0x00008000;
    static final int CMSG_KEY_TRANS_ENCRYPT_FREE_PARA_FLAG = 0x00000001;
    static final int CMSG_KEY_AGREE_ENCRYPT_FREE_PARA_FLAG = 0x00000001;
    static final int CMSG_KEY_AGREE_ENCRYPT_FREE_MATERIAL_FLAG = 0x00000002;
    static final int CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_ALG_FLAG = 0x00000004;
    static final int CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_PARA_FLAG = 0x00000008;
    static final int CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_BITS_FLAG = 0x00000010;
    static final int CMSG_MAIL_LIST_ENCRYPT_FREE_PARA_FLAG = 0x00000001;
    static final int CERT_KEY_PROV_HANDLE_PROP_ID = 1;
    static final int CERT_KEY_PROV_INFO_PROP_ID = 2;
    static final int CERT_SHA1_HASH_PROP_ID = 3;
    static final int CERT_MD5_HASH_PROP_ID = 4;
    static final int CERT_HASH_PROP_ID = CERT_SHA1_HASH_PROP_ID;
    static final int CERT_KEY_CONTEXT_PROP_ID = 5;
    static final int CERT_KEY_SPEC_PROP_ID = 6;
    static final int CERT_IE30_RESERVED_PROP_ID = 7;
    static final int CERT_PUBKEY_HASH_RESERVED_PROP_ID = 8;
    static final int CERT_ENHKEY_USAGE_PROP_ID = 9;
    static final int CERT_CTL_USAGE_PROP_ID = CERT_ENHKEY_USAGE_PROP_ID;
    static final int CERT_NEXT_UPDATE_LOCATION_PROP_ID = 10;
    static final int CERT_FRIENDLY_NAME_PROP_ID = 11;
    static final int CERT_PVK_FILE_PROP_ID = 12;
    static final int CERT_DESCRIPTION_PROP_ID = 13;
    static final int CERT_ACCESS_STATE_PROP_ID = 14;
    static final int CERT_SIGNATURE_HASH_PROP_ID = 15;
    static final int CERT_SMART_CARD_DATA_PROP_ID = 16;
    static final int CERT_EFS_PROP_ID = 17;
    static final int CERT_FORTEZZA_DATA_PROP_ID = 18;
    static final int CERT_ARCHIVED_PROP_ID = 19;
    static final int CERT_KEY_IDENTIFIER_PROP_ID = 20;
    static final int CERT_AUTO_ENROLL_PROP_ID = 21;
    static final int CERT_PUBKEY_ALG_PARA_PROP_ID = 22;
    static final int CERT_CROSS_CERT_DIST_POINTS_PROP_ID = 23;
    static final int CERT_ISSUER_PUBLIC_KEY_MD5_HASH_PROP_ID = 24;
    static final int CERT_SUBJECT_PUBLIC_KEY_MD5_HASH_PROP_ID = 25;
    static final int CERT_ENROLLMENT_PROP_ID = 26;
    static final int CERT_DATE_STAMP_PROP_ID = 27;
    static final int CERT_ISSUER_SERIAL_NUMBER_MD5_HASH_PROP_ID = 28;
    static final int CERT_SUBJECT_NAME_MD5_HASH_PROP_ID = 29;
    static final int CERT_EXTENDED_ERROR_INFO_PROP_ID = 30;
    static final int CERT_RENEWAL_PROP_ID = 64;
    static final int CERT_ARCHIVED_KEY_HASH_PROP_ID = 65;
    static final int CERT_AUTO_ENROLL_RETRY_PROP_ID = 66;
    static final int CERT_AIA_URL_RETRIEVED_PROP_ID = 67;
    static final int CERT_FIRST_RESERVED_PROP_ID = 68;
    static final int CERT_LAST_RESERVED_PROP_ID = 0x00007FFF;
    static final int CERT_FIRST_USER_PROP_ID = 0x00008000;
    static final int CERT_LAST_USER_PROP_ID = 0x0000FFFF;
    static final int CERT_ACCESS_STATE_WRITE_PERSIST_FLAG = 0x1;
    static final int CERT_ACCESS_STATE_SYSTEM_STORE_FLAG = 0x2;
    static final int CERT_ACCESS_STATE_LM_SYSTEM_STORE_FLAG = 0x4;
    static final int CERT_SET_KEY_PROV_HANDLE_PROP_ID = 0x00000001;
    static final int CERT_SET_KEY_CONTEXT_PROP_ID = 0x00000001;
    static final int CERT_STORE_SIGNATURE_FLAG = 0x00000001;
    static final int CERT_STORE_TIME_VALIDITY_FLAG = 0x00000002;
    static final int CERT_STORE_REVOCATION_FLAG = 0x00000004;
    static final int CERT_STORE_NO_CRL_FLAG = 0x00010000;
    static final int CERT_STORE_NO_ISSUER_FLAG = 0x00020000;
    static final int CERT_STORE_BASE_CRL_FLAG = 0x00000100;
    static final int CERT_STORE_DELTA_CRL_FLAG = 0x00000200;
    static final int CERT_STORE_NO_CRYPT_RELEASE_FLAG = 0x00000001;
    static final int CERT_STORE_SET_LOCALIZED_NAME_FLAG = 0x00000002;
    static final int CERT_STORE_DEFER_CLOSE_UNTIL_LAST_FREE_FLAG = 0x00000004;
    static final int CERT_STORE_DELETE_FLAG = 0x00000010;
    static final int CERT_STORE_UNSAFE_PHYSICAL_FLAG = 0x00000020;
    static final int CERT_STORE_SHARE_STORE_FLAG = 0x00000040;
    static final int CERT_STORE_SHARE_CONTEXT_FLAG = 0x00000080;
    static final int CERT_STORE_MANIFOLD_FLAG = 0x00000100;
    static final int CERT_STORE_ENUM_ARCHIVED_FLAG = 0x00000200;
    static final int CERT_STORE_UPDATE_KEYID_FLAG = 0x00000400;
    static final int CERT_STORE_BACKUP_RESTORE_FLAG = 0x00000800;
    static final int CERT_STORE_READONLY_FLAG = 0x00008000;
    static final int CERT_STORE_OPEN_EXISTING_FLAG = 0x00004000;
    static final int CERT_STORE_CREATE_NEW_FLAG = 0x00002000;
    static final int CERT_STORE_MAXIMUM_ALLOWED_FLAG = 0x00001000;
    static final int CERT_SYSTEM_STORE_MASK = 0xFFFF0000;
    static final int CERT_SYSTEM_STORE_RELOCATE_FLAG = 0x80000000;
    static final int CERT_SYSTEM_STORE_UNPROTECTED_FLAG = 0x40000000;
    static final int CERT_SYSTEM_STORE_LOCATION_MASK = 0x00FF0000;
    static final int CERT_SYSTEM_STORE_LOCATION_SHIFT = 16;
    static final int CERT_SYSTEM_STORE_CURRENT_USER_ID = 1;
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE_ID = 2;
    static final int CERT_SYSTEM_STORE_CURRENT_SERVICE_ID = 4;
    static final int CERT_SYSTEM_STORE_SERVICES_ID = 5;
    static final int CERT_SYSTEM_STORE_USERS_ID = 6;
    static final int CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID = 7;
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID = 8;
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID = 9;
    static final int CERT_SYSTEM_STORE_CURRENT_USER = (CERT_SYSTEM_STORE_CURRENT_USER_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE = (CERT_SYSTEM_STORE_LOCAL_MACHINE_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_CURRENT_SERVICE = (CERT_SYSTEM_STORE_CURRENT_SERVICE_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_SERVICES = (CERT_SYSTEM_STORE_SERVICES_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_USERS = (CERT_SYSTEM_STORE_USERS_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY = (CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY = (CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE = (CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID << CERT_SYSTEM_STORE_LOCATION_SHIFT);
    static final int CERT_PROT_ROOT_DISABLE_CURRENT_USER_FLAG = 0x1;
    static final int CERT_PROT_ROOT_INHIBIT_ADD_AT_INIT_FLAG = 0x2;
    static final int CERT_PROT_ROOT_INHIBIT_PURGE_LM_FLAG = 0x4;
    static final int CERT_PROT_ROOT_DISABLE_LM_AUTH_FLAG = 0x8;
    static final int CERT_PROT_ROOT_ONLY_LM_GPT_FLAG = 0x8;
    static final int CERT_PROT_ROOT_DISABLE_NT_AUTH_REQUIRED_FLAG = 0x10;
    static final int CERT_PROT_ROOT_DISABLE_NOT_DEFINED_NAME_CONSTRAINT_FLAG = 0x20;
    static final int CERT_TRUST_PUB_ALLOW_TRUST_MASK = 0x00000003;
    static final int CERT_TRUST_PUB_ALLOW_END_USER_TRUST = 0x00000000;
    static final int CERT_TRUST_PUB_ALLOW_MACHINE_ADMIN_TRUST = 0x00000001;
    static final int CERT_TRUST_PUB_ALLOW_ENTERPRISE_ADMIN_TRUST = 0x00000002;
    static final int CERT_TRUST_PUB_CHECK_PUBLISHER_REV_FLAG = 0x00000100;
    static final int CERT_TRUST_PUB_CHECK_TIMESTAMP_REV_FLAG = 0x00000200;
    static final int CERT_AUTH_ROOT_AUTO_UPDATE_DISABLE_UNTRUSTED_ROOT_LOGGING_FLAG = 0x1;
    static final int CERT_AUTH_ROOT_AUTO_UPDATE_DISABLE_PARTIAL_CHAIN_LOGGING_FLAG = 0x2;
    static final int CERT_REGISTRY_STORE_REMOTE_FLAG = 0x10000;
    static final int CERT_REGISTRY_STORE_SERIALIZED_FLAG = 0x20000;
    static final int CERT_REGISTRY_STORE_CLIENT_GPT_FLAG = 0x80000000;
    static final int CERT_REGISTRY_STORE_LM_GPT_FLAG = 0x01000000;
    static final int CERT_REGISTRY_STORE_ROAMING_FLAG = 0x40000;
    static final int CERT_REGISTRY_STORE_MY_IE_DIRTY_FLAG = 0x80000;
    static final int CERT_FILE_STORE_COMMIT_ENABLE_FLAG = 0x10000;
    static final int CERT_LDAP_STORE_SIGN_FLAG = 0x10000;
    static final int CERT_LDAP_STORE_AREC_EXCLUSIVE_FLAG = 0x20000;
    static final int CERT_LDAP_STORE_OPENED_FLAG = 0x40000;
    static final int CERT_LDAP_STORE_UNBIND_FLAG = 0x80000;
    static final int CERT_STORE_PROV_EXTERNAL_FLAG = 0x1;
    static final int CERT_STORE_PROV_DELETED_FLAG = 0x2;
    static final int CERT_STORE_PROV_NO_PERSIST_FLAG = 0x4;
    static final int CERT_STORE_PROV_SYSTEM_STORE_FLAG = 0x8;
    static final int CERT_STORE_PROV_LM_SYSTEM_STORE_FLAG = 0x10;
    static final int CERT_STORE_PROV_CLOSE_FUNC = 0;
    static final int CERT_STORE_PROV_READ_CERT_FUNC = 1;
    static final int CERT_STORE_PROV_WRITE_CERT_FUNC = 2;
    static final int CERT_STORE_PROV_DELETE_CERT_FUNC = 3;
    static final int CERT_STORE_PROV_SET_CERT_PROPERTY_FUNC = 4;
    static final int CERT_STORE_PROV_READ_CRL_FUNC = 5;
    static final int CERT_STORE_PROV_WRITE_CRL_FUNC = 6;
    static final int CERT_STORE_PROV_DELETE_CRL_FUNC = 7;
    static final int CERT_STORE_PROV_SET_CRL_PROPERTY_FUNC = 8;
    static final int CERT_STORE_PROV_READ_CTL_FUNC = 9;
    static final int CERT_STORE_PROV_WRITE_CTL_FUNC = 10;
    static final int CERT_STORE_PROV_DELETE_CTL_FUNC = 11;
    static final int CERT_STORE_PROV_SET_CTL_PROPERTY_FUNC = 12;
    static final int CERT_STORE_PROV_CONTROL_FUNC = 13;
    static final int CERT_STORE_PROV_FIND_CERT_FUNC = 14;
    static final int CERT_STORE_PROV_FREE_FIND_CERT_FUNC = 15;
    static final int CERT_STORE_PROV_GET_CERT_PROPERTY_FUNC = 16;
    static final int CERT_STORE_PROV_FIND_CRL_FUNC = 17;
    static final int CERT_STORE_PROV_FREE_FIND_CRL_FUNC = 18;
    static final int CERT_STORE_PROV_GET_CRL_PROPERTY_FUNC = 19;
    static final int CERT_STORE_PROV_FIND_CTL_FUNC = 20;
    static final int CERT_STORE_PROV_FREE_FIND_CTL_FUNC = 21;
    static final int CERT_STORE_PROV_GET_CTL_PROPERTY_FUNC = 22;
    static final int CERT_STORE_PROV_WRITE_ADD_FLAG = 0x1;
    static final int CERT_STORE_SAVE_AS_STORE = 1;
    static final int CERT_STORE_SAVE_AS_PKCS7 = 2;
    static final int CERT_STORE_SAVE_TO_FILE = 1;
    static final int CERT_STORE_SAVE_TO_MEMORY = 2;
    static final int CERT_STORE_SAVE_TO_FILENAME_A = 3;
    static final int CERT_STORE_SAVE_TO_FILENAME_W = 4;
    static final int CERT_STORE_SAVE_TO_FILENAME = CERT_STORE_SAVE_TO_FILENAME_W;
    static final int CERT_CLOSE_STORE_FORCE_FLAG = 0x00000001;
    static final int CERT_CLOSE_STORE_CHECK_FLAG = 0x00000002;
    static final int CERT_COMPARE_MASK = 0xFFFF;
    static final int CERT_COMPARE_SHIFT = 16;
    static final int CERT_COMPARE_ANY = 0;
    static final int CERT_COMPARE_SHA1_HASH = 1;
    static final int CERT_COMPARE_NAME = 2;
    static final int CERT_COMPARE_ATTR = 3;
    static final int CERT_COMPARE_MD5_HASH = 4;
    static final int CERT_COMPARE_PROPERTY = 5;
    static final int CERT_COMPARE_PUBLIC_KEY = 6;
    static final int CERT_COMPARE_HASH = CERT_COMPARE_SHA1_HASH;
    static final int CERT_COMPARE_NAME_STR_A = 7;
    static final int CERT_COMPARE_NAME_STR_W = 8;
    static final int CERT_COMPARE_KEY_SPEC = 9;
    static final int CERT_COMPARE_ENHKEY_USAGE = 10;
    static final int CERT_COMPARE_CTL_USAGE = CERT_COMPARE_ENHKEY_USAGE;
    static final int CERT_COMPARE_SUBJECT_CERT = 11;
    static final int CERT_COMPARE_ISSUER_OF = 12;
    static final int CERT_COMPARE_EXISTING = 13;
    static final int CERT_COMPARE_SIGNATURE_HASH = 14;
    static final int CERT_COMPARE_KEY_IDENTIFIER = 15;
    static final int CERT_COMPARE_CERT_ID = 16;
    static final int CERT_COMPARE_CROSS_CERT_DIST_POINTS = 17;
    static final int CERT_COMPARE_PUBKEY_MD5_HASH = 18;
    static final int CERT_FIND_ANY = (CERT_COMPARE_ANY << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_SHA1_HASH = (CERT_COMPARE_SHA1_HASH << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_MD5_HASH = (CERT_COMPARE_MD5_HASH << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_SIGNATURE_HASH = (CERT_COMPARE_SIGNATURE_HASH << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_KEY_IDENTIFIER = (CERT_COMPARE_KEY_IDENTIFIER << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_HASH = CERT_FIND_SHA1_HASH;
    static final int CERT_FIND_PROPERTY = (CERT_COMPARE_PROPERTY << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_PUBLIC_KEY = (CERT_COMPARE_PUBLIC_KEY << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_SUBJECT_NAME = (CERT_COMPARE_NAME << CERT_COMPARE_SHIFT | CERT_INFO_SUBJECT_FLAG);
    static final int CERT_FIND_SUBJECT_ATTR = (CERT_COMPARE_ATTR << CERT_COMPARE_SHIFT | CERT_INFO_SUBJECT_FLAG);
    static final int CERT_FIND_ISSUER_NAME = (CERT_COMPARE_NAME << CERT_COMPARE_SHIFT | CERT_INFO_ISSUER_FLAG);
    static final int CERT_FIND_ISSUER_ATTR = (CERT_COMPARE_ATTR << CERT_COMPARE_SHIFT | CERT_INFO_ISSUER_FLAG);
    static final int CERT_FIND_SUBJECT_STR_A = (CERT_COMPARE_NAME_STR_A << CERT_COMPARE_SHIFT | CERT_INFO_SUBJECT_FLAG);
    static final int CERT_FIND_SUBJECT_STR_W = (CERT_COMPARE_NAME_STR_W << CERT_COMPARE_SHIFT | CERT_INFO_SUBJECT_FLAG);
    static final int CERT_FIND_SUBJECT_STR = CERT_FIND_SUBJECT_STR_W;
    static final int CERT_FIND_ISSUER_STR_A = (CERT_COMPARE_NAME_STR_A << CERT_COMPARE_SHIFT | CERT_INFO_ISSUER_FLAG);
    static final int CERT_FIND_ISSUER_STR_W = (CERT_COMPARE_NAME_STR_W << CERT_COMPARE_SHIFT | CERT_INFO_ISSUER_FLAG);
    static final int CERT_FIND_ISSUER_STR = CERT_FIND_ISSUER_STR_W;
    static final int CERT_FIND_KEY_SPEC = (CERT_COMPARE_KEY_SPEC << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_ENHKEY_USAGE = (CERT_COMPARE_ENHKEY_USAGE << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_CTL_USAGE = CERT_FIND_ENHKEY_USAGE;
    static final int CERT_FIND_SUBJECT_CERT = (CERT_COMPARE_SUBJECT_CERT << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_ISSUER_OF = (CERT_COMPARE_ISSUER_OF << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_EXISTING = (CERT_COMPARE_EXISTING << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_CERT_ID = (CERT_COMPARE_CERT_ID << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_CROSS_CERT_DIST_POINTS = (CERT_COMPARE_CROSS_CERT_DIST_POINTS << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_PUBKEY_MD5_HASH = (CERT_COMPARE_PUBKEY_MD5_HASH << CERT_COMPARE_SHIFT);
    static final int CERT_FIND_OPTIONAL_ENHKEY_USAGE_FLAG = 0x1;
    static final int CERT_FIND_EXT_ONLY_ENHKEY_USAGE_FLAG = 0x2;
    static final int CERT_FIND_PROP_ONLY_ENHKEY_USAGE_FLAG = 0x4;
    static final int CERT_FIND_NO_ENHKEY_USAGE_FLAG = 0x8;
    static final int CERT_FIND_OR_ENHKEY_USAGE_FLAG = 0x10;
    static final int CERT_FIND_VALID_ENHKEY_USAGE_FLAG = 0x20;
    static final int CERT_FIND_OPTIONAL_CTL_USAGE_FLAG = CERT_FIND_OPTIONAL_ENHKEY_USAGE_FLAG;
    static final int CERT_FIND_EXT_ONLY_CTL_USAGE_FLAG = CERT_FIND_EXT_ONLY_ENHKEY_USAGE_FLAG;
    static final int CERT_FIND_PROP_ONLY_CTL_USAGE_FLAG = CERT_FIND_PROP_ONLY_ENHKEY_USAGE_FLAG;
    static final int CERT_FIND_NO_CTL_USAGE_FLAG = CERT_FIND_NO_ENHKEY_USAGE_FLAG;
    static final int CERT_FIND_OR_CTL_USAGE_FLAG = CERT_FIND_OR_ENHKEY_USAGE_FLAG;
    static final int CERT_FIND_VALID_CTL_USAGE_FLAG = CERT_FIND_VALID_ENHKEY_USAGE_FLAG;
    static final int CERT_SET_PROPERTY_IGNORE_PERSIST_ERROR_FLAG = 0x80000000;
    static final int CERT_SET_PROPERTY_INHIBIT_PERSIST_FLAG = 0x40000000;
    static final int CTL_ENTRY_FROM_PROP_CHAIN_FLAG = 0x1;
    static final int CRL_FIND_ANY = 0;
    static final int CRL_FIND_ISSUED_BY = 1;
    static final int CRL_FIND_EXISTING = 2;
    static final int CRL_FIND_ISSUED_FOR = 3;
    static final int CRL_FIND_ISSUED_BY_AKI_FLAG = 0x1;
    static final int CRL_FIND_ISSUED_BY_SIGNATURE_FLAG = 0x2;
    static final int CRL_FIND_ISSUED_BY_DELTA_FLAG = 0x4;
    static final int CRL_FIND_ISSUED_BY_BASE_FLAG = 0x8;
    static final int CERT_STORE_ADD_NEW = 1;
    static final int CERT_STORE_ADD_USE_EXISTING = 2;
    static final int CERT_STORE_ADD_REPLACE_EXISTING = 3;
    static final int CERT_STORE_ADD_ALWAYS = 4;
    static final int CERT_STORE_ADD_REPLACE_EXISTING_INHERIT_PROPERTIES = 5;
    static final int CERT_STORE_ADD_NEWER = 6;
    static final int CERT_STORE_ADD_NEWER_INHERIT_PROPERTIES = 7;
    static final int CERT_STORE_CERTIFICATE_CONTEXT = 1;
    static final int CERT_STORE_CRL_CONTEXT = 2;
    static final int CERT_STORE_CTL_CONTEXT = 3;
    static final int CERT_STORE_CERTIFICATE_CONTEXT_FLAG = (1 << CERT_STORE_CERTIFICATE_CONTEXT);
    static final int CERT_STORE_CRL_CONTEXT_FLAG = (1 << CERT_STORE_CRL_CONTEXT);
    static final int CERT_STORE_CTL_CONTEXT_FLAG = (1 << CERT_STORE_CTL_CONTEXT);
    static final int CTL_ANY_SUBJECT_TYPE = 1;
    static final int CTL_CERT_SUBJECT_TYPE = 2;
    static final int CTL_FIND_ANY = 0;
    static final int CTL_FIND_SHA1_HASH = 1;
    static final int CTL_FIND_MD5_HASH = 2;
    static final int CTL_FIND_USAGE = 3;
    static final int CTL_FIND_SUBJECT = 4;
    static final int CTL_FIND_EXISTING = 5;
    static final int CTL_FIND_NO_LIST_ID_CBDATA = 0xFFFFFFFF;
    static final int CTL_FIND_SAME_USAGE_FLAG = 0x1;
    static final int CERT_STORE_CTRL_RESYNC = 1;
    static final int CERT_STORE_CTRL_NOTIFY_CHANGE = 2;
    static final int CERT_STORE_CTRL_COMMIT = 3;
    static final int CERT_STORE_CTRL_AUTO_RESYNC = 4;
    static final int CERT_STORE_CTRL_CANCEL_NOTIFY = 5;
    static final int CERT_STORE_CTRL_INHIBIT_DUPLICATE_HANDLE_FLAG = 0x1;
    static final int CERT_STORE_CTRL_COMMIT_FORCE_FLAG = 0x1;
    static final int CERT_STORE_CTRL_COMMIT_CLEAR_FLAG = 0x2;
    static final int CERT_STORE_LOCALIZED_NAME_PROP_ID = 0x1000;
    static final int CERT_CREATE_CONTEXT_NOCOPY_FLAG = 0x1;
    static final int CERT_CREATE_CONTEXT_SORTED_FLAG = 0x2;
    static final int CERT_CREATE_CONTEXT_NO_HCRYPTMSG_FLAG = 0x4;
    static final int CERT_CREATE_CONTEXT_NO_ENTRY_FLAG = 0x8;
    static final int CERT_PHYSICAL_STORE_ADD_ENABLE_FLAG = 0x1;
    static final int CERT_PHYSICAL_STORE_OPEN_DISABLE_FLAG = 0x2;
    static final int CERT_PHYSICAL_STORE_REMOTE_OPEN_DISABLE_FLAG = 0x4;
    static final int CERT_PHYSICAL_STORE_INSERT_COMPUTER_NAME_ENABLE_FLAG = 0x8;
    static final int CERT_PHYSICAL_STORE_PREDEFINED_ENUM_FLAG = 0x1;
    static final int CMSG_TRUSTED_SIGNER_FLAG = 0x1;
    static final int CMSG_SIGNER_ONLY_FLAG = 0x2;
    static final int CMSG_USE_SIGNER_INDEX_FLAG = 0x4;
    static final int CMSG_CMS_ENCAPSULATED_CTL_FLAG = 0x00008000;
    static final int CMSG_ENCODE_SORTED_CTL_FLAG = 0x1;
    static final int CMSG_ENCODE_HASHED_SUBJECT_IDENTIFIER_FLAG = 0x2;
    static final int CERT_VERIFY_INHIBIT_CTL_UPDATE_FLAG = 0x1;
    static final int CERT_VERIFY_TRUSTED_SIGNERS_FLAG = 0x2;
    static final int CERT_VERIFY_NO_TIME_CHECK_FLAG = 0x4;
    static final int CERT_VERIFY_ALLOW_MORE_USAGE_FLAG = 0x8;
    static final int CERT_VERIFY_UPDATED_CTL_FLAG = 0x1;
    static final int CERT_CONTEXT_REVOCATION_TYPE = 1;
    static final int CERT_VERIFY_REV_CHAIN_FLAG = 0x00000001;
    static final int CERT_VERIFY_CACHE_ONLY_BASED_REVOCATION = 0x00000002;
    static final int CERT_VERIFY_REV_ACCUMULATIVE_TIMEOUT_FLAG = 0x00000004;
    static final int CERT_UNICODE_IS_RDN_ATTRS_FLAG = 0x1;
    static final int CERT_CASE_INSENSITIVE_IS_RDN_ATTRS_FLAG = 0x2;
    static final int CRYPT_VERIFY_CERT_SIGN_SUBJECT_BLOB = 1;
    static final int CRYPT_VERIFY_CERT_SIGN_SUBJECT_CERT = 2;
    static final int CRYPT_VERIFY_CERT_SIGN_SUBJECT_CRL = 3;
    static final int CRYPT_VERIFY_CERT_SIGN_ISSUER_PUBKEY = 1;
    static final int CRYPT_VERIFY_CERT_SIGN_ISSUER_CERT = 2;
    static final int CRYPT_VERIFY_CERT_SIGN_ISSUER_CHAIN = 3;
    static final int CRYPT_VERIFY_CERT_SIGN_ISSUER_NULL = 4;
    static final int CRYPT_DEFAULT_CONTEXT_AUTO_RELEASE_FLAG = 0x00000001;
    static final int CRYPT_DEFAULT_CONTEXT_PROCESS_FLAG = 0x00000002;
    static final int CRYPT_DEFAULT_CONTEXT_CERT_SIGN_OID = 1;
    static final int CRYPT_DEFAULT_CONTEXT_MULTI_CERT_SIGN_OID = 2;
    static final int CRYPT_ACQUIRE_CACHE_FLAG = 0x00000001;
    static final int CRYPT_ACQUIRE_USE_PROV_INFO_FLAG = 0x00000002;
    static final int CRYPT_ACQUIRE_COMPARE_KEY_FLAG = 0x00000004;
    static final int CRYPT_ACQUIRE_SILENT_FLAG = 0x00000040;
    static final int CRYPT_FIND_USER_KEYSET_FLAG = 0x00000001;
    static final int CRYPT_FIND_MACHINE_KEYSET_FLAG = 0x00000002;
    static final int CRYPT_FIND_SILENT_KEYSET_FLAG = 0x00000040;
    static final int CRYPT_DELETE_KEYSET = 0x0001;
    static final int CERT_SIMPLE_NAME_STR = 1;
    static final int CERT_OID_NAME_STR = 2;
    static final int CERT_X500_NAME_STR = 3;
    static final int CERT_NAME_STR_SEMICOLON_FLAG = 0x40000000;
    static final int CERT_NAME_STR_NO_PLUS_FLAG = 0x20000000;
    static final int CERT_NAME_STR_NO_QUOTING_FLAG = 0x10000000;
    static final int CERT_NAME_STR_CRLF_FLAG = 0x08000000;
    static final int CERT_NAME_STR_COMMA_FLAG = 0x04000000;
    static final int CERT_NAME_STR_REVERSE_FLAG = 0x02000000;
    static final int CERT_NAME_STR_DISABLE_IE4_UTF8_FLAG = 0x00010000;
    static final int CERT_NAME_STR_ENABLE_T61_UNICODE_FLAG = 0x00020000;
    static final int CERT_NAME_STR_ENABLE_UTF8_UNICODE_FLAG = 0x00040000;
    static final int CERT_NAME_EMAIL_TYPE = 1;
    static final int CERT_NAME_RDN_TYPE = 2;
    static final int CERT_NAME_ATTR_TYPE = 3;
    static final int CERT_NAME_SIMPLE_DISPLAY_TYPE = 4;
    static final int CERT_NAME_FRIENDLY_DISPLAY_TYPE = 5;
    static final int CERT_NAME_DNS_TYPE = 6;
    static final int CERT_NAME_URL_TYPE = 7;
    static final int CERT_NAME_UPN_TYPE = 8;
    static final int CERT_NAME_ISSUER_FLAG = 0x1;
    static final int CERT_NAME_DISABLE_IE4_UTF8_FLAG = 0x00010000;
    static final int CRYPT_MESSAGE_BARE_CONTENT_OUT_FLAG = 0x00000001;
    static final int CRYPT_MESSAGE_ENCAPSULATED_CONTENT_OUT_FLAG = 0x00000002;
    static final int CRYPT_MESSAGE_KEYID_SIGNER_FLAG = 0x00000004;
    static final int CRYPT_MESSAGE_SILENT_KEYSET_FLAG = 0x00000040;
    static final int CRYPT_MESSAGE_KEYID_RECIPIENT_FLAG = 0x4;
    static final int CERT_QUERY_OBJECT_FILE = 0x00000001;
    static final int CERT_QUERY_OBJECT_BLOB = 0x00000002;
    static final int CERT_QUERY_CONTENT_CERT = 1;
    static final int CERT_QUERY_CONTENT_CTL = 2;
    static final int CERT_QUERY_CONTENT_CRL = 3;
    static final int CERT_QUERY_CONTENT_SERIALIZED_STORE = 4;
    static final int CERT_QUERY_CONTENT_SERIALIZED_CERT = 5;
    static final int CERT_QUERY_CONTENT_SERIALIZED_CTL = 6;
    static final int CERT_QUERY_CONTENT_SERIALIZED_CRL = 7;
    static final int CERT_QUERY_CONTENT_PKCS7_SIGNED = 8;
    static final int CERT_QUERY_CONTENT_PKCS7_UNSIGNED = 9;
    static final int CERT_QUERY_CONTENT_PKCS7_SIGNED_EMBED = 10;
    static final int CERT_QUERY_CONTENT_PKCS10 = 11;
    static final int CERT_QUERY_CONTENT_PFX = 12;
    static final int CERT_QUERY_CONTENT_CERT_PAIR = 13;
    static final int CERT_QUERY_CONTENT_FLAG_CERT = ( 1 << CERT_QUERY_CONTENT_CERT);
    static final int CERT_QUERY_CONTENT_FLAG_CTL = ( 1 << CERT_QUERY_CONTENT_CTL);
    static final int CERT_QUERY_CONTENT_FLAG_CRL = ( 1 << CERT_QUERY_CONTENT_CRL);
    static final int CERT_QUERY_CONTENT_FLAG_SERIALIZED_STORE = ( 1 << CERT_QUERY_CONTENT_SERIALIZED_STORE);
    static final int CERT_QUERY_CONTENT_FLAG_SERIALIZED_CERT = ( 1 << CERT_QUERY_CONTENT_SERIALIZED_CERT);
    static final int CERT_QUERY_CONTENT_FLAG_SERIALIZED_CTL = ( 1 << CERT_QUERY_CONTENT_SERIALIZED_CTL);
    static final int CERT_QUERY_CONTENT_FLAG_SERIALIZED_CRL = ( 1 << CERT_QUERY_CONTENT_SERIALIZED_CRL);
    static final int CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED = ( 1 << CERT_QUERY_CONTENT_PKCS7_SIGNED);
    static final int CERT_QUERY_CONTENT_FLAG_PKCS7_UNSIGNED = ( 1 << CERT_QUERY_CONTENT_PKCS7_UNSIGNED);
    static final int CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED_EMBED = ( 1 << CERT_QUERY_CONTENT_PKCS7_SIGNED_EMBED);
    static final int CERT_QUERY_CONTENT_FLAG_PKCS10 = ( 1 << CERT_QUERY_CONTENT_PKCS10);
    static final int CERT_QUERY_CONTENT_FLAG_PFX = ( 1 << CERT_QUERY_CONTENT_PFX);
    static final int CERT_QUERY_CONTENT_FLAG_CERT_PAIR = ( 1 << CERT_QUERY_CONTENT_CERT_PAIR);
    static final int CERT_QUERY_CONTENT_FLAG_ALL = CERT_QUERY_CONTENT_FLAG_CERT | CERT_QUERY_CONTENT_FLAG_CTL | CERT_QUERY_CONTENT_FLAG_CRL | CERT_QUERY_CONTENT_FLAG_SERIALIZED_STORE | CERT_QUERY_CONTENT_FLAG_SERIALIZED_CERT | CERT_QUERY_CONTENT_FLAG_SERIALIZED_CTL | CERT_QUERY_CONTENT_FLAG_SERIALIZED_CRL | CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED | CERT_QUERY_CONTENT_FLAG_PKCS7_UNSIGNED | CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED_EMBED | CERT_QUERY_CONTENT_FLAG_PKCS10 | CERT_QUERY_CONTENT_FLAG_PFX | CERT_QUERY_CONTENT_FLAG_CERT_PAIR;
    static final int CERT_QUERY_FORMAT_BINARY = 1;
    static final int CERT_QUERY_FORMAT_BASE64_ENCODED = 2;
    static final int CERT_QUERY_FORMAT_ASN_ASCII_HEX_ENCODED = 3;
    static final int CERT_QUERY_FORMAT_FLAG_BINARY = ( 1 << CERT_QUERY_FORMAT_BINARY);
    static final int CERT_QUERY_FORMAT_FLAG_BASE64_ENCODED = ( 1 << CERT_QUERY_FORMAT_BASE64_ENCODED);
    static final int CERT_QUERY_FORMAT_FLAG_ASN_ASCII_HEX_ENCODED = ( 1 << CERT_QUERY_FORMAT_ASN_ASCII_HEX_ENCODED);
    static final int CERT_QUERY_FORMAT_FLAG_ALL = CERT_QUERY_FORMAT_FLAG_BINARY | CERT_QUERY_FORMAT_FLAG_BASE64_ENCODED | CERT_QUERY_FORMAT_FLAG_ASN_ASCII_HEX_ENCODED;
    static final int CRYPT_RETRIEVE_MULTIPLE_OBJECTS = 0x00000001;
    static final int CRYPT_CACHE_ONLY_RETRIEVAL = 0x00000002;
    static final int CRYPT_WIRE_ONLY_RETRIEVAL = 0x00000004;
    static final int CRYPT_DONT_CACHE_RESULT = 0x00000008;
    static final int CRYPT_ASYNC_RETRIEVAL = 0x00000010;
    static final int CRYPT_STICKY_CACHE_RETRIEVAL = 0x00001000;
    static final int CRYPT_LDAP_SCOPE_BASE_ONLY_RETRIEVAL = 0x00002000;
    static final int CRYPT_OFFLINE_CHECK_RETRIEVAL = 0x00004000;
    static final int CRYPT_LDAP_INSERT_ENTRY_ATTRIBUTE = 0x00008000;
    static final int CRYPT_LDAP_SIGN_RETRIEVAL = 0x00010000;
    static final int CRYPT_NO_AUTH_RETRIEVAL = 0x00020000;
    static final int CRYPT_LDAP_AREC_EXCLUSIVE_RETRIEVAL = 0x00040000;
    static final int CRYPT_AIA_RETRIEVAL = 0x00080000;
    static final int CRYPT_VERIFY_CONTEXT_SIGNATURE = 0x00000020;
    static final int CRYPT_VERIFY_DATA_HASH = 0x00000040;
    static final int CRYPT_KEEP_TIME_VALID = 0x00000080;
    static final int CRYPT_DONT_VERIFY_SIGNATURE = 0x00000100;
    static final int CRYPT_DONT_CHECK_TIME_VALIDITY = 0x00000200;
    static final int CRYPT_CHECK_FRESHNESS_TIME_VALIDITY = 0x00000400;
    static final int CRYPT_ACCUMULATIVE_TIMEOUT = 0x00000800;
    static final int CRYPT_GET_URL_FROM_PROPERTY = 0x00000001;
    static final int CRYPT_GET_URL_FROM_EXTENSION = 0x00000002;
    static final int CRYPT_GET_URL_FROM_UNAUTH_ATTRIBUTE = 0x00000004;
    static final int CRYPT_GET_URL_FROM_AUTH_ATTRIBUTE = 0x00000008;
    static final int CRYPTPROTECT_PROMPT_ON_UNPROTECT = 0x1;
    static final int CRYPTPROTECT_PROMPT_ON_PROTECT = 0x2;
    static final int CRYPTPROTECT_PROMPT_RESERVED = 0x04;
    static final int CRYPTPROTECT_PROMPT_STRONG = 0x08;
    static final int CRYPTPROTECT_PROMPT_REQUIRE_STRONG = 0x10;
    static final int CRYPTPROTECT_UI_FORBIDDEN = 0x1;
    static final int CRYPTPROTECT_LOCAL_MACHINE = 0x4;
    static final int CRYPTPROTECT_CRED_SYNC = 0x8;
    static final int CRYPTPROTECT_AUDIT = 0x10;
    static final int CRYPTPROTECT_NO_RECOVERY = 0x20;
    static final int CRYPTPROTECT_VERIFY_PROTECTION = 0x40;
    static final int CRYPTPROTECT_CRED_REGENERATE = 0x80;
    static final int CRYPTPROTECT_FIRST_RESERVED_FLAGVAL = 0x0FFFFFFF;
    static final int CRYPTPROTECT_LAST_RESERVED_FLAGVAL = 0xFFFFFFFF;
    static final int CRYPTPROTECTMEMORY_BLOCK_SIZE = 16;
    static final int CRYPTPROTECTMEMORY_SAME_PROCESS = 0x00;
    static final int CRYPTPROTECTMEMORY_CROSS_PROCESS = 0x01;
    static final int CRYPTPROTECTMEMORY_SAME_LOGON = 0x02;
    static final int CERT_CREATE_SELFSIGN_NO_SIGN = 1;
    static final int CERT_CREATE_SELFSIGN_NO_KEY_INFO = 2;
    static final int CRYPT_KEYID_MACHINE_FLAG = 0x00000020;
    static final int CRYPT_KEYID_ALLOC_FLAG = 0x00008000;
    static final int CRYPT_KEYID_DELETE_FLAG = 0x00000010;
    static final int CRYPT_KEYID_SET_NEW_FLAG = 0x00002000;
    static final int CERT_CHAIN_MAX_AIA_URL_COUNT_IN_CERT_DEFAULT = 5;
    static final int CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_COUNT_PER_CHAIN_DEFAULT = 10;
    static final int CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_BYTE_COUNT_DEFAULT = 100000;
    static final int CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_CERT_COUNT_DEFAULT = 10;
    static final int CERT_CHAIN_CACHE_END_CERT = 0x00000001;
    static final int CERT_CHAIN_THREAD_STORE_SYNC = 0x00000002;
    static final int CERT_CHAIN_CACHE_ONLY_URL_RETRIEVAL = 0x00000004;
    static final int CERT_CHAIN_USE_LOCAL_MACHINE_STORE = 0x00000008;
    static final int CERT_CHAIN_ENABLE_CACHE_AUTO_UPDATE = 0x00000010;
    static final int CERT_CHAIN_ENABLE_SHARE_STORE = 0x00000020;
    static final int CERT_TRUST_NO_ERROR = 0x00000000;
    static final int CERT_TRUST_IS_NOT_TIME_VALID = 0x00000001;
    static final int CERT_TRUST_IS_NOT_TIME_NESTED = 0x00000002;
    static final int CERT_TRUST_IS_REVOKED = 0x00000004;
    static final int CERT_TRUST_IS_NOT_SIGNATURE_VALID = 0x00000008;
    static final int CERT_TRUST_IS_NOT_VALID_FOR_USAGE = 0x00000010;
    static final int CERT_TRUST_IS_UNTRUSTED_ROOT = 0x00000020;
    static final int CERT_TRUST_REVOCATION_STATUS_UNKNOWN = 0x00000040;
    static final int CERT_TRUST_IS_CYCLIC = 0x00000080;
    static final int CERT_TRUST_INVALID_EXTENSION = 0x00000100;
    static final int CERT_TRUST_INVALID_POLICY_CONSTRAINTS = 0x00000200;
    static final int CERT_TRUST_INVALID_BASIC_CONSTRAINTS = 0x00000400;
    static final int CERT_TRUST_INVALID_NAME_CONSTRAINTS = 0x00000800;
    static final int CERT_TRUST_HAS_NOT_SUPPORTED_NAME_CONSTRAINT = 0x00001000;
    static final int CERT_TRUST_HAS_NOT_DEFINED_NAME_CONSTRAINT = 0x00002000;
    static final int CERT_TRUST_HAS_NOT_PERMITTED_NAME_CONSTRAINT = 0x00004000;
    static final int CERT_TRUST_HAS_EXCLUDED_NAME_CONSTRAINT = 0x00008000;
    static final int CERT_TRUST_IS_OFFLINE_REVOCATION = 0x01000000;
    static final int CERT_TRUST_NO_ISSUANCE_CHAIN_POLICY = 0x02000000;
    static final int CERT_TRUST_IS_PARTIAL_CHAIN = 0x00010000;
    static final int CERT_TRUST_CTL_IS_NOT_TIME_VALID = 0x00020000;
    static final int CERT_TRUST_CTL_IS_NOT_SIGNATURE_VALID = 0x00040000;
    static final int CERT_TRUST_CTL_IS_NOT_VALID_FOR_USAGE = 0x00080000;
    static final int CERT_TRUST_HAS_EXACT_MATCH_ISSUER = 0x00000001;
    static final int CERT_TRUST_HAS_KEY_MATCH_ISSUER = 0x00000002;
    static final int CERT_TRUST_HAS_NAME_MATCH_ISSUER = 0x00000004;
    static final int CERT_TRUST_IS_SELF_SIGNED = 0x00000008;
    static final int CERT_TRUST_HAS_PREFERRED_ISSUER = 0x00000100;
    static final int CERT_TRUST_HAS_ISSUANCE_CHAIN_POLICY = 0x00000200;
    static final int CERT_TRUST_HAS_VALID_NAME_CONSTRAINTS = 0x00000400;
    static final int CERT_TRUST_IS_COMPLEX_CHAIN = 0x00010000;
    static final int USAGE_MATCH_TYPE_AND = 0x00000000;
    static final int USAGE_MATCH_TYPE_OR = 0x00000001;
    static final int CERT_CHAIN_REVOCATION_CHECK_END_CERT = 0x10000000;
    static final int CERT_CHAIN_REVOCATION_CHECK_CHAIN = 0x20000000;
    static final int CERT_CHAIN_REVOCATION_CHECK_CHAIN_EXCLUDE_ROOT = 0x40000000;
    static final int CERT_CHAIN_REVOCATION_CHECK_CACHE_ONLY = 0x80000000;
    static final int CERT_CHAIN_REVOCATION_ACCUMULATIVE_TIMEOUT = 0x08000000;
    static final int CERT_CHAIN_DISABLE_PASS1_QUALITY_FILTERING = 0x00000040;
    static final int CERT_CHAIN_RETURN_LOWER_QUALITY_CONTEXTS = 0x00000080;
    static final int CERT_CHAIN_DISABLE_AUTH_ROOT_AUTO_UPDATE = 0x00000100;
    static final int CERT_CHAIN_TIMESTAMP_TIME = 0x00000200;
    static final int CERT_CHAIN_FIND_BY_ISSUER = 1;
    static final int CERT_CHAIN_FIND_BY_ISSUER_COMPARE_KEY_FLAG = 0x0001;
    static final int CERT_CHAIN_FIND_BY_ISSUER_COMPLEX_CHAIN_FLAG = 0x0002;
    static final int CERT_CHAIN_FIND_BY_ISSUER_CACHE_ONLY_URL_FLAG = 0x0004;
    static final int CERT_CHAIN_FIND_BY_ISSUER_LOCAL_MACHINE_FLAG = 0x0008;
    static final int CERT_CHAIN_FIND_BY_ISSUER_NO_KEY_FLAG = 0x4000;
    static final int CERT_CHAIN_FIND_BY_ISSUER_CACHE_ONLY_FLAG = 0x8000;
    static final int CERT_CHAIN_POLICY_IGNORE_NOT_TIME_VALID_FLAG = 0x00000001;
    static final int CERT_CHAIN_POLICY_IGNORE_CTL_NOT_TIME_VALID_FLAG = 0x00000002;
    static final int CERT_CHAIN_POLICY_IGNORE_NOT_TIME_NESTED_FLAG = 0x00000004;
    static final int CERT_CHAIN_POLICY_IGNORE_INVALID_BASIC_CONSTRAINTS_FLAG = 0x00000008;
    static final int CERT_CHAIN_POLICY_IGNORE_ALL_NOT_TIME_VALID_FLAGS = ( CERT_CHAIN_POLICY_IGNORE_NOT_TIME_VALID_FLAG | CERT_CHAIN_POLICY_IGNORE_CTL_NOT_TIME_VALID_FLAG | CERT_CHAIN_POLICY_IGNORE_NOT_TIME_NESTED_FLAG );
    static final int CERT_CHAIN_POLICY_ALLOW_UNKNOWN_CA_FLAG = 0x00000010;
    static final int CERT_CHAIN_POLICY_IGNORE_WRONG_USAGE_FLAG = 0x00000020;
    static final int CERT_CHAIN_POLICY_IGNORE_INVALID_NAME_FLAG = 0x00000040;
    static final int CERT_CHAIN_POLICY_IGNORE_INVALID_POLICY_FLAG = 0x00000080;
    static final int CERT_CHAIN_POLICY_IGNORE_END_REV_UNKNOWN_FLAG = 0x00000100;
    static final int CERT_CHAIN_POLICY_IGNORE_CTL_SIGNER_REV_UNKNOWN_FLAG = 0x00000200;
    static final int CERT_CHAIN_POLICY_IGNORE_CA_REV_UNKNOWN_FLAG = 0x00000400;
    static final int CERT_CHAIN_POLICY_IGNORE_ROOT_REV_UNKNOWN_FLAG = 0x00000800;
    static final int CERT_CHAIN_POLICY_IGNORE_ALL_REV_UNKNOWN_FLAGS = ( CERT_CHAIN_POLICY_IGNORE_END_REV_UNKNOWN_FLAG | CERT_CHAIN_POLICY_IGNORE_CTL_SIGNER_REV_UNKNOWN_FLAG | CERT_CHAIN_POLICY_IGNORE_CA_REV_UNKNOWN_FLAG | CERT_CHAIN_POLICY_IGNORE_ROOT_REV_UNKNOWN_FLAG );
    static final int CERT_CHAIN_POLICY_ALLOW_TESTROOT_FLAG = 0x00008000;
    static final int CERT_CHAIN_POLICY_TRUST_TESTROOT_FLAG = 0x00004000;
    static final int AUTHTYPE_CLIENT = 1;
    static final int AUTHTYPE_SERVER = 2;
    static final int BASIC_CONSTRAINTS_CERT_CHAIN_POLICY_CA_FLAG = 0x80000000;
    static final int BASIC_CONSTRAINTS_CERT_CHAIN_POLICY_END_ENTITY_FLAG = 0x40000000;
    static final int MICROSOFT_ROOT_CERT_CHAIN_POLICY_ENABLE_TEST_ROOT_FLAG = 0x00010000;
    static final int CRYPT_STRING_BASE64HEADER = 0x00000000;
    static final int CRYPT_STRING_BASE64 = 0x00000001;
    static final int CRYPT_STRING_BINARY = 0x00000002;
    static final int CRYPT_STRING_BASE64REQUESTHEADER = 0x00000003;
    static final int CRYPT_STRING_HEX = 0x00000004;
    static final int CRYPT_STRING_HEXASCII = 0x00000005;
    static final int CRYPT_STRING_BASE64_ANY = 0x00000006;
    static final int CRYPT_STRING_ANY = 0x00000007;
    static final int CRYPT_STRING_HEX_ANY = 0x00000008;
    static final int CRYPT_STRING_BASE64X509CRLHEADER = 0x00000009;
    static final int CRYPT_STRING_HEXADDR = 0x0000000a;
    static final int CRYPT_STRING_HEXASCIIADDR = 0x0000000b;
    static final int CRYPT_STRING_NOCR = 0x80000000;
    static final int CRYPT_USER_KEYSET = 0x00001000;
    static final int PKCS12_IMPORT_RESERVED_MASK = 0xffff0000;
    static final int REPORT_NO_PRIVATE_KEY = 0x0001;
    static final int REPORT_NOT_ABLE_TO_EXPORT_PRIVATE_KEY = 0x0002;
    static final int EXPORT_PRIVATE_KEYS = 0x0004;
    static final int PKCS12_EXPORT_RESERVED_MASK = 0xffff0000;
    static final int MAX_SID_SIZE = 256;
    static final int __REQUIRED_RPCNDR_H_VERSION__ = 475;
    static final int __RPCNDR_H_VERSION__ = ( 475 );
    static final int TARGET_IS_NT51_OR_LATER = 0;
    static final int TARGET_IS_NT50_OR_LATER = 1;
    static final int TARGET_IS_NT40_OR_LATER = 1;
    static final int TARGET_IS_NT351_OR_WIN95_OR_LATER = 1;
    static final int cbNDRContext = 20;
    static final int USER_CALL_IS_ASYNC = 0x0100;
    static final int USER_CALL_NEW_CORRELATION_DESC = 0x0200;
    static final int USER_MARSHAL_FC_BYTE = 1;
    static final int USER_MARSHAL_FC_CHAR = 2;
    static final int USER_MARSHAL_FC_SMALL = 3;
    static final int USER_MARSHAL_FC_USMALL = 4;
    static final int USER_MARSHAL_FC_WCHAR = 5;
    static final int USER_MARSHAL_FC_SHORT = 6;
    static final int USER_MARSHAL_FC_USHORT = 7;
    static final int USER_MARSHAL_FC_LONG = 8;
    static final int USER_MARSHAL_FC_ULONG = 9;
    static final int USER_MARSHAL_FC_FLOAT = 10;
    static final int USER_MARSHAL_FC_HYPER = 11;
    static final int USER_MARSHAL_FC_DOUBLE = 12;
    static final int ROTFLAGS_REGISTRATIONKEEPSALIVE = 0x1;
    static final int ROTFLAGS_ALLOWANYCLIENT = 0x2;
    static final int ROT_COMPARE_MAX = 2048;
    static final int WDT_INPROC_CALL = ( 0x48746457 );
    static final int WDT_REMOTE_CALL = ( 0x52746457 );
    static final int WDT_INPROC64_CALL = ( 0x50746457 );
    static final byte DECIMAL_NEG = ((byte)0x80);
    static final int FILE_DEVICE_BEEP = 0x00000001;
    static final int FILE_DEVICE_CD_ROM = 0x00000002;
    static final int FILE_DEVICE_CD_ROM_FILE_SYSTEM = 0x00000003;
    static final int FILE_DEVICE_CONTROLLER = 0x00000004;
    static final int FILE_DEVICE_DATALINK = 0x00000005;
    static final int FILE_DEVICE_DFS = 0x00000006;
    static final int FILE_DEVICE_DISK = 0x00000007;
    static final int FILE_DEVICE_DISK_FILE_SYSTEM = 0x00000008;
    static final int FILE_DEVICE_FILE_SYSTEM = 0x00000009;
    static final int FILE_DEVICE_INPORT_PORT = 0x0000000a;
    static final int FILE_DEVICE_KEYBOARD = 0x0000000b;
    static final int FILE_DEVICE_MAILSLOT = 0x0000000c;
    static final int FILE_DEVICE_MIDI_IN = 0x0000000d;
    static final int FILE_DEVICE_MIDI_OUT = 0x0000000e;
    static final int FILE_DEVICE_MOUSE = 0x0000000f;
    static final int FILE_DEVICE_MULTI_UNC_PROVIDER = 0x00000010;
    static final int FILE_DEVICE_NAMED_PIPE = 0x00000011;
    static final int FILE_DEVICE_NETWORK = 0x00000012;
    static final int FILE_DEVICE_NETWORK_BROWSER = 0x00000013;
    static final int FILE_DEVICE_NETWORK_FILE_SYSTEM = 0x00000014;
    static final int FILE_DEVICE_NULL = 0x00000015;
    static final int FILE_DEVICE_PARALLEL_PORT = 0x00000016;
    static final int FILE_DEVICE_PHYSICAL_NETCARD = 0x00000017;
    static final int FILE_DEVICE_PRINTER = 0x00000018;
    static final int FILE_DEVICE_SCANNER = 0x00000019;
    static final int FILE_DEVICE_SERIAL_MOUSE_PORT = 0x0000001a;
    static final int FILE_DEVICE_SERIAL_PORT = 0x0000001b;
    static final int FILE_DEVICE_SCREEN = 0x0000001c;
    static final int FILE_DEVICE_SOUND = 0x0000001d;
    static final int FILE_DEVICE_STREAMS = 0x0000001e;
    static final int FILE_DEVICE_TAPE = 0x0000001f;
    static final int FILE_DEVICE_TAPE_FILE_SYSTEM = 0x00000020;
    static final int FILE_DEVICE_TRANSPORT = 0x00000021;
    static final int FILE_DEVICE_UNKNOWN = 0x00000022;
    static final int FILE_DEVICE_VIDEO = 0x00000023;
    static final int FILE_DEVICE_VIRTUAL_DISK = 0x00000024;
    static final int FILE_DEVICE_WAVE_IN = 0x00000025;
    static final int FILE_DEVICE_WAVE_OUT = 0x00000026;
    static final int FILE_DEVICE_8042_PORT = 0x00000027;
    static final int FILE_DEVICE_NETWORK_REDIRECTOR = 0x00000028;
    static final int FILE_DEVICE_BATTERY = 0x00000029;
    static final int FILE_DEVICE_BUS_EXTENDER = 0x0000002a;
    static final int FILE_DEVICE_MODEM = 0x0000002b;
    static final int FILE_DEVICE_VDM = 0x0000002c;
    static final int FILE_DEVICE_MASS_STORAGE = 0x0000002d;
    static final int FILE_DEVICE_SMB = 0x0000002e;
    static final int FILE_DEVICE_KS = 0x0000002f;
    static final int FILE_DEVICE_CHANGER = 0x00000030;
    static final int FILE_DEVICE_ACPI = 0x00000032;
    static final int FILE_DEVICE_DVD = 0x00000033;
    static final int FILE_DEVICE_FULLSCREEN_VIDEO = 0x00000034;
    static final int FILE_DEVICE_DFS_FILE_SYSTEM = 0x00000035;
    static final int FILE_DEVICE_DFS_VOLUME = 0x00000036;
    static final int FILE_DEVICE_SERENUM = 0x00000037;
    static final int FILE_DEVICE_TERMSRV = 0x00000038;
    static final int FILE_DEVICE_KSEC = 0x00000039;
    static final int FILE_DEVICE_FIPS = 0x0000003A;
    static final int FILE_DEVICE_INFINIBAND = 0x0000003B;
    static final int METHOD_BUFFERED = 0;
    static final int METHOD_IN_DIRECT = 1;
    static final int METHOD_OUT_DIRECT = 2;
    static final int METHOD_NEITHER = 3;
    static final int METHOD_DIRECT_TO_HARDWARE = METHOD_OUT_DIRECT;
    static final int METHOD_DIRECT_FROM_HARDWARE = METHOD_IN_DIRECT;
    static final int FILE_ANY_ACCESS = 0;
    static final int FILE_SPECIAL_ACCESS = (FILE_ANY_ACCESS);
    static final int FILE_READ_ACCESS = ( 0x0001 );
    static final int FILE_WRITE_ACCESS = ( 0x0002 );
    static final int IOCTL_STORAGE_BASE = FILE_DEVICE_MASS_STORAGE;
    static final int RECOVERED_WRITES_VALID = 0x00000001;
    static final int UNRECOVERED_WRITES_VALID = 0x00000002;
    static final int RECOVERED_READS_VALID = 0x00000004;
    static final int UNRECOVERED_READS_VALID = 0x00000008;
    static final int WRITE_COMPRESSION_INFO_VALID = 0x00000010;
    static final int READ_COMPRESSION_INFO_VALID = 0x00000020;
    static final int TAPE_RETURN_STATISTICS = 0;
    static final int TAPE_RETURN_ENV_INFO = 1;
    static final int TAPE_RESET_STATISTICS = 2;
    static final int MEDIA_ERASEABLE = 0x00000001;
    static final int MEDIA_WRITE_ONCE = 0x00000002;
    static final int MEDIA_READ_ONLY = 0x00000004;
    static final int MEDIA_READ_WRITE = 0x00000008;
    static final int MEDIA_WRITE_PROTECTED = 0x00000100;
    static final int MEDIA_CURRENTLY_MOUNTED = 0x80000000;
    static final int IOCTL_DISK_BASE = FILE_DEVICE_DISK;
    static final int PARTITION_ENTRY_UNUSED = 0x00;
    static final int PARTITION_FAT_12 = 0x01;
    static final int PARTITION_XENIX_1 = 0x02;
    static final int PARTITION_XENIX_2 = 0x03;
    static final int PARTITION_FAT_16 = 0x04;
    static final int PARTITION_EXTENDED = 0x05;
    static final int PARTITION_HUGE = 0x06;
    static final int PARTITION_IFS = 0x07;
    static final int PARTITION_OS2BOOTMGR = 0x0A;
    static final int PARTITION_FAT32 = 0x0B;
    static final int PARTITION_FAT32_XINT13 = 0x0C;
    static final int PARTITION_XINT13 = 0x0E;
    static final int PARTITION_XINT13_EXTENDED = 0x0F;
    static final int PARTITION_PREP = 0x41;
    static final int PARTITION_LDM = 0x42;
    static final int PARTITION_UNIX = 0x63;
    static final int VALID_NTFT = 0xC0;
    static final int PARTITION_NTFT = 0x80;
    static final int GPT_ATTRIBUTE_PLATFORM_REQUIRED = (0x0000000000000001);
    static final long GPT_BASIC_DATA_ATTRIBUTE_HIDDEN = (0x4000000000000000L);
    static final long GPT_BASIC_DATA_ATTRIBUTE_READ_ONLY = (0x1000000000000000L);
    static final int HIST_NO_OF_BUCKETS = 24;
    static final int DISK_LOGGING_START = 0;
    static final int DISK_LOGGING_STOP = 1;
    static final int DISK_LOGGING_DUMP = 2;
    static final int DISK_BINNING = 3;
    static final int CAP_ATA_ID_CMD = 1;
    static final int CAP_ATAPI_ID_CMD = 2;
    static final int CAP_SMART_CMD = 4;
    static final int ATAPI_ID_CMD = 0xA1;
    static final int ID_CMD = 0xEC;
    static final int SMART_CMD = 0xB0;
    static final int SMART_CYL_LOW = 0x4F;
    static final int SMART_CYL_HI = 0xC2;
    static final int SMART_NO_ERROR = 0;
    static final int SMART_IDE_ERROR = 1;
    static final int SMART_INVALID_FLAG = 2;
    static final int SMART_INVALID_COMMAND = 3;
    static final int SMART_INVALID_BUFFER = 4;
    static final int SMART_INVALID_DRIVE = 5;
    static final int SMART_INVALID_IOCTL = 6;
    static final int SMART_ERROR_NO_MEM = 7;
    static final int SMART_INVALID_REGISTER = 8;
    static final int SMART_NOT_SUPPORTED = 9;
    static final int SMART_NO_IDE_DEVICE = 10;
    static final int SMART_OFFLINE_ROUTINE_OFFLINE = 0;
    static final int SMART_SHORT_SELFTEST_OFFLINE = 1;
    static final int SMART_EXTENDED_SELFTEST_OFFLINE = 2;
    static final int SMART_ABORT_OFFLINE_SELFTEST = 127;
    static final int SMART_SHORT_SELFTEST_CAPTIVE = 129;
    static final int SMART_EXTENDED_SELFTEST_CAPTIVE = 130;
    static final int READ_ATTRIBUTE_BUFFER_SIZE = 512;
    static final int IDENTIFY_BUFFER_SIZE = 512;
    static final int READ_THRESHOLD_BUFFER_SIZE = 512;
    static final int SMART_LOG_SECTOR_SIZE = 512;
    static final int READ_ATTRIBUTES = 0xD0;
    static final int READ_THRESHOLDS = 0xD1;
    static final int ENABLE_DISABLE_AUTOSAVE = 0xD2;
    static final int SAVE_ATTRIBUTE_VALUES = 0xD3;
    static final int EXECUTE_OFFLINE_DIAGS = 0xD4;
    static final int SMART_READ_LOG = 0xD5;
    static final int SMART_WRITE_LOG = 0xd6;
    static final int ENABLE_SMART = 0xD8;
    static final int DISABLE_SMART = 0xD9;
    static final int RETURN_SMART_STATUS = 0xDA;
    static final int ENABLE_DISABLE_AUTO_OFFLINE = 0xDB;
    static final int IOCTL_CHANGER_BASE = FILE_DEVICE_CHANGER;
    static final int MAX_VOLUME_ID_SIZE = 36;
    static final int MAX_VOLUME_TEMPLATE_SIZE = 40;
    static final int VENDOR_ID_LENGTH = 8;
    static final int PRODUCT_ID_LENGTH = 16;
    static final int REVISION_LENGTH = 4;
    static final int SERIAL_NUMBER_LENGTH = 32;
    static final int CHANGER_BAR_CODE_SCANNER_INSTALLED = 0x00000001;
    static final int CHANGER_INIT_ELEM_STAT_WITH_RANGE = 0x00000002;
    static final int CHANGER_CLOSE_IEPORT = 0x00000004;
    static final int CHANGER_OPEN_IEPORT = 0x00000008;
    static final int CHANGER_STATUS_NON_VOLATILE = 0x00000010;
    static final int CHANGER_EXCHANGE_MEDIA = 0x00000020;
    static final int CHANGER_CLEANER_SLOT = 0x00000040;
    static final int CHANGER_LOCK_UNLOCK = 0x00000080;
    static final int CHANGER_CARTRIDGE_MAGAZINE = 0x00000100;
    static final int CHANGER_MEDIUM_FLIP = 0x00000200;
    static final int CHANGER_POSITION_TO_ELEMENT = 0x00000400;
    static final int CHANGER_REPORT_IEPORT_STATE = 0x00000800;
    static final int CHANGER_STORAGE_DRIVE = 0x00001000;
    static final int CHANGER_STORAGE_IEPORT = 0x00002000;
    static final int CHANGER_STORAGE_SLOT = 0x00004000;
    static final int CHANGER_STORAGE_TRANSPORT = 0x00008000;
    static final int CHANGER_DRIVE_CLEANING_REQUIRED = 0x00010000;
    static final int CHANGER_PREDISMOUNT_EJECT_REQUIRED = 0x00020000;
    static final int CHANGER_CLEANER_ACCESS_NOT_VALID = 0x00040000;
    static final int CHANGER_PREMOUNT_EJECT_REQUIRED = 0x00080000;
    static final int CHANGER_VOLUME_IDENTIFICATION = 0x00100000;
    static final int CHANGER_VOLUME_SEARCH = 0x00200000;
    static final int CHANGER_VOLUME_ASSERT = 0x00400000;
    static final int CHANGER_VOLUME_REPLACE = 0x00800000;
    static final int CHANGER_VOLUME_UNDEFINE = 0x01000000;
    static final int CHANGER_SERIAL_NUMBER_VALID = 0x04000000;
    static final int CHANGER_DEVICE_REINITIALIZE_CAPABLE = 0x08000000;
    static final int CHANGER_KEYPAD_ENABLE_DISABLE = 0x10000000;
    static final int CHANGER_DRIVE_EMPTY_ON_DOOR_ACCESS = 0x20000000;
    static final int CHANGER_RESERVED_BIT = 0x80000000;
    static final int CHANGER_PREDISMOUNT_ALIGN_TO_SLOT = 0x80000001;
    static final int CHANGER_PREDISMOUNT_ALIGN_TO_DRIVE = 0x80000002;
    static final int CHANGER_CLEANER_AUTODISMOUNT = 0x80000004;
    static final int CHANGER_TRUE_EXCHANGE_CAPABLE = 0x80000008;
    static final int CHANGER_SLOTS_USE_TRAYS = 0x80000010;
    static final int CHANGER_RTN_MEDIA_TO_ORIGINAL_ADDR = 0x80000020;
    static final int CHANGER_CLEANER_OPS_NOT_SUPPORTED = 0x80000040;
    static final int CHANGER_IEPORT_USER_CONTROL_OPEN = 0x80000080;
    static final int CHANGER_IEPORT_USER_CONTROL_CLOSE = 0x80000100;
    static final int CHANGER_MOVE_EXTENDS_IEPORT = 0x80000200;
    static final int CHANGER_MOVE_RETRACTS_IEPORT = 0x80000400;
    static final int CHANGER_TO_TRANSPORT = 0x01;
    static final int CHANGER_TO_SLOT = 0x02;
    static final int CHANGER_TO_IEPORT = 0x04;
    static final int CHANGER_TO_DRIVE = 0x08;
    static final int LOCK_UNLOCK_IEPORT = 0x01;
    static final int LOCK_UNLOCK_DOOR = 0x02;
    static final int LOCK_UNLOCK_KEYPAD = 0x04;
    static final int LOCK_ELEMENT = 0;
    static final int UNLOCK_ELEMENT = 1;
    static final int EXTEND_IEPORT = 2;
    static final int RETRACT_IEPORT = 3;
    static final int ELEMENT_STATUS_FULL = 0x00000001;
    static final int ELEMENT_STATUS_IMPEXP = 0x00000002;
    static final int ELEMENT_STATUS_EXCEPT = 0x00000004;
    static final int ELEMENT_STATUS_ACCESS = 0x00000008;
    static final int ELEMENT_STATUS_EXENAB = 0x00000010;
    static final int ELEMENT_STATUS_INENAB = 0x00000020;
    static final int ELEMENT_STATUS_PRODUCT_DATA = 0x00000040;
    static final int ELEMENT_STATUS_LUN_VALID = 0x00001000;
    static final int ELEMENT_STATUS_ID_VALID = 0x00002000;
    static final int ELEMENT_STATUS_NOT_BUS = 0x00008000;
    static final int ELEMENT_STATUS_INVERT = 0x00400000;
    static final int ELEMENT_STATUS_SVALID = 0x00800000;
    static final int ELEMENT_STATUS_PVOLTAG = 0x10000000;
    static final int ELEMENT_STATUS_AVOLTAG = 0x20000000;
    static final int ERROR_LABEL_UNREADABLE = 0x00000001;
    static final int ERROR_LABEL_QUESTIONABLE = 0x00000002;
    static final int ERROR_SLOT_NOT_PRESENT = 0x00000004;
    static final int ERROR_DRIVE_NOT_INSTALLED = 0x00000008;
    static final int ERROR_TRAY_MALFUNCTION = 0x00000010;
    static final int ERROR_INIT_STATUS_NEEDED = 0x00000011;
    static final int ERROR_UNHANDLED_ERROR = 0xFFFFFFFF;
    static final int SEARCH_ALL = 0x0;
    static final int SEARCH_PRIMARY = 0x1;
    static final int SEARCH_ALTERNATE = 0x2;
    static final int SEARCH_ALL_NO_SEQ = 0x4;
    static final int SEARCH_PRI_NO_SEQ = 0x5;
    static final int SEARCH_ALT_NO_SEQ = 0x6;
    static final int ASSERT_PRIMARY = 0x8;
    static final int ASSERT_ALTERNATE = 0x9;
    static final int REPLACE_PRIMARY = 0xA;
    static final int REPLACE_ALTERNATE = 0xB;
    static final int UNDEFINE_PRIMARY = 0xC;
    static final int UNDEFINE_ALTERNATE = 0xD;
    static final byte SERIAL_LSRMST_ESCAPE = ((byte)0x00);
    static final byte SERIAL_LSRMST_LSR_DATA = ((byte)0x01);
    static final byte SERIAL_LSRMST_LSR_NODATA = ((byte)0x02);
    static final byte SERIAL_LSRMST_MST = ((byte)0x03);
    static final int USN_PAGE_SIZE = (0x1000);
    static final int USN_REASON_DATA_OVERWRITE = (0x00000001);
    static final int USN_REASON_DATA_EXTEND = (0x00000002);
    static final int USN_REASON_DATA_TRUNCATION = (0x00000004);
    static final int USN_REASON_NAMED_DATA_OVERWRITE = (0x00000010);
    static final int USN_REASON_NAMED_DATA_EXTEND = (0x00000020);
    static final int USN_REASON_NAMED_DATA_TRUNCATION = (0x00000040);
    static final int USN_REASON_FILE_CREATE = (0x00000100);
    static final int USN_REASON_FILE_DELETE = (0x00000200);
    static final int USN_REASON_EA_CHANGE = (0x00000400);
    static final int USN_REASON_SECURITY_CHANGE = (0x00000800);
    static final int USN_REASON_RENAME_OLD_NAME = (0x00001000);
    static final int USN_REASON_RENAME_NEW_NAME = (0x00002000);
    static final int USN_REASON_INDEXABLE_CHANGE = (0x00004000);
    static final int USN_REASON_BASIC_INFO_CHANGE = (0x00008000);
    static final int USN_REASON_HARD_LINK_CHANGE = (0x00010000);
    static final int USN_REASON_COMPRESSION_CHANGE = (0x00020000);
    static final int USN_REASON_ENCRYPTION_CHANGE = (0x00040000);
    static final int USN_REASON_OBJECT_ID_CHANGE = (0x00080000);
    static final int USN_REASON_REPARSE_POINT_CHANGE = (0x00100000);
    static final int USN_REASON_STREAM_CHANGE = (0x00200000);
    static final int USN_REASON_CLOSE = (0x80000000);
    static final int USN_DELETE_FLAG_DELETE = (0x00000001);
    static final int USN_DELETE_FLAG_NOTIFY = (0x00000002);
    static final int USN_DELETE_VALID_FLAGS = (0x00000003);
    static final int USN_SOURCE_DATA_MANAGEMENT = (0x00000001);
    static final int USN_SOURCE_AUXILIARY_DATA = (0x00000002);
    static final int USN_SOURCE_REPLICATION_MANAGEMENT = (0x00000004);
    static final int MARK_HANDLE_PROTECT_CLUSTERS = (0x00000001);
    static final int VOLUME_IS_DIRTY = (0x00000001);
    static final int VOLUME_UPGRADE_SCHEDULED = (0x00000002);
    static final int FILE_PREFETCH_TYPE_FOR_CREATE = 0x1;
    static final int FILESYSTEM_STATISTICS_TYPE_NTFS = 1;
    static final int FILESYSTEM_STATISTICS_TYPE_FAT = 2;
    static final int FILE_SET_ENCRYPTION = 0x00000001;
    static final int FILE_CLEAR_ENCRYPTION = 0x00000002;
    static final int STREAM_SET_ENCRYPTION = 0x00000003;
    static final int STREAM_CLEAR_ENCRYPTION = 0x00000004;
    static final int MAXIMUM_ENCRYPTION_VALUE = 0x00000004;
    static final int ENCRYPTION_FORMAT_DEFAULT = (0x01);
    static final int COMPRESSION_FORMAT_SPARSE = (0x4000);
    static final int COPYFILE_SIS_LINK = 0x0001;
    static final int COPYFILE_SIS_REPLACE = 0x0002;
    static final int COPYFILE_SIS_FLAGS = 0x0003;
    static final int FILE_DEVICE_SMARTCARD = 0x00000031;
    static final int SCARD_ATR_LENGTH = 33;
    static final int SCARD_PROTOCOL_UNDEFINED = 0x00000000;
    static final int SCARD_PROTOCOL_T0 = 0x00000001;
    static final int SCARD_PROTOCOL_T1 = 0x00000002;
    static final int SCARD_PROTOCOL_RAW = 0x00010000;
    static final int SCARD_PROTOCOL_Tx = (SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1);
    static final int SCARD_PROTOCOL_DEFAULT = 0x80000000;
    static final int SCARD_PROTOCOL_OPTIMAL = 0x00000000;
    static final int SCARD_POWER_DOWN = 0;
    static final int SCARD_COLD_RESET = 1;
    static final int SCARD_WARM_RESET = 2;
    static final int MAXIMUM_ATTR_STRING_LENGTH = 32;
    static final int MAXIMUM_SMARTCARD_READERS = 10;
    static final int SCARD_CLASS_VENDOR_INFO = 1;
    static final int SCARD_CLASS_COMMUNICATIONS = 2;
    static final int SCARD_CLASS_PROTOCOL = 3;
    static final int SCARD_CLASS_POWER_MGMT = 4;
    static final int SCARD_CLASS_SECURITY = 5;
    static final int SCARD_CLASS_MECHANICAL = 6;
    static final int SCARD_CLASS_VENDOR_DEFINED = 7;
    static final int SCARD_CLASS_IFD_PROTOCOL = 8;
    static final int SCARD_CLASS_ICC_STATE = 9;
    static final int SCARD_CLASS_PERF = 0x7ffe;
    static final int SCARD_CLASS_SYSTEM = 0x7fff;
    static final int SCARD_T0_HEADER_LENGTH = 7;
    static final int SCARD_T0_CMD_LENGTH = 5;
    static final int SCARD_T1_PROLOGUE_LENGTH = 3;
    static final int SCARD_T1_EPILOGUE_LENGTH = 2;
    static final int SCARD_T1_MAX_IFS = 254;
    static final int SCARD_UNKNOWN = 0;
    static final int SCARD_ABSENT = 1;
    static final int SCARD_PRESENT = 2;
    static final int SCARD_SWALLOWED = 3;
    static final int SCARD_POWERED = 4;
    static final int SCARD_NEGOTIABLE = 5;
    static final int SCARD_SPECIFIC = 6;
    static final int SCARD_READER_SWALLOWS = 0x00000001;
    static final int SCARD_READER_EJECTS = 0x00000002;
    static final int SCARD_READER_CONFISCATES = 0x00000004;
    static final int SCARD_READER_TYPE_SERIAL = 0x01;
    static final int SCARD_READER_TYPE_PARALELL = 0x02;
    static final int SCARD_READER_TYPE_KEYBOARD = 0x04;
    static final int SCARD_READER_TYPE_SCSI = 0x08;
    static final int SCARD_READER_TYPE_IDE = 0x10;
    static final int SCARD_READER_TYPE_USB = 0x20;
    static final int SCARD_READER_TYPE_PCMCIA = 0x40;
    static final int SCARD_READER_TYPE_VENDOR = 0xF0;
    static final int SCARD_SCOPE_USER = 0;
    static final int SCARD_SCOPE_TERMINAL = 1;
    static final int SCARD_SCOPE_SYSTEM = 2;
    static final int SCARD_PROVIDER_PRIMARY = 1;
    static final int SCARD_PROVIDER_CSP = 2;
    static final int SCARD_STATE_UNAWARE = 0x00000000;
    static final int SCARD_STATE_IGNORE = 0x00000001;
    static final int SCARD_STATE_CHANGED = 0x00000002;
    static final int SCARD_STATE_UNKNOWN = 0x00000004;
    static final int SCARD_STATE_UNAVAILABLE = 0x00000008;
    static final int SCARD_STATE_EMPTY = 0x00000010;
    static final int SCARD_STATE_PRESENT = 0x00000020;
    static final int SCARD_STATE_ATRMATCH = 0x00000040;
    static final int SCARD_STATE_EXCLUSIVE = 0x00000080;
    static final int SCARD_STATE_INUSE = 0x00000100;
    static final int SCARD_STATE_MUTE = 0x00000200;
    static final int SCARD_STATE_UNPOWERED = 0x00000400;
    static final int SCARD_SHARE_EXCLUSIVE = 1;
    static final int SCARD_SHARE_SHARED = 2;
    static final int SCARD_SHARE_DIRECT = 3;
    static final int SCARD_LEAVE_CARD = 0;
    static final int SCARD_RESET_CARD = 1;
    static final int SCARD_UNPOWER_CARD = 2;
    static final int SCARD_EJECT_CARD = 3;
    static final int SC_DLG_MINIMAL_UI = 0x01;
    static final int SC_DLG_NO_UI = 0x02;
    static final int SC_DLG_FORCE_UI = 0x04;
    static final int SCERR_NOCARDNAME = 0x4000;
    static final int SCERR_NOGUIDS = 0x8000;
    static final int _WIN32_IE = 0x0501;
    static final int MAXPROPPAGES = 100;
    static final int PSP_DEFAULT = 0x00000000;
    static final int PSP_DLGINDIRECT = 0x00000001;
    static final int PSP_USEHICON = 0x00000002;
    static final int PSP_USEICONID = 0x00000004;
    static final int PSP_USETITLE = 0x00000008;
    static final int PSP_RTLREADING = 0x00000010;
    static final int PSP_HASHELP = 0x00000020;
    static final int PSP_USEREFPARENT = 0x00000040;
    static final int PSP_USECALLBACK = 0x00000080;
    static final int PSP_PREMATURE = 0x00000400;
    static final int PSP_HIDEHEADER = 0x00000800;
    static final int PSP_USEHEADERTITLE = 0x00001000;
    static final int PSP_USEHEADERSUBTITLE = 0x00002000;
    static final int PSPCB_ADDREF = 0;
    static final int PSPCB_RELEASE = 1;
    static final int PSPCB_CREATE = 2;
    static final int PSH_DEFAULT = 0x00000000;
    static final int PSH_PROPTITLE = 0x00000001;
    static final int PSH_USEHICON = 0x00000002;
    static final int PSH_USEICONID = 0x00000004;
    static final int PSH_PROPSHEETPAGE = 0x00000008;
    static final int PSH_WIZARDHASFINISH = 0x00000010;
    static final int PSH_WIZARD = 0x00000020;
    static final int PSH_USEPSTARTPAGE = 0x00000040;
    static final int PSH_NOAPPLYNOW = 0x00000080;
    static final int PSH_USECALLBACK = 0x00000100;
    static final int PSH_HASHELP = 0x00000200;
    static final int PSH_MODELESS = 0x00000400;
    static final int PSH_RTLREADING = 0x00000800;
    static final int PSH_WIZARDCONTEXTHELP = 0x00001000;
    static final int PSH_WIZARD97 = 0x01000000;
    static final int PSH_WATERMARK = 0x00008000;
    static final int PSH_USEHBMWATERMARK = 0x00010000;
    static final int PSH_USEHPLWATERMARK = 0x00020000;
    static final int PSH_STRETCHWATERMARK = 0x00040000;
    static final int PSH_HEADER = 0x00080000;
    static final int PSH_USEHBMHEADER = 0x00100000;
    static final int PSH_USEPAGELANG = 0x00200000;
    static final int PSH_WIZARD_LITE = 0x00400000;
    static final int PSH_NOCONTEXTHELP = 0x02000000;
    static final int PSCB_INITIALIZED = 1;
    static final int PSCB_PRECREATE = 2;
    static final int PSNRET_NOERROR = 0;
    static final int PSNRET_INVALID = 1;
    static final int PSNRET_INVALID_NOCHANGEPAGE = 2;
    static final int PSNRET_MESSAGEHANDLED = 3;
    static final int PSM_SETCURSEL = (WM_USER + 101);
    static final int PSM_REMOVEPAGE = (WM_USER + 102);
    static final int PSM_ADDPAGE = (WM_USER + 103);
    static final int PSM_CHANGED = (WM_USER + 104);
    static final int PSM_RESTARTWINDOWS = (WM_USER + 105);
    static final int PSM_REBOOTSYSTEM = (WM_USER + 106);
    static final int PSM_CANCELTOCLOSE = (WM_USER + 107);
    static final int PSM_QUERYSIBLINGS = (WM_USER + 108);
    static final int PSM_UNCHANGED = (WM_USER + 109);
    static final int PSM_APPLY = (WM_USER + 110);
    static final int PSM_SETTITLEA = (WM_USER + 111);
    static final int PSM_SETTITLEW = (WM_USER + 120);
    static final int PSM_SETTITLE = PSM_SETTITLEA;
    static final int PSM_SETWIZBUTTONS = (WM_USER + 112);
    static final int PSWIZB_BACK = 0x00000001;
    static final int PSWIZB_NEXT = 0x00000002;
    static final int PSWIZB_FINISH = 0x00000004;
    static final int PSWIZB_DISABLEDFINISH = 0x00000008;
    static final int PSM_PRESSBUTTON = (WM_USER + 113);
    static final int PSBTN_BACK = 0;
    static final int PSBTN_NEXT = 1;
    static final int PSBTN_FINISH = 2;
    static final int PSBTN_OK = 3;
    static final int PSBTN_APPLYNOW = 4;
    static final int PSBTN_CANCEL = 5;
    static final int PSBTN_HELP = 6;
    static final int PSBTN_MAX = 6;
    static final int PSM_SETCURSELID = (WM_USER + 114);
    static final int PSM_SETFINISHTEXTA = (WM_USER + 115);
    static final int PSM_SETFINISHTEXTW = (WM_USER + 121);
    static final int PSM_SETFINISHTEXT = PSM_SETFINISHTEXTA;
    static final int PSM_GETTABCONTROL = (WM_USER + 116);
    static final int PSM_ISDIALOGMESSAGE = (WM_USER + 117);
    static final int PSM_GETCURRENTPAGEHWND = (WM_USER + 118);
    static final int PSM_INSERTPAGE = (WM_USER + 119);
    static final int PSM_SETHEADERTITLEA = (WM_USER + 125);
    static final int PSM_SETHEADERTITLEW = (WM_USER + 126);
    static final int PSM_SETHEADERTITLE = PSM_SETHEADERTITLEA;
    static final int PSM_SETHEADERSUBTITLEA = (WM_USER + 127);
    static final int PSM_SETHEADERSUBTITLEW = (WM_USER + 128);
    static final int PSM_SETHEADERSUBTITLE = PSM_SETHEADERSUBTITLEA;
    static final int PSM_HWNDTOINDEX = (WM_USER + 129);
    static final int PSM_INDEXTOHWND = (WM_USER + 130);
    static final int PSM_PAGETOINDEX = (WM_USER + 131);
    static final int PSM_INDEXTOPAGE = (WM_USER + 132);
    static final int PSM_IDTOINDEX = (WM_USER + 133);
    static final int PSM_INDEXTOID = (WM_USER + 134);
    static final int PSM_GETRESULT = (WM_USER + 135);
    static final int PSM_RECALCPAGESIZES = (WM_USER + 136);
    static final int ID_PSRESTARTWINDOWS = 0x2;
    static final int ID_PSREBOOTSYSTEM = (ID_PSRESTARTWINDOWS | 0x1);
    static final int WIZ_CXDLG = 276;
    static final int WIZ_CYDLG = 140;
    static final int WIZ_CXBMP = 80;
    static final int WIZ_BODYX = 92;
    static final int WIZ_BODYCX = 184;
    static final int PROP_SM_CXDLG = 212;
    static final int PROP_SM_CYDLG = 188;
    static final int PROP_MED_CXDLG = 227;
    static final int PROP_MED_CYDLG = 215;
    static final int PROP_LG_CXDLG = 252;
    static final int PROP_LG_CYDLG = 218;
    static final int DSPRINT_PUBLISH = 0x00000001;
    static final int DSPRINT_UPDATE = 0x00000002;
    static final int DSPRINT_UNPUBLISH = 0x00000004;
    static final int DSPRINT_REPUBLISH = 0x00000008;
    static final int DSPRINT_PENDING = 0x80000000;
    static final int PRINTER_CONTROL_PAUSE = 1;
    static final int PRINTER_CONTROL_RESUME = 2;
    static final int PRINTER_CONTROL_PURGE = 3;
    static final int PRINTER_CONTROL_SET_STATUS = 4;
    static final int PRINTER_STATUS_PAUSED = 0x00000001;
    static final int PRINTER_STATUS_ERROR = 0x00000002;
    static final int PRINTER_STATUS_PENDING_DELETION = 0x00000004;
    static final int PRINTER_STATUS_PAPER_JAM = 0x00000008;
    static final int PRINTER_STATUS_PAPER_OUT = 0x00000010;
    static final int PRINTER_STATUS_MANUAL_FEED = 0x00000020;
    static final int PRINTER_STATUS_PAPER_PROBLEM = 0x00000040;
    static final int PRINTER_STATUS_OFFLINE = 0x00000080;
    static final int PRINTER_STATUS_IO_ACTIVE = 0x00000100;
    static final int PRINTER_STATUS_BUSY = 0x00000200;
    static final int PRINTER_STATUS_PRINTING = 0x00000400;
    static final int PRINTER_STATUS_OUTPUT_BIN_FULL = 0x00000800;
    static final int PRINTER_STATUS_NOT_AVAILABLE = 0x00001000;
    static final int PRINTER_STATUS_WAITING = 0x00002000;
    static final int PRINTER_STATUS_PROCESSING = 0x00004000;
    static final int PRINTER_STATUS_INITIALIZING = 0x00008000;
    static final int PRINTER_STATUS_WARMING_UP = 0x00010000;
    static final int PRINTER_STATUS_TONER_LOW = 0x00020000;
    static final int PRINTER_STATUS_NO_TONER = 0x00040000;
    static final int PRINTER_STATUS_PAGE_PUNT = 0x00080000;
    static final int PRINTER_STATUS_USER_INTERVENTION = 0x00100000;
    static final int PRINTER_STATUS_OUT_OF_MEMORY = 0x00200000;
    static final int PRINTER_STATUS_DOOR_OPEN = 0x00400000;
    static final int PRINTER_STATUS_SERVER_UNKNOWN = 0x00800000;
    static final int PRINTER_STATUS_POWER_SAVE = 0x01000000;
    static final int PRINTER_ATTRIBUTE_QUEUED = 0x00000001;
    static final int PRINTER_ATTRIBUTE_DIRECT = 0x00000002;
    static final int PRINTER_ATTRIBUTE_DEFAULT = 0x00000004;
    static final int PRINTER_ATTRIBUTE_SHARED = 0x00000008;
    static final int PRINTER_ATTRIBUTE_NETWORK = 0x00000010;
    static final int PRINTER_ATTRIBUTE_HIDDEN = 0x00000020;
    static final int PRINTER_ATTRIBUTE_LOCAL = 0x00000040;
    static final int PRINTER_ATTRIBUTE_ENABLE_DEVQ = 0x00000080;
    static final int PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS = 0x00000100;
    static final int PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST = 0x00000200;
    static final int PRINTER_ATTRIBUTE_WORK_OFFLINE = 0x00000400;
    static final int PRINTER_ATTRIBUTE_ENABLE_BIDI = 0x00000800;
    static final int PRINTER_ATTRIBUTE_RAW_ONLY = 0x00001000;
    static final int PRINTER_ATTRIBUTE_PUBLISHED = 0x00002000;
    static final int PRINTER_ATTRIBUTE_FAX = 0x00004000;
    static final int PRINTER_ATTRIBUTE_TS = 0x00008000;
    static final int NO_PRIORITY = 0;
    static final int MAX_PRIORITY = 99;
    static final int MIN_PRIORITY = 1;
    static final int DEF_PRIORITY = 1;
    static final int JOB_CONTROL_PAUSE = 1;
    static final int JOB_CONTROL_RESUME = 2;
    static final int JOB_CONTROL_CANCEL = 3;
    static final int JOB_CONTROL_RESTART = 4;
    static final int JOB_CONTROL_DELETE = 5;
    static final int JOB_CONTROL_SENT_TO_PRINTER = 6;
    static final int JOB_CONTROL_LAST_PAGE_EJECTED = 7;
    static final int JOB_STATUS_PAUSED = 0x00000001;
    static final int JOB_STATUS_ERROR = 0x00000002;
    static final int JOB_STATUS_DELETING = 0x00000004;
    static final int JOB_STATUS_SPOOLING = 0x00000008;
    static final int JOB_STATUS_PRINTING = 0x00000010;
    static final int JOB_STATUS_OFFLINE = 0x00000020;
    static final int JOB_STATUS_PAPEROUT = 0x00000040;
    static final int JOB_STATUS_PRINTED = 0x00000080;
    static final int JOB_STATUS_DELETED = 0x00000100;
    static final int JOB_STATUS_BLOCKED_DEVQ = 0x00000200;
    static final int JOB_STATUS_USER_INTERVENTION = 0x00000400;
    static final int JOB_STATUS_RESTART = 0x00000800;
    static final int JOB_STATUS_COMPLETE = 0x00001000;
    static final int JOB_POSITION_UNSPECIFIED = 0;
    static final int DRIVER_KERNELMODE = 0x00000001;
    static final int DRIVER_USERMODE = 0x00000002;
    static final int DPD_DELETE_UNUSED_FILES = 0x00000001;
    static final int DPD_DELETE_SPECIFIC_VERSION = 0x00000002;
    static final int DPD_DELETE_ALL_FILES = 0x00000004;
    static final int APD_STRICT_UPGRADE = 0x00000001;
    static final int APD_STRICT_DOWNGRADE = 0x00000002;
    static final int APD_COPY_ALL_FILES = 0x00000004;
    static final int APD_COPY_NEW_FILES = 0x00000008;
    static final int APD_COPY_FROM_DIRECTORY = 0x00000010;
    static final int DI_CHANNEL = 1;
    static final int DI_READ_SPOOL_JOB = 3;
    static final int DI_MEMORYMAP_WRITE = 0x00000001;
    static final int FORM_USER = 0x00000000;
    static final int FORM_BUILTIN = 0x00000001;
    static final int FORM_PRINTER = 0x00000002;
    static final int NORMAL_PRINT = 0x00000000;
    static final int REVERSE_PRINT = 0x00000001;
    static final int PORT_TYPE_WRITE = 0x0001;
    static final int PORT_TYPE_READ = 0x0002;
    static final int PORT_TYPE_REDIRECTED = 0x0004;
    static final int PORT_TYPE_NET_ATTACHED = 0x0008;
    static final int PORT_STATUS_TYPE_ERROR = 1;
    static final int PORT_STATUS_TYPE_WARNING = 2;
    static final int PORT_STATUS_TYPE_INFO = 3;
    static final int PORT_STATUS_OFFLINE = 1;
    static final int PORT_STATUS_PAPER_JAM = 2;
    static final int PORT_STATUS_PAPER_OUT = 3;
    static final int PORT_STATUS_OUTPUT_BIN_FULL = 4;
    static final int PORT_STATUS_PAPER_PROBLEM = 5;
    static final int PORT_STATUS_NO_TONER = 6;
    static final int PORT_STATUS_DOOR_OPEN = 7;
    static final int PORT_STATUS_USER_INTERVENTION = 8;
    static final int PORT_STATUS_OUT_OF_MEMORY = 9;
    static final int PORT_STATUS_TONER_LOW = 10;
    static final int PORT_STATUS_WARMING_UP = 11;
    static final int PORT_STATUS_POWER_SAVE = 12;
    static final int PRINTER_ENUM_DEFAULT = 0x00000001;
    static final int PRINTER_ENUM_LOCAL = 0x00000002;
    static final int PRINTER_ENUM_CONNECTIONS = 0x00000004;
    static final int PRINTER_ENUM_FAVORITE = 0x00000004;
    static final int PRINTER_ENUM_NAME = 0x00000008;
    static final int PRINTER_ENUM_REMOTE = 0x00000010;
    static final int PRINTER_ENUM_SHARED = 0x00000020;
    static final int PRINTER_ENUM_NETWORK = 0x00000040;
    static final int PRINTER_ENUM_EXPAND = 0x00004000;
    static final int PRINTER_ENUM_CONTAINER = 0x00008000;
    static final int PRINTER_ENUM_ICONMASK = 0x00ff0000;
    static final int PRINTER_ENUM_ICON1 = 0x00010000;
    static final int PRINTER_ENUM_ICON2 = 0x00020000;
    static final int PRINTER_ENUM_ICON3 = 0x00040000;
    static final int PRINTER_ENUM_ICON4 = 0x00080000;
    static final int PRINTER_ENUM_ICON5 = 0x00100000;
    static final int PRINTER_ENUM_ICON6 = 0x00200000;
    static final int PRINTER_ENUM_ICON7 = 0x00400000;
    static final int PRINTER_ENUM_ICON8 = 0x00800000;
    static final int PRINTER_ENUM_HIDE = 0x01000000;
    static final int SPOOL_FILE_PERSISTENT = 0x00000001;
    static final int SPOOL_FILE_TEMPORARY = 0x00000002;
    static final int PRINTER_NOTIFY_TYPE = 0x00;
    static final int JOB_NOTIFY_TYPE = 0x01;
    static final int PRINTER_NOTIFY_FIELD_SERVER_NAME = 0x00;
    static final int PRINTER_NOTIFY_FIELD_PRINTER_NAME = 0x01;
    static final int PRINTER_NOTIFY_FIELD_SHARE_NAME = 0x02;
    static final int PRINTER_NOTIFY_FIELD_PORT_NAME = 0x03;
    static final int PRINTER_NOTIFY_FIELD_DRIVER_NAME = 0x04;
    static final int PRINTER_NOTIFY_FIELD_COMMENT = 0x05;
    static final int PRINTER_NOTIFY_FIELD_LOCATION = 0x06;
    static final int PRINTER_NOTIFY_FIELD_DEVMODE = 0x07;
    static final int PRINTER_NOTIFY_FIELD_SEPFILE = 0x08;
    static final int PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR = 0x09;
    static final int PRINTER_NOTIFY_FIELD_PARAMETERS = 0x0A;
    static final int PRINTER_NOTIFY_FIELD_DATATYPE = 0x0B;
    static final int PRINTER_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 0x0C;
    static final int PRINTER_NOTIFY_FIELD_ATTRIBUTES = 0x0D;
    static final int PRINTER_NOTIFY_FIELD_PRIORITY = 0x0E;
    static final int PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY = 0x0F;
    static final int PRINTER_NOTIFY_FIELD_START_TIME = 0x10;
    static final int PRINTER_NOTIFY_FIELD_UNTIL_TIME = 0x11;
    static final int PRINTER_NOTIFY_FIELD_STATUS = 0x12;
    static final int PRINTER_NOTIFY_FIELD_STATUS_STRING = 0x13;
    static final int PRINTER_NOTIFY_FIELD_CJOBS = 0x14;
    static final int PRINTER_NOTIFY_FIELD_AVERAGE_PPM = 0x15;
    static final int PRINTER_NOTIFY_FIELD_TOTAL_PAGES = 0x16;
    static final int PRINTER_NOTIFY_FIELD_PAGES_PRINTED = 0x17;
    static final int PRINTER_NOTIFY_FIELD_TOTAL_BYTES = 0x18;
    static final int PRINTER_NOTIFY_FIELD_BYTES_PRINTED = 0x19;
    static final int PRINTER_NOTIFY_FIELD_OBJECT_GUID = 0x1A;
    static final int JOB_NOTIFY_FIELD_PRINTER_NAME = 0x00;
    static final int JOB_NOTIFY_FIELD_MACHINE_NAME = 0x01;
    static final int JOB_NOTIFY_FIELD_PORT_NAME = 0x02;
    static final int JOB_NOTIFY_FIELD_USER_NAME = 0x03;
    static final int JOB_NOTIFY_FIELD_NOTIFY_NAME = 0x04;
    static final int JOB_NOTIFY_FIELD_DATATYPE = 0x05;
    static final int JOB_NOTIFY_FIELD_PRINT_PROCESSOR = 0x06;
    static final int JOB_NOTIFY_FIELD_PARAMETERS = 0x07;
    static final int JOB_NOTIFY_FIELD_DRIVER_NAME = 0x08;
    static final int JOB_NOTIFY_FIELD_DEVMODE = 0x09;
    static final int JOB_NOTIFY_FIELD_STATUS = 0x0A;
    static final int JOB_NOTIFY_FIELD_STATUS_STRING = 0x0B;
    static final int JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 0x0C;
    static final int JOB_NOTIFY_FIELD_DOCUMENT = 0x0D;
    static final int JOB_NOTIFY_FIELD_PRIORITY = 0x0E;
    static final int JOB_NOTIFY_FIELD_POSITION = 0x0F;
    static final int JOB_NOTIFY_FIELD_SUBMITTED = 0x10;
    static final int JOB_NOTIFY_FIELD_START_TIME = 0x11;
    static final int JOB_NOTIFY_FIELD_UNTIL_TIME = 0x12;
    static final int JOB_NOTIFY_FIELD_TIME = 0x13;
    static final int JOB_NOTIFY_FIELD_TOTAL_PAGES = 0x14;
    static final int JOB_NOTIFY_FIELD_PAGES_PRINTED = 0x15;
    static final int JOB_NOTIFY_FIELD_TOTAL_BYTES = 0x16;
    static final int JOB_NOTIFY_FIELD_BYTES_PRINTED = 0x17;
    static final int PRINTER_NOTIFY_OPTIONS_REFRESH = 0x01;
    static final int PRINTER_NOTIFY_INFO_DISCARDED = 0x01;
    static final int BIDI_ACCESS_ADMINISTRATOR = 0x1;
    static final int BIDI_ACCESS_USER = 0x2;
    static final int ERROR_BIDI_STATUS_OK = 0;
    static final int ERROR_BIDI_NOT_SUPPORTED = ERROR_NOT_SUPPORTED;
    static final int ERROR_BIDI_ERROR_BASE = 13000;
    static final int ERROR_BIDI_STATUS_WARNING = (ERROR_BIDI_ERROR_BASE + 1);
    static final int ERROR_BIDI_SCHEMA_READ_ONLY = (ERROR_BIDI_ERROR_BASE + 2);
    static final int ERROR_BIDI_SERVER_OFFLINE = (ERROR_BIDI_ERROR_BASE + 3);
    static final int ERROR_BIDI_DEVICE_OFFLINE = (ERROR_BIDI_ERROR_BASE + 4);
    static final int ERROR_BIDI_SCHEMA_NOT_SUPPORTED = (ERROR_BIDI_ERROR_BASE + 5);
    static final int PRINTER_CHANGE_ADD_PRINTER = 0x00000001;
    static final int PRINTER_CHANGE_SET_PRINTER = 0x00000002;
    static final int PRINTER_CHANGE_DELETE_PRINTER = 0x00000004;
    static final int PRINTER_CHANGE_FAILED_CONNECTION_PRINTER = 0x00000008;
    static final int PRINTER_CHANGE_PRINTER = 0x000000FF;
    static final int PRINTER_CHANGE_ADD_JOB = 0x00000100;
    static final int PRINTER_CHANGE_SET_JOB = 0x00000200;
    static final int PRINTER_CHANGE_DELETE_JOB = 0x00000400;
    static final int PRINTER_CHANGE_WRITE_JOB = 0x00000800;
    static final int PRINTER_CHANGE_JOB = 0x0000FF00;
    static final int PRINTER_CHANGE_ADD_FORM = 0x00010000;
    static final int PRINTER_CHANGE_SET_FORM = 0x00020000;
    static final int PRINTER_CHANGE_DELETE_FORM = 0x00040000;
    static final int PRINTER_CHANGE_FORM = 0x00070000;
    static final int PRINTER_CHANGE_ADD_PORT = 0x00100000;
    static final int PRINTER_CHANGE_CONFIGURE_PORT = 0x00200000;
    static final int PRINTER_CHANGE_DELETE_PORT = 0x00400000;
    static final int PRINTER_CHANGE_PORT = 0x00700000;
    static final int PRINTER_CHANGE_ADD_PRINT_PROCESSOR = 0x01000000;
    static final int PRINTER_CHANGE_DELETE_PRINT_PROCESSOR = 0x04000000;
    static final int PRINTER_CHANGE_PRINT_PROCESSOR = 0x07000000;
    static final int PRINTER_CHANGE_ADD_PRINTER_DRIVER = 0x10000000;
    static final int PRINTER_CHANGE_SET_PRINTER_DRIVER = 0x20000000;
    static final int PRINTER_CHANGE_DELETE_PRINTER_DRIVER = 0x40000000;
    static final int PRINTER_CHANGE_PRINTER_DRIVER = 0x70000000;
    static final int PRINTER_CHANGE_TIMEOUT = 0x80000000;
    static final int PRINTER_CHANGE_ALL = 0x7777FFFF;
    static final int PRINTER_ERROR_INFORMATION = 0x80000000;
    static final int PRINTER_ERROR_WARNING = 0x40000000;
    static final int PRINTER_ERROR_SEVERE = 0x20000000;
    static final int PRINTER_ERROR_OUTOFPAPER = 0x00000001;
    static final int PRINTER_ERROR_JAM = 0x00000002;
    static final int PRINTER_ERROR_OUTOFTONER = 0x00000004;
    static final int SERVER_ACCESS_ADMINISTER = 0x00000001;
    static final int SERVER_ACCESS_ENUMERATE = 0x00000002;
    static final int PRINTER_ACCESS_ADMINISTER = 0x00000004;
    static final int PRINTER_ACCESS_USE = 0x00000008;
    static final int JOB_ACCESS_ADMINISTER = 0x00000010;
    static final int JOB_ACCESS_READ = 0x00000020;
    static final int SERVER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SERVER_ACCESS_ADMINISTER | SERVER_ACCESS_ENUMERATE);
    static final int SERVER_READ = (STANDARD_RIGHTS_READ | SERVER_ACCESS_ENUMERATE);
    static final int SERVER_WRITE = (STANDARD_RIGHTS_WRITE | SERVER_ACCESS_ADMINISTER | SERVER_ACCESS_ENUMERATE);
    static final int SERVER_EXECUTE = (STANDARD_RIGHTS_EXECUTE | SERVER_ACCESS_ENUMERATE);
    static final int PRINTER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | PRINTER_ACCESS_ADMINISTER | PRINTER_ACCESS_USE);
    static final int PRINTER_READ = (STANDARD_RIGHTS_READ | PRINTER_ACCESS_USE);
    static final int PRINTER_WRITE = (STANDARD_RIGHTS_WRITE | PRINTER_ACCESS_USE);
    static final int PRINTER_EXECUTE = (STANDARD_RIGHTS_EXECUTE | PRINTER_ACCESS_USE);
    static final int JOB_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | JOB_ACCESS_ADMINISTER | JOB_ACCESS_READ);
    static final int JOB_READ = (STANDARD_RIGHTS_READ | JOB_ACCESS_READ);
    static final int JOB_WRITE = (STANDARD_RIGHTS_WRITE | JOB_ACCESS_ADMINISTER);
    static final int JOB_EXECUTE = (STANDARD_RIGHTS_EXECUTE | JOB_ACCESS_ADMINISTER);
    static final int WIN32 = 100;
    static final int EXIT_SUCCESS = 0;
    static final int EXIT_FAILURE = 1;
    static final int RAND_MAX = 0x7fff;
    static final int _MAX_PATH = 260;
    static final int _MAX_DRIVE = 3;
    static final int _MAX_DIR = 256;
    static final int _MAX_FNAME = 256;
    static final int _MAX_EXT = 256;
    static final int _OUT_TO_DEFAULT = 0;
    static final int _OUT_TO_STDERR = 1;
    static final int _OUT_TO_MSGBOX = 2;
    static final int _REPORT_ERRMODE = 3;
    static final int _SECERR_BUFFER_OVERRUN = 1;
    static final int _CVTBUFSIZE = (309+40);
    static final int MARSHALINTERFACE_MIN = 500;
    static final int CWCSTORAGENAME = 32;
    static final int STGM_DIRECT = 0x00000000;
    static final int STGM_TRANSACTED = 0x00010000;
    static final int STGM_SIMPLE = 0x08000000;
    static final int STGM_READ = 0x00000000;
    static final int STGM_WRITE = 0x00000001;
    static final int STGM_READWRITE = 0x00000002;
    static final int STGM_SHARE_DENY_NONE = 0x00000040;
    static final int STGM_SHARE_DENY_READ = 0x00000030;
    static final int STGM_SHARE_DENY_WRITE = 0x00000020;
    static final int STGM_SHARE_EXCLUSIVE = 0x00000010;
    static final int STGM_PRIORITY = 0x00040000;
    static final int STGM_DELETEONRELEASE = 0x04000000;
    static final int STGM_NOSCRATCH = 0x00100000;
    static final int STGM_CREATE = 0x00001000;
    static final int STGM_CONVERT = 0x00020000;
    static final int STGM_FAILIFTHERE = 0x00000000;
    static final int STGM_NOSNAPSHOT = 0x00200000;
    static final int STGM_DIRECT_SWMR = 0x00400000;
    static final int ASYNC_MODE_COMPATIBILITY = 0x00000001;
    static final int ASYNC_MODE_DEFAULT = 0x00000000;
    static final int STGTY_REPEAT = 0x00000100;
    static final int STG_TOEND = 0xFFFFFFFF;
    static final int STG_LAYOUT_SEQUENTIAL = 0x00000000;
    static final int STG_LAYOUT_INTERLEAVED = 0x00000001;
    static final int STGFMT_STORAGE = 0;
    static final int STGFMT_NATIVE = 1;
    static final int STGFMT_FILE = 3;
    static final int STGFMT_ANY = 4;
    static final int STGFMT_DOCFILE = 5;
    static final int STGFMT_DOCUMENT = 0;
    static final int COM_RIGHTS_EXECUTE = 1;
    static final int COM_RIGHTS_SAFE_FOR_SCRIPTING = 2;
    static final int STGOPTIONS_VERSION = 2;
    static final int UPDFCACHE_NODATACACHE = ( 0x1 );
    static final int UPDFCACHE_ONSAVECACHE = ( 0x2 );
    static final int UPDFCACHE_ONSTOPCACHE = ( 0x4 );
    static final int UPDFCACHE_NORMALCACHE = ( 0x8 );
    static final int UPDFCACHE_IFBLANK = ( 0x10 );
    static final int UPDFCACHE_ONLYIFBLANK = ( 0x80000000 );
    static final int UPDFCACHE_IFBLANKORONSAVECACHE = ( UPDFCACHE_IFBLANK | UPDFCACHE_ONSAVECACHE );
    static final int MK_ALT = ( 0x20 );
    static final int DROPEFFECT_NONE = ( 0 );
    static final int DROPEFFECT_COPY = ( 1 );
    static final int DROPEFFECT_MOVE = ( 2 );
    static final int DROPEFFECT_LINK = ( 4 );
    static final int DROPEFFECT_SCROLL = ( 0x80000000 );
    static final int DD_DEFSCROLLINSET = ( 11 );
    static final int DD_DEFSCROLLDELAY = ( 50 );
    static final int DD_DEFSCROLLINTERVAL = ( 50 );
    static final int DD_DEFDRAGDELAY = ( 200 );
    static final int DD_DEFDRAGMINDIST = ( 2 );
    static final int FADF_AUTO = ( 0x1 );
    static final int FADF_STATIC = ( 0x2 );
    static final int FADF_EMBEDDED = ( 0x4 );
    static final int FADF_FIXEDSIZE = ( 0x10 );
    static final int FADF_RECORD = ( 0x20 );
    static final int FADF_HAVEIID = ( 0x40 );
    static final int FADF_HAVEVARTYPE = ( 0x80 );
    static final int FADF_BSTR = ( 0x100 );
    static final int FADF_UNKNOWN = ( 0x200 );
    static final int FADF_DISPATCH = ( 0x400 );
    static final int FADF_VARIANT = ( 0x800 );
    static final int FADF_RESERVED = ( 0xf008 );
    static final int PARAMFLAG_NONE = ( 0 );
    static final int PARAMFLAG_FIN = ( 0x1 );
    static final int PARAMFLAG_FOUT = ( 0x2 );
    static final int PARAMFLAG_FLCID = ( 0x4 );
    static final int PARAMFLAG_FRETVAL = ( 0x8 );
    static final int PARAMFLAG_FOPT = ( 0x10 );
    static final int PARAMFLAG_FHASDEFAULT = ( 0x20 );
    static final int PARAMFLAG_FHASCUSTDATA = ( 0x40 );
    static final int IDLFLAG_NONE = ( PARAMFLAG_NONE );
    static final int IDLFLAG_FIN = ( PARAMFLAG_FIN );
    static final int IDLFLAG_FOUT = ( PARAMFLAG_FOUT );
    static final int IDLFLAG_FLCID = ( PARAMFLAG_FLCID );
    static final int IDLFLAG_FRETVAL = ( PARAMFLAG_FRETVAL );
    static final int IMPLTYPEFLAG_FDEFAULT = ( 0x1 );
    static final int IMPLTYPEFLAG_FSOURCE = ( 0x2 );
    static final int IMPLTYPEFLAG_FRESTRICTED = ( 0x4 );
    static final int IMPLTYPEFLAG_FDEFAULTVTABLE = ( 0x8 );
    static final int DISPID_UNKNOWN = ( -1 );
    static final int DISPID_VALUE = ( 0 );
    static final int DISPID_PROPERTYPUT = ( -3 );
    static final int DISPID_NEWENUM = ( -4 );
    static final int DISPID_EVALUATE = ( -5 );
    static final int DISPID_CONSTRUCTOR = ( -6 );
    static final int DISPID_DESTRUCTOR = ( -7 );
    static final int DISPID_COLLECT = ( -8 );
    static final int MKSYS_URLMONIKER = 6;
    static final int URL_MK_LEGACY = 0;
    static final int URL_MK_UNIFORM = 1;
    static final int URL_MK_NO_CANONICALIZE = 2;
    static final int FIEF_FLAG_FORCE_JITUI = 0x1;
    static final int FIEF_FLAG_PEEK = 0x2;
    static final int FIEF_FLAG_SKIP_INSTALLED_VERSION_CHECK = 0x4;
    static final int FMFD_DEFAULT = 0x00000000;
    static final int FMFD_URLASFILENAME = 0x00000001;
    static final int URLMON_OPTION_USERAGENT = 0x10000001;
    static final int URLMON_OPTION_USERAGENT_REFRESH = 0x10000002;
    static final int URLMON_OPTION_URL_ENCODING = 0x10000004;
    static final int CF_NULL = 0;
    static final int WININETINFO_OPTION_LOCK_HANDLE = 65534;
    static final int URLOSTRM_USECACHEDCOPY_ONLY = 0x1;
    static final int URLOSTRM_USECACHEDCOPY = 0x2;
    static final int URLOSTRM_GETNEWESTVERSION = 0x3;
    static final int PROTOCOLFLAG_NO_PICS_CHECK = 0x00000001;
    static final int MUTZ_NOSAVEDFILECHECK = 0x00000001;
    static final int MUTZ_ENFORCERESTRICTED = 0x00000100;
    static final int MAX_SIZE_SECURITY_ID = 512;
    static final int URLACTION_MIN = 0x00001000;
    static final int URLACTION_DOWNLOAD_MIN = 0x00001000;
    static final int URLACTION_DOWNLOAD_SIGNED_ACTIVEX = 0x00001001;
    static final int URLACTION_DOWNLOAD_UNSIGNED_ACTIVEX = 0x00001004;
    static final int URLACTION_DOWNLOAD_CURR_MAX = 0x00001004;
    static final int URLACTION_DOWNLOAD_MAX = 0x000011FF;
    static final int URLACTION_ACTIVEX_MIN = 0x00001200;
    static final int URLACTION_ACTIVEX_RUN = 0x00001200;
    static final int URLPOLICY_ACTIVEX_CHECK_LIST = 0x00010000;
    static final int URLACTION_ACTIVEX_OVERRIDE_OBJECT_SAFETY = 0x00001201;
    static final int URLACTION_ACTIVEX_OVERRIDE_DATA_SAFETY = 0x00001202;
    static final int URLACTION_ACTIVEX_OVERRIDE_SCRIPT_SAFETY = 0x00001203;
    static final int URLACTION_SCRIPT_OVERRIDE_SAFETY = 0x00001401;
    static final int URLACTION_ACTIVEX_CONFIRM_NOOBJECTSAFETY = 0x00001204;
    static final int URLACTION_ACTIVEX_TREATASUNTRUSTED = 0x00001205;
    static final int URLACTION_ACTIVEX_NO_WEBOC_SCRIPT = 0x00001206;
    static final int URLACTION_ACTIVEX_CURR_MAX = 0x00001206;
    static final int URLACTION_ACTIVEX_MAX = 0x000013ff;
    static final int URLACTION_SCRIPT_MIN = 0x00001400;
    static final int URLACTION_SCRIPT_RUN = 0x00001400;
    static final int URLACTION_SCRIPT_JAVA_USE = 0x00001402;
    static final int URLACTION_SCRIPT_SAFE_ACTIVEX = 0x00001405;
    static final int URLACTION_CROSS_DOMAIN_DATA = 0x00001406;
    static final int URLACTION_SCRIPT_PASTE = 0x00001407;
    static final int URLACTION_SCRIPT_CURR_MAX = 0x00001407;
    static final int URLACTION_SCRIPT_MAX = 0x000015ff;
    static final int URLACTION_HTML_MIN = 0x00001600;
    static final int URLACTION_HTML_SUBMIT_FORMS = 0x00001601;
    static final int URLACTION_HTML_SUBMIT_FORMS_FROM = 0x00001602;
    static final int URLACTION_HTML_SUBMIT_FORMS_TO = 0x00001603;
    static final int URLACTION_HTML_FONT_DOWNLOAD = 0x00001604;
    static final int URLACTION_HTML_JAVA_RUN = 0x00001605;
    static final int URLACTION_HTML_USERDATA_SAVE = 0x00001606;
    static final int URLACTION_HTML_SUBFRAME_NAVIGATE = 0x00001607;
    static final int URLACTION_HTML_META_REFRESH = 0x00001608;
    static final int URLACTION_HTML_MIXED_CONTENT = 0x00001609;
    static final int URLACTION_HTML_MAX = 0x000017ff;
    static final int URLACTION_SHELL_MIN = 0x00001800;
    static final int URLACTION_SHELL_INSTALL_DTITEMS = 0x00001800;
    static final int URLACTION_SHELL_MOVE_OR_COPY = 0x00001802;
    static final int URLACTION_SHELL_FILE_DOWNLOAD = 0x00001803;
    static final int URLACTION_SHELL_VERB = 0x00001804;
    static final int URLACTION_SHELL_WEBVIEW_VERB = 0x00001805;
    static final int URLACTION_SHELL_SHELLEXECUTE = 0x00001806;
    static final int URLACTION_SHELL_CURR_MAX = 0x00001806;
    static final int URLACTION_SHELL_MAX = 0x000019ff;
    static final int URLACTION_NETWORK_MIN = 0x00001A00;
    static final int URLACTION_CREDENTIALS_USE = 0x00001A00;
    static final int URLPOLICY_CREDENTIALS_SILENT_LOGON_OK = 0x00000000;
    static final int URLPOLICY_CREDENTIALS_MUST_PROMPT_USER = 0x00010000;
    static final int URLPOLICY_CREDENTIALS_CONDITIONAL_PROMPT = 0x00020000;
    static final int URLPOLICY_CREDENTIALS_ANONYMOUS_ONLY = 0x00030000;
    static final int URLACTION_AUTHENTICATE_CLIENT = 0x00001A01;
    static final int URLPOLICY_AUTHENTICATE_CLEARTEXT_OK = 0x00000000;
    static final int URLPOLICY_AUTHENTICATE_CHALLENGE_RESPONSE = 0x00010000;
    static final int URLPOLICY_AUTHENTICATE_MUTUAL_ONLY = 0x00030000;
    static final int URLACTION_COOKIES = 0x00001A02;
    static final int URLACTION_COOKIES_SESSION = 0x00001A03;
    static final int URLACTION_CLIENT_CERT_PROMPT = 0x00001A04;
    static final int URLACTION_COOKIES_THIRD_PARTY = 0x00001A05;
    static final int URLACTION_COOKIES_SESSION_THIRD_PARTY = 0x00001A06;
    static final int URLACTION_COOKIES_ENABLED = 0x00001A10;
    static final int URLACTION_NETWORK_CURR_MAX = 0x00001A10;
    static final int URLACTION_NETWORK_MAX = 0x00001Bff;
    static final int URLACTION_JAVA_MIN = 0x00001C00;
    static final int URLACTION_JAVA_PERMISSIONS = 0x00001C00;
    static final int URLPOLICY_JAVA_PROHIBIT = 0x00000000;
    static final int URLPOLICY_JAVA_HIGH = 0x00010000;
    static final int URLPOLICY_JAVA_MEDIUM = 0x00020000;
    static final int URLPOLICY_JAVA_LOW = 0x00030000;
    static final int URLPOLICY_JAVA_CUSTOM = 0x00800000;
    static final int URLACTION_JAVA_CURR_MAX = 0x00001C00;
    static final int URLACTION_JAVA_MAX = 0x00001Cff;
    static final int URLACTION_INFODELIVERY_MIN = 0x00001D00;
    static final int URLACTION_INFODELIVERY_NO_ADDING_CHANNELS = 0x00001D00;
    static final int URLACTION_INFODELIVERY_NO_EDITING_CHANNELS = 0x00001D01;
    static final int URLACTION_INFODELIVERY_NO_REMOVING_CHANNELS = 0x00001D02;
    static final int URLACTION_INFODELIVERY_NO_ADDING_SUBSCRIPTIONS = 0x00001D03;
    static final int URLACTION_INFODELIVERY_NO_EDITING_SUBSCRIPTIONS = 0x00001D04;
    static final int URLACTION_INFODELIVERY_NO_REMOVING_SUBSCRIPTIONS = 0x00001D05;
    static final int URLACTION_INFODELIVERY_NO_CHANNEL_LOGGING = 0x00001D06;
    static final int URLACTION_INFODELIVERY_CURR_MAX = 0x00001D06;
    static final int URLACTION_INFODELIVERY_MAX = 0x00001Dff;
    static final int URLACTION_CHANNEL_SOFTDIST_MIN = 0x00001E00;
    static final int URLACTION_CHANNEL_SOFTDIST_PERMISSIONS = 0x00001E05;
    static final int URLPOLICY_CHANNEL_SOFTDIST_PROHIBIT = 0x00010000;
    static final int URLPOLICY_CHANNEL_SOFTDIST_PRECACHE = 0x00020000;
    static final int URLPOLICY_CHANNEL_SOFTDIST_AUTOINSTALL = 0x00030000;
    static final int URLACTION_CHANNEL_SOFTDIST_MAX = 0x00001Eff;
    static final int URLPOLICY_ALLOW = 0x00;
    static final int URLPOLICY_QUERY = 0x01;
    static final int URLPOLICY_DISALLOW = 0x03;
    static final int URLPOLICY_NOTIFY_ON_ALLOW = 0x10;
    static final int URLPOLICY_NOTIFY_ON_DISALLOW = 0x20;
    static final int URLPOLICY_LOG_ON_ALLOW = 0x40;
    static final int URLPOLICY_LOG_ON_DISALLOW = 0x80;
    static final int URLPOLICY_MASK_PERMISSIONS = 0x0f;
    static final int URLPOLICY_DONTCHECKDLGBOX = 0x100;
    static final int SOFTDIST_FLAG_USAGE_EMAIL = 0x00000001;
    static final int SOFTDIST_FLAG_USAGE_PRECACHE = 0x00000002;
    static final int SOFTDIST_FLAG_USAGE_AUTOINSTALL = 0x00000004;
    static final int SOFTDIST_FLAG_DELETE_SUBSCRIPTION = 0x00000008;
    static final int SOFTDIST_ADSTATE_NONE = 0x00000000;
    static final int SOFTDIST_ADSTATE_AVAILABLE = 0x00000001;
    static final int SOFTDIST_ADSTATE_DOWNLOADED = 0x00000002;
    static final int SOFTDIST_ADSTATE_INSTALLED = 0x00000003;
    static final int CONFIRMSAFETYACTION_LOADOBJECT = 0x00000001;
    static final int PROPSETFLAG_DEFAULT = ( 0 );
    static final int PROPSETFLAG_NONSIMPLE = ( 1 );
    static final int PROPSETFLAG_ANSI = ( 2 );
    static final int PROPSETFLAG_UNBUFFERED = ( 4 );
    static final int PROPSETFLAG_CASE_SENSITIVE = ( 8 );
    static final int PROPSET_BEHAVIOR_CASE_SENSITIVE = ( 1 );
    static final int PID_DICTIONARY = ( 0 );
    static final int PID_CODEPAGE = ( 0x1 );
    static final int PID_FIRST_USABLE = ( 0x2 );
    static final int PID_FIRST_NAME_DEFAULT = ( 0xfff );
    static final int PID_LOCALE = ( 0x80000000 );
    static final int PID_MODIFY_TIME = ( 0x80000001 );
    static final int PID_SECURITY = ( 0x80000002 );
    static final int PID_BEHAVIOR = ( 0x80000003 );
    static final int PID_ILLEGAL = ( 0xffffffff );
    static final int PID_MIN_READONLY = ( 0x80000000 );
    static final int PID_MAX_READONLY = ( 0xbfffffff );
    static final int PIDDI_THUMBNAIL = 0x00000002;
    static final int PIDSI_TITLE = 0x00000002;
    static final int PIDSI_SUBJECT = 0x00000003;
    static final int PIDSI_AUTHOR = 0x00000004;
    static final int PIDSI_KEYWORDS = 0x00000005;
    static final int PIDSI_COMMENTS = 0x00000006;
    static final int PIDSI_TEMPLATE = 0x00000007;
    static final int PIDSI_LASTAUTHOR = 0x00000008;
    static final int PIDSI_REVNUMBER = 0x00000009;
    static final int PIDSI_EDITTIME = 0x0000000a;
    static final int PIDSI_LASTPRINTED = 0x0000000b;
    static final int PIDSI_CREATE_DTM = 0x0000000c;
    static final int PIDSI_LASTSAVE_DTM = 0x0000000d;
    static final int PIDSI_PAGECOUNT = 0x0000000e;
    static final int PIDSI_WORDCOUNT = 0x0000000f;
    static final int PIDSI_CHARCOUNT = 0x00000010;
    static final int PIDSI_THUMBNAIL = 0x00000011;
    static final int PIDSI_APPNAME = 0x00000012;
    static final int PIDSI_DOC_SECURITY = 0x00000013;
    static final int PIDDSI_CATEGORY = 0x00000002;
    static final int PIDDSI_PRESFORMAT = 0x00000003;
    static final int PIDDSI_BYTECOUNT = 0x00000004;
    static final int PIDDSI_LINECOUNT = 0x00000005;
    static final int PIDDSI_PARCOUNT = 0x00000006;
    static final int PIDDSI_SLIDECOUNT = 0x00000007;
    static final int PIDDSI_NOTECOUNT = 0x00000008;
    static final int PIDDSI_HIDDENCOUNT = 0x00000009;
    static final int PIDDSI_MMCLIPCOUNT = 0x0000000A;
    static final int PIDDSI_SCALE = 0x0000000B;
    static final int PIDDSI_HEADINGPAIR = 0x0000000C;
    static final int PIDDSI_DOCPARTS = 0x0000000D;
    static final int PIDDSI_MANAGER = 0x0000000E;
    static final int PIDDSI_COMPANY = 0x0000000F;
    static final int PIDDSI_LINKSDIRTY = 0x00000010;
    static final int PIDMSI_EDITOR = 0x00000002;
    static final int PIDMSI_SUPPLIER = 0x00000003;
    static final int PIDMSI_SOURCE = 0x00000004;
    static final int PIDMSI_SEQUENCE_NO = 0x00000005;
    static final int PIDMSI_PROJECT = 0x00000006;
    static final int PIDMSI_STATUS = 0x00000007;
    static final int PIDMSI_OWNER = 0x00000008;
    static final int PIDMSI_RATING = 0x00000009;
    static final int PIDMSI_PRODUCTION = 0x0000000A;
    static final int PIDMSI_COPYRIGHT = 0x0000000B;
    static final int PRSPEC_INVALID = ( 0xffffffff );
    static final int PRSPEC_LPWSTR = ( 0 );
    static final int PRSPEC_PROPID = ( 1 );
    static final int PROPSETHDR_OSVERSION_UNKNOWN = 0xFFFFFFFF;
    static final int CCH_MAX_PROPSTG_NAME = 31;
    static final int STDOLE_MAJORVERNUM = 0x1;
    static final int STDOLE_MINORVERNUM = 0x0;
    static final int STDOLE_LCID = 0x0000;
    static final int STDOLE2_MAJORVERNUM = 0x2;
    static final int STDOLE2_MINORVERNUM = 0x0;
    static final int STDOLE2_LCID = 0x0000;
    static final int VARIANT_NOVALUEPROP = 0x01;
    static final int VARIANT_ALPHABOOL = 0x02;
    static final int VARIANT_NOUSEROVERRIDE = 0x04;
    static final int VARIANT_CALENDAR_HIJRI = 0x08;
    static final int VARIANT_LOCALBOOL = 0x10;
    static final int VARIANT_CALENDAR_THAI = 0x20;
    static final int VARIANT_CALENDAR_GREGORIAN = 0x40;
    static final int VARIANT_USE_NLS = 0x80;
    static final int LOCALE_USE_NLS = 0x10000000;
    static final int VTDATEGRE_MAX = 2958465;
    static final int VTDATEGRE_MIN = -657434;
    static final int NUMPRS_LEADING_WHITE = 0x0001;
    static final int NUMPRS_TRAILING_WHITE = 0x0002;
    static final int NUMPRS_LEADING_PLUS = 0x0004;
    static final int NUMPRS_TRAILING_PLUS = 0x0008;
    static final int NUMPRS_LEADING_MINUS = 0x0010;
    static final int NUMPRS_TRAILING_MINUS = 0x0020;
    static final int NUMPRS_HEX_OCT = 0x0040;
    static final int NUMPRS_PARENS = 0x0080;
    static final int NUMPRS_DECIMAL = 0x0100;
    static final int NUMPRS_THOUSANDS = 0x0200;
    static final int NUMPRS_CURRENCY = 0x0400;
    static final int NUMPRS_EXPONENT = 0x0800;
    static final int NUMPRS_USE_ALL = 0x1000;
    static final int NUMPRS_STD = 0x1FFF;
    static final int NUMPRS_NEG = 0x10000;
    static final int NUMPRS_INEXACT = 0x20000;
    static final int VARCMP_LT = 0;
    static final int VARCMP_EQ = 1;
    static final int VARCMP_GT = 2;
    static final int VARCMP_NULL = 3;
    static final int MEMBERID_NIL = DISPID_UNKNOWN;
    static final int ID_DEFAULTINST = -2;
    static final int DISPATCH_METHOD = 0x1;
    static final int DISPATCH_PROPERTYGET = 0x2;
    static final int DISPATCH_PROPERTYPUT = 0x4;
    static final int DISPATCH_PROPERTYPUTREF = 0x8;
    static final int LOAD_TLB_AS_32BIT = 0x20;
    static final int LOAD_TLB_AS_64BIT = 0x40;
    static final int ACTIVEOBJECT_STRONG = 0x0;
    static final int ACTIVEOBJECT_WEAK = 0x1;
    static final int OLEIVERB_PRIMARY = (0);
    static final int OLEIVERB_SHOW = (-1);
    static final int OLEIVERB_OPEN = (-2);
    static final int OLEIVERB_HIDE = (-3);
    static final int OLEIVERB_UIACTIVATE = (-4);
    static final int OLEIVERB_INPLACEACTIVATE = (-5);
    static final int OLEIVERB_DISCARDUNDOSTATE = (-6);
    static final int EMBDHLP_INPROC_HANDLER = 0x0000;
    static final int EMBDHLP_INPROC_SERVER = 0x0001;
    static final int EMBDHLP_CREATENOW = 0x00000000;
    static final int EMBDHLP_DELAYCREATE = 0x00010000;
    static final int OLECREATE_LEAVERUNNING = 0x00000001;
    static final int OFN_READONLY = 0x00000001;
    static final int OFN_OVERWRITEPROMPT = 0x00000002;
    static final int OFN_HIDEREADONLY = 0x00000004;
    static final int OFN_NOCHANGEDIR = 0x00000008;
    static final int OFN_SHOWHELP = 0x00000010;
    static final int OFN_ENABLEHOOK = 0x00000020;
    static final int OFN_ENABLETEMPLATE = 0x00000040;
    static final int OFN_ENABLETEMPLATEHANDLE = 0x00000080;
    static final int OFN_NOVALIDATE = 0x00000100;
    static final int OFN_ALLOWMULTISELECT = 0x00000200;
    static final int OFN_EXTENSIONDIFFERENT = 0x00000400;
    static final int OFN_PATHMUSTEXIST = 0x00000800;
    static final int OFN_FILEMUSTEXIST = 0x00001000;
    static final int OFN_CREATEPROMPT = 0x00002000;
    static final int OFN_SHAREAWARE = 0x00004000;
    static final int OFN_NOREADONLYRETURN = 0x00008000;
    static final int OFN_NOTESTFILECREATE = 0x00010000;
    static final int OFN_NONETWORKBUTTON = 0x00020000;
    static final int OFN_NOLONGNAMES = 0x00040000;
    static final int OFN_EXPLORER = 0x00080000;
    static final int OFN_NODEREFERENCELINKS = 0x00100000;
    static final int OFN_LONGNAMES = 0x00200000;
    static final int OFN_ENABLEINCLUDENOTIFY = 0x00400000;
    static final int OFN_ENABLESIZING = 0x00800000;
    static final int OFN_DONTADDTORECENT = 0x02000000;
    static final int OFN_FORCESHOWHIDDEN = 0x10000000;
    static final int OFN_EX_NOPLACESBAR = 0x00000001;
    static final int OFN_SHAREFALLTHROUGH = 2;
    static final int OFN_SHARENOWARN = 1;
    static final int OFN_SHAREWARN = 0;
    static final int CDM_FIRST = (WM_USER + 100);
    static final int CDM_LAST = (WM_USER + 200);
    static final int CDM_GETSPEC = (CDM_FIRST + 0x0000);
    static final int CDM_GETFILEPATH = (CDM_FIRST + 0x0001);
    static final int CDM_GETFOLDERPATH = (CDM_FIRST + 0x0002);
    static final int CDM_GETFOLDERIDLIST = (CDM_FIRST + 0x0003);
    static final int CDM_SETCONTROLTEXT = (CDM_FIRST + 0x0004);
    static final int CDM_HIDECONTROL = (CDM_FIRST + 0x0005);
    static final int CDM_SETDEFEXT = (CDM_FIRST + 0x0006);
    static final int CC_RGBINIT = 0x00000001;
    static final int CC_FULLOPEN = 0x00000002;
    static final int CC_PREVENTFULLOPEN = 0x00000004;
    static final int CC_SHOWHELP = 0x00000008;
    static final int CC_ENABLEHOOK = 0x00000010;
    static final int CC_ENABLETEMPLATE = 0x00000020;
    static final int CC_ENABLETEMPLATEHANDLE = 0x00000040;
    static final int CC_SOLIDCOLOR = 0x00000080;
    static final int CC_ANYCOLOR = 0x00000100;
    static final int FR_DOWN = 0x00000001;
    static final int FR_WHOLEWORD = 0x00000002;
    static final int FR_MATCHCASE = 0x00000004;
    static final int FR_FINDNEXT = 0x00000008;
    static final int FR_REPLACE = 0x00000010;
    static final int FR_REPLACEALL = 0x00000020;
    static final int FR_DIALOGTERM = 0x00000040;
    static final int FR_SHOWHELP = 0x00000080;
    static final int FR_ENABLEHOOK = 0x00000100;
    static final int FR_ENABLETEMPLATE = 0x00000200;
    static final int FR_NOUPDOWN = 0x00000400;
    static final int FR_NOMATCHCASE = 0x00000800;
    static final int FR_NOWHOLEWORD = 0x00001000;
    static final int FR_ENABLETEMPLATEHANDLE = 0x00002000;
    static final int FR_HIDEUPDOWN = 0x00004000;
    static final int FR_HIDEMATCHCASE = 0x00008000;
    static final int FR_HIDEWHOLEWORD = 0x00010000;
    static final int FR_RAW = 0x00020000;
    static final int FR_MATCHDIAC = 0x20000000;
    static final int FR_MATCHKASHIDA = 0x40000000;
    static final int FR_MATCHALEFHAMZA = 0x80000000;
    static final int CF_SCREENFONTS = 0x00000001;
    static final int CF_PRINTERFONTS = 0x00000002;
    static final int CF_BOTH = (CF_SCREENFONTS | CF_PRINTERFONTS);
    static final int CF_SHOWHELP = 0x00000004;
    static final int CF_ENABLEHOOK = 0x00000008;
    static final int CF_ENABLETEMPLATE = 0x00000010;
    static final int CF_ENABLETEMPLATEHANDLE = 0x00000020;
    static final int CF_INITTOLOGFONTSTRUCT = 0x00000040;
    static final int CF_USESTYLE = 0x00000080;
    static final int CF_EFFECTS = 0x00000100;
    static final int CF_APPLY = 0x00000200;
    static final int CF_ANSIONLY = 0x00000400;
    static final int CF_SCRIPTSONLY = CF_ANSIONLY;
    static final int CF_NOVECTORFONTS = 0x00000800;
    static final int CF_NOOEMFONTS = CF_NOVECTORFONTS;
    static final int CF_NOSIMULATIONS = 0x00001000;
    static final int CF_LIMITSIZE = 0x00002000;
    static final int CF_FIXEDPITCHONLY = 0x00004000;
    static final int CF_WYSIWYG = 0x00008000;
    static final int CF_FORCEFONTEXIST = 0x00010000;
    static final int CF_SCALABLEONLY = 0x00020000;
    static final int CF_TTONLY = 0x00040000;
    static final int CF_NOFACESEL = 0x00080000;
    static final int CF_NOSTYLESEL = 0x00100000;
    static final int CF_NOSIZESEL = 0x00200000;
    static final int CF_SELECTSCRIPT = 0x00400000;
    static final int CF_NOSCRIPTSEL = 0x00800000;
    static final int CF_NOVERTFONTS = 0x01000000;
    static final int SIMULATED_FONTTYPE = 0x8000;
    static final int PRINTER_FONTTYPE = 0x4000;
    static final int SCREEN_FONTTYPE = 0x2000;
    static final int BOLD_FONTTYPE = 0x0100;
    static final int ITALIC_FONTTYPE = 0x0200;
    static final int REGULAR_FONTTYPE = 0x0400;
    static final int WM_CHOOSEFONT_GETLOGFONT = (WM_USER + 1);
    static final int WM_CHOOSEFONT_SETLOGFONT = (WM_USER + 101);
    static final int WM_CHOOSEFONT_SETFLAGS = (WM_USER + 102);
    static final int CD_LBSELNOITEMS = -1;
    static final int CD_LBSELCHANGE = 0;
    static final int CD_LBSELSUB = 1;
    static final int CD_LBSELADD = 2;
    static final int PD_ALLPAGES = 0x00000000;
    static final int PD_SELECTION = 0x00000001;
    static final int PD_PAGENUMS = 0x00000002;
    static final int PD_NOSELECTION = 0x00000004;
    static final int PD_NOPAGENUMS = 0x00000008;
    static final int PD_COLLATE = 0x00000010;
    static final int PD_PRINTTOFILE = 0x00000020;
    static final int PD_PRINTSETUP = 0x00000040;
    static final int PD_NOWARNING = 0x00000080;
    static final int PD_RETURNDC = 0x00000100;
    static final int PD_RETURNIC = 0x00000200;
    static final int PD_RETURNDEFAULT = 0x00000400;
    static final int PD_SHOWHELP = 0x00000800;
    static final int PD_ENABLEPRINTHOOK = 0x00001000;
    static final int PD_ENABLESETUPHOOK = 0x00002000;
    static final int PD_ENABLEPRINTTEMPLATE = 0x00004000;
    static final int PD_ENABLESETUPTEMPLATE = 0x00008000;
    static final int PD_ENABLEPRINTTEMPLATEHANDLE = 0x00010000;
    static final int PD_ENABLESETUPTEMPLATEHANDLE = 0x00020000;
    static final int PD_USEDEVMODECOPIES = 0x00040000;
    static final int PD_USEDEVMODECOPIESANDCOLLATE = 0x00040000;
    static final int PD_DISABLEPRINTTOFILE = 0x00080000;
    static final int PD_HIDEPRINTTOFILE = 0x00100000;
    static final int PD_NONETWORKBUTTON = 0x00200000;
    static final int PD_CURRENTPAGE = 0x00400000;
    static final int PD_NOCURRENTPAGE = 0x00800000;
    static final int PD_EXCLUSIONFLAGS = 0x01000000;
    static final int PD_USELARGETEMPLATE = 0x10000000;
    static final int PD_EXCL_COPIESANDCOLLATE = (DM_COPIES | DM_COLLATE);
    static final int START_PAGE_GENERAL = 0xffffffff;
    static final int PD_RESULT_CANCEL = 0;
    static final int PD_RESULT_PRINT = 1;
    static final int PD_RESULT_APPLY = 2;
    static final int DN_DEFAULTPRN = 0x0001;
    static final int WM_PSD_PAGESETUPDLG = (WM_USER );
    static final int WM_PSD_FULLPAGERECT = (WM_USER+1);
    static final int WM_PSD_MINMARGINRECT = (WM_USER+2);
    static final int WM_PSD_MARGINRECT = (WM_USER+3);
    static final int WM_PSD_GREEKTEXTRECT = (WM_USER+4);
    static final int WM_PSD_ENVSTAMPRECT = (WM_USER+5);
    static final int WM_PSD_YAFULLPAGERECT = (WM_USER+6);
    static final int PSD_DEFAULTMINMARGINS = 0x00000000;
    static final int PSD_INWININIINTLMEASURE = 0x00000000;
    static final int PSD_MINMARGINS = 0x00000001;
    static final int PSD_MARGINS = 0x00000002;
    static final int PSD_INTHOUSANDTHSOFINCHES = 0x00000004;
    static final int PSD_INHUNDREDTHSOFMILLIMETERS = 0x00000008;
    static final int PSD_DISABLEMARGINS = 0x00000010;
    static final int PSD_DISABLEPRINTER = 0x00000020;
    static final int PSD_NOWARNING = 0x00000080;
    static final int PSD_DISABLEORIENTATION = 0x00000100;
    static final int PSD_RETURNDEFAULT = 0x00000400;
    static final int PSD_DISABLEPAPER = 0x00000200;
    static final int PSD_SHOWHELP = 0x00000800;
    static final int PSD_ENABLEPAGESETUPHOOK = 0x00002000;
    static final int PSD_ENABLEPAGESETUPTEMPLATE = 0x00008000;
    static final int PSD_ENABLEPAGESETUPTEMPLATEHANDLE = 0x00020000;
    static final int PSD_ENABLEPAGEPAINTHOOK = 0x00040000;
    static final int PSD_DISABLEPAGEPAINTING = 0x00080000;
    static final int PSD_NONETWORKBUTTON = 0x00200000;
    static final int SERVICE_NO_CHANGE = 0xffffffff;
    static final int SERVICE_ACTIVE = 0x00000001;
    static final int SERVICE_INACTIVE = 0x00000002;
    static final int SERVICE_STATE_ALL = (SERVICE_ACTIVE | SERVICE_INACTIVE);
    static final int SERVICE_CONTROL_STOP = 0x00000001;
    static final int SERVICE_CONTROL_PAUSE = 0x00000002;
    static final int SERVICE_CONTROL_CONTINUE = 0x00000003;
    static final int SERVICE_CONTROL_INTERROGATE = 0x00000004;
    static final int SERVICE_CONTROL_SHUTDOWN = 0x00000005;
    static final int SERVICE_CONTROL_PARAMCHANGE = 0x00000006;
    static final int SERVICE_CONTROL_NETBINDADD = 0x00000007;
    static final int SERVICE_CONTROL_NETBINDREMOVE = 0x00000008;
    static final int SERVICE_CONTROL_NETBINDENABLE = 0x00000009;
    static final int SERVICE_CONTROL_NETBINDDISABLE = 0x0000000A;
    static final int SERVICE_CONTROL_DEVICEEVENT = 0x0000000B;
    static final int SERVICE_CONTROL_HARDWAREPROFILECHANGE = 0x0000000C;
    static final int SERVICE_CONTROL_POWEREVENT = 0x0000000D;
    static final int SERVICE_CONTROL_SESSIONCHANGE = 0x0000000E;
    static final int SERVICE_STOPPED = 0x00000001;
    static final int SERVICE_START_PENDING = 0x00000002;
    static final int SERVICE_STOP_PENDING = 0x00000003;
    static final int SERVICE_RUNNING = 0x00000004;
    static final int SERVICE_CONTINUE_PENDING = 0x00000005;
    static final int SERVICE_PAUSE_PENDING = 0x00000006;
    static final int SERVICE_PAUSED = 0x00000007;
    static final int SERVICE_ACCEPT_STOP = 0x00000001;
    static final int SERVICE_ACCEPT_PAUSE_CONTINUE = 0x00000002;
    static final int SERVICE_ACCEPT_SHUTDOWN = 0x00000004;
    static final int SERVICE_ACCEPT_PARAMCHANGE = 0x00000008;
    static final int SERVICE_ACCEPT_NETBINDCHANGE = 0x00000010;
    static final int SERVICE_ACCEPT_HARDWAREPROFILECHANGE = 0x00000020;
    static final int SERVICE_ACCEPT_POWEREVENT = 0x00000040;
    static final int SERVICE_ACCEPT_SESSIONCHANGE = 0x00000080;
    static final int SC_MANAGER_CONNECT = 0x0001;
    static final int SC_MANAGER_CREATE_SERVICE = 0x0002;
    static final int SC_MANAGER_ENUMERATE_SERVICE = 0x0004;
    static final int SC_MANAGER_LOCK = 0x0008;
    static final int SC_MANAGER_QUERY_LOCK_STATUS = 0x0010;
    static final int SC_MANAGER_MODIFY_BOOT_CONFIG = 0x0020;
    static final int SC_MANAGER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SC_MANAGER_CONNECT | SC_MANAGER_CREATE_SERVICE | SC_MANAGER_ENUMERATE_SERVICE | SC_MANAGER_LOCK | SC_MANAGER_QUERY_LOCK_STATUS | SC_MANAGER_MODIFY_BOOT_CONFIG);
    static final int SERVICE_QUERY_CONFIG = 0x0001;
    static final int SERVICE_CHANGE_CONFIG = 0x0002;
    static final int SERVICE_QUERY_STATUS = 0x0004;
    static final int SERVICE_ENUMERATE_DEPENDENTS = 0x0008;
    static final int SERVICE_START = 0x0010;
    static final int SERVICE_STOP = 0x0020;
    static final int SERVICE_PAUSE_CONTINUE = 0x0040;
    static final int SERVICE_INTERROGATE = 0x0080;
    static final int SERVICE_USER_DEFINED_CONTROL = 0x0100;
    static final int SERVICE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | SERVICE_QUERY_CONFIG | SERVICE_CHANGE_CONFIG | SERVICE_QUERY_STATUS | SERVICE_ENUMERATE_DEPENDENTS | SERVICE_START | SERVICE_STOP | SERVICE_PAUSE_CONTINUE | SERVICE_INTERROGATE | SERVICE_USER_DEFINED_CONTROL);
    static final int SERVICE_RUNS_IN_SYSTEM_PROCESS = 0x00000001;
    static final int SERVICE_CONFIG_DESCRIPTION = 1;
    static final int SERVICE_CONFIG_FAILURE_ACTIONS = 2;
    static final int DIALOPTION_BILLING = 0x00000040;
    static final int DIALOPTION_QUIET = 0x00000080;
    static final int DIALOPTION_DIALTONE = 0x00000100;
    static final int MDMVOLFLAG_LOW = 0x00000001;
    static final int MDMVOLFLAG_MEDIUM = 0x00000002;
    static final int MDMVOLFLAG_HIGH = 0x00000004;
    static final int MDMVOL_LOW = 0x00000000;
    static final int MDMVOL_MEDIUM = 0x00000001;
    static final int MDMVOL_HIGH = 0x00000002;
    static final int MDMSPKRFLAG_OFF = 0x00000001;
    static final int MDMSPKRFLAG_DIAL = 0x00000002;
    static final int MDMSPKRFLAG_ON = 0x00000004;
    static final int MDMSPKRFLAG_CALLSETUP = 0x00000008;
    static final int MDMSPKR_OFF = 0x00000000;
    static final int MDMSPKR_DIAL = 0x00000001;
    static final int MDMSPKR_ON = 0x00000002;
    static final int MDMSPKR_CALLSETUP = 0x00000003;
    static final int MDM_COMPRESSION = 0x00000001;
    static final int MDM_ERROR_CONTROL = 0x00000002;
    static final int MDM_FORCED_EC = 0x00000004;
    static final int MDM_CELLULAR = 0x00000008;
    static final int MDM_FLOWCONTROL_HARD = 0x00000010;
    static final int MDM_FLOWCONTROL_SOFT = 0x00000020;
    static final int MDM_CCITT_OVERRIDE = 0x00000040;
    static final int MDM_SPEED_ADJUST = 0x00000080;
    static final int MDM_TONE_DIAL = 0x00000100;
    static final int MDM_BLIND_DIAL = 0x00000200;
    static final int MDM_V23_OVERRIDE = 0x00000400;
    static final int MDM_DIAGNOSTICS = 0x00000800;
    static final int MDM_MASK_BEARERMODE = 0x0000f000;
    static final int MDM_SHIFT_BEARERMODE = 12;
    static final int MDM_MASK_PROTOCOLID = 0x000f0000;
    static final int MDM_SHIFT_PROTOCOLID = 16;
    static final int MDM_MASK_PROTOCOLDATA = 0x0ff00000;
    static final int MDM_SHIFT_PROTOCOLDATA = 20;
    static final int MDM_MASK_PROTOCOLINFO = (MDM_MASK_PROTOCOLID|MDM_MASK_PROTOCOLDATA);
    static final int MDM_SHIFT_PROTOCOLINFO = MDM_SHIFT_PROTOCOLID;
    static final int MDM_MASK_EXTENDEDINFO = (MDM_MASK_BEARERMODE|MDM_MASK_PROTOCOLINFO);
    static final int MDM_SHIFT_EXTENDEDINFO = MDM_SHIFT_BEARERMODE;
    static final int MDM_BEARERMODE_ANALOG = 0x0;
    static final int MDM_BEARERMODE_ISDN = 0x1;
    static final int MDM_BEARERMODE_GSM = 0x2;
    static final int MDM_PROTOCOLID_DEFAULT = 0x0;
    static final int MDM_PROTOCOLID_HDLCPPP = 0x1;
    static final int MDM_PROTOCOLID_V128 = 0x2;
    static final int MDM_PROTOCOLID_X75 = 0x3;
    static final int MDM_PROTOCOLID_V110 = 0x4;
    static final int MDM_PROTOCOLID_V120 = 0x5;
    static final int MDM_PROTOCOLID_AUTO = 0x6;
    static final int MDM_PROTOCOLID_ANALOG = 0x7;
    static final int MDM_PROTOCOLID_GPRS = 0x8;
    static final int MDM_PROTOCOLID_PIAFS = 0x9;
    static final int MDM_SHIFT_HDLCPPP_SPEED = 0x0;
    static final int MDM_MASK_HDLCPPP_SPEED = 0x7;
    static final int MDM_HDLCPPP_SPEED_DEFAULT = 0x0;
    static final int MDM_HDLCPPP_SPEED_64K = 0x1;
    static final int MDM_HDLCPPP_SPEED_56K = 0x2;
    static final int MDM_SHIFT_HDLCPPP_AUTH = 0x3;
    static final int MDM_MASK_HDLCPPP_AUTH = (0x7<<3);
    static final int MDM_HDLCPPP_AUTH_DEFAULT = 0x0;
    static final int MDM_HDLCPPP_AUTH_NONE = 0x1;
    static final int MDM_HDLCPPP_AUTH_PAP = 0x2;
    static final int MDM_HDLCPPP_AUTH_CHAP = 0x3;
    static final int MDM_HDLCPPP_AUTH_MSCHAP = 0x4;
    static final int MDM_SHIFT_HDLCPPP_ML = 0x6;
    static final int MDM_MASK_HDLCPPP_ML = (0x3<<6);
    static final int MDM_HDLCPPP_ML_DEFAULT = 0x0;
    static final int MDM_HDLCPPP_ML_NONE = 0x1;
    static final int MDM_HDLCPPP_ML_2 = 0x2;
    static final int MDM_SHIFT_V120_SPEED = 0x0;
    static final int MDM_MASK_V120_SPEED = 0x7;
    static final int MDM_V120_SPEED_DEFAULT = 0x0;
    static final int MDM_V120_SPEED_64K = 0x1;
    static final int MDM_V120_SPEED_56K = 0x2;
    static final int MDM_SHIFT_V120_ML = 0x6;
    static final int MDM_MASK_V120_ML = (0x3<<6);
    static final int MDM_V120_ML_DEFAULT = 0x0;
    static final int MDM_V120_ML_NONE = 0x1;
    static final int MDM_V120_ML_2 = 0x2;
    static final int MDM_SHIFT_X75_DATA = 0x0;
    static final int MDM_MASK_X75_DATA = 0x7;
    static final int MDM_X75_DATA_DEFAULT = 0x0;
    static final int MDM_X75_DATA_64K = 0x1;
    static final int MDM_X75_DATA_128K = 0x2;
    static final int MDM_X75_DATA_T_70 = 0x3;
    static final int MDM_X75_DATA_BTX = 0x4;
    static final int MDM_SHIFT_V110_SPEED = 0x0;
    static final int MDM_MASK_V110_SPEED = 0xf;
    static final int MDM_V110_SPEED_DEFAULT = 0x0;
    static final int MDM_V110_SPEED_1DOT2K = 0x1;
    static final int MDM_V110_SPEED_2DOT4K = 0x2;
    static final int MDM_V110_SPEED_4DOT8K = 0x3;
    static final int MDM_V110_SPEED_9DOT6K = 0x4;
    static final int MDM_V110_SPEED_12DOT0K = 0x5;
    static final int MDM_V110_SPEED_14DOT4K = 0x6;
    static final int MDM_V110_SPEED_19DOT2K = 0x7;
    static final int MDM_V110_SPEED_28DOT8K = 0x8;
    static final int MDM_V110_SPEED_38DOT4K = 0x9;
    static final int MDM_V110_SPEED_57DOT6K = 0xA;
    static final int MDM_SHIFT_AUTO_SPEED = 0x0;
    static final int MDM_MASK_AUTO_SPEED = 0x7;
    static final int MDM_AUTO_SPEED_DEFAULT = 0x0;
    static final int MDM_SHIFT_AUTO_ML = 0x6;
    static final int MDM_MASK_AUTO_ML = (0x3<<6);
    static final int MDM_AUTO_ML_DEFAULT = 0x0;
    static final int MDM_AUTO_ML_NONE = 0x1;
    static final int MDM_AUTO_ML_2 = 0x2;
    static final int MDM_ANALOG_RLP_ON = 0x0;
    static final int MDM_ANALOG_RLP_OFF = 0x1;
    static final int MDM_ANALOG_V34 = 0x2;
    static final int MDM_PIAFS_INCOMING = 0;
    static final int MDM_PIAFS_OUTGOING = 1;
    static final int STYLE_DESCRIPTION_SIZE = 32;
    static final int IMEMENUITEM_STRING_SIZE = 80;
    static final int IMC_GETCANDIDATEPOS = 0x0007;
    static final int IMC_SETCANDIDATEPOS = 0x0008;
    static final int IMC_GETCOMPOSITIONFONT = 0x0009;
    static final int IMC_SETCOMPOSITIONFONT = 0x000A;
    static final int IMC_GETCOMPOSITIONWINDOW = 0x000B;
    static final int IMC_SETCOMPOSITIONWINDOW = 0x000C;
    static final int IMC_GETSTATUSWINDOWPOS = 0x000F;
    static final int IMC_SETSTATUSWINDOWPOS = 0x0010;
    static final int IMC_CLOSESTATUSWINDOW = 0x0021;
    static final int IMC_OPENSTATUSWINDOW = 0x0022;
    static final int NI_OPENCANDIDATE = 0x0010;
    static final int NI_CLOSECANDIDATE = 0x0011;
    static final int NI_SELECTCANDIDATESTR = 0x0012;
    static final int NI_CHANGECANDIDATELIST = 0x0013;
    static final int NI_FINALIZECONVERSIONRESULT = 0x0014;
    static final int NI_COMPOSITIONSTR = 0x0015;
    static final int NI_SETCANDIDATE_PAGESTART = 0x0016;
    static final int NI_SETCANDIDATE_PAGESIZE = 0x0017;
    static final int NI_IMEMENUSELECTED = 0x0018;
    static final int ISC_SHOWUICANDIDATEWINDOW = 0x00000001;
    static final int ISC_SHOWUICOMPOSITIONWINDOW = 0x80000000;
    static final int ISC_SHOWUIGUIDELINE = 0x40000000;
    static final int ISC_SHOWUIALLCANDIDATEWINDOW = 0x0000000F;
    static final int ISC_SHOWUIALL = 0xC000000F;
    static final int CPS_COMPLETE = 0x0001;
    static final int CPS_CONVERT = 0x0002;
    static final int CPS_REVERT = 0x0003;
    static final int CPS_CANCEL = 0x0004;
    static final int MOD_ALT = 0x0001;
    static final int MOD_CONTROL = 0x0002;
    static final int MOD_SHIFT = 0x0004;
    static final int MOD_LEFT = 0x8000;
    static final int MOD_RIGHT = 0x4000;
    static final int MOD_ON_KEYUP = 0x0800;
    static final int MOD_IGNORE_ALL_MODIFIER = 0x0400;
    static final int IME_CHOTKEY_IME_NONIME_TOGGLE = 0x10;
    static final int IME_CHOTKEY_SHAPE_TOGGLE = 0x11;
    static final int IME_CHOTKEY_SYMBOL_TOGGLE = 0x12;
    static final int IME_JHOTKEY_CLOSE_OPEN = 0x30;
    static final int IME_KHOTKEY_SHAPE_TOGGLE = 0x50;
    static final int IME_KHOTKEY_HANJACONVERT = 0x51;
    static final int IME_KHOTKEY_ENGLISH = 0x52;
    static final int IME_THOTKEY_IME_NONIME_TOGGLE = 0x70;
    static final int IME_THOTKEY_SHAPE_TOGGLE = 0x71;
    static final int IME_THOTKEY_SYMBOL_TOGGLE = 0x72;
    static final int IME_HOTKEY_DSWITCH_FIRST = 0x100;
    static final int IME_HOTKEY_DSWITCH_LAST = 0x11F;
    static final int IME_HOTKEY_PRIVATE_FIRST = 0x200;
    static final int IME_ITHOTKEY_RESEND_RESULTSTR = 0x200;
    static final int IME_ITHOTKEY_PREVIOUS_COMPOSITION = 0x201;
    static final int IME_ITHOTKEY_UISTYLE_TOGGLE = 0x202;
    static final int IME_ITHOTKEY_RECONVERTSTRING = 0x203;
    static final int IME_HOTKEY_PRIVATE_LAST = 0x21F;
    static final int GCS_COMPREADSTR = 0x0001;
    static final int GCS_COMPREADATTR = 0x0002;
    static final int GCS_COMPREADCLAUSE = 0x0004;
    static final int GCS_COMPSTR = 0x0008;
    static final int GCS_COMPATTR = 0x0010;
    static final int GCS_COMPCLAUSE = 0x0020;
    static final int GCS_CURSORPOS = 0x0080;
    static final int GCS_DELTASTART = 0x0100;
    static final int GCS_RESULTREADSTR = 0x0200;
    static final int GCS_RESULTREADCLAUSE = 0x0400;
    static final int GCS_RESULTSTR = 0x0800;
    static final int GCS_RESULTCLAUSE = 0x1000;
    static final int CS_INSERTCHAR = 0x2000;
    static final int CS_NOMOVECARET = 0x4000;
    static final int IMEVER_0310 = 0x0003000A;
    static final int IMEVER_0400 = 0x00040000;
    static final int IME_PROP_AT_CARET = 0x00010000;
    static final int IME_PROP_SPECIAL_UI = 0x00020000;
    static final int IME_PROP_CANDLIST_START_FROM_1 = 0x00040000;
    static final int IME_PROP_UNICODE = 0x00080000;
    static final int IME_PROP_COMPLETE_ON_UNSELECT = 0x00100000;
    static final int UI_CAP_2700 = 0x00000001;
    static final int UI_CAP_ROT90 = 0x00000002;
    static final int UI_CAP_ROTANY = 0x00000004;
    static final int SCS_CAP_COMPSTR = 0x00000001;
    static final int SCS_CAP_MAKEREAD = 0x00000002;
    static final int SCS_CAP_SETRECONVERTSTRING = 0x00000004;
    static final int SELECT_CAP_CONVERSION = 0x00000001;
    static final int SELECT_CAP_SENTENCE = 0x00000002;
    static final int GGL_LEVEL = 0x00000001;
    static final int GGL_INDEX = 0x00000002;
    static final int GGL_STRING = 0x00000003;
    static final int GGL_PRIVATE = 0x00000004;
    static final int GL_LEVEL_NOGUIDELINE = 0x00000000;
    static final int GL_LEVEL_FATAL = 0x00000001;
    static final int GL_LEVEL_ERROR = 0x00000002;
    static final int GL_LEVEL_WARNING = 0x00000003;
    static final int GL_LEVEL_INFORMATION = 0x00000004;
    static final int GL_ID_UNKNOWN = 0x00000000;
    static final int GL_ID_NOMODULE = 0x00000001;
    static final int GL_ID_NODICTIONARY = 0x00000010;
    static final int GL_ID_CANNOTSAVE = 0x00000011;
    static final int GL_ID_NOCONVERT = 0x00000020;
    static final int GL_ID_TYPINGERROR = 0x00000021;
    static final int GL_ID_TOOMANYSTROKE = 0x00000022;
    static final int GL_ID_READINGCONFLICT = 0x00000023;
    static final int GL_ID_INPUTREADING = 0x00000024;
    static final int GL_ID_INPUTRADICAL = 0x00000025;
    static final int GL_ID_INPUTCODE = 0x00000026;
    static final int GL_ID_INPUTSYMBOL = 0x00000027;
    static final int GL_ID_CHOOSECANDIDATE = 0x00000028;
    static final int GL_ID_REVERSECONVERSION = 0x00000029;
    static final int GL_ID_PRIVATE_FIRST = 0x00008000;
    static final int GL_ID_PRIVATE_LAST = 0x0000FFFF;
    static final int IGP_PROPERTY = 0x00000004;
    static final int IGP_CONVERSION = 0x00000008;
    static final int IGP_SENTENCE = 0x0000000c;
    static final int IGP_UI = 0x00000010;
    static final int IGP_SETCOMPSTR = 0x00000014;
    static final int IGP_SELECT = 0x00000018;
    static final int SCS_SETSTR = (GCS_COMPREADSTR|GCS_COMPSTR);
    static final int SCS_CHANGEATTR = (GCS_COMPREADATTR|GCS_COMPATTR);
    static final int SCS_CHANGECLAUSE = (GCS_COMPREADCLAUSE|GCS_COMPCLAUSE);
    static final int SCS_SETRECONVERTSTRING = 0x00010000;
    static final int SCS_QUERYRECONVERTSTRING = 0x00020000;
    static final int ATTR_INPUT = 0x00;
    static final int ATTR_TARGET_CONVERTED = 0x01;
    static final int ATTR_CONVERTED = 0x02;
    static final int ATTR_TARGET_NOTCONVERTED = 0x03;
    static final int ATTR_INPUT_ERROR = 0x04;
    static final int ATTR_FIXEDCONVERTED = 0x05;
    static final int CFS_DEFAULT = 0x0000;
    static final int CFS_RECT = 0x0001;
    static final int CFS_POINT = 0x0002;
    static final int CFS_FORCE_POSITION = 0x0020;
    static final int CFS_CANDIDATEPOS = 0x0040;
    static final int CFS_EXCLUDE = 0x0080;
    static final int GCL_CONVERSION = 0x0001;
    static final int GCL_REVERSECONVERSION = 0x0002;
    static final int GCL_REVERSE_LENGTH = 0x0003;
    static final int IME_CMODE_ALPHANUMERIC = 0x0000;
    static final int IME_CMODE_NATIVE = 0x0001;
    static final int IME_CMODE_CHINESE = IME_CMODE_NATIVE;
    static final int IME_CMODE_HANGEUL = IME_CMODE_NATIVE;
    static final int IME_CMODE_HANGUL = IME_CMODE_NATIVE;
    static final int IME_CMODE_JAPANESE = IME_CMODE_NATIVE;
    static final int IME_CMODE_KATAKANA = 0x0002;
    static final int IME_CMODE_LANGUAGE = 0x0003;
    static final int IME_CMODE_FULLSHAPE = 0x0008;
    static final int IME_CMODE_ROMAN = 0x0010;
    static final int IME_CMODE_CHARCODE = 0x0020;
    static final int IME_CMODE_HANJACONVERT = 0x0040;
    static final int IME_CMODE_SOFTKBD = 0x0080;
    static final int IME_CMODE_NOCONVERSION = 0x0100;
    static final int IME_CMODE_EUDC = 0x0200;
    static final int IME_CMODE_SYMBOL = 0x0400;
    static final int IME_CMODE_FIXED = 0x0800;
    static final int IME_CMODE_RESERVED = 0xF0000000;
    static final int IME_SMODE_NONE = 0x0000;
    static final int IME_SMODE_PLAURALCLAUSE = 0x0001;
    static final int IME_SMODE_SINGLECONVERT = 0x0002;
    static final int IME_SMODE_AUTOMATIC = 0x0004;
    static final int IME_SMODE_PHRASEPREDICT = 0x0008;
    static final int IME_SMODE_CONVERSATION = 0x0010;
    static final int IME_SMODE_RESERVED = 0x0000F000;
    static final int IME_CAND_UNKNOWN = 0x0000;
    static final int IME_CAND_READ = 0x0001;
    static final int IME_CAND_CODE = 0x0002;
    static final int IME_CAND_MEANING = 0x0003;
    static final int IME_CAND_RADICAL = 0x0004;
    static final int IME_CAND_STROKE = 0x0005;
    static final int IMN_CLOSESTATUSWINDOW = 0x0001;
    static final int IMN_OPENSTATUSWINDOW = 0x0002;
    static final int IMN_CHANGECANDIDATE = 0x0003;
    static final int IMN_CLOSECANDIDATE = 0x0004;
    static final int IMN_OPENCANDIDATE = 0x0005;
    static final int IMN_SETCONVERSIONMODE = 0x0006;
    static final int IMN_SETSENTENCEMODE = 0x0007;
    static final int IMN_SETOPENSTATUS = 0x0008;
    static final int IMN_SETCANDIDATEPOS = 0x0009;
    static final int IMN_SETCOMPOSITIONFONT = 0x000A;
    static final int IMN_SETCOMPOSITIONWINDOW = 0x000B;
    static final int IMN_SETSTATUSWINDOWPOS = 0x000C;
    static final int IMN_GUIDELINE = 0x000D;
    static final int IMN_PRIVATE = 0x000E;
    static final int IMR_COMPOSITIONWINDOW = 0x0001;
    static final int IMR_CANDIDATEWINDOW = 0x0002;
    static final int IMR_COMPOSITIONFONT = 0x0003;
    static final int IMR_RECONVERTSTRING = 0x0004;
    static final int IMR_CONFIRMRECONVERTSTRING = 0x0005;
    static final int IMR_QUERYCHARPOSITION = 0x0006;
    static final int IMR_DOCUMENTFEED = 0x0007;
    static final int IMM_ERROR_NODATA = (-1);
    static final int IMM_ERROR_GENERAL = (-2);
    static final int IME_CONFIG_GENERAL = 1;
    static final int IME_CONFIG_REGISTERWORD = 2;
    static final int IME_CONFIG_SELECTDICTIONARY = 3;
    static final int IME_ESC_QUERY_SUPPORT = 0x0003;
    static final int IME_ESC_RESERVED_FIRST = 0x0004;
    static final int IME_ESC_RESERVED_LAST = 0x07FF;
    static final int IME_ESC_PRIVATE_FIRST = 0x0800;
    static final int IME_ESC_PRIVATE_LAST = 0x0FFF;
    static final int IME_ESC_SEQUENCE_TO_INTERNAL = 0x1001;
    static final int IME_ESC_GET_EUDC_DICTIONARY = 0x1003;
    static final int IME_ESC_SET_EUDC_DICTIONARY = 0x1004;
    static final int IME_ESC_MAX_KEY = 0x1005;
    static final int IME_ESC_IME_NAME = 0x1006;
    static final int IME_ESC_SYNC_HOTKEY = 0x1007;
    static final int IME_ESC_HANJA_MODE = 0x1008;
    static final int IME_ESC_AUTOMATA = 0x1009;
    static final int IME_ESC_PRIVATE_HOTKEY = 0x100a;
    static final int IME_ESC_GETHELPFILENAME = 0x100b;
    static final int IME_REGWORD_STYLE_EUDC = 0x00000001;
    static final int IME_REGWORD_STYLE_USER_FIRST = 0x80000000;
    static final int IME_REGWORD_STYLE_USER_LAST = 0xFFFFFFFF;
    static final int IACE_CHILDREN = 0x0001;
    static final int IACE_DEFAULT = 0x0010;
    static final int IACE_IGNORENOCONTEXT = 0x0020;
    static final int IGIMIF_RIGHTMENU = 0x0001;
    static final int IGIMII_CMODE = 0x0001;
    static final int IGIMII_SMODE = 0x0002;
    static final int IGIMII_CONFIGURE = 0x0004;
    static final int IGIMII_TOOLS = 0x0008;
    static final int IGIMII_HELP = 0x0010;
    static final int IGIMII_OTHER = 0x0020;
    static final int IGIMII_INPUTTOOLS = 0x0040;
    static final int IMFT_RADIOCHECK = 0x00001;
    static final int IMFT_SEPARATOR = 0x00002;
    static final int IMFT_SUBMENU = 0x00004;
    static final int IMFS_GRAYED = MFS_GRAYED;
    static final int IMFS_DISABLED = MFS_DISABLED;
    static final int IMFS_CHECKED = MFS_CHECKED;
    static final int IMFS_HILITE = MFS_HILITE;
    static final int IMFS_ENABLED = MFS_ENABLED;
    static final int IMFS_UNCHECKED = MFS_UNCHECKED;
    static final int IMFS_UNHILITE = MFS_UNHILITE;
    static final int IMFS_DEFAULT = MFS_DEFAULT;
    static final int SOFTKEYBOARD_TYPE_T1 = 0x0001;
    static final int SOFTKEYBOARD_TYPE_C1 = 0x0002;
    static final int DIRECTDRAW_VERSION = 0x0700;
    static final int _FACDD = 0x876;
    static final int DDENUM_ATTACHEDSECONDARYDEVICES = 0x00000001;
    static final int DDENUM_DETACHEDSECONDARYDEVICES = 0x00000002;
    static final int DDENUM_NONDISPLAYDEVICES = 0x00000004;
    static final int MAX_DDDEVICEID_STRING = 512;
    static final int DDGDI_GETHOSTIDENTIFIER = 0x00000001;
    static final int DDSCAPS2_RESERVED4 = 0x00000002;
    static final int DDSCAPS2_HARDWAREDEINTERLACE = 0x00000000;
    static final int DDSCAPS2_HINTDYNAMIC = 0x00000004;
    static final int DDSCAPS2_HINTSTATIC = 0x00000008;
    static final int DDSCAPS2_TEXTUREMANAGE = 0x00000010;
    static final int DDSCAPS2_RESERVED1 = 0x00000020;
    static final int DDSCAPS2_RESERVED2 = 0x00000040;
    static final int DDSCAPS2_OPAQUE = 0x00000080;
    static final int DDSCAPS2_HINTANTIALIASING = 0x00000100;
    static final int DDSCAPS2_CUBEMAP = 0x00000200;
    static final int DDSCAPS2_CUBEMAP_POSITIVEX = 0x00000400;
    static final int DDSCAPS2_CUBEMAP_NEGATIVEX = 0x00000800;
    static final int DDSCAPS2_CUBEMAP_POSITIVEY = 0x00001000;
    static final int DDSCAPS2_CUBEMAP_NEGATIVEY = 0x00002000;
    static final int DDSCAPS2_CUBEMAP_POSITIVEZ = 0x00004000;
    static final int DDSCAPS2_CUBEMAP_NEGATIVEZ = 0x00008000;
    static final int DDSCAPS2_CUBEMAP_ALLFACES = ( DDSCAPS2_CUBEMAP_POSITIVEX | DDSCAPS2_CUBEMAP_NEGATIVEX | DDSCAPS2_CUBEMAP_POSITIVEY | DDSCAPS2_CUBEMAP_NEGATIVEY | DDSCAPS2_CUBEMAP_POSITIVEZ | DDSCAPS2_CUBEMAP_NEGATIVEZ );
    static final int DDSCAPS2_MIPMAPSUBLEVEL = 0x00010000;
    static final int DDSCAPS2_D3DTEXTUREMANAGE = 0x00020000;
    static final int DDSCAPS2_DONOTPERSIST = 0x00040000;
    static final int DDSCAPS2_STEREOSURFACELEFT = 0x00080000;
    static final int DDSCAPS2_VOLUME = 0x00200000;
    static final int DDSCAPS2_NOTUSERLOCKABLE = 0x00400000;
    static final int DDSCAPS2_POINTS = 0x00800000;
    static final int DDSCAPS2_RTPATCHES = 0x01000000;
    static final int DDSCAPS2_NPATCHES = 0x02000000;
    static final int DDSCAPS2_RESERVED3 = 0x04000000;
    static final int DDSCAPS2_DISCARDBACKBUFFER = 0x10000000;
    static final int DDSCAPS2_ENABLEALPHACHANNEL = 0x20000000;
    static final int DDSCAPS3_MULTISAMPLE_MASK = 0x0000001F;
    static final int DDCAPS2_STEREO = 0x02000000;
    static final int DDCAPS2_SYSTONONLOCAL_AS_SYSTOLOCAL = 0x04000000;
    static final int DDCAPS2_RESERVED1 = 0x08000000;
    static final int DDCAPS2_CANMANAGERESOURCE = 0x10000000;
    static final int DDCAPS2_DYNAMICTEXTURES = 0x20000000;
    static final int DDSVCAPS_STEREOSEQUENTIAL = 0x00000010;
    static final int DDSPD_IUNKNOWNPOINTER = 0x00000001;
    static final int DDSPD_VOLATILE = 0x00000002;
    static final int DDEDM_STANDARDVGAMODES = 0x00000002;
    static final int DDBLTFAST_NOCOLORKEY = 0x00000000;
    static final int DDBLTFAST_SRCCOLORKEY = 0x00000001;
    static final int DDBLTFAST_DESTCOLORKEY = 0x00000002;
    static final int DDBLTFAST_WAIT = 0x00000010;
    static final int DDBLTFAST_DONOTWAIT = 0x00000020;
    static final int DDFLIP_WAIT = 0x00000001;
    static final int DDFLIP_EVEN = 0x00000002;
    static final int DDFLIP_ODD = 0x00000004;
    static final int DDFLIP_NOVSYNC = 0x00000008;
    static final int DDFLIP_INTERVAL2 = 0x02000000;
    static final int DDFLIP_INTERVAL3 = 0x03000000;
    static final int DDFLIP_INTERVAL4 = 0x04000000;
    static final int DDFLIP_STEREO = 0x00000010;
    static final int DDFLIP_DONOTWAIT = 0x00000020;
    static final int DDLOCK_SURFACEMEMORYPTR = 0x00000000;
    static final int DDLOCK_WAIT = 0x00000001;
    static final int DDLOCK_EVENT = 0x00000002;
    static final int DDLOCK_READONLY = 0x00000010;
    static final int DDLOCK_WRITEONLY = 0x00000020;
    static final int DDLOCK_NOSYSLOCK = 0x00000800;
    static final int DDLOCK_NOOVERWRITE = 0x00001000;
    static final int DDLOCK_DISCARDCONTENTS = 0x00002000;
    static final int DDLOCK_OKTOSWAP = 0x00002000;
    static final int DDLOCK_DONOTWAIT = 0x00004000;
    static final int DDLOCK_HASVOLUMETEXTUREBOXRECT = 0x00008000;
    static final int DDLOCK_NODIRTYUPDATE = 0x00010000;
    static final int DDSGR_CALIBRATE = 0x00000001;
    static final int DDSMT_ISTESTREQUIRED = 0x00000001;
    static final int DDEM_MODEPASSED = 0x00000001;
    static final int DDEM_MODEFAILED = 0x00000002;
    static final int DD_OK = S_OK;
    static final int DD_FALSE = S_FALSE;
    static final int DDENUMRET_CANCEL = 0;
    static final int DDENUMRET_OK = 1;
    static final int GDIP_EMFPLUS_RECORD_BASE = 0x00004000;
    static final int GDIP_WMF_RECORD_BASE = 0x00010000;
    static final int ALPHA_SHIFT = 24;
    static final int RED_SHIFT = 16;
    static final int GREEN_SHIFT = 8;
    static final int BLUE_SHIFT = 0;
    static final int PixelFormatIndexed = 0x00010000;
    static final int PixelFormatGDI = 0x00020000;
    static final int PixelFormatAlpha = 0x00040000;
    static final int PixelFormatPAlpha = 0x00080000;
    static final int PixelFormatExtended = 0x00100000;
    static final int PixelFormatCanonical = 0x00200000;
    static final int PixelFormatUndefined = 0;
    static final int PixelFormatDontCare = 0;
    static final int PixelFormat1bppIndexed = (1 | ( 1 << 8) | PixelFormatIndexed | PixelFormatGDI);
    static final int PixelFormat4bppIndexed = (2 | ( 4 << 8) | PixelFormatIndexed | PixelFormatGDI);
    static final int PixelFormat8bppIndexed = (3 | ( 8 << 8) | PixelFormatIndexed | PixelFormatGDI);
    static final int PixelFormat16bppGrayScale = (4 | (16 << 8) | PixelFormatExtended);
    static final int PixelFormat16bppRGB555 = (5 | (16 << 8) | PixelFormatGDI);
    static final int PixelFormat16bppRGB565 = (6 | (16 << 8) | PixelFormatGDI);
    static final int PixelFormat16bppARGB1555 = (7 | (16 << 8) | PixelFormatAlpha | PixelFormatGDI);
    static final int PixelFormat24bppRGB = (8 | (24 << 8) | PixelFormatGDI);
    static final int PixelFormat32bppRGB = (9 | (32 << 8) | PixelFormatGDI);
    static final int PixelFormat32bppARGB = (10 | (32 << 8) | PixelFormatAlpha | PixelFormatGDI | PixelFormatCanonical);
    static final int PixelFormat32bppPARGB = (11 | (32 << 8) | PixelFormatAlpha | PixelFormatPAlpha | PixelFormatGDI);
    static final int PixelFormat48bppRGB = (12 | (48 << 8) | PixelFormatExtended);
    static final int PixelFormat64bppARGB = (13 | (64 << 8) | PixelFormatAlpha | PixelFormatCanonical | PixelFormatExtended);
    static final int PixelFormat64bppPARGB = (14 | (64 << 8) | PixelFormatAlpha | PixelFormatPAlpha | PixelFormatExtended);
    static final int PixelFormatMax = 15;
    static final int GDIP_EMFPLUSFLAGS_DISPLAY = 0x00000001;
    static final int PropertyTagTypeByte = 1;
    static final int PropertyTagTypeASCII = 2;
    static final int PropertyTagTypeShort = 3;
    static final int PropertyTagTypeLong = 4;
    static final int PropertyTagTypeRational = 5;
    static final int PropertyTagTypeUndefined = 7;
    static final int PropertyTagTypeSLONG = 9;
    static final int PropertyTagTypeSRational = 10;
    static final int PropertyTagExifIFD = 0x8769;
    static final int PropertyTagGpsIFD = 0x8825;
    static final int PropertyTagNewSubfileType = 0x00FE;
    static final int PropertyTagSubfileType = 0x00FF;
    static final int PropertyTagImageWidth = 0x0100;
    static final int PropertyTagImageHeight = 0x0101;
    static final int PropertyTagBitsPerSample = 0x0102;
    static final int PropertyTagCompression = 0x0103;
    static final int PropertyTagPhotometricInterp = 0x0106;
    static final int PropertyTagThreshHolding = 0x0107;
    static final int PropertyTagCellWidth = 0x0108;
    static final int PropertyTagCellHeight = 0x0109;
    static final int PropertyTagFillOrder = 0x010A;
    static final int PropertyTagDocumentName = 0x010D;
    static final int PropertyTagImageDescription = 0x010E;
    static final int PropertyTagEquipMake = 0x010F;
    static final int PropertyTagEquipModel = 0x0110;
    static final int PropertyTagStripOffsets = 0x0111;
    static final int PropertyTagOrientation = 0x0112;
    static final int PropertyTagSamplesPerPixel = 0x0115;
    static final int PropertyTagRowsPerStrip = 0x0116;
    static final int PropertyTagStripBytesCount = 0x0117;
    static final int PropertyTagMinSampleValue = 0x0118;
    static final int PropertyTagMaxSampleValue = 0x0119;
    static final int PropertyTagXResolution = 0x011A;
    static final int PropertyTagYResolution = 0x011B;
    static final int PropertyTagPlanarConfig = 0x011C;
    static final int PropertyTagPageName = 0x011D;
    static final int PropertyTagXPosition = 0x011E;
    static final int PropertyTagYPosition = 0x011F;
    static final int PropertyTagFreeOffset = 0x0120;
    static final int PropertyTagFreeByteCounts = 0x0121;
    static final int PropertyTagGrayResponseUnit = 0x0122;
    static final int PropertyTagGrayResponseCurve = 0x0123;
    static final int PropertyTagT4Option = 0x0124;
    static final int PropertyTagT6Option = 0x0125;
    static final int PropertyTagResolutionUnit = 0x0128;
    static final int PropertyTagPageNumber = 0x0129;
    static final int PropertyTagTransferFuncition = 0x012D;
    static final int PropertyTagSoftwareUsed = 0x0131;
    static final int PropertyTagDateTime = 0x0132;
    static final int PropertyTagArtist = 0x013B;
    static final int PropertyTagHostComputer = 0x013C;
    static final int PropertyTagPredictor = 0x013D;
    static final int PropertyTagWhitePoint = 0x013E;
    static final int PropertyTagPrimaryChromaticities = 0x013F;
    static final int PropertyTagColorMap = 0x0140;
    static final int PropertyTagHalftoneHints = 0x0141;
    static final int PropertyTagTileWidth = 0x0142;
    static final int PropertyTagTileLength = 0x0143;
    static final int PropertyTagTileOffset = 0x0144;
    static final int PropertyTagTileByteCounts = 0x0145;
    static final int PropertyTagInkSet = 0x014C;
    static final int PropertyTagInkNames = 0x014D;
    static final int PropertyTagNumberOfInks = 0x014E;
    static final int PropertyTagDotRange = 0x0150;
    static final int PropertyTagTargetPrinter = 0x0151;
    static final int PropertyTagExtraSamples = 0x0152;
    static final int PropertyTagSampleFormat = 0x0153;
    static final int PropertyTagSMinSampleValue = 0x0154;
    static final int PropertyTagSMaxSampleValue = 0x0155;
    static final int PropertyTagTransferRange = 0x0156;
    static final int PropertyTagJPEGProc = 0x0200;
    static final int PropertyTagJPEGInterFormat = 0x0201;
    static final int PropertyTagJPEGInterLength = 0x0202;
    static final int PropertyTagJPEGRestartInterval = 0x0203;
    static final int PropertyTagJPEGLosslessPredictors = 0x0205;
    static final int PropertyTagJPEGPointTransforms = 0x0206;
    static final int PropertyTagJPEGQTables = 0x0207;
    static final int PropertyTagJPEGDCTables = 0x0208;
    static final int PropertyTagJPEGACTables = 0x0209;
    static final int PropertyTagYCbCrCoefficients = 0x0211;
    static final int PropertyTagYCbCrSubsampling = 0x0212;
    static final int PropertyTagYCbCrPositioning = 0x0213;
    static final int PropertyTagREFBlackWhite = 0x0214;
    static final int PropertyTagICCProfile = 0x8773;
    static final int PropertyTagGamma = 0x0301;
    static final int PropertyTagICCProfileDescriptor = 0x0302;
    static final int PropertyTagSRGBRenderingIntent = 0x0303;
    static final int PropertyTagImageTitle = 0x0320;
    static final int PropertyTagCopyright = 0x8298;
    static final int PropertyTagResolutionXUnit = 0x5001;
    static final int PropertyTagResolutionYUnit = 0x5002;
    static final int PropertyTagResolutionXLengthUnit = 0x5003;
    static final int PropertyTagResolutionYLengthUnit = 0x5004;
    static final int PropertyTagPrintFlags = 0x5005;
    static final int PropertyTagPrintFlagsVersion = 0x5006;
    static final int PropertyTagPrintFlagsCrop = 0x5007;
    static final int PropertyTagPrintFlagsBleedWidth = 0x5008;
    static final int PropertyTagPrintFlagsBleedWidthScale = 0x5009;
    static final int PropertyTagHalftoneLPI = 0x500A;
    static final int PropertyTagHalftoneLPIUnit = 0x500B;
    static final int PropertyTagHalftoneDegree = 0x500C;
    static final int PropertyTagHalftoneShape = 0x500D;
    static final int PropertyTagHalftoneMisc = 0x500E;
    static final int PropertyTagHalftoneScreen = 0x500F;
    static final int PropertyTagJPEGQuality = 0x5010;
    static final int PropertyTagGridSize = 0x5011;
    static final int PropertyTagThumbnailFormat = 0x5012;
    static final int PropertyTagThumbnailWidth = 0x5013;
    static final int PropertyTagThumbnailHeight = 0x5014;
    static final int PropertyTagThumbnailColorDepth = 0x5015;
    static final int PropertyTagThumbnailPlanes = 0x5016;
    static final int PropertyTagThumbnailRawBytes = 0x5017;
    static final int PropertyTagThumbnailSize = 0x5018;
    static final int PropertyTagThumbnailCompressedSize = 0x5019;
    static final int PropertyTagColorTransferFunction = 0x501A;
    static final int PropertyTagThumbnailData = 0x501B;
    static final int PropertyTagThumbnailImageWidth = 0x5020;
    static final int PropertyTagThumbnailImageHeight = 0x5021;
    static final int PropertyTagThumbnailBitsPerSample = 0x5022;
    static final int PropertyTagThumbnailCompression = 0x5023;
    static final int PropertyTagThumbnailPhotometricInterp = 0x5024;
    static final int PropertyTagThumbnailImageDescription = 0x5025;
    static final int PropertyTagThumbnailEquipMake = 0x5026;
    static final int PropertyTagThumbnailEquipModel = 0x5027;
    static final int PropertyTagThumbnailStripOffsets = 0x5028;
    static final int PropertyTagThumbnailOrientation = 0x5029;
    static final int PropertyTagThumbnailSamplesPerPixel = 0x502A;
    static final int PropertyTagThumbnailRowsPerStrip = 0x502B;
    static final int PropertyTagThumbnailStripBytesCount = 0x502C;
    static final int PropertyTagThumbnailResolutionX = 0x502D;
    static final int PropertyTagThumbnailResolutionY = 0x502E;
    static final int PropertyTagThumbnailPlanarConfig = 0x502F;
    static final int PropertyTagThumbnailResolutionUnit = 0x5030;
    static final int PropertyTagThumbnailTransferFunction = 0x5031;
    static final int PropertyTagThumbnailSoftwareUsed = 0x5032;
    static final int PropertyTagThumbnailDateTime = 0x5033;
    static final int PropertyTagThumbnailArtist = 0x5034;
    static final int PropertyTagThumbnailWhitePoint = 0x5035;
    static final int PropertyTagThumbnailPrimaryChromaticities = 0x5036;
    static final int PropertyTagThumbnailYCbCrCoefficients = 0x5037;
    static final int PropertyTagThumbnailYCbCrSubsampling = 0x5038;
    static final int PropertyTagThumbnailYCbCrPositioning = 0x5039;
    static final int PropertyTagThumbnailRefBlackWhite = 0x503A;
    static final int PropertyTagThumbnailCopyRight = 0x503B;
    static final int PropertyTagLuminanceTable = 0x5090;
    static final int PropertyTagChrominanceTable = 0x5091;
    static final int PropertyTagFrameDelay = 0x5100;
    static final int PropertyTagLoopCount = 0x5101;
    static final int PropertyTagPixelUnit = 0x5110;
    static final int PropertyTagPixelPerUnitX = 0x5111;
    static final int PropertyTagPixelPerUnitY = 0x5112;
    static final int PropertyTagPaletteHistogram = 0x5113;
    static final int PropertyTagExifExposureTime = 0x829A;
    static final int PropertyTagExifFNumber = 0x829D;
    static final int PropertyTagExifExposureProg = 0x8822;
    static final int PropertyTagExifSpectralSense = 0x8824;
    static final int PropertyTagExifISOSpeed = 0x8827;
    static final int PropertyTagExifOECF = 0x8828;
    static final int PropertyTagExifVer = 0x9000;
    static final int PropertyTagExifDTOrig = 0x9003;
    static final int PropertyTagExifDTDigitized = 0x9004;
    static final int PropertyTagExifCompConfig = 0x9101;
    static final int PropertyTagExifCompBPP = 0x9102;
    static final int PropertyTagExifShutterSpeed = 0x9201;
    static final int PropertyTagExifAperture = 0x9202;
    static final int PropertyTagExifBrightness = 0x9203;
    static final int PropertyTagExifExposureBias = 0x9204;
    static final int PropertyTagExifMaxAperture = 0x9205;
    static final int PropertyTagExifSubjectDist = 0x9206;
    static final int PropertyTagExifMeteringMode = 0x9207;
    static final int PropertyTagExifLightSource = 0x9208;
    static final int PropertyTagExifFlash = 0x9209;
    static final int PropertyTagExifFocalLength = 0x920A;
    static final int PropertyTagExifMakerNote = 0x927C;
    static final int PropertyTagExifUserComment = 0x9286;
    static final int PropertyTagExifDTSubsec = 0x9290;
    static final int PropertyTagExifDTOrigSS = 0x9291;
    static final int PropertyTagExifDTDigSS = 0x9292;
    static final int PropertyTagExifFPXVer = 0xA000;
    static final int PropertyTagExifColorSpace = 0xA001;
    static final int PropertyTagExifPixXDim = 0xA002;
    static final int PropertyTagExifPixYDim = 0xA003;
    static final int PropertyTagExifRelatedWav = 0xA004;
    static final int PropertyTagExifInterop = 0xA005;
    static final int PropertyTagExifFlashEnergy = 0xA20B;
    static final int PropertyTagExifSpatialFR = 0xA20C;
    static final int PropertyTagExifFocalXRes = 0xA20E;
    static final int PropertyTagExifFocalYRes = 0xA20F;
    static final int PropertyTagExifFocalResUnit = 0xA210;
    static final int PropertyTagExifSubjectLoc = 0xA214;
    static final int PropertyTagExifExposureIndex = 0xA215;
    static final int PropertyTagExifSensingMethod = 0xA217;
    static final int PropertyTagExifFileSource = 0xA300;
    static final int PropertyTagExifSceneType = 0xA301;
    static final int PropertyTagExifCfaPattern = 0xA302;
    static final int PropertyTagGpsVer = 0x0000;
    static final int PropertyTagGpsLatitudeRef = 0x0001;
    static final int PropertyTagGpsLatitude = 0x0002;
    static final int PropertyTagGpsLongitudeRef = 0x0003;
    static final int PropertyTagGpsLongitude = 0x0004;
    static final int PropertyTagGpsAltitudeRef = 0x0005;
    static final int PropertyTagGpsAltitude = 0x0006;
    static final int PropertyTagGpsGpsTime = 0x0007;
    static final int PropertyTagGpsGpsSatellites = 0x0008;
    static final int PropertyTagGpsGpsStatus = 0x0009;
    static final int PropertyTagGpsGpsMeasureMode = 0x00A;
    static final int PropertyTagGpsGpsDop = 0x000B;
    static final int PropertyTagGpsSpeedRef = 0x000C;
    static final int PropertyTagGpsSpeed = 0x000D;
    static final int PropertyTagGpsTrackRef = 0x000E;
    static final int PropertyTagGpsTrack = 0x000F;
    static final int PropertyTagGpsImgDirRef = 0x0010;
    static final int PropertyTagGpsImgDir = 0x0011;
    static final int PropertyTagGpsMapDatum = 0x0012;
    static final int PropertyTagGpsDestLatRef = 0x0013;
    static final int PropertyTagGpsDestLat = 0x0014;
    static final int PropertyTagGpsDestLongRef = 0x0015;
    static final int PropertyTagGpsDestLong = 0x0016;
    static final int PropertyTagGpsDestBearRef = 0x0017;
    static final int PropertyTagGpsDestBear = 0x0018;
    static final int PropertyTagGpsDestDistRef = 0x0019;
    static final int PropertyTagGpsDestDist = 0x001A;
    static final int SCHEMADEF_VERSION = 1;
    static final int THEMEMGR_VERSION = 1;
    static final int ICC_LISTVIEW_CLASSES = 0x00000001;
    static final int ICC_TREEVIEW_CLASSES = 0x00000002;
    static final int ICC_BAR_CLASSES = 0x00000004;
    static final int ICC_TAB_CLASSES = 0x00000008;
    static final int ICC_UPDOWN_CLASS = 0x00000010;
    static final int ICC_PROGRESS_CLASS = 0x00000020;
    static final int ICC_HOTKEY_CLASS = 0x00000040;
    static final int ICC_ANIMATE_CLASS = 0x00000080;
    static final int ICC_WIN95_CLASSES = 0x000000FF;
    static final int ICC_DATE_CLASSES = 0x00000100;
    static final int ICC_USEREX_CLASSES = 0x00000200;
    static final int ICC_COOL_CLASSES = 0x00000400;
    static final int ICC_INTERNET_CLASSES = 0x00000800;
    static final int ICC_PAGESCROLLER_CLASS = 0x00001000;
    static final int ICC_NATIVEFNTCTL_CLASS = 0x00002000;
    static final int ODT_HEADER = 100;
    static final int ODT_TAB = 101;
    static final int ODT_LISTVIEW = 102;
    static final int LVM_FIRST = 0x1000;
    static final int TV_FIRST = 0x1100;
    static final int HDM_FIRST = 0x1200;
    static final int TCM_FIRST = 0x1300;
    static final int PGM_FIRST = 0x1400;
    static final int CCM_FIRST = 0x2000;
    static final int CCM_LAST = (CCM_FIRST + 0x200);
    static final int CCM_SETBKCOLOR = (CCM_FIRST + 1);
    static final int CCM_SETCOLORSCHEME = (CCM_FIRST + 2);
    static final int CCM_GETCOLORSCHEME = (CCM_FIRST + 3);
    static final int CCM_GETDROPTARGET = (CCM_FIRST + 4);
    static final int CCM_SETUNICODEFORMAT = (CCM_FIRST + 5);
    static final int CCM_GETUNICODEFORMAT = (CCM_FIRST + 6);
    static final int COMCTL32_VERSION = 5;
    static final int CCM_SETVERSION = (CCM_FIRST + 0x7);
    static final int CCM_GETVERSION = (CCM_FIRST + 0x8);
    static final int CCM_SETNOTIFYWINDOW = (CCM_FIRST + 0x9);
    static final int INFOTIPSIZE = 1024;
    static final int MSGF_COMMCTRL_BEGINDRAG = 0x4200;
    static final int MSGF_COMMCTRL_SIZEHEADER = 0x4201;
    static final int MSGF_COMMCTRL_DRAGSELECT = 0x4202;
    static final int MSGF_COMMCTRL_TOOLBARCUST = 0x4203;
    static final int CDRF_DODEFAULT = 0x00000000;
    static final int CDRF_NEWFONT = 0x00000002;
    static final int CDRF_SKIPDEFAULT = 0x00000004;
    static final int CDRF_NOTIFYPOSTPAINT = 0x00000010;
    static final int CDRF_NOTIFYITEMDRAW = 0x00000020;
    static final int CDRF_NOTIFYSUBITEMDRAW = 0x00000020;
    static final int CDRF_NOTIFYPOSTERASE = 0x00000040;
    static final int CDDS_PREPAINT = 0x00000001;
    static final int CDDS_POSTPAINT = 0x00000002;
    static final int CDDS_PREERASE = 0x00000003;
    static final int CDDS_POSTERASE = 0x00000004;
    static final int CDDS_ITEM = 0x00010000;
    static final int CDDS_ITEMPREPAINT = (CDDS_ITEM | CDDS_PREPAINT);
    static final int CDDS_ITEMPOSTPAINT = (CDDS_ITEM | CDDS_POSTPAINT);
    static final int CDDS_ITEMPREERASE = (CDDS_ITEM | CDDS_PREERASE);
    static final int CDDS_ITEMPOSTERASE = (CDDS_ITEM | CDDS_POSTERASE);
    static final int CDDS_SUBITEM = 0x00020000;
    static final int CDIS_SELECTED = 0x0001;
    static final int CDIS_GRAYED = 0x0002;
    static final int CDIS_DISABLED = 0x0004;
    static final int CDIS_CHECKED = 0x0008;
    static final int CDIS_FOCUS = 0x0010;
    static final int CDIS_DEFAULT = 0x0020;
    static final int CDIS_HOT = 0x0040;
    static final int CDIS_MARKED = 0x0080;
    static final int CDIS_INDETERMINATE = 0x0100;
    static final int CLR_NONE = 0xFFFFFFFF;
    static final int CLR_DEFAULT = 0xFF000000;
    static final int ILC_MASK = 0x00000001;
    static final int ILC_COLOR = 0x00000000;
    static final int ILC_COLORDDB = 0x000000FE;
    static final int ILC_COLOR4 = 0x00000004;
    static final int ILC_COLOR8 = 0x00000008;
    static final int ILC_COLOR16 = 0x00000010;
    static final int ILC_COLOR24 = 0x00000018;
    static final int ILC_COLOR32 = 0x00000020;
    static final int ILC_PALETTE = 0x00000800;
    static final int ILD_NORMAL = 0x00000000;
    static final int ILD_TRANSPARENT = 0x00000001;
    static final int ILD_MASK = 0x00000010;
    static final int ILD_IMAGE = 0x00000020;
    static final int ILD_ROP = 0x00000040;
    static final int ILD_BLEND25 = 0x00000002;
    static final int ILD_BLEND50 = 0x00000004;
    static final int ILD_OVERLAYMASK = 0x00000F00;
    static final int ILD_PRESERVEALPHA = 0x00001000;
    static final int ILD_SCALE = 0x00002000;
    static final int ILD_DPISCALE = 0x00004000;
    static final int ILD_SELECTED = ILD_BLEND50;
    static final int ILD_FOCUS = ILD_BLEND25;
    static final int ILD_BLEND = ILD_BLEND50;
    static final int CLR_HILIGHT = CLR_DEFAULT;
    static final int ILS_NORMAL = 0x00000000;
    static final int ILS_GLOW = 0x00000001;
    static final int ILS_SHADOW = 0x00000002;
    static final int ILS_SATURATE = 0x00000004;
    static final int ILS_ALPHA = 0x00000008;
    static final int ILCF_MOVE = (0x00000000);
    static final int ILCF_SWAP = (0x00000001);
    static final int HDS_HORZ = 0x0000;
    static final int HDS_BUTTONS = 0x0002;
    static final int HDS_HOTTRACK = 0x0004;
    static final int HDS_HIDDEN = 0x0008;
    static final int HDS_DRAGDROP = 0x0040;
    static final int HDS_FULLDRAG = 0x0080;
    static final int HDS_FILTERBAR = 0x0100;
    static final int HDFT_ISSTRING = 0x0000;
    static final int HDFT_ISNUMBER = 0x0001;
    static final int HDFT_HASNOVALUE = 0x8000;
    static final int HDI_WIDTH = 0x0001;
    static final int HDI_HEIGHT = HDI_WIDTH;
    static final int HDI_TEXT = 0x0002;
    static final int HDI_FORMAT = 0x0004;
    static final int HDI_LPARAM = 0x0008;
    static final int HDI_BITMAP = 0x0010;
    static final int HDI_IMAGE = 0x0020;
    static final int HDI_DI_SETITEM = 0x0040;
    static final int HDI_ORDER = 0x0080;
    static final int HDI_FILTER = 0x0100;
    static final int HDF_LEFT = 0x0000;
    static final int HDF_RIGHT = 0x0001;
    static final int HDF_CENTER = 0x0002;
    static final int HDF_JUSTIFYMASK = 0x0003;
    static final int HDF_RTLREADING = 0x0004;
    static final int HDF_OWNERDRAW = 0x8000;
    static final int HDF_STRING = 0x4000;
    static final int HDF_BITMAP = 0x2000;
    static final int HDF_BITMAP_ON_RIGHT = 0x1000;
    static final int HDF_IMAGE = 0x0800;
    static final int HDM_GETITEMCOUNT = (HDM_FIRST + 0);
    static final int HDM_INSERTITEMA = (HDM_FIRST + 1);
    static final int HDM_INSERTITEMW = (HDM_FIRST + 10);
    static final int HDM_INSERTITEM = HDM_INSERTITEMA;
    static final int HDM_DELETEITEM = (HDM_FIRST + 2);
    static final int HDM_GETITEMA = (HDM_FIRST + 3);
    static final int HDM_GETITEMW = (HDM_FIRST + 11);
    static final int HDM_GETITEM = HDM_GETITEMA;
    static final int HDM_SETITEMA = (HDM_FIRST + 4);
    static final int HDM_SETITEMW = (HDM_FIRST + 12);
    static final int HDM_SETITEM = HDM_SETITEMA;
    static final int HDM_LAYOUT = (HDM_FIRST + 5);
    static final int HHT_NOWHERE = 0x0001;
    static final int HHT_ONHEADER = 0x0002;
    static final int HHT_ONDIVIDER = 0x0004;
    static final int HHT_ONDIVOPEN = 0x0008;
    static final int HHT_ONFILTER = 0x0010;
    static final int HHT_ONFILTERBUTTON = 0x0020;
    static final int HHT_ABOVE = 0x0100;
    static final int HHT_BELOW = 0x0200;
    static final int HHT_TORIGHT = 0x0400;
    static final int HHT_TOLEFT = 0x0800;
    static final int HDM_HITTEST = (HDM_FIRST + 6);
    static final int HDM_GETITEMRECT = (HDM_FIRST + 7);
    static final int HDM_SETIMAGELIST = (HDM_FIRST + 8);
    static final int HDM_GETIMAGELIST = (HDM_FIRST + 9);
    static final int HDM_ORDERTOINDEX = (HDM_FIRST + 15);
    static final int HDM_CREATEDRAGIMAGE = (HDM_FIRST + 16);
    static final int HDM_GETORDERARRAY = (HDM_FIRST + 17);
    static final int HDM_SETORDERARRAY = (HDM_FIRST + 18);
    static final int HDM_SETHOTDIVIDER = (HDM_FIRST + 19);
    static final int HDM_SETBITMAPMARGIN = (HDM_FIRST + 20);
    static final int HDM_GETBITMAPMARGIN = (HDM_FIRST + 21);
    static final int HDM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int HDM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int HDM_SETFILTERCHANGETIMEOUT = (HDM_FIRST+22);
    static final int HDM_EDITFILTER = (HDM_FIRST+23);
    static final int HDM_CLEARFILTER = (HDM_FIRST+24);
    static final int CMB_MASKED = 0x02;
    static final int TBSTATE_CHECKED = 0x01;
    static final int TBSTATE_PRESSED = 0x02;
    static final int TBSTATE_ENABLED = 0x04;
    static final int TBSTATE_HIDDEN = 0x08;
    static final int TBSTATE_INDETERMINATE = 0x10;
    static final int TBSTATE_WRAP = 0x20;
    static final int TBSTATE_ELLIPSES = 0x40;
    static final int TBSTATE_MARKED = 0x80;
    static final int TBSTYLE_BUTTON = 0x0000;
    static final int TBSTYLE_SEP = 0x0001;
    static final int TBSTYLE_CHECK = 0x0002;
    static final int TBSTYLE_GROUP = 0x0004;
    static final int TBSTYLE_CHECKGROUP = (TBSTYLE_GROUP | TBSTYLE_CHECK);
    static final int TBSTYLE_DROPDOWN = 0x0008;
    static final int TBSTYLE_AUTOSIZE = 0x0010;
    static final int TBSTYLE_NOPREFIX = 0x0020;
    static final int TBSTYLE_TOOLTIPS = 0x0100;
    static final int TBSTYLE_WRAPABLE = 0x0200;
    static final int TBSTYLE_ALTDRAG = 0x0400;
    static final int TBSTYLE_FLAT = 0x0800;
    static final int TBSTYLE_LIST = 0x1000;
    static final int TBSTYLE_CUSTOMERASE = 0x2000;
    static final int TBSTYLE_REGISTERDROP = 0x4000;
    static final int TBSTYLE_TRANSPARENT = 0x8000;
    static final int TBSTYLE_EX_DRAWDDARROWS = 0x00000001;
    static final int BTNS_BUTTON = TBSTYLE_BUTTON;
    static final int BTNS_SEP = TBSTYLE_SEP;
    static final int BTNS_CHECK = TBSTYLE_CHECK;
    static final int BTNS_GROUP = TBSTYLE_GROUP;
    static final int BTNS_CHECKGROUP = TBSTYLE_CHECKGROUP;
    static final int BTNS_DROPDOWN = TBSTYLE_DROPDOWN;
    static final int BTNS_AUTOSIZE = TBSTYLE_AUTOSIZE;
    static final int BTNS_NOPREFIX = TBSTYLE_NOPREFIX;
    static final int BTNS_SHOWTEXT = 0x0040;
    static final int BTNS_WHOLEDROPDOWN = 0x0080;
    static final int TBSTYLE_EX_MIXEDBUTTONS = 0x00000008;
    static final int TBSTYLE_EX_HIDECLIPPEDBUTTONS = 0x00000010;
    static final int TBCDRF_NOEDGES = 0x00010000;
    static final int TBCDRF_HILITEHOTTRACK = 0x00020000;
    static final int TBCDRF_NOOFFSET = 0x00040000;
    static final int TBCDRF_NOMARK = 0x00080000;
    static final int TBCDRF_NOETCHEDEFFECT = 0x00100000;
    static final int TBCDRF_BLENDICON = 0x00200000;
    static final int TBCDRF_NOBACKGROUND = 0x00400000;
    static final int TB_ENABLEBUTTON = (WM_USER + 1);
    static final int TB_CHECKBUTTON = (WM_USER + 2);
    static final int TB_PRESSBUTTON = (WM_USER + 3);
    static final int TB_HIDEBUTTON = (WM_USER + 4);
    static final int TB_INDETERMINATE = (WM_USER + 5);
    static final int TB_MARKBUTTON = (WM_USER + 6);
    static final int TB_ISBUTTONENABLED = (WM_USER + 9);
    static final int TB_ISBUTTONCHECKED = (WM_USER + 10);
    static final int TB_ISBUTTONPRESSED = (WM_USER + 11);
    static final int TB_ISBUTTONHIDDEN = (WM_USER + 12);
    static final int TB_ISBUTTONINDETERMINATE = (WM_USER + 13);
    static final int TB_ISBUTTONHIGHLIGHTED = (WM_USER + 14);
    static final int TB_SETSTATE = (WM_USER + 17);
    static final int TB_GETSTATE = (WM_USER + 18);
    static final int TB_ADDBITMAP = (WM_USER + 19);
    static final int IDB_STD_SMALL_COLOR = 0;
    static final int IDB_STD_LARGE_COLOR = 1;
    static final int IDB_VIEW_SMALL_COLOR = 4;
    static final int IDB_VIEW_LARGE_COLOR = 5;
    static final int IDB_HIST_SMALL_COLOR = 8;
    static final int IDB_HIST_LARGE_COLOR = 9;
    static final int STD_CUT = 0;
    static final int STD_COPY = 1;
    static final int STD_PASTE = 2;
    static final int STD_UNDO = 3;
    static final int STD_REDOW = 4;
    static final int STD_DELETE = 5;
    static final int STD_FILENEW = 6;
    static final int STD_FILEOPEN = 7;
    static final int STD_FILESAVE = 8;
    static final int STD_PRINTPRE = 9;
    static final int STD_PROPERTIES = 10;
    static final int STD_HELP = 11;
    static final int STD_FIND = 12;
    static final int STD_REPLACE = 13;
    static final int STD_PRINT = 14;
    static final int VIEW_LARGEICONS = 0;
    static final int VIEW_SMALLICONS = 1;
    static final int VIEW_LIST = 2;
    static final int VIEW_DETAILS = 3;
    static final int VIEW_SORTNAME = 4;
    static final int VIEW_SORTSIZE = 5;
    static final int VIEW_SORTDATE = 6;
    static final int VIEW_SORTTYPE = 7;
    static final int VIEW_PARENTFOLDER = 8;
    static final int VIEW_NETCONNECT = 9;
    static final int VIEW_NETDISCONNECT = 10;
    static final int VIEW_NEWFOLDER = 11;
    static final int VIEW_VIEWMENU = 12;
    static final int HIST_BACK = 0;
    static final int HIST_FORWARD = 1;
    static final int HIST_FAVORITES = 2;
    static final int HIST_ADDTOFAVORITES = 3;
    static final int HIST_VIEWTREE = 4;
    static final int TB_ADDBUTTONSA = (WM_USER + 20);
    static final int TB_INSERTBUTTONA = (WM_USER + 21);
    static final int TB_DELETEBUTTON = (WM_USER + 22);
    static final int TB_GETBUTTON = (WM_USER + 23);
    static final int TB_BUTTONCOUNT = (WM_USER + 24);
    static final int TB_COMMANDTOINDEX = (WM_USER + 25);
    static final int TB_SAVERESTOREA = (WM_USER + 26);
    static final int TB_SAVERESTOREW = (WM_USER + 76);
    static final int TB_CUSTOMIZE = (WM_USER + 27);
    static final int TB_ADDSTRINGA = (WM_USER + 28);
    static final int TB_ADDSTRINGW = (WM_USER + 77);
    static final int TB_GETITEMRECT = (WM_USER + 29);
    static final int TB_BUTTONSTRUCTSIZE = (WM_USER + 30);
    static final int TB_SETBUTTONSIZE = (WM_USER + 31);
    static final int TB_SETBITMAPSIZE = (WM_USER + 32);
    static final int TB_AUTOSIZE = (WM_USER + 33);
    static final int TB_GETTOOLTIPS = (WM_USER + 35);
    static final int TB_SETTOOLTIPS = (WM_USER + 36);
    static final int TB_SETPARENT = (WM_USER + 37);
    static final int TB_SETROWS = (WM_USER + 39);
    static final int TB_GETROWS = (WM_USER + 40);
    static final int TB_SETCMDID = (WM_USER + 42);
    static final int TB_CHANGEBITMAP = (WM_USER + 43);
    static final int TB_GETBITMAP = (WM_USER + 44);
    static final int TB_GETBUTTONTEXTA = (WM_USER + 45);
    static final int TB_GETBUTTONTEXTW = (WM_USER + 75);
    static final int TB_REPLACEBITMAP = (WM_USER + 46);
    static final int TB_SETINDENT = (WM_USER + 47);
    static final int TB_SETIMAGELIST = (WM_USER + 48);
    static final int TB_GETIMAGELIST = (WM_USER + 49);
    static final int TB_LOADIMAGES = (WM_USER + 50);
    static final int TB_GETRECT = (WM_USER + 51);
    static final int TB_SETHOTIMAGELIST = (WM_USER + 52);
    static final int TB_GETHOTIMAGELIST = (WM_USER + 53);
    static final int TB_SETDISABLEDIMAGELIST = (WM_USER + 54);
    static final int TB_GETDISABLEDIMAGELIST = (WM_USER + 55);
    static final int TB_SETSTYLE = (WM_USER + 56);
    static final int TB_GETSTYLE = (WM_USER + 57);
    static final int TB_GETBUTTONSIZE = (WM_USER + 58);
    static final int TB_SETBUTTONWIDTH = (WM_USER + 59);
    static final int TB_SETMAXTEXTROWS = (WM_USER + 60);
    static final int TB_GETTEXTROWS = (WM_USER + 61);
    static final int TB_GETBUTTONTEXT = TB_GETBUTTONTEXTA;
    static final int TB_SAVERESTORE = TB_SAVERESTOREA;
    static final int TB_ADDSTRING = TB_ADDSTRINGA;
    static final int TB_GETOBJECT = (WM_USER + 62);
    static final int TB_GETHOTITEM = (WM_USER + 71);
    static final int TB_SETHOTITEM = (WM_USER + 72);
    static final int TB_SETANCHORHIGHLIGHT = (WM_USER + 73);
    static final int TB_GETANCHORHIGHLIGHT = (WM_USER + 74);
    static final int TB_MAPACCELERATORA = (WM_USER + 78);
    static final int TBIMHT_AFTER = 0x00000001;
    static final int TBIMHT_BACKGROUND = 0x00000002;
    static final int TB_GETINSERTMARK = (WM_USER + 79);
    static final int TB_SETINSERTMARK = (WM_USER + 80);
    static final int TB_INSERTMARKHITTEST = (WM_USER + 81);
    static final int TB_MOVEBUTTON = (WM_USER + 82);
    static final int TB_GETMAXSIZE = (WM_USER + 83);
    static final int TB_SETEXTENDEDSTYLE = (WM_USER + 84);
    static final int TB_GETEXTENDEDSTYLE = (WM_USER + 85);
    static final int TB_GETPADDING = (WM_USER + 86);
    static final int TB_SETPADDING = (WM_USER + 87);
    static final int TB_SETINSERTMARKCOLOR = (WM_USER + 88);
    static final int TB_GETINSERTMARKCOLOR = (WM_USER + 89);
    static final int TB_SETCOLORSCHEME = CCM_SETCOLORSCHEME;
    static final int TB_GETCOLORSCHEME = CCM_GETCOLORSCHEME;
    static final int TB_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int TB_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int TB_MAPACCELERATORW = (WM_USER + 90);
    static final int TB_MAPACCELERATOR = TB_MAPACCELERATORA;
    static final int TBBF_LARGE = 0x0001;
    static final int TB_GETBITMAPFLAGS = (WM_USER + 41);
    static final int TBIF_IMAGE = 0x00000001;
    static final int TBIF_TEXT = 0x00000002;
    static final int TBIF_STATE = 0x00000004;
    static final int TBIF_STYLE = 0x00000008;
    static final int TBIF_LPARAM = 0x00000010;
    static final int TBIF_COMMAND = 0x00000020;
    static final int TBIF_SIZE = 0x00000040;
    static final int TBIF_BYINDEX = 0x80000000;
    static final int TB_GETBUTTONINFOW = (WM_USER + 63);
    static final int TB_SETBUTTONINFOW = (WM_USER + 64);
    static final int TB_GETBUTTONINFOA = (WM_USER + 65);
    static final int TB_SETBUTTONINFOA = (WM_USER + 66);
    static final int TB_GETBUTTONINFO = TB_GETBUTTONINFOA;
    static final int TB_SETBUTTONINFO = TB_SETBUTTONINFOA;
    static final int TB_INSERTBUTTONW = (WM_USER + 67);
    static final int TB_ADDBUTTONSW = (WM_USER + 68);
    static final int TB_HITTEST = (WM_USER + 69);
    static final int TB_INSERTBUTTON = TB_INSERTBUTTONA;
    static final int TB_ADDBUTTONS = TB_ADDBUTTONSA;
    static final int TB_SETDRAWTEXTFLAGS = (WM_USER + 70);
    static final int TB_GETSTRINGW = (WM_USER + 91);
    static final int TB_GETSTRINGA = (WM_USER + 92);
    static final int TB_GETSTRING = TB_GETSTRINGA;
    static final int HICF_OTHER = 0x00000000;
    static final int HICF_MOUSE = 0x00000001;
    static final int HICF_ARROWKEYS = 0x00000002;
    static final int HICF_ACCELERATOR = 0x00000004;
    static final int HICF_DUPACCEL = 0x00000008;
    static final int HICF_ENTERING = 0x00000010;
    static final int HICF_LEAVING = 0x00000020;
    static final int HICF_RESELECT = 0x00000040;
    static final int HICF_LMOUSE = 0x00000080;
    static final int HICF_TOGGLEDROPDOWN = 0x00000100;
    static final int TBNRF_HIDEHELP = 0x00000001;
    static final int TBNRF_ENDCUSTOMIZE = 0x00000002;
    static final int TBNF_IMAGE = 0x00000001;
    static final int TBNF_TEXT = 0x00000002;
    static final int TBNF_DI_SETITEM = 0x10000000;
    static final int TBDDRET_DEFAULT = 0;
    static final int TBDDRET_NODEFAULT = 1;
    static final int TBDDRET_TREATPRESSED = 2;
    static final int RBIM_IMAGELIST = 0x00000001;
    static final int RBS_TOOLTIPS = 0x0100;
    static final int RBS_VARHEIGHT = 0x0200;
    static final int RBS_BANDBORDERS = 0x0400;
    static final int RBS_FIXEDORDER = 0x0800;
    static final int RBS_REGISTERDROP = 0x1000;
    static final int RBS_AUTOSIZE = 0x2000;
    static final int RBS_VERTICALGRIPPER = 0x4000;
    static final int RBS_DBLCLKTOGGLE = 0x8000;
    static final int RBBS_BREAK = 0x00000001;
    static final int RBBS_FIXEDSIZE = 0x00000002;
    static final int RBBS_CHILDEDGE = 0x00000004;
    static final int RBBS_HIDDEN = 0x00000008;
    static final int RBBS_NOVERT = 0x00000010;
    static final int RBBS_FIXEDBMP = 0x00000020;
    static final int RBBS_VARIABLEHEIGHT = 0x00000040;
    static final int RBBS_GRIPPERALWAYS = 0x00000080;
    static final int RBBS_NOGRIPPER = 0x00000100;
    static final int RBBS_USECHEVRON = 0x00000200;
    static final int RBBS_HIDETITLE = 0x00000400;
    static final int RBBS_TOPALIGN = 0x00000800;
    static final int RBBIM_STYLE = 0x00000001;
    static final int RBBIM_COLORS = 0x00000002;
    static final int RBBIM_TEXT = 0x00000004;
    static final int RBBIM_IMAGE = 0x00000008;
    static final int RBBIM_CHILD = 0x00000010;
    static final int RBBIM_CHILDSIZE = 0x00000020;
    static final int RBBIM_SIZE = 0x00000040;
    static final int RBBIM_BACKGROUND = 0x00000080;
    static final int RBBIM_ID = 0x00000100;
    static final int RBBIM_IDEALSIZE = 0x00000200;
    static final int RBBIM_LPARAM = 0x00000400;
    static final int RBBIM_HEADERSIZE = 0x00000800;
    static final int RB_INSERTBANDA = (WM_USER + 1);
    static final int RB_DELETEBAND = (WM_USER + 2);
    static final int RB_GETBARINFO = (WM_USER + 3);
    static final int RB_SETBARINFO = (WM_USER + 4);
    static final int RB_SETBANDINFOA = (WM_USER + 6);
    static final int RB_SETPARENT = (WM_USER + 7);
    static final int RB_HITTEST = (WM_USER + 8);
    static final int RB_GETRECT = (WM_USER + 9);
    static final int RB_INSERTBANDW = (WM_USER + 10);
    static final int RB_SETBANDINFOW = (WM_USER + 11);
    static final int RB_GETBANDCOUNT = (WM_USER + 12);
    static final int RB_GETROWCOUNT = (WM_USER + 13);
    static final int RB_GETROWHEIGHT = (WM_USER + 14);
    static final int RB_IDTOINDEX = (WM_USER + 16);
    static final int RB_GETTOOLTIPS = (WM_USER + 17);
    static final int RB_SETTOOLTIPS = (WM_USER + 18);
    static final int RB_SETBKCOLOR = (WM_USER + 19);
    static final int RB_GETBKCOLOR = (WM_USER + 20);
    static final int RB_SETTEXTCOLOR = (WM_USER + 21);
    static final int RB_GETTEXTCOLOR = (WM_USER + 22);
    static final int RB_SIZETORECT = (WM_USER + 23);
    static final int RB_SETCOLORSCHEME = CCM_SETCOLORSCHEME;
    static final int RB_GETCOLORSCHEME = CCM_GETCOLORSCHEME;
    static final int RB_INSERTBAND = RB_INSERTBANDA;
    static final int RB_SETBANDINFO = RB_SETBANDINFOA;
    static final int RB_BEGINDRAG = (WM_USER + 24);
    static final int RB_ENDDRAG = (WM_USER + 25);
    static final int RB_DRAGMOVE = (WM_USER + 26);
    static final int RB_GETBARHEIGHT = (WM_USER + 27);
    static final int RB_GETBANDINFOW = (WM_USER + 28);
    static final int RB_GETBANDINFOA = (WM_USER + 29);
    static final int RB_GETBANDINFO = RB_GETBANDINFOA;
    static final int RB_MINIMIZEBAND = (WM_USER + 30);
    static final int RB_MAXIMIZEBAND = (WM_USER + 31);
    static final int RB_GETDROPTARGET = (CCM_GETDROPTARGET);
    static final int RB_GETBANDBORDERS = (WM_USER + 34);
    static final int RB_SHOWBAND = (WM_USER + 35);
    static final int RB_SETPALETTE = (WM_USER + 37);
    static final int RB_GETPALETTE = (WM_USER + 38);
    static final int RB_MOVEBAND = (WM_USER + 39);
    static final int RB_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int RB_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int RB_PUSHCHEVRON = (WM_USER + 43);
    static final int RBNM_ID = 0x00000001;
    static final int RBNM_STYLE = 0x00000002;
    static final int RBNM_LPARAM = 0x00000004;
    static final int RBHT_NOWHERE = 0x0001;
    static final int RBHT_CAPTION = 0x0002;
    static final int RBHT_CLIENT = 0x0003;
    static final int RBHT_GRABBER = 0x0004;
    static final int RBHT_CHEVRON = 0x0008;
    static final int TTS_ALWAYSTIP = 0x01;
    static final int TTS_NOPREFIX = 0x02;
    static final int TTS_NOANIMATE = 0x10;
    static final int TTS_NOFADE = 0x20;
    static final int TTS_BALLOON = 0x40;
    static final int TTS_CLOSE = 0x80;
    static final int TTF_IDISHWND = 0x0001;
    static final int TTF_CENTERTIP = 0x0002;
    static final int TTF_RTLREADING = 0x0004;
    static final int TTF_SUBCLASS = 0x0010;
    static final int TTF_TRACK = 0x0020;
    static final int TTF_ABSOLUTE = 0x0080;
    static final int TTF_TRANSPARENT = 0x0100;
    static final int TTF_PARSELINKS = 0x1000;
    static final int TTF_DI_SETITEM = 0x8000;
    static final int TTDT_AUTOMATIC = 0;
    static final int TTDT_RESHOW = 1;
    static final int TTDT_AUTOPOP = 2;
    static final int TTDT_INITIAL = 3;
    static final int TTI_NONE = 0;
    static final int TTI_INFO = 1;
    static final int TTI_WARNING = 2;
    static final int TTI_ERROR = 3;
    static final int TTM_ACTIVATE = (WM_USER + 1);
    static final int TTM_SETDELAYTIME = (WM_USER + 3);
    static final int TTM_ADDTOOLA = (WM_USER + 4);
    static final int TTM_ADDTOOLW = (WM_USER + 50);
    static final int TTM_DELTOOLA = (WM_USER + 5);
    static final int TTM_DELTOOLW = (WM_USER + 51);
    static final int TTM_NEWTOOLRECTA = (WM_USER + 6);
    static final int TTM_NEWTOOLRECTW = (WM_USER + 52);
    static final int TTM_RELAYEVENT = (WM_USER + 7);
    static final int TTM_GETTOOLINFOA = (WM_USER + 8);
    static final int TTM_GETTOOLINFOW = (WM_USER + 53);
    static final int TTM_SETTOOLINFOA = (WM_USER + 9);
    static final int TTM_SETTOOLINFOW = (WM_USER + 54);
    static final int TTM_HITTESTA = (WM_USER +10);
    static final int TTM_HITTESTW = (WM_USER +55);
    static final int TTM_GETTEXTA = (WM_USER +11);
    static final int TTM_GETTEXTW = (WM_USER +56);
    static final int TTM_UPDATETIPTEXTA = (WM_USER +12);
    static final int TTM_UPDATETIPTEXTW = (WM_USER +57);
    static final int TTM_GETTOOLCOUNT = (WM_USER +13);
    static final int TTM_ENUMTOOLSA = (WM_USER +14);
    static final int TTM_ENUMTOOLSW = (WM_USER +58);
    static final int TTM_GETCURRENTTOOLA = (WM_USER + 15);
    static final int TTM_GETCURRENTTOOLW = (WM_USER + 59);
    static final int TTM_WINDOWFROMPOINT = (WM_USER + 16);
    static final int TTM_TRACKACTIVATE = (WM_USER + 17);
    static final int TTM_TRACKPOSITION = (WM_USER + 18);
    static final int TTM_SETTIPBKCOLOR = (WM_USER + 19);
    static final int TTM_SETTIPTEXTCOLOR = (WM_USER + 20);
    static final int TTM_GETDELAYTIME = (WM_USER + 21);
    static final int TTM_GETTIPBKCOLOR = (WM_USER + 22);
    static final int TTM_GETTIPTEXTCOLOR = (WM_USER + 23);
    static final int TTM_SETMAXTIPWIDTH = (WM_USER + 24);
    static final int TTM_GETMAXTIPWIDTH = (WM_USER + 25);
    static final int TTM_SETMARGIN = (WM_USER + 26);
    static final int TTM_GETMARGIN = (WM_USER + 27);
    static final int TTM_POP = (WM_USER + 28);
    static final int TTM_UPDATE = (WM_USER + 29);
    static final int TTM_GETBUBBLESIZE = (WM_USER + 30);
    static final int TTM_ADJUSTRECT = (WM_USER + 31);
    static final int TTM_SETTITLEA = (WM_USER + 32);
    static final int TTM_SETTITLEW = (WM_USER + 33);
    static final int TTM_ADDTOOL = TTM_ADDTOOLA;
    static final int TTM_DELTOOL = TTM_DELTOOLA;
    static final int TTM_NEWTOOLRECT = TTM_NEWTOOLRECTA;
    static final int TTM_GETTOOLINFO = TTM_GETTOOLINFOA;
    static final int TTM_SETTOOLINFO = TTM_SETTOOLINFOA;
    static final int TTM_HITTEST = TTM_HITTESTA;
    static final int TTM_GETTEXT = TTM_GETTEXTA;
    static final int TTM_UPDATETIPTEXT = TTM_UPDATETIPTEXTA;
    static final int TTM_ENUMTOOLS = TTM_ENUMTOOLSA;
    static final int TTM_GETCURRENTTOOL = TTM_GETCURRENTTOOLA;
    static final int TTM_SETTITLE = TTM_SETTITLEA;
    static final int SBARS_SIZEGRIP = 0x0100;
    static final int SBARS_TOOLTIPS = 0x0800;
    static final int SBT_TOOLTIPS = 0x0800;
    static final int SB_SETTEXTA = (WM_USER+1);
    static final int SB_SETTEXTW = (WM_USER+11);
    static final int SB_GETTEXTA = (WM_USER+2);
    static final int SB_GETTEXTW = (WM_USER+13);
    static final int SB_GETTEXTLENGTHA = (WM_USER+3);
    static final int SB_GETTEXTLENGTHW = (WM_USER+12);
    static final int SB_GETTEXT = SB_GETTEXTA;
    static final int SB_SETTEXT = SB_SETTEXTA;
    static final int SB_GETTEXTLENGTH = SB_GETTEXTLENGTHA;
    static final int SB_SETPARTS = (WM_USER+4);
    static final int SB_GETPARTS = (WM_USER+6);
    static final int SB_GETBORDERS = (WM_USER+7);
    static final int SB_SETMINHEIGHT = (WM_USER+8);
    static final int SB_SIMPLE = (WM_USER+9);
    static final int SB_GETRECT = (WM_USER+10);
    static final int SB_ISSIMPLE = (WM_USER+14);
    static final int SB_SETICON = (WM_USER+15);
    static final int SB_SETTIPTEXTA = (WM_USER+16);
    static final int SB_SETTIPTEXTW = (WM_USER+17);
    static final int SB_GETTIPTEXTA = (WM_USER+18);
    static final int SB_GETTIPTEXTW = (WM_USER+19);
    static final int SB_GETICON = (WM_USER+20);
    static final int SB_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int SB_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int SBT_OWNERDRAW = 0x1000;
    static final int SBT_NOBORDERS = 0x0100;
    static final int SBT_POPOUT = 0x0200;
    static final int SBT_RTLREADING = 0x0400;
    static final int SBT_NOTABPARSING = 0x0800;
    static final int SB_SETBKCOLOR = CCM_SETBKCOLOR;
    static final int SB_SIMPLEID = 0x00ff;
    static final int MINSYSCOMMAND = SC_SIZE;
    static final int TBS_AUTOTICKS = 0x0001;
    static final int TBS_VERT = 0x0002;
    static final int TBS_HORZ = 0x0000;
    static final int TBS_TOP = 0x0004;
    static final int TBS_BOTTOM = 0x0000;
    static final int TBS_LEFT = 0x0004;
    static final int TBS_RIGHT = 0x0000;
    static final int TBS_BOTH = 0x0008;
    static final int TBS_NOTICKS = 0x0010;
    static final int TBS_ENABLESELRANGE = 0x0020;
    static final int TBS_FIXEDLENGTH = 0x0040;
    static final int TBS_NOTHUMB = 0x0080;
    static final int TBS_TOOLTIPS = 0x0100;
    static final int TBS_REVERSED = 0x0200;
    static final int TBS_DOWNISLEFT = 0x0400;
    static final int TBM_GETPOS = (WM_USER);
    static final int TBM_GETRANGEMIN = (WM_USER+1);
    static final int TBM_GETRANGEMAX = (WM_USER+2);
    static final int TBM_GETTIC = (WM_USER+3);
    static final int TBM_SETTIC = (WM_USER+4);
    static final int TBM_SETPOS = (WM_USER+5);
    static final int TBM_SETRANGE = (WM_USER+6);
    static final int TBM_SETRANGEMIN = (WM_USER+7);
    static final int TBM_SETRANGEMAX = (WM_USER+8);
    static final int TBM_CLEARTICS = (WM_USER+9);
    static final int TBM_SETSEL = (WM_USER+10);
    static final int TBM_SETSELSTART = (WM_USER+11);
    static final int TBM_SETSELEND = (WM_USER+12);
    static final int TBM_GETPTICS = (WM_USER+14);
    static final int TBM_GETTICPOS = (WM_USER+15);
    static final int TBM_GETNUMTICS = (WM_USER+16);
    static final int TBM_GETSELSTART = (WM_USER+17);
    static final int TBM_GETSELEND = (WM_USER+18);
    static final int TBM_CLEARSEL = (WM_USER+19);
    static final int TBM_SETTICFREQ = (WM_USER+20);
    static final int TBM_SETPAGESIZE = (WM_USER+21);
    static final int TBM_GETPAGESIZE = (WM_USER+22);
    static final int TBM_SETLINESIZE = (WM_USER+23);
    static final int TBM_GETLINESIZE = (WM_USER+24);
    static final int TBM_GETTHUMBRECT = (WM_USER+25);
    static final int TBM_GETCHANNELRECT = (WM_USER+26);
    static final int TBM_SETTHUMBLENGTH = (WM_USER+27);
    static final int TBM_GETTHUMBLENGTH = (WM_USER+28);
    static final int TBM_SETTOOLTIPS = (WM_USER+29);
    static final int TBM_GETTOOLTIPS = (WM_USER+30);
    static final int TBM_SETTIPSIDE = (WM_USER+31);
    static final int TBTS_TOP = 0;
    static final int TBTS_LEFT = 1;
    static final int TBTS_BOTTOM = 2;
    static final int TBTS_RIGHT = 3;
    static final int TBM_SETBUDDY = (WM_USER+32);
    static final int TBM_GETBUDDY = (WM_USER+33);
    static final int TBM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int TBM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int TB_LINEUP = 0;
    static final int TB_LINEDOWN = 1;
    static final int TB_PAGEUP = 2;
    static final int TB_PAGEDOWN = 3;
    static final int TB_THUMBPOSITION = 4;
    static final int TB_THUMBTRACK = 5;
    static final int TB_TOP = 6;
    static final int TB_BOTTOM = 7;
    static final int TB_ENDTRACK = 8;
    static final int TBCD_TICS = 0x0001;
    static final int TBCD_THUMB = 0x0002;
    static final int TBCD_CHANNEL = 0x0003;
    static final int DL_BEGINDRAG = (WM_USER+133);
    static final int DL_DRAGGING = (WM_USER+134);
    static final int DL_DROPPED = (WM_USER+135);
    static final int DL_CANCELDRAG = (WM_USER+136);
    static final int DL_CURSORSET = 0;
    static final int DL_STOPCURSOR = 1;
    static final int DL_COPYCURSOR = 2;
    static final int DL_MOVECURSOR = 3;
    static final int UD_MAXVAL = 0x7fff;
    static final int UD_MINVAL = (-UD_MAXVAL);
    static final int UDS_WRAP = 0x0001;
    static final int UDS_SETBUDDYINT = 0x0002;
    static final int UDS_ALIGNRIGHT = 0x0004;
    static final int UDS_ALIGNLEFT = 0x0008;
    static final int UDS_AUTOBUDDY = 0x0010;
    static final int UDS_ARROWKEYS = 0x0020;
    static final int UDS_HORZ = 0x0040;
    static final int UDS_NOTHOUSANDS = 0x0080;
    static final int UDS_HOTTRACK = 0x0100;
    static final int UDM_SETRANGE = (WM_USER+101);
    static final int UDM_GETRANGE = (WM_USER+102);
    static final int UDM_SETPOS = (WM_USER+103);
    static final int UDM_GETPOS = (WM_USER+104);
    static final int UDM_SETBUDDY = (WM_USER+105);
    static final int UDM_GETBUDDY = (WM_USER+106);
    static final int UDM_SETACCEL = (WM_USER+107);
    static final int UDM_GETACCEL = (WM_USER+108);
    static final int UDM_SETBASE = (WM_USER+109);
    static final int UDM_GETBASE = (WM_USER+110);
    static final int UDM_SETRANGE32 = (WM_USER+111);
    static final int UDM_GETRANGE32 = (WM_USER+112);
    static final int UDM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int UDM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int UDM_SETPOS32 = (WM_USER+113);
    static final int UDM_GETPOS32 = (WM_USER+114);
    static final int PBS_SMOOTH = 0x01;
    static final int PBS_VERTICAL = 0x04;
    static final int PBM_SETRANGE = (WM_USER+1);
    static final int PBM_SETPOS = (WM_USER+2);
    static final int PBM_DELTAPOS = (WM_USER+3);
    static final int PBM_SETSTEP = (WM_USER+4);
    static final int PBM_STEPIT = (WM_USER+5);
    static final int PBM_SETRANGE32 = (WM_USER+6);
    static final int PBM_GETRANGE = (WM_USER+7);
    static final int PBM_GETPOS = (WM_USER+8);
    static final int PBM_SETBARCOLOR = (WM_USER+9);
    static final int PBM_SETBKCOLOR = CCM_SETBKCOLOR;
    static final int HOTKEYF_SHIFT = 0x01;
    static final int HOTKEYF_CONTROL = 0x02;
    static final int HOTKEYF_ALT = 0x04;
    static final int HOTKEYF_EXT = 0x08;
    static final int HKCOMB_NONE = 0x0001;
    static final int HKCOMB_S = 0x0002;
    static final int HKCOMB_C = 0x0004;
    static final int HKCOMB_A = 0x0008;
    static final int HKCOMB_SC = 0x0010;
    static final int HKCOMB_SA = 0x0020;
    static final int HKCOMB_CA = 0x0040;
    static final int HKCOMB_SCA = 0x0080;
    static final int HKM_SETHOTKEY = (WM_USER+1);
    static final int HKM_GETHOTKEY = (WM_USER+2);
    static final int HKM_SETRULES = (WM_USER+3);
    static final int CCS_TOP = 0x00000001;
    static final int CCS_NOMOVEY = 0x00000002;
    static final int CCS_BOTTOM = 0x00000003;
    static final int CCS_NORESIZE = 0x00000004;
    static final int CCS_NOPARENTALIGN = 0x00000008;
    static final int CCS_ADJUSTABLE = 0x00000020;
    static final int CCS_NODIVIDER = 0x00000040;
    static final int CCS_VERT = 0x00000080;
    static final int CCS_LEFT = (CCS_VERT | CCS_TOP);
    static final int CCS_RIGHT = (CCS_VERT | CCS_BOTTOM);
    static final int CCS_NOMOVEX = (CCS_VERT | CCS_NOMOVEY);
    static final int LVS_ICON = 0x0000;
    static final int LVS_REPORT = 0x0001;
    static final int LVS_SMALLICON = 0x0002;
    static final int LVS_LIST = 0x0003;
    static final int LVS_TYPEMASK = 0x0003;
    static final int LVS_SINGLESEL = 0x0004;
    static final int LVS_SHOWSELALWAYS = 0x0008;
    static final int LVS_SORTASCENDING = 0x0010;
    static final int LVS_SORTDESCENDING = 0x0020;
    static final int LVS_SHAREIMAGELISTS = 0x0040;
    static final int LVS_NOLABELWRAP = 0x0080;
    static final int LVS_AUTOARRANGE = 0x0100;
    static final int LVS_EDITLABELS = 0x0200;
    static final int LVS_OWNERDATA = 0x1000;
    static final int LVS_NOSCROLL = 0x2000;
    static final int LVS_TYPESTYLEMASK = 0xfc00;
    static final int LVS_ALIGNTOP = 0x0000;
    static final int LVS_ALIGNLEFT = 0x0800;
    static final int LVS_ALIGNMASK = 0x0c00;
    static final int LVS_OWNERDRAWFIXED = 0x0400;
    static final int LVS_NOCOLUMNHEADER = 0x4000;
    static final int LVS_NOSORTHEADER = 0x8000;
    static final int LVM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int LVM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int LVM_GETBKCOLOR = (LVM_FIRST + 0);
    static final int LVM_SETBKCOLOR = (LVM_FIRST + 1);
    static final int LVM_GETIMAGELIST = (LVM_FIRST + 2);
    static final int LVSIL_NORMAL = 0;
    static final int LVSIL_SMALL = 1;
    static final int LVSIL_STATE = 2;
    static final int LVM_SETIMAGELIST = (LVM_FIRST + 3);
    static final int LVM_GETITEMCOUNT = (LVM_FIRST + 4);
    static final int LVIF_TEXT = 0x0001;
    static final int LVIF_IMAGE = 0x0002;
    static final int LVIF_PARAM = 0x0004;
    static final int LVIF_STATE = 0x0008;
    static final int LVIF_INDENT = 0x0010;
    static final int LVIF_NORECOMPUTE = 0x0800;
    static final int LVIS_FOCUSED = 0x0001;
    static final int LVIS_SELECTED = 0x0002;
    static final int LVIS_CUT = 0x0004;
    static final int LVIS_DROPHILITED = 0x0008;
    static final int LVIS_GLOW = 0x0010;
    static final int LVIS_ACTIVATING = 0x0020;
    static final int LVIS_OVERLAYMASK = 0x0F00;
    static final int LVIS_STATEIMAGEMASK = 0xF000;
    static final int I_INDENTCALLBACK = (-1);
    static final int I_IMAGECALLBACK = (-1);
    static final int I_IMAGENONE = (-2);
    static final int LVM_GETITEMA = (LVM_FIRST + 5);
    static final int LVM_GETITEMW = (LVM_FIRST + 75);
    static final int LVM_GETITEM = LVM_GETITEMA;
    static final int LVM_SETITEMA = (LVM_FIRST + 6);
    static final int LVM_SETITEMW = (LVM_FIRST + 76);
    static final int LVM_SETITEM = LVM_SETITEMA;
    static final int LVM_INSERTITEMA = (LVM_FIRST + 7);
    static final int LVM_INSERTITEMW = (LVM_FIRST + 77);
    static final int LVM_INSERTITEM = LVM_INSERTITEMA;
    static final int LVM_DELETEITEM = (LVM_FIRST + 8);
    static final int LVM_DELETEALLITEMS = (LVM_FIRST + 9);
    static final int LVM_GETCALLBACKMASK = (LVM_FIRST + 10);
    static final int LVM_SETCALLBACKMASK = (LVM_FIRST + 11);
    static final int LVNI_ALL = 0x0000;
    static final int LVNI_FOCUSED = 0x0001;
    static final int LVNI_SELECTED = 0x0002;
    static final int LVNI_CUT = 0x0004;
    static final int LVNI_DROPHILITED = 0x0008;
    static final int LVNI_ABOVE = 0x0100;
    static final int LVNI_BELOW = 0x0200;
    static final int LVNI_TOLEFT = 0x0400;
    static final int LVNI_TORIGHT = 0x0800;
    static final int LVM_GETNEXTITEM = (LVM_FIRST + 12);
    static final int LVFI_PARAM = 0x0001;
    static final int LVFI_STRING = 0x0002;
    static final int LVFI_PARTIAL = 0x0008;
    static final int LVFI_WRAP = 0x0020;
    static final int LVFI_NEARESTXY = 0x0040;
    static final int LVM_FINDITEMA = (LVM_FIRST + 13);
    static final int LVM_FINDITEMW = (LVM_FIRST + 83);
    static final int LVM_FINDITEM = LVM_FINDITEMA;
    static final int LVIR_BOUNDS = 0;
    static final int LVIR_ICON = 1;
    static final int LVIR_LABEL = 2;
    static final int LVIR_SELECTBOUNDS = 3;
    static final int LVM_GETITEMRECT = (LVM_FIRST + 14);
    static final int LVM_SETITEMPOSITION = (LVM_FIRST + 15);
    static final int LVM_GETITEMPOSITION = (LVM_FIRST + 16);
    static final int LVM_GETSTRINGWIDTHA = (LVM_FIRST + 17);
    static final int LVM_GETSTRINGWIDTHW = (LVM_FIRST + 87);
    static final int LVM_GETSTRINGWIDTH = LVM_GETSTRINGWIDTHA;
    static final int LVHT_NOWHERE = 0x0001;
    static final int LVHT_ONITEMICON = 0x0002;
    static final int LVHT_ONITEMLABEL = 0x0004;
    static final int LVHT_ONITEMSTATEICON = 0x0008;
    static final int LVHT_ONITEM = (LVHT_ONITEMICON | LVHT_ONITEMLABEL | LVHT_ONITEMSTATEICON);
    static final int LVHT_ABOVE = 0x0008;
    static final int LVHT_BELOW = 0x0010;
    static final int LVHT_TORIGHT = 0x0020;
    static final int LVHT_TOLEFT = 0x0040;
    static final int LVM_HITTEST = (LVM_FIRST + 18);
    static final int LVM_ENSUREVISIBLE = (LVM_FIRST + 19);
    static final int LVM_SCROLL = (LVM_FIRST + 20);
    static final int LVM_REDRAWITEMS = (LVM_FIRST + 21);
    static final int LVA_DEFAULT = 0x0000;
    static final int LVA_ALIGNLEFT = 0x0001;
    static final int LVA_ALIGNTOP = 0x0002;
    static final int LVA_SNAPTOGRID = 0x0005;
    static final int LVM_ARRANGE = (LVM_FIRST + 22);
    static final int LVM_EDITLABELA = (LVM_FIRST + 23);
    static final int LVM_EDITLABELW = (LVM_FIRST + 118);
    static final int LVM_EDITLABEL = LVM_EDITLABELA;
    static final int LVM_GETEDITCONTROL = (LVM_FIRST + 24);
    static final int LVCF_FMT = 0x0001;
    static final int LVCF_WIDTH = 0x0002;
    static final int LVCF_TEXT = 0x0004;
    static final int LVCF_SUBITEM = 0x0008;
    static final int LVCF_IMAGE = 0x0010;
    static final int LVCF_ORDER = 0x0020;
    static final int LVCFMT_LEFT = 0x0000;
    static final int LVCFMT_RIGHT = 0x0001;
    static final int LVCFMT_CENTER = 0x0002;
    static final int LVCFMT_JUSTIFYMASK = 0x0003;
    static final int LVCFMT_IMAGE = 0x0800;
    static final int LVCFMT_BITMAP_ON_RIGHT = 0x1000;
    static final int LVCFMT_COL_HAS_IMAGES = 0x8000;
    static final int LVM_GETCOLUMNA = (LVM_FIRST + 25);
    static final int LVM_GETCOLUMNW = (LVM_FIRST + 95);
    static final int LVM_GETCOLUMN = LVM_GETCOLUMNA;
    static final int LVM_SETCOLUMNA = (LVM_FIRST + 26);
    static final int LVM_SETCOLUMNW = (LVM_FIRST + 96);
    static final int LVM_SETCOLUMN = LVM_SETCOLUMNA;
    static final int LVM_INSERTCOLUMNA = (LVM_FIRST + 27);
    static final int LVM_INSERTCOLUMNW = (LVM_FIRST + 97);
    static final int LVM_INSERTCOLUMN = LVM_INSERTCOLUMNA;
    static final int LVM_DELETECOLUMN = (LVM_FIRST + 28);
    static final int LVM_GETCOLUMNWIDTH = (LVM_FIRST + 29);
    static final int LVSCW_AUTOSIZE = -1;
    static final int LVSCW_AUTOSIZE_USEHEADER = -2;
    static final int LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30);
    static final int LVM_GETHEADER = (LVM_FIRST + 31);
    static final int LVM_CREATEDRAGIMAGE = (LVM_FIRST + 33);
    static final int LVM_GETVIEWRECT = (LVM_FIRST + 34);
    static final int LVM_GETTEXTCOLOR = (LVM_FIRST + 35);
    static final int LVM_SETTEXTCOLOR = (LVM_FIRST + 36);
    static final int LVM_GETTEXTBKCOLOR = (LVM_FIRST + 37);
    static final int LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38);
    static final int LVM_GETTOPINDEX = (LVM_FIRST + 39);
    static final int LVM_GETCOUNTPERPAGE = (LVM_FIRST + 40);
    static final int LVM_GETORIGIN = (LVM_FIRST + 41);
    static final int LVM_UPDATE = (LVM_FIRST + 42);
    static final int LVM_SETITEMSTATE = (LVM_FIRST + 43);
    static final int LVM_GETITEMSTATE = (LVM_FIRST + 44);
    static final int LVM_GETITEMTEXTA = (LVM_FIRST + 45);
    static final int LVM_GETITEMTEXTW = (LVM_FIRST + 115);
    static final int LVM_GETITEMTEXT = LVM_GETITEMTEXTA;
    static final int LVM_SETITEMTEXTA = (LVM_FIRST + 46);
    static final int LVM_SETITEMTEXTW = (LVM_FIRST + 116);
    static final int LVM_SETITEMTEXT = LVM_SETITEMTEXTA;
    static final int LVSICF_NOINVALIDATEALL = 0x00000001;
    static final int LVSICF_NOSCROLL = 0x00000002;
    static final int LVM_SETITEMCOUNT = (LVM_FIRST + 47);
    static final int LVM_SORTITEMS = (LVM_FIRST + 48);
    static final int LVM_SETITEMPOSITION32 = (LVM_FIRST + 49);
    static final int LVM_GETSELECTEDCOUNT = (LVM_FIRST + 50);
    static final int LVM_GETITEMSPACING = (LVM_FIRST + 51);
    static final int LVM_GETISEARCHSTRINGA = (LVM_FIRST + 52);
    static final int LVM_GETISEARCHSTRINGW = (LVM_FIRST + 117);
    static final int LVM_GETISEARCHSTRING = LVM_GETISEARCHSTRINGA;
    static final int LVM_SETICONSPACING = (LVM_FIRST + 53);
    static final int LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54);
    static final int LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55);
    static final int LVS_EX_GRIDLINES = 0x00000001;
    static final int LVS_EX_SUBITEMIMAGES = 0x00000002;
    static final int LVS_EX_CHECKBOXES = 0x00000004;
    static final int LVS_EX_TRACKSELECT = 0x00000008;
    static final int LVS_EX_HEADERDRAGDROP = 0x00000010;
    static final int LVS_EX_FULLROWSELECT = 0x00000020;
    static final int LVS_EX_ONECLICKACTIVATE = 0x00000040;
    static final int LVS_EX_TWOCLICKACTIVATE = 0x00000080;
    static final int LVS_EX_FLATSB = 0x00000100;
    static final int LVS_EX_REGIONAL = 0x00000200;
    static final int LVS_EX_INFOTIP = 0x00000400;
    static final int LVS_EX_UNDERLINEHOT = 0x00000800;
    static final int LVS_EX_UNDERLINECOLD = 0x00001000;
    static final int LVS_EX_MULTIWORKAREAS = 0x00002000;
    static final int LVS_EX_LABELTIP = 0x00004000;
    static final int LVS_EX_BORDERSELECT = 0x00008000;
    static final int LVM_GETSUBITEMRECT = (LVM_FIRST + 56);
    static final int LVM_SUBITEMHITTEST = (LVM_FIRST + 57);
    static final int LVM_SETCOLUMNORDERARRAY = (LVM_FIRST + 58);
    static final int LVM_GETCOLUMNORDERARRAY = (LVM_FIRST + 59);
    static final int LVM_SETHOTITEM = (LVM_FIRST + 60);
    static final int LVM_GETHOTITEM = (LVM_FIRST + 61);
    static final int LVM_SETHOTCURSOR = (LVM_FIRST + 62);
    static final int LVM_GETHOTCURSOR = (LVM_FIRST + 63);
    static final int LVM_APPROXIMATEVIEWRECT = (LVM_FIRST + 64);
    static final int LV_MAX_WORKAREAS = 16;
    static final int LVM_SETWORKAREAS = (LVM_FIRST + 65);
    static final int LVM_GETWORKAREAS = (LVM_FIRST + 70);
    static final int LVM_GETNUMBEROFWORKAREAS = (LVM_FIRST + 73);
    static final int LVM_GETSELECTIONMARK = (LVM_FIRST + 66);
    static final int LVM_SETSELECTIONMARK = (LVM_FIRST + 67);
    static final int LVM_SETHOVERTIME = (LVM_FIRST + 71);
    static final int LVM_GETHOVERTIME = (LVM_FIRST + 72);
    static final int LVM_SETTOOLTIPS = (LVM_FIRST + 74);
    static final int LVM_GETTOOLTIPS = (LVM_FIRST + 78);
    static final int LVM_SORTITEMSEX = (LVM_FIRST + 81);
    static final int LVBKIF_SOURCE_NONE = 0x00000000;
    static final int LVBKIF_SOURCE_HBITMAP = 0x00000001;
    static final int LVBKIF_SOURCE_URL = 0x00000002;
    static final int LVBKIF_SOURCE_MASK = 0x00000003;
    static final int LVBKIF_STYLE_NORMAL = 0x00000000;
    static final int LVBKIF_STYLE_TILE = 0x00000010;
    static final int LVBKIF_STYLE_MASK = 0x00000010;
    static final int LVM_SETBKIMAGEA = (LVM_FIRST + 68);
    static final int LVM_SETBKIMAGEW = (LVM_FIRST + 138);
    static final int LVM_GETBKIMAGEA = (LVM_FIRST + 69);
    static final int LVM_GETBKIMAGEW = (LVM_FIRST + 139);
    static final int LVM_SETBKIMAGE = LVM_SETBKIMAGEA;
    static final int LVM_GETBKIMAGE = LVM_GETBKIMAGEA;
    static final int LVKF_ALT = 0x0001;
    static final int LVKF_CONTROL = 0x0002;
    static final int LVKF_SHIFT = 0x0004;
    static final int LVCDI_ITEM = 0x00000000;
    static final int LVCDI_GROUP = 0x00000001;
    static final int LVCDRF_NOSELECT = 0x00010000;
    static final int LVCDRF_NOGROUPFRAME = 0x00020000;
    static final int LVIF_DI_SETITEM = 0x1000;
    static final int LVGIT_UNFOLDED = 0x0001;
    static final int TVS_HASBUTTONS = 0x0001;
    static final int TVS_HASLINES = 0x0002;
    static final int TVS_LINESATROOT = 0x0004;
    static final int TVS_EDITLABELS = 0x0008;
    static final int TVS_DISABLEDRAGDROP = 0x0010;
    static final int TVS_SHOWSELALWAYS = 0x0020;
    static final int TVS_RTLREADING = 0x0040;
    static final int TVS_NOTOOLTIPS = 0x0080;
    static final int TVS_CHECKBOXES = 0x0100;
    static final int TVS_TRACKSELECT = 0x0200;
    static final int TVS_SINGLEEXPAND = 0x0400;
    static final int TVS_INFOTIP = 0x0800;
    static final int TVS_FULLROWSELECT = 0x1000;
    static final int TVS_NOSCROLL = 0x2000;
    static final int TVS_NONEVENHEIGHT = 0x4000;
    static final int TVS_NOHSCROLL = 0x8000;
    static final int TVIF_TEXT = 0x0001;
    static final int TVIF_IMAGE = 0x0002;
    static final int TVIF_PARAM = 0x0004;
    static final int TVIF_STATE = 0x0008;
    static final int TVIF_HANDLE = 0x0010;
    static final int TVIF_SELECTEDIMAGE = 0x0020;
    static final int TVIF_CHILDREN = 0x0040;
    static final int TVIF_INTEGRAL = 0x0080;
    static final int TVIS_SELECTED = 0x0002;
    static final int TVIS_CUT = 0x0004;
    static final int TVIS_DROPHILITED = 0x0008;
    static final int TVIS_BOLD = 0x0010;
    static final int TVIS_EXPANDED = 0x0020;
    static final int TVIS_EXPANDEDONCE = 0x0040;
    static final int TVIS_EXPANDPARTIAL = 0x0080;
    static final int TVIS_OVERLAYMASK = 0x0F00;
    static final int TVIS_STATEIMAGEMASK = 0xF000;
    static final int TVIS_USERMASK = 0xF000;
    static final int I_CHILDRENCALLBACK = (-1);
    static final int TVM_INSERTITEMA = (TV_FIRST + 0);
    static final int TVM_INSERTITEMW = (TV_FIRST + 50);
    static final int TVM_INSERTITEM = TVM_INSERTITEMA;
    static final int TVM_DELETEITEM = (TV_FIRST + 1);
    static final int TVM_EXPAND = (TV_FIRST + 2);
    static final int TVE_COLLAPSE = 0x0001;
    static final int TVE_EXPAND = 0x0002;
    static final int TVE_TOGGLE = 0x0003;
    static final int TVE_EXPANDPARTIAL = 0x4000;
    static final int TVE_COLLAPSERESET = 0x8000;
    static final int TVM_GETITEMRECT = (TV_FIRST + 4);
    static final int TVM_GETCOUNT = (TV_FIRST + 5);
    static final int TVM_GETINDENT = (TV_FIRST + 6);
    static final int TVM_SETINDENT = (TV_FIRST + 7);
    static final int TVM_GETIMAGELIST = (TV_FIRST + 8);
    static final int TVSIL_NORMAL = 0;
    static final int TVSIL_STATE = 2;
    static final int TVM_SETIMAGELIST = (TV_FIRST + 9);
    static final int TVM_GETNEXTITEM = (TV_FIRST + 10);
    static final int TVGN_ROOT = 0x0000;
    static final int TVGN_NEXT = 0x0001;
    static final int TVGN_PREVIOUS = 0x0002;
    static final int TVGN_PARENT = 0x0003;
    static final int TVGN_CHILD = 0x0004;
    static final int TVGN_FIRSTVISIBLE = 0x0005;
    static final int TVGN_NEXTVISIBLE = 0x0006;
    static final int TVGN_PREVIOUSVISIBLE = 0x0007;
    static final int TVGN_DROPHILITE = 0x0008;
    static final int TVGN_CARET = 0x0009;
    static final int TVGN_LASTVISIBLE = 0x000A;
    static final int TVM_SELECTITEM = (TV_FIRST + 11);
    static final int TVM_GETITEMA = (TV_FIRST + 12);
    static final int TVM_GETITEMW = (TV_FIRST + 62);
    static final int TVM_GETITEM = TVM_GETITEMA;
    static final int TVM_SETITEMA = (TV_FIRST + 13);
    static final int TVM_SETITEMW = (TV_FIRST + 63);
    static final int TVM_SETITEM = TVM_SETITEMA;
    static final int TVM_EDITLABELA = (TV_FIRST + 14);
    static final int TVM_EDITLABELW = (TV_FIRST + 65);
    static final int TVM_EDITLABEL = TVM_EDITLABELA;
    static final int TVM_GETEDITCONTROL = (TV_FIRST + 15);
    static final int TVM_GETVISIBLECOUNT = (TV_FIRST + 16);
    static final int TVM_HITTEST = (TV_FIRST + 17);
    static final int TVHT_NOWHERE = 0x0001;
    static final int TVHT_ONITEMICON = 0x0002;
    static final int TVHT_ONITEMLABEL = 0x0004;
    static final int TVHT_ONITEMINDENT = 0x0008;
    static final int TVHT_ONITEMBUTTON = 0x0010;
    static final int TVHT_ONITEMRIGHT = 0x0020;
    static final int TVHT_ONITEMSTATEICON = 0x0040;
    static final int TVHT_ABOVE = 0x0100;
    static final int TVHT_BELOW = 0x0200;
    static final int TVHT_TORIGHT = 0x0400;
    static final int TVHT_TOLEFT = 0x0800;
    static final int TVM_CREATEDRAGIMAGE = (TV_FIRST + 18);
    static final int TVM_SORTCHILDREN = (TV_FIRST + 19);
    static final int TVM_ENSUREVISIBLE = (TV_FIRST + 20);
    static final int TVM_SORTCHILDRENCB = (TV_FIRST + 21);
    static final int TVM_ENDEDITLABELNOW = (TV_FIRST + 22);
    static final int TVM_GETISEARCHSTRINGA = (TV_FIRST + 23);
    static final int TVM_GETISEARCHSTRINGW = (TV_FIRST + 64);
    static final int TVM_GETISEARCHSTRING = TVM_GETISEARCHSTRINGA;
    static final int TVM_SETTOOLTIPS = (TV_FIRST + 24);
    static final int TVM_GETTOOLTIPS = (TV_FIRST + 25);
    static final int TVM_SETINSERTMARK = (TV_FIRST + 26);
    static final int TVM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int TVM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int TVM_SETITEMHEIGHT = (TV_FIRST + 27);
    static final int TVM_GETITEMHEIGHT = (TV_FIRST + 28);
    static final int TVM_SETBKCOLOR = (TV_FIRST + 29);
    static final int TVM_SETTEXTCOLOR = (TV_FIRST + 30);
    static final int TVM_GETBKCOLOR = (TV_FIRST + 31);
    static final int TVM_GETTEXTCOLOR = (TV_FIRST + 32);
    static final int TVM_SETSCROLLTIME = (TV_FIRST + 33);
    static final int TVM_GETSCROLLTIME = (TV_FIRST + 34);
    static final int TVM_SETINSERTMARKCOLOR = (TV_FIRST + 37);
    static final int TVM_GETINSERTMARKCOLOR = (TV_FIRST + 38);
    static final int TVM_GETITEMSTATE = (TV_FIRST + 39);
    static final int TVM_SETLINECOLOR = (TV_FIRST + 40);
    static final int TVM_GETLINECOLOR = (TV_FIRST + 41);
    static final int TVC_UNKNOWN = 0x0000;
    static final int TVC_BYMOUSE = 0x0001;
    static final int TVC_BYKEYBOARD = 0x0002;
    static final int TVIF_DI_SETITEM = 0x1000;
    static final int TVNRET_DEFAULT = 0;
    static final int TVNRET_SKIPOLD = 1;
    static final int TVNRET_SKIPNEW = 2;
    static final int TVCDRF_NOIMAGES = 0x00010000;
    static final int CBEIF_TEXT = 0x00000001;
    static final int CBEIF_IMAGE = 0x00000002;
    static final int CBEIF_SELECTEDIMAGE = 0x00000004;
    static final int CBEIF_OVERLAY = 0x00000008;
    static final int CBEIF_INDENT = 0x00000010;
    static final int CBEIF_LPARAM = 0x00000020;
    static final int CBEIF_DI_SETITEM = 0x10000000;
    static final int CBEM_INSERTITEMA = (WM_USER + 1);
    static final int CBEM_SETIMAGELIST = (WM_USER + 2);
    static final int CBEM_GETIMAGELIST = (WM_USER + 3);
    static final int CBEM_GETITEMA = (WM_USER + 4);
    static final int CBEM_SETITEMA = (WM_USER + 5);
    static final int CBEM_DELETEITEM = CB_DELETESTRING;
    static final int CBEM_GETCOMBOCONTROL = (WM_USER + 6);
    static final int CBEM_GETEDITCONTROL = (WM_USER + 7);
    static final int CBEM_SETEXSTYLE = (WM_USER + 8);
    static final int CBEM_SETEXTENDEDSTYLE = (WM_USER + 14);
    static final int CBEM_GETEXSTYLE = (WM_USER + 9);
    static final int CBEM_GETEXTENDEDSTYLE = (WM_USER + 9);
    static final int CBEM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int CBEM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int CBEM_HASEDITCHANGED = (WM_USER + 10);
    static final int CBEM_INSERTITEMW = (WM_USER + 11);
    static final int CBEM_SETITEMW = (WM_USER + 12);
    static final int CBEM_GETITEMW = (WM_USER + 13);
    static final int CBEM_INSERTITEM = CBEM_INSERTITEMA;
    static final int CBEM_SETITEM = CBEM_SETITEMA;
    static final int CBEM_GETITEM = CBEM_GETITEMA;
    static final int CBES_EX_NOEDITIMAGE = 0x00000001;
    static final int CBES_EX_NOEDITIMAGEINDENT = 0x00000002;
    static final int CBES_EX_PATHWORDBREAKPROC = 0x00000004;
    static final int CBES_EX_NOSIZELIMIT = 0x00000008;
    static final int CBES_EX_CASESENSITIVE = 0x00000010;
    static final int CBENF_KILLFOCUS = 1;
    static final int CBENF_RETURN = 2;
    static final int CBENF_ESCAPE = 3;
    static final int CBENF_DROPDOWN = 4;
    static final int CBEMAXSTRLEN = 260;
    static final int TCS_SCROLLOPPOSITE = 0x0001;
    static final int TCS_BOTTOM = 0x0002;
    static final int TCS_RIGHT = 0x0002;
    static final int TCS_MULTISELECT = 0x0004;
    static final int TCS_FLATBUTTONS = 0x0008;
    static final int TCS_FORCEICONLEFT = 0x0010;
    static final int TCS_FORCELABELLEFT = 0x0020;
    static final int TCS_HOTTRACK = 0x0040;
    static final int TCS_VERTICAL = 0x0080;
    static final int TCS_TABS = 0x0000;
    static final int TCS_BUTTONS = 0x0100;
    static final int TCS_SINGLELINE = 0x0000;
    static final int TCS_MULTILINE = 0x0200;
    static final int TCS_RIGHTJUSTIFY = 0x0000;
    static final int TCS_FIXEDWIDTH = 0x0400;
    static final int TCS_RAGGEDRIGHT = 0x0800;
    static final int TCS_FOCUSONBUTTONDOWN = 0x1000;
    static final int TCS_OWNERDRAWFIXED = 0x2000;
    static final int TCS_TOOLTIPS = 0x4000;
    static final int TCS_FOCUSNEVER = 0x8000;
    static final int TCS_EX_FLATSEPARATORS = 0x00000001;
    static final int TCS_EX_REGISTERDROP = 0x00000002;
    static final int TCM_GETIMAGELIST = (TCM_FIRST + 2);
    static final int TCM_SETIMAGELIST = (TCM_FIRST + 3);
    static final int TCM_GETITEMCOUNT = (TCM_FIRST + 4);
    static final int TCIF_TEXT = 0x0001;
    static final int TCIF_IMAGE = 0x0002;
    static final int TCIF_RTLREADING = 0x0004;
    static final int TCIF_PARAM = 0x0008;
    static final int TCIF_STATE = 0x0010;
    static final int TCIS_BUTTONPRESSED = 0x0001;
    static final int TCIS_HIGHLIGHTED = 0x0002;
    static final int TCM_GETITEMA = (TCM_FIRST + 5);
    static final int TCM_GETITEMW = (TCM_FIRST + 60);
    static final int TCM_GETITEM = TCM_GETITEMA;
    static final int TCM_SETITEMA = (TCM_FIRST + 6);
    static final int TCM_SETITEMW = (TCM_FIRST + 61);
    static final int TCM_SETITEM = TCM_SETITEMA;
    static final int TCM_INSERTITEMA = (TCM_FIRST + 7);
    static final int TCM_INSERTITEMW = (TCM_FIRST + 62);
    static final int TCM_INSERTITEM = TCM_INSERTITEMA;
    static final int TCM_DELETEITEM = (TCM_FIRST + 8);
    static final int TCM_DELETEALLITEMS = (TCM_FIRST + 9);
    static final int TCM_GETITEMRECT = (TCM_FIRST + 10);
    static final int TCM_GETCURSEL = (TCM_FIRST + 11);
    static final int TCM_SETCURSEL = (TCM_FIRST + 12);
    static final int TCHT_NOWHERE = 0x0001;
    static final int TCHT_ONITEMICON = 0x0002;
    static final int TCHT_ONITEMLABEL = 0x0004;
    static final int TCHT_ONITEM = (TCHT_ONITEMICON | TCHT_ONITEMLABEL);
    static final int TCM_HITTEST = (TCM_FIRST + 13);
    static final int TCM_SETITEMEXTRA = (TCM_FIRST + 14);
    static final int TCM_ADJUSTRECT = (TCM_FIRST + 40);
    static final int TCM_SETITEMSIZE = (TCM_FIRST + 41);
    static final int TCM_REMOVEIMAGE = (TCM_FIRST + 42);
    static final int TCM_SETPADDING = (TCM_FIRST + 43);
    static final int TCM_GETROWCOUNT = (TCM_FIRST + 44);
    static final int TCM_GETTOOLTIPS = (TCM_FIRST + 45);
    static final int TCM_SETTOOLTIPS = (TCM_FIRST + 46);
    static final int TCM_GETCURFOCUS = (TCM_FIRST + 47);
    static final int TCM_SETCURFOCUS = (TCM_FIRST + 48);
    static final int TCM_SETMINTABWIDTH = (TCM_FIRST + 49);
    static final int TCM_DESELECTALL = (TCM_FIRST + 50);
    static final int TCM_HIGHLIGHTITEM = (TCM_FIRST + 51);
    static final int TCM_SETEXTENDEDSTYLE = (TCM_FIRST + 52);
    static final int TCM_GETEXTENDEDSTYLE = (TCM_FIRST + 53);
    static final int TCM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int TCM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int ACS_CENTER = 0x0001;
    static final int ACS_TRANSPARENT = 0x0002;
    static final int ACS_AUTOPLAY = 0x0004;
    static final int ACS_TIMER = 0x0008;
    static final int ACM_OPENA = (WM_USER+100);
    static final int ACM_OPENW = (WM_USER+103);
    static final int ACM_OPEN = ACM_OPENA;
    static final int ACM_PLAY = (WM_USER+101);
    static final int ACM_STOP = (WM_USER+102);
    static final int ACN_START = 1;
    static final int ACN_STOP = 2;
    static final int MCM_FIRST = 0x1000;
    static final int MCM_GETCURSEL = (MCM_FIRST + 1);
    static final int MCM_SETCURSEL = (MCM_FIRST + 2);
    static final int MCM_GETMAXSELCOUNT = (MCM_FIRST + 3);
    static final int MCM_SETMAXSELCOUNT = (MCM_FIRST + 4);
    static final int MCM_GETSELRANGE = (MCM_FIRST + 5);
    static final int MCM_SETSELRANGE = (MCM_FIRST + 6);
    static final int MCM_GETMONTHRANGE = (MCM_FIRST + 7);
    static final int MCM_SETDAYSTATE = (MCM_FIRST + 8);
    static final int MCM_GETMINREQRECT = (MCM_FIRST + 9);
    static final int MCM_SETCOLOR = (MCM_FIRST + 10);
    static final int MCM_GETCOLOR = (MCM_FIRST + 11);
    static final int MCSC_BACKGROUND = 0;
    static final int MCSC_TEXT = 1;
    static final int MCSC_TITLEBK = 2;
    static final int MCSC_TITLETEXT = 3;
    static final int MCSC_MONTHBK = 4;
    static final int MCSC_TRAILINGTEXT = 5;
    static final int MCM_SETTODAY = (MCM_FIRST + 12);
    static final int MCM_GETTODAY = (MCM_FIRST + 13);
    static final int MCM_HITTEST = (MCM_FIRST + 14);
    static final int MCHT_TITLE = 0x00010000;
    static final int MCHT_CALENDAR = 0x00020000;
    static final int MCHT_TODAYLINK = 0x00030000;
    static final int MCHT_NEXT = 0x01000000;
    static final int MCHT_PREV = 0x02000000;
    static final int MCHT_NOWHERE = 0x00000000;
    static final int MCHT_TITLEBK = (MCHT_TITLE);
    static final int MCHT_TITLEMONTH = (MCHT_TITLE | 0x0001);
    static final int MCHT_TITLEYEAR = (MCHT_TITLE | 0x0002);
    static final int MCHT_TITLEBTNNEXT = (MCHT_TITLE | MCHT_NEXT | 0x0003);
    static final int MCHT_TITLEBTNPREV = (MCHT_TITLE | MCHT_PREV | 0x0003);
    static final int MCHT_CALENDARBK = (MCHT_CALENDAR);
    static final int MCHT_CALENDARDATE = (MCHT_CALENDAR | 0x0001);
    static final int MCHT_CALENDARDATENEXT = (MCHT_CALENDARDATE | MCHT_NEXT);
    static final int MCHT_CALENDARDATEPREV = (MCHT_CALENDARDATE | MCHT_PREV);
    static final int MCHT_CALENDARDAY = (MCHT_CALENDAR | 0x0002);
    static final int MCHT_CALENDARWEEKNUM = (MCHT_CALENDAR | 0x0003);
    static final int MCM_SETFIRSTDAYOFWEEK = (MCM_FIRST + 15);
    static final int MCM_GETFIRSTDAYOFWEEK = (MCM_FIRST + 16);
    static final int MCM_GETRANGE = (MCM_FIRST + 17);
    static final int MCM_SETRANGE = (MCM_FIRST + 18);
    static final int MCM_GETMONTHDELTA = (MCM_FIRST + 19);
    static final int MCM_SETMONTHDELTA = (MCM_FIRST + 20);
    static final int MCM_GETMAXTODAYWIDTH = (MCM_FIRST + 21);
    static final int MCM_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT;
    static final int MCM_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT;
    static final int MCS_DAYSTATE = 0x0001;
    static final int MCS_MULTISELECT = 0x0002;
    static final int MCS_WEEKNUMBERS = 0x0004;
    static final int MCS_NOTODAYCIRCLE = 0x0008;
    static final int MCS_NOTODAY = 0x0010;
    static final int GMR_VISIBLE = 0;
    static final int GMR_DAYSTATE = 1;
    static final int DTM_FIRST = 0x1000;
    static final int DTM_GETSYSTEMTIME = (DTM_FIRST + 1);
    static final int DTM_SETSYSTEMTIME = (DTM_FIRST + 2);
    static final int DTM_GETRANGE = (DTM_FIRST + 3);
    static final int DTM_SETRANGE = (DTM_FIRST + 4);
    static final int DTM_SETFORMATA = (DTM_FIRST + 5);
    static final int DTM_SETFORMATW = (DTM_FIRST + 50);
    static final int DTM_SETFORMAT = DTM_SETFORMATA;
    static final int DTM_SETMCCOLOR = (DTM_FIRST + 6);
    static final int DTM_GETMCCOLOR = (DTM_FIRST + 7);
    static final int DTM_GETMONTHCAL = (DTM_FIRST + 8);
    static final int DTM_SETMCFONT = (DTM_FIRST + 9);
    static final int DTM_GETMCFONT = (DTM_FIRST + 10);
    static final int DTS_UPDOWN = 0x0001;
    static final int DTS_SHOWNONE = 0x0002;
    static final int DTS_SHORTDATEFORMAT = 0x0000;
    static final int DTS_LONGDATEFORMAT = 0x0004;
    static final int DTS_SHORTDATECENTURYFORMAT = 0x000C;
    static final int DTS_TIMEFORMAT = 0x0009;
    static final int DTS_APPCANPARSE = 0x0010;
    static final int DTS_RIGHTALIGN = 0x0020;
    static final int GDTR_MIN = 0x0001;
    static final int GDTR_MAX = 0x0002;
    static final int GDT_ERROR = -1;
    static final int GDT_VALID = 0;
    static final int GDT_NONE = 1;
    static final int IPM_CLEARADDRESS = (WM_USER+100);
    static final int IPM_SETADDRESS = (WM_USER+101);
    static final int IPM_GETADDRESS = (WM_USER+102);
    static final int IPM_SETRANGE = (WM_USER+103);
    static final int IPM_SETFOCUS = (WM_USER+104);
    static final int IPM_ISBLANK = (WM_USER+105);
    static final int PGS_VERT = 0x00000000;
    static final int PGS_HORZ = 0x00000001;
    static final int PGS_AUTOSCROLL = 0x00000002;
    static final int PGS_DRAGNDROP = 0x00000004;
    static final int PGF_INVISIBLE = 0;
    static final int PGF_NORMAL = 1;
    static final int PGF_GRAYED = 2;
    static final int PGF_DEPRESSED = 4;
    static final int PGF_HOT = 8;
    static final int PGB_TOPORLEFT = 0;
    static final int PGB_BOTTOMORRIGHT = 1;
    static final int PGM_SETCHILD = (PGM_FIRST + 1);
    static final int PGM_RECALCSIZE = (PGM_FIRST + 2);
    static final int PGM_FORWARDMOUSE = (PGM_FIRST + 3);
    static final int PGM_SETBKCOLOR = (PGM_FIRST + 4);
    static final int PGM_GETBKCOLOR = (PGM_FIRST + 5);
    static final int PGM_SETBORDER = (PGM_FIRST + 6);
    static final int PGM_GETBORDER = (PGM_FIRST + 7);
    static final int PGM_SETPOS = (PGM_FIRST + 8);
    static final int PGM_GETPOS = (PGM_FIRST + 9);
    static final int PGM_SETBUTTONSIZE = (PGM_FIRST + 10);
    static final int PGM_GETBUTTONSIZE = (PGM_FIRST + 11);
    static final int PGM_GETBUTTONSTATE = (PGM_FIRST + 12);
    static final int PGM_GETDROPTARGET = CCM_GETDROPTARGET;
    static final int PGF_SCROLLUP = 1;
    static final int PGF_SCROLLDOWN = 2;
    static final int PGF_SCROLLLEFT = 4;
    static final int PGF_SCROLLRIGHT = 8;
    static final int PGK_SHIFT = 1;
    static final int PGK_CONTROL = 2;
    static final int PGK_MENU = 4;
    static final int PGF_CALCWIDTH = 1;
    static final int PGF_CALCHEIGHT = 2;
    static final int NFS_EDIT = 0x0001;
    static final int NFS_STATIC = 0x0002;
    static final int NFS_LISTCOMBO = 0x0004;
    static final int NFS_BUTTON = 0x0008;
    static final int NFS_ALL = 0x0010;
    static final int NFS_USEFONTASSOC = 0x0020;
    static final int DA_LAST = (0x7FFFFFFF);
    static final int DPA_APPEND = (0x7fffffff);
    static final int DPA_ERR = (-1);
    static final int DSA_APPEND = (0x7fffffff);
    static final int DSA_ERR = (-1);
    static final int DPAS_SORTED = 0x0001;
    static final int DPAS_INSERTBEFORE = 0x0002;
    static final int DPAS_INSERTAFTER = 0x0004;
    static final int WSB_PROP_CYVSCROLL = 0x00000001;
    static final int WSB_PROP_CXHSCROLL = 0x00000002;
    static final int WSB_PROP_CYHSCROLL = 0x00000004;
    static final int WSB_PROP_CXVSCROLL = 0x00000008;
    static final int WSB_PROP_CXHTHUMB = 0x00000010;
    static final int WSB_PROP_CYVTHUMB = 0x00000020;
    static final int WSB_PROP_VBKGCOLOR = 0x00000040;
    static final int WSB_PROP_HBKGCOLOR = 0x00000080;
    static final int WSB_PROP_VSTYLE = 0x00000100;
    static final int WSB_PROP_HSTYLE = 0x00000200;
    static final int WSB_PROP_WINSTYLE = 0x00000400;
    static final int WSB_PROP_PALETTE = 0x00000800;
    static final int WSB_PROP_MASK = 0x00000FFF;
    static final int FSB_FLAT_MODE = 2;
    static final int FSB_ENCARTA_MODE = 1;
    static final int FSB_REGULAR_MODE = 0;
    static final int DTT_GRAYED = 0x1;
    static final int HTTB_BACKGROUNDSEG = 0x0000;
    static final int HTTB_FIXEDBORDER = 0x0002;
    static final int HTTB_CAPTION = 0x0004;
    static final int HTTB_RESIZINGBORDER_LEFT = 0x0010;
    static final int HTTB_RESIZINGBORDER_TOP = 0x0020;
    static final int HTTB_RESIZINGBORDER_RIGHT = 0x0040;
    static final int HTTB_RESIZINGBORDER_BOTTOM = 0x0080;
    static final int HTTB_RESIZINGBORDER = (HTTB_RESIZINGBORDER_LEFT|HTTB_RESIZINGBORDER_TOP| HTTB_RESIZINGBORDER_RIGHT|HTTB_RESIZINGBORDER_BOTTOM);
    static final int HTTB_SIZINGTEMPLATE = 0x0100;
    static final int HTTB_SYSTEMSIZINGMARGINS = 0x0200;
    static final int MAX_INTLIST_COUNT = 10;
    static final int ETDT_DISABLE = 0x00000001;
    static final int ETDT_ENABLE = 0x00000002;
    static final int ETDT_USETABTEXTURE = 0x00000004;
    static final int ETDT_ENABLETAB = (ETDT_ENABLE | ETDT_USETABTEXTURE);
    static final int STAP_ALLOW_NONCLIENT = (1 << 0);
    static final int STAP_ALLOW_CONTROLS = (1 << 1);
    static final int STAP_ALLOW_WEBCONTENT = (1 << 2);
    static final int DTBG_CLIPRECT = 0x00000001;
    static final int DTBG_DRAWSOLID = 0x00000002;
    static final int DTBG_OMITBORDER = 0x00000004;
    static final int DTBG_OMITCONTENT = 0x00000008;
    static final int DTBG_COMPUTINGREGION = 0x00000010;
    static final int DTBG_MIRRORDC = 0x00000020;
    static final int MULTICLASSINFO_GETTYPEINFO = 0x00000001;
    static final int MULTICLASSINFO_GETNUMRESERVEDDISPIDS = 0x00000002;
    static final int MULTICLASSINFO_GETIIDPRIMARY = 0x00000004;
    static final int MULTICLASSINFO_GETIIDSOURCE = 0x00000008;
    static final int TIFLAGS_EXTENDDISPATCHONLY = 0x00000001;
    static final int OLECMDERR_E_FIRST = (OLE_E_LAST+1);
    static final int OLECMDERR_E_NOTSUPPORTED = (OLECMDERR_E_FIRST);
    static final int OLECMDERR_E_DISABLED = (OLECMDERR_E_FIRST+1);
    static final int OLECMDERR_E_NOHELP = (OLECMDERR_E_FIRST+2);
    static final int OLECMDERR_E_CANCELED = (OLECMDERR_E_FIRST+3);
    static final int OLECMDERR_E_UNKNOWNGROUP = (OLECMDERR_E_FIRST+4);
    static final int MSOCMDERR_E_FIRST = OLECMDERR_E_FIRST;
    static final int MSOCMDERR_E_NOTSUPPORTED = OLECMDERR_E_NOTSUPPORTED;
    static final int MSOCMDERR_E_DISABLED = OLECMDERR_E_DISABLED;
    static final int MSOCMDERR_E_NOHELP = OLECMDERR_E_NOHELP;
    static final int MSOCMDERR_E_CANCELED = OLECMDERR_E_CANCELED;
    static final int MSOCMDERR_E_UNKNOWNGROUP = OLECMDERR_E_UNKNOWNGROUP;
    static final int PID_FINDDATA = 0;
    static final int PID_NETRESOURCE = 1;
    static final int PID_DESCRIPTIONID = 2;
    static final int PID_WHICHFOLDER = 3;
    static final int PID_NETWORKLOCATION = 4;
    static final int PID_COMPUTERNAME = 5;
    static final int PID_DISPLACED_FROM = 2;
    static final int PID_DISPLACED_DATE = 3;
    static final int PID_SYNC_COPY_IN = 2;
    static final int PID_MISC_STATUS = 2;
    static final int PID_MISC_ACCESSCOUNT = 3;
    static final int PID_MISC_OWNER = 4;
    static final int PID_HTMLINFOTIPFILE = 5;
    static final int PID_MISC_PICS = 6;
    static final int PID_DISPLAY_PROPERTIES = 0;
    static final int PID_INTROTEXT = 1;
    static final int PIDSI_ARTIST = 2;
    static final int PIDSI_SONGTITLE = 3;
    static final int PIDSI_ALBUM = 4;
    static final int PIDSI_YEAR = 5;
    static final int PIDSI_COMMENT = 6;
    static final int PIDSI_TRACK = 7;
    static final int PIDSI_GENRE = 11;
    static final int PIDSI_LYRICS = 12;
    static final int PIDDRSI_PROTECTED = 2;
    static final int PIDDRSI_DESCRIPTION = 3;
    static final int PIDDRSI_PLAYCOUNT = 4;
    static final int PIDDRSI_PLAYSTARTS = 5;
    static final int PIDDRSI_PLAYEXPIRES = 6;
    static final int PIDVSI_STREAM_NAME = 0x00000002;
    static final int PIDVSI_FRAME_WIDTH = 0x00000003;
    static final int PIDVSI_FRAME_HEIGHT = 0x00000004;
    static final int PIDVSI_TIMELENGTH = 0x00000007;
    static final int PIDVSI_FRAME_COUNT = 0x00000005;
    static final int PIDVSI_FRAME_RATE = 0x00000006;
    static final int PIDVSI_DATA_RATE = 0x00000008;
    static final int PIDVSI_SAMPLE_SIZE = 0x00000009;
    static final int PIDVSI_COMPRESSION = 0x0000000A;
    static final int PIDVSI_STREAM_NUMBER = 0x0000000B;
    static final int PIDASI_FORMAT = 0x00000002;
    static final int PIDASI_TIMELENGTH = 0x00000003;
    static final int PIDASI_AVG_DATA_RATE = 0x00000004;
    static final int PIDASI_SAMPLE_RATE = 0x00000005;
    static final int PIDASI_SAMPLE_SIZE = 0x00000006;
    static final int PIDASI_CHANNEL_COUNT = 0x00000007;
    static final int PIDASI_STREAM_NUMBER = 0x00000008;
    static final int PIDASI_STREAM_NAME = 0x00000009;
    static final int PIDASI_COMPRESSION = 0x0000000A;
    static final int PID_CONTROLPANEL_CATEGORY = 2;
    static final int PID_VOLUME_FREE = 2;
    static final int PID_VOLUME_CAPACITY = 3;
    static final int PID_VOLUME_FILESYSTEM = 4;
    static final int PID_SHARE_CSC_STATUS = 2;
    static final int PID_LINK_TARGET = 2;
    static final int PID_QUERY_RANK = 2;
    static final int SHCIDS_ALLFIELDS = 0x80000000;
    static final int SHCIDS_CANONICALONLY = 0x10000000;
    static final int SHCIDS_BITMASK = 0xFFFF0000;
    static final int SHCIDS_COLUMNMASK = 0x0000FFFF;
    static final int SFGAO_CANCOPY = DROPEFFECT_COPY;
    static final int SFGAO_CANMOVE = DROPEFFECT_MOVE;
    static final int SFGAO_CANLINK = DROPEFFECT_LINK;
    static final int SFGAO_STORAGE = 0x00000008;
    static final int SFGAO_CANRENAME = 0x00000010;
    static final int SFGAO_CANDELETE = 0x00000020;
    static final int SFGAO_HASPROPSHEET = 0x00000040;
    static final int SFGAO_DROPTARGET = 0x00000100;
    static final int SFGAO_CAPABILITYMASK = 0x00000177;
    static final int SFGAO_ENCRYPTED = 0x00002000;
    static final int SFGAO_ISSLOW = 0x00004000;
    static final int SFGAO_GHOSTED = 0x00008000;
    static final int SFGAO_LINK = 0x00010000;
    static final int SFGAO_SHARE = 0x00020000;
    static final int SFGAO_READONLY = 0x00040000;
    static final int SFGAO_HIDDEN = 0x00080000;
    static final int SFGAO_DISPLAYATTRMASK = 0x000FC000;
    static final int SFGAO_FILESYSANCESTOR = 0x10000000;
    static final int SFGAO_FOLDER = 0x20000000;
    static final int SFGAO_FILESYSTEM = 0x40000000;
    static final int SFGAO_HASSUBFOLDER = 0x80000000;
    static final int SFGAO_CONTENTSMASK = 0x80000000;
    static final int SFGAO_VALIDATE = 0x01000000;
    static final int SFGAO_REMOVABLE = 0x02000000;
    static final int SFGAO_COMPRESSED = 0x04000000;
    static final int SFGAO_BROWSABLE = 0x08000000;
    static final int SFGAO_NONENUMERATED = 0x00100000;
    static final int SFGAO_NEWCONTENT = 0x00200000;
    static final int SFGAO_CANMONIKER = 0x00400000;
    static final int SFGAO_HASSTORAGE = 0x00400000;
    static final int SFGAO_STREAM = 0x00400000;
    static final int SFGAO_STORAGEANCESTOR = 0x00800000;
    static final int SFGAO_STORAGECAPMASK = 0x70C50008;
    static final int SVSI_DESELECT = 0x00000000;
    static final int SVSI_SELECT = 0x00000001;
    static final int SVSI_EDIT = 0x00000003;
    static final int SVSI_DESELECTOTHERS = 0x00000004;
    static final int SVSI_ENSUREVISIBLE = 0x00000008;
    static final int SVSI_FOCUSED = 0x00000010;
    static final int SVSI_TRANSLATEPT = 0x00000020;
    static final int SVSI_SELECTIONMARK = 0x00000040;
    static final int SVSI_POSITIONITEM = 0x00000080;
    static final int SVSI_CHECK = 0x00000100;
    static final int SVSI_NOSTATECHANGE = 0x80000000;
    static final int SBSP_DEFBROWSER = 0x0000;
    static final int SBSP_SAMEBROWSER = 0x0001;
    static final int SBSP_NEWBROWSER = 0x0002;
    static final int SBSP_DEFMODE = 0x0000;
    static final int SBSP_OPENMODE = 0x0010;
    static final int SBSP_EXPLOREMODE = 0x0020;
    static final int SBSP_HELPMODE = 0x0040;
    static final int SBSP_NOTRANSFERHIST = 0x0080;
    static final int SBSP_ABSOLUTE = 0x0000;
    static final int SBSP_RELATIVE = 0x1000;
    static final int SBSP_PARENT = 0x2000;
    static final int SBSP_NAVIGATEBACK = 0x4000;
    static final int SBSP_NAVIGATEFORWARD = 0x8000;
    static final int SBSP_ALLOW_AUTONAVIGATE = 0x10000;
    static final int SBSP_NOAUTOSELECT = 0x04000000;
    static final int SBSP_WRITENOHISTORY = 0x08000000;
    static final int SBSP_REDIRECT = 0x40000000;
    static final int SBSP_INITIATEDBYHLINKFRAME = 0x80000000;
    static final int FCW_STATUS = 0x0001;
    static final int FCW_TOOLBAR = 0x0002;
    static final int FCW_TREE = 0x0003;
    static final int FCW_INTERNETBAR = 0x0006;
    static final int FCW_PROGRESS = 0x0008;
    static final int FCT_MERGE = 0x0001;
    static final int FCT_CONFIGABLE = 0x0002;
    static final int FCT_ADDTOEND = 0x0004;
    static final int ARCONTENT_AUTORUNINF = 0x00000002;
    static final int ARCONTENT_AUDIOCD = 0x00000004;
    static final int ARCONTENT_DVDMOVIE = 0x00000008;
    static final int ARCONTENT_BLANKCD = 0x00000010;
    static final int ARCONTENT_BLANKDVD = 0x00000020;
    static final int ARCONTENT_UNKNOWNCONTENT = 0x00000040;
    static final int ARCONTENT_AUTOPLAYPIX = 0x00000080;
    static final int ARCONTENT_AUTOPLAYMUSIC = 0x00000100;
    static final int ARCONTENT_AUTOPLAYVIDEO = 0x00000200;
    static final int SNCF_REFRESHLIST = 0x00000001;
    static final int IEIFLAG_ASYNC = 0x0001;
    static final int IEIFLAG_CACHE = 0x0002;
    static final int IEIFLAG_ASPECT = 0x0004;
    static final int IEIFLAG_OFFLINE = 0x0008;
    static final int IEIFLAG_GLEAM = 0x0010;
    static final int IEIFLAG_SCREEN = 0x0020;
    static final int IEIFLAG_ORIGSIZE = 0x0040;
    static final int IEIFLAG_NOSTAMP = 0x0080;
    static final int IEIFLAG_NOBORDER = 0x0100;
    static final int IEIFLAG_QUALITY = 0x0200;
    static final int IEIFLAG_REFRESH = 0x0400;
    static final int DBIM_MINSIZE = 0x0001;
    static final int DBIM_MAXSIZE = 0x0002;
    static final int DBIM_INTEGRAL = 0x0004;
    static final int DBIM_ACTUAL = 0x0008;
    static final int DBIM_TITLE = 0x0010;
    static final int DBIM_MODEFLAGS = 0x0020;
    static final int DBIM_BKCOLOR = 0x0040;
    static final int DBIMF_NORMAL = 0x0000;
    static final int DBIMF_FIXED = 0x0001;
    static final int DBIMF_FIXEDBMP = 0x0004;
    static final int DBIMF_VARIABLEHEIGHT = 0x0008;
    static final int DBIMF_UNDELETEABLE = 0x0010;
    static final int DBIMF_DEBOSSED = 0x0020;
    static final int DBIMF_BKCOLOR = 0x0040;
    static final int DBIMF_USECHEVRON = 0x0080;
    static final int DBIMF_BREAK = 0x0100;
    static final int DBIMF_ADDTOFRONT = 0x0200;
    static final int DBIMF_TOPALIGN = 0x0400;
    static final int DBIF_VIEWMODE_NORMAL = 0x0000;
    static final int DBIF_VIEWMODE_VERTICAL = 0x0001;
    static final int DBIF_VIEWMODE_FLOATING = 0x0002;
    static final int DBIF_VIEWMODE_TRANSPARENT = 0x0004;
    static final int IDD_WIZEXTN_FIRST = 0x5000;
    static final int IDD_WIZEXTN_LAST = 0x5100;
    static final int SHPWHF_NORECOMPRESS = 0x00000001;
    static final int SHPWHF_NONETPLACECREATE = 0x00000002;
    static final int SHPWHF_NOFILESELECTOR = 0x00000004;
    static final int SHPWHF_VALIDATEVIAWEBFOLDERS = 0x00010000;
    static final int ACDD_VISIBLE = 0x0001;
    static final int PPW_LAUNCHEDBYUSER = 0x00000001;
    static final int BSIM_STATE = 0x00000001;
    static final int BSIM_STYLE = 0x00000002;
    static final int BSSF_VISIBLE = 0x00000001;
    static final int BSSF_NOTITLE = 0x00000002;
    static final int BSSF_UNDELETEABLE = 0x00001000;
    static final int BSIS_AUTOGRIPPER = 0x00000000;
    static final int BSIS_NOGRIPPER = 0x00000001;
    static final int BSIS_ALWAYSGRIPPER = 0x00000002;
    static final int BSIS_LEFTALIGN = 0x00000004;
    static final int BSIS_SINGLECLICK = 0x00000008;
    static final int BSIS_NOCONTEXTMENU = 0x00000010;
    static final int BSIS_NODROPTARGET = 0x00000020;
    static final int BSIS_NOCAPTION = 0x00000040;
    static final int BSIS_PREFERNOLINEBREAK = 0x00000080;
    static final int BSIS_LOCKED = 0x00000100;
    static final int CMF_NORMAL = 0x00000000;
    static final int CMF_DEFAULTONLY = 0x00000001;
    static final int CMF_VERBSONLY = 0x00000002;
    static final int CMF_EXPLORE = 0x00000004;
    static final int CMF_NOVERBS = 0x00000008;
    static final int CMF_CANRENAME = 0x00000010;
    static final int CMF_NODEFAULT = 0x00000020;
    static final int CMF_INCLUDESTATIC = 0x00000040;
    static final int CMF_EXTENDEDVERBS = 0x00000100;
    static final int CMF_RESERVED = 0xffff0000;
    static final int GCS_VERBA = 0x00000000;
    static final int GCS_HELPTEXTA = 0x00000001;
    static final int GCS_VALIDATEA = 0x00000002;
    static final int GCS_VERBW = 0x00000004;
    static final int GCS_HELPTEXTW = 0x00000005;
    static final int GCS_VALIDATEW = 0x00000006;
    static final int GCS_UNICODE = 0x00000004;
    static final int GCS_VERB = GCS_VERBA;
    static final int GCS_HELPTEXT = GCS_HELPTEXTA;
    static final int GCS_VALIDATE = GCS_VALIDATEA;
    static final int CMIC_MASK_HOTKEY = SEE_MASK_HOTKEY;
    static final int CMIC_MASK_ICON = SEE_MASK_ICON;
    static final int CMIC_MASK_FLAG_NO_UI = SEE_MASK_FLAG_NO_UI;
    static final int CMIC_MASK_UNICODE = SEE_MASK_UNICODE;
    static final int CMIC_MASK_NO_CONSOLE = SEE_MASK_NO_CONSOLE;
    static final int CMIC_MASK_ASYNCOK = SEE_MASK_ASYNCOK;
    static final int CMIC_MASK_SHIFT_DOWN = 0x10000000;
    static final int CMIC_MASK_CONTROL_DOWN = 0x40000000;
    static final int CMIC_MASK_PTINVOKE = 0x20000000;
    static final int GIL_OPENICON = 0x0001;
    static final int GIL_FORSHELL = 0x0002;
    static final int GIL_ASYNC = 0x0020;
    static final int GIL_DEFAULTICON = 0x0040;
    static final int GIL_FORSHORTCUT = 0x0080;
    static final int GIL_SIMULATEDOC = 0x0001;
    static final int GIL_PERINSTANCE = 0x0002;
    static final int GIL_PERCLASS = 0x0004;
    static final int GIL_NOTFILENAME = 0x0008;
    static final int GIL_DONTCACHE = 0x0010;
    static final int ISIOI_ICONFILE = 0x00000001;
    static final int ISIOI_ICONINDEX = 0x00000002;
    static final int SIOM_OVERLAYINDEX = 1;
    static final int SIOM_ICONINDEX = 2;
    static final int SIOM_RESERVED_SHARED = 0;
    static final int SIOM_RESERVED_LINK = 1;
    static final int SIOM_RESERVED_SLOWFILE = 2;
    static final int OI_ASYNC = 0xFFFFEEEE;
    static final int IDO_SHGIOI_SHARE = 0x0FFFFFFF;
    static final int IDO_SHGIOI_LINK = 0x0FFFFFFE;
    static final int IDO_SHGIOI_SLOWFILE = 0x0FFFFFFFD;
    static final int NT_CONSOLE_PROPS_SIG = 0xA0000002;
    static final int NT_FE_CONSOLE_PROPS_SIG = 0xA0000004;
    static final int EXP_DARWIN_ID_SIG = 0xA0000006;
    static final int EXP_LOGO3_ID_SIG = 0xA0000007;
    static final int EXP_SPECIAL_FOLDER_SIG = 0xA0000005;
    static final int EXP_SZ_LINK_SIG = 0xA0000001;
    static final int EXP_SZ_ICON_SIG = 0xA0000007;
    static final int FVSIF_RECT = 0x00000001;
    static final int FVSIF_PINNED = 0x00000002;
    static final int FVSIF_NEWFAILED = 0x08000000;
    static final int FVSIF_NEWFILE = 0x80000000;
    static final int FVSIF_CANVIEWIT = 0x40000000;
    static final int FCIDM_SHVIEWFIRST = 0x0000;
    static final int FCIDM_SHVIEWLAST = 0x7fff;
    static final int FCIDM_BROWSERFIRST = 0xa000;
    static final int FCIDM_BROWSERLAST = 0xbf00;
    static final int FCIDM_GLOBALFIRST = 0x8000;
    static final int FCIDM_GLOBALLAST = 0x9fff;
    static final int FCIDM_MENU_FILE = (FCIDM_GLOBALFIRST+0x0000);
    static final int FCIDM_MENU_EDIT = (FCIDM_GLOBALFIRST+0x0040);
    static final int FCIDM_MENU_VIEW = (FCIDM_GLOBALFIRST+0x0080);
    static final int FCIDM_MENU_VIEW_SEP_OPTIONS = (FCIDM_GLOBALFIRST+0x0081);
    static final int FCIDM_MENU_TOOLS = (FCIDM_GLOBALFIRST+0x00c0);
    static final int FCIDM_MENU_TOOLS_SEP_GOTO = (FCIDM_GLOBALFIRST+0x00c1);
    static final int FCIDM_MENU_HELP = (FCIDM_GLOBALFIRST+0x0100);
    static final int FCIDM_MENU_FIND = (FCIDM_GLOBALFIRST+0x0140);
    static final int FCIDM_MENU_EXPLORE = (FCIDM_GLOBALFIRST+0x0150);
    static final int FCIDM_MENU_FAVORITES = (FCIDM_GLOBALFIRST+0x0170);
    static final int FCIDM_TOOLBAR = (FCIDM_BROWSERFIRST + 0);
    static final int FCIDM_STATUS = (FCIDM_BROWSERFIRST + 1);
    static final int IDC_OFFLINE_HAND = 103;
    static final int PANE_NONE = -1;
    static final int PANE_ZONE = 1;
    static final int PANE_OFFLINE = 2;
    static final int PANE_PRINTER = 3;
    static final int PANE_SSL = 4;
    static final int PANE_NAVIGATION = 5;
    static final int PANE_PROGRESS = 6;
    static final int PANE_PRIVACY = 7;
    static final int CDBOSC_SETFOCUS = 0x00000000;
    static final int CDBOSC_KILLFOCUS = 0x00000001;
    static final int CDBOSC_SELCHANGE = 0x00000002;
    static final int CDBOSC_RENAME = 0x00000003;
    static final int CDBOSC_STATECHANGE = 0x00000004;
    static final int CDB2N_CONTEXTMENU_DONE = 0x00000001;
    static final int CDB2N_CONTEXTMENU_START = 0x00000002;
    static final int CDB2GVF_SHOWALLFILES = 0x00000001;
    static final int CSIDL_DESKTOP = 0x0000;
    static final int CSIDL_INTERNET = 0x0001;
    static final int CSIDL_PROGRAMS = 0x0002;
    static final int CSIDL_CONTROLS = 0x0003;
    static final int CSIDL_PRINTERS = 0x0004;
    static final int CSIDL_PERSONAL = 0x0005;
    static final int CSIDL_FAVORITES = 0x0006;
    static final int CSIDL_STARTUP = 0x0007;
    static final int CSIDL_RECENT = 0x0008;
    static final int CSIDL_SENDTO = 0x0009;
    static final int CSIDL_BITBUCKET = 0x000a;
    static final int CSIDL_STARTMENU = 0x000b;
    static final int CSIDL_MYDOCUMENTS = 0x000c;
    static final int CSIDL_MYMUSIC = 0x000d;
    static final int CSIDL_MYVIDEO = 0x000e;
    static final int CSIDL_DESKTOPDIRECTORY = 0x0010;
    static final int CSIDL_DRIVES = 0x0011;
    static final int CSIDL_NETWORK = 0x0012;
    static final int CSIDL_NETHOOD = 0x0013;
    static final int CSIDL_FONTS = 0x0014;
    static final int CSIDL_TEMPLATES = 0x0015;
    static final int CSIDL_COMMON_STARTMENU = 0x0016;
    static final int CSIDL_COMMON_PROGRAMS = 0X0017;
    static final int CSIDL_COMMON_STARTUP = 0x0018;
    static final int CSIDL_COMMON_DESKTOPDIRECTORY = 0x0019;
    static final int CSIDL_APPDATA = 0x001a;
    static final int CSIDL_PRINTHOOD = 0x001b;
    static final int CSIDL_LOCAL_APPDATA = 0x001c;
    static final int CSIDL_ALTSTARTUP = 0x001d;
    static final int CSIDL_COMMON_ALTSTARTUP = 0x001e;
    static final int CSIDL_COMMON_FAVORITES = 0x001f;
    static final int CSIDL_INTERNET_CACHE = 0x0020;
    static final int CSIDL_COOKIES = 0x0021;
    static final int CSIDL_HISTORY = 0x0022;
    static final int CSIDL_COMMON_APPDATA = 0x0023;
    static final int CSIDL_WINDOWS = 0x0024;
    static final int CSIDL_SYSTEM = 0x0025;
    static final int CSIDL_PROGRAM_FILES = 0x0026;
    static final int CSIDL_MYPICTURES = 0x0027;
    static final int CSIDL_PROFILE = 0x0028;
    static final int CSIDL_SYSTEMX86 = 0x0029;
    static final int CSIDL_PROGRAM_FILESX86 = 0x002a;
    static final int CSIDL_PROGRAM_FILES_COMMON = 0x002b;
    static final int CSIDL_PROGRAM_FILES_COMMONX86 = 0x002c;
    static final int CSIDL_COMMON_TEMPLATES = 0x002d;
    static final int CSIDL_COMMON_DOCUMENTS = 0x002e;
    static final int CSIDL_COMMON_ADMINTOOLS = 0x002f;
    static final int CSIDL_ADMINTOOLS = 0x0030;
    static final int CSIDL_CONNECTIONS = 0x0031;
    static final int CSIDL_COMMON_MUSIC = 0x0035;
    static final int CSIDL_COMMON_PICTURES = 0x0036;
    static final int CSIDL_COMMON_VIDEO = 0x0037;
    static final int CSIDL_RESOURCES = 0x0038;
    static final int CSIDL_RESOURCES_LOCALIZED = 0x0039;
    static final int CSIDL_COMMON_OEM_LINKS = 0x003a;
    static final int CSIDL_CDBURN_AREA = 0x003b;
    static final int CSIDL_COMPUTERSNEARME = 0x003d;
    static final int CSIDL_FLAG_CREATE = 0x8000;
    static final int CSIDL_FLAG_DONT_VERIFY = 0x4000;
    static final int CSIDL_FLAG_NO_ALIAS = 0x1000;
    static final int CSIDL_FLAG_PER_USER_INIT = 0x0800;
    static final int CSIDL_FLAG_MASK = 0xFF00;
    static final int FCS_READ = 0x00000001;
    static final int FCS_FORCEWRITE = 0x00000002;
    static final int FCS_WRITE = (FCS_READ | FCS_FORCEWRITE);
    static final int FCS_FLAG_DRAGDROP = 2;
    static final int FCSM_VIEWID = 0x00000001;
    static final int FCSM_WEBVIEWTEMPLATE = 0x00000002;
    static final int FCSM_INFOTIP = 0x00000004;
    static final int FCSM_CLSID = 0x00000008;
    static final int FCSM_ICONFILE = 0x00000010;
    static final int FCSM_LOGO = 0x00000020;
    static final int FCSM_FLAGS = 0x00000040;
    static final int BIF_RETURNONLYFSDIRS = 0x0001;
    static final int BIF_DONTGOBELOWDOMAIN = 0x0002;
    static final int BIF_STATUSTEXT = 0x0004;
    static final int BIF_RETURNFSANCESTORS = 0x0008;
    static final int BIF_EDITBOX = 0x0010;
    static final int BIF_VALIDATE = 0x0020;
    static final int BIF_NEWDIALOGSTYLE = 0x0040;
    static final int BIF_USENEWUI = (BIF_NEWDIALOGSTYLE | BIF_EDITBOX);
    static final int BIF_BROWSEINCLUDEURLS = 0x0080;
    static final int BIF_UAHINT = 0x0100;
    static final int BIF_NONEWFOLDERBUTTON = 0x0200;
    static final int BIF_NOTRANSLATETARGETS = 0x0400;
    static final int BIF_BROWSEFORCOMPUTER = 0x1000;
    static final int BIF_BROWSEFORPRINTER = 0x2000;
    static final int BIF_BROWSEINCLUDEFILES = 0x4000;
    static final int BIF_SHAREABLE = 0x8000;
    static final int BFFM_INITIALIZED = 1;
    static final int BFFM_SELCHANGED = 2;
    static final int BFFM_VALIDATEFAILEDA = 3;
    static final int BFFM_VALIDATEFAILEDW = 4;
    static final int BFFM_IUNKNOWN = 5;
    static final int BFFM_SETSTATUSTEXTA = (WM_USER + 100);
    static final int BFFM_ENABLEOK = (WM_USER + 101);
    static final int BFFM_SETSELECTIONA = (WM_USER + 102);
    static final int BFFM_SETSELECTIONW = (WM_USER + 103);
    static final int BFFM_SETSTATUSTEXTW = (WM_USER + 104);
    static final int BFFM_SETOKTEXT = (WM_USER + 105);
    static final int BFFM_SETEXPANDED = (WM_USER + 106);
    static final int BFFM_SETSTATUSTEXT = BFFM_SETSTATUSTEXTA;
    static final int BFFM_SETSELECTION = BFFM_SETSELECTIONA;
    static final int BFFM_VALIDATEFAILED = BFFM_VALIDATEFAILEDA;
    static final int PROGDLG_NORMAL = 0x00000000;
    static final int PROGDLG_MODAL = 0x00000001;
    static final int PROGDLG_AUTOTIME = 0x00000002;
    static final int PROGDLG_NOTIME = 0x00000004;
    static final int PROGDLG_NOMINIMIZE = 0x00000008;
    static final int PROGDLG_NOPROGRESSBAR = 0x00000010;
    static final int PDTIMER_RESET = 0x00000001;
    static final int DWFRF_NORMAL = 0x0000;
    static final int DWFRF_DELETECONFIGDATA = 0x0001;
    static final int DWFAF_HIDDEN = 0x0001;
    static final int IRTIR_TASK_NOT_RUNNING = 0;
    static final int IRTIR_TASK_RUNNING = 1;
    static final int IRTIR_TASK_SUSPENDED = 2;
    static final int IRTIR_TASK_PENDING = 3;
    static final int IRTIR_TASK_FINISHED = 4;
    static final int ITSSFLAG_COMPLETE_ON_DESTROY = 0x0000;
    static final int ITSSFLAG_KILL_ON_DESTROY = 0x0001;
    static final int ITSSFLAG_SUPPORTS_TERMINATE = 0x0002;
    static final int ITSSFLAG_FLAGS_MASK = 0x0003;
    static final int ITSSFLAG_THREAD_TERMINATE_TIMEOUT = 0x0010;
    static final int ITSSFLAG_THREAD_POOL_TIMEOUT = 0x0020;
    static final int ITSS_THREAD_TERMINATE_TIMEOUT = (INFINITE);
    static final int ITSS_THREAD_TIMEOUT_NO_CHANGE = (INFINITE - 1);
    static final int ITSAT_DEFAULT_LPARAM = 0xffffffff;
    static final int ITSAT_DEFAULT_PRIORITY = 0x10000000;
    static final int ITSAT_MAX_PRIORITY = 0x7fffffff;
    static final int ITSAT_MIN_PRIORITY = 0x00000000;
    static final int ITSSFLAG_TASK_PLACEINFRONT = 0x00000001;
    static final int ITSSFLAG_TASK_PLACEINBACK = 0x00000002;
    static final int SHIMSTCAPFLAG_LOCKABLE = 0x0001;
    static final int SHIMSTCAPFLAG_PURGEABLE = 0x0002;
    static final int ISFB_MASK_STATE = 0x00000001;
    static final int ISFB_MASK_BKCOLOR = 0x00000002;
    static final int ISFB_MASK_VIEWMODE = 0x00000004;
    static final int ISFB_MASK_SHELLFOLDER = 0x00000008;
    static final int ISFB_MASK_IDLIST = 0x00000010;
    static final int ISFB_MASK_COLORS = 0x00000020;
    static final int ISFB_STATE_DEFAULT = 0x00000000;
    static final int ISFB_STATE_DEBOSSED = 0x00000001;
    static final int ISFB_STATE_ALLOWRENAME = 0x00000002;
    static final int ISFB_STATE_NOSHOWTEXT = 0x00000004;
    static final int ISFB_STATE_CHANNELBAR = 0x00000010;
    static final int ISFB_STATE_QLINKSMODE = 0x00000020;
    static final int ISFB_STATE_FULLOPEN = 0x00000040;
    static final int ISFB_STATE_NONAMESORT = 0x00000080;
    static final int ISFB_STATE_BTNMINSIZE = 0x00000100;
    static final int ISFBVIEWMODE_SMALLICONS = 0x0001;
    static final int ISFBVIEWMODE_LARGEICONS = 0x0002;
    static final int ISFBVIEWMODE_LOGOS = 0x0003;
    static final int DBC_GS_IDEAL = 0;
    static final int DBC_GS_SIZEDOWN = 1;
    static final int DBC_HIDE = 0;
    static final int DBC_SHOW = 1;
    static final int DBC_SHOWOBSCURE = 2;
    static final int MAX_COLUMN_NAME_LEN = 80;
    static final int MAX_COLUMN_DESC_LEN = 128;
    static final int SHCDF_UPDATEITEM = 0x00000001;
    static final int DVASPECT_SHORTNAME = 2;
    static final int DVASPECT_COPY = 3;
    static final int DVASPECT_LINK = 4;
    static final int SHCNE_RENAMEITEM = 0x00000001;
    static final int SHCNE_CREATE = 0x00000002;
    static final int SHCNE_DELETE = 0x00000004;
    static final int SHCNE_MKDIR = 0x00000008;
    static final int SHCNE_RMDIR = 0x00000010;
    static final int SHCNE_MEDIAINSERTED = 0x00000020;
    static final int SHCNE_MEDIAREMOVED = 0x00000040;
    static final int SHCNE_DRIVEREMOVED = 0x00000080;
    static final int SHCNE_DRIVEADD = 0x00000100;
    static final int SHCNE_NETSHARE = 0x00000200;
    static final int SHCNE_NETUNSHARE = 0x00000400;
    static final int SHCNE_ATTRIBUTES = 0x00000800;
    static final int SHCNE_UPDATEDIR = 0x00001000;
    static final int SHCNE_UPDATEITEM = 0x00002000;
    static final int SHCNE_SERVERDISCONNECT = 0x00004000;
    static final int SHCNE_UPDATEIMAGE = 0x00008000;
    static final int SHCNE_DRIVEADDGUI = 0x00010000;
    static final int SHCNE_RENAMEFOLDER = 0x00020000;
    static final int SHCNE_FREESPACE = 0x00040000;
    static final int SHCNE_EXTENDED_EVENT = 0x04000000;
    static final int SHCNE_ASSOCCHANGED = 0x08000000;
    static final int SHCNE_DISKEVENTS = 0x0002381F;
    static final int SHCNE_GLOBALEVENTS = 0x0C0581E0;
    static final int SHCNE_ALLEVENTS = 0x7FFFFFFF;
    static final int SHCNE_INTERRUPT = 0x80000000;
    static final int SHCNEE_ORDERCHANGED = 2;
    static final int SHCNEE_MSI_CHANGE = 4;
    static final int SHCNEE_MSI_UNINSTALL = 5;
    static final int SHCNF_IDLIST = 0x0000;
    static final int SHCNF_PATHA = 0x0001;
    static final int SHCNF_PRINTERA = 0x0002;
    static final int SHCNF_DWORD = 0x0003;
    static final int SHCNF_PATHW = 0x0005;
    static final int SHCNF_PRINTERW = 0x0006;
    static final int SHCNF_TYPE = 0x00FF;
    static final int SHCNF_FLUSH = 0x1000;
    static final int SHCNF_FLUSHNOWAIT = 0x2000;
    static final int SHCNF_PATH = SHCNF_PATHA;
    static final int SHCNF_PRINTER = SHCNF_PRINTERA;
    static final int QITIPF_DEFAULT = 0x00000000;
    static final int QITIPF_USENAME = 0x00000001;
    static final int QITIPF_LINKNOTARGET = 0x00000002;
    static final int QITIPF_LINKUSETARGET = 0x00000004;
    static final int QITIPF_USESLOWTIP = 0x00000008;
    static final int QIF_CACHED = 0x00000001;
    static final int QIF_DONTEXPANDFOLDER = 0x00000002;
    static final int SHARD_PIDL = 0x00000001;
    static final int SHARD_PATHA = 0x00000002;
    static final int SHARD_PATHW = 0x00000003;
    static final int SHARD_PATH = SHARD_PATHA;
    static final int SHGDFIL_FINDDATA = 1;
    static final int SHGDFIL_NETRESOURCE = 2;
    static final int SHGDFIL_DESCRIPTIONID = 3;
    static final int SHDID_ROOT_REGITEM = 1;
    static final int SHDID_FS_FILE = 2;
    static final int SHDID_FS_DIRECTORY = 3;
    static final int SHDID_FS_OTHER = 4;
    static final int SHDID_COMPUTER_DRIVE35 = 5;
    static final int SHDID_COMPUTER_DRIVE525 = 6;
    static final int SHDID_COMPUTER_REMOVABLE = 7;
    static final int SHDID_COMPUTER_FIXED = 8;
    static final int SHDID_COMPUTER_NETDRIVE = 9;
    static final int SHDID_COMPUTER_CDROM = 10;
    static final int SHDID_COMPUTER_RAMDISK = 11;
    static final int SHDID_COMPUTER_OTHER = 12;
    static final int SHDID_NET_DOMAIN = 13;
    static final int SHDID_NET_SERVER = 14;
    static final int SHDID_NET_SHARE = 15;
    static final int SHDID_NET_RESTOFNET = 16;
    static final int SHDID_NET_OTHER = 17;
    static final int SHDID_COMPUTER_IMAGING = 18;
    static final int SHDID_COMPUTER_AUDIO = 19;
    static final int SHDID_COMPUTER_SHAREDDOCS = 20;
    static final int PRF_VERIFYEXISTS = 0x0001;
    static final int PRF_TRYPROGRAMEXTENSIONS = (0x0002 | PRF_VERIFYEXISTS);
    static final int PRF_FIRSTDIRDEF = 0x0004;
    static final int PRF_DONTFINDLNK = 0x0008;
    static final int NUM_POINTS = 3;
    static final int CABINETSTATE_VERSION = 2;
    static final int PCS_FATAL = 0x80000000;
    static final int PCS_REPLACEDCHAR = 0x00000001;
    static final int PCS_REMOVEDCHAR = 0x00000002;
    static final int PCS_TRUNCATED = 0x00000004;
    static final int PCS_PATHTOOLONG = 0x00000008;
    static final int MM_ADDSEPARATOR = 0x00000001;
    static final int MM_SUBMENUSHAVEIDS = 0x00000002;
    static final int MM_DONTREMOVESEPS = 0x00000004;
    static final int SHOP_PRINTERNAME = 0x00000001;
    static final int SHOP_FILEPATH = 0x00000002;
    static final int SHOP_VOLUMEGUID = 0x00000004;
    static final int SHFMT_ID_DEFAULT = 0xFFFF;
    static final int SHFMT_OPT_FULL = 0x0001;
    static final int SHFMT_OPT_SYSONLY = 0x0002;
    static final int SHFMT_ERROR = 0xFFFFFFFF;
    static final int SHFMT_CANCEL = 0xFFFFFFFE;
    static final int SHFMT_NOFORMAT = 0xFFFFFFFD;
    static final int PPCF_ADDQUOTES = 0x00000001;
    static final int PPCF_ADDARGUMENTS = 0x00000003;
    static final int PPCF_NODIRECTORIES = 0x00000010;
    static final int PPCF_NORELATIVEOBJECTQUALIFY = 0x00000020;
    static final int PPCF_FORCEQUALIFY = 0x00000040;
    static final int PPCF_LONGESTPOSSIBLE = 0x00000080;
    static final int VALIDATEUNC_NOUI = 0x0002;
    static final int VALIDATEUNC_CONNECT = 0x0001;
    static final int VALIDATEUNC_PRINT = 0x0004;
    static final int VALIDATEUNC_VALID = 0x0007;
    static final int OPENPROPS_NONE = 0x0000;
    static final int OPENPROPS_INHIBITPIF = 0x8000;
    static final int GETPROPS_NONE = 0x0000;
    static final int SETPROPS_NONE = 0x0000;
    static final int CLOSEPROPS_NONE = 0x0000;
    static final int CLOSEPROPS_DISCARD = 0x0001;
    static final int PIFNAMESIZE = 30;
    static final int PIFSTARTLOCSIZE = 63;
    static final int PIFDEFPATHSIZE = 64;
    static final int PIFPARAMSSIZE = 64;
    static final int PIFSHPROGSIZE = 64;
    static final int PIFSHDATASIZE = 64;
    static final int PIFDEFFILESIZE = 80;
    static final int PIFMAXFILEPATH = 260;
    static final int QCMINFO_PLACE_BEFORE = 0;
    static final int QCMINFO_PLACE_AFTER = 1;
    static final int TBIF_APPEND = 0;
    static final int TBIF_PREPEND = 1;
    static final int TBIF_REPLACE = 2;
    static final int TBIF_DEFAULT = 0x00000000;
    static final int TBIF_INTERNETBAR = 0x00010000;
    static final int TBIF_STANDARDTOOLBAR = 0x00020000;
    static final int TBIF_NOTOOLBAR = 0x00030000;
    static final int SFVM_MERGEMENU = 1;
    static final int SFVM_INVOKECOMMAND = 2;
    static final int SFVM_GETHELPTEXT = 3;
    static final int SFVM_GETTOOLTIPTEXT = 4;
    static final int SFVM_GETBUTTONINFO = 5;
    static final int SFVM_GETBUTTONS = 6;
    static final int SFVM_INITMENUPOPUP = 7;
    static final int SFVM_WINDOWCREATED = 15;
    static final int SFVM_GETDETAILSOF = 23;
    static final int SFVM_COLUMNCLICK = 24;
    static final int SFVM_QUERYFSNOTIFY = 25;
    static final int SFVM_DEFITEMCOUNT = 26;
    static final int SFVM_DEFVIEWMODE = 27;
    static final int SFVM_UNMERGEMENU = 28;
    static final int SFVM_UPDATESTATUSBAR = 31;
    static final int SFVM_BACKGROUNDENUM = 32;
    static final int SFVM_DIDDRAGDROP = 36;
    static final int SFVM_SETISFV = 39;
    static final int SFVM_THISIDLIST = 41;
    static final int SFVM_ADDPROPERTYPAGES = 47;
    static final int SFVM_BACKGROUNDENUMDONE = 48;
    static final int SFVM_GETNOTIFY = 49;
    static final int SFVM_GETSORTDEFAULTS = 53;
    static final int SFVM_SIZE = 57;
    static final int SFVM_GETZONE = 58;
    static final int SFVM_GETPANE = 59;
    static final int SFVM_GETHELPTOPIC = 63;
    static final int DFM_MERGECONTEXTMENU = 1;
    static final int DFM_INVOKECOMMAND = 2;
    static final int DFM_GETDEFSTATICID = 14;
    static final int SFVM_REARRANGE = 0x00000001;
    static final int SFVM_ADDOBJECT = 0x00000003;
    static final int SFVM_REMOVEOBJECT = 0x00000006;
    static final int SFVM_UPDATEOBJECT = 0x00000007;
    static final int SFVM_GETSELECTEDOBJECTS = 0x00000009;
    static final int SFVM_SETITEMPOS = 0x0000000e;
    static final int SFVM_SETCLIPBOARD = 0x00000010;
    static final int SFVM_SETPOINTS = 0x00000017;
    static final int PID_IS_URL = 2;
    static final int PID_IS_NAME = 4;
    static final int PID_IS_WORKINGDIR = 5;
    static final int PID_IS_HOTKEY = 6;
    static final int PID_IS_SHOWCMD = 7;
    static final int PID_IS_ICONINDEX = 8;
    static final int PID_IS_ICONFILE = 9;
    static final int PID_IS_WHATSNEW = 10;
    static final int PID_IS_AUTHOR = 11;
    static final int PID_IS_DESCRIPTION = 12;
    static final int PID_IS_COMMENT = 13;
    static final int PID_INTSITE_WHATSNEW = 2;
    static final int PID_INTSITE_AUTHOR = 3;
    static final int PID_INTSITE_LASTVISIT = 4;
    static final int PID_INTSITE_LASTMOD = 5;
    static final int PID_INTSITE_VISITCOUNT = 6;
    static final int PID_INTSITE_DESCRIPTION = 7;
    static final int PID_INTSITE_COMMENT = 8;
    static final int PID_INTSITE_FLAGS = 9;
    static final int PID_INTSITE_CONTENTLEN = 10;
    static final int PID_INTSITE_CONTENTCODE = 11;
    static final int PID_INTSITE_RECURSE = 12;
    static final int PID_INTSITE_WATCH = 13;
    static final int PID_INTSITE_SUBSCRIPTION = 14;
    static final int PID_INTSITE_URL = 15;
    static final int PID_INTSITE_TITLE = 16;
    static final int PID_INTSITE_CODEPAGE = 18;
    static final int PID_INTSITE_TRACKING = 19;
    static final int PID_INTSITE_ICONINDEX = 20;
    static final int PID_INTSITE_ICONFILE = 21;
    static final int PIDISF_RECENTLYCHANGED = 0x00000001;
    static final int PIDISF_CACHEDSTICKY = 0x00000002;
    static final int PIDISF_CACHEIMAGES = 0x00000010;
    static final int PIDISF_FOLLOWALLLINKS = 0x00000020;
    static final int PIDISM_GLOBAL = 0;
    static final int PIDISM_WATCH = 1;
    static final int PIDISM_DONTWATCH = 2;
    static final int SHELLSTATEVERSION_IE4 = 9;
    static final int SHELLSTATEVERSION_WIN2K = 10;
    static final int SSF_SHOWALLOBJECTS = 0x00000001;
    static final int SSF_SHOWEXTENSIONS = 0x00000002;
    static final int SSF_SHOWCOMPCOLOR = 0x00000008;
    static final int SSF_SHOWSYSFILES = 0x00000020;
    static final int SSF_DOUBLECLICKINWEBVIEW = 0x00000080;
    static final int SSF_SHOWATTRIBCOL = 0x00000100;
    static final int SSF_DESKTOPHTML = 0x00000200;
    static final int SSF_WIN95CLASSIC = 0x00000400;
    static final int SSF_DONTPRETTYPATH = 0x00000800;
    static final int SSF_SHOWINFOTIP = 0x00002000;
    static final int SSF_MAPNETDRVBUTTON = 0x00001000;
    static final int SSF_NOCONFIRMRECYCLE = 0x00008000;
    static final int SSF_HIDEICONS = 0x00004000;
    static final int SHPPFW_NONE = 0x00000000;
    static final int SHPPFW_DIRCREATE = 0x00000001;
    static final int SHPPFW_ASKDIRCREATE = 0x00000002;
    static final int SHPPFW_IGNOREFILENAME = 0x00000004;
    static final int SHPPFW_NOWRITECHECK = 0x00000008;
    static final int SHPPFW_MEDIACHECKONLY = 0x00000010;
    static final int STIF_DEFAULT = 0x00000000;
    static final int STIF_SUPPORT_HEX = 0x00000001;
    static final int GCT_INVALID = 0x0000;
    static final int GCT_LFNCHAR = 0x0001;
    static final int GCT_SHORTCHAR = 0x0002;
    static final int GCT_WILD = 0x0004;
    static final int GCT_SEPARATOR = 0x0008;
    static final int URL_UNESCAPE = 0x10000000;
    static final int URL_ESCAPE_UNSAFE = 0x20000000;
    static final int URL_PLUGGABLE_PROTOCOL = 0x40000000;
    static final int URL_WININET_COMPATIBILITY = 0x80000000;
    static final int URL_DONT_ESCAPE_EXTRA_INFO = 0x02000000;
    static final int URL_DONT_UNESCAPE_EXTRA_INFO = URL_DONT_ESCAPE_EXTRA_INFO;
    static final int URL_BROWSER_MODE = URL_DONT_ESCAPE_EXTRA_INFO;
    static final int URL_ESCAPE_SPACES_ONLY = 0x04000000;
    static final int URL_DONT_SIMPLIFY = 0x08000000;
    static final int URL_NO_META = URL_DONT_SIMPLIFY;
    static final int URL_UNESCAPE_INPLACE = 0x00100000;
    static final int URL_CONVERT_IF_DOSPATH = 0x00200000;
    static final int URL_UNESCAPE_HIGH_ANSI_ONLY = 0x00400000;
    static final int URL_INTERNAL_PATH = 0x00800000;
    static final int URL_FILE_USE_PATHURL = 0x00010000;
    static final int URL_ESCAPE_PERCENT = 0x00001000;
    static final int URL_ESCAPE_SEGMENT_ONLY = 0x00002000;
    static final int URL_PARTFLAG_KEEPSCHEME = 0x00000001;
    static final int URL_APPLY_DEFAULT = 0x00000001;
    static final int URL_APPLY_GUESSSCHEME = 0x00000002;
    static final int URL_APPLY_GUESSFILE = 0x00000004;
    static final int URL_APPLY_FORCEAPPLY = 0x00000008;
    static final int SHREGSET_HKCU = 0x00000001;
    static final int SHREGSET_FORCE_HKCU = 0x00000002;
    static final int SHREGSET_HKLM = 0x00000004;
    static final int SHREGSET_FORCE_HKLM = 0x00000008;
    static final int SHREGSET_DEFAULT = (SHREGSET_FORCE_HKCU | SHREGSET_HKLM);
    static final int SHGVSPB_PERUSER = 0x00000001;
    static final int SHGVSPB_ALLUSERS = 0x00000002;
    static final int SHGVSPB_PERFOLDER = 0x00000004;
    static final int SHGVSPB_ALLFOLDERS = 0x00000008;
    static final int SHGVSPB_INHERIT = 0x00000010;
    static final int SHGVSPB_ROAM = 0x00000020;
    static final int SHGVSPB_NOAUTODEFAULTS = 0x80000000;
    static final int SHGVSPB_FOLDER = (SHGVSPB_PERUSER | SHGVSPB_PERFOLDER);
    static final int SHGVSPB_FOLDERNODEFAULTS = (SHGVSPB_PERUSER | SHGVSPB_PERFOLDER | SHGVSPB_NOAUTODEFAULTS);
    static final int SHGVSPB_USERDEFAULTS = (SHGVSPB_PERUSER | SHGVSPB_ALLFOLDERS);
    static final int SHGVSPB_GLOBALDEAFAULTS = (SHGVSPB_ALLUSERS | SHGVSPB_ALLFOLDERS);
    static final int SHACF_DEFAULT = 0x00000000;
    static final int SHACF_FILESYSTEM = 0x00000001;
    static final int SHACF_URLHISTORY = 0x00000002;
    static final int SHACF_URLMRU = 0x00000004;
    static final int SHACF_USETAB = 0x00000008;
    static final int SHACF_FILESYS_ONLY = 0x00000010;
    static final int SHACF_AUTOSUGGEST_FORCE_ON = 0x10000000;
    static final int SHACF_AUTOSUGGEST_FORCE_OFF = 0x20000000;
    static final int SHACF_AUTOAPPEND_FORCE_ON = 0x40000000;
    static final int SHACF_AUTOAPPEND_FORCE_OFF = 0x80000000;
    static final int CTF_INSIST = 0x00000001;
    static final int CTF_THREAD_REF = 0x00000002;
    static final int CTF_PROCESS_REF = 0x00000004;
    static final int CTF_COINIT = 0x00000008;
    static final int CTF_FREELIBANDEXIT = 0x00000010;
    static final int CTF_REF_COUNTED = 0x00000020;
    static final int CTF_WAIT_ALLOWCOM = 0x00000040;
    static final int DLLVER_PLATFORM_WINDOWS = 0x00000001;
    static final int DLLVER_PLATFORM_NT = 0x00000002;
    static final long DLLVER_MINOR_MASK = 0x0000FFFF00000000L;
    static final int DLLVER_BUILD_MASK = 0x00000000FFFF0000;
    static final int DLLVER_QFE_MASK = 0x000000000000FFFF;
    static final int MIN_ACL_REVISION = ACL_REVISION2;
    static final int DMPAPER_FIRST = DMPAPER_LETTER;
    static final int DMBIN_FIRST = DMBIN_UPPER;
    static final int WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW;
    static final int PM_QS_INPUT = (QS_INPUT << 16);
    static final int PM_QS_POSTMESSAGE = ((QS_POSTMESSAGE | QS_HOTKEY | QS_TIMER) << 16);
    static final int PM_QS_PAINT = (QS_PAINT << 16);
    static final int PM_QS_SENDMESSAGE = (QS_SENDMESSAGE << 16);
    static final int SB_SETTIPTEXT = SB_SETTIPTEXTA;
    static final int SB_GETTIPTEXT = SB_GETTIPTEXTA;
    static final int TVHT_ONITEM = (TVHT_ONITEMICON | TVHT_ONITEMLABEL | TVHT_ONITEMSTATEICON);
    static final int IEI_PRIORITY_MAX = ITSAT_MAX_PRIORITY;
    static final int IEI_PRIORITY_MIN = ITSAT_MIN_PRIORITY;
    static final int IEIT_PRIORITY_NORMAL = ITSAT_DEFAULT_PRIORITY;
    static final int CSIDL_FLAG_PFTI_TRACKTARGET = CSIDL_FLAG_DONT_VERIFY;
    static final int SHPPFW_DEFAULT = SHPPFW_DIRCREATE;
    static final int SHACF_URLALL = (SHACF_URLHISTORY | SHACF_URLMRU);
}
